/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","@vscode/proxy-agent","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],oe=function(Z){for(var e=[],S=0,A=Z.length;S<A;S++)e[S]=re[Z[S]];return e};define(re[134],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function S(m,b,g){const u=A(m,b);if(u!==-1)return m[u]}e.$eb=S;function A(m,b,g=m.length-1){for(let u=g;u>=0;u--){const a=m[u];if(b(a))return u}return-1}e.$fb=A;function s(m,b){const g=M(m,b);return g===-1?void 0:m[g]}e.$gb=s;function M(m,b,g=0,u=m.length){let a=g,E=u;for(;a<E;){const h=Math.floor((a+E)/2);b(m[h])?a=h+1:E=h}return a-1}e.$hb=M;function C(m,b){const g=P(m,b);return g===m.length?void 0:m[g]}e.$ib=C;function P(m,b,g=0,u=m.length){let a=g,E=u;for(;a<E;){const h=Math.floor((a+E)/2);b(m[h])?E=h:a=h+1}return a}e.$jb=P;function d(m,b,g=0,u=m.length){const a=P(m,b,g,u);return a===m.length?-1:a}e.$kb=d;class c{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(c.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!b(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const g=M(this.e,b,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$lb=c;function $(m,b){if(m.length===0)return;let g=m[0];for(let u=1;u<m.length;u++){const a=m[u];b(a,g)>0&&(g=a)}return g}e.$mb=$;function p(m,b){if(m.length===0)return;let g=m[0];for(let u=1;u<m.length;u++){const a=m[u];b(a,g)>=0&&(g=a)}return g}e.$nb=p;function v(m,b){return $(m,(g,u)=>-b(g,u))}e.$ob=v;function f(m,b){if(m.length===0)return-1;let g=0;for(let u=1;u<m.length;u++){const a=m[u];b(a,m[g])>0&&(g=u)}return g}e.$pb=f;function y(m,b){for(const g of m){const u=b(g);if(u!==void 0)return u}}e.$qb=y}),define(re[135],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function S(C,P){const d=Object.create(null);for(const c of C){const $=P(c);let p=d[$];p||(p=d[$]=[]),p.push(c)}return d}e.$J=S;function A(C,P){const d=[],c=[];for(const $ of C)P.has($)||d.push($);for(const $ of P)C.has($)||c.push($);return{removed:d,added:c}}e.$K=A;function s(C,P){const d=[],c=[];for(const[$,p]of C)P.has($)||d.push(p);for(const[$,p]of P)C.has($)||c.push(p);return{removed:d,added:c}}e.$L=s;function M(C,P){const d=new Set;for(const c of P)C.has(c)&&d.add(c);return d}e.$M=M}),define(re[136],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=e.$2s=e.$1s=void 0;function S(P,d){const c=Math.pow(10,d);return Math.round(P*c)/c}class A{constructor(d,c,$,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=S(Math.max(Math.min(1,p),0),3)}static equals(d,c){return d.r===c.r&&d.g===c.g&&d.b===c.b&&d.a===c.a}}e.$1s=A;class s{constructor(d,c,$,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=S(Math.max(Math.min(1,c),0),3),this.l=S(Math.max(Math.min(1,$),0),3),this.a=S(Math.max(Math.min(1,p),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.l===c.l&&d.a===c.a}static fromRGBA(d){const c=d.r/255,$=d.g/255,p=d.b/255,v=d.a,f=Math.max(c,$,p),y=Math.min(c,$,p);let m=0,b=0;const g=(y+f)/2,u=f-y;if(u>0){switch(b=Math.min(g<=.5?u/(2*g):u/(2-2*g),1),f){case c:m=($-p)/u+($<p?6:0);break;case $:m=(p-c)/u+2;break;case p:m=(c-$)/u+4;break}m*=60,m=Math.round(m)}return new s(m,b,g,v)}static i(d,c,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?d+(c-d)*6*$:$<1/2?c:$<2/3?d+(c-d)*(2/3-$)*6:d}static toRGBA(d){const c=d.h/360,{s:$,l:p,a:v}=d;let f,y,m;if($===0)f=y=m=p;else{const b=p<.5?p*(1+$):p+$-p*$,g=2*p-b;f=s.i(g,b,c+1/3),y=s.i(g,b,c),m=s.i(g,b,c-1/3)}return new A(Math.round(f*255),Math.round(y*255),Math.round(m*255),v)}}e.$2s=s;class M{constructor(d,c,$,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=S(Math.max(Math.min(1,c),0),3),this.v=S(Math.max(Math.min(1,$),0),3),this.a=S(Math.max(Math.min(1,p),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.v===c.v&&d.a===c.a}static fromRGBA(d){const c=d.r/255,$=d.g/255,p=d.b/255,v=Math.max(c,$,p),f=Math.min(c,$,p),y=v-f,m=v===0?0:y/v;let b;return y===0?b=0:v===c?b=(($-p)/y%6+6)%6:v===$?b=(p-c)/y+2:b=(c-$)/y+4,new M(Math.round(b*60),m,v,d.a)}static toRGBA(d){const{h:c,s:$,v:p,a:v}=d,f=p*$,y=f*(1-Math.abs(c/60%2-1)),m=p-f;let[b,g,u]=[0,0,0];return c<60?(b=f,g=y):c<120?(b=y,g=f):c<180?(g=f,u=y):c<240?(g=y,u=f):c<300?(b=y,u=f):c<=360&&(b=f,u=y),b=Math.round((b+m)*255),g=Math.round((g+m)*255),u=Math.round((u+m)*255),new A(b,g,u,v)}}e.$3s=M;class C{static fromHex(d){return C.Format.CSS.parseHex(d)||C.red}static equals(d,c){return!d&&!c?!0:!d||!c?!1:d.equals(c)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof A)this.rgba=d;else if(d instanceof s)this.i=d,this.rgba=s.toRGBA(d);else if(d instanceof M)this.j=d,this.rgba=M.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&A.equals(this.rgba,d.rgba)&&s.equals(this.hsla,d.hsla)&&M.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=C.k(this.rgba.r),c=C.k(this.rgba.g),$=C.k(this.rgba.b),p=.2126*d+.7152*c+.0722*$;return S(p,4)}static k(d){const c=d/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(d){const c=this.getRelativeLuminance(),$=d.getRelativeLuminance();return c>$?(c+.05)/($+.05):($+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const c=this.getRelativeLuminance(),$=d.getRelativeLuminance();return c>$}isDarkerThan(d){const c=this.getRelativeLuminance(),$=d.getRelativeLuminance();return c<$}lighten(d){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:c,g:$,b:p,a:v}=this.rgba;return new C(new A(c,$,p,v*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const c=d.rgba,$=this.rgba.a,p=c.a,v=$+p*(1-$);if(v<1e-6)return C.transparent;const f=this.rgba.r*$/v+c.r*p*(1-$)/v,y=this.rgba.g*$/v+c.g*p*(1-$)/v,m=this.rgba.b*$/v+c.b*p*(1-$)/v;return new C(new A(f,y,m,v))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:c,g:$,b:p,a:v}=this.rgba;return new C(new A(d.rgba.r-v*(d.rgba.r-c),d.rgba.g-v*(d.rgba.g-$),d.rgba.b-v*(d.rgba.b-p),1))}flatten(...d){const c=d.reduceRight(($,p)=>C.o(p,$));return C.o(this,c)}static o(d,c){const $=1-d.rgba.a;return new C(new A($*c.rgba.r+d.rgba.a*d.rgba.r,$*c.rgba.g+d.rgba.a*d.rgba.g,$*c.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(d,c,$){if(d.isLighterThan(c))return d;$=$||.5;const p=d.getRelativeLuminance(),v=c.getRelativeLuminance();return $=$*(v-p)/v,d.lighten($)}static getDarkerColor(d,c,$){if(d.isDarkerThan(c))return d;$=$||.5;const p=d.getRelativeLuminance(),v=c.getRelativeLuminance();return $=$*(p-v)/p,d.darken($)}static{this.white=new C(new A(255,255,255,1))}static{this.black=new C(new A(0,0,0,1))}static{this.red=new C(new A(255,0,0,1))}static{this.blue=new C(new A(0,0,255,1))}static{this.green=new C(new A(0,255,0,1))}static{this.cyan=new C(new A(0,255,255,1))}static{this.lightgrey=new C(new A(211,211,211,1))}static{this.transparent=new C(new A(0,0,0,0))}}e.$4s=C,function(P){let d;(function(c){let $;(function(p){function v(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}p.formatRGB=v;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}p.formatRGBA=f;function y(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}p.formatHSL=y;function m(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}p.formatHSLA=m;function b(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function g(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}p.formatHex=g;function u(i,o=!1){return o&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}p.formatHexA=u;function a(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}p.format=a;function E(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const r=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6));return new P(new A(r,t,n,1))}if(o===9){const r=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6)),l=16*h(i.charCodeAt(7))+h(i.charCodeAt(8));return new P(new A(r,t,n,l/255))}if(o===4){const r=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3));return new P(new A(16*r+r,16*t+t,16*n+n))}if(o===5){const r=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3)),l=h(i.charCodeAt(4));return new P(new A(16*r+r,16*t+t,16*n+n,(16*l+l)/255))}return null}p.parseHex=E;function h(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=c.CSS||(c.CSS={}))})(d=P.Format||(P.Format={}))}(C||(e.$4s=C={}))}),define(re[56],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function S(C){return(P,d,c)=>{let $=null,p=null;if(typeof c.value=="function"?($="value",p=c.value):typeof c.get=="function"&&($="get",p=c.get),!p)throw new Error("not supported");c[$]=C(p,d)}}function A(C,P,d){let c=null,$=null;if(typeof d.value=="function"?(c="value",$=d.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",$=d.get),!$)throw new Error("not supported");const p=`$memoize$${P}`;d[c]=function(...v){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,v)}),this[p]}}e.$nh=A;function s(C,P,d){return S((c,$)=>{const p=`$debounce$${$}`,v=`$debounce$result$${$}`;return function(...f){this[v]||(this[v]=d?d():void 0),clearTimeout(this[p]),P&&(this[v]=P(this[v],...f),f=[this[v]]),this[p]=setTimeout(()=>{c.apply(this,f),this[v]=d?d():void 0},C)}})}e.$oh=s;function M(C,P,d){return S((c,$)=>{const p=`$throttle$timer$${$}`,v=`$throttle$result$${$}`,f=`$throttle$lastRun$${$}`,y=`$throttle$pending$${$}`;return function(...m){if(this[v]||(this[v]=d?d():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...m)),this[y])return;const b=this[f]+C;b<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[v]]),this[v]=d?d():void 0):(this[y]=!0,this[p]=setTimeout(()=>{this[y]=!1,this[f]=Date.now(),c.apply(this,[this[v]]),this[v]=d?d():void 0},b-Date.now()))}})}e.$ph=M}),define(re[14],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$V=S,e.$W=new S;function A(h){e.$W.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=A;function s(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Y=s;function M(h){c(h)||e.$W.onUnexpectedError(h)}e.$Z=M;function C(h){c(h)||e.$W.onUnexpectedExternalError(h)}e.$1=C;function P(h){if(h instanceof Error){const{name:i,message:o}=h,r=h.stacktrace||h.stack;return{$isError:!0,name:i,message:o,stack:r,noTelemetry:a.isErrorNoTelemetry(h)}}return h}e.$2=P;const d="Canceled";function c(h){return h instanceof $?!0:h instanceof Error&&h.name===d&&h.message===d}e.$3=c;class $ extends Error{constructor(){super(d),this.name=this.message}}e.$4=$;function p(){const h=new Error(d);return h.name=h.message,h}e.$5=p;function v(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$6=v;function f(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$7=f;class y extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=y;function m(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$9=m;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=b;class g extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=g;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=u;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const o=new a;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=a;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$bb=E}),define(re[23],oe([0,1,14,134]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function s(F,z=0){return F[F.length-(1+z)]}e.$rb=s;function M(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$sb=M;function C(F,z,W=(x,he)=>x===he){if(F===z)return!0;if(!F||!z||F.length!==z.length)return!1;for(let x=0,he=F.length;x<he;x++)if(!W(F[x],z[x]))return!1;return!0}e.$tb=C;function P(F,z){const W=F.length-1;z<W&&(F[z]=F[W]),F.pop()}e.$ub=P;function d(F,z,W){return c(F.length,x=>W(F[x],z))}e.$vb=d;function c(F,z){let W=0,x=F-1;for(;W<=x;){const he=(W+x)/2|0,de=z(he);if(de<0)W=he+1;else if(de>0)x=he-1;else return he}return-(W+1)}e.$wb=c;function $(F,z,W){if(F=F|0,F>=z.length)throw new TypeError("invalid index");const x=z[Math.floor(z.length*Math.random())],he=[],de=[],le=[];for(const we of z){const be=W(we,x);be<0?he.push(we):be>0?de.push(we):le.push(we)}return F<he.length?$(F,he,W):F<he.length+le.length?le[0]:$(F-(he.length+le.length),de,W)}e.$xb=$;function p(F,z){const W=[];let x;for(const he of F.slice(0).sort(z))!x||z(x[0],he)!==0?(x=[he],W.push(x)):x.push(he);return W}e.$yb=p;function*v(F,z){let W,x;for(const he of F)x!==void 0&&z(x,he)?W.push(he):(W&&(yield W),W=[he]),x=he;W&&(yield W)}e.$zb=v;function f(F,z){for(let W=0;W<=F.length;W++)z(W===0?void 0:F[W-1],W===F.length?void 0:F[W])}e.$Ab=f;function y(F,z){for(let W=0;W<F.length;W++)z(W===0?void 0:F[W-1],F[W],W+1===F.length?void 0:F[W+1])}e.$Bb=y;function m(F,z,W){const x=[];function he(we,be,Ee){if(be===0&&Ee.length===0)return;const Se=x[x.length-1];Se&&Se.start+Se.deleteCount===we?(Se.deleteCount+=be,Se.toInsert.push(...Ee)):x.push({start:we,deleteCount:be,toInsert:Ee})}let de=0,le=0;for(;;){if(de===F.length){he(de,0,z.slice(le));break}if(le===z.length){he(de,F.length-de,[]);break}const we=F[de],be=z[le],Ee=W(we,be);Ee===0?(de+=1,le+=1):Ee<0?(he(de,1,[]),de+=1):Ee>0&&(he(de,0,[be]),le+=1)}return x}e.$Cb=m;function b(F,z,W){const x=m(F,z,W),he=[],de=[];for(const le of x)he.push(...F.slice(le.start,le.start+le.deleteCount)),de.push(...le.toInsert);return{removed:he,added:de}}e.$Db=b;function g(F,z,W){if(W===0)return[];const x=F.slice(0,W).sort(z);return a(F,z,x,W,F.length),x}e.top=g;function u(F,z,W,x,he){return W===0?Promise.resolve([]):new Promise((de,le)=>{(async()=>{const we=F.length,be=F.slice(0,W).sort(z);for(let Ee=W,Se=Math.min(W+x,we);Ee<we;Ee=Se,Se=Math.min(Se+x,we)){if(Ee>W&&await new Promise(Fe=>setTimeout(Fe)),he&&he.isCancellationRequested)throw new S.$4;a(F,z,be,Ee,Se)}return be})().then(de,le)})}e.$Fb=u;function a(F,z,W,x,he){for(const de=W.length;x<he;x++){const le=F[x];if(z(le,W[de-1])<0){W.pop();const we=(0,A.$jb)(W,be=>z(le,be)<0);W.splice(we,0,le)}}}function E(F){return F.filter(z=>!!z)}e.$Gb=E;function h(F){let z=0;for(let W=0;W<F.length;W++)F[W]&&(F[z]=F[W],z+=1);F.length=z}e.$Hb=h;function i(F,z,W){F.splice(W,0,F.splice(z,1)[0])}e.$Ib=i;function o(F){return!Array.isArray(F)||F.length===0}e.$Jb=o;function r(F){return Array.isArray(F)&&F.length>0}e.$Kb=r;function t(F,z=W=>W){const W=new Set;return F.filter(x=>{const he=z(x);return W.has(he)?!1:(W.add(he),!0)})}e.$Lb=t;function n(F){const z=new Set;return W=>{const x=F(W);return z.has(x)?!1:(z.add(x),!0)}}e.$Mb=n;function l(F,z){return F.length>0?F[0]:z}e.$Nb=l;function w(F,z){return F.length>0?F[F.length-1]:z}e.$Ob=w;function D(F,z,W=(x,he)=>x===he){let x=0;for(let he=0,de=Math.min(F.length,z.length);he<de&&W(F[he],z[he]);he++)x++;return x}e.$Pb=D;function I(F){return[].concat(...F)}e.$Qb=I;function k(F,z){let W=typeof z=="number"?F:0;typeof z=="number"?W=F:(W=0,z=F);const x=[];if(W<=z)for(let he=W;he<z;he++)x.push(he);else for(let he=W;he>z;he--)x.push(he);return x}e.$Rb=k;function R(F,z,W){return F.reduce((x,he)=>(x[z(he)]=W?W(he):he,x),Object.create(null))}e.$Sb=R;function L(F,z){return F.push(z),()=>T(F,z)}e.$Tb=L;function T(F,z){const W=F.indexOf(z);if(W>-1)return F.splice(W,1),z}e.$Ub=T;function N(F,z,W){const x=F.slice(0,z),he=F.slice(z);return x.concat(W,he)}e.$Vb=N;function K(F,z){let W;if(typeof z=="number"){let x=z;W=()=>{const he=Math.sin(x++)*179426549;return he-Math.floor(he)}}else W=Math.random;for(let x=F.length-1;x>0;x-=1){const he=Math.floor(W()*(x+1)),de=F[x];F[x]=F[he],F[he]=de}}e.$Wb=K;function Q(F,z){const W=F.indexOf(z);W>-1&&(F.splice(W,1),F.unshift(z))}e.$Xb=Q;function ae(F,z){const W=F.indexOf(z);W>-1&&(F.splice(W,1),F.push(z))}e.$Yb=ae;function ne(F,z){for(const W of z)F.push(W)}e.$Zb=ne;function ce(F,z){return Array.isArray(F)?F.map(z):z(F)}e.$1b=ce;function X(F){return Array.isArray(F)?F:[F]}e.$2b=X;function Y(F){return F[Math.floor(Math.random()*F.length)]}e.$3b=Y;function V(F,z,W){const x=j(F,z),he=F.length,de=W.length;F.length=he+de;for(let le=he-1;le>=x;le--)F[le+de]=F[le];for(let le=0;le<de;le++)F[le+x]=W[le]}e.$4b=V;function q(F,z,W,x){const he=j(F,z);let de=F.splice(he,W);return de===void 0&&(de=[]),V(F,he,x),de}e.$5b=q;function j(F,z){return z<0?Math.max(z+F.length,0):Math.min(z,F.length)}var H;(function(F){function z(de){return de<0}F.isLessThan=z;function W(de){return de<=0}F.isLessThanOrEqual=W;function x(de){return de>0}F.isGreaterThan=x;function he(de){return de===0}F.isNeitherLessOrGreaterThan=he,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function B(F,z){return(W,x)=>z(F(W),F(x))}e.$6b=B;function _(...F){return(z,W)=>{for(const x of F){const he=x(z,W);if(!H.isNeitherLessOrGreaterThan(he))return he}return H.neitherLessOrGreaterThan}}e.$7b=_;const se=(F,z)=>F-z;e.$8b=se;const J=(F,z)=>(0,e.$8b)(F?1:0,z?1:0);e.$9b=J;function O(F){return(z,W)=>-F(z,W)}e.$0b=O;class U{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let W=this.c;for(;W<this.g.length&&z(this.g[W]);)W++;const x=W===this.c?null:this.g.slice(this.c,W);return this.c=W,x}takeFromEndWhile(z){let W=this.d;for(;W>=0&&z(this.g[W]);)W--;const x=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,x}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const W=this.g.slice(this.c,this.c+z);return this.c+=z,W}}e.$$b=U;class G{static{this.empty=new G(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(W=>(z(W),!0))}toArray(){const z=[];return this.iterate(W=>(z.push(W),!0)),z}filter(z){return new G(W=>this.iterate(x=>z(x)?W(x):!0))}map(z){return new G(W=>this.iterate(x=>W(z(x))))}some(z){let W=!1;return this.iterate(x=>(W=z(x),!W)),W}findFirst(z){let W;return this.iterate(x=>z(x)?(W=x,!1):!0),W}findLast(z){let W;return this.iterate(x=>(z(x)&&(W=x),!0)),W}findLastMaxBy(z){let W,x=!0;return this.iterate(he=>((x||H.isGreaterThan(z(he,W)))&&(x=!1,W=he),!0)),W}}e.$_b=G}),define(re[137],oe([0,1,14]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function A(d,c){if(!d)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=A;function s(d,c="Unreachable"){throw new Error(c)}e.$4c=s;function M(d){if(!d)throw new S.$bb("Assertion Failed")}e.$5c=M;function C(d){if(!d()){debugger;d(),(0,S.$Z)(new S.$bb("Assertion Failed"))}}e.$6c=C;function P(d,c){let $=0;for(;$<d.length-1;){const p=d[$],v=d[$+1];if(!c(p,v))return!1;$++}return!0}e.$7c=P}),define(re[84],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function S(A,s){const M=this;let C=!1,P;return function(){if(C)return P;if(C=!0,s)try{P=A.apply(M,arguments)}finally{s()}else P=A.apply(M,arguments);return P}}e.$cb=S}),define(re[71],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(A){function s(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}A.is=s;const M=Object.freeze([]);function C(){return M}A.empty=C;function*P(h){yield h}A.single=P;function d(h){return s(h)?h:P(h)}A.wrap=d;function c(h){return h||M}A.from=c;function*$(h){for(let i=h.length-1;i>=0;i--)yield h[i]}A.reverse=$;function p(h){return!h||h[Symbol.iterator]().next().done===!0}A.isEmpty=p;function v(h){return h[Symbol.iterator]().next().value}A.first=v;function f(h,i){for(const o of h)if(i(o))return!0;return!1}A.some=f;function y(h,i){for(const o of h)if(i(o))return o}A.find=y;function*m(h,i){for(const o of h)i(o)&&(yield o)}A.filter=m;function*b(h,i){let o=0;for(const r of h)yield i(r,o++)}A.map=b;function*g(...h){for(const i of h)for(const o of i)yield o}A.concat=g;function u(h,i,o){let r=o;for(const t of h)r=i(r,t);return r}A.reduce=u;function*a(h,i,o=h.length){for(i<0&&(i+=h.length),o<0?o+=h.length:o>h.length&&(o=h.length);i<o;i++)yield h[i]}A.slice=a;function E(h,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,h];const r=h[Symbol.iterator]();for(let t=0;t<i;t++){const n=r.next();if(n.done)return[o,A.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return r}}]}A.consume=E})(S||(e.Iterable=S={}))}),define(re[44],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function C(i,o=!1){let r=0;const t=i.length;let n="",l=0,w=16,D=0;function I(Q){let ae=0,ne=0;for(;ae<Q;){const ce=i.charCodeAt(r);if(ce>=48&&ce<=57)ne=ne*16+ce-48;else if(ce>=65&&ce<=70)ne=ne*16+ce-65+10;else if(ce>=97&&ce<=102)ne=ne*16+ce-97+10;else break;r++,ae++}return ae<Q&&(ne=-1),ne}function k(Q){r=Q,n="",l=0,w=16,D=0}function R(){const Q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&c(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&c(i.charCodeAt(r)))for(r++;r<i.length&&c(i.charCodeAt(r));)r++;else return D=3,i.substring(Q,r);let ae=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&c(i.charCodeAt(r))){for(r++;r<i.length&&c(i.charCodeAt(r));)r++;ae=r}else D=3;return i.substring(Q,ae)}function L(){let Q="",ae=r;for(;;){if(r>=t){Q+=i.substring(ae,r),D=2;break}const ne=i.charCodeAt(r);if(ne===34){Q+=i.substring(ae,r),r++;break}if(ne===92){if(Q+=i.substring(ae,r),r++,r>=t){D=2;break}switch(i.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const X=I(4);X>=0?Q+=String.fromCharCode(X):D=4;break}default:D=5}ae=r;continue}if(ne>=0&&ne<=31)if(d(ne)){Q+=i.substring(ae,r),D=2;break}else D=6;r++}return Q}function T(){if(n="",D=0,l=r,r>=t)return l=t,w=17;let Q=i.charCodeAt(r);if(P(Q)){do r++,n+=String.fromCharCode(Q),Q=i.charCodeAt(r);while(P(Q));return w=15}if(d(Q))return r++,n+=String.fromCharCode(Q),Q===13&&i.charCodeAt(r)===10&&(r++,n+=`
`),w=14;switch(Q){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,n=L(),w=10;case 47:{const ae=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!d(i.charCodeAt(r));)r++;return n=i.substring(ae,r),w=12}if(i.charCodeAt(r+1)===42){r+=2;const ne=t-1;let ce=!1;for(;r<ne;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,ce=!0;break}r++}return ce||(r++,D=1),n=i.substring(ae,r),w=13}return n+=String.fromCharCode(Q),r++,w=16}case 45:if(n+=String.fromCharCode(Q),r++,r===t||!c(i.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),w=11;default:for(;r<t&&N(Q);)r++,Q=i.charCodeAt(r);if(l!==r){switch(n=i.substring(l,r),n){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return n+=String.fromCharCode(Q),r++,w=16}}function N(Q){if(P(Q)||d(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let Q;do Q=T();while(Q>=12&&Q<=15);return Q}return{setPosition:k,getPosition:()=>r,scan:o?K:T,getToken:()=>w,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>D}}e.$1m=C;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function d(i){return i===10||i===13||i===8232||i===8233}function c(i){return i>=48&&i<=57}var $;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})($||($={}));function p(i,o){const r=[],t=new Object;let n;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function D(I,k,R,L){l.value=I,l.offset=k,l.length=R,l.type=L,l.colonOffset=void 0,n=l}try{a(i,{onObjectBegin:(I,k)=>{if(o<=I)throw t;n=void 0,w=o>I,r.push("")},onObjectProperty:(I,k,R)=>{if(o<k||(D(I,k,R,"property"),r[r.length-1]=I,o<=k+R))throw t},onObjectEnd:(I,k)=>{if(o<=I)throw t;n=void 0,r.pop()},onArrayBegin:(I,k)=>{if(o<=I)throw t;n=void 0,r.push(0)},onArrayEnd:(I,k)=>{if(o<=I)throw t;n=void 0,r.pop()},onLiteralValue:(I,k,R)=>{if(o<k||(D(I,k,R,h(I)),o<=k+R))throw t},onSeparator:(I,k,R)=>{if(o<=k)throw t;if(I===":"&&n&&n.type==="property")n.colonOffset=k,w=!1,n=void 0;else if(I===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(w=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==t)throw I}return{path:r,previousNode:n,isAtPropertyKey:w,matches:I=>{let k=0;for(let R=0;k<I.length&&R<r.length;R++)if(I[k]===r[R]||I[k]==="*")k++;else if(I[k]!=="**")return!1;return k===I.length}}}e.$2m=p;function v(i,o=[],r=M.DEFAULT){let t=null,n=[];const l=[];function w(I){Array.isArray(n)?n.push(I):t!==null&&(n[t]=I)}return a(i,{onObjectBegin:()=>{const I={};w(I),l.push(n),n=I,t=null},onObjectProperty:I=>{t=I},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{const I=[];w(I),l.push(n),n=I,t=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:w,onError:(I,k,R)=>{o.push({error:I,offset:k,length:R})}},r),n[0]}e.$3m=v;function f(i,o=[],r=M.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){t.type==="property"&&(t.length=I-t.offset,t=t.parent)}function l(I){return t.children.push(I),I}a(i,{onObjectBegin:I=>{t=l({type:"object",offset:I,length:-1,parent:t,children:[]})},onObjectProperty:(I,k,R)=>{t=l({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:I,offset:k,length:R,parent:t})},onObjectEnd:(I,k)=>{t.length=I+k-t.offset,t=t.parent,n(I+k)},onArrayBegin:(I,k)=>{t=l({type:"array",offset:I,length:-1,parent:t,children:[]})},onArrayEnd:(I,k)=>{t.length=I+k-t.offset,t=t.parent,n(I+k)},onLiteralValue:(I,k,R)=>{l({type:h(I),offset:k,length:R,parent:t,value:I}),n(k+R)},onSeparator:(I,k,R)=>{t.type==="property"&&(I===":"?t.colonOffset=k:I===","&&n(k))},onError:(I,k,R)=>{o.push({error:I,offset:k,length:R})}},r);const D=t.children[0];return D&&delete D.parent,D}e.$4m=f;function y(i,o){if(!i)return;let r=i;for(const t of o)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===t){r=l.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$5m=y;function m(i){if(!i.parent||!i.parent.children)return[];const o=m(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}e.$6m=m;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const o=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(o[r.children[0].value]=b(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$7m=b;function g(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}e.$8m=g;function u(i,o,r=!1){if(g(i,o,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=o;n++){const l=u(t[n],o,r);if(l)return l}return i}}e.$9m=u;function a(i,o,r=M.DEFAULT){const t=C(i,!1);function n(B){return B?()=>B(t.getTokenOffset(),t.getTokenLength()):()=>!0}function l(B){return B?_=>B(_,t.getTokenOffset(),t.getTokenLength()):()=>!0}const w=n(o.onObjectBegin),D=l(o.onObjectProperty),I=n(o.onObjectEnd),k=n(o.onArrayBegin),R=n(o.onArrayEnd),L=l(o.onLiteralValue),T=l(o.onSeparator),N=n(o.onComment),K=l(o.onError),Q=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function ne(){for(;;){const B=t.scan();switch(t.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:Q||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(B){case 12:case 13:Q?ce(10):N();break;case 16:ce(1);break;case 15:case 14:break;default:return B}}}function ce(B,_=[],se=[]){if(K(B),_.length+se.length>0){let J=t.getToken();for(;J!==17;){if(_.indexOf(J)!==-1){ne();break}else if(se.indexOf(J)!==-1)break;J=ne()}}}function X(B){const _=t.getTokenValue();return B?L(_):D(_),ne(),!0}function Y(){switch(t.getToken()){case 11:{let B=0;try{B=JSON.parse(t.getTokenValue()),typeof B!="number"&&(ce(2),B=0)}catch{ce(2)}L(B);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return ne(),!0}function V(){return t.getToken()!==10?(ce(3,[],[2,5]),!1):(X(!1),t.getToken()===6?(T(":"),ne(),H()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function q(){w(),ne();let B=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(B||ce(4,[],[]),T(","),ne(),t.getToken()===2&&ae)break}else B&&ce(6,[],[]);V()||ce(4,[],[2,5]),B=!0}return I(),t.getToken()!==2?ce(7,[2],[]):ne(),!0}function j(){k(),ne();let B=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(B||ce(4,[],[]),T(","),ne(),t.getToken()===4&&ae)break}else B&&ce(6,[],[]);H()||ce(4,[],[4,5]),B=!0}return R(),t.getToken()!==4?ce(8,[4],[]):ne(),!0}function H(){switch(t.getToken()){case 3:return j();case 1:return q();case 10:return X(!0);default:return Y()}}return ne(),t.getToken()===17?r.allowEmptyContent?!0:(ce(4,[],[]),!1):H()?(t.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.$0m=a;function E(i,o){const r=C(i),t=[];let n,l=0,w;do switch(w=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:l!==w&&t.push(i.substring(l,w)),o!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,o)),l=r.getPosition();break}while(n!==17);return t.join("")}e.$$m=E;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=h}),define(re[138],oe([0,1,44]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wT=e.$vT=e.$uT=e.$tT=void 0;function A(c,$,p){let v,f,y,m,b;if($){for(m=$.offset,b=m+$.length,y=m;y>0&&!d(c,y-1);)y--;let w=b;for(;w<c.length&&!d(c,w);)w++;f=c.substring(y,w),v=C(f,p)}else f=c,v=0,y=0,m=0,b=c.length;const g=P(p,c);let u=!1,a=0,E;p.insertSpaces?E=M(" ",p.tabSize||4):E="	";const h=(0,S.$1m)(f,!1);let i=!1;function o(){return g+M(E,v+a)}function r(){let w=h.scan();for(u=!1;w===15||w===14;)u=u||w===14,w=h.scan();return i=w===16||h.getTokenError()!==0,w}const t=[];function n(w,D,I){!i&&D<b&&I>m&&c.substring(D,I)!==w&&t.push({offset:D,length:I-D,content:w})}let l=r();if(l!==17){const w=h.getTokenOffset()+y,D=M(E,v);n(D,y,w)}for(;l!==17;){let w=h.getTokenOffset()+h.getTokenLength()+y,D=r(),I="";for(;!u&&(D===12||D===13);){const R=h.getTokenOffset()+y;n(" ",w,R),w=h.getTokenOffset()+h.getTokenLength()+y,I=D===12?o():"",D=r()}if(D===2)l!==1&&(a--,I=o());else if(D===4)l!==3&&(a--,I=o());else{switch(l){case 3:case 1:a++,I=o();break;case 5:case 12:I=o();break;case 13:u?I=o():I=" ";break;case 6:I=" ";break;case 10:if(D===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?I=" ":D!==5&&D!==17&&(i=!0);break;case 16:i=!0;break}u&&(D===12||D===13)&&(I=o())}const k=h.getTokenOffset()+y;n(I,w,k),l=D}return t}e.$tT=A;function s(c,$){const p=JSON.stringify(c,void 0,$.insertSpaces?$.tabSize||4:"	");return $.eol!==void 0?p.replace(/\r\n|\r|\n/g,$.eol):p}e.$uT=s;function M(c,$){let p="";for(let v=0;v<$;v++)p+=c;return p}function C(c,$){let p=0,v=0;const f=$.tabSize||4;for(;p<c.length;){const y=c.charAt(p);if(y===" ")v++;else if(y==="	")v+=f;else break;p++}return Math.floor(v/f)}function P(c,$){for(let p=0;p<$.length;p++){const v=$.charAt(p);if(v==="\r")return p+1<$.length&&$.charAt(p+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return c&&c.eol||`
`}e.$vT=P;function d(c,$){return`\r
`.indexOf(c.charAt($))!==-1}e.$wT=d}),define(re[139],oe([0,1,44,138]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BT=e.$AT=e.$zT=e.$yT=e.$xT=void 0;function s(c,$,p){return M(c,$,void 0,p)}e.$xT=s;function M(c,$,p,v,f){const y=$.slice(),m=[],b=(0,S.$4m)(c,m);let g,u;for(;y.length>0&&(u=y.pop(),g=(0,S.$5m)(b,y),g===void 0&&p!==void 0);)typeof u=="string"?p={[u]:p}:p=[p];if(g)if(g.type==="object"&&typeof u=="string"&&Array.isArray(g.children)){const a=(0,S.$5m)(g,[u]);if(a!==void 0)if(p===void 0){if(!a.parent)throw new Error("Malformed AST");const E=g.children.indexOf(a.parent);let h,i=a.parent.offset+a.parent.length;if(E>0){const o=g.children[E-1];h=o.offset+o.length}else h=g.offset+1,g.children.length>1&&(i=g.children[1].offset);return C(c,{offset:h,length:i-h,content:""},v)}else return C(c,{offset:a.offset,length:a.length,content:JSON.stringify(p)},v);else{if(p===void 0)return[];const E=`${JSON.stringify(u)}: ${JSON.stringify(p)}`,h=f?f(g.children.map(o=>o.children[0].value)):g.children.length;let i;if(h>0){const o=g.children[h-1];i={offset:o.offset+o.length,length:0,content:","+E}}else g.children.length===0?i={offset:g.offset+1,length:0,content:E}:i={offset:g.offset+1,length:0,content:E+","};return C(c,i,v)}}else if(g.type==="array"&&typeof u=="number"&&Array.isArray(g.children))if(p!==void 0){const a=`${JSON.stringify(p)}`;let E;if(g.children.length===0||u===0)E={offset:g.offset+1,length:0,content:g.children.length===0?a:a+","};else{const h=u===-1||u>g.children.length?g.children.length:u,i=g.children[h-1];E={offset:i.offset+i.length,length:0,content:","+a}}return C(c,E,v)}else{const a=u,E=g.children[a];let h;if(g.children.length===1)h={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===a){const i=g.children[a-1],o=i.offset+i.length,r=g.offset+g.length;h={offset:o,length:r-2-o,content:""}}else h={offset:E.offset,length:g.children[a+1].offset-E.offset,content:""};return C(c,h,v)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${g.type}`);else{if(p===void 0)throw new Error("Can not delete in empty document");return C(c,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(p)},v)}}e.$yT=M;function C(c,$,p){let v=P(c,$),f=$.offset,y=$.offset+$.content.length;if($.length===0||$.content.length===0){for(;f>0&&!(0,A.$wT)(v,f-1);)f--;for(;y<v.length&&!(0,A.$wT)(v,y);)y++}const m=(0,A.$tT)(v,{offset:f,length:y-f},p);for(let g=m.length-1;g>=0;g--){const u=m[g];v=P(v,u),f=Math.min(f,u.offset),y=Math.max(y,u.offset+u.length),y+=u.content.length-u.length}const b=c.length-(v.length-y)-f;return[{offset:f,length:b,content:v.substring(f,y)}]}e.$zT=C;function P(c,$){return c.substring(0,$.offset)+$.content+c.substring($.offset+$.length)}e.$AT=P;function d(c,$){const p=$.slice(0).sort((f,y)=>{const m=f.offset-y.offset;return m===0?f.length-y.length:m});let v=c.length;for(let f=p.length-1;f>=0;f--){const y=p[f];if(y.offset+y.length<=v)c=P(c,y);else throw new Error("Overlapping edit");v=y.offset}return c}e.$BT=d}),define(re[72],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=S}),define(re[101],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}class A{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const C=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=C}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,C){const P=new S(M);if(this.a===S.Undefined)this.a=P,this.b=P;else if(C){const c=this.b;this.b=P,P.prev=c,c.next=P}else{const c=this.a;this.a=P,P.next=c,c.prev=P}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const C=M.prev;C.next=M.next,M.next.prev=C}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.$2c=A}),define(re[31],oe([0,1]),function(Z,e){"use strict";var S,A,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function M(u,a,E){let h=u.get(a);return h===void 0&&(h=E,u.set(a,h)),h}e.$wc=M;function C(u){const a=[];return u.forEach((E,h)=>{a.push(`${h} => ${E}`)}),`Map(${u.size}) {${a.join(", ")}}`}e.$xc=C;function P(u){const a=[];return u.forEach(E=>{a.push(E)}),`Set(${u.size}) {${a.join(", ")}}`}e.$yc=P;class d{constructor(a,E){this.uri=a,this.value=E}}function c(u){return Array.isArray(u)}class ${static{this.a=a=>a.toString()}constructor(a,E){if(this[S]="ResourceMap",a instanceof $)this.b=new Map(a.b),this.c=E??$.a;else if(c(a)){this.b=new Map,this.c=E??$.a;for(const[h,i]of a)this.set(h,i)}else this.b=new Map,this.c=a??$.a}set(a,E){return this.b.set(this.c(a),new d(a,E)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,E){typeof E<"u"&&(a=a.bind(E));for(const[h,i]of this.b)a(i.value,i.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}e.$zc=$;class p{constructor(a,E){this[A]="ResourceSet",!a||typeof a=="function"?this.a=new $(a):(this.a=new $(E),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,E){this.a.forEach((h,i)=>a.call(E,i,i,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=p;var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,E=0){const h=this.a.get(a);if(h)return E!==0&&this.j(h,E),h.value}set(a,E,h=0){let i=this.a.get(a);if(i)i.value=E,h!==0&&this.j(i,h);else{switch(i={key:a,value:E,next:void 0,previous:void 0},h){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(a,i),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const E=this.a.get(a);if(E)return this.a.delete(a),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,E){const h=this.e;let i=this.b;for(;i;){if(E?a.bind(E)(i.value,i.key,this):a(i.value,i.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const a=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const o={value:h.key,done:!1};return h=h.next,o}else return{value:void 0,done:!0}}};return i}values(){const a=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const o={value:h.value,done:!1};return h=h.next,o}else return{value:void 0,done:!0}}};return i}entries(){const a=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const o={value:[h.key,h.value],done:!1};return h=h.next,o}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let E=this.b,h=this.size;for(;E&&h>a;)this.a.delete(E.key),E=E.next,h--;this.b=E,this.d=h,E&&(E.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const E=a.next,h=a.previous;if(!E||!h)throw new Error("Invalid list");E.previous=h,h.next=E}a.next=void 0,a.previous=void 0,this.e++}j(a,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(a===this.b)return;const h=a.next,i=a.previous;a===this.c?(i.next=void 0,this.c=i):(h.previous=i,i.next=h),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(E===2){if(a===this.c)return;const h=a.next,i=a.previous;a===this.b?(h.previous=void 0,this.b=h):(h.previous=i,i.next=h),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((E,h)=>{a.push([h,E])}),a}fromJSON(a){this.clear();for(const[E,h]of a)this.set(E,h)}}e.$Bc=f;class y extends f{constructor(a,E=1){super(),this.k=a,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,E=2){return super.get(a,E)}peek(a){return super.get(a,0)}set(a,E){return super.set(a,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=y;class m{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let E=this.a.get(a)||0;return E===0?!1:(E--,E===0?this.a.delete(a):this.a.set(a,E),!0)}has(a){return this.a.has(a)}}e.$Dc=m;class b{constructor(a){if(this.a=new Map,this.b=new Map,a)for(const[E,h]of a)this.set(E,h)}clear(){this.a.clear(),this.b.clear()}set(a,E){this.a.set(a,E),this.b.set(E,a)}get(a){return this.a.get(a)}getKey(a){return this.b.get(a)}delete(a){const E=this.a.get(a);return E===void 0?!1:(this.a.delete(a),this.b.delete(E),!0)}forEach(a,E){this.a.forEach((h,i)=>{a.call(E,h,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=b;class g{constructor(){this.a=new Map}add(a,E){let h=this.a.get(a);h||(h=new Set,this.a.set(a,h)),h.add(E)}delete(a,E){const h=this.a.get(a);h&&(h.delete(E),h.size===0&&this.a.delete(a))}forEach(a,E){const h=this.a.get(a);h&&h.forEach(E)}get(a){const E=this.a.get(a);return E||new Set}}e.$Fc=g}),define(re[2],oe([0,1,23,135,31,84,71]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const P=!1;let d=null;class c{constructor(){this.b=new Map}static{this.a=0}c(L){let T=this.b.get(L);return T||(T={parent:null,source:null,isSingleton:!1,value:L,idx:c.a++},this.b.set(L,T)),T}trackDisposable(L){const T=this.c(L);T.source||(T.source=new Error().stack)}setParent(L,T){const N=this.c(L);N.parent=T}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,T){const N=T.get(L);if(N)return N;const K=L.parent?this.f(this.c(L.parent),T):L;return T.set(L,K),K}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,L).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(L=10,T){let N;if(T)N=T;else{const ce=new Map,X=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,ce).isSingleton);if(X.length===0)return;const Y=new Set(X.map(V=>V.value));if(N=X.filter(V=>!(V.parent&&Y.has(V.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function K(ce){function X(V,q){for(;V.length>0&&q.some(j=>typeof j=="string"?j===V[0]:V[0].match(j));)V.shift()}const Y=ce.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return X(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const Q=new s.$Fc;for(const ce of N){const X=K(ce);for(let Y=0;Y<=X.length;Y++)Q.add(X.slice(0,Y).join(`
`),ce)}N.sort((0,S.$6b)(ce=>ce.idx,S.$8b));let ae="",ne=0;for(const ce of N.slice(0,L)){ne++;const X=K(ce),Y=[];for(let V=0;V<X.length;V++){let q=X[V];q=`(shared with ${Q.get(X.slice(0,V+1).join(`
`)).size}/${N.length} leaks) at ${q}`;const H=Q.get(X.slice(0,V).join(`
`)),B=(0,A.$J)([...H].map(_=>K(_)[V]),_=>_);delete B[X[V]];for(const[_,se]of Object.entries(B))Y.unshift(`    - stacktraces of ${se.length} other leaks continue with ${_}`);Y.unshift(q)}ae+=`


==================== Leaking disposable ${ne}/${N.length}: ${ce.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return N.length>L&&(ae+=`


... and ${N.length-L} more leaking disposables

`),{leaks:N,details:ae}}}e.$Gc=c;function $(R){d=R}if(e.$Hc=$,P){const R="__is_disposable_tracked__";$(new class{trackDisposable(L){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[R]||console.log(T)},3e3)}setParent(L,T){if(L&&L!==i.None)try{L[R]=!0}catch{}}markAsDisposed(L){if(L&&L!==i.None)try{L[R]=!0}catch{}}markAsSingleton(L){}})}function p(R){return d?.trackDisposable(R),R}e.$Ic=p;function v(R){d?.markAsDisposed(R)}e.$Jc=v;function f(R,L){d?.setParent(R,L)}function y(R,L){if(d)for(const T of R)d.setParent(T,L)}function m(R){return d?.markAsSingleton(R),R}e.$Kc=m;function b(R){return typeof R.dispose=="function"&&R.dispose.length===0}e.$Lc=b;function g(R){if(C.Iterable.is(R)){const L=[];for(const T of R)if(T)try{T.dispose()}catch(N){L.push(N)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}e.$Mc=g;function u(R){for(const L of R)b(L)&&L.dispose();return[]}e.$Nc=u;function a(...R){const L=E(()=>g(R));return y(R,L),L}e.$Oc=a;function E(R){const L=p({dispose:(0,M.$cb)(()=>{v(L),R()})});return L}e.$Pc=E;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return f(L,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),f(L,null))}}e.$Qc=h;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,p(this),f(this.q,this)}dispose(){v(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Rc=i;class o{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&f(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&f(L,null),L}}e.$Sc=o;class r{constructor(L){this.a=new o,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=r;class t{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=t;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(L){let T=L;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,v(this))},this}}e.$Vc=n;class l{constructor(){this.a=new Map}acquire(L,...T){let N=this.a.get(L);N||(N={counter:0,object:this.b(L,...T)},this.a.set(L,N));const{object:K}=N,Q=(0,M.$cb)(()=>{--N.counter===0&&(this.c(L,N.object),this.a.delete(L))});return N.counter++,{object:K,dispose:Q}}}e.$Wc=l;class w{constructor(L){this.a=L}async acquire(L,...T){const N=this.a.acquire(L,...T);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(K){throw N.dispose(),K}}}e.$Xc=w;class D{constructor(L){this.object=L}dispose(){}}e.$Yc=D;function I(R){const L=new h;try{R(L)}finally{L.dispose()}}e.$Zc=I;class k{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,T,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(L)?.dispose(),this.a.set(L,T)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=k}),define(re[85],oe([0,1,31]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.$ul=void 0;const A=new S.$Cc(1e4);function s(c){return d(c,"NFC",A)}e.$ul=s;const M=new S.$Cc(1e4);function C(c){return d(c,"NFD",M)}e.$vl=C;const P=/[^\u0000-\u0080]/;function d(c,$,p){if(!c)return c;const v=p.get(c);if(v)return v;let f;return P.test(c)?f=c.normalize($):f=c,p.set(c,f),f}e.$wl=function(){const c=/[\u0300-\u036f]/g;return function($){return C($).replace(c,"")}}()}),define(re[140],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function S(P,d,c){return Math.min(Math.max(P,d),c)}e.$Ul=S;function A(P,d){return(d+P%d)%d}e.rot=A;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=s;class M{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=M;class C{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const c=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=C}),function(){function Z(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function C(d){M.push(d,Date.now())}function P(){const d=[];for(let c=0;c<M.length;c+=2)d.push({name:M[c],startTime:M[c+1]});return d}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))M.push({name:C.name,startTime:Math.round(s+C.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=S(A))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var A in S)(typeof exports=="object"?exports:Z)[A]=S[A]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function S(A){if(e[A])return e[A].exports;var s=e[A]={i:A,l:!1,exports:{}};return Z[A].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=Z,S.c=e,S.d=function(A,s,M){S.o(A,s)||Object.defineProperty(A,s,{enumerable:!0,get:M})},S.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},S.t=function(A,s){if(1&s&&(A=S(A)),8&s||4&s&&typeof A=="object"&&A&&A.__esModule)return A;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:A}),2&s&&typeof A!="string")for(var C in A)S.d(M,C,function(P){return A[P]}.bind(null,C));return M},S.n=function(A){var s=A&&A.__esModule?function(){return A.default}:function(){return A};return S.d(s,"a",s),s},S.o=function(A,s){return Object.prototype.hasOwnProperty.call(A,s)},S.p="",S(S.s=0)}([function(Z,e,S){(function(A){var s;e=Z.exports=se,s=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],c=0,$=c++;d[$]="0|[1-9]\\d*";var p=c++;d[p]="[0-9]+";var v=c++;d[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;d[f]="("+d[$]+")\\.("+d[$]+")\\.("+d[$]+")";var y=c++;d[y]="("+d[p]+")\\.("+d[p]+")\\.("+d[p]+")";var m=c++;d[m]="(?:"+d[$]+"|"+d[v]+")";var b=c++;d[b]="(?:"+d[p]+"|"+d[v]+")";var g=c++;d[g]="(?:-("+d[m]+"(?:\\."+d[m]+")*))";var u=c++;d[u]="(?:-?("+d[b]+"(?:\\."+d[b]+")*))";var a=c++;d[a]="[0-9A-Za-z-]+";var E=c++;d[E]="(?:\\+("+d[a]+"(?:\\."+d[a]+")*))";var h=c++,i="v?"+d[f]+d[g]+"?"+d[E]+"?";d[h]="^"+i+"$";var o="[v=\\s]*"+d[y]+d[u]+"?"+d[E]+"?",r=c++;d[r]="^"+o+"$";var t=c++;d[t]="((?:<|>)?=?)";var n=c++;d[n]=d[p]+"|x|X|\\*";var l=c++;d[l]=d[$]+"|x|X|\\*";var w=c++;d[w]="[v=\\s]*("+d[l]+")(?:\\.("+d[l]+")(?:\\.("+d[l]+")(?:"+d[g]+")?"+d[E]+"?)?)?";var D=c++;d[D]="[v=\\s]*("+d[n]+")(?:\\.("+d[n]+")(?:\\.("+d[n]+")(?:"+d[u]+")?"+d[E]+"?)?)?";var I=c++;d[I]="^"+d[t]+"\\s*"+d[w]+"$";var k=c++;d[k]="^"+d[t]+"\\s*"+d[D]+"$";var R=c++;d[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=c++;d[L]="(?:~>?)";var T=c++;d[T]="(\\s*)"+d[L]+"\\s+",P[T]=new RegExp(d[T],"g");var N=c++;d[N]="^"+d[L]+d[w]+"$";var K=c++;d[K]="^"+d[L]+d[D]+"$";var Q=c++;d[Q]="(?:\\^)";var ae=c++;d[ae]="(\\s*)"+d[Q]+"\\s+",P[ae]=new RegExp(d[ae],"g");var ne=c++;d[ne]="^"+d[Q]+d[w]+"$";var ce=c++;d[ce]="^"+d[Q]+d[D]+"$";var X=c++;d[X]="^"+d[t]+"\\s*("+o+")$|^$";var Y=c++;d[Y]="^"+d[t]+"\\s*("+i+")$|^$";var V=c++;d[V]="(\\s*)"+d[t]+"\\s*("+o+"|"+d[w]+")",P[V]=new RegExp(d[V],"g");var q=c++;d[q]="^\\s*("+d[w]+")\\s+-\\s+("+d[w]+")\\s*$";var j=c++;d[j]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var H=c++;d[H]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)s(B,d[B]),P[B]||(P[B]=new RegExp(d[B]));function _(ee,ue){if(ee instanceof se)return ee;if(typeof ee!="string"||ee.length>M||!(ue?P[r]:P[h]).test(ee))return null;try{return new se(ee,ue)}catch{return null}}function se(ee,ue){if(ee instanceof se){if(ee.loose===ue)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(ee,ue);s("SemVer",ee,ue),this.loose=ue;var ge=ee.trim().match(ue?P[r]:P[h]);if(!ge)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var De=+Re;if(De>=0&&De<C)return De}return Re}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=_,e.valid=function(ee,ue){var ge=_(ee,ue);return ge?ge.version:null},e.clean=function(ee,ue){var ge=_(ee.trim().replace(/^[=v]+/,""),ue);return ge?ge.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(ee){return s("SemVer.compare",this.version,this.loose,ee),ee instanceof se||(ee=new se(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},se.prototype.compareMain=function(ee){return ee instanceof se||(ee=new se(ee,this.loose)),O(this.major,ee.major)||O(this.minor,ee.minor)||O(this.patch,ee.patch)},se.prototype.comparePre=function(ee){if(ee instanceof se||(ee=new se(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ue=0;do{var ge=this.prerelease[ue],Re=ee.prerelease[ue];if(s("prerelease compare",ue,ge,Re),ge===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(ge===void 0)return-1;if(ge!==Re)return O(ge,Re)}while(++ue)},se.prototype.inc=function(ee,ue){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ue,ge,Re){typeof ge=="string"&&(Re=ge,ge=void 0);try{return new se(ee,ge).inc(ue,Re).version}catch{return null}},e.diff=function(ee,ue){if(z(ee,ue))return null;var ge=_(ee),Re=_(ue);if(ge.prerelease.length||Re.prerelease.length){for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Re[De])return"pre"+De;return"prerelease"}for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Re[De])return De},e.compareIdentifiers=O;var J=/^[0-9]+$/;function O(ee,ue){var ge=J.test(ee),Re=J.test(ue);return ge&&Re&&(ee=+ee,ue=+ue),ge&&!Re?-1:Re&&!ge?1:ee<ue?-1:ee>ue?1:0}function U(ee,ue,ge){return new se(ee,ge).compare(new se(ue,ge))}function G(ee,ue,ge){return U(ee,ue,ge)>0}function F(ee,ue,ge){return U(ee,ue,ge)<0}function z(ee,ue,ge){return U(ee,ue,ge)===0}function W(ee,ue,ge){return U(ee,ue,ge)!==0}function x(ee,ue,ge){return U(ee,ue,ge)>=0}function he(ee,ue,ge){return U(ee,ue,ge)<=0}function de(ee,ue,ge,Re){var De;switch(ue){case"===":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),De=ee===ge;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),De=ee!==ge;break;case"":case"=":case"==":De=z(ee,ge,Re);break;case"!=":De=W(ee,ge,Re);break;case">":De=G(ee,ge,Re);break;case">=":De=x(ee,ge,Re);break;case"<":De=F(ee,ge,Re);break;case"<=":De=he(ee,ge,Re);break;default:throw new TypeError("Invalid operator: "+ue)}return De}function le(ee,ue){if(ee instanceof le){if(ee.loose===ue)return ee;ee=ee.value}if(!(this instanceof le))return new le(ee,ue);s("comparator",ee,ue),this.loose=ue,this.parse(ee),this.semver===we?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ee,ue){return O(ue,ee)},e.major=function(ee,ue){return new se(ee,ue).major},e.minor=function(ee,ue){return new se(ee,ue).minor},e.patch=function(ee,ue){return new se(ee,ue).patch},e.compare=U,e.compareLoose=function(ee,ue){return U(ee,ue,!0)},e.rcompare=function(ee,ue,ge){return U(ue,ee,ge)},e.sort=function(ee,ue){return ee.sort(function(ge,Re){return e.compare(ge,Re,ue)})},e.rsort=function(ee,ue){return ee.sort(function(ge,Re){return e.rcompare(ge,Re,ue)})},e.gt=G,e.lt=F,e.eq=z,e.neq=W,e.gte=x,e.lte=he,e.cmp=de,e.Comparator=le;var we={};function be(ee,ue){if(ee instanceof be)return ee.loose===ue?ee:new be(ee.raw,ue);if(ee instanceof le)return new be(ee.value,ue);if(!(this instanceof be))return new be(ee,ue);if(this.loose=ue,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ee(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Se(ee,ue,ge,Re,De,je,Me,Ve,ze,ie,fe,$e,ye){return((ue=Ee(ge)?"":Ee(Re)?">="+ge+".0.0":Ee(De)?">="+ge+"."+Re+".0":">="+ue)+" "+(Ve=Ee(ze)?"":Ee(ie)?"<"+(+ze+1)+".0.0":Ee(fe)?"<"+ze+"."+(+ie+1)+".0":$e?"<="+ze+"."+ie+"."+fe+"-"+$e:"<="+Ve)).trim()}function Fe(ee,ue){for(var ge=0;ge<ee.length;ge++)if(!ee[ge].test(ue))return!1;if(ue.prerelease.length){for(ge=0;ge<ee.length;ge++)if(s(ee[ge].semver),ee[ge].semver!==we&&ee[ge].semver.prerelease.length>0){var Re=ee[ge].semver;if(Re.major===ue.major&&Re.minor===ue.minor&&Re.patch===ue.patch)return!0}return!1}return!0}function ke(ee,ue,ge){try{ue=new be(ue,ge)}catch{return!1}return ue.test(ee)}function pe(ee,ue,ge,Re){var De,je,Me,Ve,ze;switch(ee=new se(ee,Re),ue=new be(ue,Re),ge){case">":De=G,je=he,Me=F,Ve=">",ze=">=";break;case"<":De=F,je=x,Me=G,Ve="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(ee,ue,Re))return!1;for(var ie=0;ie<ue.set.length;++ie){var fe=ue.set[ie],$e=null,ye=null;if(fe.forEach(function(Ce){Ce.semver===we&&(Ce=new le(">=0.0.0")),$e=$e||Ce,ye=ye||Ce,De(Ce.semver,$e.semver,Re)?$e=Ce:Me(Ce.semver,ye.semver,Re)&&(ye=Ce)}),$e.operator===Ve||$e.operator===ze||(!ye.operator||ye.operator===Ve)&&je(ee,ye.semver)||ye.operator===ze&&Me(ee,ye.semver))return!1}return!0}le.prototype.parse=function(ee){var ue=this.loose?P[X]:P[Y],ge=ee.match(ue);if(!ge)throw new TypeError("Invalid comparator: "+ee);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new se(ge[2],this.loose):this.semver=we},le.prototype.toString=function(){return this.value},le.prototype.test=function(ee){return s("Comparator.test",ee,this.loose),this.semver===we||(typeof ee=="string"&&(ee=new se(ee,this.loose)),de(ee,this.operator,this.semver,this.loose))},le.prototype.intersects=function(ee,ue){if(!(ee instanceof le))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ee.value,ue),ke(this.value,ge,ue);if(ee.operator==="")return ge=new be(this.value,ue),ke(ee.semver,ge,ue);var Re=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),je=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ve=de(this.semver,"<",ee.semver,ue)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),ze=de(this.semver,">",ee.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Re||De||je&&Me||Ve||ze},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ee){var ue=this.loose;ee=ee.trim(),s("range",ee,ue);var ge=ue?P[j]:P[q];ee=ee.replace(ge,Se),s("hyphen replace",ee),ee=ee.replace(P[V],"$1$2$3"),s("comparator trim",ee,P[V]),ee=(ee=(ee=ee.replace(P[T],"$1~")).replace(P[ae],"$1^")).split(/\s+/).join(" ");var Re=ue?P[X]:P[Y],De=ee.split(" ").map(function(je){return function(Me,Ve){return s("comp",Me),Me=function(ze,ie){return ze.trim().split(/\s+/).map(function(fe){return function($e,ye){s("caret",$e,ye);var Ce=ye?P[ce]:P[ne];return $e.replace(Ce,function(Ue,Le,We,qe,Ge){var Je;return s("caret",$e,Ue,Le,We,qe,Ge),Ee(Le)?Je="":Ee(We)?Je=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(qe)?Je=Le==="0"?">="+Le+"."+We+".0 <"+Le+"."+(+We+1)+".0":">="+Le+"."+We+".0 <"+(+Le+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Je=Le==="0"?We==="0"?">="+Le+"."+We+"."+qe+Ge+" <"+Le+"."+We+"."+(+qe+1):">="+Le+"."+We+"."+qe+Ge+" <"+Le+"."+(+We+1)+".0":">="+Le+"."+We+"."+qe+Ge+" <"+(+Le+1)+".0.0"):(s("no pr"),Je=Le==="0"?We==="0"?">="+Le+"."+We+"."+qe+" <"+Le+"."+We+"."+(+qe+1):">="+Le+"."+We+"."+qe+" <"+Le+"."+(+We+1)+".0":">="+Le+"."+We+"."+qe+" <"+(+Le+1)+".0.0"),s("caret return",Je),Je})}(fe,ie)}).join(" ")}(Me,Ve),s("caret",Me),Me=function(ze,ie){return ze.trim().split(/\s+/).map(function(fe){return function($e,ye){var Ce=ye?P[K]:P[N];return $e.replace(Ce,function(Ue,Le,We,qe,Ge){var Je;return s("tilde",$e,Ue,Le,We,qe,Ge),Ee(Le)?Je="":Ee(We)?Je=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(qe)?Je=">="+Le+"."+We+".0 <"+Le+"."+(+We+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Je=">="+Le+"."+We+"."+qe+Ge+" <"+Le+"."+(+We+1)+".0"):Je=">="+Le+"."+We+"."+qe+" <"+Le+"."+(+We+1)+".0",s("tilde return",Je),Je})}(fe,ie)}).join(" ")}(Me,Ve),s("tildes",Me),Me=function(ze,ie){return s("replaceXRanges",ze,ie),ze.split(/\s+/).map(function(fe){return function($e,ye){$e=$e.trim();var Ce=ye?P[k]:P[I];return $e.replace(Ce,function(Ue,Le,We,qe,Ge,Je){s("xRange",$e,Ue,Le,We,qe,Ge,Je);var _e=Ee(We),Ze=_e||Ee(qe),it=Ze||Ee(Ge);return Le==="="&&it&&(Le=""),_e?Ue=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(Ze&&(qe=0),it&&(Ge=0),Le===">"?(Le=">=",Ze?(We=+We+1,qe=0,Ge=0):it&&(qe=+qe+1,Ge=0)):Le==="<="&&(Le="<",Ze?We=+We+1:qe=+qe+1),Ue=Le+We+"."+qe+"."+Ge):Ze?Ue=">="+We+".0.0 <"+(+We+1)+".0.0":it&&(Ue=">="+We+"."+qe+".0 <"+We+"."+(+qe+1)+".0"),s("xRange return",Ue),Ue})}(fe,ie)}).join(" ")}(Me,Ve),s("xrange",Me),Me=function(ze,ie){return s("replaceStars",ze,ie),ze.trim().replace(P[H],"")}(Me,Ve),s("stars",Me),Me}(je,ue)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(je){return!!je.match(Re)})),De=De.map(function(je){return new le(je,ue)})},be.prototype.intersects=function(ee,ue){if(!(ee instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Re){return ee.set.some(function(De){return De.every(function(je){return Re.intersects(je,ue)})})})})},e.toComparators=function(ee,ue){return new be(ee,ue).set.map(function(ge){return ge.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new se(ee,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Fe(this.set[ue],ee))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(ee,ue,ge){var Re=null,De=null;try{var je=new be(ue,ge)}catch{return null}return ee.forEach(function(Me){je.test(Me)&&(Re&&De.compare(Me)!==-1||(De=new se(Re=Me,ge)))}),Re},e.minSatisfying=function(ee,ue,ge){var Re=null,De=null;try{var je=new be(ue,ge)}catch{return null}return ee.forEach(function(Me){je.test(Me)&&(Re&&De.compare(Me)!==1||(De=new se(Re=Me,ge)))}),Re},e.validRange=function(ee,ue){try{return new be(ee,ue).range||"*"}catch{return null}},e.ltr=function(ee,ue,ge){return pe(ee,ue,"<",ge)},e.gtr=function(ee,ue,ge){return pe(ee,ue,">",ge)},e.outside=pe,e.prerelease=function(ee,ue){var ge=_(ee,ue);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ee,ue,ge){return ee=new be(ee,ge),ue=new be(ue,ge),ee.intersects(ue)},e.coerce=function(ee){if(ee instanceof se)return ee;if(typeof ee!="string")return null;var ue=ee.match(P[R]);return ue==null?null:_((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,S(1))},function(Z,e){var S,A,s=Z.exports={};function M(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(b){if(S===setTimeout)return setTimeout(b,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch{try{return S.call(null,b,0)}catch{return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var d,c=[],$=!1,p=-1;function v(){$&&d&&($=!1,d.length?c=d.concat(c):p=-1,c.length&&f())}function f(){if(!$){var b=P(v);$=!0;for(var g=c.length;g;){for(d=c,c=[];++p<g;)d&&d[p].run();p=-1,g=c.length}d=null,$=!1,function(u){if(A===clearTimeout)return clearTimeout(u);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(u);try{A(u)}catch{try{return A.call(null,u)}catch{return A.call(this,u)}}}(b)}}function y(b,g){this.fun=b,this.array=g}function m(){}s.nextTick=function(b){var g=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)g[u-1]=arguments[u];c.push(new y(b,g)),c.length!==1||$||P(f)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=m,s.addListener=m,s.once=m,s.off=m,s.removeListener=m,s.removeAllListeners=m,s.emit=m,s.prependListener=m,s.prependOnceListener=m,s.listeners=function(b){return[]},s.binding=function(b){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(b){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(re[141],oe([0,1]),function(Z,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;class A{constructor(P,d,c){this.level=P,this.key=d,this.value=c,this.forward=[]}}const s=void 0;class M{constructor(P,d=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new A(this.c,s,s)}get size(){return this.f}clear(){this.e=new A(this.c,s,s),this.f=0}has(P){return!!M.g(this,P,this.comparator)}get(P){return M.g(this,P,this.comparator)?.value}set(P,d){return M.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=M.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let c=this.e.forward[0];for(;c;)P.call(d,c.value,c.key,this),c=c.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,c){let $=P.e;for(let p=P.d-1;p>=0;p--)for(;$.forward[p]&&c($.forward[p].key,d)<0;)$=$.forward[p];if($=$.forward[0],$&&c($.key,d)===0)return $}static h(P,d,c,$){const p=[];let v=P.e;for(let f=P.d-1;f>=0;f--){for(;v.forward[f]&&$(v.forward[f].key,d)<0;)v=v.forward[f];p[f]=v}if(v=v.forward[0],v&&$(v.key,d)===0)return v.value=c,!1;{const f=M.j(P);if(f>P.d){for(let y=P.d;y<f;y++)p[y]=P.e;P.d=f}v=new A(f,d,c);for(let y=0;y<f;y++)v.forward[y]=p[y].forward[y],p[y].forward[y]=v;return!0}}static j(P,d=.5){let c=1;for(;Math.random()<d&&c<P.c;)c+=1;return c}static k(P,d,c){const $=[];let p=P.e;for(let v=P.d-1;v>=0;v--){for(;p.forward[v]&&c(p.forward[v].key,d)<0;)p=p.forward[v];$[v]=p}if(p=p.forward[0],!p||c(p.key,d)!==0)return!1;for(let v=0;v<P.d&&$[v].forward[v]===p;v++)$[v].forward[v]=p.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$Er=M}),define(re[73],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(M){return new A(M)}constructor(M){this.c=S&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=A}),define(re[3],oe([0,1,14,84,2,101,73]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const P=!1,d=!1;var c;(function(I){I.None=()=>s.$Rc.None;function k(de){if(d){const{onDidAddListener:le}=de,we=y.create();let be=0;de.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),le?.()}}}function R(de,le){return Y(de,()=>{},0,void 0,!0,void 0,le)}I.defer=R;function L(de){return(le,we=null,be)=>{let Ee=!1,Se;return Se=de(Fe=>{if(!Ee)return Se?Se.dispose():Ee=!0,le.call(we,Fe)},null,be),Ee&&Se.dispose(),Se}}I.once=L;function T(de,le,we){return ce((be,Ee=null,Se)=>de(Fe=>be.call(Ee,le(Fe)),null,Se),we)}I.map=T;function N(de,le,we){return ce((be,Ee=null,Se)=>de(Fe=>{le(Fe),be.call(Ee,Fe)},null,Se),we)}I.forEach=N;function K(de,le,we){return ce((be,Ee=null,Se)=>de(Fe=>le(Fe)&&be.call(Ee,Fe),null,Se),we)}I.filter=K;function Q(de){return de}I.signal=Q;function ae(...de){return(le,we=null,be)=>{const Ee=(0,s.$Oc)(...de.map(Se=>Se(Fe=>le.call(we,Fe))));return X(Ee,be)}}I.any=ae;function ne(de,le,we,be){let Ee=we;return T(de,Se=>(Ee=le(Ee,Se),Ee),be)}I.reduce=ne;function ce(de,le){let we;const be={onWillAddFirstListener(){we=de(Ee.fire,Ee)},onDidRemoveLastListener(){we?.dispose()}};le||k(be);const Ee=new a(be);return le?.add(Ee),Ee.event}function X(de,le){return le instanceof Array?le.push(de):le&&le.add(de),de}function Y(de,le,we=100,be=!1,Ee=!1,Se,Fe){let ke,pe,ee,ue=0,ge;const Re={leakWarningThreshold:Se,onWillAddFirstListener(){ke=de(je=>{ue++,pe=le(pe,je),be&&!ee&&(De.fire(pe),pe=void 0),ge=()=>{const Me=pe;pe=void 0,ee=void 0,(!be||ue>1)&&De.fire(Me),ue=0},typeof we=="number"?(clearTimeout(ee),ee=setTimeout(ge,we)):ee===void 0&&(ee=0,queueMicrotask(ge))})},onWillRemoveListener(){Ee&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ke.dispose()}};Fe||k(Re);const De=new a(Re);return Fe?.add(De),De.event}I.debounce=Y;function V(de,le=0,we){return I.debounce(de,(be,Ee)=>be?(be.push(Ee),be):[Ee],le,void 0,!0,void 0,we)}I.accumulate=V;function q(de,le=(be,Ee)=>be===Ee,we){let be=!0,Ee;return K(de,Se=>{const Fe=be||!le(Se,Ee);return be=!1,Ee=Se,Fe},we)}I.latch=q;function j(de,le,we){return[I.filter(de,le,we),I.filter(de,be=>!le(be),we)]}I.split=j;function H(de,le=!1,we=[],be){let Ee=we.slice(),Se=de(pe=>{Ee?Ee.push(pe):ke.fire(pe)});be&&be.add(Se);const Fe=()=>{Ee?.forEach(pe=>ke.fire(pe)),Ee=null},ke=new a({onWillAddFirstListener(){Se||(Se=de(pe=>ke.fire(pe)),be&&be.add(Se))},onDidAddFirstListener(){Ee&&(le?setTimeout(Fe):Fe())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return be&&be.add(ke),ke.event}I.buffer=H;function B(de,le){return(be,Ee,Se)=>{const Fe=le(new se);return de(function(ke){const pe=Fe.evaluate(ke);pe!==_&&be.call(Ee,pe)},void 0,Se)}}I.chain=B;const _=Symbol("HaltChainable");class se{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push(we=>(le(we),we)),this}filter(le){return this.f.push(we=>le(we)?we:_),this}reduce(le,we){let be=we;return this.f.push(Ee=>(be=le(be,Ee),be)),this}latch(le=(we,be)=>we===be){let we=!0,be;return this.f.push(Ee=>{const Se=we||!le(Ee,be);return we=!1,be=Ee,Se?Ee:_}),this}evaluate(le){for(const we of this.f)if(le=we(le),le===_)break;return le}}function J(de,le,we=be=>be){const be=(...ke)=>Fe.fire(we(...ke)),Ee=()=>de.on(le,be),Se=()=>de.removeListener(le,be),Fe=new a({onWillAddFirstListener:Ee,onDidRemoveLastListener:Se});return Fe.event}I.fromNodeEventEmitter=J;function O(de,le,we=be=>be){const be=(...ke)=>Fe.fire(we(...ke)),Ee=()=>de.addEventListener(le,be),Se=()=>de.removeEventListener(le,be),Fe=new a({onWillAddFirstListener:Ee,onDidRemoveLastListener:Se});return Fe.event}I.fromDOMEventEmitter=O;function U(de){return new Promise(le=>L(de)(le))}I.toPromise=U;function G(de){const le=new a;return de.then(we=>{le.fire(we)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}I.fromPromise=G;function F(de,le,we){return le(we),de(be=>le(be))}I.runAndSubscribe=F;function z(de,le){let we=null;function be(Se){we?.dispose(),we=new s.$Qc,le(Se,we)}be(void 0);const Ee=de(Se=>be(Se));return(0,s.$Pc)(()=>{Ee.dispose(),we?.dispose()})}I.runAndSubscribeWithStore=z;class W{constructor(le,we){this._observable=le,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};we||k(be),this.emitter=new a(be),we&&we.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,we){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function x(de,le){return new W(de,le).emitter.event}I.fromObservable=x;function he(de){return le=>{let we=0,be=!1;const Ee={beginUpdate(){we++},endUpdate(){we--,we===0&&(de.reportChanges(),be&&(be=!1,le()))},handlePossibleChange(){},handleChange(){be=!0}};return de.addObserver(Ee),de.reportChanges(),{dispose(){de.removeObserver(Ee)}}}}I.fromObservableLight=he})(c||(e.Event=c={}));class ${static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${$.f++}`,$.all.add(this)}start(k){this.g=new C.$Nd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Pd=$;let p=-1;function v(I){const k=p;return p=I,{dispose(){p=k}}}e.$Qd=v;class f{constructor(k,R=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=R,this.g=0}dispose(){this.f?.clear()}check(k,R){const L=this.threshold;if(L<=0||R<L)return;this.f||(this.f=new Map);const T=this.f.get(k.value)||0;if(this.f.set(k.value,T+1),this.g-=1,this.g<=0){this.g=L*.5;let N,K=0;for(const[Q,ae]of this.f)(!N||K<ae)&&(N=Q,K=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${K}):`),console.warn(N)}return()=>{const N=this.f.get(k.value)||0;this.f.set(k.value,N-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class b{constructor(k){this.value=k,this.id=m++}}const g=2,u=(I,k)=>{if(I instanceof b)k(I);else for(let R=0;R<I.length;R++){const L=I[R];L&&k(L)}};class a{constructor(k){this.w=0,this.f=k,this.g=p>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const k=this.t;queueMicrotask(()=>{u(k,R=>R.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,R,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Rc.None;if(this.m)return s.$Rc.None;R&&(k=k.bind(R));const T=new b(k);let N,K;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=y.create(),N=this.g.check(T.stack,this.w+1)),P&&(T.stack=K??y.create()),this.t?this.t instanceof b?(this.u??=new h,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const Q=(0,s.$Pc)(()=>{N?.(),this.x(T)});return L instanceof s.$Qc?L.add(Q):Array.isArray(L)&&L.push(Q),Q},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const R=this.t,L=R.indexOf(k);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,R[L]=void 0;const T=this.u.current===this;if(this.w*g<=R.length){let N=0;for(let K=0;K<R.length;K++)R[K]?R[N++]=R[K]:T&&(this.u.end--,N<this.u.i&&this.u.i--);R.length=N}}y(k,R){if(!k)return;const L=this.f?.onListenerError||S.$Z;if(!L){k.value(R);return}try{k.value(R)}catch(T){L(T)}}z(k){const R=k.current.t;for(;k.i<k.end;)this.y(R[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,k);else{const R=this.u;R.enqueue(this,k,this.t.length),this.z(R)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=a;const E=()=>new h;e.$Sd=E;class h{constructor(){this.i=-1,this.end=0}enqueue(k,R,L){this.i=0,this.end=L,this.current=k,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends a{async fireAsync(k,R,L){if(this.t)for(this.h||(this.h=new M.$2c),u(this.t,T=>this.h.push([T.value,k]));this.h.size>0&&!R.isCancellationRequested;){const[T,N]=this.h.shift(),K=[],Q={...N,token:R,waitUntil:ae=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");L&&(ae=L(ae,T)),K.push(ae)}};try{T(Q)}catch(ae){(0,S.$Z)(ae);continue}Object.freeze(K),await Promise.allSettled(K).then(ae=>{for(const ne of ae)ne.status==="rejected"&&(0,S.$Z)(ne.reason)})}}}e.$Td=i;class o extends a{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new M.$2c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Ud=o;class r extends o{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Vd=r;class t extends a{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(R=>super.fire(R)),this.h=[]}))}}e.$Wd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const R={event:k,listener:null};this.h.push(R),this.g&&this.m(R);const L=()=>{this.g&&this.o(R);const T=this.h.indexOf(R);this.h.splice(T,1)};return(0,s.$Pc)((0,A.$cb)(L))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(R=>this.f.fire(R))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Xd=n;class l{constructor(k,R,L,T){this.f=new s.$Qc;const N=this.f.add(new n),K=this.f.add(new s.$1c);function Q(ae){K.set(ae,N.add(T(ae)))}for(const ae of k)Q(ae);this.f.add(R(ae=>{Q(ae)})),this.f.add(L(ae=>{K.deleteAndDispose(ae)})),this.event=N.event}dispose(){this.f.dispose()}}e.$Yd=l;class w{constructor(){this.f=[]}wrapEvent(k){return(R,L,T)=>k(N=>{const K=this.f[this.f.length-1];K?K.push(()=>R.call(L,N)):R.call(L,N)},void 0,T)}bufferEvents(k){const R=[];this.f.push(R);const L=k();return this.f.pop(),R.forEach(T=>T()),L}}e.$Zd=w;class D{constructor(){this.f=!1,this.g=c.None,this.h=s.$Rc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=D}),define(re[22],oe([0,1,3]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const A=Object.freeze(function(P,d){const c=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(c)}}});var s;(function(P){function d(c){return c===P.None||c===P.Cancelled||c instanceof M?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new S.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$2d=C}),define(re[142],oe([0,1,22]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$2d,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Ae=A;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const d=JSON.stringify(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.$Be=s;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const d=this.b(P);return this.a.set(P,d),d}}e.$Ce=M}),define(re[62],oe([0,1,14,2]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function s(E){const h=E;return h?typeof h.read=="function":!1}e.$3d=s;function M(E){const h=E;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$4d=M;function C(E){const h=E;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$5d=C;function P(E,h){return new d(E,h)}e.$6d=P;class d{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,S.$Z)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let o;switch(h){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,h){const i=[];let o;for(;(o=E.read())!==null;)i.push(o);return h(i)}e.$7d=c;function $(E,h,i){const o=[];let r;for(;(r=E.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?h(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return E.read()}}}e.$8d=$;function p(E,h){return new Promise((i,o)=>{const r=[];v(E,{onData:t=>{h&&r.push(t)},onError:t=>{h?o(t):i(void 0)},onEnd:()=>{i(h?h(r):void 0)}})})}e.$9d=p;function v(E,h,i){E.on("error",o=>{i?.isCancellationRequested||h.onError(o)}),E.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),E.on("data",o=>{i?.isCancellationRequested||h.onData(o)})}e.$0d=v;function f(E,h){return new Promise((i,o)=>{const r=new A.$Qc,t=[],n=D=>{if(t.push(D),t.length>h)return r.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},l=D=>(r.dispose(),o(D)),w=()=>(r.dispose(),i({stream:E,buffer:t,ended:!0}));r.add((0,A.$Pc)(()=>E.removeListener("error",l))),E.on("error",l),r.add((0,A.$Pc)(()=>E.removeListener("end",w))),E.on("end",w),r.add((0,A.$Pc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$$d=f;function y(E,h){const i=P(h);return i.end(E),i}e.$_d=y;function m(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.$ae=m;function b(E){let h=!1;return{read:()=>h?null:(h=!0,E)}}e.$be=b;function g(E,h,i){const o=P(i);return v(E,{onData:r=>o.write(h.data(r)),onError:r=>o.error(h.error?h.error(r):r),onEnd:()=>o.end()}),o}e.$ce=g;function u(E,h,i){let o=!1;return{read:()=>{const r=h.read();return o?r:(o=!0,r!==null?i([E,r]):E)}}}e.$de=u;function a(E,h,i){let o=!1;const r=P(i);return v(h,{onData:t=>o?r.write(t):(o=!0,r.write(i([E,t]))),onError:t=>r.error(t),onEnd:()=>{o||(o=!0,r.write(E)),r.end()}}),r}e.$ee=a}),define(re[18],oe([0,1,72,62]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const s=typeof Buffer<"u",M=new S.$U(()=>new Uint8Array(256));let C,P;class d{static alloc(R){return s?new d(Buffer.allocUnsafe(R)):new d(new Uint8Array(R))}static wrap(R){return s&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new d(R)}static fromString(R,L){return!(L?.dontUseNodeBuffer||!1)&&s?new d(Buffer.from(R)):(C||(C=new TextEncoder),new d(C.encode(R)))}static fromByteArray(R){const L=d.alloc(R.length);for(let T=0,N=R.length;T<N;T++)L.buffer[T]=R[T];return L}static concat(R,L){if(typeof L>"u"){L=0;for(let K=0,Q=R.length;K<Q;K++)L+=R[K].byteLength}const T=d.alloc(L);let N=0;for(let K=0,Q=R.length;K<Q;K++){const ae=R[K];T.set(ae,N),N+=ae.byteLength}return T}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=d.alloc(this.byteLength);return R.set(this),R}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(R,L){return new d(this.buffer.subarray(R,L))}set(R,L){if(R instanceof d)this.buffer.set(R.buffer,L);else if(R instanceof Uint8Array)this.buffer.set(R,L);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),L);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return v(this.buffer,R)}writeUInt32BE(R,L){f(this.buffer,R,L)}readUInt32LE(R){return y(this.buffer,R)}writeUInt32LE(R,L){m(this.buffer,R,L)}readUInt8(R){return b(this.buffer,R)}writeUInt8(R,L){g(this.buffer,R,L)}indexOf(R,L=0){return c(this.buffer,R instanceof d?R.buffer:R,L)}}e.$fe=d;function c(k,R,L=0){const T=R.byteLength,N=k.byteLength;if(T===0)return 0;if(T===1)return k.indexOf(R[0]);if(T>N-L)return-1;const K=M.value;K.fill(R.length);for(let ce=0;ce<R.length;ce++)K[R[ce]]=R.length-ce-1;let Q=L+R.length-1,ae=Q,ne=-1;for(;Q<N;)if(k[Q]===R[ae]){if(ae===0){ne=Q;break}Q--,ae--}else Q+=Math.max(R.length-ae,K[k[Q]]),ae=R.length-1;return ne}e.$ge=c;function $(k,R){return k[R+0]<<0>>>0|k[R+1]<<8>>>0}e.$he=$;function p(k,R,L){k[L+0]=R&255,R=R>>>8,k[L+1]=R&255}e.$ie=p;function v(k,R){return k[R]*2**24+k[R+1]*2**16+k[R+2]*2**8+k[R+3]}e.$je=v;function f(k,R,L){k[L+3]=R,R=R>>>8,k[L+2]=R,R=R>>>8,k[L+1]=R,R=R>>>8,k[L]=R}e.$ke=f;function y(k,R){return k[R+0]<<0>>>0|k[R+1]<<8>>>0|k[R+2]<<16>>>0|k[R+3]<<24>>>0}e.$le=y;function m(k,R,L){k[L+0]=R&255,R=R>>>8,k[L+1]=R&255,R=R>>>8,k[L+2]=R&255,R=R>>>8,k[L+3]=R&255}e.$me=m;function b(k,R){return k[R]}e.$ne=b;function g(k,R,L){k[L]=R}e.$oe=g;function u(k){return A.$7d(k,R=>d.concat(R))}e.$pe=u;function a(k){return A.$be(k)}e.$qe=a;function E(k){return A.$9d(k,R=>d.concat(R))}e.$re=E;async function h(k){return k.ended?d.concat(k.buffer):d.concat([...k.buffer,await E(k.stream)])}e.$se=h;function i(k){return A.$_d(k,R=>d.concat(R))}e.$te=i;function o(k){return A.$ce(k,{data:R=>typeof R=="string"?d.fromString(R):d.wrap(R)},R=>d.concat(R))}e.$ue=o;function r(k){return A.$6d(R=>d.concat(R),k)}e.$ve=r;function t(k,R){return A.$de(k,R,L=>d.concat(L))}e.$we=t;function n(k,R){return A.$ee(k,R,L=>d.concat(L))}e.$xe=n;function l(k){let R=0,L=0,T=0;const N=new Uint8Array(Math.floor(k.length/4*3)),K=ae=>{switch(L){case 3:N[T++]=R|ae,L=0;break;case 2:N[T++]=R|ae>>>2,R=ae<<6,L=3;break;case 1:N[T++]=R|ae>>>4,R=ae<<4,L=2;break;default:R=ae<<2,L=1}};for(let ae=0;ae<k.length;ae++){const ne=k.charCodeAt(ae);if(ne>=65&&ne<=90)K(ne-65);else if(ne>=97&&ne<=122)K(ne-97+26);else if(ne>=48&&ne<=57)K(ne-48+52);else if(ne===43||ne===45)K(62);else if(ne===47||ne===95)K(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ae]}`)}}const Q=T;for(;L>0;)K(0);return d.wrap(N).slice(0,Q)}e.$ye=l;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:k},R=!0,L=!1){const T=L?D:w;let N="";const K=k.byteLength%3;let Q=0;for(;Q<k.byteLength-K;Q+=3){const ae=k[Q+0],ne=k[Q+1],ce=k[Q+2];N+=T[ae>>>2],N+=T[(ae<<4|ne>>>4)&63],N+=T[(ne<<2|ce>>>6)&63],N+=T[ce&63]}if(K===1){const ae=k[Q+0];N+=T[ae>>>2],N+=T[ae<<4&63],R&&(N+="==")}else if(K===2){const ae=k[Q+0],ne=k[Q+1];N+=T[ae>>>2],N+=T[(ae<<4|ne>>>4)&63],N+=T[ne<<2&63],R&&(N+="=")}return N}e.$ze=I}),define(re[27],oe([0,1,142,72]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function s(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$Fe=s;const M=/{(\d+)}/g;function C(ie,...fe){return fe.length===0?ie:ie.replace(M,function($e,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=fe.length?$e:fe[Ce]})}e.$Ge=C;const P=/{([^}]+)}/g;function d(ie,fe){return Object.keys(fe).length===0?ie:ie.replace(P,($e,ye)=>fe[ye]??$e)}e.$He=d;function c(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ie=c;function $(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=$;function p(ie,fe){let $e=0;const ye=fe.charCodeAt(0);for(let Ce=ie.length-1;Ce>=0;Ce--)ie.charCodeAt(Ce)===ye&&$e++;return $e}e.$Ke=p;function v(ie,fe,$e="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${$e}`}e.$Le=v;function f(ie,fe=" "){const $e=y(ie,fe);return m($e,fe)}e.$Me=f;function y(ie,fe){if(!ie||!fe)return ie;const $e=fe.length;if($e===0||ie.length===0)return ie;let ye=0;for(;ie.indexOf(fe,ye)===ye;)ye=ye+$e;return ie.substring(ye)}e.$Ne=y;function m(ie,fe){if(!ie||!fe)return ie;const $e=fe.length,ye=ie.length;if($e===0||ye===0)return ie;let Ce=ye,Ue=-1;for(;Ue=ie.lastIndexOf(fe,Ce-1),!(Ue===-1||Ue+$e!==Ce);){if(Ue===0)return"";Ce=Ue}return ie.substring(0,Ce)}e.$Oe=m;function b(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=b;function g(ie){return ie.replace(/\*/g,"")}e.$Qe=g;function u(ie,fe,$e={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=$(ie)),$e.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(ie,ye)}e.$Re=u;function a(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Se=a;function E(ie){return ie.split(/\r\n|\r|\n/)}e.$Te=E;function h(ie){for(let fe=0,$e=ie.length;fe<$e;fe++){const ye=ie.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}e.$Ue=h;function i(ie,fe=0,$e=ie.length){for(let ye=fe;ye<$e;ye++){const Ce=ie.charCodeAt(ye);if(Ce!==32&&Ce!==9)return ie.substring(fe,ye)}return ie.substring(fe,$e)}e.$Ve=i;function o(ie,fe=ie.length-1){for(let $e=fe;$e>=0;$e--){const ye=ie.charCodeAt($e);if(ye!==32&&ye!==9)return $e}return-1}e.$We=o;function r(ie,fe,$e){const ye=[];let Ce=0;for(const Ue of ie.matchAll(fe)){if(ye.push(ie.slice(Ce,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Ce=Ue.index+Ue[0].length,ye.push($e(Ue[0],...Ue.slice(1),Ue.index,ie,Ue.groups))}return ye.push(ie.slice(Ce)),Promise.all(ye).then(Ue=>Ue.join(""))}e.$Xe=r;function t(ie,fe){return ie<fe?-1:ie>fe?1:0}e.$Ye=t;function n(ie,fe,$e=0,ye=ie.length,Ce=0,Ue=fe.length){for(;$e<ye&&Ce<Ue;$e++,Ce++){const qe=ie.charCodeAt($e),Ge=fe.charCodeAt(Ce);if(qe<Ge)return-1;if(qe>Ge)return 1}const Le=ye-$e,We=Ue-Ce;return Le<We?-1:Le>We?1:0}e.$Ze=n;function l(ie,fe){return w(ie,fe,0,ie.length,0,fe.length)}e.$1e=l;function w(ie,fe,$e=0,ye=ie.length,Ce=0,Ue=fe.length){for(;$e<ye&&Ce<Ue;$e++,Ce++){let qe=ie.charCodeAt($e),Ge=fe.charCodeAt(Ce);if(qe===Ge)continue;if(qe>=128||Ge>=128)return n(ie.toLowerCase(),fe.toLowerCase(),$e,ye,Ce,Ue);I(qe)&&(qe-=32),I(Ge)&&(Ge-=32);const Je=qe-Ge;if(Je!==0)return Je}const Le=ye-$e,We=Ue-Ce;return Le<We?-1:Le>We?1:0}e.$2e=w;function D(ie){return ie>=48&&ie<=57}e.$3e=D;function I(ie){return ie>=97&&ie<=122}e.$4e=I;function k(ie){return ie>=65&&ie<=90}e.$5e=k;function R(ie,fe){return ie.length===fe.length&&w(ie,fe)===0}e.$6e=R;function L(ie,fe){const $e=fe.length;return fe.length>ie.length?!1:w(ie,fe,0,$e)===0}e.$7e=L;function T(ie,fe){const $e=Math.min(ie.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(ie.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}e.$8e=T;function N(ie,fe){const $e=Math.min(ie.length,fe.length);let ye;const Ce=ie.length-1,Ue=fe.length-1;for(ye=0;ye<$e;ye++)if(ie.charCodeAt(Ce-ye)!==fe.charCodeAt(Ue-ye))return ye;return $e}e.$9e=N;function K(ie){return 55296<=ie&&ie<=56319}e.$0e=K;function Q(ie){return 56320<=ie&&ie<=57343}e.$$e=Q;function ae(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.$_e=ae;function ne(ie,fe,$e){const ye=ie.charCodeAt($e);if(K(ye)&&$e+1<fe){const Ce=ie.charCodeAt($e+1);if(Q(Ce))return ae(ye,Ce)}return ye}e.$af=ne;function ce(ie,fe){const $e=ie.charCodeAt(fe-1);if(Q($e)&&fe>1){const ye=ie.charCodeAt(fe-2);if(K(ye))return ae(ye,$e)}return $e}class X{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ce(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=ne(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$bf=X;class Y{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new X(fe,$e)}nextGraphemeLength(){const fe=ue.getInstance(),$e=this.c,ye=$e.offset;let Ce=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ue=$e.offset,Le=fe.getGraphemeBreakType($e.nextCodePoint());if(pe(Ce,Le)){$e.setOffset(Ue);break}Ce=Le}return $e.offset-ye}prevGraphemeLength(){const fe=ue.getInstance(),$e=this.c,ye=$e.offset;let Ce=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ue=$e.offset,Le=fe.getGraphemeBreakType($e.prevCodePoint());if(pe(Le,Ce)){$e.setOffset(Ue);break}Ce=Le}return ye-$e.offset}eol(){return this.c.eol()}}e.$cf=Y;function V(ie,fe){return new Y(ie,fe).nextGraphemeLength()}e.$df=V;function q(ie,fe){return new Y(ie,fe).prevGraphemeLength()}e.$ef=q;function j(ie,fe){fe>0&&Q(ie.charCodeAt(fe))&&fe--;const $e=fe+V(ie,fe);return[$e-q(ie,$e),$e]}e.$ff=j;function H(ie){const fe=new Y(ie);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}e.$gf=H;let B;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function se(ie){return B||(B=_()),B.test(ie)}e.$hf=se;const J=/^[\t\n\r\x20-\x7E]*$/;function O(ie){return J.test(ie)}e.$if=O,e.$jf=/[\u2028\u2029]/;function U(ie){return e.$jf.test(ie)}e.$kf=U;function G(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$lf=G;function F(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$mf=F;function z(ie,fe){if(ie.length<fe)return ie;const $e=/\b/g;let ye=0;for(;$e.test(ie)&&!(ie.length-$e.lastIndex<fe);)ye=$e.lastIndex,$e.lastIndex+=1;return ie.substring(ye).replace(/^\s/,"")}e.$nf=z;const W=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,x=/\x1b\].*?\x07/g;function he(ie){return ie&&(ie=ie.replace(W,"").replace(x,"")),ie}e.$of=he,e.$pf=String.fromCharCode(65279);function de(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$qf=de;function le(ie){return de(ie)?ie.substr(1):ie}e.$rf=le;function we(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const $e=fe.length,ye=ie.toLowerCase();let Ce=0,Ue=-1;for(;Ce<$e;){const Le=ye.indexOf(fe[Ce],Ue+1);if(Le<0)return!1;Ue=Le,Ce++}return!0}e.$sf=we;function be(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$tf=be;function Ee(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$uf=Ee;function Se(ie,fe=1){if(fe===0)return"";let $e=-1;do $e=ie.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?ie:(ie[$e-1]==="\r"&&$e--,ie.substr(0,$e))}e.$vf=Se;function Fe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$wf=Fe;function ke(ie){return ue.getInstance().getGraphemeBreakType(ie)}e.$xf=ke;function pe(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var ee;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ee||(e.GraphemeBreakType=ee={}));class ue{static{this.c=null}static getInstance(){return ue.c||(ue.c=new ue),ue.c}constructor(){this.d=ge()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const $e=this.d,ye=$e.length/3;let Ce=1;for(;Ce<=ye;)if(fe<$e[3*Ce])Ce=2*Ce;else if(fe>$e[3*Ce+1])Ce=2*Ce+1;else return $e[3*Ce+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(ie,fe){if(ie===0)return 0;const $e=De(ie,fe);if($e!==void 0)return $e;const ye=new X(fe,ie);return ye.prevCodePoint(),ye.offset}e.$yf=Re;function De(ie,fe){const $e=new X(fe,ie);let ye=$e.prevCodePoint();for(;je(ye)||ye===65039||ye===8419;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!F(ye))return;let Ce=$e.offset;return Ce>0&&$e.prevCodePoint()===8205&&(Ce=$e.offset),Ce}function je(ie){return 127995<=ie&&ie<=127999}var Me;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.$zf="\xA0";class Ve{static{this.c=new A.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$Be(fe=>{function $e(Je){const _e=new Map;for(let Ze=0;Ze<Je.length;Ze+=2)_e.set(Je[Ze],Je[Ze+1]);return _e}function ye(Je,_e){const Ze=new Map(Je);for(const[it,st]of _e)Ze.set(it,st);return Ze}function Ce(Je,_e){if(!Je)return _e;const Ze=new Map;for(const[it,st]of Je)_e.has(it)&&Ze.set(it,st);return Ze}const Ue=this.c.value;let Le=fe.filter(Je=>!Je.startsWith("_")&&Je in Ue);Le.length===0&&(Le=["_default"]);let We;for(const Je of Le){const _e=$e(Ue[Je]);We=Ce(We,_e)}const qe=$e(Ue._common),Ge=ye(qe,We);return new Ve(Ge)})}static getInstance(fe){return Ve.d.get(Array.from(fe))}static{this.e=new A.$U(()=>Object.keys(Ve.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ve.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=Ve;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(fe){return ze.e().has(fe)}static get codePoints(){return ze.e()}}e.$Bf=ze}),define(re[45],oe([0,1,27]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;function A(g){return s(g,0)}e.$Ji=A;function s(g,u){switch(typeof g){case"object":return g===null?M(349,u):Array.isArray(g)?d(g,u):c(g,u);case"string":return P(g,u);case"boolean":return C(g,u);case"number":return M(g,u);case"undefined":return M(937,u);default:return M(617,u)}}e.$Ki=s;function M(g,u){return(u<<5)-u+g|0}e.$Li=M;function C(g,u){return M(g?433:863,u)}function P(g,u){u=M(149417,u);for(let a=0,E=g.length;a<E;a++)u=M(g.charCodeAt(a),u);return u}e.$Mi=P;function d(g,u){return u=M(104579,u),g.reduce((a,E)=>s(E,a),u)}function c(g,u){return u=M(181387,u),Object.keys(g).sort().reduce((a,E)=>(a=P(E,a),s(g[E],a)),u)}class ${constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=s(u,this.g),this.g}}e.$Ni=$;var p;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function v(g,u,a=32){const E=a-u,h=~((1<<E)-1);return(g<<u|(h&g)>>>E)>>>0}function f(g,u=0,a=g.byteLength,E=0){for(let h=0;h<a;h++)g[u+h]=E}function y(g,u,a="0"){for(;g.length<u;)g=a+g;return g}function m(g,u=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(a=>a.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),u/4)}e.$Oi=m;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const a=u.length;if(a===0)return;const E=this.p;let h=this.r,i=this.u,o,r;for(i!==0?(o=i,r=-1,i=0):(o=u.charCodeAt(0),r=0);;){let t=o;if(S.$0e(o))if(r+1<a){const n=u.charCodeAt(r+1);S.$$e(n)?(r++,t=S.$_e(o,n)):t=65533}else{i=o;break}else S.$$e(o)&&(t=65533);if(h=this.w(E,h,t),r++,r<a)o=u.charCodeAt(r);else break}this.r=h,this.u=i}w(u,a,E){return E<128?u[a++]=E:E<2048?(u[a++]=192|(E&1984)>>>6,u[a++]=128|(E&63)>>>0):E<65536?(u[a++]=224|(E&61440)>>>12,u[a++]=128|(E&4032)>>>6,u[a++]=128|(E&63)>>>0):(u[a++]=240|(E&1835008)>>>18,u[a++]=128|(E&258048)>>>12,u[a++]=128|(E&4032)>>>6,u[a++]=128|(E&63)>>>0),a>=64&&(this.y(),a-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),a}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=b.g,a=this.q;for(let w=0;w<64;w+=4)u.setUint32(w,a.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)u.setUint32(w,v(u.getUint32(w-12,!1)^u.getUint32(w-32,!1)^u.getUint32(w-56,!1)^u.getUint32(w-64,!1),1),!1);let E=this.h,h=this.l,i=this.m,o=this.n,r=this.o,t,n,l;for(let w=0;w<80;w++)w<20?(t=h&i|~h&o,n=1518500249):w<40?(t=h^i^o,n=1859775393):w<60?(t=h&i|h&o|i&o,n=2400959708):(t=h^i^o,n=3395469782),l=v(E,5)+t+r+n+u.getUint32(w*4,!1)&4294967295,r=o,o=i,i=v(h,30),h=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+h&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Pi=b}),define(re[74],oe([0,1,27]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(A||(A={})),function(s){const M="error",C="warning",P="warn",d="info",c="ignore";function $(v){return v?S.$6e(M,v)?s.Error:S.$6e(C,v)||S.$6e(P,v)?s.Warning:S.$6e(d,v)?s.Info:s.Ignore:s.Ignore}s.fromValue=$;function p(v){switch(v){case s.Error:return M;case s.Warning:return C;case s.Info:return d;default:return c}}s.toString=p}(A||(A={})),e.default=A}),define(re[143],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(re[57],oe([0,1,23,27]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const y=f.charCodeAt(0),m=this.b.charCodeAt(this.c);return y-m}value(){return this.b[this.c]}}e.$Xh=s;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,A.$Ze)(f,this.b,0,f.length,this.c,this.d):(0,A.$2e)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=M;class C{constructor(f=!0,y=!0){this.f=f,this.g=y}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let y=f.length-1;y>=0;y--,this.c--){const m=this.b.charCodeAt(y);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,A.$Ze)(f,this.b,0,f.length,this.d,this.e):(0,A.$2e)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=C;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class d{constructor(f,y){this.f=f,this.g=y,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,A.$1e)(f,this.c.scheme);if(this.d[this.e]===2)return(0,A.$1e)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,A.$Ye)(f,this.c.query);if(this.d[this.e]===5)return(0,A.$Ye)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=d;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})($||($={}));class p{static forUris(f=()=>!1,y=()=>!1){return new p(new d(f,y))}static forPaths(f=!1){return new p(new C(void 0,!f))}static forStrings(){return new p(new s)}static forConfigKeys(){return new p(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,y){if(y){const m=y.slice(0);(0,S.$Wb)(m);for(const b of m)this.set(b,f)}else{const m=f.slice(0);(0,S.$Wb)(m);for(const b of m)this.set(b[0],b[1])}}set(f,y){const m=this.b.reset(f);let b;this.c||(this.c=new c,this.c.segment=m.value());const g=[];for(b=this.c;;){const a=m.cmp(b.segment);if(a>0)b.left||(b.left=new c,b.left.segment=m.value()),g.push([-1,b]),b=b.left;else if(a<0)b.right||(b.right=new c,b.right.segment=m.value()),g.push([1,b]),b=b.right;else if(m.hasNext())m.next(),b.mid||(b.mid=new c,b.mid.segment=m.value()),g.push([0,b]),b=b.mid;else break}const u=b.value;b.value=y,b.key=f;for(let a=g.length-1;a>=0;a--){const E=g[a][1];E.updateHeight();const h=E.balanceFactor();if(h<-1||h>1){const i=g[a][0],o=g[a+1][0];if(i===1&&o===1)g[a][1]=E.rotateLeft();else if(i===-1&&o===-1)g[a][1]=E.rotateRight();else if(i===1&&o===-1)E.right=g[a+1][1]=g[a+1][1].rotateRight(),g[a][1]=E.rotateLeft();else if(i===-1&&o===1)E.left=g[a+1][1]=g[a+1][1].rotateLeft(),g[a][1]=E.rotateRight();else throw new Error;if(a>0)switch(g[a-1][0]){case-1:g[a-1][1].left=g[a][1];break;case 1:g[a-1][1].right=g[a][1];break;case 0:g[a-1][1].mid=g[a][1];break}else this.c=g[0][1]}}return u}get(f){return this.d(f)?.value}d(f){const y=this.b.reset(f);let m=this.c;for(;m;){const b=y.cmp(m.segment);if(b>0)m=m.left;else if(b<0)m=m.right;else if(y.hasNext())y.next(),m=m.mid;else break}return m}has(f){const y=this.d(f);return!(y?.value===void 0&&y?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,y){const m=this.b.reset(f),b=[];let g=this.c;for(;g;){const u=m.cmp(g.segment);if(u>0)b.push([-1,g]),g=g.left;else if(u<0)b.push([1,g]),g=g.right;else if(m.hasNext())m.next(),b.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const u=this.f(g.right);if(u.key){const{key:a,value:E,segment:h}=u;this.e(u.key,!1),g.key=a,g.value=E,g.segment=h}}else{const u=g.left??g.right;if(b.length>0){const[a,E]=b[b.length-1];switch(a){case-1:E.left=u;break;case 0:E.mid=u;break;case 1:E.right=u;break}}else this.c=u}for(let u=b.length-1;u>=0;u--){const a=b[u][1];a.updateHeight();const E=a.balanceFactor();if(E>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),b[u][1]=a.rotateLeft()):E<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),b[u][1]=a.rotateRight()),u>0)switch(b[u-1][0]){case-1:b[u-1][1].left=b[u][1];break;case 1:b[u-1][1].right=b[u][1];break;case 0:b[u-1][1].mid=b[u][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const y=this.b.reset(f);let m=this.c,b;for(;m;){const g=y.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(y.hasNext())y.next(),b=m.value||b,m=m.mid;else break}return m&&m.value||b}findSuperstr(f){return this.g(f,!1)}g(f,y){const m=this.b.reset(f);let b=this.c;for(;b;){const g=m.cmp(b.segment);if(g>0)b=b.left;else if(g<0)b=b.right;else if(m.hasNext())m.next(),b=b.mid;else return b.mid?this.h(b.mid):y?b.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[y,m]of this)f(m,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const y=[];return this.j(f,y),y[Symbol.iterator]()}j(f,y){f&&(f.left&&this.j(f.left,y),f.value&&y.push([f.key,f.value]),f.mid&&this.j(f.mid,y),f.right&&this.j(f.right,y))}_isBalanced(){const f=y=>{if(!y)return!0;const m=y.balanceFactor();return m<-1||m>1?!1:f(y.left)&&f(y.right)};return f(this.c)}}e.$2h=p}),define(re[12],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function S(h){return typeof h=="string"}e.$Cf=S;function A(h){return Array.isArray(h)&&h.every(i=>S(i))}e.$Df=A;function s(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$Ef=s;function M(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}e.$Ff=M;function C(h){return typeof h=="number"&&!isNaN(h)}e.$Gf=C;function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Hf=P;function d(h){return h===!0||h===!1}e.$If=d;function c(h){return typeof h>"u"}e.$Jf=c;function $(h){return!p(h)}e.$Kf=$;function p(h){return c(h)||h===null}e.$Lf=p;function v(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Mf=v;function f(h){if(p(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$Nf=f;function y(...h){const i=[];for(let o=0;o<h.length;o++){const r=h[o];if(p(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(r)}return i}e.$Of=y;const m=Object.prototype.hasOwnProperty;function b(h){if(!s(h))return!1;for(const i in h)if(m.call(h,i))return!1;return!0}e.$Pf=b;function g(h){return typeof h=="function"}e.$Qf=g;function u(...h){return h.length>0&&h.every(g)}e.$Rf=u;function a(h,i){const o=Math.min(h.length,i.length);for(let r=0;r<o;r++)E(h[r],i[r])}e.$Sf=a;function E(h,i){if(S(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(h instanceof i)return}catch{}if(!p(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=E}),define(re[75],oe([0,1,12]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=void 0;const A=Object.create(null);function s(P,d){if((0,S.$Cf)(d)){const c=A[d];if(c===void 0)throw new Error(`${P} references an unknown codicon: ${d}`);d=c}return A[P]=d,{id:P}}function M(){return A}e.$Yj=M;function C(){return Object.values(e.$1j)}e.$Zj=C,e.$1j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(re[38],oe([0,1,12]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const u=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([a,E])=>{u[a]=E&&typeof E=="object"?A(E):E}),u}e.$an=A;function s(g){if(!g||typeof g!="object")return g;const u=[g];for(;u.length>0;){const a=u.shift();Object.freeze(a);for(const E in a)if(M.call(a,E)){const h=a[E];typeof h=="object"&&!Object.isFrozen(h)&&!(0,S.$Ff)(h)&&u.push(h)}}return g}e.$bn=s;const M=Object.prototype.hasOwnProperty;function C(g,u){return P(g,u,new Set)}e.$cn=C;function P(g,u,a){if((0,S.$Lf)(g))return g;const E=u(g);if(typeof E<"u")return E;if(Array.isArray(g)){const h=[];for(const i of g)h.push(P(i,u,a));return h}if((0,S.$Ef)(g)){if(a.has(g))throw new Error("Cannot clone recursive data-structure");a.add(g);const h={};for(const i in g)M.call(g,i)&&(h[i]=P(g[i],u,a));return a.delete(g),h}return g}function d(g,u,a=!0){return(0,S.$Ef)(g)?((0,S.$Ef)(u)&&Object.keys(u).forEach(E=>{E in g?a&&((0,S.$Ef)(g[E])&&(0,S.$Ef)(u[E])?d(g[E],u[E],a):g[E]=u[E]):g[E]=u[E]}),g):u}e.$dn=d;function c(g,u){if(g===u)return!0;if(g==null||u===null||u===void 0||typeof g!=typeof u||typeof g!="object"||Array.isArray(g)!==Array.isArray(u))return!1;let a,E;if(Array.isArray(g)){if(g.length!==u.length)return!1;for(a=0;a<g.length;a++)if(!c(g[a],u[a]))return!1}else{const h=[];for(E in g)h.push(E);h.sort();const i=[];for(E in u)i.push(E);if(i.sort(),!c(h,i))return!1;for(a=0;a<h.length;a++)if(!c(g[h[a]],u[h[a]]))return!1}return!0}e.$en=c;function $(g){const u=new Set;return JSON.stringify(g,(a,E)=>{if((0,S.$Ef)(E)||Array.isArray(E)){if(u.has(E))return"[Circular]";u.add(E)}return E})}e.$fn=$;function p(g,u){const a=Object.create(null);return!g||!u||Object.keys(u).forEach(h=>{const i=g[h],o=u[h];c(i,o)||(a[h]=o)}),a}e.$gn=p;function v(g,u){const a=u.toLowerCase(),E=Object.keys(g).find(h=>h.toLowerCase()===a);return E?g[E]:g[u]}e.$hn=v;function f(g,u){const a=Object.create(null);for(const[E,h]of Object.entries(g))u(E,h)&&(a[E]=h);return a}e.$in=f;function y(g){let u=[];for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}e.$jn=y;function m(g){const u=[];for(const a of y(g))typeof g[a]=="function"&&u.push(a);return u}e.$kn=m;function b(g,u){const a=h=>function(){const i=Array.prototype.slice.call(arguments,0);return u(h,i)},E={};for(const h of g)E[h]=a(h);return E}e.$ln=b}),define(re[102],oe([0,1,75]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var A;(function(C){function P(d){return d&&typeof d=="object"&&typeof d.id=="string"}C.isThemeColor=P})(A||(e.ThemeColor=A={}));function s(C){return{id:C}}e.$2j=s;var M;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function d(u){const a=P.exec(u.id);if(!a)return d(S.$1j.error);const[,E,h]=a,i=["codicon","codicon-"+E];return h&&i.push("codicon-modifier-"+h.substring(1)),i}C.asClassNameArray=d;function c(u){return d(u).join(" ")}C.asClassName=c;function $(u){return"."+d(u).join(".")}C.asCSSSelector=$;function p(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||A.isThemeColor(u.color))}C.isThemeIcon=p;const v=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function f(u){const a=v.exec(u);if(!a)return;const[,E]=a;return{id:E}}C.fromString=f;function y(u){return{id:u}}C.fromId=y;function m(u,a){let E=u.id;const h=E.lastIndexOf("~");return h!==-1&&(E=E.substring(0,h)),a&&(E=`${E}~${a}`),{id:E}}C.modify=m;function b(u){const a=u.id.lastIndexOf("~");if(a!==-1)return u.id.substring(a+1)}C.getModifier=b;function g(u,a){return u.id===a.id&&u.color?.id===a.color?.id}C.isEqual=g})(M||(e.ThemeIcon=M={}))}),define(re[32],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(s){return S.test(s)}e.$hg=A,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let d=0,c="";return c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+="-",c+=C[M[d++]],c+=C[M[d++]],c+="-",c+=C[M[d++]],c+=C[M[d++]],c+="-",c+=C[M[d++]],c+=C[M[d++]],c+="-",c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c+=C[M[d++]],c}}()}),define(re[144],oe([0,1,86,46,84]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QT=void 0;async function M(C,P){if(await new Promise(($,p)=>{const v=A.createReadStream(C),f=S.createHash("sha1");v.pipe(f);const y=(0,s.$cb)((m,b)=>{v.removeAllListeners(),f.removeAllListeners(),m?p(m):$(b)});v.once("error",y),v.once("end",y),f.once("error",y),f.once("data",m=>y(void 0,m.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$QT=M}),define(re[145],oe([0,1,28]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const P=C.replace(/\-/g,":").toLowerCase();return!A.has(P)}function M(){const C=(0,S.networkInterfaces)();for(const P in C){const d=C[P];if(d){for(const{mac:c}of d)if(s(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Wm=M}),define(re[103],oe([0,1,87]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=e.$kg=void 0;function A(P,d,c,$=1){let p=!1;return new Promise(v=>{const f=setTimeout(()=>{if(!p)return p=!0,v(0)},c);s(P,d,$,y=>{if(!p)return p=!0,clearTimeout(f),v(y)})})}e.$kg=A;function s(P,d,c,$){if(d===0)return $(0);const p=new S.Socket;p.once("connect",()=>(C(p),s(P+c,d-1,c,$))),p.once("data",()=>{}),p.once("error",v=>(C(p),v.code!=="ECONNREFUSED"?s(P+c,d-1,c,$):$(P))),p.connect(P,"127.0.0.1")}e.$lg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,d,c,$="127.0.0.1"){let p=!1,v,f=1;const y=S.createServer({pauseOnConnect:!0});function m(b,g){p||(p=!0,y.removeAllListeners(),y.close(),v&&clearTimeout(v),g(b))}return new Promise(b=>{v=setTimeout(()=>{m(0,b)},c),y.on("listening",()=>{m(P,b)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&f<d?(P++,f++,y.listen(P,$)):m(0,b)}),y.on("close",()=>{m(0,b)}),y.listen(P,$)})}e.$mg=M;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(d){console.error(d)}}}),function(){function Z(){function e(){return process.uncHostAllowlist}function S(d){const c=new Set;if(Array.isArray(d))for(const $ of d)typeof $=="string"&&c.add($);return Array.from(c)}function A(){const d=e();return d?Array.from(d):[]}function s(d){if(process.platform!=="win32")return;const c=e();if(c)if(typeof d=="string")c.add(d.toLowerCase());else for(const $ of S(d))s($)}function M(d){if(typeof d!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let $;for(const p of c){if(d.indexOf(p)!==0)continue;const f=d.indexOf("\\",p.length);if(f===-1)continue;const y=d.substring(p.length,f);if(y){$=y;break}}return $}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Z()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Z():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(re[146],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UT=e.$TT=void 0,e.$TT="vscode:contextmenu",e.$UT="vscode:onCloseContextMenu"}),define(re[147],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2T=void 0;class S{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$2T=S}),define(re[148],oe([11,10]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(re[149],oe([0,1,148]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const A=60,s=A*60,M=s*24,C=M*7,P=M*30,d=M*365;function c(p,v,f,y){typeof p!="number"&&(p=p.getTime());const m=Math.round((new Date().getTime()-p)/1e3);if(m<-30)return(0,S.localize)(0,null,c(new Date().getTime()+m*1e3,!1));if(!y&&m<30)return(0,S.localize)(1,null);let b;return m<A?(b=m,v?b===1?f?(0,S.localize)(2,null,b):(0,S.localize)(3,null,b):f?(0,S.localize)(4,null,b):(0,S.localize)(5,null,b):b===1?f?(0,S.localize)(6,null,b):(0,S.localize)(7,null,b):f?(0,S.localize)(8,null,b):(0,S.localize)(9,null,b)):m<s?(b=Math.floor(m/A),v?b===1?f?(0,S.localize)(10,null,b):(0,S.localize)(11,null,b):f?(0,S.localize)(12,null,b):(0,S.localize)(13,null,b):b===1?f?(0,S.localize)(14,null,b):(0,S.localize)(15,null,b):f?(0,S.localize)(16,null,b):(0,S.localize)(17,null,b)):m<M?(b=Math.floor(m/s),v?b===1?f?(0,S.localize)(18,null,b):(0,S.localize)(19,null,b):f?(0,S.localize)(20,null,b):(0,S.localize)(21,null,b):b===1?f?(0,S.localize)(22,null,b):(0,S.localize)(23,null,b):f?(0,S.localize)(24,null,b):(0,S.localize)(25,null,b)):m<C?(b=Math.floor(m/M),v?b===1?(0,S.localize)(26,null,b):(0,S.localize)(27,null,b):b===1?(0,S.localize)(28,null,b):(0,S.localize)(29,null,b)):m<P?(b=Math.floor(m/C),v?b===1?f?(0,S.localize)(30,null,b):(0,S.localize)(31,null,b):f?(0,S.localize)(32,null,b):(0,S.localize)(33,null,b):b===1?f?(0,S.localize)(34,null,b):(0,S.localize)(35,null,b):f?(0,S.localize)(36,null,b):(0,S.localize)(37,null,b)):m<d?(b=Math.floor(m/P),v?b===1?f?(0,S.localize)(38,null,b):(0,S.localize)(39,null,b):f?(0,S.localize)(40,null,b):(0,S.localize)(41,null,b):b===1?f?(0,S.localize)(42,null,b):(0,S.localize)(43,null,b):f?(0,S.localize)(44,null,b):(0,S.localize)(45,null,b)):(b=Math.floor(m/d),v?b===1?f?(0,S.localize)(46,null,b):(0,S.localize)(47,null,b):f?(0,S.localize)(48,null,b):(0,S.localize)(49,null,b):b===1?f?(0,S.localize)(50,null,b):(0,S.localize)(51,null,b):f?(0,S.localize)(52,null,b):(0,S.localize)(53,null,b))}e.$jm=c;function $(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=$}),define(re[150],oe([11,10]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(re[50],oe([0,1,23,12,150]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function M(p,v){return v&&(p.stack||p.stacktrace)?s.localize(0,null,P(p),C(p.stack)||C(p.stacktrace)):P(p)}function C(p){return Array.isArray(p)?p.join(`
`):p}function P(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?s.localize(1,null,p.message):p.message||s.localize(2,null)}function d(p=null,v=!1){if(!p)return s.localize(3,null);if(Array.isArray(p)){const f=S.$Gb(p),y=d(f[0],v);return f.length>1?s.localize(4,null,y,f.length):y}if(A.$Cf(p))return p;if(p.detail){const f=p.detail;if(f.error)return M(f.error,v);if(f.exception)return M(f.exception,v)}return p.stack?M(p,v):p.message?p.message:s.localize(5,null)}e.$Gi=d;function c(p){const v=p;return v instanceof Error&&Array.isArray(v.actions)}e.$Hi=c;function $(p,v){let f;return typeof p=="string"?f=new Error(p):f=p,f.actions=v,f}e.$Ii=$}),define(re[151],oe([11,10]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(re[152],oe([0,1,151]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;function A(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$Cp=A}),define(re[153],oe([11,10]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,153]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,s=!1,M=!1,C=!1,P=!1,d=!1,c=!1,$=!1,p=!1,v=!1,f,y=e.$g,m=e.$g,b,g;const u=globalThis;let a;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?a=u.vscode.process:typeof process<"u"&&(a=process);const E=typeof a?.versions?.electron=="string",h=E&&a?.type==="renderer";if(typeof navigator=="object"&&!h)g=navigator.userAgent,A=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,$=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=g.indexOf("Linux")>=0,v=g?.indexOf("Mobi")>=0,d=!0,f=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,y=f,m=navigator.language;else if(typeof a=="object"){A=a.platform==="win32",s=a.platform==="darwin",M=a.platform==="linux",C=M&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,c=E,p=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,y=e.$g;const I=a.env.VSCODE_NLS_CONFIG;if(I)try{const k=JSON.parse(I),R=k.availableLanguages["*"];f=k.locale,m=k.osLocale,y=R||e.$g,b=k._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var i;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:A?r=3:M&&(r=2),e.$i=A,e.$j=s,e.$k=M,e.$l=C,e.$m=P,e.$n=c,e.$o=d,e.$p=d&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=$,e.$s=v,e.$t=p,e.$u=r,e.$v=g,e.$w=y;var t;(function(I){function k(){return e.$w}I.value=k;function R(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=R;function L(){return e.$w==="en"}I.isDefault=L})(t||(e.Language=t={})),e.$x=f,e.$y=m,e.$z=b,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const I=[];u.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let L=0,T=I.length;L<T;L++){const N=I[L];if(N.id===R.data.vscodeScheduleAsyncWork){I.splice(L,1),N.callback();return}}});let k=0;return R=>{const L=++k;I.push({id:L,callback:R}),u.postMessage({vscodeScheduleAsyncWork:L},"*")}}return I=>setTimeout(I)})();var n;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||$?2:A?1:3;let l=!0,w=!1;function D(){if(!w){w=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,l=new Uint16Array(I.buffer)[0]===(2<<8)+1}return l}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(re[35],oe([0,1,4]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;A={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$cc=A.platform,e.$dc=A.arch}),define(re[9],oe([0,1,35]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const A=65,s=97,M=90,C=122,P=46,d=47,c=92,$=58,p=63;class v extends Error{constructor(o,r,t){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const l=o.indexOf(".")!==-1?"property":"argument";let w=`The "${o}" ${l} ${n} of type ${r}`;w+=`. Received type ${typeof t}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new v(o,"Object",i)}function y(i,o){if(typeof i!="string")throw new v(o,"string",i)}const m=S.$cc==="win32";function b(i){return i===d||i===c}function g(i){return i===d}function u(i){return i>=A&&i<=M||i>=s&&i<=C}function a(i,o,r,t){let n="",l=0,w=-1,D=0,I=0;for(let k=0;k<=i.length;++k){if(k<i.length)I=i.charCodeAt(k);else{if(t(I))break;I=d}if(t(I)){if(!(w===k-1||D===1))if(D===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const R=n.lastIndexOf(r);R===-1?(n="",l=0):(n=n.slice(0,R),l=n.length-1-n.lastIndexOf(r)),w=k,D=0;continue}else if(n.length!==0){n="",l=0,w=k,D=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",l=2)}else n.length>0?n+=`${r}${i.slice(w+1,k)}`:n=i.slice(w+1,k),l=k-w-1;w=k,D=0}else I===P&&D!==-1?++D:D=-1}return n}function E(i,o){f(o,"pathObject");const r=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${t}`:`${r}${i}${t}`:t}e.$ec={resolve(...i){let o="",r="",t=!1;for(let n=i.length-1;n>=-1;n--){let l;if(n>=0){if(l=i[n],y(l,"path"),l.length===0)continue}else o.length===0?l=S.cwd():(l=S.env[`=${o}`]||S.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===c)&&(l=`${o}\\`));const w=l.length;let D=0,I="",k=!1;const R=l.charCodeAt(0);if(w===1)b(R)&&(D=1,k=!0);else if(b(R))if(k=!0,b(l.charCodeAt(1))){let L=2,T=L;for(;L<w&&!b(l.charCodeAt(L));)L++;if(L<w&&L!==T){const N=l.slice(T,L);for(T=L;L<w&&b(l.charCodeAt(L));)L++;if(L<w&&L!==T){for(T=L;L<w&&!b(l.charCodeAt(L));)L++;(L===w||L!==T)&&(I=`\\\\${N}\\${l.slice(T,L)}`,D=L)}}}else D=1;else u(R)&&l.charCodeAt(1)===$&&(I=l.slice(0,2),D=2,w>2&&b(l.charCodeAt(2))&&(k=!0,D=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(t){if(o.length>0)break}else if(r=`${l.slice(D)}\\${r}`,t=k,k&&o.length>0)break}return r=a(r,!t,"\\",b),t?`${o}\\${r}`:`${o}${r}`||"."},normalize(i){y(i,"path");const o=i.length;if(o===0)return".";let r=0,t,n=!1;const l=i.charCodeAt(0);if(o===1)return g(l)?"\\":i;if(b(l))if(n=!0,b(i.charCodeAt(1))){let D=2,I=D;for(;D<o&&!b(i.charCodeAt(D));)D++;if(D<o&&D!==I){const k=i.slice(I,D);for(I=D;D<o&&b(i.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&!b(i.charCodeAt(D));)D++;if(D===o)return`\\\\${k}\\${i.slice(I)}\\`;D!==I&&(t=`\\\\${k}\\${i.slice(I,D)}`,r=D)}}}else r=1;else u(l)&&i.charCodeAt(1)===$&&(t=i.slice(0,2),r=2,o>2&&b(i.charCodeAt(2))&&(n=!0,r=3));let w=r<o?a(i.slice(r),!n,"\\",b):"";return w.length===0&&!n&&(w="."),w.length>0&&b(i.charCodeAt(o-1))&&(w+="\\"),t===void 0?n?`\\${w}`:w:n?`${t}\\${w}`:`${t}${w}`},isAbsolute(i){y(i,"path");const o=i.length;if(o===0)return!1;const r=i.charCodeAt(0);return b(r)||o>2&&u(r)&&i.charCodeAt(1)===$&&b(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,r;for(let l=0;l<i.length;++l){const w=i[l];y(w,"path"),w.length>0&&(o===void 0?o=r=w:o+=`\\${w}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof r=="string"&&b(r.charCodeAt(0))){++n;const l=r.length;l>1&&b(r.charCodeAt(1))&&(++n,l>2&&(b(r.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&b(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$ec.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o)return"";const r=e.$ec.resolve(i),t=e.$ec.resolve(o);if(r===t||(i=r.toLowerCase(),o=t.toLowerCase(),i===o))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===c;)n++;let l=i.length;for(;l-1>n&&i.charCodeAt(l-1)===c;)l--;const w=l-n;let D=0;for(;D<o.length&&o.charCodeAt(D)===c;)D++;let I=o.length;for(;I-1>D&&o.charCodeAt(I-1)===c;)I--;const k=I-D,R=w<k?w:k;let L=-1,T=0;for(;T<R;T++){const K=i.charCodeAt(n+T);if(K!==o.charCodeAt(D+T))break;K===c&&(L=T)}if(T!==R){if(L===-1)return t}else{if(k>R){if(o.charCodeAt(D+T)===c)return t.slice(D+T+1);if(T===2)return t.slice(D+T)}w>R&&(i.charCodeAt(n+T)===c?L=T:T===2&&(L=3)),L===-1&&(L=0)}let N="";for(T=n+L+1;T<=l;++T)(T===l||i.charCodeAt(T)===c)&&(N+=N.length===0?"..":"\\..");return D+=L,N.length>0?`${N}${t.slice(D,I)}`:(t.charCodeAt(D)===c&&++D,t.slice(D,I))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$ec.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const r=o.charCodeAt(2);if(r!==p&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===$&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return i},dirname(i){y(i,"path");const o=i.length;if(o===0)return".";let r=-1,t=0;const n=i.charCodeAt(0);if(o===1)return b(n)?i:".";if(b(n)){if(r=t=1,b(i.charCodeAt(1))){let D=2,I=D;for(;D<o&&!b(i.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&b(i.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&!b(i.charCodeAt(D));)D++;if(D===o)return i;D!==I&&(r=t=D+1)}}}}else u(n)&&i.charCodeAt(1)===$&&(r=o>2&&b(i.charCodeAt(2))?3:2,t=r);let l=-1,w=!0;for(let D=o-1;D>=t;--D)if(b(i.charCodeAt(D))){if(!w){l=D;break}}else w=!1;if(l===-1){if(r===-1)return".";l=r}return i.slice(0,l)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let r=0,t=-1,n=!0,l;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===$&&(r=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let w=o.length-1,D=-1;for(l=i.length-1;l>=r;--l){const I=i.charCodeAt(l);if(b(I)){if(!n){r=l+1;break}}else D===-1&&(n=!1,D=l+1),w>=0&&(I===o.charCodeAt(w)?--w===-1&&(t=l):(w=-1,t=D))}return r===t?t=D:t===-1&&(t=i.length),i.slice(r,t)}for(l=i.length-1;l>=r;--l)if(b(i.charCodeAt(l))){if(!n){r=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":i.slice(r,t)},extname(i){y(i,"path");let o=0,r=-1,t=0,n=-1,l=!0,w=0;i.length>=2&&i.charCodeAt(1)===$&&u(i.charCodeAt(0))&&(o=t=2);for(let D=i.length-1;D>=o;--D){const I=i.charCodeAt(D);if(b(I)){if(!l){t=D+1;break}continue}n===-1&&(l=!1,n=D+1),I===P?r===-1?r=D:w!==1&&(w=1):r!==-1&&(w=-1)}return r===-1||n===-1||w===0||w===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:E.bind(null,"\\"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.length;let t=0,n=i.charCodeAt(0);if(r===1)return b(n)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(b(n)){if(t=1,b(i.charCodeAt(1))){let L=2,T=L;for(;L<r&&!b(i.charCodeAt(L));)L++;if(L<r&&L!==T){for(T=L;L<r&&b(i.charCodeAt(L));)L++;if(L<r&&L!==T){for(T=L;L<r&&!b(i.charCodeAt(L));)L++;L===r?t=L:L!==T&&(t=L+1)}}}}else if(u(n)&&i.charCodeAt(1)===$){if(r<=2)return o.root=o.dir=i,o;if(t=2,b(i.charCodeAt(2))){if(r===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let l=-1,w=t,D=-1,I=!0,k=i.length-1,R=0;for(;k>=t;--k){if(n=i.charCodeAt(k),b(n)){if(!I){w=k+1;break}continue}D===-1&&(I=!1,D=k+1),n===P?l===-1?l=k:R!==1&&(R=1):l!==-1&&(R=-1)}return D!==-1&&(l===-1||R===0||R===1&&l===D-1&&l===w+1?o.base=o.name=i.slice(w,D):(o.name=i.slice(w,l),o.base=i.slice(w,D),o.ext=i.slice(l,D))),w>0&&w!==t?o.dir=i.slice(0,w-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(m){const i=/\\/g;return()=>{const o=S.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>S.cwd()})();e.$fc={resolve(...i){let o="",r=!1;for(let t=i.length-1;t>=-1&&!r;t--){const n=t>=0?i[t]:h();y(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===d)}return o=a(o,!r,"/",g),r?`/${o}`:o.length>0?o:"."},normalize(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===d,r=i.charCodeAt(i.length-1)===d;return i=a(i,!o,"/",g),i.length===0?o?"/":r?"./":".":(r&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return y(i,"path"),i.length>0&&i.charCodeAt(0)===d},join(...i){if(i.length===0)return".";let o;for(let r=0;r<i.length;++r){const t=i[r];y(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.$fc.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o||(i=e.$fc.resolve(i),o=e.$fc.resolve(o),i===o))return"";const r=1,t=i.length,n=t-r,l=1,w=o.length-l,D=n<w?n:w;let I=-1,k=0;for(;k<D;k++){const L=i.charCodeAt(r+k);if(L!==o.charCodeAt(l+k))break;L===d&&(I=k)}if(k===D)if(w>D){if(o.charCodeAt(l+k)===d)return o.slice(l+k+1);if(k===0)return o.slice(l+k)}else n>D&&(i.charCodeAt(r+k)===d?I=k:k===0&&(I=0));let R="";for(k=r+I+1;k<=t;++k)(k===t||i.charCodeAt(k)===d)&&(R+=R.length===0?"..":"/..");return`${R}${o.slice(l+I)}`},toNamespacedPath(i){return i},dirname(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===d;let r=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===d){if(!t){r=n;break}}else t=!1;return r===-1?o?"/":".":o&&r===1?"//":i.slice(0,r)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let r=0,t=-1,n=!0,l;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let w=o.length-1,D=-1;for(l=i.length-1;l>=0;--l){const I=i.charCodeAt(l);if(I===d){if(!n){r=l+1;break}}else D===-1&&(n=!1,D=l+1),w>=0&&(I===o.charCodeAt(w)?--w===-1&&(t=l):(w=-1,t=D))}return r===t?t=D:t===-1&&(t=i.length),i.slice(r,t)}for(l=i.length-1;l>=0;--l)if(i.charCodeAt(l)===d){if(!n){r=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":i.slice(r,t)},extname(i){y(i,"path");let o=-1,r=0,t=-1,n=!0,l=0;for(let w=i.length-1;w>=0;--w){const D=i.charCodeAt(w);if(D===d){if(!n){r=w+1;break}continue}t===-1&&(n=!1,t=w+1),D===P?o===-1?o=w:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||t===-1||l===0||l===1&&o===t-1&&o===r+1?"":i.slice(o,t)},format:E.bind(null,"/"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.charCodeAt(0)===d;let t;r?(o.root="/",t=1):t=0;let n=-1,l=0,w=-1,D=!0,I=i.length-1,k=0;for(;I>=t;--I){const R=i.charCodeAt(I);if(R===d){if(!D){l=I+1;break}continue}w===-1&&(D=!1,w=I+1),R===P?n===-1?n=I:k!==1&&(k=1):n!==-1&&(k=-1)}if(w!==-1){const R=l===0&&r?1:l;n===-1||k===0||k===1&&n===w-1&&n===l+1?o.base=o.name=i.slice(R,w):(o.name=i.slice(R,n),o.base=i.slice(R,w),o.ext=i.slice(n,w))}return l>0?o.dir=i.slice(0,l-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=m?e.$ec.normalize:e.$fc.normalize,e.$hc=m?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=m?e.$ec.join:e.$fc.join,e.$jc=m?e.$ec.resolve:e.$fc.resolve,e.$kc=m?e.$ec.relative:e.$fc.relative,e.$lc=m?e.$ec.dirname:e.$fc.dirname,e.$mc=m?e.$ec.basename:e.$fc.basename,e.$nc=m?e.$ec.extname:e.$fc.extname,e.$oc=m?e.$ec.format:e.$fc.format,e.$pc=m?e.$ec.parse:e.$fc.parse,e.$qc=m?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=m?e.$ec.sep:e.$fc.sep,e.$sc=m?e.$ec.delimiter:e.$fc.delimiter}),define(re[33],oe([0,1,9,4,27,12]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function C(l){return l===47||l===92}e.$Uf=C;function P(l){return l.replace(/[\\/]/g,S.$fc.sep)}e.$Vf=P;function d(l){return l.indexOf("/")===-1&&(l=P(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Wf=d;function c(l,w=S.$fc.sep){if(!l)return"";const D=l.length,I=l.charCodeAt(0);if(C(I)){if(C(l.charCodeAt(1))&&!C(l.charCodeAt(2))){let R=3;const L=R;for(;R<D&&!C(l.charCodeAt(R));R++);if(L!==R&&!C(l.charCodeAt(R+1))){for(R+=1;R<D;R++)if(C(l.charCodeAt(R)))return l.slice(0,R+1).replace(/[\\/]/g,w)}}return w}else if(g(I)&&l.charCodeAt(1)===58)return C(l.charCodeAt(2))?l.slice(0,2)+w:l.slice(0,2);let k=l.indexOf("://");if(k!==-1){for(k+=3;k<D;k++)if(C(l.charCodeAt(k)))return l.slice(0,k+1)}return""}e.$Xf=c;function $(l){if(!A.$i||!l||l.length<5)return!1;let w=l.charCodeAt(0);if(w!==92||(w=l.charCodeAt(1),w!==92))return!1;let D=2;const I=D;for(;D<l.length&&(w=l.charCodeAt(D),w!==92);D++);return!(I===D||(w=l.charCodeAt(D+1),isNaN(w)||w===92))}e.$Yf=$;const p=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(l,w=A.$i){const D=w?p:v;return!(!l||l.length===0||/^\s+$/.test(l)||(D.lastIndex=0,D.test(l))||w&&f.test(l)||l==="."||l===".."||w&&l[l.length-1]==="."||w&&l.length!==l.trim().length||l.length>255)}e.$Zf=y;function m(l,w,D){const I=l===w;return!D||I?I:!l||!w?!1:(0,s.$6e)(l,w)}e.$1f=m;function b(l,w,D,I=S.sep){if(l===w)return!0;if(!l||!w||w.length>l.length)return!1;if(D){if(!(0,s.$7e)(l,w))return!1;if(w.length===l.length)return!0;let R=w.length;return w.charAt(w.length-1)===I&&R--,l.charAt(R)===I}return w.charAt(w.length-1)!==I&&(w+=I),l.indexOf(w)===0}e.$2f=b;function g(l){return l>=65&&l<=90||l>=97&&l<=122}e.$3f=g;function u(l,w){return A.$i&&l.endsWith(":")&&(l+=S.sep),(0,S.$hc)(l)||(l=(0,S.$ic)(w,l)),l=(0,S.$gc)(l),A.$i?(l=(0,s.$Oe)(l,S.sep),l.endsWith(":")&&(l+=S.sep)):(l=(0,s.$Oe)(l,S.sep),l||(l=S.sep)),l}e.$4f=u;function a(l){const w=(0,S.$gc)(l);return A.$i?l.length>3?!1:E(w)&&(l.length===2||w.charCodeAt(2)===92):w===S.$fc.sep}e.$5f=a;function E(l,w=A.$i){return w?g(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$6f=E;function h(l,w=A.$i){return E(l,w)?l[0]:void 0}e.$7f=h;function i(l,w,D){return w.length>l.length?-1:l===w?0:(D&&(l=l.toLowerCase(),w=w.toLowerCase()),l.indexOf(w))}e.$8f=i;function o(l){const w=l.split(":");let D,I,k;for(const R of w){const L=Number(R);(0,M.$Gf)(L)?I===void 0?I=L:k===void 0&&(k=L):D=D?[D,R].join(":"):R}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:k!==void 0?k:I!==void 0?1:void 0}}e.$9f=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(l,w,D=8){let I="";for(let R=0;R<D;R++){let L;R===0&&A.$i&&!w&&(D===3||D===4)?L=t:L=r,I+=L.charAt(Math.floor(Math.random()*L.length))}let k;return w?k=`${w}-${I}`:k=I,l?(0,S.$ic)(l,k):k}e.$0f=n}),define(re[76],oe([0,1,4]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(P,...d){const c=d.reduce((v,f)=>(v[f]=!0,v),{}),$=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!c[v]).forEach(v=>{for(let f=0;f<$.length;f++)if(v.search($[f])!==-1){delete P[v];break}})}e.$Fl=M;function C(P){P&&(delete P.DEBUG,S.$j&&delete P.DYLD_LIBRARY_PATH,S.$k&&delete P.LD_PRELOAD)}e.$Gl=C}),define(re[7],oe([0,1,9,4]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,C=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!M.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(t,n){return!t&&!n?"file":t}function c(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==p&&(n=p+n):n=p;break}return n}const $="",p="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,l,w,D,I,k=!1){typeof n=="object"?(this.scheme=n.scheme||$,this.authority=n.authority||$,this.path=n.path||$,this.query=n.query||$,this.fragment=n.fragment||$):(this.scheme=d(n,k),this.authority=l||$,this.path=c(this.scheme,w||$),this.query=D||$,this.fragment=I||$,P(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:w,path:D,query:I,fragment:k}=n;return l===void 0?l=this.scheme:l===null&&(l=$),w===void 0?w=this.authority:w===null&&(w=$),D===void 0?D=this.path:D===null&&(D=$),I===void 0?I=this.query:I===null&&(I=$),k===void 0?k=this.fragment:k===null&&(k=$),l===this.scheme&&w===this.authority&&D===this.path&&I===this.query&&k===this.fragment?this:new b(l,w,D,I,k)}static parse(n,l=!1){const w=v.exec(n);return w?new b(w[2]||$,r(w[4]||$),r(w[5]||$),r(w[7]||$),r(w[9]||$),l):new b($,$,$,$,$)}static file(n){let l=$;if(A.$i&&(n=n.replace(/\\/g,p)),n[0]===p&&n[1]===p){const w=n.indexOf(p,2);w===-1?(l=n.substring(2),n=p):(l=n.substring(2,w),n=n.substring(w)||p)}return new b("file",l,n,$,$)}static from(n,l){return new b(n.scheme,n.authority,n.path,n.query,n.fragment,l)}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return A.$i&&n.scheme==="file"?w=f.file(S.$ec.join(E(n,!0),...l)).path:w=S.$fc.join(n.path,...l),n.with({path:w})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const l=new b(n);return l._formatted=n.external??null,l._fsPath=n._sep===m?n.fsPath??null:null,l}}else return n}}e.URI=f;function y(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$uc=y;const m=A.$i?1:void 0;class b extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,n,l){let w,D=-1;for(let I=0;I<t.length;I++){const k=t.charCodeAt(I);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||l&&k===91||l&&k===93||l&&k===58)D!==-1&&(w+=encodeURIComponent(t.substring(D,I)),D=-1),w!==void 0&&(w+=t.charAt(I));else{w===void 0&&(w=t.substr(0,I));const R=g[k];R!==void 0?(D!==-1&&(w+=encodeURIComponent(t.substring(D,I)),D=-1),w+=R):D===-1&&(D=I)}}return D!==-1&&(w+=encodeURIComponent(t.substring(D))),w!==void 0?w:t}function a(t){let n;for(let l=0;l<t.length;l++){const w=t.charCodeAt(l);w===35||w===63?(n===void 0&&(n=t.substr(0,l)),n+=g[w]):n!==void 0&&(n+=t[l])}return n!==void 0?n:t}function E(t,n){let l;return t.authority&&t.path.length>1&&t.scheme==="file"?l=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?l=t.path.substr(1):l=t.path[1].toLowerCase()+t.path.substr(2):l=t.path,A.$i&&(l=l.replace(/\//g,"\\")),l}e.$vc=E;function h(t,n){const l=n?a:u;let w="",{scheme:D,authority:I,path:k,query:R,fragment:L}=t;if(D&&(w+=D,w+=":"),(I||D==="file")&&(w+=p,w+=p),I){let T=I.indexOf("@");if(T!==-1){const N=I.substr(0,T);I=I.substr(T+1),T=N.lastIndexOf(":"),T===-1?w+=l(N,!1,!1):(w+=l(N.substr(0,T),!1,!1),w+=":",w+=l(N.substr(T+1),!1,!0)),w+="@"}I=I.toLowerCase(),T=I.lastIndexOf(":"),T===-1?w+=l(I,!1,!0):(w+=l(I.substr(0,T),!1,!0),w+=I.substr(T))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const T=k.charCodeAt(1);T>=65&&T<=90&&(k=`/${String.fromCharCode(T+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const T=k.charCodeAt(0);T>=65&&T<=90&&(k=`${String.fromCharCode(T+32)}:${k.substr(2)}`)}w+=l(k,!0,!1)}return R&&(w+="?",w+=l(R,!1,!1)),L&&(w+="#",w+=n?L:u(L,!1,!1)),w}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(o)?t.replace(o,n=>i(n)):t}}),define(re[154],oe([0,1,7]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$6p=e.$5p=e.$4p=void 0;function A(c){const $=c;return $&&typeof $.type=="string"&&typeof $.severity=="string"}e.$4p=A;function s(c){const $=[];let p;try{const v=JSON.parse(c.arguments),f=v[v.length-1];f&&f.__$stack&&(v.pop(),p=f.__$stack),$.push(...v)}catch{$.push("Unable to log remote console arguments",c.arguments)}return{args:$,stack:p}}e.$5p=s;function M(c){if(typeof c!="string")return M(s(c).stack);const $=c;if($){const p=C($),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(v&&v.length===4)return{uri:S.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$6p=M;function C(c){if(!c)return c;const $=c.indexOf(`
`);return $===-1?c:c.substring(0,$)}function P(c,$){const{args:p,stack:v}=s(c),f=typeof p[0]=="string"&&p.length===1;let y=C(v);y&&(y=`(${y.trim()})`);let m=[];if(typeof p[0]=="string"?y&&f?m=[`%c[${$}] %c${p[0]} %c${y}`,d("blue"),d(""),d("grey")]:m=[`%c[${$}] %c${p[0]}`,d("blue"),d(""),...p.slice(1)]:m=[`%c[${$}]%`,d("blue"),...p],y&&!f&&m.push(y),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,m)}e.log=P;function d(c){return`color: ${c}`}}),define(re[77],oe([0,1,18,7]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function s(d){return JSON.stringify(d,C)}e.$qh=s;function M(d){let c=JSON.parse(d);return c=P(c),c}e.$rh=M;function C(d,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function P(d,c=0){if(!d||c>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return A.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof S.$fe||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let $=0;$<d.length;++$)d[$]=P(d[$],c+1);else for(const $ in d)Object.hasOwnProperty.call(d,$)&&(d[$]=P(d[$],c+1))}return d}e.$sh=P}),define(re[13],oe([0,1,14,4,7]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var M;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$$f="vscode-tkn",e.$_f="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${M.vscodeRemoteResource}`}set($,p,v){this.a[$]=p,this.b[$]=v}setConnectionToken($,p){this.c[$]=p}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(b){return S.$Z(b),$}const p=$.authority;let v=this.a[p];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const f=this.b[p],y=this.c[p];let m=`path=${encodeURIComponent($.path)}`;return typeof y=="string"&&(m+=`&${e.$_f}=${encodeURIComponent(y)}`),s.URI.from({scheme:A.$o?this.d:M.vscodeRemoteResource,authority:`${v}:${f}`,path:this.f,query:m})}}e.$ag=new C,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class P{static{this.a=e.$fg}asBrowserUri($){const p=this.b($,Z);return this.uriToBrowserUri(p)}uriToBrowserUri($){return $.scheme===M.vscodeRemote?e.$ag.rewrite($):$.scheme===M.file&&(A.$m||A.$q===`${M.vscodeFileResource}://${P.a}`)?$.with({scheme:M.vscodeFileResource,authority:$.authority||P.a,query:null,fragment:null}):$}asFileUri($){const p=this.b($,Z);return this.uriToFileUri(p)}uriToFileUri($){return $.scheme===M.vscodeFileResource?$.with({scheme:M.file,authority:$.authority!==P.a?$.authority:null,query:null,fragment:null}):$}b($,p){return s.URI.isUri($)?$:s.URI.parse(p.toUrl($))}}e.$gg=new P;var d;(function(c){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze($.get("3"));const p="vscode-coi";function v(y){let m;typeof y=="string"?m=new URL(y).searchParams:y instanceof URL?m=y.searchParams:s.URI.isUri(y)&&(m=new URL(y.toString(!0)).searchParams);const b=m?.get(p);if(b)return $.get(b)}c.getHeadersFromQuery=v;function f(y,m,b){if(!globalThis.crossOriginIsolated)return;const g=m&&b?"3":b?"2":"1";y instanceof URLSearchParams?y.set(p,g):y[p]=g}c.addSearchParam=f})(d||(e.COI=d={}))}),define(re[19],oe([0,1,33,13,9,4,27,7]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function d(f){return(0,P.$vc)(f,!0)}e.$ng=d;class c{constructor(y){this.a=y}compare(y,m,b=!1){return y===m?0:(0,C.$Ye)(this.getComparisonKey(y,b),this.getComparisonKey(m,b))}isEqual(y,m,b=!1){return y===m?!0:!y||!m?!1:this.getComparisonKey(y,b)===this.getComparisonKey(m,b)}getComparisonKey(y,m=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,m,b=!1){if(y.scheme===m.scheme){if(y.scheme===A.Schemas.file)return S.$2f(d(y),d(m),this.a(y))&&y.query===m.query&&(b||y.fragment===m.fragment);if((0,e.$Eg)(y.authority,m.authority))return S.$2f(y.path,m.path,this.a(y),"/")&&y.query===m.query&&(b||y.fragment===m.fragment)}return!1}joinPath(y,...m){return P.URI.joinPath(y,...m)}basenameOrAuthority(y){return(0,e.$wg)(y)||y.authority}basename(y){return s.$fc.basename(y.path)}extname(y){return s.$fc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let m;return y.scheme===A.Schemas.file?m=P.URI.file(s.$lc(d(y))).path:(m=s.$fc.dirname(y.path),y.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),m="/")),y.with({path:m})}normalizePath(y){if(!y.path.length)return y;let m;return y.scheme===A.Schemas.file?m=P.URI.file(s.$gc(d(y))).path:m=s.$fc.normalize(y.path),y.with({path:m})}relativePath(y,m){if(y.scheme!==m.scheme||!(0,e.$Eg)(y.authority,m.authority))return;if(y.scheme===A.Schemas.file){const u=s.$kc(d(y),d(m));return M.$i?S.$Vf(u):u}let b=y.path||"/";const g=m.path||"/";if(this.a(y)){let u=0;for(const a=Math.min(b.length,g.length);u<a&&!(b.charCodeAt(u)!==g.charCodeAt(u)&&b.charAt(u).toLowerCase()!==g.charAt(u).toLowerCase());u++);b=g.substr(0,u)+b.substr(u)}return s.$fc.relative(b,g)}resolvePath(y,m){if(y.scheme===A.Schemas.file){const b=P.URI.file(s.$jc(d(y),m));return y.with({authority:b.authority,path:b.path})}return m=S.$Wf(m),y.with({path:s.$fc.resolve(y.path,m)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,m){return y===m||y!==void 0&&m!==void 0&&(0,C.$6e)(y,m)}hasTrailingPathSeparator(y,m=s.sep){if(y.scheme===A.Schemas.file){const b=d(y);return b.length>S.$Xf(b).length&&b[b.length-1]===m}else{const b=y.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,m=s.sep){return(0,e.$Fg)(y,m)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,m=s.sep){let b=!1;if(y.scheme===A.Schemas.file){const g=d(y);b=g!==void 0&&g.length===S.$Xf(g).length&&g[g.length-1]===m}else{m="/";const g=y.path;b=g.length===1&&g.charCodeAt(g.length-1)===47}return!b&&!(0,e.$Fg)(y,m)?y.with({path:y.path+"/"}):y}}e.$og=c,e.$pg=new c(()=>!1),e.$qg=new c(f=>f.scheme===A.Schemas.file?!M.$k:!0),e.$rg=new c(f=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function $(f,y){const m=[];for(let b=0;b<f.length;b++){const g=y(f[b]);f.some((u,a)=>a===b?!1:(0,e.$tg)(g,y(u)))||m.push(f[b])}return m}e.$Ig=$;var p;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function y(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(a=>{const[E,h]=a.split(":");E&&h&&b.set(E,h)});const u=m.path.substring(0,m.path.indexOf(";"));return u&&b.set(f.META_DATA_MIME,u),b}f.parseMetaData=y})(p||(e.DataUri=p={}));function v(f,y,m){if(y){let b=f.path;return b&&b[0]!==s.$fc.sep&&(b=s.$fc.sep+b),f.with({scheme:m,authority:y,path:b})}return f.with({scheme:m})}e.$Jg=v}),define(re[8],oe([0,1,22,14,3,2,19,4,143]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function c(G){return!!G&&typeof G.then=="function"}e.$Kg=c;function $(G){const F=new S.$2d,z=G(F.token),W=new Promise((x,he)=>{const de=F.token.onCancellationRequested(()=>{de.dispose(),F.dispose(),he(new A.$4)});Promise.resolve(z).then(le=>{de.dispose(),F.dispose(),x(le)},le=>{de.dispose(),F.dispose(),he(le)})});return new class{cancel(){F.cancel()}then(x,he){return W.then(x,he)}catch(x){return this.then(void 0,x)}finally(x){return W.finally(x)}}}e.$Lg=$;function p(G,F,z){return new Promise((W,x)=>{const he=F.onCancellationRequested(()=>{he.dispose(),W(z)});G.then(W,x).finally(()=>he.dispose())})}e.$Mg=p;function v(G,F){return new Promise((z,W)=>{const x=F.onCancellationRequested(()=>{x.dispose(),W(new A.$4)});G.then(z,W).finally(()=>x.dispose())})}e.$Ng=v;async function f(G){let F=-1;const z=G.map((W,x)=>W.then(he=>(F=x,he)));try{return await Promise.race(z)}finally{G.forEach((W,x)=>{x!==F&&W.cancel()})}}e.$Og=f;function y(G,F,z){let W;const x=setTimeout(()=>{W?.(void 0),z?.()},F);return Promise.race([G.finally(()=>clearTimeout(x)),new Promise(he=>W=he)])}e.$Pg=y;function m(G){return new Promise((F,z)=>{const W=G();c(W)?W.then(F,z):F(W)})}e.$Qg=m;class b{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(F){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=F,!this.b){const z=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(z,z).then(W)})}return new Promise((z,W)=>{this.b.then(z,W)})}return this.a=F(),new Promise((z,W)=>{this.a.then(x=>{this.a=null,z(x)},x=>{this.a=null,W(x)})})}dispose(){this.f=!0}}e.$Rg=b;class g{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.$Sg=g;class u{constructor(){this.a=new Map}queue(F,z){const x=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.a.get(F)===x&&this.a.delete(F)});return this.a.set(F,x),x}}e.$Tg=u;const a=(G,F)=>{let z=!0;const W=setTimeout(()=>{z=!1,F()},G);return{isTriggered:()=>z,dispose:()=>{clearTimeout(W),z=!1}}},E=G=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,G())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class h{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,z=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise((x,he)=>{this.d=x,this.f=he}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=z===d.$Od?E(W):a(z,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=h;class i{constructor(F){this.a=new h(F),this.b=new b}trigger(F,z){return this.a.trigger(()=>this.b.queue(F),z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=i;class o{constructor(){this.a=!1,this.b=new Promise((F,z)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=o;class r extends o{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.$Xg=r;function t(G,F){return F?new Promise((z,W)=>{const x=setTimeout(()=>{he.dispose(),z()},G),he=F.onCancellationRequested(()=>{clearTimeout(x),he.dispose(),W(new A.$4)})}):$(z=>t(G,z))}e.$Yg=t;function n(G,F=0,z){const W=setTimeout(()=>{G(),z&&x.dispose()},F),x=(0,M.$Pc)(()=>{clearTimeout(W),z?.deleteAndLeak(x)});return z?.add(x),x}e.$Zg=n;function l(G){const F=[];let z=0;const W=G.length;function x(){return z<W?G[z++]():null}function he(de){de!=null&&F.push(de);const le=x();return le?le.then(he):Promise.resolve(F)}return Promise.resolve(null).then(he)}e.$1g=l;function w(G,F=W=>!!W,z=null){let W=0;const x=G.length,he=()=>{if(W>=x)return Promise.resolve(z);const de=G[W++];return Promise.resolve(de()).then(we=>F(we)?Promise.resolve(we):he())};return he()}e.$2g=w;function D(G,F=W=>!!W,z=null){if(G.length===0)return Promise.resolve(z);let W=G.length;const x=()=>{W=-1;for(const he of G)he.cancel?.()};return new Promise((he,de)=>{for(const le of G)le.then(we=>{--W>=0&&F(we)?(x(),he(we)):W===0&&he(z)}).catch(we=>{--W>=0&&(x(),de(we))})})}e.$3g=D;class I{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new s.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((z,W)=>{this.f.push({factory:F,c:z,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const z=F.factory();z.then(F.c,F.e),z.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=I;class k extends I{constructor(){super(1)}}e.$5g=k;class R{constructor(){this.a=new V,this.b=0}queue(F){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,F())):this.a.run(this.b++,F())}}e.$6g=R;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const F=new H;return this.b.add(F),F.p}g(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,z=C.$pg){const W=z.getComparisonKey(F);let x=this.a.get(W);if(!x){x=new k;const he=this.f++,de=s.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(he,de),this.a.set(W,x)}return x}h(){this.g()&&this.j()}j(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=L;class T{constructor(F,z){this.a=-1,typeof F=="function"&&typeof z=="number"&&this.setIfNotSet(F,z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},z)}setIfNotSet(F,z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},z))}}e.$8g=T;class N{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(F,z,W=globalThis){this.cancel();const x=W.setInterval(()=>{F()},z);this.d=(0,M.$Pc)(()=>{W.clearInterval(x),this.d=void 0})}dispose(){this.cancel()}}e.$9g=N;class K{constructor(F,z){this.b=-1,this.a=F,this.d=z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=K;class Q{constructor(F,z){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.a=F,this.b=z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=Q;class ae extends K{constructor(F,z){super(F,z),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.$_g=ae;class ne extends M.$Rc{constructor(F,z){super(),this.g=F,this.h=z,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const z of F)this.a.push(z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(G,F)=>{(0,P.$B)(()=>{if(z)return;const W=Date.now()+15;F(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0)}}}:e.$ch=(G,F,z)=>{const W=G.requestIdleCallback(F,typeof z=="number"?{timeout:z}:void 0);let x=!1;return{dispose(){x||(x=!0,G.cancelIdleCallback(W))}}},e.$bh=G=>(0,e.$ch)(globalThis,G)}();class ce{constructor(F,z){this.g=!1,this.d=()=>{try{this.j=z()}catch(W){this.l=W}finally{this.g=!0}},this.f=(0,e.$ch)(F,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=ce;class X extends ce{constructor(F){super(globalThis,F)}}e.$eh=X;async function Y(G,F,z){let W;for(let x=0;x<z;x++)try{return await G()}catch(he){W=he,await t(F)}throw W}e.$fh=Y;class V{isRunning(F){return typeof F=="number"?this.a?.taskId===F:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(F,z,W){return this.a={taskId:F,cancel:()=>W?.(),promise:z},z.then(()=>this.d(F),()=>this.d(F)),z}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}queue(F){if(this.b)this.b.run=F;else{let z,W;const x=new Promise((he,de)=>{z=he,W=de});this.b={run:F,promise:x,promiseResolve:z,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=V;class q{constructor(F,z=()=>Date.now()){this.d=F,this.f=z,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.$hh=q;var j;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(j||(j={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((F,z)=>{this.a=F,this.b=z})}complete(F){return new Promise(z=>{this.a(F),this.d={outcome:0,value:F},z()})}error(F){return new Promise(z=>{this.b(F),this.d={outcome:1,value:F},z()})}cancel(){return this.error(new A.$4)}}e.$ih=H;var B;(function(G){async function F(W){let x;const he=await Promise.all(W.map(de=>de.then(le=>le,le=>{x||(x=le)})));if(typeof x<"u")throw x;return he}G.settled=F;function z(W){return new Promise(async(x,he)=>{try{await W(x,he)}catch(de){he(de)}})}G.withAsyncBody=z})(B||(e.Promises=B={}));var _;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(_||(_={}));class se{static fromArray(F){return new se(z=>{z.emitMany(F)})}static fromPromise(F){return new se(async z=>{z.emitMany(await F)})}static fromPromises(F){return new se(async z=>{await Promise.all(F.map(async W=>z.emitOne(await W)))})}static merge(F){return new se(async z=>{await Promise.all(F.map(async W=>{for await(const x of W)z.emitOne(x)}))})}static{this.EMPTY=se.fromArray([])}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new s.$Rd,queueMicrotask(async()=>{const z={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(F(z)),this.j()}catch(W){this.k(W)}finally{z.emitOne=void 0,z.emitMany=void 0,z.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(F,z){return new se(async W=>{for await(const x of F)W.emitOne(z(x))})}map(F){return se.map(this,F)}static filter(F,z){return new se(async W=>{for await(const x of F)z(x)&&W.emitOne(x)})}filter(F){return se.filter(this,F)}static coalesce(F){return se.filter(F,z=>!!z)}coalesce(){return se.coalesce(this)}static async toPromise(F){const z=[];for await(const W of F)z.push(W);return z}toPromise(){return se.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}e.$jh=se;class J extends se{constructor(F,z){super(z),this.l=F}cancel(){this.l.cancel()}}e.$kh=J;function O(G){const F=new S.$2d,z=G(F.token);return new J(F,async W=>{const x=F.token.onCancellationRequested(()=>{x.dispose(),F.dispose(),W.reject(new A.$4)});try{for await(const he of z){if(F.token.isCancellationRequested)return;W.emitOne(he)}x.dispose(),F.dispose()}catch(he){x.dispose(),F.dispose(),W.reject(he)}})}e.$lh=O;class U{constructor(){this.a=new H,this.b=new se(W=>{if(F){W.reject(F);return}return z&&W.emitMany(z),this.d=x=>W.reject(x),this.f=x=>W.emitOne(x),this.a.p});let F,z;this.f=W=>{z||(z=[]),z.push(W)},this.d=W=>{F||(F=W)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(F){this.d(F),this.a.complete()}emitOne(F){this.f(F)}}e.$mh=U}),define(re[104],oe([0,1,23,8,33,31,9,4,27]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function c(){return Object.create(null)}e.$xj=c,e.$yj="**",e.$zj="/";const $="[/\\\\]",p="[^/\\\\]",v=/\//g;function f(Y,V){switch(Y){case 0:return"";case 1:return`${p}*?`;default:return`(?:${$}|${p}+${$}${V?`|${$}${p}+`:""})*?`}}function y(Y,V){if(!Y)return[];const q=[];let j=!1,H=!1,B="";for(const _ of Y){switch(_){case V:if(!j&&!H){q.push(B),B="";continue}break;case"{":j=!0;break;case"}":j=!1;break;case"[":H=!0;break;case"]":H=!1;break}B+=_}return B&&q.push(B),q}e.$Aj=y;function m(Y){if(!Y)return"";let V="";const q=y(Y,e.$zj);if(q.every(j=>j===e.$yj))V=".*";else{let j=!1;q.forEach((H,B)=>{if(H===e.$yj){if(j)return;V+=f(2,B===q.length-1)}else{let _=!1,se="",J=!1,O="";for(const U of H){if(U!=="}"&&_){se+=U;continue}if(J&&(U!=="]"||!O)){let G;U==="-"?G=U:(U==="^"||U==="!")&&!O?G="^":U===e.$zj?G="":G=(0,d.$Je)(U),O+=G;continue}switch(U){case"{":_=!0;continue;case"[":J=!0;continue;case"}":{const F=`(?:${y(se,",").map(z=>m(z)).join("|")})`;V+=F,_=!1,se="";break}case"]":{V+="["+O+"]",J=!1,O="";break}case"?":V+=p;continue;case"*":V+=f(1);continue;default:V+=(0,d.$Je)(U)}}B<q.length-1&&(q[B+1]!==e.$yj||B+2<q.length)&&(V+=$)}j=H===e.$yj})}return V}const b=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Cc(1e4),o=function(){return!1},r=function(){return null};function t(Y,V){if(!Y)return r;let q;typeof Y!="string"?q=Y.pattern:q=Y,q=q.trim();const j=`${q}_${!!V.trimForExclusions}`;let H=i.get(j);if(H)return n(H,Y);let B;return b.test(q)?H=w(q.substr(4),q):(B=g.exec(l(q,V)))?H=D(B[1],q):(V.trimForExclusions?a:u).test(q)?H=I(q,V):(B=E.exec(l(q,V)))?H=k(B[1].substr(1),q,!0):(B=h.exec(l(q,V)))?H=k(B[1],q,!1):H=R(q),i.set(j,H),n(H,Y)}function n(Y,V){if(typeof V=="string")return Y;const q=function(j,H){return(0,s.$2f)(j,V.base,!P.$k)?Y((0,d.$Ne)(j.substr(V.base.length),C.sep),H):null};return q.allBasenames=Y.allBasenames,q.allPaths=Y.allPaths,q.basenames=Y.basenames,q.patterns=Y.patterns,q}function l(Y,V){return V.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function w(Y,V){return function(q,j){return typeof q=="string"&&q.endsWith(Y)?V:null}}function D(Y,V){const q=`/${Y}`,j=`\\${Y}`,H=function(_,se){return typeof _!="string"?null:se?se===Y?V:null:_===Y||_.endsWith(q)||_.endsWith(j)?V:null},B=[Y];return H.basenames=B,H.patterns=[V],H.allBasenames=B,H}function I(Y,V){const q=ce(Y.slice(1,-1).split(",").map(se=>t(se,V)).filter(se=>se!==r),Y),j=q.length;if(!j)return r;if(j===1)return q[0];const H=function(se,J){for(let O=0,U=q.length;O<U;O++)if(q[O](se,J))return Y;return null},B=q.find(se=>!!se.allBasenames);B&&(H.allBasenames=B.allBasenames);const _=q.reduce((se,J)=>J.allPaths?se.concat(J.allPaths):se,[]);return _.length&&(H.allPaths=_),H}function k(Y,V,q){const j=C.sep===C.$fc.sep,H=j?Y:Y.replace(v,C.sep),B=C.sep+H,_=C.$fc.sep+Y;let se;return q?se=function(J,O){return typeof J=="string"&&(J===H||J.endsWith(B)||!j&&(J===Y||J.endsWith(_)))?V:null}:se=function(J,O){return typeof J=="string"&&(J===H||!j&&J===Y)?V:null},se.allPaths=[(q?"*/":"./")+Y],se}function R(Y){try{const V=new RegExp(`^${m(Y)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?Y:null}}catch{return r}}function L(Y,V,q){return!Y||typeof V!="string"?!1:T(Y)(V,void 0,q)}e.$Bj=L;function T(Y,V={}){if(!Y)return o;if(typeof Y=="string"||N(Y)){const q=t(Y,V);if(q===r)return o;const j=function(H,B){return!!q(H,B)};return q.allBasenames&&(j.allBasenames=q.allBasenames),q.allPaths&&(j.allPaths=q.allPaths),j}return ae(Y,V)}e.$Cj=T;function N(Y){const V=Y;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$Dj=N;function K(Y){return Y.allBasenames||[]}e.$Ej=K;function Q(Y){return Y.allPaths||[]}e.$Fj=Q;function ae(Y,V){const q=ce(Object.getOwnPropertyNames(Y).map(se=>ne(se,Y[se],V)).filter(se=>se!==r)),j=q.length;if(!j)return r;if(!q.some(se=>!!se.requiresSiblings)){if(j===1)return q[0];const se=function(U,G){let F;for(let z=0,W=q.length;z<W;z++){const x=q[z](U,G);if(typeof x=="string")return x;(0,A.$Kg)(x)&&(F||(F=[]),F.push(x))}return F?(async()=>{for(const z of F){const W=await z;if(typeof W=="string")return W}return null})():null},J=q.find(U=>!!U.allBasenames);J&&(se.allBasenames=J.allBasenames);const O=q.reduce((U,G)=>G.allPaths?U.concat(G.allPaths):U,[]);return O.length&&(se.allPaths=O),se}const H=function(se,J,O){let U,G;for(let F=0,z=q.length;F<z;F++){const W=q[F];W.requiresSiblings&&O&&(J||(J=(0,C.$mc)(se)),U||(U=J.substr(0,J.length-(0,C.$nc)(se).length)));const x=W(se,J,U,O);if(typeof x=="string")return x;(0,A.$Kg)(x)&&(G||(G=[]),G.push(x))}return G?(async()=>{for(const F of G){const z=await F;if(typeof z=="string")return z}return null})():null},B=q.find(se=>!!se.allBasenames);B&&(H.allBasenames=B.allBasenames);const _=q.reduce((se,J)=>J.allPaths?se.concat(J.allPaths):se,[]);return _.length&&(H.allPaths=_),H}function ne(Y,V,q){if(V===!1)return r;const j=t(Y,q);if(j===r)return r;if(typeof V=="boolean")return j;if(V){const H=V.when;if(typeof H=="string"){const B=(_,se,J,O)=>{if(!O||!j(_,se))return null;const U=H.replace("$(basename)",()=>J),G=O(U);return(0,A.$Kg)(G)?G.then(F=>F?Y:null):G?Y:null};return B.requiresSiblings=!0,B}}return j}function ce(Y,V){const q=Y.filter(se=>!!se.basenames);if(q.length<2)return Y;const j=q.reduce((se,J)=>{const O=J.basenames;return O?se.concat(O):se},[]);let H;if(V){H=[];for(let se=0,J=j.length;se<J;se++)H.push(V)}else H=q.reduce((se,J)=>{const O=J.patterns;return O?se.concat(O):se},[]);const B=function(se,J){if(typeof se!="string")return null;if(!J){let U;for(U=se.length;U>0;U--){const G=se.charCodeAt(U-1);if(G===47||G===92)break}J=se.substr(U)}const O=j.indexOf(J);return O!==-1?H[O]:null};B.basenames=j,B.patterns=H,B.allBasenames=j;const _=Y.filter(se=>!se.basenames);return _.push(B),_}function X(Y,V){return(0,S.$tb)(Y,V,(q,j)=>typeof q=="string"&&typeof j=="string"?q===j:typeof q!="string"&&typeof j!="string"?q.base===j.base&&q.pattern===j.pattern:!1)}e.$Gj=X}),define(re[47],oe([0,1,23,33,9,4,19,27]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=void 0;function d(t,n){const{os:l,tildify:w,relative:D}=n;if(D){const R=c(t,D,l);if(typeof R=="string")return R}let I=t.fsPath;if(l===1&&!M.$i?I=I.replace(/\//g,"\\"):l!==1&&M.$i&&(I=I.replace(/\\/g,"/")),l!==1&&w?.userHome){const R=w.userHome.fsPath;let L;t.scheme!==w.userHome.scheme&&t.path[0]===s.$fc.sep&&t.path[1]!==s.$fc.sep?L=w.userHome.with({path:t.path}).fsPath:L=I,I=v(L,R,l)}return(l===1?s.$ec:s.$fc).normalize($(I,l===1))}e.$yv=d;function c(t,n,l){const w=l===1?s.$ec:s.$fc,D=l===3?C.$pg:C.$rg,I=n.getWorkspace(),k=(0,S.$Nb)(I.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path[0]===s.$fc.sep&&t.path[1]!==s.$fc.sep&&(t=k.uri.with({path:t.path}));const R=n.getWorkspaceFolder(t);if(!R)return;let L;if(D.isEqual(R.uri,t)?L="":L=D.relativePath(R.uri,t)??"",L&&(L=w.normalize(L)),I.folders.length>1&&!n.noPrefix){const T=R.name?R.name:D.basenameOrAuthority(R.uri);L=L?`${T} \u2022 ${L}`:T}return L}function $(t,n=M.$i){return(0,A.$6f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$zv=$;let p=Object.create(null);function v(t,n,l=M.OS){if(l===1||!t||!n)return t;let w=p.original===n?p.normalized:void 0;w||(w=n,M.$i&&(w=(0,A.$Vf)(w)),w=`${(0,P.$Oe)(w,s.$fc.sep)}${s.$fc.sep}`,p={original:n,normalized:w});let D=t;return M.$i&&(D=(0,A.$Vf)(D)),(l===3?D.startsWith(w):(0,P.$7e)(D,w))?`~/${D.substr(w.length)}`:t}e.$Av=v;function f(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Bv=f;const y="\u2026",m="\\\\",b="~";function g(t,n=s.sep){const l=new Array(t.length);let w=!1;for(let D=0;D<t.length;D++){const I=t[D];if(I===""){l[D]=`.${n}`;continue}if(!I){l[D]=I;continue}w=!0;let k="",R=I;R.indexOf(m)===0?(k=R.substr(0,R.indexOf(m)+m.length),R=R.substr(R.indexOf(m)+m.length)):R.indexOf(n)===0?(k=R.substr(0,R.indexOf(n)+n.length),R=R.substr(R.indexOf(n)+n.length)):R.indexOf(b)===0&&(k=R.substr(0,R.indexOf(b)+b.length),R=R.substr(R.indexOf(b)+b.length));const L=R.split(n);for(let T=1;w&&T<=L.length;T++)for(let N=L.length-T;w&&N>=0;N--){w=!1;let K=L.slice(N,N+T).join(n);for(let Q=0;!w&&Q<t.length;Q++)if(Q!==D&&t[Q]&&t[Q].indexOf(K)>-1){const ae=N+T===L.length,ne=N>0&&t[Q].indexOf(n)>-1?n+K:K,ce=t[Q].endsWith(ne);w=!ae||ce}if(!w){let Q="";(L[0].endsWith(":")||k!=="")&&(N===1&&(N=0,T++,K=L[0]+n+K),N>0&&(Q=L[0]+n),Q=k+Q),N>0&&(Q=Q+y+n),Q=Q+K,N+T<L.length&&(Q=Q+n+y),l[D]=Q}}w&&(l[D]=I)}return l}e.$Cv=g;var u;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function a(t,n=Object.create(null)){const l=[];let w=!1,D="";for(const I of t)if(I==="$"||w&&I==="{")D&&l.push({value:D,type:u.TEXT}),D="",w=!0;else if(I==="}"&&w){const k=n[D];if(typeof k=="string")k.length&&l.push({value:k,type:u.VARIABLE});else if(k){const R=l[l.length-1];(!R||R.type!==u.SEPARATOR)&&l.push({value:k.label,type:u.SEPARATOR})}D="",w=!1}else D+=I;return D&&!w&&l.push({value:D,type:u.TEXT}),l.filter((I,k)=>{if(I.type===u.SEPARATOR){const R=l[k-1],L=l[k+1];return[R,L].every(T=>T&&(T.type===u.VARIABLE||T.type===u.TEXT)&&T.value.length>0)}return!0}).map(I=>I.value).join("")}e.$Dv=a;function E(t,n){return M.$j||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$Ev=E;function h(t,n){return M.$j||n?t.replace(/\(&&\w\)|&&/g,""):M.$i?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$Fv=h;function i(t){return t.replace(/&/g,"&&")}e.$Gv=i;function o(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const l=r(t.substring(0,n));return{name:l.name,parentPath:l.parentPath+t.substring(n)}}}return r(t)}e.$Hv=o;function r(t){const n=t.indexOf("/")!==-1?s.$fc:s.$ec,l=n.basename(t),w=n.dirname(t);return l.length?{name:l,parentPath:w}:{name:w,parentPath:""}}}),define(re[155],oe([0,1,18,7]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function s(p){return p.toJSON()}class M{constructor(v){this.a=v}transformIncoming(v){const f=this.a.transformIncoming(v);return f===v?v:s(A.URI.from(f))}transformOutgoing(v){const f=this.a.transformOutgoing(v);return f===v?v:s(A.URI.from(f))}transformOutgoingURI(v){const f=this.a.transformOutgoing(v);return f===v?v:A.URI.from(f)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Rm=M,e.$Sm=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function C(p,v,f){if(!p||f>200)return null;if(typeof p=="object"){if(p instanceof A.URI)return v.transformOutgoing(p);for(const y in p)if(Object.hasOwnProperty.call(p,y)){const m=C(p[y],v,f+1);m!==null&&(p[y]=m)}}return null}function P(p,v){const f=C(p,v,0);return f===null?p:f}e.$Tm=P;function d(p,v,f,y){if(!p||y>200)return null;if(typeof p=="object"){if(p.$mid===1)return f?A.URI.revive(v.transformIncoming(p)):v.transformIncoming(p);if(p instanceof S.$fe)return null;for(const m in p)if(Object.hasOwnProperty.call(p,m)){const b=d(p[m],v,f,y+1);b!==null&&(p[m]=b)}}return null}function c(p,v){const f=d(p,v,!1,0);return f===null?p:f}e.$Um=c;function $(p,v){const f=d(p,v,!0,0);return f===null?p:f}e.$Vm=$}),define(re[88],oe([0,1,28,57,32,145,4]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=void 0,e.$Xm=new class{c(v){return this.a||(this.a=A.$2h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,f=0;const y=(0,S.networkInterfaces)();for(const m in y){const b=y[m];if(b)for(const{mac:g,internal:u}of b)u||(f+=1,this.c(g.toUpperCase())&&(v+=1))}this.b=f>0?v/f:0}return this.b}};let P;async function d(v){return P||(P=(async()=>await c(v)||s.$ig())()),P}e.$Ym=d;async function c(v){try{const f=await new Promise((m,b)=>{Z(["crypto"],m,b)}),y=(0,M.$Wm)();return f.createHash("sha256").update(y,"utf8").digest("hex")}catch(f){v(f);return}}const $="Software\\Microsoft\\SQMClient";async function p(v){if(C.$i){const f=await new Promise((y,m)=>{Z(["@vscode/windows-registry"],y,m)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",$,"MachineId")||""}catch(y){return v(y),""}}return""}e.$Zm=p}),define(re[21],oe([0,1,46,28,156,8,33,85,9,4,19,7]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function f(ne,ce=v.UNLINK,X){if((0,C.$5f)(ne))throw new Error("rimraf - will refuse to recursively delete root");return ce===v.UNLINK?m(ne):y(ne,X)}async function y(ne,ce=(0,C.$0f)((0,A.tmpdir)())){try{try{await S.promises.rename(ne,ce)}catch(X){return X.code==="ENOENT"?void 0:m(ne)}m(ce).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function m(ne){return(0,s.promisify)(S.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function b(ne){if((0,C.$5f)(ne))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function g(ne,ce){return E(await(ce?u(ne):(0,s.promisify)(S.readdir)(ne)))}async function u(ne){try{return await(0,s.promisify)(S.readdir)(ne,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ce=[],X=await g(ne);for(const Y of X){let V=!1,q=!1,j=!1;try{const H=await e.Promises.lstat((0,d.$ic)(ne,Y));V=H.isFile(),q=H.isDirectory(),j=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ce.push({name:Y,isFile:()=>V,isDirectory:()=>q,isSymbolicLink:()=>j})}return ce}function a(ne){return E(S.readdirSync(ne))}e.readdirSync=a;function E(ne){return ne.map(ce=>typeof ce=="string"?c.$j?(0,P.$ul)(ce):ce:(ce.name=c.$j?(0,P.$ul)(ce.name):ce.name,ce))}async function h(ne){const ce=await g(ne),X=[];for(const Y of ce)await o.existsDirectory((0,d.$ic)(ne,Y))&&X.push(Y);return X}function i(ne,ce=1e3){return new Promise(X=>{let Y=!1;const V=setInterval(()=>{Y||(Y=!0,S.access(ne,q=>{Y=!1,q&&(clearInterval(V),X(void 0))}))},ce)})}e.whenDeleted=i;var o;(function(ne){async function ce(V){let q;try{if(q=await e.Promises.lstat(V),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(c.$i&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw H}throw j}}ne.stat=ce;async function X(V){try{const{stat:q,symbolicLink:j}=await ne.stat(V);return q.isFile()&&j?.dangling!==!0}catch{}return!1}ne.existsFile=X;async function Y(V){try{const{stat:q,symbolicLink:j}=await ne.stat(V);return q.isDirectory()&&j?.dangling!==!0}catch{}return!1}ne.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const r=new M.$7g;function t(ne,ce,X){return r.queueFor(p.URI.file(ne),$.$qg).queue(()=>{const Y=I(X);return new Promise((V,q)=>w(ne,ce,Y,j=>j?q(j):V()))})}let n=!0;function l(ne){n=ne}e.configureFlushOnWrite=l;function w(ne,ce,X,Y){if(!n)return S.writeFile(ne,ce,{mode:X.mode,flag:X.flag},Y);S.open(ne,X.flag,X.mode,(V,q)=>{if(V)return Y(V);S.writeFile(q,ce,j=>{if(j)return S.close(q,()=>Y(j));S.fdatasync(q,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),l(!1)),S.close(q,B=>Y(B))))})})}function D(ne,ce,X){const Y=I(X);if(!n)return S.writeFileSync(ne,ce,{mode:Y.mode,flag:Y.flag});const V=S.openSync(ne,Y.flag,Y.mode);try{S.writeFileSync(V,ce);try{S.fdatasyncSync(V)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{S.closeSync(V)}}e.writeFileSync=D;function I(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function k(ne,ce,X=6e4){if(ne!==ce)try{c.$i&&typeof X=="number"?await R(ne,ce,Date.now(),X):await(0,s.promisify)(S.rename)(ne,ce)}catch(Y){if(ne.toLowerCase()!==ce.toLowerCase()&&Y.code==="EXDEV"||ne.endsWith("."))await L(ne,ce,{preserveSymlinks:!1}),await f(ne,v.MOVE);else throw Y}}async function R(ne,ce,X,Y,V=0){try{return await(0,s.promisify)(S.rename)(ne,ce)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-X>=Y)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${q}`),q;if(V===0){let j=!1;try{const{stat:H}=await o.stat(ce);H.isFile()||(j=!0)}catch{}if(j)throw q}return await(0,M.$Yg)(Math.min(100,V*10)),R(ne,ce,X,Y,V+1)}}async function L(ne,ce,X){return N(ne,ce,{root:{source:ne,target:ce},options:X,handledSourcePaths:new Set})}const T=511;async function N(ne,ce,X){if(X.handledSourcePaths.has(ne))return;X.handledSourcePaths.add(ne);const{stat:Y,symbolicLink:V}=await o.stat(ne);if(V){if(X.options.preserveSymlinks)try{return await ae(ne,ce,X)}catch{}if(V.dangling)return}return Y.isDirectory()?K(ne,ce,Y.mode&T,X):Q(ne,ce,Y.mode&T)}async function K(ne,ce,X,Y){await e.Promises.mkdir(ce,{recursive:!0,mode:X});const V=await g(ne);for(const q of V)await N((0,d.$ic)(ne,q),(0,d.$ic)(ce,q),Y)}async function Q(ne,ce,X){await e.Promises.copyFile(ne,ce),await e.Promises.chmod(ce,X)}async function ae(ne,ce,X){let Y=await e.Promises.readlink(ne);(0,C.$2f)(Y,X.root.source,!c.$k)&&(Y=(0,d.$ic)(X.root.target,Y.substr(X.root.source.length+1))),await e.Promises.symlink(Y,ce)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(ne,ce,X,Y,V)=>new Promise((q,j)=>{S.read(ne,ce,X,Y,V,(H,B,_)=>H?j(H):q({bytesRead:B,buffer:_}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(ne,ce,X,Y,V)=>new Promise((q,j)=>{S.write(ne,ce,X,Y,V,(H,B,_)=>H?j(H):q({bytesWritten:B,buffer:_}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return h}get writeFile(){return t}get rm(){return f}get rename(){return k}get copy(){return L}}}),define(re[105],oe([0,1,46,9,4,27,21]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=void 0;function P(v){if(s.$k)return v;const f=(0,A.$lc)(v);if(v===f)return v;const y=((0,A.$mc)(v)||v).toLowerCase();try{const b=(0,C.readdirSync)(f).filter(g=>g.toLowerCase()===y);if(b.length===1){const g=P(f);if(g)return(0,A.$ic)(g,b[0])}else if(b.length>1){const g=b.indexOf(y);if(g>=0){const u=P(f);if(u)return(0,A.$ic)(u,b[g])}}}catch{}return null}e.$$p=P;async function d(v){if(s.$k)return v;const f=(0,A.$lc)(v);if(v===f)return v;const y=((0,A.$mc)(v)||v).toLowerCase();try{const b=(await C.Promises.readdir(f)).filter(g=>g.toLowerCase()===y);if(b.length===1){const g=await d(f);if(g)return(0,A.$ic)(g,b[0])}else if(b.length>1){const g=b.indexOf(y);if(g>=0){const u=await d(f);if(u)return(0,A.$ic)(u,b[g])}}}catch{}return null}e.$_p=d;async function c(v){try{return await C.Promises.realpath(v)}catch{const y=p(v);return await C.Promises.access(y,S.constants.R_OK),y}}e.$aq=c;function $(v){try{return S.realpathSync(v)}catch{const y=p(v);return S.accessSync(y,S.constants.R_OK),y}}e.$bq=$;function p(v){return(0,M.$Oe)((0,A.$gc)(v),A.sep)}}),define(re[106],oe([0,1,28,9,21]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=void 0;const M=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(d||(d={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let $;process.env.PROCESSOR_ARCHITEW6432?$=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?$=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?$=1:$=0;class p{constructor(h,i,o){this.exePath=h,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:E=!1}={}){return E?c===0?process.env["ProgramFiles(x86)"]||null:$===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:h=!1}={}){const i=v({useAlternateBitness:E});if(!i)return null;const o=A.$ic(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,t=null;for(const w of await s.Promises.readdir(o)){let D=-1;if(h){const k=w.indexOf("-");if(k<0)continue;const R=w.substring(0,k);if(!M.test(R)||w.substring(k+1)!=="preview")continue;D=parseInt(R,10)}else{if(!M.test(w))continue;D=parseInt(w,10)}if(D<=r)continue;const I=A.$ic(o,w,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(t=I,r=D)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",l=h?" Preview":"";return new p(t,`PowerShell${l}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const h=A.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(h))if(i.test(r)){const t=A.$ic(h,r,"pwsh.exe");return new p(t,o)}return null}function m(){const E=A.$ic(S.homedir(),".dotnet","tools","pwsh.exe");return new p(E,".NET Core PowerShell Global Tool")}function b(){const E=A.$ic(process.env.windir,c===1&&$!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(E,"Windows PowerShell",!0)}async function*g(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=m(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=b(),E&&(yield E)}async function*u(){for await(const E of g())await E.exists()&&(yield E)}e.$Dl=u;async function a(){for await(const E of u())return E;return null}e.$El=a}),define(re[89],oe([0,1,9,4,35,76,12,21]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function d(p=s.env){return p.comspec||"cmd.exe"}e.$Hl=d;function c(p){let v=[],f=!1;const y=function(m){if(f){v.push(m);return}(!p.send(m,g=>{if(g&&console.error(g),f=!1,v.length>0){const u=v.slice(0);v=[],u.forEach(a=>y(a))}})||A.$i)&&(f=!0)};return{send:y}}e.$Il=c;var $;(function(p){async function v(f,y,m){if(S.$hc(f))return f;if(y===void 0&&(y=s.cwd()),S.$lc(f)!=="."||(m===void 0&&C.$Cf(s.env.PATH)&&(m=s.env.PATH.split(S.$sc)),m===void 0||m.length===0))return S.$ic(y,f);async function g(u){if(await P.Promises.exists(u)){let a;try{a=await P.Promises.stat(u)}catch(E){E.message.startsWith("EACCES")&&(a=await P.Promises.lstat(u))}return a?!a.isDirectory():!1}return!1}for(const u of m){let a;if(S.$hc(u)?a=S.$ic(u,f):a=S.$ic(y,u,f),await g(a))return a;let E=a+".com";if(await g(E)||(E=a+".exe",await g(E)))return E}return S.$ic(y,f)}p.findExecutable=v})($||(e.win32=$={}))}),define(re[107],oe([0,1,48,13]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;function s(C){return new Promise((P,d)=>{let c;const $=new Map;function p(f,y,m,b,g){const u=$.get(y);if(f===C||u){const a={name:v(m),cmd:m,pid:f,ppid:y,load:b,mem:g};$.set(f,a),f===C&&(c=a),u&&(u.children||(u.children=[]),u.children.push(a),u.children.length>1&&(u.children=u.children.sort((E,h)=>E.pid-h.pid)))}}function v(f){const y=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,b=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,a=/--type=([a-zA-Z-]+)/;if(b.exec(f))return"electron-crash-reporter";if(g.exec(f))return"winpty-agent";if(u.exec(f))return"conpty-agent";let E=a.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const h=/[a-zA-Z-]+\.js/g;let i="";do E=h.exec(f),E&&(i+=E+" ");while(E);return i&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${i})`:m.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,m)=>{Z(["@vscode/windows-process-tree"],y,m)}).then(y=>{y.getProcessList(C,m=>{if(!m){d(new Error(`Root process ${C} not found`));return}y.getProcessCpuUsage(m,b=>{const g=new Map;b.forEach(u=>{const a=f(u.commandLine||"");g.set(u.pid,{name:v(a),cmd:a,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),c=g.get(C),c?(g.forEach(u=>{const a=g.get(u.ppid);a&&(a.children||(a.children=[]),a.children.push(u))}),g.forEach(u=>{u.children&&(u.children=u.children.sort((a,E)=>a.pid-E.pid))}),P(c)):d(new Error(`Root process ${C} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let f=function(){let y=[c];const m=[];for(;y.length;){const g=y.shift();g&&(m.push(g.pid),g.children&&(y=y.concat(g.children)))}let b=JSON.stringify(A.$gg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+m.join(" "),(0,S.exec)(b,{},(g,u,a)=>{if(g||a)d(g||new Error(a.toString()));else{const E=u.toString().split(`
`);for(let h=0;h<m.length;h++){const i=$.get(m[h]);i.load=parseFloat(E[h])}if(!c){d(new Error(`Root process ${C} not found`));return}P(c)}})};(0,S.exec)("which ps",{},(y,m,b)=>{if(y||b)if(process.platform!=="linux")d(y||new Error(b.toString()));else{const g=JSON.stringify(A.$gg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(g,{},(u,a,E)=>{u||E?d(u||new Error(E.toString())):(M(a,p),f())})}else{const g=m.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${g} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,E,h)=>{a||h&&!h.includes("screen size is bogus")?d(a||new Error(h.toString())):(M(E,p),process.platform==="linux"?f():c?P(c):d(new Error(`Root process ${C} not found`)))})}})}})}e.$Ir=s;function M(C,P){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=C.toString().split(`
`);for(const $ of c){const p=d.exec($.trim());p&&p.length===6&&P(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(re[108],oe([0,1,28,4,106,89]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0;async function C(p,v){return p===1?A.$i?$():M.$Hl(v):d(p,v)}e.$Jl=C;let P=null;function d(p,v){if(A.$k&&p===2||A.$j&&p===3)return"/bin/bash";if(!P){let f;if(A.$i)f="/bin/bash";else{if(f=v.SHELL,!f)try{f=(0,S.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}P=f}return P}let c=null;async function $(){return c||(c=(await(0,s.$El)()).exePath),c}});var ve=this&&this.__decorate||function(Z,e,S,A){var s=arguments.length,M=s<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,S):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Z,e,S,A);else for(var P=Z.length-1;P>=0;P--)(C=Z[P])&&(M=(s<3?C(M):s>3?C(e,S,M):C(e,S))||M);return s>3&&M&&Object.defineProperty(e,S,M),M};define(re[42],oe([0,1,23,8,18,22,56,14,3,2,77,27,12]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.ProxyChannel=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.RequestInitiator=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=void 0;var f;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(f||(f={}));function y(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(m||(m={}));function b(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(g||(g={}));function u(V){let q=0;for(let j=0;;j+=7){const H=V.read(1);if(q|=(H.buffer[0]&127)<<j,!(H.buffer[0]&128))return q}}const a=r(0);function E(V,q){if(q===0){V.write(a);return}let j=0;for(let B=q;B!==0;B=B>>>7)j++;const H=s.$fe.alloc(j);for(let B=0;q!==0;B++)H.buffer[B]=q&127,q=q>>>7,q>0&&(H.buffer[B]|=128);V.write(H)}class h{constructor(q){this.b=q,this.a=0}read(q){const j=this.b.slice(this.a,this.a+q);return this.a+=j.byteLength,j}}e.$th=h;class i{constructor(){this.a=[]}get buffer(){return s.$fe.concat(this.a)}write(q){this.a.push(q)}}e.$uh=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function r(V){const q=s.$fe.alloc(1);return q.writeUInt8(V,0),q}const t={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function l(V,q){if(typeof q>"u")V.write(t.Undefined);else if(typeof q=="string"){const j=s.$fe.fromString(q);V.write(t.String),E(V,j.byteLength),V.write(j)}else if(n&&Buffer.isBuffer(q)){const j=s.$fe.wrap(q);V.write(t.Buffer),E(V,j.byteLength),V.write(j)}else if(q instanceof s.$fe)V.write(t.VSBuffer),E(V,q.byteLength),V.write(q);else if(Array.isArray(q)){V.write(t.Array),E(V,q.length);for(const j of q)l(V,j)}else if(typeof q=="number"&&(q|0)===q)V.write(t.Uint),E(V,q);else{const j=s.$fe.fromString(JSON.stringify(q));V.write(t.Object),E(V,j.byteLength),V.write(j)}}e.$vh=l;function w(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(u(V)).toString();case o.Buffer:return V.read(u(V)).buffer;case o.VSBuffer:return V.read(u(V));case o.Array:{const j=u(V),H=[];for(let B=0;B<j;B++)H.push(w(V));return H}case o.Object:return JSON.parse(V.read(u(V)).toString());case o.Int:return u(V)}}e.$wh=w;class D{constructor(q,j,H=null,B=1e3){this.h=q,this.j=j,this.k=H,this.l=B,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(q,j){this.b.set(q,j),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const j=this.o([q.type]);this.k?.logOutgoing(j,0,1,b(q.type));return}case 201:case 202:case 204:case 203:{const j=this.o([q.type,q.id],q.data);this.k?.logOutgoing(j,q.id,1,b(q.type),q.data);return}}}o(q,j=void 0){const H=new i;return l(H,q),l(H,j),this.p(H.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const j=new h(q),H=w(j),B=w(j),_=H[0];switch(_){case 100:return this.k?.logIncoming(q.byteLength,H[1],1,`${y(_)}: ${H[2]}.${H[3]}`,B),this.s({type:_,id:H[1],channelName:H[2],name:H[3],arg:B});case 102:return this.k?.logIncoming(q.byteLength,H[1],1,`${y(_)}: ${H[2]}.${H[3]}`,B),this.t({type:_,id:H[1],channelName:H[2],name:H[3],arg:B});case 101:return this.k?.logIncoming(q.byteLength,H[1],1,`${y(_)}`),this.u({type:_,id:H[1]});case 103:return this.k?.logIncoming(q.byteLength,H[1],1,`${y(_)}`),this.u({type:_,id:H[1]})}}s(q){const j=this.b.get(q.channelName);if(!j){this.v(q);return}const H=new M.$2d;let B;try{B=j.call(this.j,q.name,q.arg,H.token)}catch(J){B=Promise.reject(J)}const _=q.id;B.then(J=>{this.m({id:_,data:J,type:201})},J=>{J instanceof Error?this.m({id:_,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:_,data:J,type:203})}).finally(()=>{se.dispose(),this.d.delete(q.id)});const se=(0,c.$Pc)(()=>H.cancel());this.d.set(q.id,se)}t(q){const j=this.b.get(q.channelName);if(!j){this.v(q);return}const H=q.id,_=j.listen(this.j,q.name,q.arg)(se=>this.m({id:H,data:se,type:204}));this.d.set(q.id,_)}u(q){const j=this.d.get(q.id);j&&(j.dispose(),this.d.delete(q.id))}v(q){let j=this.g.get(q.channelName);j||(j=[],this.g.set(q.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);j.push({request:q,timeoutTimer:H})}w(q){const j=this.g.get(q);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$xh=D;var I;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class k{constructor(q,j=null){this.l=q,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=j}getChannel(q){const j=this;return{call(H,B,_){return j.a?Promise.reject(new P.$4):j.m(q,H,B,_)},listen(H,B){return j.a?d.Event.None:j.o(q,H,B)}}}m(q,j,H,B=M.CancellationToken.None){const _=this.g++,J={id:_,type:100,channelName:q,name:j,arg:H};if(B.isCancellationRequested)return Promise.reject(new P.$4);let O;return new Promise((G,F)=>{if(B.isCancellationRequested)return F(new P.$4);const z=()=>{const de=le=>{switch(le.type){case 201:this.f.delete(_),G(le.data);break;case 202:{this.f.delete(_);const we=new Error(le.data.message);we.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,we.name=le.data.name,F(we);break}case 203:this.f.delete(_),F(le.data);break}};this.f.set(_,de),this.p(J)};let W=null;this.b===g.Idle?z():(W=(0,A.$Lg)(de=>this.u()),W.then(()=>{W=null,z()}));const x=()=>{W?(W.cancel(),W=null):this.p({id:_,type:101}),F(new P.$4)},he=B.onCancellationRequested(x);O=(0,c.$Oc)((0,c.$Pc)(x),he),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(q,j,H){const B=this.g++,se={id:B,type:102,channelName:q,name:j,arg:H};let J=null;const O=new d.$Rd({onWillAddFirstListener:()=>{J=(0,A.$Lg)(G=>this.u()),J.then(()=>{J=null,this.d.add(O),this.p(se)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(O),this.p({id:B,type:103}))}}),U=G=>O.fire(G.data);return this.f.set(B,U),O.event}p(q){switch(q.type){case 100:case 102:{const j=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(j,q.id,0,`${y(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const j=this.q([q.type,q.id]);this.j?.logOutgoing(j,q.id,0,y(q.type));return}}}q(q,j=void 0){const H=new i;return l(H,q),l(H,j),this.r(H.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const j=new h(q),H=w(j),B=w(j),_=H[0];switch(_){case 200:return this.j?.logIncoming(q.byteLength,0,0,b(_)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,H[1],0,b(_),B),this.t({type:H[0],id:H[1],data:B})}}t(q){if(q.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$yh=k,ve([C.$nh],k.prototype,"onDidInitializePromise",null);class R{get connections(){const q=[];return this.f.forEach(j=>q.push(j)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new d.$Rd,this.onDidAddConnection=this.g.event,this.h=new d.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(q(({protocol:j,onDidClientDisconnect:H})=>{const B=d.Event.once(j.onMessage);this.j.add(B(_=>{const se=new h(_),J=w(se),O=new D(j,J),U=new k(j);this.a.forEach((F,z)=>O.registerChannel(z,F));const G={channelServer:O,channelClient:U,ctx:J};this.f.add(G),this.g.fire(G),this.j.add(H(()=>{O.dispose(),U.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(q,j){const H=this;return{call(B,_,se){let J;if((0,v.$Qf)(j)){const U=(0,S.$3b)(H.connections.filter(j));J=U?Promise.resolve(U):d.Event.toPromise(d.Event.filter(H.onDidAddConnection,j))}else J=j.routeCall(H,B,_);const O=J.then(U=>U.channelClient.getChannel(q));return T(O).call(B,_,se)},listen(B,_){if((0,v.$Qf)(j))return H.k(q,j,B,_);const se=j.routeEvent(H,B,_).then(J=>J.channelClient.getChannel(q));return T(se).listen(B,_)}}}k(q,j,H,B){const _=this;let se;const J=new d.$Rd({onWillAddFirstListener:()=>{se=new c.$Qc;const O=new d.$Xd,U=new Map,G=z=>{const x=z.channelClient.getChannel(q).listen(H,B),he=O.add(x);U.set(z,he)},F=z=>{const W=U.get(z);W&&(W.dispose(),U.delete(z))};_.connections.filter(j).forEach(G),d.Event.filter(_.onDidAddConnection,j)(G,void 0,se),_.onDidRemoveConnection(F,void 0,se),O.event(J.fire,J,se),se.add(O)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return J.event}registerChannel(q,j){this.a.set(q,j);for(const H of this.f)H.channelServer.registerChannel(q,j)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$zh=R;class L{constructor(q,j,H=null){const B=new i;l(B,j),q.send(B.buffer),this.a=new k(q,H),this.d=new D(q,j,H)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,j){this.d.registerChannel(q,j)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ah=L;function T(V){return{call(q,j,H){return V.then(B=>B.call(q,j,H))},listen(q,j){const H=new d.$1d;return V.then(B=>H.input=B.listen(q,j)),H.event}}}e.$Bh=T;function N(V){let q=!1;return{call(j,H,B){return q?V.call(j,H,B):(0,A.$Yg)(0).then(()=>q=!0).then(()=>V.call(j,H,B))},listen(j,H){if(q)return V.listen(j,H);const B=new d.$1d;return(0,A.$Yg)(0).then(()=>q=!0).then(()=>B.input=V.listen(j,H)),B.event}}}e.$Ch=N;class K{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const j of q.connections)if(await Promise.resolve(this.a(j.ctx)))return Promise.resolve(j);return await d.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$Dh=K;var Q;(function(V){function q(_,se,J){const O=_,U=J&&J.disableMarshalling,G=new Map;for(const F in O)H(F)&&G.set(F,d.Event.buffer(O[F],!0,void 0,se));return new class{listen(F,z,W){const x=G.get(z);if(x)return x;if(B(z)){const he=O[z];if(typeof he=="function")return he.call(O,W)}throw new P.$ab(`Event not found: ${z}`)}call(F,z,W){const x=O[z];if(typeof x=="function"){if(!U&&Array.isArray(W))for(let de=0;de<W.length;de++)W[de]=(0,$.$sh)(W[de]);let he=x.apply(O,W);return he instanceof Promise||(he=Promise.resolve(he)),he}throw new P.$ab(`Method not found: ${z}`)}}}V.fromService=q;function j(_,se){const J=se&&se.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return se?.properties?.has(U)?se.properties.get(U):B(U)?function(G){return _.listen(U,G)}:H(U)?_.listen(U):async function(...G){let F;se&&!(0,v.$Lf)(se.context)?F=[se.context,...G]:F=G;const z=await _.call(U,F);return J?z:(0,$.$sh)(z)};throw new P.$ab(`Property not found: ${String(U)}`)}})}V.toService=j;function H(_){return _[0]==="o"&&_[1]==="n"&&p.$5e(_.charCodeAt(2))}function B(_){return/^onDynamic/.test(_)&&p.$5e(_.charCodeAt(9))}})(Q||(e.ProxyChannel=Q={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const q=V.toString();if(q!=="[object Object]")return q}return V}function ce(V){return Array.isArray(V)?V.map(ne):ne(V)}function X(V,q,j,H,B,_,se){se=ce(se);const J=ae[B],O=J[H%J.length];let U=[`%c[${V}]%c[${String(q).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(_)?(U=U.concat(se),U.push(")")):U.push(se),console.log.apply(console,U)}class Y{constructor(q,j){this.d=q,this.f=j,this.a=0,this.b=0}logOutgoing(q,j,H,B,_){this.b+=q,X(this.d,this.b,q,j,H,B,_)}logIncoming(q,j,H,B,_){this.a+=q,X(this.f,this.a,q,j,H,B,_)}}e.$Eh=Y}),define(re[157],oe([0,1,18,3,42]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZT=e.$YT=void 0;class M{constructor(d){this.a=d,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",c=>S.$fe.wrap(c.data)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.$YT=M;class C extends s.$Ah{constructor(d,c){const $=new M(d);super($,c),this.b=$}dispose(){this.b.disconnect(),super.dispose()}}e.$ZT=C}),define(re[109],oe([0,1,18,3,2,42]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.ProtocolConstants=e.$Fh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let l=0;function w(I,k){if(!n.has(I)){const R=String(++l);n.set(I,R)}return n.get(I)}function D(I,k,R,L){if(!t.enableDiagnostics)return;const T=w(I,k);if(L instanceof S.$fe||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const N=S.$fe.alloc(L.byteLength);N.set(L),t.records.push({timestamp:Date.now(),id:T,label:k,type:R,buff:N})}else t.records.push({timestamp:Date.now(),id:T,label:k,type:R,data:L})}t.traceSocketEvent=D})(P||(e.SocketDiagnostics=P={}));var d;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let c=null;function $(){return c||(c=S.$fe.alloc(0)),c}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,l){if(n===0)return $();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return l&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return l&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const w=S.$fe.alloc(n);let D=0,I=0;for(;n>0;){const k=this.a[I];if(k.byteLength>n){const R=k.slice(0,n);w.set(R,D),D+=n,l&&(this.a[I]=k.slice(n),this.b-=n),n-=n}else w.set(k,D),D+=k.byteLength,l?(this.a.shift(),this.b-=k.byteLength):I++,n-=k.byteLength}return w}}e.$Fh=p;var v;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(v||(v={}));function f(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class m{constructor(n,l,w,D){this.type=n,this.id=l,this.ack=w,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends s.$Rc{constructor(n){super(),this.f=this.B(new A.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new p,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,D=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new m(w,D,I,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=S.$fe.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(l,n.data)}g(n,l){const w=this.f===0;return this.d.push(n,l),this.f+=n.byteLength+l.byteLength,w}h(){const n=S.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,l){this.g(n,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class u extends s.$Rc{constructor(n){super(),this.f=new A.$Rd,this.onMessage=this.f.event,this.g=new A.$Rd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$Gh=u;class a extends M.$Ah{static fromSocket(n,l){return new a(new u(n),l)}get onDidDispose(){return this.b.onDidDispose}constructor(n,l,w=null){super(n,l,w),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Hh=a;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Ih=E;class h{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,l=this.a;for(;l;)l=l.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let l=0,w=this.a;for(;w;)n[l++]=w.data,w=w.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const l=new h(n);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let l=0;l<o.a;l++)this.c[l]=n-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),l=(1+o.a)*1e3;let w=0;for(let D=0;D<o.a;D++)n-this.c[D]<=l&&w++;return 1-w/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Qc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,$());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,$());this.p.write(n)}sendResume(){const n=new m(8,0,0,$());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,l){this.a=!0,this.r.dispose(),this.r=new s.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,$());this.p.write(n);const l=this.b.toArray();for(let w=0,D=l.length;w<D;w++)this.p.write(l[w]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const l=this.b.peek();if(l&&l.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new m(6,0,0,$())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let w=0,D=l.length;w<D;w++)this.p.write(l[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const l=++this.c;this.h=this.g;const w=new m(1,l,this.h,n);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(n){const l=new m(2,0,0,n);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),l=Date.now()-n.writtenTime,w=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(l>=2e4&&w>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:w});return}const I=Math.max(2e4-l,2e4-w,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,$());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,$());this.p.write(n)}}e.$Jh=r}),define(re[36],oe([0,1,15,14,13]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VT=void 0;class M{constructor(){this.a=new WeakMap}on(P,d){const c=($,...p)=>{this.b(P,$)&&d($,...p)};return this.a.set(d,c),S.ipcMain.on(P,c),this}once(P,d){return S.ipcMain.once(P,(c,...$)=>{this.b(P,c)&&d(c,...$)}),this}handle(P,d){return S.ipcMain.handle(P,(c,...$)=>this.b(P,c)?d(c,...$):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,d){const c=this.a.get(d);return c&&(S.ipcMain.removeListener(P,c),this.a.delete(d)),this}b(P,d){if(!P||!P.startsWith("vscode:"))return(0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const c=d.senderFrame,$=c.url;if(!$||$==="about:blank")return!0;let p="unknown";try{p=new URL($).host}catch{return(0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${$}'.`),!1}return p!==s.$fg?((0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${p}'.`),!1):c.parent!==null?((0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.$VT=new M}),define(re[158],oe([0,1,15,36,146]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WT=void 0;function M(){A.$VT.on(s.$TT,(P,d,c,$,p)=>{const v=C(P,$,c);v.popup({x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{v&&P.sender.send(s.$UT,d)}})})}e.$WT=M;function C(P,d,c){const $=new S.Menu;return c.forEach(p=>{let v;p.type==="separator"?v=new S.MenuItem({type:p.type}):Array.isArray(p.submenu)?v=new S.MenuItem({submenu:C(P,d,p.submenu),label:p.label}):v=new S.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:(f,y,m)=>P.sender.send(d,p.id,m)}),$.append(v)}),$}}),define(re[159],oe([0,1,36,18,3,2,42,147]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3T=void 0;function d($,p){const v=s.Event.fromNodeEventEmitter(S.$VT,p,(y,m)=>({event:y,message:m})),f=s.Event.filter(v,({event:y})=>y.sender.id===$);return s.Event.map(f,({message:y})=>y&&A.$fe.wrap(y))}class c extends C.$zh{static{this.b=new Map}static d(){const p=s.Event.fromNodeEventEmitter(S.$VT,"vscode:hello",({sender:v})=>v);return s.Event.map(p,v=>{const f=v.id;c.b.get(f)?.dispose();const m=new s.$Rd;c.b.set(f,(0,M.$Pc)(()=>m.fire()));const b=d(f,"vscode:message"),g=s.Event.any(s.Event.signal(d(f,"vscode:disconnect")),m.event);return{protocol:new P.$2T(v,b),onDidClientDisconnect:g}})}constructor(){super(c.d())}}e.$3T=c}),define(re[110],oe([0,1,36,3,32,157]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5T=e.$4T=void 0;class C extends M.$ZT{constructor(c,$){super({addEventListener:(p,v)=>c.addListener(p,v),removeEventListener:(p,v)=>c.removeListener(p,v),postMessage:p=>c.postMessage(p),start:()=>c.start(),close:()=>c.close()},$)}}e.$4T=C;async function P(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,s.$ig)();d.webContents.send("vscode:createMessageChannel",c);const $=A.Event.fromNodeEventEmitter(S.$VT,"vscode:createMessageChannelResult",(v,f)=>({nonce:f,port:v.ports[0]})),{port:p}=await A.Event.toPromise(A.Event.once(A.Event.filter($,v=>v.nonce===c)));return p}e.$5T=P}),define(re[160],oe([0,1,48,8,18,22,154,14,3,2,38,89,76,42]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;class y extends f.$xh{constructor(g){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",u=>s.$fe.wrap(Buffer.from(u,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$8p=y;class m{constructor(g,u){this.i=g,this.j=u,this.c=new Set,this.g=new Map,this.h=new d.$Rd,this.onDidProcessExit=this.h.event;const a=u&&u.timeout?u.timeout:6e4;this.b=new A.$Ug(a),this.d=null,this.f=null}getChannel(g){const u=this;return{call(a,E,h){return u.k(g,a,E,h)},listen(a,E){return u.l(g,a,E)}}}k(g,u,a,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$5());this.b.cancel();const h=this.n(g),i=(0,A.$Lg)(t=>h.call(u,a,t)),o=E.onCancellationRequested(()=>i.cancel()),r=(0,c.$Pc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(g,u,a){if(!this.b)return d.Event.None;this.b.cancel();let E;const h=new d.$Rd({onWillAddFirstListener:()=>{E=this.n(g).listen(u,a)(h.fire,h),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,$.$an)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,v.$Gl)(u.env),this.d=(0,S.fork)(this.i,g,u);const a=new d.$Rd;d.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$4p)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}a.fire(s.$fe.wrap(Buffer.from(n,"base64")))});const h=this.j.useQueue?(0,p.$Il)(this.d):this.d,i=n=>this.d&&this.d.connected&&h.send(n.buffer.toString("base64")),o=a.event,r={send:i,onMessage:o};this.f=new f.$yh(r);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,l)=>{process.removeListener("exit",t),this.c.forEach(w=>(0,c.$Mc)(w)),this.c.clear(),n!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:l})})}return this.f}n(g){let u=this.g.get(g);return u||(u=this.m.getChannel(g),this.g.set(g,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9p=m}),define(re[111],oe([0,1,8,3,2,77,12]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.StorageState=e.$7o=e.StorageHint=void 0;var P;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function d(v){const f=v;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$7o=d;var c;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(c||(e.StorageState=c={}));class $ extends s.$Rc{static{this.a=100}constructor(f,y=Object.create(null)){super(),this.r=f,this.s=y,this.b=this.B(new A.$Ud),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new S.$Vg($.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((y,m)=>this.w(m,y)),f.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(f,y){if(this.c===c.Closed)return;let m=!1;(0,C.$Lf)(y)?m=this.f.delete(f):this.f.get(f)!==y&&(this.f.set(f,y),m=!0),m&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,y){const m=this.f.get(f);return(0,C.$Lf)(m)?y:m}getBoolean(f,y){const m=this.get(f);return(0,C.$Lf)(m)?y:m==="true"}getNumber(f,y){const m=this.get(f);return(0,C.$Lf)(m)?y:parseInt(m,10)}getObject(f,y){const m=this.get(f);return(0,C.$Lf)(m)?y:(0,M.$rh)(m)}async set(f,y,m=!1){if(this.c===c.Closed)return;if((0,C.$Lf)(y))return this.delete(f,m);const b=(0,C.$Ef)(y)||Array.isArray(y)?(0,M.$qh)(y):String(y);if(this.f.get(f)!==b)return this.f.set(f,b),this.j.set(f,b),this.h.delete(f),this.b.fire({key:f,external:m}),this.D()}async delete(f,y=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:y}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$8o=$;class p{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((y,m)=>this.a.set(m,y)),f.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$9o=p}),define(re[161],oe([0,1,8,3,31,9,21]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oU=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.a=2e3}static{this.b=256}constructor($,p=Object.create(null)){this.g=$,this.h=p,this.c=(0,M.$mc)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const $=await this.f,p=new Map;return(await this.s($,"SELECT * FROM ItemTable")).forEach(f=>p.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${p.size} rows`),p}async updateItems($){const p=await this.f;return this.j(p,$)}j($,p){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${p.insert?(0,s.$xc)(p.insert):"0"}), delete(${p.delete?(0,s.$yc)(p.delete):"0"})`),this.t($,()=>{const v=p.insert,f=p.delete;if(v&&v.size>0){const y=[];y.push([]);let m=0;v.forEach((b,g)=>{let u=y[m];u.length>P.b&&(m++,u=[],y.push(u)),u.push(g,b)}),y.forEach(b=>{this.u($,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,g=>g.run(b),()=>{const g=[];let u=0;return v.forEach((a,E)=>{g.push(E),u+=a.length}),`Keys: ${g.join(", ")} Length: ${u}`})})}if(f&&f.size){const y=[];y.push([]);let m=0;f.forEach(b=>{let g=y[m];g.length>P.b&&(m++,g=[],y.push(g)),g.push(b)}),y.forEach(b=>{this.u($,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,g=>g.run(b),()=>{const g=[];return f.forEach(u=>{g.push(u)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const $=await this.f;return this.q($,"VACUUM")}async close($){this.d.trace(`[storage ${this.c}] close()`);const p=await this.f;return this.k(p,$)}k($,p){return new Promise((v,f)=>{$.db.close(y=>(y&&this.o($,`[storage ${this.c}] close(): ${y}`),this.g===P.IN_MEMORY_PATH?v():!$.isErroneous&&!$.isInMemory?this.l().then(v,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),v())):typeof p=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const b=()=>this.k(m,void 0);return this.j(m,{insert:p()}).then(()=>b(),g=>(b(),Promise.reject(g)))})).then(v,f):f(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const $=this.m(this.g);return C.Promises.copy(this.g,$,{preserveSymlinks:!1})}m($){return`${$}.backup`}async checkIntegrity($){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${$})`);const p=await this.f,v=await this.r(p,$?"PRAGMA integrity_check":"PRAGMA quick_check"),f=$?v.integrity_check:v.quick_check;return p.isErroneous?`${f} (last error: ${p.lastError})`:p.isInMemory?`${f} (in-memory!)`:f}async n($,p=!0){this.d.trace(`[storage ${this.c}] open(${$}, retryOnBusy: ${p})`);try{return await this.p($)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&p)return await(0,S.$Yg)(P.a),this.n($,!1);try{await C.Promises.unlink($);try{await C.Promises.rename(this.m($),$,!1)}catch{}return await this.p($)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(P.IN_MEMORY_PATH)}}}o($,p){$.isErroneous=!0,$.lastError=p,this.d.error(p)}p($){return new Promise((p,v)=>{new Promise((f,y)=>{Z(["@vscode/sqlite3"],f,y)}).then(f=>{const y={db:new(this.d.isTracing?f.verbose().Database:f.Database)($,m=>m?y.db&&m.code!=="SQLITE_CANTOPEN"?y.db.close(()=>v(m)):v(m):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>p(y),b=>y.db.close(()=>v(b)))),isInMemory:$===P.IN_MEMORY_PATH};y.db.on("error",m=>this.o(y,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&y.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},v)})}q($,p){return new Promise((v,f)=>{$.db.exec(p,y=>y?(this.o($,`[storage ${this.c}] exec(): ${y}`),f(y)):v())})}r($,p){return new Promise((v,f)=>{$.db.get(p,(y,m)=>y?(this.o($,`[storage ${this.c}] get(): ${y}`),f(y)):v(m))})}s($,p){return new Promise((v,f)=>{$.db.all(p,(y,m)=>y?(this.o($,`[storage ${this.c}] all(): ${y}`),f(y)):v(m))})}t($,p){return new Promise((v,f)=>{$.db.serialize(()=>{$.db.run("BEGIN TRANSACTION"),p(),$.db.run("END TRANSACTION",y=>y?(this.o($,`[storage ${this.c}] transaction(): ${y}`),f(y)):v())})})}u($,p,v,f){const y=$.db.prepare(p),m=b=>{this.o($,`[storage ${this.c}] prepare(): ${b} (${p}). Details: ${f()}`)};y.on("error",m),v(y),y.finalize(b=>{b&&m(b),y.removeListener("error",m)})}}e.$oU=P;class d{static{this.a="VSCODE_TRACE_STORAGE"}constructor($){$&&typeof $.logTrace=="function"&&process.env[d.a]&&(this.b=$.logTrace),$&&typeof $.logError=="function"&&(this.c=$.logError)}get isTracing(){return!!this.b}trace($){this.b?.($)}error($){this.c?.($)}}}),define(re[162],oe([11,10]),function(Z,e){return Z.create("vs/code/electron-main/app",e)}),define(re[163],oe([11,10]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[164],oe([11,10]),function(Z,e){return Z.create("vs/platform/contextkey/common/contextkey",e)}),define(re[165],oe([11,10]),function(Z,e){return Z.create("vs/platform/contextkey/common/scanner",e)}),define(re[166],oe([11,10]),function(Z,e){return Z.create("vs/platform/dialogs/common/dialogs",e)}),define(re[167],oe([11,10]),function(Z,e){return Z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(re[168],oe([11,10]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(re[169],oe([11,10]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(re[170],oe([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[171],oe([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[172],oe([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[173],oe([11,10]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[174],oe([11,10]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(re[175],oe([11,10]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(re[176],oe([11,10]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(re[177],oe([11,10]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(re[178],oe([11,10]),function(Z,e){return Z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(re[179],oe([11,10]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[180],oe([11,10]),function(Z,e){return Z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(re[181],oe([11,10]),function(Z,e){return Z.create("vs/platform/menubar/electron-main/menubar",e)}),define(re[182],oe([11,10]),function(Z,e){return Z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(re[183],oe([11,10]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(re[184],oe([11,10]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(re[185],oe([11,10]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[186],oe([11,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[187],oe([11,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[188],oe([11,10]),function(Z,e){return Z.create("vs/platform/update/common/update.config.contribution",e)}),define(re[189],oe([11,10]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[190],oe([11,10]),function(Z,e){return Z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(re[191],oe([11,10]),function(Z,e){return Z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(re[192],oe([11,10]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(re[193],oe([11,10]),function(Z,e){return Z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(re[194],oe([11,10]),function(Z,e){return Z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(re[195],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_eb=e.$$eb=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$$eb=S;function A(s){return s&&s.hasOwnProperty("workspace")}e.$_eb=A}),define(re[196],oe([0,1,7]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8b=e.$n8b=e.$m8b=void 0;function A(C){return typeof C?.backupFolder=="string"}e.$m8b=A;function s(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(d=>({workspace:{id:d.id,configPath:S.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$n8b=s;function M(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(d=>({folderUri:S.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$o8b=M}),define(re[197],oe([0,1,14,165]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var s;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...c){switch(c.length){case 1:return(0,A.localize)(0,null,c[0]);case 2:return(0,A.localize)(1,null,c[0],c[1]);case 3:return(0,A.localize)(2,null,c[0],c[1],c[2]);default:return}}const C=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return $.isTripleEq?"===":"==";case 4:return $.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return $.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return $.lexeme;case 18:return $.lexeme;case 19:return $.lexeme;case 20:return"EOF";default:throw(0,S.$7)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const p=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:p})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const p=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:p})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const p=this.d,v=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:v};this.g.push({offset:p,lexeme:v,additionalInfo:$}),this.f.push(f)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const p=this.c.substring(this.d,this.e),v=d.b.get(p);v?this.k(v):this.f.push({type:17,lexeme:p,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,p=!1,v=!1;for(;;){if($>=this.c.length){this.e=$,this.l(P);return}const y=this.c.charCodeAt($);if(p)p=!1;else if(y===47&&!v){$++;break}else y===91?v=!0:y===92?p=!0:y===93&&(v=!1);$++}for(;$<this.c.length&&d.a.has(this.c.charCodeAt($));)$++;this.e=$;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=d}),define(re[198],oe([0,1,3,2]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=void 0;class s{constructor(){this.a=new S.$Rd,this.b=new S.$Rd,this.c=new S.$Rd,this.d=new S.$Rd}static{this.ChannelName="extensionhostdebugservice"}call(P,d,c){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(P,d,c){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Sn=s;class M extends A.$Rc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,d,c){this.b.call("attach",[P,d,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,d){this.b.call("terminate",[P,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,d){return this.b.call("openExtensionDevelopmentHostWindow",[P,d])}}e.$Tn=M}),define(re[199],oe([0,1,149,56,13,9,35,19,7]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=void 0,e.$lm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,M.$lc)(s.$gg.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,M.$ic)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.$zg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$zg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,S.$km)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$ic)(this.userDataPath,"logs",f)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$zg)(d.URI.file((0,M.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$zg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$zg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$zg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?d.URI.file((0,M.$ic)(f,"argv.json")):(0,P.$zg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,M.$jc)(f):(0,M.$gc)((0,M.$ic)(s.$gg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?d.URI.file((0,M.$jc)(f)):d.URI.file((0,M.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,M.$jc)(f);const y=C.env.VSCODE_EXTENSIONS;if(y)return y;const m=C.env.VSCODE_PORTABLE;return m?(0,M.$ic)(m,"extensions"):(0,P.$zg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?d.URI.parse(y):d.URI.file((0,M.$gc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?d.URI.parse(f):d.URI.file((0,M.$gc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return $(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$lm.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const m=e.$lm.exec(y);m&&m[1]&&m[2]&&f.push([m[1],m[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.$zg)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=C.env.VSCODE_PORTABLE;return f?d.URI.file((0,M.$ic)(f,"policy.json")):(0,P.$zg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,y,m){this.a=f,this.b=y,this.c=m,this.editSessionId=this.args.editSessionId}}e.$mm=c,ve([A.$nh],c.prototype,"appRoot",null),ve([A.$nh],c.prototype,"userHome",null),ve([A.$nh],c.prototype,"userDataPath",null),ve([A.$nh],c.prototype,"appSettingsHome",null),ve([A.$nh],c.prototype,"tmpDir",null),ve([A.$nh],c.prototype,"cacheHome",null),ve([A.$nh],c.prototype,"stateResource",null),ve([A.$nh],c.prototype,"userRoamingDataHome",null),ve([A.$nh],c.prototype,"userDataSyncHome",null),ve([A.$nh],c.prototype,"sync",null),ve([A.$nh],c.prototype,"machineSettingsResource",null),ve([A.$nh],c.prototype,"workspaceStorageHome",null),ve([A.$nh],c.prototype,"localHistoryHome",null),ve([A.$nh],c.prototype,"keyboardLayoutResource",null),ve([A.$nh],c.prototype,"argvResource",null),ve([A.$nh],c.prototype,"isExtensionDevelopment",null),ve([A.$nh],c.prototype,"untitledWorkspacesHome",null),ve([A.$nh],c.prototype,"builtinExtensionsPath",null),ve([A.$nh],c.prototype,"extensionsPath",null),ve([A.$nh],c.prototype,"extensionDevelopmentLocationURI",null),ve([A.$nh],c.prototype,"extensionDevelopmentKind",null),ve([A.$nh],c.prototype,"extensionTestsLocationURI",null),ve([A.$nh],c.prototype,"debugExtensionHost",null),ve([A.$nh],c.prototype,"logLevel",null),ve([A.$nh],c.prototype,"extensionLogLevel",null),ve([A.$nh],c.prototype,"serviceMachineIdResource",null),ve([A.$nh],c.prototype,"disableTelemetry",null),ve([A.$nh],c.prototype,"disableWorkspaceTrust",null),ve([A.$nh],c.prototype,"useInMemorySecretStorage",null),ve([A.$nh],c.prototype,"policyFile",null);function $(v,f){return p(v["inspect-extensions"],v["inspect-brk-extensions"],5870,f,v.debugId,v.extensionEnvironment)}e.$nm=$;function p(v,f,y,m,b,g){const a=Number(f||v)||(m?null:y),E=a?!!f:!1;let h;if(g)try{h=JSON.parse(g)}catch{}return{port:a,break:E,debugId:b,env:h}}e.$om=p}),define(re[112],oe([0,1,310,4,168]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Kl=["tunnel","serve-web"],e.$Ll={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,b,g=C){const u=m.find(l=>l.length>0&&l[0]!=="-"),a={},E=["_"],h=[],i={};let o;for(const l in b){const w=b[l];w.type==="subcommand"?l===u&&(o=w):(w.alias&&(a[l]=w.alias),w.type==="string"||w.type==="string[]"?(E.push(l),w.deprecates&&E.push(...w.deprecates)):w.type==="boolean"&&(h.push(l),w.deprecates&&h.push(...w.deprecates)),w.global&&(i[l]=w))}if(o&&u){const l=i;for(const k in o.options)l[k]=o.options[k];const w=m.filter(k=>k!==u),D=g.getSubcommandReporter?g.getSubcommandReporter(u):void 0,I=P(w,l,D);return{[u]:I,_:[]}}const r=S(m,{string:E,boolean:h,alias:a}),t={},n=r;t._=r._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(const l in b){const w=b[l];if(w.type==="subcommand")continue;w.alias&&delete n[w.alias];let D=n[l];if(w.deprecates)for(const I of w.deprecates)n.hasOwnProperty(I)&&(D||(D=n[I],D&&g.onDeprecatedOption(I,w.deprecationMessage||(0,s.localize)(37,null,l))),delete n[I]);if(typeof D<"u"){if(w.type==="string[]"){if(Array.isArray(D)||(D=[D]),!w.allowEmptyValue){const I=D.filter(k=>k.length>0);I.length!==D.length&&(g.onEmptyValue(l),D=I.length>0?I:void 0)}}else w.type==="string"&&(Array.isArray(D)?(D=D.pop(),g.onMultipleValues(l,D)):!D&&!w.allowEmptyValue&&(g.onEmptyValue(l),D=void 0));t[l]=D,w.deprecationMessage&&g.onDeprecatedOption(l,w.deprecationMessage)}delete n[l]}for(const l in n)g.onUnknownOption(l);return t}e.$Ml=P;function d(m,b){let g="";return b.args&&(Array.isArray(b.args)?g=` <${b.args.join("> <")}>`:g=` <${b.args}>`),b.alias?`-${b.alias} --${m}${g}`:`--${m}${g}`}function c(m,b){const g=[];for(const u in m){const a=m[u],E=d(u,a);g.push([E,a.description])}return $(g,b)}e.$Nl=c;function $(m,b){const u=m.reduce((h,i)=>Math.max(h,i[0].length),12)+2+1;if(b-u<25)return m.reduce((h,i)=>h.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=b-u-1,E=[];for(const h of m){const i=h[0],o=v(h[1],a),r=p(u-i.length-2);E.push("  "+i+r+o[0]);for(let t=1;t<o.length;t++)E.push(p(u)+o[t])}return E}function p(m){return" ".repeat(m)}function v(m,b){const g=[];for(;m.length;){const u=m.length<b?m.length:m.lastIndexOf(" ",b),a=m.slice(0,u).trim();m=m.slice(u),g.push(a)}return g}function f(m,b,g,u,a){const E=process.stdout.isTTY&&process.stdout.columns||80,h=a?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${m} ${g}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${b} [${(0,s.localize)(40,null)}]${h}`),i.push(""),a?.noPipe!==!0&&(A.$i?i.push((0,s.localize)(41,null,b)):i.push((0,s.localize)(42,null,b)),i.push(""));const o={},r=[];for(const t in u){const n=u[t];if(n.type==="subcommand")n.description&&r.push({command:t,description:n.description});else if(n.description&&n.cat){let l=o[n.cat];l||(o[n.cat]=l={}),l[t]=n}}for(const t in o){const n=t,l=o[n];l&&(i.push(M[n]),i.push(...c(l,E)),i.push(""))}return r.length&&(i.push((0,s.localize)(43,null)),i.push(...$(r.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Ol=f;function y(m,b){return`${m||(0,s.localize)(44,null)}
${b||(0,s.localize)(45,null)}
${process.arch}`}e.$Pl=y}),define(re[200],oe([0,1,87,198,112]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P8b=void 0;class M extends A.$Sn{constructor(P){super(),this.f=P}call(P,d,c){return d==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(P,d,c)}async g(P,d){const c=(0,s.$Ml)(P,s.$Ll);c.debugRenderer=d;const $=c.extensionDevelopmentPath;if(!$)return{success:!1};const[p]=await this.f.openExtensionDevelopmentHostWindow($,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!d)return{success:!0};const v=p.win;if(!v)return{success:!0};const f=v.webContents.debugger;let y=f.isAttached()?1/0:0;const m=(0,S.createServer)(b=>{y++===0&&f.attach();let g=!1;const u=h=>{g||b.write(JSON.stringify(h)+"\0")},a=(h,i,o,r)=>u({method:i,params:o,sessionId:r});v.on("close",()=>{f.removeListener("message",a),b.end(),g=!0}),f.addListener("message",a);let E=Buffer.alloc(0);b.on("data",h=>{E=Buffer.concat([E,h]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let o;try{const r=E.slice(0,i).toString("utf8");E=E.slice(i+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(o.method,o.params,o.sessionId).then(r=>u({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>u({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),b.on("error",h=>{console.error("error on cdp pipe:",h)}),b.on("close",()=>{g=!0,--y===0&&f.detach()})});return await new Promise(b=>m.listen(0,b)),v.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$P8b=M}),define(re[63],oe([0,1,311,169,112]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=e.$Ql=void 0;function M(p,v){const f=(a,E)=>{console.warn((0,A.localize)(0,null,a,E))},y=a=>{console.warn((0,A.localize)(1,null,a))},m=(a,E)=>{console.warn((0,A.localize)(2,null,a,E))},b=a=>({onUnknownOption:E=>{s.$Kl.includes(a)||console.warn((0,A.localize)(3,null,E,a))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:m,getSubcommandReporter:s.$Kl.includes(a)?b:void 0}),g={onUnknownOption:a=>{console.warn((0,A.localize)(4,null,a))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:m,getSubcommandReporter:b},u=(0,s.$Ml)(p,s.$Ll,v?g:void 0);return u.goto&&u._.forEach(a=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(a),(0,A.localize)(5,null))),u}function C(p){const v=p.findIndex(f=>!/^-/.test(f));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function P(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=C(v)||[]);const f=!$(process.env);return M(v,f)}e.$Ql=P;function d(p){let[,,...v]=p;return process.env.VSCODE_DEV&&(v=C(v)||[]),M(v,!0)}e.$Rl=d;function c(p,...v){const f=p.indexOf("--");return f===-1?p.push(...v):p.splice(f,0,...v),p}e.$Sl=c;function $(p){return p.VSCODE_CLI==="1"}e.$Tl=$}),function(){"use strict";function Z(e,S,A){function s(C,P){const d=M(C,P),c=[d];return e.isAbsolute(d)||c.unshift(A),e.resolve(...c)}function M(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,P);const $=C["user-data-dir"];if($)return $;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(p,"AppData","Roaming")}break;case"darwin":c=e.join(S.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,P)}return{getUserDataPath:s}}if(typeof define=="function")define(re[201],oe([113,28,35]),function(e,S,A){return Z(e,S,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Z(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[90],oe([0,1,28,199,201]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0;class M extends A.$mm{constructor(c,$){super(c,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(c,$.nameShort)},$)}}e.$pm=M;function C(d,c){return(0,A.$om)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,c,d.extensionEnvironment)}e.$qm=C;function P(d,c){return(0,A.$om)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,c,d.extensionEnvironment)}e.$rm=P}),define(re[202],oe([0,1,46,28,33]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$89b=void 0;function M(C){const P=(0,s.$0f)((0,A.tmpdir)());try{return(0,S.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(d){C&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.$89b=M}),define(re[203],oe([0,1,12,171]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;function s(C,P,d,c){try{M(C,P,d,c)}catch($){C.error($?.message??$)}return P}e.$Dp=s;function M(C,P,d,c){const $=(p,v,f)=>{const y=p[v];if((0,S.$Cf)(y)){const m=y,b=m.length;if(b>1&&m[0]==="%"&&m[b-1]==="%"){const g=m.substr(1,b-2);let u=d[g];u===void 0&&c&&(u=c[g]);const a=typeof u=="string"?u:u?.message,E=c?.[g],h=typeof E=="string"?E:E?.message;if(!a){h||C.warn(`[${P.name}]: ${(0,A.localize)(0,null,g)}`);return}if(f&&(v==="title"||v==="category")&&h&&h!==a){const i={value:a,original:h};p[v]=i}else p[v]=a}}else if((0,S.$Ef)(y))for(const m in y)y.hasOwnProperty(m)&&(m==="commands"?$(y,m,!0):$(y,m,f));else if(Array.isArray(y))for(let m=0;m<y.length;m++)$(y,m,f)};for(const p in P)P.hasOwnProperty(p)&&$(P,p)}}),define(re[204],oe([0,1,19,74,173,205]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(g){return g=g.trim(),g==="*"||C.test(g)}e.$Ro=d;function c(g){if(!d(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=g.match(C);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$So=c;function $(g){if(!g)return null;const u=g.majorBase,a=g.majorMustEqual,E=g.minorBase;let h=g.minorMustEqual;const i=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(u===0||(h=!1),o=!1);let r=0;if(g.preRelease){const t=P.exec(g.preRelease);if(t){const[,n,l,w]=t;r=Date.UTC(Number(n),Number(l)-1,Number(w))}}return{majorBase:u,majorMustEqual:a,minorBase:E,minorMustEqual:h,patchBase:i,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:r}}e.$To=$;function p(g,u,a){let E;typeof g=="string"?E=$(c(g)):E=g;let h;u instanceof Date?h=u.getTime():typeof u=="string"&&(h=new Date(u).getTime());let i;if(typeof a=="string"?i=$(c(a)):i=a,!E||!i)return!1;const o=E.majorBase,r=E.minorBase,t=E.patchBase;let n=i.majorBase,l=i.minorBase,w=i.patchBase;const D=i.notBefore;let I=i.majorMustEqual,k=i.minorMustEqual,R=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:r>l?!0:r<l||h&&h<D?!1:t>=w:(o===1&&n===0&&(!I||!k||!R)&&(n=1,l=0,w=0,I=!0,k=!1,R=!1),o<n?!1:o>n?!I:r<l?!1:r>l?!k:t<w?!1:t>w?!R:!(h&&h<D))}e.$Uo=p;function v(g,u,a,E,h){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([A.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([A.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([A.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([A.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([A.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!b(E.extensionDependencies))return i.push([A.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!b(E.activationEvents))return i.push([A.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([A.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([A.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([A.default.Error,s.localize(9,null,"main")]),i;{const t=(0,S.$zg)(a,E.main);(0,S.$tg)(t,a)||i.push([A.default.Warning,s.localize(10,null,t.path,a.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([A.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,S.$zg)(a,E.browser);(0,S.$tg)(t,a)||i.push([A.default.Warning,s.localize(12,null,t.path,a.path)])}}if(!M.valid(E.version))return i.push([A.default.Error,s.localize(13,null)]),i;const o=[];if(!f(g,u,E,h,o))for(const t of o)i.push([A.default.Error,t]);return i}e.$Vo=v;function f(g,u,a,E,h){return E||typeof a.main>"u"&&typeof a.browser>"u"?!0:m(g,u,a.engines.vscode,h)}e.$Wo=f;function y(g,u,a){return g==="*"||m(u,a,g)}e.$Xo=y;function m(g,u,a,E=[]){const h=$(c(a));if(!h)return E.push(s.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return E.push(s.localize(15,null,a)),!1}else if(!h.majorMustEqual)return E.push(s.localize(16,null,a)),!1;return p(g,u,h)?!0:(E.push(s.localize(17,null,g,a)),!1)}function b(g){if(!Array.isArray(g))return!1;for(let u=0,a=g.length;u<a;u++)if(typeof g[u]!="string")return!1;return!0}}),define(re[206],oe([0,1,18,32]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;async function s(M,C,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const $=(await C.readFile(M.serviceMachineIdResource)).value.toString();d=(0,A.$hg)($)?$:null}catch{d=null}if(!d){d=(0,A.$ig)();try{await C.writeFile(M.serviceMachineIdResource,S.$fe.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.$fp=s}),define(re[78],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class S{constructor(s,M=[],C=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=C}}e.$Sh=S}),define(re[207],oe([0,1,78]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const A=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(P,d,c){d instanceof S.$Sh||(d=new S.$Sh(d,[],!!c)),A.push([P,d])}e.$Cr=M;function C(){return A}e.$Dr=C}),define(re[208],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class S{constructor(M,C){this.key=M,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$hq=S;class A{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const C of this.a.values())C.outgoing.size===0&&M.push(C);return M}insertEdge(M,C){const P=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(C);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(M){const C=this.b(M);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(M){const C=this.b(M);let P=this.a.get(C);return P||(P=new S(C,M),this.a.set(C,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[C,P]of this.a)M.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,C]of this.a){const P=new Set([M]),d=this.c(C,P);if(d)return d}}c(M,C){for(const[P,d]of M.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const c=this.c(d,C);if(c)return c;C.delete(P)}}}e.$iq=A}),define(re[6],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var S;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(d){return d[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(S||(e._util=S={})),e.$Uh=s("instantiationService");function A(C,P,d){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:C,index:d}):(P[S.DI_DEPENDENCIES]=[{id:C,index:d}],P[S.DI_TARGET]=P)}function s(C){if(S.serviceIds.has(C))return S.serviceIds.get(C);const P=function(d,c,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,d,$)};return P.toString=()=>C,S.serviceIds.set(C,P),P}e.$Vh=s;function M(C){return C}e.$Wh=M}),define(re[64],oe([0,1,13,6]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I8b=e.$H8b=void 0,e.$H8b=(0,A.$Vh)("auxiliaryWindowsMainService");function s(M){return M?.opener?.url.startsWith(`${S.Schemas.vscodeFileResource}://${S.$fg}/`)}e.$I8b=s}),define(re[65],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=void 0,e.$p8b=(0,S.$Vh)("backupMainService")}),define(re[17],oe([0,1,12,7,6]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,s.$Vh)("configurationService");function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof A.URI)}e.$qi=M;function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof A.URI)}e.$ri=C;var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function d(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=d;function c(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$ti=c;function $(g,u){const a=Object.create(null);for(const E in g)p(a,E,g[E],u);return a}e.$ui=$;function p(g,u,a,E){const h=u.split("."),i=h.pop();let o=g;for(let r=0;r<h.length;r++){const t=h[r];let n=o[t];switch(typeof n){case"undefined":n=o[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${u} as ${h.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=a}catch{E(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(o)}`)}e.$vi=p;function v(g,u){const a=u.split(".");f(g,a)}e.$wi=v;function f(g,u){const a=u.shift();if(u.length===0){delete g[a];return}if(Object.keys(g).indexOf(a)!==-1){const E=g[a];typeof E=="object"&&!Array.isArray(E)&&(f(E,u),Object.keys(E).length===0&&delete g[a])}}function y(g,u,a){function E(o,r){let t=o;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const h=u.split("."),i=E(g,h);return typeof i>"u"?a:i}e.$xi=y;function m(g,u,a){Object.keys(u).forEach(E=>{E!=="__proto__"&&(E in g?S.$Ef(g[E])&&S.$Ef(u[E])?m(g[E],u[E],a):a&&(g[E]=u[E]):g[E]=u[E])})}e.$yi=m;function b(g){return g.replace(/[\[\]]/g,"")}e.$zi=b}),define(re[114],oe([0,1,4,27,197,6,164,14]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",S.$j),d.set("isLinux",S.$k),d.set("isWindows",S.$i),d.set("isWeb",S.$o),d.set("isMacNative",S.$j&&!S.$o),d.set("isEdge",S.$H),d.set("isFirefox",S.$F),d.set("isChrome",S.$E),d.set("isSafari",S.$G);function c(J,O){if(d.get(J)!==void 0)throw(0,P.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(J,O)}e.$Ri=c;const $=Object.prototype.hasOwnProperty;var p;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const v={regexParsingWithErrorRecovery:!0},f=(0,C.localize)(0,null),y=(0,C.localize)(1,null),m=(0,C.localize)(2,null),b=(0,C.localize)(3,null),g=(0,C.localize)(4,null),u=(0,C.localize)(5,null),a=(0,C.localize)(6,null),E=(0,C.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=v){this.k=O,this.d=new s.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const G=this.D(),F=G.type===17?u:void 0;throw this.h.push({message:g,offset:G.offset,lexeme:s.$Qi.getLexeme(G),additionalInfo:F}),h.c}return U}catch(U){if(U!==h.c)throw U;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const U=this.o();O.push(U)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const U=this.s();O.push(U)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,b),U?.negate()}case 17:return this.z(),L.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const U=this.l();return this.A(1,b),U}case 17:{const U=O.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const z=F.lexeme,W=z.lastIndexOf("/"),x=W===z.length-1?void 0:this.w(z.substring(W+1));let he;try{he=new RegExp(z.substring(1,W),x)}catch{throw this.B("REGEX",F)}return ne.create(U,he)}switch(F.type){case 10:case 19:{const z=[F.lexeme];this.z();let W=this.D(),x=0;for(let be=0;be<F.lexeme.length;be++)F.lexeme.charCodeAt(be)===40?x++:F.lexeme.charCodeAt(be)===41&&x--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:x++;break;case 1:x--;break;case 10:case 18:for(let be=0;be<W.lexeme.length;be++)W.lexeme.charCodeAt(be)===40?x++:F.lexeme.charCodeAt(be)===41&&x--}if(x<0)break;z.push(s.$Qi.getLexeme(W)),this.z(),W=this.D()}const he=z.join(""),de=he.lastIndexOf("/"),le=de===he.length-1?void 0:this.w(he.substring(de+1));let we;try{we=new RegExp(he.substring(1,de),le)}catch{throw this.B("REGEX",F)}return i.regex(U,we)}case 18:{const z=F.lexeme;this.z();let W=null;if(!(0,A.$Fe)(z)){const x=z.indexOf("/"),he=z.lastIndexOf("/");if(x!==he&&x>=0){const de=z.slice(x+1,he),le=z[he+1]==="i"?"i":"";try{W=new RegExp(de,le)}catch{throw this.B("REGEX",F)}}}if(W===null)throw this.B("REGEX",F);return ne.create(U,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const F=this.u();return i.notIn(U,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return i.equals(U,F);switch(F){case"true":return i.has(U);case"false":return i.not(U);default:return i.equals(U,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return i.notEquals(U,F);switch(F){case"true":return i.not(U);case"false":return i.has(U);default:return i.notEquals(U,F)}}case 5:return this.z(),Q.create(U,this.u());case 6:return this.z(),ae.create(U,this.u());case 7:return this.z(),N.create(U,this.u());case 8:return this.z(),K.create(U,this.u());case 13:return this.z(),i.in(U,this.u());default:return i.has(U)}}case 20:throw this.h.push({message:a,offset:O.offset,lexeme:"",additionalInfo:E}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,U){if(this.C(O))return this.z();throw this.B(U,this.D())}B(O,U,G){const F=(0,C.localize)(8,null,O,s.$Qi.getLexeme(U)),z=U.offset,W=s.$Qi.getLexeme(U);return this.h.push({message:F,offset:z,lexeme:W,additionalInfo:G}),h.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=h;class i{static false(){return n.INSTANCE}static true(){return l.INSTANCE}static has(O){return w.create(O)}static equals(O,U){return D.create(O,U)}static notEquals(O,U){return R.create(O,U)}static regex(O,U){return ne.create(O,U)}static in(O,U){return I.create(O,U)}static notIn(O,U){return k.create(O,U)}static not(O){return L.create(O)}static and(...O){return Y.create(O,null,!0)}static or(...O){return V.create(O,null,!0)}static greater(O,U){return N.create(O,U)}static greaterEquals(O,U){return K.create(O,U)}static smaller(O,U){return Q.create(O,U)}static smallerEquals(O,U){return ae.create(O,U)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Ti=i;function o(J){const O=new h({regexParsingWithErrorRecovery:!1});return J.map(U=>(O.parse(U),O.lexingErrors.length>0?O.lexingErrors.map(G=>({errorMessage:G.additionalInfo?(0,C.localize)(9,null,G.additionalInfo):(0,C.localize)(10,null),offset:G.offset,length:G.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(G=>({errorMessage:G.additionalInfo?`${G.message}. ${G.additionalInfo}`:G.message,offset:G.offset,length:G.lexeme.length})):[]))}e.$Ui=o;function r(J,O){const U=J?J.substituteConstants():void 0,G=O?O.substituteConstants():void 0;return!U&&!G?!0:!U||!G?!1:U.equals(G)}e.$Vi=r;function t(J,O){return J.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return l.INSTANCE}}e.$Wi=n;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Xi=l;class w{static create(O,U=null){const G=d.get(O);return typeof G=="boolean"?G?l.INSTANCE:n.INSTANCE:new w(O,U)}constructor(O,U){this.key=O,this.c=U,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:j(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=d.get(this.key);return typeof O=="boolean"?O?l.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Yi=w;class D{static create(O,U,G=null){if(typeof U=="boolean")return U?w.create(O,G):L.create(O,G);const F=d.get(O);return typeof F=="boolean"?U===(F?"true":"false")?l.INSTANCE:n.INSTANCE:new D(O,U,G)}constructor(O,U,G){this.c=O,this.d=U,this.f=G,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?l.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Zi=D;class I{static create(O,U){return new I(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:H(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.f),G=O.getValue(this.d);return Array.isArray(U)?U.includes(G):typeof G=="string"&&typeof U=="object"&&U!==null?$.call(U,G):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$1i=I;class k{static create(O,U){return new k(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=11,this.c=I.create(O,U)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=k;class R{static create(O,U,G=null){if(typeof U=="boolean")return U?L.create(O,G):w.create(O,G);const F=d.get(O);return typeof F=="boolean"?U===(F?"true":"false")?n.INSTANCE:l.INSTANCE:new R(O,U,G)}constructor(O,U,G){this.c=O,this.d=U,this.f=G,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?n.INSTANCE:l.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$3i=R;class L{static create(O,U=null){const G=d.get(O);return typeof G=="boolean"?G?n.INSTANCE:l.INSTANCE:new L(O,U)}constructor(O,U){this.c=O,this.d=U,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:j(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=d.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:l.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$4i=L;function T(J,O){if(typeof J=="string"){const U=parseFloat(J);isNaN(U)||(J=U)}return typeof J=="string"||typeof J=="number"?O(J):n.INSTANCE}class N{static create(O,U,G=null){return T(U,F=>new N(O,F,G))}constructor(O,U,G){this.c=O,this.d=U,this.f=G,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$5i=N;class K{static create(O,U,G=null){return T(U,F=>new K(O,F,G))}constructor(O,U,G){this.c=O,this.d=U,this.f=G,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$6i=K;class Q{static create(O,U,G=null){return T(U,F=>new Q(O,F,G))}constructor(O,U,G){this.c=O,this.d=U,this.f=G,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$7i=Q;class ae{static create(O,U,G=null){return T(U,F=>new ae(O,F,G))}constructor(O,U,G){this.c=O,this.d=U,this.f=G,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$8i=ae;class ne{static create(O,U){return new ne(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const U=this.f?this.f.source:"",G=O.f?O.f.source:"";return U<G?-1:U>G?1:0}equals(O){if(O.type===this.type){const U=this.f?this.f.source:"",G=O.f?O.f.source:"";return this.d===O.d&&U===G}return!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$9i=ne;class ce{static create(O){return new ce(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ce(this.c.map(O))}negate(){return this.c}}e.$0i=ce;function X(J){let O=null;for(let U=0,G=J.length;U<G;U++){const F=J[U].substituteConstants();if(J[U]!==F&&O===null){O=[];for(let z=0;z<U;z++)O[z]=J[z]}O!==null&&(O[U]=F)}return O===null?J:O}class Y{static create(O,U,G){return Y.d(O,U,G)}constructor(O,U){this.expr=O,this.c=U,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,G=this.expr.length;U<G;U++){const F=t(this.expr[U],O.expr[U]);if(F!==0)return F}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,G=this.expr.length;U<G;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:Y.create(O,this.c,!1)}evaluate(O){for(let U=0,G=this.expr.length;U<G;U++)if(!this.expr[U].evaluate(O))return!1;return!0}static d(O,U,G){const F=[];let z=!1;for(const W of O)if(W){if(W.type===1){z=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){F.push(...W.expr);continue}F.push(W)}if(F.length===0&&z)return l.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(t);for(let W=1;W<F.length;W++)F[W-1].equals(F[W])&&(F.splice(W,1),W--);if(F.length===1)return F[0];for(;F.length>1;){const W=F[F.length-1];if(W.type!==9)break;F.pop();const x=F.pop(),he=F.length===0,de=V.create(W.expr.map(le=>Y.create([le,x],null,G)),null,he);de&&(F.push(de),F.sort(t))}if(F.length===1)return F[0];if(G){for(let W=0;W<F.length;W++)for(let x=W+1;x<F.length;x++)if(F[W].negate().equals(F[x]))return n.INSTANCE;if(F.length===1)return F[0]}return new Y(F,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new Y(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());this.c=V.create(O,this,!0)}return this.c}}e.$$i=Y;class V{static create(O,U,G){return V.d(O,U,G)}constructor(O,U){this.expr=O,this.c=U,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,G=this.expr.length;U<G;U++){const F=t(this.expr[U],O.expr[U]);if(F!==0)return F}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,G=this.expr.length;U<G;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:V.create(O,this.c,!1)}evaluate(O){for(let U=0,G=this.expr.length;U<G;U++)if(this.expr[U].evaluate(O))return!0;return!1}static d(O,U,G){let F=[],z=!1;if(O){for(let W=0,x=O.length;W<x;W++){const he=O[W];if(he){if(he.type===0){z=!0;continue}if(he.type===1)return l.INSTANCE;if(he.type===9){F=F.concat(he.expr);continue}F.push(he)}}if(F.length===0&&z)return n.INSTANCE;F.sort(t)}if(F.length!==0){if(F.length===1)return F[0];for(let W=1;W<F.length;W++)F[W-1].equals(F[W])&&(F.splice(W,1),W--);if(F.length===1)return F[0];if(G){for(let W=0;W<F.length;W++)for(let x=W+1;x<F.length;x++)if(F[W].negate().equals(F[x]))return l.INSTANCE;if(F.length===1)return F[0]}return new V(F,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new V(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());for(;O.length>1;){const U=O.shift(),G=O.shift(),F=[];for(const z of se(U))for(const W of se(G))F.push(Y.create([z,W],null,!1));O.unshift(V.create(F,null,!1))}this.c=V.create(O,this,!0)}return this.c}}e.$_i=V;class q extends w{static{this.d=[]}static all(){return q.d.values()}constructor(O,U,G){super(O,null),this.f=U,typeof G=="object"?q.d.push({...G,key:O}):G!==!0&&q.d.push({key:O,description:G,type:U!=null?typeof U:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return D.create(this.key,O)}notEqualsTo(O){return R.create(this.key,O)}}e.$aj=q,e.$bj=(0,M.$Vh)("contextKeyService");function j(J,O){return J<O?-1:J>O?1:0}function H(J,O,U,G){return J<U?-1:J>U?1:O<G?-1:O>G?1:0}function B(J,O){if(J.type===0||O.type===1)return!0;if(J.type===9)return O.type===9?_(J.expr,O.expr):!1;if(O.type===9){for(const U of O.expr)if(B(J,U))return!0;return!1}if(J.type===6){if(O.type===6)return _(O.expr,J.expr);for(const U of J.expr)if(B(U,O))return!0;return!1}return J.equals(O)}e.$cj=B;function _(J,O){let U=0,G=0;for(;U<J.length&&G<O.length;){const F=J[U].cmp(O[G]);if(F<0)return!1;F===0&&U++,G++}return U===J.length}function se(J){return J.type===9?J.expr:[J]}}),define(re[91],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=e.ID=void 0,e.ID="diagnosticsService",e.$wm=(0,S.$Vh)(e.ID);function A(M){return!!M.hostName&&!!M.errorMessage}e.$xm=A;class s{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$ym=s}),define(re[115],oe([0,1,19,74,166,6,47,4,38]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.ConfirmResult=e.$Kv=e.$Jv=e.$Iv=void 0,e.$Iv=(0,M.$Vh)("dialogService");var c;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(c||(c={}));class ${a(b){return this.d(b,c.Confirmation)}b(b){return this.d(b,c.Prompt)}c(b){return this.d(b,c.Input)}d(b,g){const u=[];switch(g){case c.Confirmation:{const a=b;a.primaryButton?u.push(a.primaryButton):u.push((0,s.localize)(0,null)),a.cancelButton?u.push(a.cancelButton):u.push((0,s.localize)(1,null));break}case c.Prompt:{const a=b;Array.isArray(a.buttons)&&a.buttons.length>0&&u.push(...a.buttons.map(E=>E.label)),a.cancelButton&&(a.cancelButton===!0?u.push((0,s.localize)(2,null)):typeof a.cancelButton=="string"?u.push(a.cancelButton):a.cancelButton.label?u.push(a.cancelButton.label):u.push((0,s.localize)(3,null))),u.length===0&&u.push((0,s.localize)(4,null));break}case c.Input:{const a=b;a.primaryButton?u.push(a.primaryButton):u.push((0,s.localize)(5,null)),a.cancelButton?u.push(a.cancelButton):u.push((0,s.localize)(6,null));break}}return u}e(b){if(typeof b=="string")return b;if(typeof b=="number")return b===A.default.Info?"info":b===A.default.Error?"error":b===A.default.Warning?"warning":"none"}f(b,g,u){const a=[...b.buttons??[]];b.cancelButton&&typeof b.cancelButton!="string"&&typeof b.cancelButton!="boolean"&&a.push(b.cancelButton);let E=a[g]?.run({checkboxChecked:u});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:u}}}e.$Jv=$,e.$Kv=(0,M.$Vh)("fileDialogService");var p;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(p||(e.ConfirmResult=p={}));const v=10;function f(m){const b=[];return b.push(...m.slice(0,v).map(g=>typeof g=="string"?g:(0,S.$wg)(g))),m.length>v&&(m.length-v===1?b.push((0,s.localize)(7,null)):b.push((0,s.localize)(8,null,m.length-v))),b.push(""),b.join(`
`)}e.$Lv=f;function y(m,b){const g=(0,d.$an)(m);let u=(g.buttons??[]).map(i=>(0,C.$Fv)(i)),a=(m.buttons||[]).map((i,o)=>o),E=0,h=g.cancelId??u.length-1;if(u.length>1){const i=typeof h=="number"?u[h]:void 0;if(P.$k||P.$j){if(typeof i=="string"&&u.length>1&&h!==1){u.splice(h,1),u.splice(1,0,i);const o=a[h];a.splice(h,1),a.splice(1,0,o),h=1}P.$k&&u.length>1&&(u=u.reverse(),a=a.reverse(),E=u.length-1,typeof i=="string"&&(h=E-1))}else if(P.$i&&typeof i=="string"&&u.length>1&&h!==u.length-1){u.splice(h,1),u.push(i);const o=a[h];a.splice(h,1),a.push(o),h=u.length-1}}return g.buttons=u,g.defaultId=E,g.cancelId=h,g.noLink=!0,g.title=g.title||b.nameLong,{options:g,buttonIndeces:a}}e.$Mv=y}),define(re[116],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GU=e.$FU=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$EU=e.$DU=void 0,e.$DU=(0,S.$Vh)("encryptionService"),e.$EU=(0,S.$Vh)("encryptionMainService");var A;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$FU=M;function C(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$GU=C}),define(re[37],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,S.$Vh)("environmentService"),e.$4h=(0,S.$Wh)(e.$3h)}),define(re[117],oe([0,1,170,6]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function s(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=s;function M(g){switch(g){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=M;function C(g,u){switch(g){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=C;function P(g,u){return u==="web"&&!g.includes("web")}e.$ao=P;function d(g,u,a){return P(u,a)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===a}e.$bo=d;function c(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.$co=c;var $;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var p;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var v;(function(g){g.Install="install",g.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var f;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$do=(0,A.$Vh)("extensionGalleryService");var y;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Signature="Signature",g.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var m;(function(g){g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class b extends Error{constructor(u,a){super(u),this.code=a,this.name=a}}e.$eo=b,e.$fo=(0,A.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,A.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,A.$Vh)("IExtensionTipsService"),e.$ko=(0,S.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,S.localize)(1,null),original:"Preferences"}}),define(re[209],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=e.$W8b=void 0,e.$W8b=(0,S.$Vh)("extensionHostStarter"),e.$X8b="extensionHostStarter"}),define(re[210],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Zb=e.$3Zb=void 0,e.$3Zb=(0,S.$Vh)("externalTerminal"),e.$4Zb="Terminal.app"}),define(re[211],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=void 0,e.$Z8b=(0,S.$Vh)("externalTerminal")}),define(re[212],oe([0,1,48,13,9,4,76,21,89,174,210]),function(Z,e,S,A,s,M,C,P,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=e.$28b=e.$18b=void 0;const p=c.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends v{static{this.b="cmd.exe"}openTerminal(E,h){return this.spawnTerminal(S,E,d.$Hl(),h)}spawnTerminal(E,h,i,o){const r=h.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=s.$mc(r,".exe").toLowerCase();if(t==="cmder")return E.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),t==="wt"&&n.push("-d ."),new Promise((l,w)=>{const D=b(process),I=E.spawn(i,n,{cwd:o,env:D});I.on("error",w),I.on("exit",()=>l())})}runInTerminal(E,h,i,o,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,l)=>{const w=`"${h} - ${p}"`,D=`""${i.join('" "')}" & pause"`,I=Object.assign({},b(process),o);Object.keys(I).filter(N=>I[N]===null).forEach(N=>delete I[N]);const k={cwd:h,env:I,windowsVerbatimArguments:!0};let R,L;s.$mc(t,".exe")==="wt"?(R=t,L=["-d",".",f.b,"/c",D]):(R=f.b,L=["/c","start",w,"/wait",t,"/c",D]),S.spawn(R,L,k).on("error",N=>{l(g(N))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$18b=f;class y extends v{static{this.b="/usr/bin/osascript"}openTerminal(E,h){return this.spawnTerminal(S,E,h)}runInTerminal(E,h,i,o,r){const t=r.osxExec||$.$4Zb;return new Promise((n,l)=>{if(t===$.$4Zb||t==="iTerm.app"){const w=t===$.$4Zb?"TerminalHelper":"iTermHelper",I=[A.$gg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`).fsPath,"-t",E||p,"-w",h];for(const L of i)I.push("-a"),I.push(L);if(o){const L=Object.assign({},b(process),o);for(const T in L){const N=L[T];N===null?(I.push("-u"),I.push(T)):(I.push("-e"),I.push(`${T}=${N}`))}}let k="";const R=S.spawn(y.b,I);R.on("error",L=>{l(g(L))}),R.stderr.on("data",L=>{k+=L.toString()}),R.on("exit",L=>{if(L===0)n(void 0);else if(k){const T=k.split(`
`,1);l(new Error(T[0]))}else l(new Error(c.localize(1,null,w,L)))})}else l(new Error(c.localize(2,null,t)))})}spawnTerminal(E,h,i){const o=h.osxExec||$.$4Zb;return new Promise((r,t)=>{const n=["-a",o];i&&n.push(i);const l=b(process),w=E.spawn("/usr/bin/open",n,{cwd:i,env:l});w.on("error",t),w.on("exit",()=>r())})}}e.$28b=y;class m extends v{static{this.b=c.localize(3,null)}openTerminal(E,h){return this.spawnTerminal(S,E,h)}runInTerminal(E,h,i,o,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,l)=>{const w=[];t.then(D=>{D.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const I=`${u(i)}; echo; read -p "${m.b}" -n1;`;w.push(`''${I}''`);const k=Object.assign({},b(process),o);Object.keys(k).filter(N=>k[N]===null).forEach(N=>delete k[N]);const R={cwd:h,env:k};let L="";const T=S.spawn(D,w,R);T.on("error",N=>{l(g(N))}),T.stderr.on("data",N=>{L+=N.toString()}),T.on("exit",N=>{if(N===0)n(void 0);else if(L){const K=L.split(`
`,1);l(new Error(K[0]))}else l(new Error(c.localize(4,null,D,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!M.$k)m.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");m.d=new Promise(h=>{E?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return m.d}spawnTerminal(E,h,i){const o=h.linuxExec?Promise.resolve(h.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{o.then(n=>{const l=b(process),w=E.spawn(n,[],{cwd:i,env:l});w.on("error",t),w.on("exit",()=>r())})})}}e.$38b=m;function b(a){const E={...a.env};return(0,C.$Fl)(E),E}function g(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(c.localize(5,null,a.path)):a}function u(a){let E="";for(const h of a)h.indexOf(" ")>=0?E+='"'+h+'"':E+=h,E+=" ";return E}}),define(re[16],oe([0,1,57,9,27,12,7,176,6,4,13,72]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,d.$Vh)("fileService");function v(B){return B.create===!0}e.$fk=v;var f;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var y;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function m(B){const _=B;return!!_&&typeof _.onDidChange=="function"}e.$gk=m;var b;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function g(B){return!!(B.capabilities&2)}e.$hk=g;function u(B){return!!(B.capabilities&8)}e.$ik=u;function a(B){return!!(B.capabilities&131072)}e.$jk=a;function E(B){return!!(B.capabilities&4)}e.$kk=E;function h(B){return!!(B.capabilities&16)}e.$lk=h;function i(B){return g(B)?!!(B.capabilities&16384):!1}e.$mk=i;function o(B){return g(B)?!!(B.capabilities&32768):!1}e.$nk=o;function r(B){return!!(B.capabilities&65536)}e.$ok=r;function t(B){return!!(B.capabilities&2048)}e.$pk=t;var n;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class l extends Error{static create(_,se){const J=new l(_.toString(),se);return I(J,se),J}constructor(_,se){super(_),this.code=se}}e.$qk=l;function w(B,_){return l.create(B,_)}e.$rk=w;function D(B){return B||w((0,P.localize)(0,null),n.Unknown)}e.$sk=D;function I(B,_){return B.name=_?`${_} (FileSystemError)`:"FileSystemError",B}e.$tk=I;function k(B){if(!B)return n.Unknown;if(B instanceof l)return B.code;const _=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!_)return n.Unknown;switch(_[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$uk=k;function R(B){if(B instanceof ae)return B.fileOperationResult;switch(k(B)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$vk=R;var L;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class T{constructor(_,se,J){this.resource=_,this.operation=se,this.target=J}isOperation(_){return this.operation===_}}e.$wk=T;var N;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class K{static{this.a=null}constructor(_,se){this.c=se,this.b=void 0,this.d=new p.$U(()=>{const J=S.$2h.forUris(()=>this.c);return J.fill(this.rawAdded.map(O=>[O,!0])),J}),this.f=new p.$U(()=>{const J=S.$2h.forUris(()=>this.c);return J.fill(this.rawUpdated.map(O=>[O,!0])),J}),this.g=new p.$U(()=>{const J=S.$2h.forUris(()=>this.c);return J.fill(this.rawDeleted.map(O=>[O,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of _){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.b!==K.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(_,...se){return this.h(_,{includeChildren:!1},...se)}affects(_,...se){return this.h(_,{includeChildren:!0},...se)}h(_,se,...J){if(!_)return!1;const O=J.length>0;return!!((!O||J.includes(1))&&(this.d.value.get(_)||se.includeChildren&&this.d.value.findSuperstr(_))||(!O||J.includes(0))&&(this.f.value.get(_)||se.includeChildren&&this.f.value.findSuperstr(_))||(!O||J.includes(2))&&(this.g.value.findSubstr(_)||se.includeChildren&&this.g.value.findSuperstr(_)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(_){return this.b===_}hasCorrelation(){return typeof this.b=="number"}}e.$xk=K;function Q(B,_,se){return!B||!_||B===_||_.length>B.length?!1:(_.charAt(_.length-1)!==A.sep&&(_+=A.sep),se?(0,s.$7e)(B,_):B.indexOf(_)===0)}e.$yk=Q;class ae extends Error{constructor(_,se,J){super(_),this.fileOperationResult=se,this.options=J}}e.$zk=ae;class ne extends ae{constructor(_,se,J,O){super(_,se,O),this.fileOperationResult=se,this.size=J}}e.$Ak=ne;class ce extends ae{constructor(_,se,J){super(_,2,J),this.stat=se}}e.$Bk=ce;var X;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var Y;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$Jk="";function V(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.$Kk=V;async function q(B,_){if(!_.hasProvider(C.URI.from({scheme:B.scheme})))return new Promise(se=>{const J=_.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===B.scheme&&O.added&&(J.dispose(),se())})})}e.$Lk=q;class j{static{this.KB=1024}static{this.MB=j.KB*j.KB}static{this.GB=j.MB*j.KB}static{this.TB=j.GB*j.KB}static formatSize(_){return(0,M.$Gf)(_)||(_=0),_<j.KB?(0,P.localize)(1,null,_.toFixed(0)):_<j.MB?(0,P.localize)(2,null,(_/j.KB).toFixed(2)):_<j.GB?(0,P.localize)(3,null,(_/j.MB).toFixed(2)):_<j.TB?(0,P.localize)(4,null,(_/j.GB).toFixed(2)):(0,P.localize)(5,null,(_/j.TB).toFixed(2))}}e.$Mk=j;function H(B){const _=typeof B=="string"||B?.scheme===$.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===$.Schemas.file?1024*j.MB:_?10*j.MB:c.$o?50*j.MB:1024*j.MB}e.$Nk=H}),define(re[118],oe([0,1,18,14,177,16]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;async function C($,p,v,f,y,m){let b;try{await P($,p,v,f,y,m)}catch(g){b=g}finally{b&&y.errorTransformer&&(b=y.errorTransformer(b)),typeof b<"u"&&v.error(b),v.end()}}e.$Sp=C;async function P($,p,v,f,y,m){d(m);const b=await $.open(p,{create:!1});try{d(m);let g=0,u=0,a=y&&typeof y.length=="number"?y.length:void 0,E=S.$fe.alloc(Math.min(y.bufferSize,typeof a=="number"?a:y.bufferSize)),h=y&&typeof y.position=="number"?y.position:0,i=0;do u=await $.read(b,h,E.buffer,i,E.byteLength-i),h+=u,i+=u,g+=u,typeof a=="number"&&(a-=u),i===E.byteLength&&(await v.write(f(E)),E=S.$fe.alloc(Math.min(y.bufferSize,typeof a=="number"?a:y.bufferSize)),i=0);while(u>0&&(typeof a!="number"||a>0)&&d(m)&&c(g,y));if(i>0){let o=i;typeof a=="number"&&(o=Math.min(i,a)),v.write(f(E.slice(0,o)))}}catch(g){throw(0,M.$sk)(g)}finally{await $.close(b)}}function d($){if($.isCancellationRequested)throw(0,A.$5)();return!0}function c($,p){if(typeof p?.limits?.size=="number"&&$>p.limits.size)throw(0,M.$rk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[66],oe([0,1,104,2,9,4,7,16]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function d(g){return g.recursive===!0}e.$Up=d;class c extends A.$Rc{static{this.a=5}constructor(u,a,E,h){super(),this.h=u,this.j=a,this.m=E,this.n=h,this.c=this.B(new A.$Sc),this.f=void 0,this.g=0}s(){const u=new A.$Qc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(a=>this.h(a))),u.add(this.b.onDidLogMessage(a=>this.j(a))),u.add(this.b.onDidError(a=>this.t(a)))}t(u){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Vp=c;class $ extends c{constructor(u,a,E){super(u,a,E,{type:"node.js",restartOnError:!1})}}e.$Wp=$;class p extends c{constructor(u,a,E){super(u,a,E,{type:"universal",restartOnError:!0})}}e.$Xp=p;function v(g){return g.map(u=>({type:u.type,resource:C.URI.revive(u.resource),cId:u.cId}))}e.$Yp=v;function f(g){const u=new b;for(const a of g)u.processEvent(a);return u.coalesce()}e.$Zp=f;function y(g,u){return typeof u=="string"&&!u.startsWith(S.$yj)&&!(0,s.$hc)(u)?{base:g,pattern:u}:u}e.$1p=y;function m(g,u){const a=[];for(const E of u)a.push((0,S.$Cj)(y(g,E)));return a}e.$2p=m;class b{constructor(){this.a=new Set,this.b=new Map}c(u){return M.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const a=this.b.get(this.c(u));let E=!1;if(a){const h=a.type,i=u.type;a.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?E=!0:h===1&&i===2?(this.b.delete(this.c(u)),this.a.delete(a)):h===2&&i===1?a.type=0:h===1&&i===0||(a.type=i)}else E=!0;E&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],a=[];return Array.from(this.a).filter(E=>E.type!==2?(u.push(E),!1):!0).sort((E,h)=>E.resource.fsPath.length-h.resource.fsPath.length).filter(E=>a.some(h=>(0,P.$yk)(E.resource.fsPath,h,!M.$k))?!1:(a.push(E.resource.fsPath),!0)).concat(u)}}}),define(re[213],oe([0,1,18,50,14,3,2,62,32,16,66]),function(Z,e,S,A,s,M,C,P,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN="localFilesystem";class p extends C.$Rc{constructor(f,y){super(),this.a=f,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Rd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Rd),this.onDidWatchError=this.g.event,this.h=(0,d.$ig)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,y){const{buffer:m}=await this.a.call("readFile",[f,y]);return m}readFileStream(f,y,m){const b=(0,P.$6d)(u=>S.$fe.concat(u.map(a=>S.$fe.wrap(a))).buffer),g=new C.$Qc;return g.add(this.a.listen("readFileStream",[f,y])(u=>{if(u instanceof S.$fe)b.write(u.buffer);else{if(u==="end")b.end();else{let a;if(u instanceof Error)a=u;else{const E=u;a=(0,c.$rk)(E.message??(0,A.$Gi)(E),E.code??c.FileSystemProviderErrorCode.Unknown)}b.error(a),b.end()}g.dispose()}})),g.add(m.onCancellationRequested(()=>{b.error((0,s.$5)()),b.end(),g.dispose()})),b}writeFile(f,y,m){return this.a.call("writeFile",[f,S.$fe.wrap(y),m])}open(f,y){return this.a.call("open",[f,y])}close(f){return this.a.call("close",[f])}async read(f,y,m,b,g){const[u,a]=await this.a.call("read",[f,y,g]);return m.set(u.buffer.slice(0,a),b),a}write(f,y,m,b,g){return this.a.call("write",[f,y,S.$fe.wrap(m),b,g])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,y){return this.a.call("delete",[f,y])}rename(f,y,m){return this.a.call("rename",[f,y,m])}copy(f,y,m){return this.a.call("copy",[f,y,m])}cloneFile(f,y){return this.a.call("cloneFile",[f,y])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const y=f;this.f.fire((0,$.$Yp)(y))}else{const y=f;this.g.fire(y)}}))}watch(f,y){const m=(0,d.$ig)();return this.a.call("watch",[this.h,m,f,y]),(0,C.$Pc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$FN=p}),define(re[214],oe([0,1,46,8,22,33,2,85,9,4,19,7,105,21,66]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class m extends C.$Rc{static{this.a=100}static{this.b=75}constructor(u,a,E,h){super(),this.m=u,this.n=a,this.r=E,this.s=h,this.c=this.B(new A.$ah({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$_g(i=>this.z(i),m.b)),this.g=(0,y.$2p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$2p)(this.m.path,this.m.includes):void 0,this.j=new s.$2d,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const a=await f.Promises.stat(u);this.B(await this.w(u,a.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let a=u.path;try{a=await f.Promises.realpath(u.path),u.path===a&&(a=await(0,v.$_p)(u.path)??u.path),u.path!==a&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${a})`)}catch{}return a}async w(u,a){if(c.$j&&(0,M.$2f)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Rc.None;const E=new s.$2d(this.j.token),h=new C.$Qc;try{const i=p.URI.file(this.m.path),o=(0,d.$mc)(u),r=(0,S.watch)(u);h.add((0,C.$Pc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${u}'`);const t=new Set;if(a)try{for(const l of await f.Promises.readdir(u))t.add(l)}catch(l){this.D(l)}const n=new Map;h.add((0,C.$Pc)(()=>{for(const[,l]of n)l.dispose();n.clear()})),r.on("error",(l,w)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${l}, ${w})`),this.dispose()}),r.on("change",(l,w)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${w}`);let D="";if(w&&(D=w.toString(),c.$j&&(D=(0,P.$ul)(D))),!(!D||l!=="change"&&l!=="rename"))if(a)if(l==="rename"){n.get(D)?.dispose();const I=setTimeout(async()=>{if(n.delete(D),D===o&&!await f.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,d.$ic)(u,D));if(E.token.isCancellationRequested)return;let R;k?t.has(D)?R=0:(R=1,t.add(D)):(t.delete(D),R=2),this.y({resource:(0,$.$zg)(i,D),type:R,cId:this.m.correlationId})},m.a);n.set(D,(0,C.$Pc)(()=>clearTimeout(I)))}else{let I;t.has(D)?I=0:(I=1,t.add(D)),this.y({resource:(0,$.$zg)(i,D),type:I,cId:this.m.correlationId})}else if(l==="rename"||D!==o){const I=setTimeout(async()=>{const k=await f.Promises.exists(u);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),h.add(await this.w(u,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);h.clear(),h.add((0,C.$Pc)(()=>clearTimeout(I)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await f.Promises.exists(u)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${i.toString()})`)}return(0,C.$Pc)(()=>{E.dispose(!0),h.dispose()})}y(u,a=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!a&&this.g.some(E=>E(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!a&&this.h&&this.h.length>0&&!this.h.some(E=>E(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const a=(0,y.$Zp)(u);if(a.length>0){if(this.s)for(const h of a)this.G(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.c.work(a)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(c.$k)return f.Promises.exists(u);try{const a=(0,d.$mc)(u);return(await f.Promises.readdir((0,d.$lc)(u))).some(h=>h===a)}catch(a){return this.G(a),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$cq=m;async function b(g,u,a,E,h=512){const i=await f.Promises.open(g,"r"),o=Buffer.allocUnsafe(h),r=new s.$2d(E);let t,n=!1;const l={path:g,excludes:[],recursive:!1},w=new m(l,D=>{(async()=>{for(const{type:I}of D)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:k}=await f.Promises.read(i,o,0,h,null);if(!k||r.token.isCancellationRequested)break;u(o.slice(0,k))}}catch(k){t=new Error(k),r.dispose(!0)}finally{n=!1}}})()});return await w.ready,a(),new Promise((D,I)=>{r.token.onCancellationRequested(async()=>{w.dispose();try{await f.Promises.close(i)}catch(k){t=new Error(k)}t?I(t):D()})})}e.$dq=b}),define(re[215],oe([0,1,3,104,2,4,214]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class P extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new S.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(c){const $=this.j(c),p=$.filter(f=>{const y=this.c.get(f.path);return y?!(0,A.$Gj)(y.request.excludes,f.excludes)||!(0,A.$Gj)(y.request.includes,f.includes):!0}),v=Array.from(this.c.values()).filter(({request:f})=>!$.find(y=>y.path===f.path&&(0,A.$Gj)(y.excludes,f.excludes)&&(0,A.$Gj)(y.includes,f.includes))).map(({request:f})=>f.path);p.length&&this.m(`Request to start watching: ${p.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const f of v)this.h(f);for(const f of p)this.g(f)}g(c){const $=new C.$cq(c,v=>this.a.fire(v),v=>this.b.fire(v),this.f),p={request:c,instance:$};this.c.set(c.path,p)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const $=this.c.get(c);$&&(this.c.delete(c),$.instance.dispose())}j(c){const $=new Map;for(const p of c){const v=M.$k?p.path:p.path.toLowerCase();let f=$.get(p.correlationId);f||(f=new Map,$.set(p.correlationId,f)),f.set(v,p)}return Array.from($.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,$]of this.c)$.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,$){return $?`[File Watcher (node.js)] ${c} (path: ${$.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$eq=P}),define(re[216],oe([0,1,66,215]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class s extends S.$Wp{constructor(C,P,d){super(C,P,d),this.s()}r(C){return C.add(new A.$eq)}}e.$fq=s}),define(re[217],oe([0,1,13,42,160,66]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class C extends M.$Xp{constructor(d,c,$){super(d,c,$),this.s()}r(d){const c=d.add(new s.$9p(S.$gg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(c.onDidProcessExit(({code:$,signal:p})=>this.t(`terminated by itself with code ${$}, signal: ${p}`))),A.ProxyChannel.toService((0,A.$Ch)(c.getChannel("watcher")))}}e.$0p=C}),define(re[92],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class S{constructor(...s){this.a=new Map;for(const[M,C]of s)this.set(M,C)}set(s,M){const C=this.a.get(s);return this.a.set(s,M),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Th=S}),define(re[218],oe([0,1,8,14,2,78,208,6,92,101]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const $=!1;class p extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class v{constructor(b=new d.$Th,g=!1,u,a=$){this.f=b,this.g=g,this.h=u,this.i=a,this.o=new Set,this.f.set(P.$Uh,this),this._globalGraph=a?u?._globalGraph??new C.$iq(E=>E):void 0}createChild(b){return new v(b,this.g,this,this.i)}invokeFunction(b,...g){const u=y.traceInvocation(this.i,b);let a=!1;try{return b({get:h=>{if(a)throw(0,A.$7)("service accessor is only valid during the invocation of its target method");const i=this.m(h,u);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...g)}finally{a=!0,u.stop()}}createInstance(b,...g){let u,a;return b instanceof M.$Sh?(u=y.traceCreation(this.i,b.ctor),a=this.j(b.ctor,b.staticArguments.concat(g),u)):(u=y.traceCreation(this.i,b),a=this.j(b,g,u)),u.stop(),a}j(b,g=[],u){const a=P._util.getServiceDependencies(b).sort((i,o)=>i.index-o.index),E=[];for(const i of a){const o=this.m(i.id,u);o||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(o)}const h=a.length>0?a[0].index:g.length;if(g.length!==h){console.trace(`[createInstance] First service dependency of ${b.name} at position ${h+1} conflicts with ${g.length} static arguments`);const i=h-g.length;i>0?g=g.concat(new Array(i)):g=g.slice(0,h)}return Reflect.construct(b,g.concat(E))}k(b,g){if(this.f.get(b)instanceof M.$Sh)this.f.set(b,g);else if(this.h)this.h.k(b,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const g=this.f.get(b);return!g&&this.h?this.h.l(b):g}m(b,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const u=this.l(b);return u instanceof M.$Sh?this.q(b,u,g.branch(b,!0)):(g.branch(b,!1),u)}q(b,g,u){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,g,u)}finally{this.o.delete(b)}}r(b,g,u){const a=new C.$iq(i=>i.id.toString());let E=0;const h=[{id:b,desc:g,_trace:u}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),E++>1e3)throw new p(a);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${b} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),r instanceof M.$Sh){const t={id:o.id,desc:r,_trace:i._trace.branch(o.id,!0)};a.insertEdge(i,t),h.push(t)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new p(a);break}for(const{data:o}of i){if(this.l(o.id)instanceof M.$Sh){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}a.removeNode(o)}}return this.l(b)}s(b,g,u=[],a,E){if(this.f.get(b)instanceof M.$Sh)return this.t(b,g,u,a,E);if(this.h)return this.h.s(b,g,u,a,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(b,g,u=[],a,E){if(a){const h=new v(void 0,this.g,this,this.i);h.c=String(b);const i=new Map,o=new S.$eh(()=>{const r=h.j(g,u,E);for(const[t,n]of i){const l=r[t];if(typeof l=="function")for(const w of n)l.apply(r,w)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let w=i.get(t);return w||(w=new c.$2c,i.set(t,w)),(I,k,R)=>{const L=w.push([I,k,R]);return(0,s.$Pc)(L)}}if(t in r)return r[t];const n=o.value;let l=n[t];return typeof l!="function"||(l=l.bind(n),r[t]=l),l},set(r,t,n){return o.value[t]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,u,E)}u(b,g){if(g&&console.warn(b),this.g)throw new Error(b)}}e.$jq=v;var f;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(f||(f={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,g){return b?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(b,g){return b?new y(1,g.name):y.c}static{this.f=0}constructor(b,g){this.type=b,this.name=g,this.g=Date.now(),this.h=[]}branch(b,g){const u=new y(3,b.toString());return this.h.push([b,g,u]),u}stop(){const b=Date.now()-this.g;y.f+=b;let g=!1;function u(E,h){const i=[],o=new Array(E+1).join("	");for(const[r,t,n]of h.h)if(t&&n){g=!0,i.push(`${o}CREATES -> ${r}`);const l=u(E+1,n);l&&i.push(l)}else i.push(`${o}uses -> ${r}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(b>2||g)&&y.all.add(a.join(`
`))}}e.$kq=y}),define(re[219],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_xb=e.IssueType=void 0;var A;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.$_xb=(0,S.$Vh)("issueService")}),define(re[5],oe([0,1,50,3,45,2,31,4,19,12,7,114,6]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,v.$Vh)("logService"),e.$ej=(0,v.$Vh)("loggerService");function f(){return new Date().toISOString()}function y(I){return(0,c.$Gf)(I)}e.$fj=y;var m;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$gj=m.Info;function b(I,k,R){switch(k){case m.Trace:I.trace(R);break;case m.Debug:I.debug(R);break;case m.Info:I.info(R);break;case m.Warning:I.warn(R);break;case m.Error:I.error(R);break;case m.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=b;function g(I,k=!1){let R="";for(let L=0;L<I.length;L++){let T=I[L];if(T instanceof Error&&(T=(0,S.$Gi)(T,k)),typeof T=="object")try{T=JSON.stringify(T)}catch{}R+=(L>0?" ":"")+T}return R}class u extends M.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new A.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==m.Off&&this.b<=k}}e.$ij=u;class a extends u{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...R){this.f(m.Trace)&&this.g(m.Trace,g([k,...R],!0))}debug(k,...R){this.f(m.Debug)&&this.g(m.Debug,g([k,...R]))}info(k,...R){this.f(m.Info)&&this.g(m.Info,g([k,...R]))}warn(k,...R){this.f(m.Warning)&&this.g(m.Warning,g([k,...R]))}error(k,...R){if(this.f(m.Error))if(k instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=k.stack,this.g(m.Error,g(L))}else this.g(m.Error,g([k,...R]))}flush(){}}e.$jj=a;class E extends u{constructor(k=e.$gj){super(),this.setLevel(k),this.g=!P.$i}trace(k,...R){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...R):console.log(`[main ${f()}]`,k,...R))}debug(k,...R){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...R):console.log(`[main ${f()}]`,k,...R))}info(k,...R){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...R):console.log(`[main ${f()}]`,k,...R))}warn(k,...R){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,k,...R):console.warn(`[main ${f()}]`,k,...R))}error(k,...R){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,k,...R):console.error(`[main ${f()}]`,k,...R))}dispose(){}flush(){}}e.$kj=E;class h extends u{constructor(k=e.$gj,R=!0){super(),this.g=R,this.setLevel(k)}trace(k,...R){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...R):console.log(k,...R))}debug(k,...R){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...R):console.log(k,...R))}info(k,...R){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...R):console.log(k,...R))}warn(k,...R){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...R):console.log(k,...R))}error(k,...R){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...R):console.error(k,...R))}dispose(){}flush(){}}e.$lj=h;class i extends u{constructor(k,R=e.$gj){super(),this.g=k,this.setLevel(R)}trace(k,...R){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(k),...R])}debug(k,...R){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(k),...R])}info(k,...R){this.f(m.Info)&&this.g.log(m.Info,[this.h(k),...R])}warn(k,...R){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(k),...R])}error(k,...R){this.f(m.Error)&&this.g.log(m.Error,[this.h(k),...R])}h(k){return typeof k=="string"?k:(0,S.$Gi)(k,this.f(m.Trace))}dispose(){}flush(){}}e.$mj=i;class o extends u{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const R of this.g)R.setLevel(k);super.setLevel(k)}trace(k,...R){for(const L of this.g)L.trace(k,...R)}debug(k,...R){for(const L of this.g)L.debug(k,...R)}info(k,...R){for(const L of this.g)L.info(k,...R)}warn(k,...R){for(const L of this.g)L.warn(k,...R)}error(k,...R){for(const L of this.g)L.error(k,...R)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$nj=o;class r extends M.$Rc{constructor(k,R,L){if(super(),this.h=k,this.j=R,this.b=new C.$zc,this.c=this.B(new A.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Rd),this.onDidChangeVisibility=this.g.event,L)for(const T of L)this.b.set(T.resource,{logger:void 0,info:T})}m(k){return(0,c.$Cf)(k)?[...this.b.values()].find(R=>R.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,R){const L=this.n(k),T=(0,c.$Cf)(k)?k:R?.id??(0,s.$Ji)(L.toString()).toString(16);let N=this.b.get(L)?.logger;const K=R?.logLevel==="always"?m.Trace:R?.logLevel;N||(N=this.s(L,K??this.getLogLevel(L)??this.h,{...R,id:T}));const Q={logger:N,info:{resource:L,id:T,logLevel:K,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(Q.info),this.b.set(L,Q),N}n(k){return(0,c.$Cf)(k)?(0,d.$zg)(this.j,`${k}.log`):k}setLogLevel(k,R){if($.URI.isUri(k)){const L=k,T=R,N=this.b.get(L);N&&T!==N.info.logLevel&&(N.info.logLevel=T===this.h?void 0:T,N.logger?.setLevel(T),this.b.set(N.info.resource,N),this.f.fire([L,T]))}else{this.h=k;for(const[L,T]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,R){const L=this.m(k);L&&R!==!L.info.hidden&&(L.info.hidden=!R,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,R]))}getLogLevel(k){let R;return k&&(R=this.b.get(k)?.info.logLevel),R??this.h}registerLogger(k){const R=this.b.get(k.resource);R?R.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const R=this.b.get(k);R&&(R.logger&&R.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=r;class t{constructor(){this.onDidChangeLogLevel=new A.$Rd().event}setLevel(k){}getLevel(){return m.Info}trace(k,...R){}debug(k,...R){}info(k,...R){}warn(k,...R){}error(k,...R){}critical(k,...R){}dispose(){}flush(){}}e.$pj=t;class n extends t{}e.$qj=n;function l(I){if(I.verbose)return m.Trace;if(typeof I.logLevel=="string"){const k=D(I.logLevel.toLowerCase());if(k!==void 0)return k}return e.$gj}e.$rj=l;function w(I){switch(I){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$sj=w;function D(I){switch(I){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$tj=D,e.$uj=new p.$aj("logLevel",w(m.Info))});var te=this&&this.__param||function(Z,e){return function(S,A){e(S,A,Z)}};define(re[220],oe([0,1,15,4,5]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V8b=void 0;const M=S.safeStorage;let C=class{constructor(d){this.a=d,S.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(d){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(M.encryptString(d));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(d){let c;try{if(c=JSON.parse(d),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${d}`);const $=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const p=M.decryptString($);return this.a.trace("[EncryptionMainService] Decrypted value."),p}catch($){throw this.a.error($),$}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(A.$i)return Promise.resolve("dpapi");if(A.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const d=M.getSelectedStorageBackend();return Promise.resolve(d)}catch(d){this.a.error(d)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$V8b=C,e.$V8b=C=ve([te(0,s.$dj)],C)}),define(re[221],oe([0,1,23,8,14,3,2,9,66,5]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class $ extends C.$Rc{constructor(v,f){super(),this.a=v,this.b=f,this.c=this.B(new M.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Vg(0)),this.w=[],this.y=this.B(new A.$Vg(0))}watch(v,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(v,f):this.z(v,f)}n(v,f){const y={path:this.H(v),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},m=(0,S.$Tb)(this.j,y);return this.r(),(0,C.$Pc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,s.$Z)(v))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,d.$Yp)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const f of this.j)(0,d.$Up)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const f of this.j)(0,d.$Up)(f)&&v.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,f){const y={path:this.H(v),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},m=(0,S.$Tb)(this.w,y);return this.C(),(0,C.$Pc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,s.$Z)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,d.$Yp)(v)),v=>this.G(v),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,P.$gc)(v.fsPath)}}e.$3p=$}),define(re[222],oe([0,1,23,8,18,22,3,45,71,2,57,13,67,19,62,175,16,118,5,14]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;let h=class extends c.$Rc{static{E=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new C.$Rd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Rd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Rd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Rd),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Rd),this.Y=this.B(new C.$Rd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$Rd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$7g)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${o}`);const t=new c.$Qc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),t.add(r.onDidChangeFile(n=>{const l=new b.$xk(n,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,c.$Mc)(t)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(t){r.push(t)}}),!this.h.has(o)&&await A.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const t=this.h.get(o.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return d.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,f.$Dg)(o))throw new b.$zk((0,m.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const t=new a.$ab;throw t.message=(0,m.localize)(1,null,o.toString()),t}return r}async m(o){const r=await this.j(o);if((0,b.$kk)(r)||(0,b.$hk)(r)||(0,b.$lk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,b.$kk)(r)||(0,b.$hk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(t){throw(0,b.$uk)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$zk((0,m.localize)(2,null,this.sb(o)),1):(0,b.$sk)(t)}}async s(o,r){const t=await this.j(o),n=this.S(t),l=r?.resolveTo,w=r?.resolveSingleChildDescendants,D=r?.resolveMetadata,I=await t.stat(o);let k;return this.t(t,o,I,void 0,!!D,(R,L)=>(k||(k=$.$2h.forUris(()=>!n),k.set(o,!0),l&&k.fill(!0,l)),k.get(R.resource)||k.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&w?L===1:!1))}async t(o,r,t,n,l,w){const{providerExtUri:D}=this.R(o),I={resource:r,name:D.basename(r),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Kk)({mtime:t.mtime,size:t.size}),children:void 0};if(I.isDirectory&&w(I,n)){try{const k=await o.readdir(r),R=await A.Promises.settled(k.map(async([L,T])=>{try{const N=D.joinPath(r,L),K=l?await o.stat(N):{type:T};return await this.t(o,N,K,k.length,l,w)}catch(N){return this.b.trace(N),null}}));I.children=(0,S.$Gb)(R)}catch(k){this.b.trace(k),I.children=[]}return I}return I}async resolveAll(o){return A.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),t=await r.stat(o);return this.t(r,o,t,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(t){return t}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new b.$zk((0,m.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$fe.fromString(""),t){await this.u(o,t);const n=await this.writeFile(o,r);return this.r.fire(new b.$wk(o,0,n)),n}async writeFile(o,r,t){const n=this.qb(await this.n(o),o),{providerExtUri:l}=this.R(n);let w=t;if((0,b.$nk)(n)&&!w?.atomic){const D=n.enforceAtomicWriteFile?.(o);D&&(w={...t,atomic:D})}try{await this.w(n,o,w)||await this.U(n,l.dirname(o));let I;if((0,b.$hk)(n)&&!(r instanceof s.$fe))if((0,y.$4d)(r)){const k=await(0,y.$$d)(r,3);k.ended?I=s.$fe.concat(k.buffer):I=k}else I=(0,y.$8d)(r,k=>s.$fe.concat(k),3);else I=r;!(0,b.$kk)(n)||(0,b.$hk)(n)&&I instanceof s.$fe||(0,b.$hk)(n)&&(0,b.$nk)(n)&&w?.atomic?await this.hb(n,o,w,I):await this.db(n,o,w,I instanceof s.$fe?(0,s.$qe)(I):I),this.r.fire(new b.$wk(o,4))}catch(D){throw new b.$zk((0,m.localize)(4,null,this.sb(o),(0,b.$sk)(D).toString()),(0,b.$vk)(D),w)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,t){const n=!!t?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(o.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(r)));if(n)throw new Error((0,m.localize)(8,null,this.sb(r)))}let w;try{w=await o.stat(r)}catch{return}if(w.type&b.FileType.Directory)throw new b.$zk((0,m.localize)(9,null,this.sb(r)),0,t);if(this.rb(r,w),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Jk&&typeof w.mtime=="number"&&typeof w.size=="number"&&t.mtime<w.mtime&&t.etag!==(0,b.$Kk)({mtime:t.mtime,size:w.size}))throw new b.$zk((0,m.localize)(10,null),3,t);return w}async readFile(o,r,t){const n=await this.m(o);return r?.atomic?this.z(n,o,r,t):this.C(n,o,r,t)}async z(o,r,t,n){return new Promise((l,w)=>{this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{try{const D=await this.C(o,r,t,n);l(D)}catch(D){w(D)}})})}async C(o,r,t,n){const l=await this.D(o,r,{...t,preferUnbuffered:!0},n);return{...l,value:await(0,s.$re)(l.value)}}async readFileStream(o,r,t){const n=await this.m(o);return this.D(n,o,r,t)}async D(o,r,t,n){const l=new M.$2d(n);let w=t;(0,b.$mk)(o)&&o.enforceAtomicReadFile?.(r)&&(w={...t,atomic:!0});const D=this.J(r,w).then(k=>k,k=>{throw l.dispose(!0),k});let I;try{return typeof w?.etag=="string"&&w.etag!==b.$Jk&&await D,w?.atomic&&(0,b.$mk)(o)||!((0,b.$kk)(o)||(0,b.$lk)(o))||(0,b.$hk)(o)&&w?.preferUnbuffered?I=this.I(o,r,w):(0,b.$lk)(o)?I=this.G(o,r,l.token,w):I=this.H(o,r,l.token,w),I.on("end",()=>l.dispose()),I.on("error",()=>l.dispose()),{...await D,value:I}}catch(k){throw I&&await(0,y.$9d)(I),this.F(k,r,w)}}F(o,r,t){const n=(0,m.localize)(11,null,this.sb(r),(0,b.$sk)(o).toString());return o instanceof b.$Bk?new b.$Bk(n,o.stat,t):o instanceof b.$Ak?new b.$Ak(n,o.fileOperationResult,o.size,o.options):new b.$zk(n,(0,b.$vk)(o),t)}G(o,r,t,n=Object.create(null)){const l=o.readFileStream(r,n,t);return(0,y.$ce)(l,{data:w=>w instanceof s.$fe?w:s.$fe.wrap(w),error:w=>this.F(w,r,n)},w=>s.$fe.concat(w))}H(o,r,t,n=Object.create(null)){const l=(0,s.$ve)();return(0,g.$Sp)(o,r,l,w=>w,{...n,bufferSize:this.a,errorTransformer:w=>this.F(w,r,n)},t),l}I(o,r,t){const n=(0,y.$6d)(l=>s.$fe.concat(l));return(async()=>{try{let l;t?.atomic&&(0,b.$mk)(o)?l=await o.readFile(r,{atomic:!0}):l=await o.readFile(r),typeof t?.position=="number"&&(l=l.slice(t.position)),typeof t?.length=="number"&&(l=l.slice(0,t.length)),this.L(r,l.byteLength,t),n.end(s.$fe.wrap(l))}catch(l){n.error(l),n.end()}})(),n}async J(o,r){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new b.$zk((0,m.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==b.$Jk&&r.etag===t.etag)throw new b.$Bk((0,m.localize)(13,null),t,r);return this.L(o,t.size,r),t}L(o,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new b.$Ak((0,m.localize)(14,null,this.sb(o)),7,r,t)}async canMove(o,r,t){return this.M(o,r,"move",t)}async canCopy(o,r,t){return this.M(o,r,"copy",t)}async M(o,r,t,n){if(o.toString()!==r.toString())try{const l=t==="move"?this.qb(await this.n(o),o):await this.m(o),w=this.qb(await this.n(r),r);await this.Q(l,o,w,r,t,n)}catch(l){return l}return!0}async move(o,r,t){const n=this.qb(await this.n(o),o),l=this.qb(await this.n(r),r),w=await this.N(n,o,l,r,"move",!!t),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$wk(o,w==="move"?2:3,D)),D}async copy(o,r,t){const n=await this.m(o),l=this.qb(await this.n(r),r),w=await this.N(n,o,l,r,"copy",!!t),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$wk(o,w==="copy"?3:2,D)),D}async N(o,r,t,n,l,w){if(r.toString()===n.toString())return l;const{exists:D,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,t,n,l,w);if(D&&!I&&w&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),l==="copy"){if(o===t&&(0,b.$ik)(o))await o.copy(r,n,{overwrite:w});else{const k=await this.resolve(r);k.isDirectory?await this.P(o,k,t,n):await this.O(o,r,t,n)}return l}else return o===t?(await o.rename(r,n,{overwrite:w}),l):(await this.N(o,r,t,n,"copy",w),await this.del(r,{recursive:!0}),"copy")}async O(o,r,t,n){if((0,b.$kk)(o)&&(0,b.$kk)(t))return this.jb(o,r,t,n);if((0,b.$kk)(o)&&(0,b.$hk)(t))return this.pb(o,r,t,n);if((0,b.$hk)(o)&&(0,b.$kk)(t))return this.nb(o,r,t,n);if((0,b.$hk)(o)&&(0,b.$hk)(t))return this.lb(o,r,t,n)}async P(o,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await A.Promises.settled(r.children.map(async l=>{const w=this.R(t).providerExtUri.joinPath(n,l.name);return l.isDirectory?this.P(o,await this.resolve(l.resource),t,w):this.O(o,l.resource,t,w)}))}async Q(o,r,t,n,l,w){let D=!1;if(o===t){const{providerExtUri:k,isPathCaseSensitive:R}=this.R(o);if(R||(D=k.isEqual(r,n)),D&&l==="copy")throw new Error((0,m.localize)(15,null,this.sb(r),this.sb(n)));if(!D&&k.isEqualOrParent(n,r))throw new Error((0,m.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!D){if(!w)throw new b.$zk((0,m.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===t){const{providerExtUri:k}=this.R(o);if(k.isEqualOrParent(r,n))throw new Error((0,m.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:D}}R(o){const r=this.S(o);return{providerExtUri:r?f.$pg:f.$rg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const t=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new b.$wk(o,0,t)),t}async U(o,r){const t=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&b.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(r)));break}catch(l){if((0,b.$uk)(l)!==b.FileSystemProviderErrorCode.FileNotFound)throw l;t.push(n.basename(r)),r=n.dirname(r)}for(let l=t.length-1;l>=0;l--){r=n.joinPath(r,t[l]);try{await o.mkdir(r)}catch(w){if((0,b.$uk)(w)!==b.FileSystemProviderErrorCode.FileExists)throw w}}}async canDelete(o,r){try{await this.W(o,r)}catch(t){return t}return!0}async W(o,r){const t=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(o)));const l=r?.atomic;if(l&&!(t.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(o)));if(n&&l)throw new Error((0,m.localize)(22,null,this.sb(o)));let w;try{w=await t.stat(o)}catch{}if(w)this.rb(o,w);else throw new b.$zk((0,m.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(o)))}return t}async del(o,r){const t=await this.W(o,r);let n=r;if((0,b.$ok)(t)&&!n?.atomic){const I=t.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const l=!!n?.useTrash,w=!!n?.recursive,D=n?.atomic??!1;await t.delete(o,{recursive:w,useTrash:l,atomic:D}),this.r.fire(new b.$wk(o,1))}async cloneFile(o,r){const t=await this.j(o),n=this.qb(await this.n(r),r);if(t===n&&this.R(t).providerExtUri.isEqual(o,r))return;if(t===n&&(0,b.$jk)(t))return t.cloneFile(o,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const l=this.cb.queueFor(o,this.R(t).providerExtUri);return t===n&&(0,b.$ik)(t)?l.queue(()=>t.copy(o,r,{overwrite:!0})):l.queue(()=>this.O(t,o,n,r))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:E.ab++})}watch(o,r={recursive:!1,excludes:[]}){const t=new c.$Qc;let n=!1,l=()=>{n=!0};t.add((0,c.$Pc)(()=>l())),(async()=>{try{const D=await this.bb(o,r);n?(0,c.$Mc)(D):l=()=>(0,c.$Mc)(D)}catch(D){this.b.error(D)}})();const w=r.correlationId;if(typeof w=="number"){const D=t.add(new C.$Rd);return t.add(this.X.event(k=>{k.correlates(w)&&D.fire(k)})),{onDidChange:D.event,dispose:()=>t.dispose()}}return t}async bb(o,r){const t=await this.j(o),n=(0,P.$Ji)([this.R(t).providerExtUri.getComparisonKey(o),r]);let l=this.$.get(n);return l||(l={count:0,disposable:t.watch(o,r)},this.$.set(n,l)),l.count+=1,(0,c.$Pc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Mc)(l.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Mc)(o.disposable);this.$.clear()}async db(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{const l=await o.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,y.$4d)(n)||(0,y.$5d)(n)?await this.eb(o,l,n):await this.fb(o,l,n)}catch(w){throw(0,b.$sk)(w)}finally{await o.close(l)}})}async eb(o,r,t){let n=0,l;if((0,y.$5d)(t)){if(t.buffer.length>0){const w=s.$fe.concat(t.buffer);await this.gb(o,r,w,w.byteLength,n,0),n+=w.byteLength}if(t.ended)return;l=t.stream}else l=t;return new Promise((w,D)=>{(0,y.$0d)(l,{onData:async I=>{l.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(k){return D(k)}n+=I.byteLength,setTimeout(()=>l.resume())},onError:I=>D(I),onEnd:()=>w()})})}async fb(o,r,t){let n=0,l;for(;(l=t.read())!==null;)await this.gb(o,r,l,l.byteLength,n,0),n+=l.byteLength}async gb(o,r,t,n,l,w){let D=0;for(;D<n;){const I=await o.write(r,l+D,t.buffer,w+D,n-D);D+=I}}async hb(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(()=>this.ib(o,r,t,n))}async ib(o,r,t,n){let l;n instanceof s.$fe?l=n:(0,y.$4d)(n)?l=await(0,s.$re)(n):(0,y.$5d)(n)?l=await(0,s.$se)(n):l=(0,s.$pe)(n),await o.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(o,r,t,n))}async kb(o,r,t,n){let l,w;try{l=await o.open(r,{create:!1}),w=await t.open(n,{create:!0,unlock:!1});const D=s.$fe.alloc(this.a);let I=0,k=0,R=0;do R=await o.read(l,I,D.buffer,k,D.byteLength-k),await this.gb(t,w,D,R,I,k),I+=R,k+=R,k===D.byteLength&&(k=0);while(R>0)}catch(D){throw(0,b.$sk)(D)}finally{await A.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof w=="number"?t.close(w):Promise.resolve()])}}async lb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(o,r,t,n))}async mb(o,r,t,n){return t.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(o,r,t,n))}async ob(o,r,t,n){const l=await t.open(n,{create:!0,unlock:!1});try{const w=await o.readFile(r);await this.gb(t,l,s.$fe.wrap(w),w.byteLength,0,0)}catch(w){throw(0,b.$sk)(w)}finally{await t.close(l)}}async pb(o,r,t,n){const l=await(0,s.$re)(this.H(o,r,M.CancellationToken.None));await this.hb(t,n,void 0,l)}qb(o,r){if(o.capabilities&2048)throw new b.$zk((0,m.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$zk((0,m.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===p.Schemas.file?o.fsPath:o.toString(!0)}};e.$Tp=h,e.$Tp=h=E=ve([te(0,u.$dj)],h)}),define(re[93],oe([0,1,46,312,8,31,18,3,33,2,9,4,19,62,21,179,16,118,221,50,217,216]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0,(()=>{try{(0,A.gracefulify)(S)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.$Gi)(o)}`)}})();class i extends u.$3p{static{this.I=!1}constructor(r,t){super(r,t),this.onDidChangeCapabilities=P.Event.None,this.N=new M.$zc(n=>v.$qg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,p.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:t,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:b.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const t=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async l=>{try{let w;l.isSymbolicLink()?w=(await this.stat((0,v.$zg)(r,l.name))).type:w=this.M(l),n.push([l.name,w])}catch(w){this.a.trace(w)}})),n}catch(t){throw this.fb(t)}}M(r,t){let n;return t?.dangling?n=b.FileType.Unknown:r.isFile()?n=b.FileType.File:r.isDirectory()?n=b.FileType.Directory:n=b.FileType.Unknown,t&&(n|=b.FileType.SymbolicLink),n}async O(r){const t=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const l=new s.$Wg;return this.N.set(r,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(r)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),l.open()})}async readFile(r,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const l=this.H(r);return await y.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{n?.dispose()}}P(r){i.I&&this.a.trace(r)}readFileStream(r,t,n){const l=(0,f.$6d)(w=>C.$fe.concat(w.map(D=>C.$fe.wrap(D))).buffer);return(0,g.$Sp)(this,r,l,w=>w.buffer,{...t,bufferSize:256*1024},n),l}async writeFile(r,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,v.$zg)((0,v.$yg)(r),`${(0,v.$wg)(r)}${n.atomic.postfix}`),t,n):this.S(r,t,n)}async Q(r){try{const t=this.H(r),{symbolicLink:n}=await y.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(r,t,n,l){const w=new c.$Qc;try{w.add(await this.O(r)),w.add(await this.O(t)),await this.S(t,n,l,!0);try{await this.rename(t,r,{overwrite:!0})}catch(D){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{w.dispose()}}async S(r,t,n,l){let w;try{const D=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(D)){if(!n.overwrite)throw(0,b.$rk)((0,m.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,b.$rk)((0,m.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:n.unlock},l),await this.write(w,0,t,0,t.byteLength)}catch(D){throw await this.gb(r,D)}finally{typeof w=="number"&&await this.close(w)}}static{this.Y=!0}static configureFlushOnWrite(r){i.Y=r}async open(r,t,n){const l=this.H(r);let w;(0,b.$fk)(t)&&!n&&(w=await this.O(r));let D;try{if((0,b.$fk)(t)&&t.unlock)try{const{stat:k}=await y.SymlinkSupport.stat(l);k.mode&128||await y.Promises.chmod(l,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let I;if((0,b.$fk)(t)){if(p.$i)try{await y.Promises.truncate(l,0),I="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}I||(I="w")}else I="r";D=await y.Promises.open(l,I)}catch(I){throw w?.dispose(),(0,b.$fk)(t)?await this.gb(r,I):this.fb(I)}if(this.U.set(D,0),(0,b.$fk)(t)&&this.X.set(D,r),w){const I=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${l})`),this.W.set(D,w),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${l})`),I.dispose())}return D}async close(r){const t=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&i.Y)try{await y.Promises.fdatasync(r)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(r)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),t.dispose())}}async read(r,t,n,l,w){const D=this.Z(r,t);let I=null;try{I=(await y.Promises.read(r,n,l,w,D)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(r,D,I)}return I}Z(r,t){return t===this.U.get(r)?null:t}$(r,t,n){const l=this.U.get(r);typeof l=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(r,l+n):this.U.delete(r)))}async write(r,t,n,l,w){return(0,s.$fh)(()=>this.ab(r,t,n,l,w),100,3)}async ab(r,t,n,l,w){const D=this.Z(r,t);let I=null;try{I=(await y.Promises.write(r,n,l,w,D)).bytesWritten}catch(k){throw await this.gb(this.X.get(r),k)}finally{this.$(r,D,I)}return I}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(t){throw this.fb(t)}}async delete(r,t){try{const n=this.H(r);if(t.recursive){let l;t?.atomic!==!1&&t.atomic.postfix&&(l=(0,$.$ic)((0,$.$lc)(n),`${(0,$.$mc)(n)}${t.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,l)}else try{await y.Promises.unlink(n)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let w=!1;try{const{stat:D,symbolicLink:I}=await y.SymlinkSupport.stat(n);w=D.isDirectory()&&!I}catch{}if(w)await y.Promises.rmdir(n);else throw l}else throw l}}catch(n){throw this.fb(n)}}async rename(r,t,n){const l=this.H(r),w=this.H(t);if(l!==w)try{await this.bb(r,t,"move",n.overwrite),await y.Promises.rename(l,w)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,m.localize)(2,null,(0,$.$mc)(l),(0,$.$mc)((0,$.$lc)(w)),D.toString()))),this.fb(D)}}async copy(r,t,n){const l=this.H(r),w=this.H(t);if(l!==w)try{await this.bb(r,t,"copy",n.overwrite),await y.Promises.copy(l,w,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,m.localize)(3,null,(0,$.$mc)(l),(0,$.$mc)((0,$.$lc)(w)),D.toString()))),this.fb(D)}}async bb(r,t,n,l){const w=this.H(r),D=this.H(t);let I=!1;if(!!(this.capabilities&1024)||(I=(0,d.$1f)(w,D,!0)),I){if(n==="copy")throw(0,b.$rk)((0,m.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.L(r);if(!R)throw(0,b.$rk)((0,m.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(t);if(L){if(!l)throw(0,b.$rk)((0,m.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);R.type&b.FileType.File&&L.type&b.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,t){return this.cb(r,t,!1)}async cb(r,t,n){const l=this.H(r),w=this.H(t),D=!!(this.capabilities&1024);if((0,d.$1f)(l,w,!D))return;const I=new c.$Qc;try{I.add(await this.O(r)),I.add(await this.O(t)),n&&await y.Promises.mkdir((0,$.$lc)(w),{recursive:!0}),await y.Promises.copyFile(l,w)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(r,t,!0);throw this.fb(k)}finally{I.dispose()}}t(r,t,n){return new E.$0p(l=>r(l),l=>t(l),n)}F(r,t,n){return new h.$fq(l=>r(l),l=>t(l),n)}fb(r){if(r instanceof b.$qk)return r;let t=r,n;switch(r.code){case"ENOENT":n=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=b.FileSystemProviderErrorCode.Unknown;break;default:n=b.FileSystemProviderErrorCode.Unknown}return(0,b.$rk)(t,n)}async gb(r,t){let n=this.fb(t);if(r&&n.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await y.SymlinkSupport.stat(this.H(r));l.mode&128||(n=(0,b.$rk)(t,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return n}}e.$gq=i}),define(re[223],oe([0,1,3,93,2,18,62,22]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=void 0;class d extends s.$Rc{constructor(p,v){super(),this.a=p,this.b=v,this.F=new Map,this.G=new Map}call(p,v,f){const y=this.c(p);switch(v){case"stat":return this.g(y,f[0]);case"readdir":return this.h(y,f[0]);case"open":return this.r(y,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(y,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(y,f[0],f[1],f[2]);case"rename":return this.z(y,f[0],f[1],f[2]);case"copy":return this.C(y,f[0],f[1],f[2]);case"cloneFile":return this.D(y,f[0],f[1]);case"mkdir":return this.w(y,f[0]);case"delete":return this.y(y,f[0],f[1]);case"watch":return this.I(y,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${v} not found`)}listen(p,v,f){const y=this.c(p);switch(v){case"fileChange":return this.H(y,f[0]);case"readFileStream":return this.m(y,f[0],f[1])}throw new Error(`Unknown event ${v}`)}g(p,v){const f=this.f(p,v,!0);return this.a.stat(f)}h(p,v){const f=this.f(p,v);return this.a.readdir(f)}async j(p,v,f){const y=this.f(p,v,!0),m=await this.a.readFile(y,f);return M.$fe.wrap(m)}m(p,v,f){const y=this.f(p,v,!0),m=new P.$2d,b=new S.$Rd({onDidRemoveLastListener:()=>{m.cancel()}}),g=this.a.readFileStream(y,f,m.token);return(0,C.$0d)(g,{onData:u=>b.fire(M.$fe.wrap(u)),onError:u=>b.fire(u),onEnd:()=>{b.fire("end"),b.dispose(),m.dispose()}}),b.event}n(p,v,f,y){const m=this.f(p,v);return this.a.writeFile(m,f.buffer,y)}r(p,v,f){const y=this.f(p,v,!0);return this.a.open(y,f)}s(p){return this.a.close(p)}async t(p,v,f){const y=M.$fe.alloc(f),m=0,b=await this.a.read(p,v,y.buffer,m,f);return[y,b]}u(p,v,f,y,m){return this.a.write(p,v,f.buffer,y,m)}w(p,v){const f=this.f(p,v);return this.a.mkdir(f)}y(p,v,f){const y=this.f(p,v);return this.a.delete(y,f)}z(p,v,f,y){const m=this.f(p,v),b=this.f(p,f);return this.a.rename(m,b,y)}C(p,v,f,y){const m=this.f(p,v),b=this.f(p,f);return this.a.copy(m,b,y)}D(p,v,f){const y=this.f(p,v),m=this.f(p,f);return this.a.cloneFile(y,m)}H(p,v){const f=new S.$Rd({onWillAddFirstListener:()=>{this.F.set(v,this.L(p,f))},onDidRemoveLastListener:()=>{(0,s.$Mc)(this.F.get(v)),this.F.delete(v)}});return f.event}async I(p,v,f,y,m){const b=this.F.get(v);if(b){const g=this.f(p,y),u=b.watch(f,g,m);this.G.set(v+f,u)}}async J(p,v){const f=p+v,y=this.G.get(f);y&&((0,s.$Mc)(y),this.G.delete(f))}dispose(){super.dispose();for(const[,p]of this.G)p.dispose();this.G.clear();for(const[,p]of this.F)p.dispose();this.F.clear()}}e.$Or=d;class c extends s.$Rc{constructor(p,v,f,y){super(),this.c=p,this.f=f,this.g=y,this.a=new Map,this.b=this.B(new A.$gq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(p){const v=this.B(new S.$Rd);this.B(v.event(f=>{p.fire(f.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type,cId:y.cId})))})),this.B(this.b.onDidChangeFile(f=>v.fire(f))),this.B(this.b.onDidWatchError(f=>p.fire(f)))}j(p){}m(p){}watch(p,v,f){const y=this.m(this.g);return Array.isArray(y)&&(f.excludes=[...f.excludes,...y]),this.a.set(p,this.b.watch(v,f)),(0,s.$Pc)(()=>{(0,s.$Mc)(this.a.get(p)),this.a.delete(p)})}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),super.dispose()}}e.$Pr=c}),define(re[224],oe([0,1,15,178,4,7,16,9,223,155]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=void 0;class $ extends d.$Or{constructor(f,y,m){super(f,y),this.M=m}c(f){return c.$Sm}f(f,y){return M.URI.revive(y)}async y(f,y,m){if(!m.useTrash)return super.y(f,y,m);const b=this.f(f,y),g=(0,P.$gc)(b.fsPath);try{await S.shell.trashItem(g)}catch{throw(0,C.$rk)(s.$i?(0,A.localize)(0,null,(0,P.$mc)(g)):(0,A.localize)(1,null,(0,P.$mc)(g)),C.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new p(f,y,this.b,this.M)}}e.$48b=$;class p extends d.$Pr{watch(f,y,m){if(m.recursive)throw(0,C.$rk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,m)}}}),define(re[225],oe([0,1,5]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P5b=void 0;class A extends S.$jj{constructor(M=S.$gj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(M){this.n=M;for(const{level:C,message:P}of this.m)(0,S.log)(M,C,P);this.m=[]}g(M,C){this.n?(0,S.log)(this.n,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$P5b=A}),define(re[226],oe([0,1,7,3,5,2]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=void 0;class C extends s.$oj{constructor(p,v,f,y,m){super(v,f,y),this.r=p,this.t=m,this.B(m.listen("onDidChangeLogLevel",p)(b=>{(0,s.$fj)(b)?super.setLogLevel(b):super.setLogLevel(S.URI.revive(b[0]),b[1])})),this.B(m.listen("onDidChangeVisibility",p)(([b,g])=>super.setVisibility(S.URI.revive(b),g))),this.B(m.listen("onDidChangeLoggers",p)(({added:b,removed:g})=>{for(const u of b)super.registerLogger({...u,resource:S.URI.revive(u.resource)});for(const u of g)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new s.$mj({log:(p,v)=>{this.t.call("consoleLog",[p,v])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,v){super.setLogLevel(p,v),this.t.call("setLogLevel",[p,v])}setVisibility(p,v){super.setVisibility(p,v),this.t.call("setVisibility",[this.n(p),v])}s(p,v,f){return new P(this.t,p,v,f,this.r)}static setLogLevel(p,v,f){return p.call("setLogLevel",[v,f])}}e.$er=C;class P extends s.$jj{constructor(p,v,f,y,m){super(y?.logLevel==="always"),this.r=p,this.s=v,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[v,y,m]).then(()=>{this.u(this.n),this.m=!0})}g(p,v){const f=[[p,v]];this.m?this.u(f):this.n.push(...f)}u(p){this.r.call("log",[this.s,p])}}class d{constructor(p,v){this.a=p,this.b=v}listen(p,v){const f=this.b(p);switch(v){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(m=>this.c(m,f)),removed:[...y.removed].map(m=>this.c(m,f))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,y=>[f.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$fj)(y)?y:[f.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${v}`)}async call(p,v,f){const y=this.b(p);switch(v){case"setLogLevel":return(0,s.$fj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(S.URI.revive(y.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,y)))}throw new Error(`Call not found: ${v}`)}c(p,v){return{...p,resource:v.transformOutgoingURI(p.resource)}}}e.$fr=d;class c extends M.$Rc{constructor(p,v){super(),v.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(f=>v.call("setLogLevel",[f]))),v.call("getRegisteredLoggers").then(f=>{for(const y of f)p.registerLogger({...y,resource:S.URI.revive(y.resource)})}),this.B(v.listen("onDidChangeVisibility")(([f,y])=>p.setVisibility(S.URI.revive(f),y))),this.B(v.listen("onDidChangeLoggers")(({added:f,removed:y})=>{for(const m of f)p.registerLogger({...m,resource:S.URI.revive(m.resource)});for(const m of y)p.deregisterLogger(m.resource)}))}}e.$gr=c}),define(re[227],oe([0,1,2,5]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=void 0;class s extends S.$Rc{constructor(C,P=[]){super(),this.a=new A.$nj([C,...P]),this.B(C.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.$WN=s}),define(re[228],oe([0,1,31,7,5]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9b=void 0;class M{constructor(P){this.b=P,this.a=new S.$zc}listen(P,d,c){switch(d){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(P,d,c){switch(d){case"createLogger":this.c(A.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(A.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,s.$fj)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(A.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:A.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(c[0]))}throw new Error(`Call not found: ${d}`)}c(P,d,c){this.a.set(P,this.b.createLogger(P,d,c))}d(P,d){let c=console.log;switch(P){case s.LogLevel.Error:c=console.error;break;case s.LogLevel.Warning:c=console.warn;break;case s.LogLevel.Info:c=console.info;break}c.call(console,...d)}e(P,d){const c=this.a.get(P);if(!c)throw new Error("Create the logger before logging");for(const[$,p]of d)(0,s.log)(c,$,p)}}e.$X9b=M}),define(re[229],oe([0,1,16,5]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=void 0;var s;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(s||(s={}));async function M(c,$,p,v,f){try{const y=await new Promise((b,g)=>{Z(["@vscode/spdlog"],b,g)});y.setFlushOn(s.Trace);const m=await y.createAsyncRotatingLogger(c,$,p,v);return f?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(y){console.error(y)}return null}function C(c,$,p){switch($){case A.LogLevel.Trace:c.trace(p);break;case A.LogLevel.Debug:c.debug(p);break;case A.LogLevel.Info:c.info(p);break;case A.LogLevel.Warning:c.warn(p);break;case A.LogLevel.Error:c.error(p);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${$}`)}}function P(c,$){switch($){case A.LogLevel.Trace:c.setLevel(s.Trace);break;case A.LogLevel.Debug:c.setLevel(s.Debug);break;case A.LogLevel.Info:c.setLevel(s.Info);break;case A.LogLevel.Warning:c.setLevel(s.Warning);break;case A.LogLevel.Error:c.setLevel(s.Error);break;case A.LogLevel.Off:c.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${$}`)}}class d extends A.$jj{constructor($,p,v,f,y){super(),this.m=[],this.setLevel(y),this.n=this.s($,p,v,f),this.B(this.onDidChangeLogLevel(m=>{this.r&&P(this.r,m)}))}async s($,p,v,f){const y=v?6:1,m=30/y*S.$Mk.MB,b=await M($,p,m,y,f);if(b){this.r=b,P(this.r,this.getLevel());for(const{level:g,message:u}of this.m)C(this.r,g,u);this.m=[]}}g($,p){this.r?C(this.r,$,p):this.getLevel()<=$&&this.m.push({level:$,message:p})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$LN=d}),define(re[230],oe([0,1,32,5,229]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;class M extends A.$oj{s(P,d,c){return new s.$LN((0,S.$ig)(),P.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,d)}}e.$MN=M}),define(re[68],oe([0,1,31,3,6,5,230]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=e.$C8b=void 0,e.$C8b=(0,s.$Wh)(M.$ej);class P extends C.$MN{constructor(){super(...arguments),this.u=new S.$zc}createLogger(c,$,p){p!==void 0&&this.u.set(this.n(c),p);try{return super.createLogger(c,$)}catch(v){throw this.u.delete(this.n(c)),v}}registerLogger(c,$){$!==void 0&&this.u.set(c.resource,$),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const $=[];for(const p of super.getRegisteredLoggers())c===this.u.get(p.resource)&&$.push(p);return $}getOnDidChangeLogLevelEvent(c){return A.Event.filter(this.onDidChangeLogLevel,$=>(0,M.$fj)($)||this.w($[0],c))}getOnDidChangeVisibilityEvent(c){return A.Event.filter(this.onDidChangeVisibility,([$])=>this.w($,c))}getOnDidChangeLoggersEvent(c){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,$=>({added:[...$.added].filter(v=>this.w(v.resource,c)),removed:[...$.removed].filter(v=>this.w(v.resource,c))})),$=>$.added.length>0||$.removed.length>0)}deregisterLoggers(c){for(const[$,p]of this.u)p===c&&this.deregisterLogger($)}w(c,$){const p=this.u.get(c);return p===void 0||p===$}dispose(){super.dispose(),this.u.clear()}}e.$D8b=P}),define(re[231],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g9b=e.$f9b=e.$e9b=e.$d9b=void 0;function S(C){return C.submenu!==void 0}e.$d9b=S;function A(C){return C.id==="vscode.menubar.separator"}e.$e9b=A;function s(C){return C.uri!==void 0}e.$f9b=s;function M(C){return!S(C)&&!A(C)&&!s(C)}e.$g9b=M}),define(re[39],oe([0,1,3,71,2,6]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=void 0,e.$on=(0,M.$Vh)("policy");class C extends s.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Rd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const $=Object.keys(this.f).length;return this.f={...c,...this.f},$!==Object.keys(this.f).length&&await this.j(c),A.Iterable.reduce(this.g.entries(),(p,[v,f])=>({...p,[v]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(c,[$,p])=>({...c,[$]:{definition:p,value:this.g.get($)}}),{})}}e.$pn=C;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$qn=P}),define(re[232],oe([0,1,8,3,71,12,16,5,39]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0b=void 0;function c(p,v){const f=[];for(const y of new Set(s.Iterable.concat(p.keys(),v.keys())))p.get(y)!==v.get(y)&&f.push(y);return f}let $=class extends d.$pn{constructor(v,f,y){super(),this.m=v,this.n=f,this.s=y,this.c=this.B(new S.$Vg(500));const m=A.Event.filter(f.onDidFilesChange,b=>b.affects(v));this.B(f.watch(v)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const f=await this.n.readFile(this.m),y=JSON.parse(f.value.toString());if(!(0,M.$Ef)(y))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(y))this.f[m]&&v.set(m,y[m])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return v}async w(){const v=await this.u(),f=c(this.g,v);this.g=v,f.length>0&&this.h.fire(f)}};e.$e0b=$,e.$e0b=$=ve([te(1,C.$ek),te(2,P.$dj)],$)}),define(re[233],oe([0,1,3,2,39]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P9b=e.$O9b=void 0;class M{constructor(d){this.b=d,this.a=new A.$Qc}listen(d,c){switch(c){case"onDidChange":return S.Event.map(this.b.onDidChange,$=>$.reduce((p,v)=>({...p,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(d,c,$){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions($)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$O9b=M;class C extends s.$pn{constructor(d,c){super(),this.a=c;for(const $ in d){const{definition:p,value:v}=d[$];this.f[$]=p,v!==void 0&&this.g.set($,v)}this.a.listen("onDidChange")($=>{for(const p in $){const v=$[p];v===null?this.g.delete(p):this.g.set(p,v)}this.h.fire(Object.keys($))})}async j(d){const c=await this.a.call("updatePolicyDefinitions",d);for(const $ in c)this.g.set($,c[$])}}e.$P9b=C}),define(re[234],oe([0,1,39,8,313,2,5]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d0b=void 0;let P=class extends S.$pn{constructor(c,$){super(),this.m=c,this.n=$,this.a=new A.$Rg,this.b=this.B(new M.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise(($,p)=>{try{this.b.value=(0,s.createWatcher)(this.n,c,v=>{this.t(v),$()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),p(v)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const $ in c){const p=c[$];p===void 0?this.g.delete($):this.g.set($,p)}this.h.fire(Object.keys(c))}};e.$d0b=P,e.$d0b=P=ve([te(0,C.$dj)],P)}),define(re[79],oe([0,1,35]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)A=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,S.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:M.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(re[25],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,S.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"}),define(re[235],oe([0,1,8,5]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$78b=void 0;let s=class{constructor(C,P,d){this.a=C,this.b=P,this.c=d}async inspect(C){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Yg)(C);const d=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$78b=s,e.$78b=s=ve([te(2,A.$dj)],s)}),define(re[80],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=void 0,e.$s8b=(0,S.$Vh)("protocolMainService")}),define(re[43],oe([0,1,137,12]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class s{constructor(){this.a=new Map}add(C,P){S.ok(A.$Cf(C)),S.ok(A.$Ef(P)),S.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$mn=new s}),define(re[236],oe([0,1,3,43]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new S.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,c){this.a[s(d)]=c,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const C=new M;A.$mn.add(e.$nn.JSONContribution,C)}),define(re[58],oe([0,1,23,3,12,163,17,236,43]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var c;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$rn={Configuration:"base.contributions.configuration"};var $;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})($||(e.ConfigurationScope=$={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const p=d.$mn.as(P.$nn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.$Rd,this.onDidSchemaChange=this.i.event,this.j=new A.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=new Set;this.n(i,o,r),p.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const o=new Set;this.o(i,o),p.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=new Set;this.o(o,r),this.n(i,!1,r),p.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const r=[];for(const{overrides:t,source:n}of i)for(const l in t)if(o.add(l),e.$Bn.test(l)){const w=this.a.get(l),D=w?.valuesSources??new Map;if(n)for(const L of Object.keys(t[l]))D.set(L,n);const I={...w?.value||{},...t[l]};this.a.set(l,{source:n,value:I,valuesSources:D});const k=(0,C.$zi)(l),R={type:"object",default:I,description:M.localize(1,null,k),$ref:e.$yn,defaultDefaultValue:I,source:s.$Cf(n)?void 0:n,defaultValueSource:n};r.push(...m(l)),this.d[l]=R,this.b.properties[l]=R}else{this.a.set(l,{value:t[l],source:n});const w=this.d[l];w&&(this.w(l,w),this.r(l,w))}this.m(r)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:r,source:t}of i)for(const n in r){const l=this.a.get(n),w=s.$Cf(t)?t:t?.id,D=s.$Cf(l?.source)?l?.source:l?.source?.id;if(w===D)if(o.add(n),this.a.delete(n),e.$Bn.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(i){let o=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,r){i.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,o){const r=t=>{if(t.properties)for(const n in t.properties){o.add(n);const l=this.d[n];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,o=!0,r,t,n=3,l){n=s.$Lf(i.scope)?n:i.scope;const w=i.properties;if(w)for(const I in w){const k=w[I];if(o&&a(I,k)){delete w[I];continue}if(k.source=r,k.defaultDefaultValue=w[I].default,this.w(I,k),e.$Bn.test(I)?k.scope=void 0:(k.scope=s.$Lf(k.scope)?n:k.scope,k.restricted=s.$Lf(k.restricted)?!!t?.includes(I):k.restricted),w[I].hasOwnProperty("included")&&!w[I].included){this.f[I]=w[I],delete w[I];continue}else this.d[I]=w[I],w[I].policy?.name&&this.e.set(w[I].policy.name,I);!w[I].deprecationMessage&&w[I].markdownDeprecationMessage&&(w[I].deprecationMessage=w[I].markdownDeprecationMessage),l.add(I)}const D=i.allOf;if(D)for(const I of D)this.p(I,o,r,t,n,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=r=>{const t=r.properties;if(t)for(const l in t)this.r(l,t[l]);r.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$sn.properties[i]=o,o.scope){case 1:e.$tn.properties[i]=o;break;case 2:e.$un.properties[i]=o;break;case 6:e.$vn.properties[i]=o;break;case 3:e.$wn.properties[i]=o;break;case 4:e.$xn.properties[i]=o;break;case 5:e.$xn.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$sn.properties[i],o.scope){case 1:delete e.$tn.properties[i];break;case 2:delete e.$un.properties[i];break;case 6:delete e.$vn.properties[i];break;case 3:delete e.$wn.properties[i];break;case 4:case 5:delete e.$xn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$yn};this.w(o,r),e.$sn.properties[o]=r,e.$tn.properties[o]=r,e.$un.properties[o]=r,e.$vn.properties[o]=r,e.$wn.properties[o]=r,e.$xn.properties[o]=r}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=i,e.$tn.patternProperties[e.$An]=i,e.$un.patternProperties[e.$An]=i,e.$vn.patternProperties[e.$An]=i,e.$wn.patternProperties[e.$An]=i,e.$xn.patternProperties[e.$An]=i,this.i.fire()}w(i,o){const r=this.a.get(i);let t=r?.value,n=r?.source;s.$Jf(t)&&(t=o.defaultDefaultValue,n=void 0),s.$Jf(t)&&(t=g(o.type)),o.default=t,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.$An=`^(${f})+$`,e.$Bn=new RegExp(e.$An);function m(h){const i=[];if(e.$Bn.test(h)){let o=y.exec(h);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=y.exec(h)}}return(0,S.$Lb)(i)}e.$Cn=m;function b(h){return h.reduce((i,o)=>`${i}[${o}]`,"")}e.$Dn=b;function g(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=g;const u=new v;d.$mn.add(e.$rn.Configuration,u);function a(h,i){return h.trim()?e.$Bn.test(h)?M.localize(7,null,h):u.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,h,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Fn=a;function E(){const h=[],i=u.getConfigurationProperties();for(const o of Object.keys(i))h.push([o,i[o].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$Gn=E}),define(re[119],oe([0,1,23,3,44,2,31,38,12,7,17,58,43]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function f(o){return Object.isFrozen(o)?o:P.$bn(o)}class y{constructor(r={},t=[],n=[],l){this.b=r,this.c=t,this.d=n,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof y)return t;const n=new m("");return n.parseRaw(t),n.configurationModel});this.f=r.reduce((t,n)=>n===t?n:t.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,$.$xi)(this.contents,r):this.contents}inspect(r,t){const n=this.rawConfiguration.getValue(r),l=t?this.rawConfiguration.getOverrideValue(r,t):void 0,w=t?this.rawConfiguration.override(t).getValue(r):n;return{value:n,override:l,merged:w}}getOverrideValue(r,t){const n=this.i(t);return n?r?(0,$.$xi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const n of this.overrides)n.identifiers.includes(r)&&t.push(...n.keys);return S.$Lb(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return S.$Lb(r)}override(r){let t=this.a.get(r);return t||(t=this.g(r),this.a.set(r,t)),t}merge(...r){const t=P.$an(this.contents),n=P.$an(this.overrides),l=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const D of r)if(w.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(t,D.contents);for(const I of D.overrides){const[k]=n.filter(R=>S.$tb(R.identifiers,I.identifiers));k?(this.h(k.contents,I.contents),k.keys.push(...I.keys),k.keys=S.$Lb(k.keys)):n.push(P.$an(I))}for(const I of D.keys)l.indexOf(I)===-1&&l.push(I)}return new y(t,l,n,w.every(D=>D instanceof y)?void 0:w)}g(r){const t=this.i(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const l of S.$Lb([...Object.keys(this.contents),...Object.keys(t)])){let w=this.contents[l];const D=t[l];D&&(typeof w=="object"&&typeof D=="object"?(w=P.$an(w),this.h(w,D)):w=D),n[l]=w}return new y(n,this.keys,this.overrides)}h(r,t){for(const n of Object.keys(t)){if(n in r&&d.$Ef(r[n])&&d.$Ef(t[n])){this.h(r[n],t[n]);continue}r[n]=P.$an(t[n])}}i(r){let t=null,n=null;const l=w=>{w&&(n?this.h(n,w):n=P.$an(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?t=w.contents:w.identifiers.includes(r)&&l(w.contents);return l(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,t){this.j(r,t,!0)}setValue(r,t){this.j(r,t,!1)}removeValue(r){const t=this.keys.indexOf(r);t!==-1&&(this.keys.splice(t,1),(0,$.$wi)(this.contents,r),p.$Bn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$tb(n.identifiers,(0,p.$Cn)(r))),1))}j(r,t,n){(0,$.$vi)(this.contents,r,t,l=>console.error(l)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),p.$Bn.test(r)&&this.overrides.push({identifiers:(0,p.$Cn)(r),keys:Object.keys(this.contents[r]),contents:(0,$.$ui)(this.contents[r],l=>console.error(l))})}}e.$Hn=y;class m{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!d.$Lf(r)){const n=this.g(r);this.parseRaw(n,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:n,keys:l,overrides:w,restricted:D,hasExcludedProperties:I}=this.h(r,t);this.b=new y(n,l,w,I?[r]:void 0),this.c=D||[]}g(r){let t={},n=null,l=[];const w=[],D=[];function I(R){Array.isArray(l)?l.push(R):n!==null&&(l[n]=R)}const k={onObjectBegin:()=>{const R={};I(R),w.push(l),l=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{l=w.pop()},onArrayBegin:()=>{const R=[];I(R),w.push(l),l=R,n=null},onArrayEnd:()=>{l=w.pop()},onLiteralValue:I,onError:(R,L,T)=>{D.push({error:R,offset:L,length:T})}};if(r)try{s.$0m(r,k),t=l[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return t}h(r,t){const n=v.$mn.as(p.$rn.Configuration).getConfigurationProperties(),l=this.i(r,n,!0,t);r=l.raw;const w=(0,$.$ui)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(r),I=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:w,keys:D,overrides:I,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,t,n,l){let w=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const D={},I=[];for(const k in r)if(p.$Bn.test(k)&&n){const R=this.i(r[k],t,!1,l);D[k]=R.raw,w=w||R.hasExcludedProperties,I.push(...R.restricted)}else{const R=t[k],L=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&I.push(k),!l.exclude?.includes(k)&&(l.include?.includes(k)||(L===void 0||l.scopes===void 0||l.scopes.includes(L))&&!(l.skipRestricted&&R?.restricted))?D[k]=r[k]:w=!0}return{raw:D,restricted:I,hasExcludedProperties:w}}j(r,t){const n=[];for(const l of Object.keys(r))if(p.$Bn.test(l)){const w={};for(const D in r[l])w[D]=r[l][D];n.push({identifiers:(0,p.$Cn)(l),keys:Object.keys(w),contents:(0,$.$ui)(w,t)})}return n}}e.$In=m;class b extends M.$Rc{constructor(r,t,n,l){super(),this.c=r,this.f=t,this.g=l,this.b=this.B(new A.$Rd),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,w=>w.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&n.isEqual(w.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=b;class g{constructor(r,t,n,l,w,D,I,k,R,L,T,N,K){this.a=r,this.b=t,this.c=n,this.overrideIdentifiers=l,this.d=w,this.f=D,this.g=I,this.h=k,this.i=R,this.j=L,this.k=T,this.l=N,this.m=K}get value(){return f(this.c)}n(r,t,n){const l=r.inspect(t,n);return{get value(){return f(l.value)},get override(){return f(l.override)},get merged(){return f(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(r,t,n,l,w=new y,D=new y,I=new C.$zc,k=new y,R=new C.$zc){this.c=r,this.d=t,this.f=n,this.g=l,this.h=w,this.i=D,this.j=I,this.l=k,this.m=R,this.a=null,this.b=new C.$zc,this.n=null}getValue(r,t,n){return this.p(r,t,n).getValue(r)}updateValue(r,t,n={}){let l;n.resource?(l=this.m.get(n.resource),l||(l=new y,this.m.set(n.resource,l))):l=this.l,t===void 0?l.removeValue(r):l.setValue(r,t),n.resource||(this.a=null)}inspect(r,t,n){const l=this.p(r,t,n),w=this.t(t.resource,n),D=t.resource?this.m.get(t.resource)||this.l:this.l,I=new Set;for(const k of l.overrides)for(const R of k.identifiers)l.getOverrideValue(r,R)!==void 0&&I.add(R);return new g(r,t,l.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,w||void 0,D)}keys(r){const t=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.j.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const n=[];if(!t){const{added:l,updated:w,removed:D}=h(this.c,r);t=[...l,...w,...D]}for(const l of t)for(const w of(0,p.$Cn)(l)){const D=this.c.getKeysForOverrideIdentifier(w),I=r.getKeysForOverrideIdentifier(w),k=[...I.filter(R=>D.indexOf(R)===-1),...D.filter(R=>I.indexOf(R)===-1),...D.filter(R=>!P.$en(this.c.override(w).getValue(R),r.override(w).getValue(R)))];n.push([w,k])}return this.updateDefaultConfiguration(r),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:n,removed:l}=h(this.d,r),w=[...t,...n,...l];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:n,removed:l,overrides:w}=h(this.applicationConfiguration,r),D=[...t,...n,...l];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:n,removed:l,overrides:w}=h(this.localUserConfiguration,r),D=[...t,...n,...l];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:n,removed:l,overrides:w}=h(this.remoteUserConfiguration,r),D=[...t,...n,...l];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:n,removed:l,overrides:w}=h(this.workspaceConfiguration,r),D=[...t,...n,...l];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:w}}compareAndUpdateFolderConfiguration(r,t){const n=this.folderConfigurations.get(r),{added:l,updated:w,removed:D,overrides:I}=h(n,t),k=[...l,...w,...D];return(k.length||!n)&&this.updateFolderConfiguration(r,t),{keys:k,overrides:I}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:l,removed:w,overrides:D}=h(t,void 0);return{keys:[...n,...l,...w],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,t,n){let l=this.q(t,n);return t.overrideIdentifier&&(l=l.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}q({resource:r},t){let n=this.r();if(t&&r){const l=t.getFolder(r);l&&(n=this.s(l.uri)||n);const w=this.m.get(r);w&&(n=n.merge(w))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let t=this.b.get(r);if(!t){const n=this.r(),l=this.j.get(r);l?(t=n.merge(l),this.b.set(r,t)):t=n}return t}t(r,t){if(t&&r){const n=t.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,t)=>{const{contents:n,overrides:l,keys:w}=this.j.get(t);return r.push([t,{contents:n,overrides:l,keys:w}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(t=>r.add(t)),this.userConfiguration.keys.forEach(t=>r.add(t)),this.i.keys.forEach(t=>r.add(t)),this.j.forEach(t=>t.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(l=>t.add(l))),[...t.values()]}static parse(r){const t=this.w(r.defaults),n=this.w(r.policy),l=this.w(r.application),w=this.w(r.user),D=this.w(r.workspace),I=r.folders.reduce((k,R)=>(k.set(c.URI.revive(R[0]),this.w(R[1])),k),new C.$zc);return new u(t,n,l,w,new y,D,I,new y,new C.$zc)}static w(r){return new y(r.contents,r.keys,r.overrides)}}e.$Kn=u;function a(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,t=new Map;for(const l of o)l.keys.forEach(w=>r.add(w)),l.overrides.forEach(([w,D])=>{const I=(0,C.$wc)(t,w,new Set);D.forEach(k=>I.add(k))});const n=[];return t.forEach((l,w)=>n.push([w,[...l.values()]])),{keys:[...r.values()],overrides:n}}e.$Ln=a;class E{constructor(r,t,n,l){this.change=r,this.f=t,this.g=n,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const w of r.keys)this.affectedKeys.add(w);for(const[,w]of r.overrides)for(const D of w)this.affectedKeys.add(D);this.d=this.a;for(const w of this.affectedKeys)this.d+=w+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(r,t){const n=this.a+r,l=this.d.indexOf(n);if(l<0)return!1;const w=l+n.length;if(w>=this.d.length)return!1;const D=this.d.charCodeAt(w);if(D!==this.b&&D!==this.c)return!1;if(t){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,k=this.g.getValue(r,t,this.h);return!P.$en(I,k)}return!0}}e.$Mn=E;function h(o,r){const{added:t,removed:n,updated:l}=i(r?.rawConfiguration,o?.rawConfiguration),w=[],D=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const k=I.filter(R=>!D.includes(R));for(const R of k)w.push([R,r.getKeysForOverrideIdentifier(R)])}if(o){const k=D.filter(R=>!I.includes(R));for(const R of k)w.push([R,o.getKeysForOverrideIdentifier(R)])}if(r&&o){for(const k of D)if(I.includes(k)){const R=i({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});w.push([k,[...R.added,...R.removed,...R.updated]])}}return{added:t,removed:n,updated:l,overrides:w}}function i(o,r){const t=o?r?o.keys.filter(w=>r.keys.indexOf(w)===-1):[...o.keys]:[],n=r?o?r.keys.filter(w=>o.keys.indexOf(w)===-1):[...r.keys]:[],l=[];if(o&&r){for(const w of r.keys)if(o.keys.indexOf(w)!==-1){const D=(0,$.$xi)(r.contents,w),I=(0,$.$xi)(o.contents,w);P.$en(D,I)||l.push(w)}}return{added:t,removed:n,updated:l}}}),define(re[237],oe([0,1,23,3,2,38,12,119,58,5,39,43]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=e.$On=e.$Nn=void 0;class v extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new A.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Hn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.$mn.as(d.$rn.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:g})=>this.c(Array.from(b),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,g){this.h(b,p.$mn.as(d.$rn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new P.$Hn;const b=p.$mn.as(d.$rn.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,g){const u=this.f();for(const a of b){const E=u[a],h=g[a];E!==void 0?this.b.addValue(a,E):h?this.b.addValue(a,h.default):this.b.removeValue(a)}}}e.$Nn=v;class f{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.$Hn}async initialize(){return this.configurationModel}}e.$On=f;let y=class extends s.$Rc{get configurationModel(){return this.b}constructor(b,g,u){super(),this.c=b,this.f=g,this.g=u,this.a=this.B(new A.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Hn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const g={},u=[],a=p.$mn.as(d.$rn.Configuration).getConfigurationProperties();for(const E of b){const h=a[E];if(!h){u.push(E);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}u.push(E),g[h.policy.name]={type:h.type}}}return(0,C.$Pf)(g)||await this.f.updatePolicyDefinitions(g),u}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const g=p.$mn.as(d.$rn.Configuration).getPolicyConfigurations(),u=(0,S.$Gb)(b.map(a=>g.get(a)));this.m(u,!0)}m(b,g){this.g.trace("PolicyConfiguration#update",b);const u=p.$mn.as(d.$rn.Configuration).getConfigurationProperties(),a=[],E=this.b.isEmpty();for(const h of b){const i=u[h]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(E?o!==void 0:!(0,M.$en)(this.b.getValue(h),o))&&a.push([h,o])}else this.b.getValue(h)!==void 0&&a.push([h,void 0])}if(a.length){this.g.trace("PolicyConfiguration#changed",a);const h=this.b;this.b=new P.$Hn;for(const i of h.keys)this.b.setValue(i,h.getValue(i));for(const[i,o]of a)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);g&&this.a.fire(this.b)}}};e.$Pn=y,e.$Pn=y=ve([te(1,$.$on),te(2,c.$dj)],y)}),define(re[238],oe([0,1,8,3,2,19,17,119,237,39]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=void 0;class $ extends s.$Rc{constructor(v,f,y,m){super(),this.j=v,this.h=this.B(new A.$Rd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Nn),this.c=y instanceof c.$qn?new d.$On:this.B(new d.$Pn(this.b,y,m)),this.f=this.B(new P.$Jn(this.j,{},M.$qg,f)),this.a=new P.$Kn(this.b.configurationModel,this.c.configurationModel,new P.$Hn,new P.$Hn),this.g=this.B(new S.$0g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:g})=>this.n(b,g))),this.B(this.c.onDidChangeConfiguration(b=>this.r(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,f,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$Kn(v,f,new P.$Hn,y)}getConfigurationData(){return this.a.toData()}getValue(v,f){const y=typeof v=="string"?v:void 0,m=(0,C.$qi)(v)?v:(0,C.$qi)(f)?f:{};return this.a.getValue(y,m,void 0)}updateValue(v,f,y,m){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.m(v)}m(v){const f=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(v);this.s(y,f,2)}n(v,f){const y=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(v,f);this.s(m,y,7)}r(v){const f=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(v);this.s(y,f,7)}s(v,f,y){const m=new P.$Mn(v,{data:f},this.a);m.source=y,m.sourceConfig=this.t(y),this.h.fire(m)}t(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Qn=$}),define(re[239],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=e.$49b=e.$39b=void 0,e.$39b="request",e.$49b="remoteResourceHandler";class S{async routeCall(s,M,C){if(M!==e.$39b)throw new Error(`Call not found: ${M}`);const P=C[0];if(P?.authority){const d=s.connections.find(c=>c.ctx===P.authority);if(d)return d}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$59b=S}),define(re[240],oe([0,1,14,6]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,A.$Vh)("remoteAuthorityResolverService");var s;(function($){$[$.WebSocket=0]="WebSocket",$[$.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=M;class C{constructor(p,v){this.host=p,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=C;var P;(function($){$.Unknown="Unknown",$.NotAvailable="NotAvailable",$.TemporarilyNotAvailable="TemporarilyNotAvailable",$.NoResolverFound="NoResolverFound",$.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class d extends S.$ab{static isNotAvailable(p){return p instanceof d&&p._code===P.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof d&&p._code===P.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof d&&p._code===P.NoResolverFound}static isInvalidAuthority(p){return p instanceof d&&p._code===P.InvalidAuthority}static isHandled(p){return p instanceof d&&p.isHandled}constructor(p,v=P.Unknown,f){super(p),this._message=p,this._code=v,this._detail=f,this.isHandled=v===P.NotAvailable&&f===!0,Object.setPrototypeOf(this,d.prototype)}}e.$Yk=d;function c($){const p=$.indexOf("+");return p===-1?$:$.substring(0,p)}e.$Zk=c}),define(re[59],oe([0,1,13]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function A(c){return c.scheme===S.Schemas.vscodeRemote?c.authority:void 0}e.$1k=A;function s(c){if(!c)return;const $=c.indexOf("+");return $<0?c:c.substr(0,$)}e.$2k=s;function M(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$3k=M;function C(c){const{host:$,port:p}=d(c);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:$,port:p}}e.$4k=C;function P(c,$){let{host:p,port:v}=d(c);return typeof v>"u"&&(v=$),{host:p,port:v}}e.$5k=P;function d(c){const $=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const p=c.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const v=c.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:c,port:void 0}}}),define(re[120],oe([0,1,27,6,59]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$0l=M,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(C||(e.ExtensionType=C={}));var P;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class d{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,g){if(typeof b>"u"||b===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof b=="string"||typeof g=="string"){const u=typeof b=="string"?b:b.value,a=typeof g=="string"?g:g.value;return S.$6e(u,a)}return b._lower===g._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$_l=d;class c{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const g of b)this.add(g)}add(b){this.c.add(d.toKey(b))}delete(b){return this.c.delete(d.toKey(b))}has(b){return this.c.has(d.toKey(b))}}e.$am=c;class ${constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(d.toKey(b))}get(b){return this.c.get(d.toKey(b))}has(b){return this.c.has(d.toKey(b))}set(b,g){this.c.set(d.toKey(b),g)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=$;function p(m){return v(m)}e.$cm=p;function v(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$dm=v;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$em=f;function y(m,b){if(b){const g=`onResolveRemoteAuthority:${(0,s.$2k)(b)}`;return!!m.activationEvents?.includes(g)}return!1}e.$fm=y,e.$gm=(0,A.$Vh)("IBuiltinExtensionsScannerService")}),define(re[241],oe([0,1,8,18,22,14,3,2,67,73,32,109,240,59]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.PersistentConnectionEventType=e.$_k=e.$$k=e.$0k=e.ConnectionType=void 0;const y=30*1e3;var m;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function b(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(J){const O=new s.$2d;return setTimeout(()=>O.cancel(),J),O.token}function u(J,O){if(J.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const U=new s.$2d;return J.onCancellationRequested(()=>U.cancel()),O.onCancellationRequested(()=>U.cancel()),U.token}class a{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Qc,this.promise=new Promise((U,G)=>{this.f=U,this.g=G}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function E(J,O){const U=new a(O);return U.registerDisposable(J.onControlMessage(G=>{const F=JSON.parse(G.toString()),z=q(F);z?U.reject(z):U.resolve(F)})),U.promise}function h(J,O,U,G,F,z,W,x){const he=new a(x),de=c.$Nd.create(!1);return J.info(`Creating a socket (${W})...`),d.mark(`code/willCreateSocket/${z}`),O.connect(U,G,F,W).then(le=>{he.didTimeout?(d.mark(`code/didCreateSocketError/${z}`),J.info(`Creating a socket (${W}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(d.mark(`code/didCreateSocketOK/${z}`),J.info(`Creating a socket (${W}) was successful after ${de.elapsed()} ms.`),he.resolve(le))},le=>{d.mark(`code/didCreateSocketError/${z}`),J.info(`Creating a socket (${W}) returned an error after ${de.elapsed()} ms.`),J.error(le),he.reject(le)}),he.promise}function i(J,O){const U=new a(O);return J.then(G=>{U.didTimeout||U.resolve(G)},G=>{U.didTimeout||U.reject(G)}),U.promise}async function o(J,O,U,G){const F=_(J,O);J.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let z;try{z=await h(J.logService,J.remoteSocketFactoryService,J.connectTo,(0,f.$3k)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,b(O),`renderer-${b(O)}-${J.reconnectionToken}`,G)}catch(le){throw J.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),J.logService.error(le),le}J.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let W,x;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(z,null),W=J.reconnectionProtocol,x=!1):(W=new p.$Jh({socket:z}),x=!0),J.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const he=await i(J.signService.createNewMessage((0,$.$ig)()),G),de={type:"auth",auth:J.connectionToken||"00000000000000000000",data:he.data};W.sendControl(A.$fe.fromString(JSON.stringify(de)));try{const le=await E(W,u(G,g(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(J.logService.trace(`${F} 4/6. received SignRequest control message.`),!await i(J.signService.validate(he,le.signedData),G)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const be=await i(J.signService.sign(le.data),G),Ee={type:"connectionType",commit:J.commit,signedData:be,desiredConnectionType:O};return U&&(Ee.args=U),J.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(A.$fe.fromString(JSON.stringify(Ee))),{protocol:W,ownsProtocol:x}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(J.logService.error(`${F} the handshake timed out. Error:`),J.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${F} received error control message when negotiating connection. Error:`),J.logService.error(le)),x&&V(W),le}}async function r(J,O,U,G){const F=Date.now(),z=_(J,O),{protocol:W,ownsProtocol:x}=await o(J,O,U,G),he=new a(G);return he.registerDisposable(W.onControlMessage(de=>{const le=JSON.parse(de.toString()),we=q(le);we?(J.logService.error(`${z} received error control message when negotiating connection. Error:`),J.logService.error(we),x&&V(W),he.reject(we)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${se(F)}!`),he.resolve({protocol:W,firstMessage:le}))})),he.promise}async function t(J,O){const{protocol:U}=await r(J,1,void 0,O);return{protocol:U}}async function n(J,O,U){const{protocol:G,firstMessage:F}=await r(J,2,O,U),z=F&&F.debugPort;return{protocol:G,debugPort:z}}async function l(J,O,U){const G=Date.now(),F=_(J,3),{protocol:z}=await o(J,3,O,U);return J.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${se(G)}!`),z}async function w(J,O,U){const{connectTo:G,connectionToken:F}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:G,connectionToken:F,reconnectionToken:O,reconnectionProtocol:U,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function D(J,O,U){return k(J,async G=>{const{protocol:F}=await t(G,s.CancellationToken.None);return new X(J,O,U,G.reconnectionToken,F)})}e.$0k=D;async function I(J,O){return k(J,async U=>{const{protocol:G,debugPort:F}=await n(U,O,s.CancellationToken.None);return new Y(J,O,U.reconnectionToken,G,F)})}e.$$k=I;async function k(J,O){for(let G=1;;G++)try{const F=(0,$.$ig)(),z=await w(J,F,null);return await O(z)}catch(F){if(G<5)J.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(F);else throw J.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(F),ce.triggerPermanentFailure(0,0,v.$Yk.isHandled(F)),F}}async function R(J,O,U){const G=await w(J,(0,$.$ig)(),null);return await l(G,{host:O,port:U},s.CancellationToken.None)}e.$_k=R;function L(J){return(0,S.$Lg)(O=>new Promise((U,G)=>{const F=setTimeout(U,J*1e3);O.onCancellationRequested(()=>{clearTimeout(F),U()})}))}var T;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class N{constructor(O,U){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.type=0}}e.$al=N;class K{constructor(O,U,G,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.durationSeconds=G,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.$bl=K;class Q{constructor(O,U,G){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=G,this.type=2}}e.$cl=Q;class ae{constructor(O,U,G){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=G,this.type=4}}e.$dl=ae;class ne{constructor(O,U,G,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=G,this.handled=F,this.type=3}}e.$el=ne;class ce extends P.$Rc{static triggerPermanentFailure(O,U,G){this._permanentFailure=!0,this.f=O,this.g=U,this.h=G,this.j.forEach(F=>F.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(O,U,G,F,z){super(),this.t=O,this.u=U,this.reconnectionToken=G,this.protocol=F,this.w=z,this.m=this.B(new C.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(F.onSocketClose(W=>{const x=B(this.t,this.reconnectionToken,!0);W?W.type===0?(this.u.logService.info(`${x} received socket close event (hadError: ${W.hadError}).`),W.error&&this.u.logService.error(W.error)):(this.u.logService.info(`${x} received socket close event (wasClean: ${W.wasClean}, code: ${W.code}, reason: ${W.reason}).`),W.event&&this.u.logService.error(W.event)):this.u.logService.info(`${x} received socket close event.`),this.y()})),this.B(F.onSocketTimeout(W=>{const x=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${W.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${W.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${W.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,P.$Pc)(()=>{const W=ce.j.indexOf(this);W>=0&&ce.j.splice(W,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const F=G<U.length?U[G]:U[U.length-1];try{if(F>0){const W=L(F);this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,W)),this.u.logService.info(`${O} waiting for ${F} seconds before reconnecting...`);try{await W}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.u.logService.info(`${O} resolving connection...`);const z=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${z.connectTo}...`),await this.G(z,g(y)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(v.$Yk.isTemporarilyNotAvailable(z)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,M.$3)(z)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof v.$Yk){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,v.$Yk.isHandled(z));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.n&&!this.s)}C(O,U,G){this.w?ce.triggerPermanentFailure(O,U,G):this.D(O,U,G)}D(O,U,G){this.m.fire(new ne(this.reconnectionToken,O,U,G)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$fl=ce;class X extends ce{constructor(O,U,G,F,z){super(1,O,F,z,!0),this.client=this.B(new p.$Hh(z,{remoteAuthority:U,clientId:G},O.ipcLogger))}async G(O,U){await t(O,U)}}e.$gl=X;class Y extends ce{constructor(O,U,G,F,z){super(2,O,G,F,!1),this.H=U,this.debugPort=z}async G(O,U){await n(O,this.H,U)}}e.$hl=Y;function V(J){try{J.acceptDisconnect();const O=J.getSocket();J.dispose(),O.dispose()}catch(O){(0,M.$Z)(O)}}function q(J){if(J&&J.type==="error"){const O=new Error(`Connection error: ${J.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function j(J,O){for(;J.length<O;)J+=" ";return J}function H(J,O){return`[remote-connection][${j(b(J),13)}][${O.substr(0,5)}\u2026]`}function B(J,O,U){return`${H(J,O)}[${U?"reconnect":"initial"}]`}function _(J,O){return`${B(O,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function se(J){return`${Date.now()-J} ms`}}),define(re[242],oe([0,1,2,6]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=void 0,e.$6k=(0,A.$Vh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,P){return this.a[C]??=[],this.a[C].push(P),(0,S.$Pc)(()=>{const d=this.a[C]?.indexOf(P);typeof d=="number"&&d>=0&&this.a[C]?.splice(d,1)})}b(C){return(this.a[C.type]||[]).find(d=>d.supports(C))}connect(C,P,d,c){const $=this.b(C);if(!$)throw new Error(`No socket factory found for ${C}`);return $.connect(C,P,d,c)}}e.$7k=s}),define(re[243],oe([0,1,28,48,21,113]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$68b=void 0;let C;async function P(f=!1){return(C===void 0||f)&&(C=d()),C}e.$68b=P;async function d(){const f=c();if(f===void 0)return!1;if(f>=22e3){const y=p();if(y)return new Promise(m=>{A.execFile(y,["--status"],b=>m(!b))})}else{const y=v();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function c(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(f)return parseInt(f[3])}function $(f){const y=process.env.SystemRoot;if(y){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,m?"Sysnative":"System32",f)}}function p(){return $("wsl.exe")}function v(){return $("lxss\\LxssManager.dll")}}),define(re[51],oe([0,1,18,14,2,183,58,6,5,43]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$Yo=(0,P.$Vh)("requestService");class ${constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?h[i]="*****":h[i]=this.b[i];this.a=h}return this.a}}class p extends s.$Rc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,M.localize)(0,null),when:d.$uj.isEqualTo((0,d.$sj)(d.LogLevel.Trace)).serialize()})}async c(h,i,o){const r=`${h} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new $(i.headers??{}));try{const t=await o();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,A.$9)(t)),t}}}e.$Zo=p;function v(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$1o=v;function f(E){return E.res.statusCode===204}e.$2o=f;async function y(E){return f(E)?null:(await(0,S.$re)(E.stream)).toString()}e.$3o=y;async function m(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.$4o=m;async function b(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const i=(await(0,S.$re)(E.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$5o=b;function g(E){a(E)}e.$6o=g;let u;function a(E){const h=c.$mn.as(C.$rn.Configuration),i=u;u={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[u],remove:i?[i]:[]})}a(1)}),define(re[244],oe([0,1,18,22]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class s{constructor(P){this.a=P}listen(P,d){throw new Error("Invalid listen")}call(P,d,c,$=A.CancellationToken.None){switch(d){case"request":return this.a.request(c[0],$).then(async({res:p,stream:v})=>{const f=await(0,S.$re)(v);return[{statusCode:p.statusCode,headers:p.headers},f]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$2q=s;class M{constructor(P){this.a=P}async request(P,d){const[c,$]=await this.a.call("request",[P],d);return{res:c,stream:(0,S.$te)($)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$3q=M}),define(re[245],oe([0,1,246,12]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;function s(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(C,P,d={}){const c=(0,S.parse)(C),$=d.proxyUrl||s(c,P);if(!$)return null;const p=(0,S.parse)($);if(!/^https?:$/.test(p.protocol||""))return null;const v={host:p.hostname||"",port:(p.port?+p.port:0)||(p.protocol==="https"?443:80),auth:p.auth,rejectUnauthorized:(0,A.$If)(d.strictSSL)?d.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,y)=>{Z(["http-proxy-agent"],f,y)})).HttpProxyAgent($,v):new(await new Promise((f,y)=>{Z(["https-proxy-agent"],f,y)})).HttpsProxyAgent($,v)}e.$4q=M}),define(re[247],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=e.$n9b=e.$m9b=void 0,e.$m9b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$n9b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$o9b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[94],oe([0,1,48,9,184,22,50,14,4,32,108,63,8,140]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=void 0;let y;async function m(g,u,a,E){return a["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.$i?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.$Tl)(E)&&!a["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.$Tl)(E)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=v.Promises.withAsyncBody(async(h,i)=>{const o=new M.$2d;let r=1e4;const t=g.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,f.$Ul)(t,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,s.localize)(0,null)))},r);try{h(await b(u,o.token))}catch(l){!(0,P.$3)(l)&&!o.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,C.$Gi)(l)))):h({})}finally{clearTimeout(n),o.dispose()}})),y)}e.$Zl=m;async function b(g,u){const a=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",a);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",E);const h=(0,c.$ig)().replace(/-/g,"").substr(0,12),i=new RegExp(h+"({.*})"+h),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const r=await(0,$.$Jl)(d.OS,o);return g.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if(u.isCancellationRequested)return n(new P.$4);const l=(0,A.$mc)(r);let w,D;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(w=`& '${process.execPath}' ${I} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,D=["-Login","-Command"]):l==="nu"?(w=`^'${process.execPath}' ${I} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,D=["-i","-l","-c"]):(w=`'${process.execPath}' ${I} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,l==="tcsh"||l==="csh"?D=["-ic"]:D=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),w);const k=(0,S.spawn)(r,[...D,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});u.onCancellationRequested(()=>(k.kill(),n(new P.$4))),k.on("error",T=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,C.$Gi)(T)),n(T)});const R=[];k.stdout.on("data",T=>R.push(T));const L=[];k.stderr.on("data",T=>L.push(T)),k.on("close",(T,N)=>{const K=Buffer.concat(R).toString("utf8");g.trace("getUnixShellEnvironment#raw",K);const Q=Buffer.concat(L).toString("utf8");if(Q.trim()&&g.trace("getUnixShellEnvironment#stderr",Q),T||N)return n(new Error((0,s.localize)(2,null,T,N)));const ae=i.exec(K),ne=ae?ae[1]:"{}";try{const ce=JSON.parse(ne);a?ce.ELECTRON_RUN_AS_NODE=a:delete ce.ELECTRON_RUN_AS_NODE,E?ce.ELECTRON_NO_ATTACH_CONSOLE=E:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ce),t(ce)}catch(ce){g.error("getUnixShellEnvironment#errorCaught",(0,C.$Gi)(ce)),n(ce)}})})}}),define(re[248],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f5b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const C=String(S.a++);return this.b.set(C,M),{id:C,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(M)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$f5b=S}),define(re[95],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=void 0,e.$8k="signService",e.$9k=(0,S.$Vh)(e.$8k)}),define(re[249],oe([0,1,248]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c0b=void 0;class A extends S.$f5b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(C=>new C.signer().sign(M))}h(){return new Promise((M,C)=>Z(["vsda"],M,C))}}e.$c0b=A}),define(re[34],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=e.$NN=void 0,e.$NN=(0,S.$Vh)("stateReadService"),e.$ON=(0,S.$Vh)("stateService")}),define(re[121],oe([0,1,8,18,2,12,37,16,5]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=e.$QN=e.$PN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class $ extends s.$Rc{constructor(y,m,b,g){super(),this.h=y,this.j=m,this.m=b,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Vg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,m){const b=this.a[y];return(0,M.$Lf)(b)?m:b}setItem(y,m){this.setItems([{key:y,data:m}])}setItems(y){let m=!1;for(const{key:b,data:g}of y)this.a[b]!==g&&((0,M.$Lf)(g)?(0,M.$Jf)(this.a[b])||(this.a[b]=void 0,m=!0):(this.a[b]=g,m=!0));m&&this.s()}removeItem(y){(0,M.$Jf)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,A.$fe.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(m){this.m.error(m)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$PN=$;let p=class extends s.$Rc{constructor(y,m,b,g){super(),this.a=this.B(new $(m.stateResource,y,b,g))}async init(){await this.a.init()}getItem(y,m){return this.a.getItem(y,m)}};e.$QN=p,e.$QN=p=ve([te(1,C.$3h),te(2,d.$dj),te(3,P.$ek)],p);class v extends p{setItem(y,m){this.a.setItem(y,m)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$RN=v}),define(re[122],oe([0,1,4,35,32]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function M(d){if(S.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function C(d,c,$,p,v,f,y,m,b){const g=Object.create(null);g["common.machineId"]=f,g["common.sqmId"]=y,g.sessionID=(0,s.$ig)()+Date.now(),g.commitHash=p,g.version=v,g["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.$h)(S.$u),g["common.nodePlatform"]=A.$cc,g["common.nodeArch"]=$,g["common.product"]=b||"desktop",m&&(g["common.msftInternal"]=m);let u=0;const a=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),S.$l&&(g["common.snap"]="true");const E=M(c);return E&&(g["common.platformDetail"]=E),g}e.$no=C;function P(d){const c=A.env.USERDNSDOMAIN;if(!c)return!1;const $=c.toLowerCase();return d.some(p=>$===p)}e.$oo=P}),define(re[26],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,S.$Vh)("telemetryService"),e.$jl=(0,S.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var A;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(re[250],oe([0,1,28,8,44,13,9,4,7,88,21,107,91,16,25,26]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0;const b=new Map;async function g(i,o){const r=`${i}::${o.join(":")}`,t=b.get(r);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,w=new Map,D=2e4;function I(R,L,T,N){const K=L.substring(R.length+1);return A.Promises.withAsyncBody(async Q=>{let ae;try{ae=await $.Promises.readdir(L,{withFileTypes:!0})}catch{Q();return}if(N.count>=D){N.count+=ae.length,N.maxReached=!0,Q();return}let ne=ae.length;if(ne===0){Q();return}let ce=ae;N.count+ae.length>D&&(N.maxReached=!0,ne=D-N.count,ce=ae.slice(0,ne)),N.count+=ae.length;for(const X of ce)if(X.isDirectory()){if(T.includes(X.name)||await I(R,(0,C.$ic)(L,X.name),T,N),--ne===0){Q();return}}else{const Y=X.name.lastIndexOf(".");if(Y>=0){const V=X.name.substring(Y+1);V&&l.set(V,(l.get(V)??0)+1)}for(const V of n)V.relativePathPattern?.test(K)!==!1&&V.filePattern.test(X.name)&&w.set(V.tag,(w.get(V.tag)??0)+1);if(--ne===0){Q();return}}})}const k=A.Promises.withAsyncBody(async R=>{const L={count:0,maxReached:!1};await I(i,i,o,L);const T=await E(i);R({configFiles:u(w),fileTypes:u(l),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:T})});return b.set(r,k),k}e.$Jr=g;function u(i){return Array.from(i.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function a(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/f.$Mk.GB).toFixed(2)}GB (${(S.freemem()/f.$Mk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$Xm.value()*100)}%`},o=S.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$Kr=a;async function E(i){try{const o=new Map,r=(0,C.$ic)(i,".vscode","launch.json"),t=await $.Promises.readFile(r),n=[],l=(0,s.$3m)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$_m)(l)==="object"&&l.configurations)for(const w of l.configurations){const D=w.type;D&&(o.has(D)?o.set(D,o.get(D)+1):o.set(D,1))}return u(o)}catch{return[]}}e.$Lr=E;let h=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const t=S.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/f.$Mk.GB).toFixed(2)}GB (${(S.freemem()/f.$Mk.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(c.$Xm.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,p.$Ir)(o.mainPID),this.k(o)]).then(async t=>{let[n,l]=t,w=this.m(o,n);return r.forEach(D=>{if((0,v.$xm)(D))w+=`
${D.errorMessage}`,l+=`
${D.errorMessage}`;else if(w+=`

Remote: ${D.hostName}`,D.processes&&(w+=`
${this.m(o,D.processes)}`),D.workspaceMetadata){l+=`
|  Remote: ${D.hostName}`;for(const I of Object.keys(D.workspaceMetadata)){const k=D.workspaceMetadata[I];let R=`${k.fileCount} files`;k.maxFilesReached&&(R=`more than ${R}`),l+=`|    Folder (${I}): ${R}`,l+=this.h(k)}}}),{processInfo:w,workspaceInfo:l}})}async getSystemInfo(o,r){const{memory:t,vmHint:n,os:l,cpus:w}=a(),D={os:l,memory:t,cpus:w,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(D.load=`${S.loadavg().map(I=>Math.round(I)).join(", ")}`),P.$k&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(o,r){const t=[];return(0,p.$Ir)(o.mainPID).then(async n=>(t.push(""),t.push(this.g(o)),t.push(""),t.push(this.m(o,n)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(o))),r.forEach(l=>{if((0,v.$xm)(l))t.push(`
${l.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${l.hostName}`),t.push(this.f(l.machineInfo)),l.processes&&t.push(this.m(o,l.processes)),l.workspaceMetadata)for(const w of Object.keys(l.workspaceMetadata)){const D=l.workspaceMetadata[w];let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),t.push(`Folder (${w}): ${I}`),t.push(this.h(D))}}),t.push(""),t.push(""),t.join(`
`)))}h(o){const r=[];let n=0;const l=(k,R)=>{const L=` ${k}(${R})`;n+L.length>60?(r.push(w),w="|                 ",n=w.length):n+=L.length,w+=L};let w="|      File types:";const D=10,I=o.fileTypes.length>D?D:o.fileTypes.length;for(let k=0;k<I;k++){const R=o.fileTypes[k];l(R.name,R.count)}if(r.push(w),o.configFiles.length>=0&&(w="|      Conf files:",n=0,o.configFiles.forEach(k=>{l(k.name,k.count)}),r.push(w)),o.launchConfigFiles.length>0){let k="|      Launch Configs:";o.launchConfigFiles.forEach(R=>{const L=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;k+=L}),r.push(k)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${o[t]}`).join(`
                  `)}k(o){const r=[],t=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(l=>{const w=d.URI.revive(l);if(w.scheme===M.Schemas.file){const D=w.fsPath;t.push(g(D,["node_modules",".git"]).then(I=>{let k=`${I.fileCount} files`;I.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,C.$mc)(D)}): ${k}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${I.toString()})`)}))}else r.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const t=new Map;o.windows.forEach(l=>t.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:w})=>t.set(l,w));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,t,n,r,0),n.join(`
`)}n(o,r,t,n,l){const w=l===0;let D;w?D=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?D=r.get(n.pid):D=`${"  ".repeat(l)} ${n.name}`;const I=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/f.$Mk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(o,r,t,k,l+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:t}of o.folders){const n=d.URI.revive(t);if(n.scheme!==M.Schemas.file)continue;const l=n.fsPath;try{(await g(l,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const t=d.URI.revive(r);if(t.scheme!==M.Schemas.file)continue;const n=t.fsPath;try{const l=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(w=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),l.launchConfigFiles.forEach(w=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),l.configFiles.forEach(w=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};e.$Mr=h,e.$Mr=h=ve([te(0,m.$il),te(1,y.$vj)],h)}),define(re[251],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s9b=e.$r9b=void 0;class S{constructor(M){this.b=M}listen(M,C){throw new Error(`Event not found: ${C}`)}call(M,C,{eventName:P,data:d}){return this.b.forEach(c=>c.log(P,d)),Promise.resolve(null)}}e.$r9b=S;class A{constructor(M){this.b=M}log(M,C){return this.b.call("log",{eventName:M,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$s9b=A}),define(re[52],oe([0,1,38,12,3,17,59,122,26]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$po=c;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=$,e.$ro=new $;class p{async publicLog(n,l,w){}async publicLogError(n,l,w){}}e.$so=p,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function v(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(w,D)=>{const I=w?new Set([...w.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:I}},1e3,!0)(w=>{w.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,M.$si)(w.source),configurationKeys:Array.from(w.affectedKeys)})})}e.$wo=v;function f(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$xo=f;function y(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$yo=y;function m(t){const n=t.getValue(d.$ql),l=t.getValue(d.$rl);if(t.getValue(d.$sl)===!1||l===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=m;function b(t){const n={},l={},w={};a(t,w);for(let D in w){D=D.length>150?D.substr(D.length-149):D;const I=w[D];typeof I=="number"?l[D]=I:typeof I=="boolean"?l[D]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${I.length}`),n[D]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[D]=I)}return{properties:n,measurements:l}}e.$Ao=b;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const n=(0,C.$2k)(t);return g.has(n)?n:"other"}e.$Bo=u;function a(t,n,l=0,w){if(t)for(const D of Object.getOwnPropertyNames(t)){const I=t[D],k=w?w+D:D;Array.isArray(I)?n[k]=(0,S.$fn)(I):I instanceof Date?n[k]=I.toISOString():(0,A.$Ef)(I)?l<2?a(I,n,l+1,k+"."):n[k]=(0,S.$fn)(I):n[k]=I}}function E(t,n){const l=t.msftInternalDomains||[],w=n.getValue("telemetry.internalTesting");return(0,P.$oo)(l)||w}e.$Co=E;function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Do=h;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let l=t;const w=[];for(const R of n)for(;;){const L=R.exec(t);if(!L)break;w.push([L.index,R.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(l="";;){const R=I.exec(t);if(!R)break;const L=w.some(([T,N])=>R.index<N&&T<I.lastIndex);!D.test(R[0])&&!L&&(l+=t.substring(k,R.index)+"<REDACTED: user-file-path>",k=I.lastIndex)}return k<t.length&&(l+=t.substr(k)),l}function o(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of n)if(l.regex.test(t))return`<REDACTED: ${l.label}>`;return t}function r(t,n){return(0,S.$cn)(t,l=>{if(l instanceof c||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let w=l.replaceAll("%20"," ");w=i(w,n);for(const D of n)w=w.replace(D,"");return w=o(w),w}})}e.$Eo=r}),define(re[123],oe([0,1,27,117,120,4,7,14,35,52]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function $(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,S.$1e)(r.id,t.id)===0}e.$Fo=$;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(t){const n=t.manifest?t.manifest.version:t.version,l=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new v(t.identifier,n,l)}static parse(t){const n=p.exec(t);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,l="undefined"){this.version=n,this.targetPlatform=l,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof v?$(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Go=v;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const t=f.exec(r);return t&&t[1]?[b(t[1]),t[2]]:[b(r),void 0]}e.$Ho=y;function m(r,t){return`${r}.${t}`}e.$Io=m;function b(r){return r.toLowerCase()}e.$Jo=b;function g(r,t){return b(m(r??s.$8l,t))}e.$Ko=g;function u(r,t){const n=[],l=w=>{for(const D of n)if(D.some(I=>$(t(I),t(w))))return D;return null};for(const w of r){const D=l(w);D?D.push(w):n.push([w])}return n}e.$Lo=u;function a(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Mo=a;function E(r){return{id:new c.$po(r.identifier.id),name:new c.$po(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$No=E,e.$Oo=new s.$_l("pprice.better-merge");function h(r,t){const n=[],l=t.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const w=l.shift();if(w&&n.every(D=>!$(D.identifier,{id:w}))){const D=r.filter(I=>$(I.identifier,{id:w}));D.length===1&&(n.push(D[0]),l.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Po=h;async function i(r,t){if(!M.$k)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){t.debug("Error while getting the os-release file.",(0,P.$9)(w))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,t){const n=await i(r,t),l=(0,A.$_n)(n?"alpine":M.$u,d.$dc);return t.debug("ComputeTargetPlatform:",l),l}e.$Qo=o}),define(re[252],oe([0,1,206,52]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;async function s(M,C,P,d,c,$,p){const v={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${C.nameShort})`};if((0,A.$xo)(C,P)&&(0,A.$zo)(d)===3){const f=await(0,S.$fp)(P,c,$);v["X-Market-User-Id"]=f,v["VSCode-SessionId"]=p.machineId||f}return v}e.$gp=s}),define(re[253],oe([0,1,2,38,4,27,185,17,58,79,25,43,26,52]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,u,a){this.k=u,this.l=a,this.d={},this.i=new S.$Qc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$Je)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Je)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(v.$ql)||E.affectsConfiguration(v.$sl)||E.affectsConfiguration(v.$rl))&&this.m()}))}setExperimentProperty(g,u){this.d[g]=u}m(){let g=(0,f.$zo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const a=u.usage?3:u.error?2:0;g=Math.min(g,a)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,u,a){this.g<u||(a=(0,A.$dn)(a,this.d),a=(0,f.$Eo)(a,this.j),a=(0,A.$dn)(a,this.c),this.b.forEach(E=>E.log(g,a)))}publicLog(g,u){this.n(g,3,u)}publicLog2(g,u){this.publicLog(g,u)}publicLogError(g,u){this.h&&this.n(g,2,u)}publicLogError2(g,u){this.publicLogError(g,u)}};e.$7q=y,e.$7q=y=ve([te(1,P.$pi),te(2,$.$vj)],y);function m(){const b=(0,C.localize)(0,null,c.default.nameLong),g=c.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=s.$o?"":(0,C.localize)(3,null),a=(0,C.localize)(4,null),E=(0,C.localize)(5,null),h=(0,C.localize)(6,null),i=(0,C.localize)(7,null),o=`
|       | ${a} | ${E} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${b} ${g} ${u}

&nbsp;

${i}
${o}

&nbsp;

${r}
`}p.$mn.as(d.$rn.Configuration).registerConfiguration({id:v.$pl,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[v.$ql]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.$mn.as(d.$rn.Configuration).registerConfiguration({id:v.$pl,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[v.$sl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,C.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,C.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${v.$ql}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[254],oe([0,1,4,88,26]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U9b=e.$T9b=void 0;async function M(P,d){let c=P.getItem(s.$nl);return(typeof c!="string"||S.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,A.$Ym)(d.error.bind(d))),c}e.$T9b=M;async function C(P,d){let c=P.getItem(s.$ol);return typeof c!="string"&&(c=await(0,A.$Zm)(d.error.bind(d))),c}e.$U9b=C}),define(re[255],oe([0,1,26,254]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=e.$V9b=void 0;async function s(C,P){const d=await(0,A.$T9b)(C,P);return C.setItem(S.$nl,d),d}e.$V9b=s;async function M(C,P){const d=await(0,A.$U9b)(C,P);return C.setItem(S.$ol,d),d}e.$W9b=M}),define(re[124],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(re[256],oe([0,1,4,124]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;const s=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor($){this.collections=$,this.a=new Map,this.b=new Map,$.forEach((p,v)=>{this.d(p,v);const f=p.map.entries();let y=f.next();for(;!y.done;){const m=y.value[1],b=y.value[0];let g=this.a.get(b);if(g||(g=[],this.a.set(b,g)),g.length>0&&g[0].type===A.EnvironmentVariableMutatorType.Replace){y=f.next();continue}const u={extensionIdentifier:v,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};u.scope||delete u.scope,g.unshift(u),y=f.next()}})}async applyToProcessEnvironment($,p,v){let f;S.$i&&(f={},Object.keys($).forEach(y=>f[y.toLowerCase()]=y));for(const[y,m]of this.getVariableMap(p)){const b=S.$i&&f[y.toLowerCase()]||y;for(const g of m){const u=v?await v(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case A.EnvironmentVariableMutatorType.Append:$[b]=($[b]||"")+u;break;case A.EnvironmentVariableMutatorType.Prepend:$[b]=u+($[b]||"");break;case A.EnvironmentVariableMutatorType.Replace:$[b]=u;break}if(g.options?.applyAtShellIntegration??!1){const a=`VSCODE_ENV_${s.get(g.type)}`;$[a]=($[a]?$[a]+":":"")+y+"="+this.c(u)}}}}c($){return $.replaceAll(":","\\x3a")}diff($,p){const v=new Map,f=new Map,y=new Map;if($.getVariableMap(p).forEach((m,b)=>{const g=this.getVariableMap(p).get(b),u=P(m,g);u&&v.set(b,u)}),this.getVariableMap(p).forEach((m,b)=>{const g=$.getVariableMap(p).get(b),u=P(m,g);u&&y.set(b,u)}),this.getVariableMap(p).forEach((m,b)=>{const g=$.getVariableMap(p).get(b),u=d(m,g);u&&f.set(b,u)}),!(v.size===0&&f.size===0&&y.size===0))return{added:v,changed:f,removed:y}}getVariableMap($){const p=new Map;for(const v of this.a.values()){const f=v.filter(y=>C(y,$));f.length>0&&p.set(f[0].variable,f)}return p}getDescriptionMap($){const p=new Map;for(const v of this.b.values()){const f=v.filter(y=>C(y,$,!0));for(const y of f)p.set(y.extensionIdentifier,y.description)}return p}d($,p){if(!$.descriptionMap)return;const v=$.descriptionMap.entries();let f=v.next();for(;!f.done;){const y=f.value[1],m=f.value[0];let b=this.b.get(m);b||(b=[],this.b.set(m,b));const g={extensionIdentifier:p,scope:y.scope,description:y.description};g.scope||delete g.scope,b.push(g),f=v.next()}}}e.$wr=M;function C(c,$,p=!1){return c.scope?!!(c.scope.workspaceFolder&&$?.workspaceFolder&&c.scope.workspaceFolder.index===$.workspaceFolder.index):p?$===c.scope:!0}function P(c,$){if(!$)return c;const p=new Set;$.forEach(f=>p.add(f.extensionIdentifier));const v=[];return c.forEach(f=>{p.has(f.extensionIdentifier)||v.push(f)}),v.length===0?void 0:v}function d(c,$){if(!$)return;const p=new Map;$.forEach(f=>p.set(f.extensionIdentifier,f));const v=[];return c.forEach(f=>{const y=p.get(f.extensionIdentifier);y&&(f.type!==y.type||f.value!==y.value||f.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&v.push(y)}),v.length===0?void 0:v}}),define(re[257],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function S(d){return[...d.entries()]}e.$qr=S;function A(d){return d?[...d.entries()]:[]}e.$rr=A;function s(d){return new Map(d)}e.$sr=s;function M(d){return new Map(d??[])}e.$tr=M;function C(d){return Array.from(d.entries()).map(c=>[c[0],S(c[1].map),A(c[1].descriptionMap)])}e.$ur=C;function P(d){return new Map(d.map(c=>[c[0],{map:s(c[1]),descriptionMap:M(c[2])}]))}e.$vr=P}),define(re[258],oe([0,1,8,22,3,2,5]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;let P=class extends M.$Rc{constructor(c,$){super(),this.h=$,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Rd),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,M.$Pc)(()=>{for(const p of this.f.values())(0,M.$Mc)(p)}))}createRequest(c){return new Promise(($,p)=>{const v=++this.a;this.c.set(v,$),this.g.fire({requestId:v,...c});const f=new A.$2d;(0,S.$Yg)(this.b,f.token).then(()=>p(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,M.$Pc)(()=>f.cancel())])})}acceptReply(c,$){const p=this.c.get(c);p?(this.c.delete(c),(0,M.$Mc)(this.f.get(c)||[]),this.f.delete(c),p($)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$hr=P,e.$hr=P=ve([te(1,C.$dj)],P)}),define(re[125],oe([0,1,6,114,43]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ar=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$_q=void 0,e.$_q=new A.$aj("terminalTabFocusMode",!1,!0);var M;(function(h){h.AutomationProfile="terminal.integrated.automationProfile.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var C;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",h.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",h.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",h.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var P;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(P||(e.PosixShellType=P={}));var d;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(d||(e.WindowsShellType=d={}));var c;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var $;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})($||(e.TerminalIpcChannels=$={}));var p;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.$ar=(0,S.$Vh)("ptyService");var v;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var f;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var y;(function(h){h.TerminalView="view",h.Editor="editor"})(y||(e.TerminalLocationString=y={}));var m;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var b;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var g;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var u;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(u||(e.ShellIntegrationStatus=u={}));var a;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(a||(e.TerminalExitReason=a={})),e.$br={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const o=this.b(i.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$mn.add(e.$br.Backend,new E),e.$cr=(0,S.$Vh)("localPtyService"),e.$dr=(0,S.$Vh)("terminalLogService")}),define(re[259],oe([0,1,75,7,187,102]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=e.$ir=void 0;function C(v,f){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...v.map(m=>({name:m.profileName,description:P(m)}))),f&&y.push(...f.map(m=>({name:m.title,description:d(m)}))),{values:y.map(m=>m.name),markdownDescriptions:y.map(m=>m.description)}}e.$ir=C;function P(v){let f=`$(${M.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:S.$1j.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?f+=`
- args: "${v.args}"`:f+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(f+=`
- overrideName: ${v.overrideName}`),v.color&&(f+=`
- color: ${v.color}`),v.env&&(f+=`
- env: ${JSON.stringify(v.env)}`),f}function d(v){return`$(${M.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:S.$1j.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function c(v,f){if(!v&&!f)return!0;if(typeof v=="string"&&typeof f=="string")return v===f;if(Array.isArray(v)&&Array.isArray(f)){if(v.length!==f.length)return!1;for(let y=0;y<v.length;y++)if(v[y]!==f[y])return!1;return!0}return!1}e.$jr=c;function $(v,f){if(!v&&!f)return!0;if(!v||!f)return!1;if(M.ThemeIcon.isThemeIcon(v)&&M.ThemeIcon.isThemeIcon(f))return v.id===f.id&&v.color===f.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof f=="object"&&"light"in f&&"dark"in f){const y=v,m=f;if((A.URI.isUri(y.light)||p(y.light))&&(A.URI.isUri(y.dark)||p(y.dark))&&(A.URI.isUri(m.light)||p(m.light))&&(A.URI.isUri(m.dark)||p(m.dark)))return y.light.path===m.light.path&&y.dark.path===m.dark.path}if(A.URI.isUri(v)&&A.URI.isUri(f)||p(v)||p(f)){const y=v,m=f;return y.path===m.path&&y.scheme===m.scheme}return!1}e.$kr=$;function p(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.$lr=p}),define(re[260],oe([0,1,75,4,186,58,43,259]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=e.$mr=void 0,e.$mr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$nr={type:"string",enum:Array.from((0,S.$Zj)(),b=>b.id),markdownEnumDescriptions:Array.from((0,S.$Zj)(),b=>`$(${b.id})`)};const d={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$nr},color:{description:(0,s.localize)(3,null),...e.$mr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...d}},$={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...d}};function p(b){const g=b===2?"linux":b===1?"osx":"windows";return(0,s.localize)(7,null,(0,A.$h)(b),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:p(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...d}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...d}},{type:"null"},c]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:p(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...d}},{type:"null"},c]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:p(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...d}},{type:"null"},c]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){C.$mn.as(M.$rn.Configuration).registerConfiguration(v),m()}e.$or=f;let y;function m(b,g){const u=C.$mn.as(M.$rn.Configuration);let a;b&&(a=(0,P.$ir)(b?.profiles,g));const E=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:b?.os===3?a?.values:void 0,markdownEnumDescriptions:b?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:b?.os===2?a?.values:void 0,markdownEnumDescriptions:b?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:b?.os===1?a?.values:void 0,markdownEnumDescriptions:b?.os===1?a?.markdownDescriptions:void 0}}},u.updateConfigurations({add:[y],remove:E?[E]:[]})}e.$pr=m}),define(re[261],oe([0,1,28,13,38,9,4,35,27,12,21,124,257,256]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=e.$xr=void 0;function y(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$xr=y;async function m(t,n,l,w=P.env,D=$.Promises.exists){if(M.$hc(t))return await D(t)?t:void 0;if(n===void 0&&(n=P.cwd()),M.$lc(t)!=="."){const L=M.$ic(n,t);return await D(L)?L:void 0}const k=(0,s.$hn)(w,"PATH");if(l===void 0&&(0,c.$Cf)(k)&&(l=k.split(M.$sc)),l===void 0||l.length===0){const L=M.$ic(n,t);return await D(L)?L:void 0}for(const L of l){let T;if(M.$hc(L)?T=M.$ic(L,t):T=M.$ic(n,L,t),await D(T))return T;if(C.$i){let N=T+".com";if(await D(N)||(N=T+".exe",await D(N)))return N}}const R=M.$ic(n,t);return await D(R)?R:void 0}e.$yr=m;function b(t,n,l,w,D){const I=C.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||I)return;const k=t.args,R=P.$cc==="win32"?M.$mc(t.executable).toLowerCase():M.$mc(t.executable),L=M.$lc(A.$gg.asFileUri("").fsPath);let T;const N={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(N.VSCODE_NONCE=n.shellIntegration.nonce),C.$i){if(R==="pwsh.exe"||R==="powershell.exe")return!k||o(k)?T=a.get(u.WindowsPwsh):i(k)&&(T=a.get(u.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,d.$Ge)(T[T.length-1],L,""),{newArgs:T,envMixin:N}):void 0;w.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(R){case"bash":return!k||k.length===0?T=a.get(u.Bash):r(k)&&(N.VSCODE_SHELL_LOGIN="1",g(n,N),T=a.get(u.Bash)),T?(T=[...T],T[T.length-1]=(0,d.$Ge)(T[T.length-1],L),{newArgs:T,envMixin:N}):void 0;case"fish":{const K=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Q=M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return N.XDG_DATA_DIRS=`${K}:${Q}`,g(n,N),{newArgs:void 0,envMixin:N}}case"pwsh":return!k||o(k)?T=a.get(u.Pwsh):i(k)&&(T=a.get(u.PwshLogin)),T?(T=[...T],T[T.length-1]=(0,d.$Ge)(T[T.length-1],L,""),{newArgs:T,envMixin:N}):void 0;case"zsh":{if(!k||k.length===0?T=a.get(u.Zsh):r(k)?(T=a.get(u.ZshLogin),g(n,N)):(k===a.get(u.Zsh)||k===a.get(u.ZshLogin))&&(T=k),!T)return;T=[...T],T[T.length-1]=(0,d.$Ge)(T[T.length-1],L);let K;try{K=S.userInfo().username}catch{K="unknown"}const Q=M.$ic(S.tmpdir(),`${K}-${D.applicationName}-zsh`);N.ZDOTDIR=Q;const ae=l?.ZDOTDIR??S.homedir()??"~";N.USER_ZDOTDIR=ae;const ne=[];return ne.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$ic(Q,".zshrc")}),ne.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$ic(Q,".zprofile")}),ne.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$ic(Q,".zshenv")}),ne.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$ic(Q,".zlogin")}),{newArgs:T,envMixin:N,filesToCopy:ne}}}w.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$zr=b;function g(t,n){if(C.$j&&t.environmentVariableCollections){const l=(0,v.$vr)(t.environmentVariableCollections),D=new f.$wr(l).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),I=[];if(D)for(const k of D)k.type===p.EnvironmentVariableMutatorType.Prepend&&I.push(k.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var u;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(u||(u={}));const a=new Map;a.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),a.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),a.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),a.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),a.set(u.Zsh,["-i"]),a.set(u.ZshLogin,["-il"]),a.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],h=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(h.includes(t[0].toLowerCase())||h.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?h.includes(t.toLowerCase()):t.length===0||t?.length===1&&h.includes(t[0].toLowerCase())}function r(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(re[262],oe([0,1,48,75,9,4,12,21,106,261,113]),function(Z,e,S,A,s,M,C,P,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;var p;(function(l){l.UnixShellsPath="/etc/shells"})(p||(p={}));let v,f=!0;function y(l,w,D,I,k=process.env,R,L,T,N){return R=R||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},M.$i?m(D,R,k,L,I.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:I.getValue("terminal.integrated.profiles.windows"),typeof w=="string"?w:I.getValue("terminal.integrated.defaultProfile.windows"),N,T):r(R,L,D,l&&typeof l=="object"?{...l}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof w=="string"?w:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,T,k)}e.$Ar=y;async function m(l,w,D,I,k,R,L,T,N){const K=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Q=`${process.env.windir}\\${K?"Sysnative":"System32"}`;let ae=!1;(0,c.$xr)()>=16299&&(ae=!0),await a(T);const ne=new Map;if(l){ne.set("PowerShell",{source:"PowerShell",icon:A.$1j.terminalPowershell,isAutoDetected:!0}),ne.set("Windows PowerShell",{path:`${Q}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$1j.terminalPowershell,isAutoDetected:!0}),ne.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ne.set("Command Prompt",{path:`${Q}\\cmd.exe`,icon:A.$1j.terminalCmd,isAutoDetected:!0}),ne.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ne.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.$1j.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ne.set("Cmder",{path:`${Q}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}t(R,ne);const ce=await b(ne.entries(),L,w,D,I,N);if(l&&k)try{const X=await i(`${Q}\\${ae?"wsl":"bash"}.exe`,L);for(const Y of X)(!R||!(Y.profileName in R))&&ce.push(Y)}catch{f&&(I?.info("WSL is not installed, so could not detect WSL profiles"),f=!1)}return ce}async function b(l,w,D,I=process.env,k,R){const L=[];for(const[T,N]of l)L.push(g(T,N,w,D,I,k,R));return(await Promise.all(L)).filter(T=>!!T)}async function g(l,w,D,I,k=process.env,R,L){if(w===null)return;let T,N,K;if("source"in w&&!("path"in w)){const ce=v?.get(w.source);if(!ce)return;T=ce.paths,N=w.args||ce.args,w.icon?K=u(w.icon):ce.icon&&(K=ce.icon)}else T=Array.isArray(w.path)?w.path:[w.path],N=M.$i||Array.isArray(w.args)?w.args:void 0,K=u(w.icon);let Q;if(L){const ce=T.map(Y=>typeof Y=="string"?Y:Y.path),X=await L(ce);Q=new Array(T.length);for(let Y=0;Y<T.length;Y++)typeof T[Y]=="string"?Q[Y]=X[Y]:Q[Y]={path:X[Y],isUnsafe:!0}}else Q=T.slice();let ae;if(w.requiresPath){let ce;if((0,C.$Cf)(w.requiresPath)?ce=w.requiresPath:(ce=w.requiresPath.path,w.requiresPath.isUnsafe&&(ae=ce)),!await I.existsFile(ce))return}const ne=await n(l,D,Q,I,k,N,w.env,w.overrideName,w.isAutoDetected,ae);if(!ne){R?.debug("Terminal profile not validated",l,T);return}return ne.isAutoDetected=w.isAutoDetected,ne.icon=K,ne.color=w.color,ne}function u(l){return typeof l=="string"?{id:l}:l}async function a(l){if(v&&!l)return;const[w,D]=await Promise.all([E(),l||h()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:w,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:D,icon:A.$1j.terminalPowershell})}async function E(){const l=new Set,w=await(0,c.$yr)("git.exe");if(w){const k=(0,$.dirname)(w);l.add((0,$.resolve)(k,"../.."))}function D(k,R){R&&k.add(R)}D(l,process.env.ProgramW6432),D(l,process.env.ProgramFiles),D(l,process.env["ProgramFiles(X86)"]),D(l,`${process.env.LocalAppData}\\Program`);const I=[];for(const k of l)I.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function h(){const l=[];for await(const w of(0,d.$Dl)())l.push(w.exePath);return l}async function i(l,w){const D=[],I=await new Promise((L,T)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,K)=>{if(N)return T("Problem occurred when getting wsl distros");L(K)})});if(!I)return[];const k=new RegExp(/[\r?\n]/),R=I.split(k).filter(L=>L.trim().length>0&&L!=="");for(const L of R){if(L===""||L.startsWith("docker-desktop"))continue;const T=`${L} (WSL)`,N={profileName:T,path:l,args:["-d",`${L}`],isDefault:T===w,icon:o(L),isAutoDetected:!1};D.push(N)}return D}function o(l){return l.includes("Ubuntu")?A.$1j.terminalUbuntu:l.includes("Debian")?A.$1j.terminalDebian:A.$1j.terminalLinux}async function r(l,w,D,I,k,R,L,T){const N=new Map;if(D&&await l.existsFile("/etc/shells")){const K=(await l.readFile("/etc/shells")).toString(),Q=(R||K.split(`
`)).map(ne=>{const ce=ne.indexOf("#");return ce===-1?ne:ne.substring(0,ce)}).filter(ne=>ne.trim().length>0),ae=new Map;for(const ne of Q){let ce=(0,s.$mc)(ne),X=ae.get(ce)||0;X++,X>1&&(ce=`${ce} (${X})`),ae.set(ce,X),N.set(ce,{path:ne,isAutoDetected:!0})}}return t(I,N),await b(N.entries(),k,l,T,w,L)}function t(l,w){if(l)for(const[D,I]of Object.entries(l))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?w.delete(D):(I.icon=I.icon||w.get(D)?.icon,w.set(D,I))}async function n(l,w,D,I,k,R,L,T,N,K){if(D.length===0)return Promise.resolve(void 0);const Q=D.shift();if(Q==="")return n(l,w,D,I,k,R,L,T,N);const ae=typeof Q!="string"&&Q.isUnsafe,ne=typeof Q=="string"?Q:Q.path,ce={profileName:l,path:ne,args:R,env:L,overrideName:T,isAutoDetected:N,isDefault:l===w,isUnsafePath:ae,requiresUnsafePath:K};if((0,s.$mc)(ne)===ne){const Y=k.PATH?k.PATH.split(s.$sc):void 0,V=await(0,c.$yr)(ne,void 0,Y,void 0,I.existsFile);return V?(ce.path=V,ce.isFromPath=!0,ce):n(l,w,D,I,k,R)}return await I.existsFile((0,s.$gc)(ne))?ce:n(l,w,D,I,k,R,L,T,N)}}),define(re[263],oe([0,1,3,2,4,42,17,5,226,94,258,125,260,262,108,73]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;var b;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let g=class extends A.$Rc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(a,E,h,i){super(),this.M=a,this.N=E,this.O=h,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Rd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Rd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Rd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Rd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Rd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Rd),this.onProcessData=this.D.event,this.F=this.B(new S.$Rd),this.onProcessReady=this.F.event,this.G=this.B(new S.$Rd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Rd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Rd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Rd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Rd),this.onProcessExit=this.L.event,(0,v.$or)(),this.B(this.M),this.B((0,A.$Pc)(()=>this.W())),this.j=this.B(new $.$hr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,c.$Zl)(this.N,this.O,{_:[]},process.env)}catch(a){return this.O.error("ptyHost was unable to resolve shell environment",a),{}}}U(){const a=this.M.start(),E=a.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(a.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=b.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const i=M.ProxyChannel.toService(E.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(o=>this.D.fire(o))),this.B(i.onProcessReady(o=>this.F.fire(o))),this.B(i.onProcessExit(o=>this.L.fire(o))),this.B(i.onDidChangeProperty(o=>this.J.fire(o))),this.B(i.onProcessReplay(o=>this.G.fire(o))),this.B(i.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(i.onDidRequestDetach(o=>this.I.fire(o))),this.B(new d.$gr(this.P,E.getChannel(p.TerminalIpcChannels.Logger))),this.a=a,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[a,i]}async createProcess(a,E,h,i,o,r,t,n,l,w,D){const I=setTimeout(()=>this.$(),p.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(a,E,h,i,o,r,t,n,l,w,D);return clearTimeout(I),k}updateTitle(a,E,h){return this.f.updateTitle(a,E,h)}updateIcon(a,E,h,i){return this.f.updateIcon(a,E,h,i)}attachToProcess(a){return this.f.attachToProcess(a)}detachFromProcess(a,E){return this.f.detachFromProcess(a,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(a){return this.f.start(a)}shutdown(a,E){return this.f.shutdown(a,E)}input(a,E){return this.f.input(a,E)}processBinary(a,E){return this.f.processBinary(a,E)}resize(a,E,h){return this.f.resize(a,E,h)}clearBuffer(a){return this.f.clearBuffer(a)}acknowledgeDataEvent(a,E){return this.f.acknowledgeDataEvent(a,E)}setUnicodeVersion(a,E){return this.f.setUnicodeVersion(a,E)}getInitialCwd(a){return this.f.getInitialCwd(a)}getCwd(a){return this.f.getCwd(a)}async getLatency(){const a=new m.$Nd,E=await this.f.getLatency();return a.stop(),[{label:"ptyhostservice<->ptyhost",latency:a.elapsed()},...E]}orphanQuestionReply(a){return this.f.orphanQuestionReply(a)}installAutoReply(a,E){return this.f.installAutoReply(a,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(a){return this.f.uninstallAutoReply(a)}getDefaultSystemShell(a){return this.g?.getDefaultSystemShell(a)??(0,y.$Jl)(a??s.OS,process.env)}async getProfiles(a,E,h,i=!1){const o=await this.S();return(0,f.$Ar)(E,h,i,this.N,o,void 0,this.O,this.bb.bind(this,a))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(a,E){return this.f.getWslPath(a,E)}getRevivedPtyNewId(a,E){return this.f.getRevivedPtyNewId(a,E)}setTerminalLayoutInfo(a){return this.f.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return this.g?.getTerminalLayoutInfo(a)}async requestDetachInstance(a,E){return this.f.requestDetachInstance(a,E)}async acceptDetachInstanceReply(a,E){return this.f.acceptDetachInstanceReply(a,E)}async freePortKillProcess(a){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(a)}async serializeTerminalState(a){return this.f.serializeTerminalState(a)}async reviveTerminalProcesses(a,E,h){return this.f.reviveTerminalProcesses(a,E,h)}async refreshProperty(a,E){return this.f.refreshProperty(a,E)}async updateProperty(a,E,h){return this.f.updateProperty(a,E,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(a){this.ab(),this.s=setTimeout(()=>this.Y(),a?p.HeartbeatConstants.ConnectingBeatInterval:p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(a,E){return this.j.createRequest({workspaceId:a,originalText:E})}async acceptPtyHostResolvedVariables(a,E){this.j.acceptReply(a,E)}};e.$Br=g,e.$Br=g=ve([te(1,C.$pi),te(2,P.$dj),te(3,P.$ej)],g)}),define(re[69],oe([0,1,15,3,2,4,17,6,34]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=e.$k8b=void 0;const c="#FFFFFF",$="#1E1E1E",p="#000000",v="#FFFFFF",f="theme",y="themeBackground",m="windowSplash";e.$k8b=(0,P.$Vh)("themeMainService");let b=class extends s.$Rc{constructor(u,a){super(),this.b=u,this.c=a,this.a=this.B(new A.$Rd),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const u=this.getColorScheme();if(u.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return u.dark?p:v;let a=this.b.getItem(y,null);if(!a)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":a=c;break;case"hc-black":a=p;break;case"hc-light":a=v;break;default:a=$}return M.$j&&a.toUpperCase()===$&&(a="#171717"),a}saveWindowSplash(u,a){this.b.setItems([{key:f,data:a.baseTheme},{key:y,data:a.colorInfo.background},{key:m,data:a}]),typeof u=="number"&&this.f(u,a)}f(u,a){for(const E of S.BrowserWindow.getAllWindows())if(E.id===u){E.setBackgroundColor(a.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$l8b=b,e.$l8b=b=ve([te(0,d.$ON),te(1,C.$pi)],b)}),define(re[126],oe([0,1,3,17,6,5]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,s.$Vh)("tunnelService"),e.$ev=(0,s.$Vh)("sharedTunnelsService");var C;(function(b){b.Http="http",b.Https="https"})(C||(e.TunnelProtocol=C={}));var P;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(b){return!!b.forwardPort}e.$fv=d;var c;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function $(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(g)return{address:g[1],port:+g[2]}}e.$gv=$,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(b){return e.$hv.indexOf(b)>=0}e.$iv=p,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(b){return e.$jv.indexOf(b)>=0}e.$kv=v;function f(b,g,u,a){if(u===1)return!1;if(u===2&&v(g)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(E?.length===4&&parseInt(E[1])>=18)return!1}return b<1024}e.$lv=f;class y{constructor(g,u,a){this.remoteAddress=g,this.localAddress=u,this.b=a,this.a=new S.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=y;let m=class{constructor(g,u){this.j=g,this.k=u,this.a=new S.$Rd,this.onTunnelOpened=this.a.event,this.b=new S.$Rd,this.onTunnelClosed=this.b.event,this.c=new S.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const g=this.k.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.f=g,g?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.g=g.elevation,this.h=g.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const g=[],u=Array.from(this.e.values());for(const a of u){const E=Array.from(a.values());for(const h of E){const i=await h.value;i&&typeof i!="string"&&g.push(i)}}return g}async dispose(){for(const g of this.e.values()){for(const{value:u}of g.values())await u.then(a=>typeof a!="string"?a?.dispose():void 0);g.clear()}this.e.clear()}setEnvironmentTunnel(g,u,a,E,h){this.p(g,u,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:u,localAddress:a,privacy:E,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,u){(v(g)||p(g))&&(g=e.$hv[0]);const a=this.r(g,u);if(a)return++a.refcount,a.value}openTunnel(g,u,a,E,h,i=!1,o,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${a} on local port ${h}.`);const t=this.f??g;if(!t)return;if(u||(u="localhost"),E||(E=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,u,a,E,h,i,o,r);return n?n.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,a),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.n(l);return(l.tunnelRemoteHost!==u||l.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&l.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const u=this.e.get(g.tunnelRemoteHost);if(u){const a=u.get(g.tunnelRemotePort);a&&(a.refcount--,await this.o(g.tunnelRemoteHost,g.tunnelRemotePort,a))}}}}async o(g,u,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${u}.`);const E=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(g)&&this.e.get(g).delete(u),E}}async closeTunnel(g,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${u} `);const a=this.e.get(g);if(a&&a.has(u)){const E=a.get(u);E.refcount=0,await this.o(g,u,E)}}p(g,u,a){this.e.has(g)||this.e.set(g,new Map),this.e.get(g).set(u,{refcount:1,value:a})}async q(g,u){const a=this.e.get(g);if(a){const E=a.get(u),h=E?await E.value:void 0;(!h||typeof h=="string")&&a.delete(u),a.size===0&&this.e.delete(g)}}r(g,u){const a=[g];p(g)?(a.push(...e.$hv),a.push(...e.$jv)):v(g)&&a.push(...e.$jv);const E=a.map(h=>this.e.get(h));for(const h of E){const i=h?.get(u);if(i)return i}}canTunnel(g){return!!$(g)}t(g,u,a,E,h,i,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${a} on local port ${E}.`);const r=a;this.i.add(r);const t=E===void 0?a:E,n={elevationRequired:h?this.isPortPrivileged(t):!1},l={remoteAddress:{host:u,port:a},localAddressPort:E,privacy:i,public:i?i!==P.Private:void 0,protocol:o},w=g.forwardPort(l,n);return w?(this.p(u,a,w),w.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),w}};e.$nv=m,e.$nv=m=ve([te(0,M.$dj),te(1,A.$pi)],m)}),define(re[49],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WU=e.$VU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(A||(e.StateType=A={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$VU={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$WU=(0,S.$Vh)("updateService")}),define(re[264],oe([0,1,4,188,58,43]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$mn.as(s.$rn.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(re[265],oe([0,1,3,49]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u9b=e.$t9b=void 0;class s{constructor(P){this.a=P}listen(P,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(P,d,c){switch(d){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${d}`)}}e.$t9b=s;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Rd,this.onStateChange=this.a.event,this.b=A.$VU.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$u9b=M}),define(re[40],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=void 0,e.$Ok=(0,S.$Vh)("IUriIdentityService")}),define(re[266],oe([0,1,40,207,16,19,141,3,2]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;class c{static{this._clock=0}constructor(v){this.uri=v,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let $=class{constructor(v){this.g=v,this.c=new d.$Qc,this.f=2**16;const f=new Map,y=m=>{let b=f.get(m.scheme);return b===void 0&&(b=v.hasProvider(m)&&!this.g.hasCapability(m,1024),f.set(m.scheme,b)),b};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(m=>{f.delete(m.scheme)})),this.extUri=new M.$og(y),this.d=new C.$Er((m,b)=>this.extUri.compare(m,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,M.$Ag)(v));const f=this.d.get(v);return f?f.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new c(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((y,m)=>y[1].time<m[1].time?1:y[1].time>m[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let y=0;y<f;y++)this.d.set(v[y][0],v[y][1].touch())}};e.$Fr=$,e.$Fr=$=ve([te(0,s.$ek)],$),(0,A.$Cr)(S.$Ok,$,1)}),define(re[127],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KU=void 0,e.$KU=(0,S.$Vh)("urlService")}),define(re[267],oe([0,1,7]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D9b=e.$C9b=e.$B9b=void 0;class A{constructor(P){this.a=P}listen(P,d){throw new Error(`Event not found: ${d}`)}call(P,d,c){switch(d){case"handleURL":return this.a.handleURL(S.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${d}`)}}e.$B9b=A;class s{constructor(P){this.a=P}handleURL(P,d){return this.a.call("handleURL",[P.toJSON(),d])}}e.$C9b=s;class M{constructor(P,d){this.a=P,this.b=d}async routeCall(P,d,c,$){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(c)&&c.length>0){const p=S.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",p.toString(!0)),p.query){const v=/\bwindowId=(\d+)/.exec(p.query);if(v){const f=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,p.toString(!0));const y=new RegExp(`window:${f}`),m=P.connections.find(b=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",b.ctx),y.test(b.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",p.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",p.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",p.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,d,c,$)}routeEvent(P,d){throw new Error(`Event not found: ${d}`)}}e.$D9b=M}),define(re[268],oe([0,1,8,2,7,25]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MU=e.$LU=void 0;class C extends A.$Rc{constructor(){super(...arguments),this.a=new Set}open(c,$){const p=[...this.a.values()];return(0,S.$2g)(p.map(v=>()=>v.handleURL(c,$)),void 0,!1).then(v=>v||!1)}registerHandler(c){return this.a.add(c),(0,A.$Pc)(()=>this.a.delete(c))}}e.$LU=C;let P=class extends C{constructor(c){super(),this.b=c}create(c){let{authority:$,path:p,query:v,fragment:f}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return $&&p&&p.indexOf("/")!==0&&(p=`/${p}`),s.URI.from({scheme:this.b.urlProtocol,authority:$,path:p,query:v,fragment:f})}};e.$MU=P,e.$MU=P=ve([te(0,M.$vj)],P)}),define(re[269],oe([0,1,15,8,3,2,4,7]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=void 0;class d extends M.$Rc{constructor($,p,v,f,y,m){if(super(),this.c=p,this.f=m,this.a=[],this.b=0,$&&(m.trace("ElectronURLListener initialUrisToHandle:",$.map(u=>u.originalUrl)),this.a=$),C.$i){const u=f.isBuilt?[]:[`"${f.appRoot}"`];u.push("--open-url","--"),S.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,u)}const b=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(u,a)=>({event:u,url:a})),({event:u,url:a})=>(u.preventDefault(),a));this.B(b(u=>{const a=this.g(u);a&&this.c.open(a,{originalUrl:u})})),v.getWindows().filter(u=>u.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g($){try{return P.URI.parse($)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const $=[];for(const p of this.a)await this.c.open(p.uri,{originalUrl:p.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",p.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",p.originalUrl),$.push(p));$.length!==0&&(this.a=$,(0,A.$Zg)(()=>this.h(),500,this.q))}}e.$E9b=d}),define(re[270],oe([0,1,3,2,16,57,31]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=void 0;class P extends A.$Rc{constructor(c,$,p,v,f,y){super(),this.f=c,this.g=$,this.h=p,this.j=v,this.m=f,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Rd),this.onDidChangeFile=this.a.event,this.b=M.$2h.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Ac(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,$){return this.g.open(this.t(c),$)}close(c){return this.g.close(c)}read(c,$,p,v,f){return this.g.read(c,$,p,v,f)}write(c,$,p,v,f){return this.g.write(c,$,p,v,f)}watch(c,$){this.b.set(c,c);const p=this.g.watch(this.t(c),$);return(0,A.$Pc)(()=>{this.b.delete(c),p.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,$,p){return this.g.rename(this.t(c),this.t($),p)}readFile(c,$){return this.g.readFile(this.t(c),$)}readFileStream(c,$,p){return this.g.readFileStream(this.t(c),$,p)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,$,p){return this.g.writeFile(this.t(c),$,p)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,$){return this.g.delete(this.t(c),$)}copy(c,$,p){if((0,s.$ik)(this.g))return this.g.copy(this.t(c),this.t($),p);throw new Error("copy not supported")}cloneFile(c,$){if((0,s.$jk)(this.g))return this.g.cloneFile(this.t(c),this.t($));throw new Error("clone not supported")}s(c){const $=[];for(const p of c){if(p.resource.scheme!==this.f)continue;const v=this.u(p.resource);this.b.findSubstr(v)&&$.push({resource:v,type:p.type,cId:p.cId})}$.length&&(this.n.debug("User data changed"),this.a.fire($))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$f0b=P}),define(re[271],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y9b=void 0,e.$Y9b="utilityProcessWorker"}),define(re[272],oe([0,1,6]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F9b=void 0,e.$F9b=(0,S.$Vh)("webviewManagerService")}),define(re[273],oe([0,1,15,2,13,7]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=void 0;class C extends A.$Rc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const d=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,d)}b(d,c){try{const $=M.URI.parse(d.url),p=C.a.get($.path);if(typeof p=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${p}`,f=s.$gg.asFileUri(v);return c({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$G9b=C}),define(re[60],oe([0,1,4]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=void 0,e.$mC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(p){return typeof p.parentId=="number"}e.$nC=A;function s(p){return!!p.workspaceUri}e.$oC=s;function M(p){return!!p.folderUri}e.$pC=M;function C(p){return!!p.fileUri}e.$qC=C;function P(p){const v=d(p),f=p.getValue("window.menuBarVisibility");return f==="default"||v==="native"&&f==="compact"||S.$j&&S.$m?"classic":f}e.$rC=P;function d(p){if(S.$o)return"custom";const v=p.getValue("window");if(v){if(S.$j&&v.nativeTabs===!0||S.$j&&v.nativeFullScreen===!1)return"native";const m=v.titleBarStyle;if(m==="native"||m==="custom")return m}return S.$k?"native":"custom"}e.$sC=d;function c(p){return!(!S.$i||S.$o||d(p)==="native")}e.$tC=c;function $(p=0){return Math.pow(1.2,p)}e.$uC=$}),define(re[128],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$87b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var A;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$87b=s;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var C;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(re[274],oe([0,1,8,3,2]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=void 0;class M extends s.$Rc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:d,getActiveWindowId:c}){super(),this.a=this.B(new s.$Qc),A.Event.latch(A.Event.any(P,d))(this.f,this,this.a),this.b=(0,S.$Lg)(()=>c()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$M9b=M}),define(re[30],oe([0,1,192,9,57,19,7,6,13]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,P.$Vh)("contextService");function c(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$6h=c;function $(t){return typeof t?.id=="string"&&!c(t)&&!v(t)}e.$7h=$,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function p(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,A.$mc)(t)}:n?e.$8h:e.$9h;const l=t;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$0h=p;function v(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$$h=v;function f(t){const n=t;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const l=t;if(l?.configPath)return{id:l.id,configPath:C.URI.revive(l.configPath)};if(t?.id)return{id:t.id}}e.$_h=f;var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$ai=m;function b(t){const n=t;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$bi=b;class g{constructor(n,l,w,D,I){this.h=n,this.j=w,this.k=D,this.l=I,this.c=s.$2h.forUris(this.l,()=>!0),this.folders=l}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$2h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=g;class u{constructor(n,l){this.raw=l,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$zg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=u;function a(t){return new u({uri:t,index:0,name:(0,M.$vg)(t)},{uri:t.toString()})}e.$ei=a,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,S.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function E(t,n){return M.$qg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$ji=E;function h(t){let n;return C.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===d.Schemas.tmp}e.$ki=h,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$li}e.$mi=i;function o(t,n){return!E(t,n)&&!h(t)}e.$ni=o;function r(t){return(typeof t=="string"?(0,A.$nc)(t):(0,M.$xg)(t))===e.$gi}e.$oi=r}),define(re[53],oe([0,1,15,8,45,47,2,85,4,21,167,115,6,5,25,30]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r8b=e.$q8b=void 0,e.$q8b=(0,v.$Vh)("dialogMainService");let b=class{constructor(u,a){this.d=u,this.e=a,this.a=new Map,this.b=new Map,this.c=new A.$5g}pickFileFolder(u,a){return this.f({...u,pickFolders:!0,pickFiles:!0,title:(0,$.localize)(0,null)},a)}pickFolder(u,a){return this.f({...u,pickFolders:!0,title:(0,$.localize)(1,null)},a)}pickFile(u,a){return this.f({...u,pickFiles:!0,title:(0,$.localize)(2,null)},a)}pickWorkspace(u,a){const E=(0,$.localize)(3,null),h=(0,M.$Fv)((0,$.localize)(4,null)),i=m.$hi;return this.f({...u,pickFiles:!0,title:E,filters:i,buttonLabel:h},a)}async f(u,a){const E={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(E.properties=void 0,u.pickFiles&&u.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),d.$j&&E.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(E,(a||S.BrowserWindow.getFocusedWindow())??void 0);if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}g(u){if(u){let a=this.b.get(u.id);return a||(a=new A.$5g,this.b.set(u.id,a)),a}else return this.c}showMessageBox(u,a){return this.g(a).queue(async()=>{const{options:E,buttonIndeces:h}=(0,p.$Mv)(u,this.e);let i;return a?i=await S.dialog.showMessageBox(a,E):i=await S.dialog.showMessageBox(E),{response:h[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(u,a){const E=this.j(u,a);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(a).queue(async()=>{let h;return a?h=await S.dialog.showSaveDialog(a,u):h=await S.dialog.showSaveDialog(u),h.filePath=this.h(h.filePath),h})}finally{(0,C.$Mc)(E)}}h(u){return u&&d.$j&&(u=(0,P.$ul)(u)),u}i(u){return u.map(a=>this.h(a))}async showOpenDialog(u,a){u.defaultPath&&(await c.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const E=this.j(u,a);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(a).queue(async()=>{let h;return a?h=await S.dialog.showOpenDialog(a,u):h=await S.dialog.showOpenDialog(u),h.filePaths=this.i(h.filePaths),h})}finally{(0,C.$Mc)(E)}}j(u,a){if(!a)return C.$Rc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let E=this.a.get(a.id);E||(E=new Set,this.a.set(a.id,E));const h=(0,s.$Ji)(u);if(!E.has(h))return this.d.trace("[DialogMainService]: new file dialog lock created",u),E.add(h),(0,C.$Pc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),E?.delete(h),E?.size===0&&this.a.delete(a.id)})}};e.$r8b=b,e.$r8b=b=ve([te(0,f.$dj),te(1,y.$vj)],b)}),define(re[275],oe([0,1,3,2,77,30]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q9b=void 0;class C extends A.$Rc{static{this.a=100}constructor(d,c){super(),this.f=d,this.g=c,this.b=this.B(new S.$Rd),this.c=new Map,this.h(c.applicationStorage,this.b)}h(d,c){this.B(S.Event.debounce(d.onDidChangeStorage,($,p)=>($?$.push(p):$=[p],$),C.a)($=>{$.length&&c.fire(this.j($,d))}))}j(d,c){const $=new Map,p=new Set;return d.forEach(v=>{const f=c.get(v.key);typeof f=="string"?$.set(v.key,f):p.add(v.key)}),{changed:Array.from($.entries()),deleted:Array.from(p.values())}}listen(d,c,$){switch(c){case"onDidChangeStorage":{const p=$.profile?(0,s.$sh)($.profile):void 0;if(!p)return this.b.event;let v=this.c.get(p.id);return v||(v=this.B(new S.$Rd),this.h(this.g.profileStorage(p),v),this.c.set(p.id,v)),v.event}}throw new Error(`Event not found: ${c}`)}async call(d,c,$){const p=$.profile?(0,s.$sh)($.profile):void 0,v=(0,M.$_h)($.workspace),f=await this.m(p,v);switch(c){case"getItems":return Array.from(f.items.entries());case"updateItems":{const y=$;if(y.insert)for(const[m,b]of y.insert)f.set(m,b);y.delete?.forEach(m=>f.delete(m));break}case"optimize":return f.optimize();case"isUsed":{const y=$.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${c}`)}}async m(d,c){let $;c?$=this.g.workspaceStorage(c):d?$=this.g.profileStorage(d):$=this.g.applicationStorage;try{await $.init()}catch(p){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":d?"profile":"application"} storage due to ${p}`)}return $}}e.$q9b=C}),define(re[41],oe([0,1,45,3,2,19,7,189,37,16,6,5,30,31,40,8,32,27,12]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.ProfileResourceType=void 0;var a;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(a||(e.ProfileResourceType=a={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Pk=E,e.$Qk=(0,$.$Vh)("IUserDataProfilesService");function h(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:n}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Rk=h;function i(t,n,l,w,D,I){return{id:t,name:n,location:l,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:I&&D?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$zg)(l,"globalStorage"),settingsResource:I&&D?.useDefaultFlags?.settings?I.settingsResource:(0,M.$zg)(l,"settings.json"),keybindingsResource:I&&D?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$zg)(l,"keybindings.json"),tasksResource:I&&D?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$zg)(l,"tasks.json"),snippetsHome:I&&D?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$zg)(l,"snippets"),extensionsResource:I&&D?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$zg)(l,"extensions.json"),cacheHome:(0,M.$zg)(w,t),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$Sk=i;let o=class extends s.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,l,w,D){super(),this.t=n,this.u=l,this.w=w,this.y=D,this.f=!0,this.h=this.B(new A.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zc,emptyWindows:new Map},this.profilesHome=(0,M.$zg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$zg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),l=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,u.$Cf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}l.push(i((0,M.$wg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const w=new f.$zc,D=new Map;if(l.length)try{const I=this.Q();if(I.workspaces)for(const[k,R]of Object.entries(I.workspaces)){const L=C.URI.parse(k),T=l.find(N=>N.id===R);T&&w.set(L,T)}if(I.emptyWindows)for(const[k,R]of Object.entries(I.emptyWindows)){const L=l.find(T=>T.id===R);L&&D.set(k,L)}}catch(I){this.y.error(I)}this.z={profiles:l,workspaces:w,emptyWindows:D}}return this.z}D(){const n=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const l="Temp",w=new RegExp(`${(0,g.$Je)(l)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const R=w.exec(k.name),L=R?parseInt(R[1]):0;D=L>D?L:D}const I=`${l} ${D+1}`;return this.createProfile((0,S.$Ji)((0,b.$ig)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,l,w){return this.createProfile((0,S.$Ji)((0,b.$ig)()).toString(16),n,l,w)}async createProfile(n,l,w,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,l,w);return D&&await this.setProfileForWorkspace(D,I),I}async F(n,l,w){if(!(0,u.$Cf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(l);return D||(D=(async()=>{try{const I=this.profiles.find(L=>L.name===l||L.id===n);if(I)return I;const k=i(n,l,(0,M.$zg)(this.profilesHome,n),this.g,w,this.defaultProfile);await this.u.createFolder(k.location);const R=[];return this.j.fire({profile:k,join(L){R.push(L)}}),await m.Promises.settled(R),this.I([k],[],[]),k}finally{this.r.delete(l)}})(),this.r.set(l,D)),D}async updateProfile(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(D=>D.id===n.id);if(!w)throw new Error(`Profile '${n.name}' does not exist`);return w=i(w.id,l.name??w.name,w.location,this.g,{shortName:l.shortName??w.shortName,icon:l.icon===null?void 0:l.icon??w.icon,transient:l.transient??w.isTransient,useDefaultFlags:l.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(D=>D.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);const w=[];this.m.fire({profile:l,join(D){w.push(D)}});try{await Promise.allSettled(w)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(D){(0,c.$vk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(D=>D.id===l.id);if(!w)throw new Error(`Profile '${l.name}' does not exist`);this.L(n,w)}unsetWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(l=>l.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(n.map(l=>this.removeProfile(l)))}getProfileForWorkspace(n){const l=this.G(n);return C.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(n){return(0,v.$6h)(n)?n.uri:(0,v.$$h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location)))}I(n,l,w){const D=[...this.profiles,...n],I=[];this.s.profiles=[];for(let k of D)k.isDefault||l.some(R=>k.id===R.id)||(k=w.find(R=>k.id===R.id)??k,k.isTransient?this.s.profiles.push(k):I.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,l,w)}J(n,l,w){this.h.fire({added:n,removed:l,updated:w,all:this.profiles})}L(n,l,w){w=l?.isTransient?!0:w,w||this.L(n,void 0,!0);const D=this.G(n),I=w?this.s:this.C;C.URI.isUri(D)?(I.workspaces.delete(D),l&&I.workspaces.set(D,l)):(I.emptyWindows.delete(D),l&&I.emptyWindows.set(D,l)),w||this.M()}M(){const n={};for(const[w,D]of this.C.workspaces.entries())n[w.toString()]=D.id;const l={};for(const[w,D]of this.C.emptyWindows.entries())l[w.toString()]=D.id;this.R({workspaces:n,emptyWindows:l}),this.z=void 0}N(n){const l={},w=this.D();if(n.workspaces)for(const[I,k]of Object.entries(n.workspaces)){const R=C.URI.parse(k);l[I]=this.w.extUri.isEqual(R,w.location)?w.id:this.w.extUri.basename(R)}const D={};if(n.emptyWindows)for(const[I,k]of Object.entries(n.emptyWindows)){const R=C.URI.parse(k);D[I]=this.w.extUri.isEqual(R,w.location)?w.id:this.w.extUri.basename(R)}return{workspaces:l,emptyWindows:D}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Tk=o,e.$Tk=o=ve([te(0,d.$3h),te(1,c.$ek),te(2,y.$Ok),te(3,p.$dj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Uk=r}),define(re[81],oe([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,26]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class a extends Error{constructor(r,t){super(r),this.code=t}}e.$zp=a,e.$Ap=(0,p.$Vh)("IExtensionsProfileScannerService");let E=class extends s.$Rc{constructor(r,t,n,l,w,D){super(),this.j=r,this.m=t,this.n=n,this.r=l,this.s=w,this.t=D,this.b=this.B(new M.$Rd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Rd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Rd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Rd),this.onDidRemoveExtensions=this.g.event,this.h=new C.$zc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t){const n=[],l=[];try{return await this.u(t,w=>{const D=[];for(const I of w)r.some(([k])=>(0,c.$Fo)(k.identifier,I.identifier)&&k.manifest.version!==I.version)?n.push(I):D.push(I);for(const[I,k]of r){const R=D.findIndex(T=>(0,c.$Fo)(T.identifier,I.identifier)&&T.version===I.manifest.version),L={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:k};R===-1?(l.push(L),D.push(L)):D.splice(R,1,L)}return l.length&&this.b.fire({extensions:l,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),D}),l.length&&this.c.fire({extensions:l,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),l}catch(w){throw l.length&&this.c.fire({extensions:l,error:w,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:w,profileLocation:t}),w}}async updateMetadata(r,t){const n=[];return await this.u(t,l=>{const w=[];for(const D of l){const I=r.find(([k])=>(0,c.$Fo)(k.identifier,D.identifier)&&k.manifest.version===D.version);I&&(D.metadata={...D.metadata,...I[1]},n.push(D)),w.push(D)}return w}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,l=>{const w=[];for(const D of l)(0,c.$Fo)(D.identifier,r.identifier)?n.push(D):w.push(D);return n.length&&this.f.fire({extensions:n,profileLocation:t}),w}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(l){throw n.length&&this.g.fire({extensions:n,error:l,profileLocation:t}),l}}async u(r,t,n){return this.F(r).queue(async()=>{let l=[],w;try{const D=await this.m.readFile(r);w=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,$.$vk)(D)!==1)throw D;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(w=await this.D()),!w&&n?.bailOutWhenFileNotFound)throw new a((0,b.$9)(D),"ERROR_PROFILE_NOT_FOUND")}if(w){Array.isArray(w)||this.w(r);let D=!1;for(const I of w){h(I)||this.w(r);let k;if((0,m.$Cf)(I.relativeLocation)&&I.relativeLocation)k=this.z(I.relativeLocation);else if((0,m.$Cf)(I.location))k=this.z(I.location),D=!0,I.relativeLocation=I.location,I.location=k.toJSON();else{k=P.URI.revive(I.location);const R=this.y(k);R&&(D=!0,I.relativeLocation=R)}l.push({identifier:I.identifier,location:k,version:I.version,metadata:I.metadata})}D&&await this.m.writeFile(r,A.$fe.fromString(JSON.stringify(w)))}if(t){l=t(l);const D=l.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,A.$fe.fromString(JSON.stringify(D)))}return l})}w(r){const t=new a(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(w){if((0,$.$vk)(w)===1)return;throw w}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const w=JSON.parse(n);Array.isArray(w)&&w.every(D=>h(D))?l=w:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",w)}catch(w){this.t.error(w)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$fe.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(w){if((0,$.$vk)(w)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw w}try{await this.m.del(r)}catch(w){(0,$.$vk)(w)!==1&&this.t.error(w)}try{await this.m.del(t)}catch(w){(0,$.$vk)(w)!==1&&this.t.error(w)}return l})()),this.C}F(r){let t=this.h.get(r);return t||(t=new S.$5g,this.h.set(r,t)),t}};e.$Bp=E,e.$Bp=E=ve([te(1,$.$ek),te(2,f.$Qk),te(3,y.$Ok),te(4,g.$il),te(5,v.$dj)],E);function h(o){return(0,m.$Ef)(o)&&(0,d.$co)(o.identifier)&&(i(o.location)||(0,m.$Cf)(o.location)&&o.location)&&((0,m.$Jf)(o.relativeLocation)||(0,m.$Cf)(o.relativeLocation))&&o.version&&(0,m.$Cf)(o.version)}function i(o){return o?(0,m.$Cf)(o.path)&&(0,m.$Cf)(o.scheme):!1}}),define(re[129],oe([0,1,23,8,38,18,14,44,152,2,13,9,4,19,205,74,12,7,172,37,123,120,204,16,6,5,25,3,77,81,41,40,203]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i,o,r,t,n,l,w,D,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.Translations=void 0;var L;(function(ce){function X(Y,V){if(Y===V)return!0;const q=Object.keys(Y),j=new Set;for(const H of Object.keys(V))j.add(H);if(q.length!==j.size)return!1;for(const H of q){if(Y[H]!==V[H])return!1;j.delete(H)}return j.size===0}ce.equals=X})(L||(e.Translations=L={})),e.$Ep=(0,r.$Vh)("IExtensionsScannerService");let T=class extends c.$Rc{constructor(X,Y,V,q,j,H,B,_,se,J,O,U){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=Y,this.r=V,this.s=q,this.t=j,this.u=H,this.w=B,this.y=_,this.z=se,this.C=J,this.D=O,this.F=U,this.g=this.B(new l.$Rd),this.onDidChangeCache=this.g.event,this.h=(0,f.$zg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Q,this.s,this.h)),this.m=this.B(this.F.createInstance(Q,this.s,this.h)),this.n=this.B(this.F.createInstance(K,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Qo)(this.w,this.y)),this.G}async scanAllExtensions(X,Y,V){const[q,j]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(Y)]),H=V?await this.scanExtensionsUnderDevelopment(X,[...q,...j]):[];return this.L(q,j,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const Y=[];Y.push(this.M(!!X.useCache,X.language)),Y.push(this.N(X.language,!!X.checkControlFile));const[V,q]=await Promise.all(Y);return this.J([...V,...q],0,X,!1)}async scanUserExtensions(X){const Y=X.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const V=this.D.extUri.isEqual(X.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(Y,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,V),j=X.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let H;try{H=await j.scanExtensions(q)}catch(B){if(B instanceof D.$zp&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await j.scanExtensions(q);else throw B}return H=await this.J(H,1,X,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(X,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===$.Schemas.file).map(async q=>{const j=await this.P(q,!1,1,!0,X.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(j)).map(B=>(B.type=Y.find(_=>(0,E.$Fo)(_.identifier,B.identifier))?.type??B.type,this.n.validate(B,j)))}))).flat();return this.J(V,"development",X,!0)}return[]}async scanExistingExtension(X,Y,V){const q=await this.P(X,!1,Y,!0,V.language,!0,void 0),j=await this.n.scanExtension(q);return!j||!V.includeInvalid&&!j.isValid?null:j}async scanOneOrMultipleExtensions(X,Y,V){const q=await this.P(X,!1,Y,!0,V.language,!0,void 0),j=await this.n.scanOneOrMultipleExtensions(q);return this.J(j,Y,V,!0)}async scanMetadata(X){const Y=(0,f.$zg)(X,"package.json"),V=(await this.w.readFile(Y)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(X,Y){const V=(0,f.$zg)(X,"package.json"),q=(await this.w.readFile(V)).value.toString(),j=JSON.parse(q);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,j.__metadata={...j.__metadata,...Y},await this.w.writeFile((0,f.$zg)(X,"package.json"),M.$fe.fromString(JSON.stringify(j,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof D.$zp&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw X}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.u.addExtensionsToProfile(X.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$fe.fromString(JSON.stringify([])))}catch(Y){(0,o.$vk)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$9)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.y.error(X)}finally{this.H=void 0}})()),this.H}async J(X,Y,V,q){return V.includeAllVersions||(X=this.L(Y===0?X:void 0,Y===1?X:void 0,Y==="development"?X:void 0,await this.getTargetPlatform(),q)),V.includeInvalid||(X=X.filter(j=>j.isValid)),X.sort((j,H)=>{const B=p.$mc(j.location.fsPath),_=p.$mc(H.location.fsPath);return B<_?-1:B>_?1:0})}L(X,Y,V,q,j){const H=(_,se,J)=>{if(_.isValid&&!se.isValid)return!1;if(_.isValid===se.isValid){if(j&&y.gt(_.manifest.version,se.manifest.version))return this.y.debug(`Skipping extension ${se.location.path} with lower version ${se.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(y.eq(_.manifest.version,se.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${se.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===q)return this.y.debug(`Skipping extension ${se.location.path} from different target platform ${se.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${_.location.path} with ${se.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${se.location.path}.`),!0},B=new h.$bm;return X?.forEach(_=>{const se=B.get(_.identifier.id);(!se||H(se,_,!1))&&B.set(_.identifier.id,_)}),Y?.forEach(_=>{const se=B.get(_.identifier.id);if(!se&&X&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!se||H(se,_,!1))&&B.set(_.identifier.id,_)}),V?.forEach(_=>{const se=B.get(_.identifier.id);(!se||H(se,_,!0))&&B.set(_.identifier.id,_),B.set(_.identifier.id,_)}),[...B.values()]}async M(X,Y){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),j=await(X&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",j.length),j}async N(X,Y){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const q=Y?await this.O():{},j=[],H=g.URI.file(p.$gc(p.$ic($.$gg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of V){const se=q[_.name]||"marketplace";switch(se){case"disabled":break;case"marketplace":j.push((0,f.$zg)(H,_.name));break;default:j.push(g.URI.file(se));break}}const B=await Promise.all(j.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,X,!0,void 0))));return this.y.trace("Scanned dev system extensions:",B.length),(0,S.$Gb)(B)}async O(){try{const X=await this.w.readFile(this.r);return JSON.parse(X.value.toString())}catch{return{}}}async P(X,Y,V,q,j,H,B){const _=await this.f(j??v.$w),se=await this.Q(X),J=Y&&!this.D.extUri.isEqual(X,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=J?await this.Q(J):void 0;return new N(X,se,J,O,Y,B,V,q,H,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,j,_)}async Q(X){try{const Y=await this.w.stat(X);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$Fp=T,e.$Fp=T=ve([te(4,I.$Qk),te(5,D.$Ap),te(6,o.$ek),te(7,t.$dj),te(8,a.$3h),te(9,n.$vj),te(10,k.$Ok),te(11,r.$Uh)],T);class N{constructor(X,Y,V,q,j,H,B,_,se,J,O,U,G,F,z){this.location=X,this.mtime=Y,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=q,this.profile=j,this.profileScanOptions=H,this.type=B,this.excludeObsolete=_,this.validate=se,this.productVersion=J,this.productDate=O,this.productCommit=U,this.devMode=G,this.language=F,this.translations=z}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,Y){return(0,f.$sg)(X.location,Y.location)&&X.mtime===Y.mtime&&(0,f.$sg)(X.applicationExtensionslocation,Y.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&X.profile===Y.profile&&s.$en(X.profileScanOptions,Y.profileScanOptions)&&X.type===Y.type&&X.excludeObsolete===Y.excludeObsolete&&X.validate===Y.validate&&X.productVersion===Y.productVersion&&X.productDate===Y.productDate&&X.productCommit===Y.productCommit&&X.devMode===Y.devMode&&X.language===Y.language&&L.equals(X.translations,Y.translations)}}e.$Gp=N;let K=class extends c.$Rc{constructor(X,Y,V,q,j){super(),this.f=X,this.g=Y,this.h=V,this.j=q,this.m=j}async scanExtensions(X){const Y=X.profile?await this.r(X):await this.n(X);let V={};if(X.excludeObsolete&&X.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(q)}catch{}return(0,b.$Pf)(V)?Y:Y.filter(q=>!V[E.$Go.create(q).toString()])}async n(X){const Y=await this.j.resolve(X.location);if(!Y.children?.length)return[];const V=await Promise.all(Y.children.map(async q=>{if(!q.isDirectory||X.type===1&&(0,f.$wg)(q.resource).indexOf(".")===0)return null;const j=new N(q.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(j)}));return(0,S.$Gb)(V).sort((q,j)=>q.location.path<j.location.path?-1:1)}async r(X){let Y=await this.s(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){Y=Y.filter(q=>!q.metadata?.isApplicationScoped);const V=await this.s(X.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,X);Y.push(...V)}return Y}async s(X,Y,V){const q=await this.g.scanProfileExtensions(X,V.profileScanOptions);if(!q.length)return[];const j=await Promise.all(q.map(async H=>{if(Y(H)){const B=new N(H.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(B,H.metadata)}return null}));return(0,S.$Gb)(j)}async scanOneOrMultipleExtensions(X){try{if(await this.j.exists((0,f.$zg)(X.location,"package.json"))){const Y=await this.scanExtension(X);return Y?[Y]:[]}else return await this.scanExtensions(X)}catch(Y){return this.m.error(`Error scanning extensions at ${X.location.path}:`,(0,C.$9)(Y)),[]}}async scanExtension(X,Y){try{let V=await this.scanExtensionManifest(X.location);if(V){V.publisher||(V.publisher=h.$8l),Y=Y??V.__metadata,delete V.__metadata;const q=(0,E.$Ko)(V.publisher,V.name),j=Y?.id?{id:q,uuid:Y.id}:{id:q},H=Y?.isSystem?0:X.type,B=H===0||!!Y?.isBuiltin;V=await this.t(X.location,V,N.createNlsConfiguration(X));const _={type:H,identifier:j,manifest:V,location:X.location,isBuiltin:B,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return X.validate?this.validate(_,X):_}}catch(V){X.type!==0&&this.m.error(V)}return null}validate(X,Y){let V=!0;const q=(0,i.$Vo)(Y.productVersion,Y.productDate,Y.location,X.manifest,X.isBuiltin);for(const[j,H]of q)j===m.default.Error&&(V=!1,this.m.error(this.z(Y.location,H)));return X.isValid=V,X.validations=q,X}async scanExtensionManifest(X){const Y=(0,f.$zg)(X,"package.json");let V;try{V=(await this.j.readFile(Y)).value.toString()}catch(j){return(0,o.$vk)(j)!==1&&this.m.error(this.z(X,(0,u.localize)(0,null,Y.path,j.message))),null}let q;try{q=JSON.parse(V)}catch{const H=[];(0,P.$3m)(V,H);for(const B of H)this.m.error(this.z(X,(0,u.localize)(1,null,Y.path,B.offset,B.length,(0,d.$Cp)(B.error))));return null}return(0,P.$_m)(q)!=="object"?(this.m.error(this.z(X,(0,u.localize)(2,null,Y.path))),null):q}async t(X,Y,V){const q=await this.u(X,Y,V);if(q)try{const j=[],H=await this.w(q.default,j);if(j.length>0)return j.forEach(_=>{this.m.error(this.z(X,(0,u.localize)(3,null,q.default?.path,(0,d.$Cp)(_.error))))}),Y;if((0,P.$_m)(q)!=="object")return this.m.error(this.z(X,(0,u.localize)(4,null,q.default?.path))),Y;const B=q.values||Object.create(null);return(0,R.$Dp)(this.m,Y,B,H)}catch{}return Y}async u(X,Y,V){const q=(0,f.$zg)(X,"package.nls.json"),j=(se,J)=>{J.forEach(O=>{this.m.error(this.z(X,(0,u.localize)(5,null,se?.path,(0,d.$Cp)(O.error))))})},H=se=>{this.m.error(this.z(X,(0,u.localize)(6,null,se?.path)))},B=`${Y.publisher}.${Y.name}`,_=V.translations[B];if(_)try{const se=g.URI.file(_),J=(await this.j.readFile(se)).value.toString(),O=[],U=(0,P.$3m)(J,O);return O.length>0?(j(se,O),{values:void 0,default:q}):(0,P.$_m)(U)!=="object"?(H(se),{values:void 0,default:q}):{values:U.contents?U.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let J;try{J=await this.y(X,V)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const O=(await this.j.readFile(J.localized)).value.toString(),U=[],G=(0,P.$3m)(O,U);return U.length>0?(j(J.localized,U),{values:void 0,default:J.original}):(0,P.$_m)(G)!=="object"?(H(J.localized),{values:void 0,default:J.original}):{values:G,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(X,Y){if(X)try{const V=(await this.j.readFile(X)).value.toString();return(0,P.$3m)(V,Y)}catch{}}y(X,Y){return new Promise((V,q)=>{const j=H=>{const B=(0,f.$zg)(X,`package.nls.${H}.json`);this.j.exists(B).then(_=>{_&&V({localized:B,original:(0,f.$zg)(X,"package.nls.json")});const se=H.lastIndexOf("-");se===-1?V({localized:(0,f.$zg)(X,"package.nls.json"),original:null}):(H=H.substring(0,se),j(H))})};if(Y.devMode||Y.pseudo||!Y.language)return V({localized:(0,f.$zg)(X,"package.nls.json"),original:null});j(Y.language)})}z(X,Y){return`[${X.path}]: ${Y}`}};K=ve([te(1,D.$Ap),te(2,k.$Ok),te(3,o.$ek),te(4,t.$dj)],K);let Q=class extends K{constructor(X,Y,V,q,j,H,B){super(Y,q,j,H,B),this.G=X,this.H=V,this.D=this.B(new A.$Vg(3e3)),this.F=this.B(new l.$Rd),this.onDidChangeCache=this.F.event}async scanExtensions(X){const Y=this.M(X),V=await this.I(Y);if(this.C=X,V&&V.input&&N.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",X.location.toString()),this.D.trigger(()=>this.L()),V.result.map(j=>(j.location=g.URI.revive(j.location),j));const q=await super.scanExtensions(X);return await this.J(Y,{input:X,result:q}),q}async I(X){try{const Y=await this.j.readFile(X),V=JSON.parse(Y.value.toString());return{result:V.result,input:(0,w.$sh)(V.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",X.path,(0,C.$9)(Y))}return null}async J(X,Y){try{await this.j.writeFile(X,M.$fe.fromString(JSON.stringify(Y)))}catch(V){this.m.debug("Error while writing the extension cache file:",X.path,(0,C.$9)(V))}}async L(){if(!this.C)return;const X=this.M(this.C),Y=await this.I(X);if(!Y)return;const V=Y.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$en(q,V))try{this.m.info("Invalidating Cache",V,q),await this.j.del(X),this.F.fire()}catch(j){this.m.error(j)}}M(X){const Y=this.N(X);return this.h.extUri.joinPath(Y.cacheHome,X.type===0?h.$7l:h.$6l)}N(X){return X.type===0?this.H.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(X.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};Q=ve([te(2,I.$Qk),te(3,D.$Ap),te(4,k.$Ok),te(5,o.$ek),te(6,t.$dj)],Q);function ae(ce,X){const Y=(0,E.$Io)(ce.manifest.publisher,ce.manifest.name);return{id:Y,identifier:new h.$_l(Y),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:X,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.$Hp=ae;class ne extends T{constructor(X,Y,V,q,j,H,B,_,se,J,O,U){super(X,Y,(0,f.$zg)(V,".vscode-oss-dev","extensions","control.json"),q,j,H,B,_,se,J,O,U),this.R=(async()=>{if(v.$z)try{const G=await this.w.readFile(g.URI.file(v.$z));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(X){return this.R}}e.$Ip=ne}),define(re[276],oe([0,1,5,41,40,26,81,16,37,7]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=void 0;let $=class extends C.$Bp{constructor(v,f,y,m,b,g){super(c.URI.file(v.extensionsPath),f,y,m,b,g)}};e.$VN=$,e.$VN=$=ve([te(0,d.$4h),te(1,P.$ek),te(2,A.$Qk),te(3,s.$Ok),te(4,M.$il),te(5,S.$dj)],$)}),define(re[277],oe([0,1,7,37,81,129,16,6,5,25,40,41]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=void 0;let v=class extends M.$Ip{constructor(y,m,b,g,u,a,E,h){super(S.URI.file(u.builtinExtensionsPath),S.URI.file(u.extensionsPath),u.userHome,y.defaultProfile,y,m,b,g,u,a,E,h)}};e.$Q9b=v,e.$Q9b=v=ve([te(0,p.$Qk),te(1,s.$Ap),te(2,C.$ek),te(3,d.$dj),te(4,A.$4h),te(5,c.$vj),te(6,$.$Ok),te(7,P.$Uh)],v)}),define(re[278],oe([0,1,15,2,13,9,4,57,7,32,36,37,5,41]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$99b=void 0;let y=class extends A.$Rc{constructor(b,g,u){super(),this.c=b,this.f=u,this.a=P.$2h.forPaths(!C.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(b.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:b}=S.session;b.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,u)=>this.j(g,u)),b.protocol.interceptFileProtocol(s.Schemas.file,(g,u)=>this.h(g,u)),this.B((0,A.$Pc)(()=>{b.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(b){const g=(0,M.$gc)(b);return this.a.get(g)?A.$Rc.None:(this.a.set(g,!0),(0,A.$Pc)(()=>this.a.delete(g)))}h(b,g){const u=d.URI.parse(b.url);return this.f.error(`Refused to load resource ${u.fsPath} from ${s.Schemas.file}: protocol (original URL: ${b.url})`),g({error:-3})}j(b,g){const u=this.m(b);let a;return this.c.crossOriginIsolated&&((0,M.$mc)(u)==="workbench.html"||(0,M.$mc)(u)==="workbench-dev.html"?a=s.COI.CoopAndCoep:a=s.COI.getHeadersFromQuery(b.url)),this.a.findSubstr(u)?g({path:u,headers:a}):this.b.has((0,M.$nc)(u).toLowerCase())?g({path:u}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${u} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),g({error:-3}))}m(b){const g=d.URI.parse(b.url),u=s.$gg.uriToFileUri(g);return(0,M.$gc)(u.fsPath)}createIPCObjectUrl(){let b;const g=d.URI.from({scheme:"vscode",path:(0,c.$ig)()}),u=g.toString(),a=async()=>b;return $.$VT.handle(u,a),this.f.trace(`IPC Object URL: Registered new channel ${u}.`),{resource:g,update:E=>b=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${u}.`),$.$VT.removeHandler(u)}}}};e.$99b=y,e.$99b=y=ve([te(0,p.$4h),te(1,f.$Qk),te(2,v.$dj)],y)}),define(re[96],oe([0,1,8,3,2,67,12,111,6,41]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_o=e.$$o=e.$0o=void 0,e.$0o="__$__isNewStorageMarker",e.$$o="__$__targetStorageMarker",e.$_o=(0,d.$Vh)("storageService");var $;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})($||(e.WillSaveStateReason=$={}));var p;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function f(u){const a=u.get(e.$$o);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.$ap=f;class y extends s.$Rc{static{this.a=60*1e3}constructor(a={flushInterval:y.a}){super(),this.m=a,this.b=this.B(new A.$Ud),this.c=this.B(new A.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$0g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(a,E,h){return A.Event.filter(this.b.event,i=>i.scope===a&&(E===void 0||i.key===E),h)}n(){this.j.value=(0,S.$bh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(a,E){const{key:h,external:i}=E;if(h===e.$$o){switch(a){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:a})}else this.b.fire({scope:a,key:h,target:this.J(a)[h],external:i})}w(a){this.f.fire({reason:a})}get(a,E,h){return this.P(E)?.get(a,h)}getBoolean(a,E,h){return this.P(E)?.getBoolean(a,h)}getNumber(a,E,h){return this.P(E)?.getNumber(a,h)}getObject(a,E,h){return this.P(E)?.getObject(a,h)}storeAll(a,E){this.y(()=>{for(const h of a)this.store(h.key,h.value,h.scope,h.target,E)})}store(a,E,h,i,o=!1){if((0,C.$Lf)(E)){this.remove(a,h,o);return}this.y(()=>{this.z(a,h,i),this.P(h)?.set(a,E,o)})}remove(a,E,h=!1){this.y(()=>{this.z(a,E,void 0),this.P(E)?.delete(a,h)})}y(a){this.b.pause(),this.c.pause();try{a()}finally{this.b.resume(),this.c.resume()}}keys(a,E){const h=[],i=this.J(a);for(const o of Object.keys(i))i[o]===E&&h.push(o);return h}z(a,E,h,i=!1){const o=this.J(E);typeof h=="number"?o[a]!==h&&(o[a]=h,this.P(E)?.set(e.$$o,JSON.stringify(o),i)):typeof o[a]=="number"&&(delete o[a],this.P(E)?.set(e.$$o,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(a){switch(a){case-1:return this.I;case 0:return this.G;default:return this.D}}L(a){const E=this.P(a);return E?f(E):Object.create(null)}isNew(a){return this.getBoolean(e.$0o,a)===!0}async flush(a=$.NONE){this.f.fire({reason:a});const E=this.P(-1),h=this.P(0),i=this.P(1);switch(a){case $.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case $.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return g(a,E,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(a){return await this.flush(),this.P(a)?.optimize()}async switch(a,E){return this.w($.NONE),(0,c.$Pk)(a)?this.R(a,E):this.S(a,E)}M(a,E){return!(a.id===E.id||m(E)&&m(a))}N(a,E,h){this.y(()=>{const i=new Set;for(const[o,r]of a)i.add(o),E.get(o)!==r&&this.u(h,{key:o,external:!0});for(const[o]of E.items)i.has(o)||this.u(h,{key:o,external:!0})})}}e.$bp=y;function m(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$cp=m;class b extends y{constructor(){super(),this.U=this.B(new P.$8o(new P.$9o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$8o(new P.$9o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$8o(new P.$9o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(a=>this.u(1,a))),this.B(this.W.onDidChangeStorage(a=>this.u(0,a))),this.B(this.U.onDidChangeStorage(a=>this.u(-1,a)))}P(a){switch(a){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(a){return!1}}e.$dp=b;async function g(u,a,E,h,i,o){const r=L=>{try{return JSON.parse(L)}catch{return L}},t=new Map,n=new Map;u.forEach((L,T)=>{t.set(T,L),n.set(T,r(L))});const l=new Map,w=new Map;a.forEach((L,T)=>{l.set(T,L),w.set(T,r(L))});const D=new Map,I=new Map;E.forEach((L,T)=>{D.set(T,L),I.set(T,r(L))}),console.group(h!==i?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const k=[];if(t.forEach((L,T)=>{k.push({key:T,value:L})}),console.table(k),console.groupEnd(),console.log(n),h!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const L=[];l.forEach((T,N)=>{L.push({key:N,value:T})}),console.table(L),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${o})`);const R=[];D.forEach((L,T)=>{R.push({key:T,value:L})}),console.table(R),console.groupEnd(),console.log(I)}e.$ep=g}),define(re[279],oe([0,1,23,8,3,2,9,73,7,21,111,161,5,96,26,30,13]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=e.$c8b=e.$b8b=e.$a8b=void 0;class g extends M.$Rc{static{this.a=2e3}get storage(){return this.f}constructor(r,t){super(),this.m=r,this.n=t,this.b=this.B(new s.$Rd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Rd),this.onDidCloseStorage=this.c.event,this.f=this.B(new $.$8o(new $.$9o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new A.$ih,this.whenInit=this.h.p,this.j=$.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===$.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const t=r.getBoolean(f.$0o);t===void 0?r.set(f.$0o,!0):t&&r.set(f.$0o,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=$.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,t){return this.f.get(r,t)}set(r,t){return this.f.set(r,t)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$Nd(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const t=(0,S.top)(Array.from(this.f.items.entries()).map(([l,w])=>({key:l,length:w.length})),(l,w)=>w.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),n=(await this.n.stat(d.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=$.StorageState.Closed,await this.f.close()}}class u extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$ic)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,u.y)}constructor(r,t,n,l){super(n,l),this.z=r,this.C=t}async t(){return new $.$8o(new p.$oU(this.path??p.$oU.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:$.StorageHint.STORAGE_IN_MEMORY})}}class a extends u{constructor(r,t,n,l){super(r,t,n,l)}}e.$a8b=a;class E extends u{constructor(r,t,n,l){super(t.defaultProfile,r,n,l)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$ll,void 0)===void 0&&r.set(y.$ll,new Date().toUTCString());const n=r.get(y.$kl,void 0),l=new Date().toUTCString();r.set(y.$ml,typeof n>"u"?null:n),r.set(y.$kl,l)}}e.$b8b=E;class h extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,h.y)}constructor(r,t,n,l,w){super(n,w),this.C=r,this.D=t,this.F=l}async t(){const{storageFilePath:r,wasCreated:t}=await this.H();return new $.$8o(new p.$oU(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?$.StorageHint.STORAGE_IN_MEMORY:t?$.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:p.$oU.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),t=(0,C.$ic)(r,h.y);return await c.Promises.exists(r)?{storageFilePath:t,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:t,wasCreated:!0})}async I(r){let t;if((0,m.$6h)(this.C)?t={folder:this.C.uri.toString()}:(0,m.$$h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,C.$ic)(r,h.z);await c.Promises.exists(n)||await c.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$c8b=h;class i extends g{get path(){}async t(){return new $.$8o(new $.$9o,{hint:$.StorageHint.STORAGE_IN_MEMORY})}}e.$d8b=i}),define(re[280],oe([0,1,3,2,96]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9b=void 0;class M extends A.$Rc{constructor(P,d,c){super(),this.b=P,this.c=d,this.f=c;const $=this.B(new A.$Sc);this.a=this.B(new S.$Rd({onWillAddFirstListener:()=>$.value=this.g(),onDidRemoveLastListener:()=>$.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new A.$Qc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,c)=>(d?d.push(c.key):d=[c.key],d),100)(d=>this.h(d))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(d,c)=>{d||(d=new Map);let $=d.get(c.profile.id);return $||d.set(c.profile.id,$={profile:c.profile,keys:[],storage:c.storage}),$.keys.push(c.key),d},100)(d=>this.j(d))),P}h(P){const d=P.includes(s.$$o)?[this.c.defaultProfile]:[],c=[];if(P=P.filter($=>$!==s.$$o),P.length){const $=(0,s.$ap)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:P.map(p=>({key:p,scope:0,target:$[p]}))})}this.m(d,c)}j(P){const d=[],c=new Map;for(const[$,p]of P.entries()){p.keys.includes(s.$$o)&&d.push(p.profile);const v=p.keys.filter(f=>f!==s.$$o);if(v.length){const f=(0,s.$ap)(p.storage.storage);c.set($,{profile:p.profile,changes:v.map(y=>({key:y,scope:0,target:f[y]}))})}}this.m(d,[...c.values()])}m(P,d){(P.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:P})}listen(P,d,c){switch(d){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${d}`)}async call(P,d){throw new Error(`Call not found: ${d}`)}}e.$S9b=M}),define(re[281],oe([0,1,7,37,16,5,34,40,41,12,121]),function(Z,e,S,A,s,M,C,P,d,c,$){"use strict";var p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=e.$SN=void 0;let f=class extends d.$Tk{static{p=this}static{this.a="profileAssociationsMigration"}constructor(g,u,a,E,h){super(a,E,u,h),this.U=g,this.W=a}O(){return this.U.getItem(p.b,[]).map(u=>({...u,location:(0,c.$Cf)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):S.URI.revive(u.location)}))}Q(){const g=this.U.getItem(p.c,{});return this.U.getItem(p.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$SN=f,e.$SN=f=p=ve([te(0,C.$NN),te(1,P.$Ok),te(2,A.$4h),te(3,s.$ek),te(4,M.$dj)],f);let y=v=class extends f{constructor(g,u,a,E,h){super(g,u,a,E,h),this.$=g}P(g){g.length?this.$.setItem(v.b,g.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(v.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(v.c,g):this.$.removeItem(v.c)}Q(){const g="workspaceAndProfileInfo",u=this.$.getItem(g,void 0);if(u){this.$.removeItem(g);const E=u.reduce((h,{workspace:i,profile:o})=>(h[S.URI.revive(i).toString()]=S.URI.revive(o).toString(),h),{});this.$.setItem(v.c,{workspaces:E})}const a=super.Q();return this.$.getItem(v.a,!1)||(this.R(a),this.$.setItem(v.a,!0)),a}};e.$TN=y,e.$TN=y=v=ve([te(0,C.$ON),te(1,P.$Ok),te(2,A.$4h),te(3,s.$ek),te(4,M.$dj)],y);let m=class extends y{constructor(g,u,a,E){super(new $.$RN(0,u,E,a),g,u,a,E)}async init(){return await this.$.init(),super.init()}};e.$UN=m,e.$UN=m=ve([te(0,P.$Ok),te(1,A.$4h),te(2,s.$ek),te(3,M.$dj)],m)}),define(re[54],oe([0,1,37,16,6,5,40,41,281,34]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=e.$e8b=void 0,e.$e8b=(0,s.$Wh)(P.$Qk);let $=class extends d.$TN{constructor(v,f,y,m,b){super(v,f,y,m,b)}getAssociatedEmptyWindows(){const v=[];for(const f of this.C.emptyWindows.keys())v.push({id:f});return v}};e.$f8b=$,e.$f8b=$=ve([te(0,c.$ON),te(1,C.$Ok),te(2,S.$4h),te(3,A.$ek),te(4,M.$dj)],$)}),define(re[130],oe([0,1,19,7,30]),function(Z,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8b=e.$u8b=e.$t8b=void 0;async function M(d,c,$){for(const v of d){const f=v.openedWorkspace;if((0,s.$$h)(f)){const y=await $(f);if(y){if(y.folders.some(m=>S.$qg.isEqualOrParent(c,m.uri)))return v}else if(S.$qg.isEqualOrParent(c,f.configPath))return v}}const p=d.filter(v=>(0,s.$6h)(v.openedWorkspace)&&S.$qg.isEqualOrParent(c,v.openedWorkspace.uri));if(p.length)return p.sort((v,f)=>-(v.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$t8b=M;function C(d,c){for(const $ of d)if((0,s.$$h)($.openedWorkspace)&&S.$qg.isEqual($.openedWorkspace.configPath,c)||(0,s.$6h)($.openedWorkspace)&&S.$qg.isEqual($.openedWorkspace.uri,c))return $}e.$u8b=C;function P(d,c){const $=p=>c.some(v=>S.$qg.isEqual(A.URI.file(v),A.URI.file(p)));for(const p of d)if(p.config?.extensionDevelopmentPath?.some(v=>$(v)))return p}e.$v8b=P}),define(re[97],oe([0,1,33,44,139,47,13,9,4,19,7,6,59,30]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfb=e.$ifb=e.$hfb=e.$gfb=e.$ffb=e.$efb=e.$dfb=e.$cfb=e.$bfb=e.$afb=void 0,e.$afb=(0,p.$Vh)("workspacesService");function y(I){return I.hasOwnProperty("workspace")}e.$bfb=y;function m(I){return I.hasOwnProperty("folderUri")}e.$cfb=m;function b(I){return I.hasOwnProperty("fileUri")}e.$dfb=b;function g(I){return u(I)||a(I)}e.$efb=g;function u(I){const k=I;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function a(I){const k=I;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(I,k,R,L,T){if(I.scheme!==L.scheme)return{name:R,uri:I.toString(!0)};let N=k?void 0:T.relativePath(L,I);if(N!==void 0)N.length===0?N=".":d.$i&&(N=h(N));else if(I.scheme===C.Schemas.file)N=I.fsPath,d.$i&&(N=h(N));else if(T.isEqualAuthority(I.authority,L.authority))N=I.path;else return{name:R,uri:I.toString(!0)};return{name:R,path:N}}e.$ffb=E;function h(I){return I=(0,M.$zv)(I),(0,S.$Yf)(I)||(I=(0,S.$Vf)(I)),I}function i(I,k,R){const L=[],T=new Set,N=R.dirname(k);for(const K of I){let Q;if(u(K))K.path&&(Q=R.resolvePath(N,K.path));else if(a(K))try{Q=$.URI.parse(K.uri),Q.path[0]!==P.$fc.sep&&(Q=Q.with({path:P.$fc.sep+Q.path}))}catch(ae){console.warn(ae)}if(Q){const ae=R.getComparisonKey(Q);if(!T.has(ae)){T.add(ae);const ne=K.name||R.basenameOrAuthority(Q);L.push(new f.$di({uri:Q,name:ne,index:L.length},K))}}}return L}e.$gfb=i;function o(I,k,R,L,T){const N=r(k,I),K=T.dirname(k),Q=T.dirname(L),ae=[];for(const Y of N.folders){const V=u(Y)?T.resolvePath(K,Y.path):$.URI.parse(Y.uri);let q;R?q=!1:q=!u(Y)||(0,P.$hc)(Y.path),ae.push(E(V,q,Y.name,Q,T))}const ne={insertSpaces:!1,tabSize:4,eol:d.$k||d.$j?`
`:`\r
`},ce=s.$yT(I,["folders"],ae,ne);let X=s.$BT(I,ce);return(0,c.$Eg)(N.remoteAuthority,(0,v.$1k)(L))&&(X=s.$BT(X,s.$xT(X,["remoteAuthority"],ne))),X}e.$hfb=o;function r(I,k){const R=A.$3m(k);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(L=>g(L));else throw new Error(`${I} looks like an invalid workspace file.`);return R}function t(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function l(I){return typeof I.fileUri=="string"}function w(I,k){const R={workspaces:[],files:[]};if(I){const L=function(N,K){for(let Q=0;Q<N.length;Q++)try{K(N[Q],Q)}catch(ae){k.warn(`Error restoring recent entry ${JSON.stringify(N[Q])}: ${ae.toString()}. Skip entry.`)}},T=I;Array.isArray(T.entries)&&L(T.entries,N=>{const K=N.label,Q=N.remoteAuthority;t(N)?R.workspaces.push({label:K,remoteAuthority:Q,workspace:{id:N.workspace.id,configPath:$.URI.parse(N.workspace.configPath)}}):n(N)?R.workspaces.push({label:K,remoteAuthority:Q,folderUri:$.URI.parse(N.folderUri)}):l(N)&&R.files.push({label:K,remoteAuthority:Q,fileUri:$.URI.parse(N.fileUri)})})}return R}e.$ifb=w;function D(I){const k={entries:[]};for(const R of I.workspaces)m(R)?k.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):k.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of I.files)k.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return k}e.$jfb=D}),define(re[98],oe([0,1,86,13,4,19]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z8b=e.$y8b=e.$x8b=e.$w8b=void 0,e.$w8b=128/4;function C(c){function $(){let p=c.scheme===A.Schemas.file?(0,M.$ng)(c):c.toString();return s.$k||(p=p.toLowerCase()),(0,S.createHash)("md5").update(p).digest("hex")}return{id:$(),configPath:c}}e.$x8b=C;function P(c,$){function p(){if(c.scheme!==A.Schemas.file)return(0,S.createHash)("md5").update(c.toString()).digest("hex");if(!$)return;let f;return s.$k?f=$.ino:s.$j?f=$.birthtime.getTime():s.$i&&(typeof $.birthtimeMs=="number"?f=Math.floor($.birthtimeMs):f=$.birthtime.getTime()),(0,S.createHash)("md5").update(c.fsPath).update(f?String(f):"").digest("hex")}const v=p();if(typeof v=="string")return{id:v,uri:c}}e.$y8b=P;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$z8b=d}),define(re[99],oe([0,1,86,87,28,282,18,14,3,2,9,4,32,42,109]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0;class m{traceSocketEvent(k,R){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,R)}constructor(k,R=""){this.f=!0,this.debugLabel=R,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,P.$Z)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const R=L=>{this.traceSocketEvent("read",L),k(C.$fe.wrap(L))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(k){const R=L=>{k({type:0,hadError:L,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(k){const R=()=>{k()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,P.$Z)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,P.$Z)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Kh=m;var b;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class u extends c.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,R){this.socket.traceSocketEvent(k,R)}constructor(k,R,L,T){super(),this.f=this.B(new d.$Rd),this.g=this.B(new d.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:L?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new a(this,R,L,T,this.f,(N,K)=>this.m(N,K))),this.B(this.a.onError(N=>{console.error(N),(0,P.$Z)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new y.$Fh,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let R=0;for(;R<k.byteLength;)this.a.writeMessage(k.slice(R,Math.min(R+262144,k.byteLength)),{compressed:!0,opcode:2}),R+=262144}m(k,{compressed:R,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let T=2;k.byteLength<126?T+=0:k.byteLength<2**16?T+=2:T+=8;const N=C.$fe.alloc(T),K=R?64:0,Q=L&15;if(N.writeUInt8(128|K|Q,0),k.byteLength<126)N.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){N.writeUInt8(126,1);let ae=1;N.writeUInt8(k.byteLength>>>8&255,++ae),N.writeUInt8(k.byteLength>>>0&255,++ae)}else{N.writeUInt8(127,1);let ae=1;N.writeUInt8(0,++ae),N.writeUInt8(0,++ae),N.writeUInt8(0,++ae),N.writeUInt8(0,++ae),N.writeUInt8(k.byteLength>>>24&255,++ae),N.writeUInt8(k.byteLength>>>16&255,++ae),N.writeUInt8(k.byteLength>>>8&255,++ae),N.writeUInt8(k.byteLength>>>0&255,++ae)}this.socket.write(C.$fe.concat([N,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const R=this.b.peek(this.j.readLen),L=R.readUInt8(0),T=(L&128)>>>7,N=(L&64)>>>6,K=L&15,Q=R.readUInt8(1),ae=(Q&128)>>>7,ne=Q&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(ne===126?2:0)+(ne===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const R=this.b.read(this.j.readLen),L=R.readUInt8(1),T=(L&128)>>>7;let N=L&127,K=1;N===126?N=R.readUInt8(++K)*2**8+R.readUInt8(++K):N===127&&(N=R.readUInt8(++K)*0+R.readUInt8(++K)*0+R.readUInt8(++K)*0+R.readUInt8(++K)*0+R.readUInt8(++K)*2**24+R.readUInt8(++K)*2**16+R.readUInt8(++K)*2**8+R.readUInt8(++K));let Q=0;T&&(Q=R.readUInt8(++K)*2**24+R.readUInt8(++K)*2**16+R.readUInt8(++K)*2**8+R.readUInt8(++K)),this.j.state=3,this.j.readLen=N,this.j.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const R=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),i(R,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Lh=u;class a extends c.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$fe.alloc(0)}constructor(k,R,L,T,N,K){super(),this.n=k,this.r=N,this.s=K,this.a=this.B(new d.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new d.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new d.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new E(this.n,T,L,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(Q=>this.a.fire(Q))),this.B(this.f.onError(Q=>this.a.fire(Q)))):(this.b=null,this.f=null)}writeMessage(k,R){this.g.push({data:k,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:R}=this.g.shift();if(this.f&&R.compressed){const L=await this.w(this.f,k);this.s(L,R)}else this.s(k,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,R){return new Promise((L,T)=>{k.write(R),k.flush(N=>L(N))})}acceptFrame(k,R,L){this.h.push({data:k,isCompressed:R,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const R=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,R,L){return new Promise((T,N)=>{k.write(R),L&&k.write(C.$fe.fromByteArray([0,0,255,255])),k.flush(K=>T(K))})}}class E extends c.$Rc{get recordedInflateBytes(){return this.j?C.$fe.concat(this.f):C.$fe.alloc(0)}constructor(k,R,L,T){super(),this.h=k,this.j=R,this.a=this.B(new d.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(T),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(C.$fe.wrap(N))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const R=C.$fe.concat(this.g);this.g.length=0,k(R)})}}class h extends c.$Rc{constructor(k,R){super(),this.g=k,this.a=this.B(new d.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(C.$fe.wrap(L))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let R=C.$fe.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),k(R)})}}function i(I,k){if(k===0)return;const R=I.byteLength>>>2;for(let ae=0;ae<R;ae++){const ne=I.readUInt32BE(ae*4);I.writeUInt32BE(ne^k,ae*4)}const L=R*4,T=I.byteLength-L,N=k>>>24&255,K=k>>>16&255,Q=k>>>8&255;T>=1&&I.writeUInt8(I.readUInt8(L)^N,L),T>=2&&I.writeUInt8(I.readUInt8(L+1)^K,L+1),T>=3&&I.writeUInt8(I.readUInt8(L+2)^Q,L+2)}e.$Mh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const I=(0,v.$ig)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const k=process.platform!=="darwin"&&e.$Mh?e.$Mh:(0,s.tmpdir)(),R=(0,$.$ic)(k,`vscode-ipc-${I}.sock`);return n(R),R}e.$Nh=r;function t(I,k,R){const L=(0,S.createHash)("md5").update(I).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${R}-${k}-sock`;const T=R.substr(0,4),N=k.substr(0,6),K=L.substr(0,8);let Q;return process.platform!=="darwin"&&e.$Mh&&!process.env.VSCODE_PORTABLE?Q=(0,$.$ic)(e.$Mh,`vscode-${K}-${T}-${N}.sock`):Q=(0,$.$ic)(I,`${T}-${N}.sock`),n(Q),Q}e.$Oh=t;function n(I){const k=o[p.$u];typeof k=="number"&&I.length>=k&&console.warn(`WARNING: IPC handle "${I}" is longer than ${k} chars, try a shorter --user-data-dir`)}class l extends f.$zh{static b(k){const R=d.Event.fromNodeEventEmitter(k,"connection");return d.Event.map(R,L=>({protocol:new y.$Gh(new m(L,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(L,"close"))}))}constructor(k){super(l.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ph=l;function w(I){return new Promise((k,R)=>{const L=(0,A.createServer)();L.on("error",R),L.listen(I,()=>{L.removeListener("error",R),k(new l(L))})})}e.$Qh=w;function D(I,k){return new Promise((R,L)=>{const T=(0,A.createConnection)(I,()=>{T.removeListener("error",L),R(y.$Hh.fromSocket(new m(T,`ipc-client${k}`),k))});T.once("error",L)})}e.$Rh=D}),define(re[24],oe([0,1,56,9,4,99,37,90,6]),function(Z,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=e.$97b=void 0,e.$97b=(0,d.$Wh)(C.$3h);class c extends P.$pm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,A.$ic)(this.userDataPath,"clp")}get backupHome(){return(0,A.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Oh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const p in process.env)if(p.endsWith("_VSCODE_SNAP_ORIG")){const v=p.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[p]?process.env[v]=process.env[p]:delete process.env[v]}}}restoreSnapExportedVariables(){if(s.$k)for(const p in this.d)process.env[p]=this.d[p],delete this.d[p]}}e.$07b=c,ve([S.$nh],c.prototype,"cachedLanguagesPath",null),ve([S.$nh],c.prototype,"backupHome",null),ve([S.$nh],c.prototype,"mainIPCHandle",null),ve([S.$nh],c.prototype,"mainLockfile",null),ve([S.$nh],c.prototype,"disableUpdates",null),ve([S.$nh],c.prototype,"crossOriginIsolated",null),ve([S.$nh],c.prototype,"codeCachePath",null),ve([S.$nh],c.prototype,"useCodeCache",null)}),define(re[283],oe([0,1,86,33,13,9,4,19,21,196,17,24,34,16,5,195,30,98]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=void 0;let a=class{static{u=this}static{this.a="backupWorkspaces"}constructor(h,i,o,r){this.j=h,this.k=i,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$qg,this.i={isEqual:(t,n)=>(0,A.$1f)(t,n,!C.$k)}}async initialize(){const h=this.m.getItem(u.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(h.emptyWindows),this.d=await this.u((0,c.$n8b)(h)),this.e=await this.v((0,c.$o8b)(h)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$Dk.OFF}q(){return this.s()===f.$Dk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$Dk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(h,i){this.d.some(r=>h.workspace.id===r.workspace.id)||(this.d.push(h),this.C());const o=(0,M.$ic)(this.c,h.workspace.id);return i?this.t(o,i).then(()=>o):o}async t(h,i){if(await d.Promises.exists(h)&&await this.z(h),await d.Promises.exists(i))try{await d.Promises.rename(i,h,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(h){return this.e.some(i=>this.h.isEqual(h.folderUri,i.folderUri))||(this.e.push(h),this.C()),(0,M.$ic)(this.c,this.D(h))}registerEmptyWindowBackup(h){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,h.backupFolder))||(this.g.push(h),this.C()),(0,M.$ic)(this.c,h.backupFolder)}async u(h){if(!Array.isArray(h))return[];const i=new Set,o=[];for(const r of h){const t=r.workspace;if(!(0,b.$$h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,M.$ic)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await d.Promises.exists(t.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(h){if(!Array.isArray(h))return[];const i=[],o=new Set;for(const r of h){const t=r.folderUri,n=this.h.getComparisonKey(t);if(!o.has(n)){o.add(n);const l=(0,M.$ic)(this.c,this.D(r));await this.B(l)?t.scheme!==s.Schemas.file||await d.Promises.exists(t.fsPath)?i.push(r):await this.z(l):await this.x(l)}}return i}async w(h){if(!Array.isArray(h))return[];const i=[],o=new Set;for(const r of h){const t=r.backupFolder;if(typeof t!="string")return[];if(!o.has(t)){o.add(t);const n=(0,M.$ic)(this.c,t);await this.B(n)?i.push(r):await this.x(n)}}return i}async x(h){try{await d.Promises.rm(h,d.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let h=(0,g.$z8b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,h.id));)h=(0,g.$z8b)();return{backupFolder:h.id}}async z(h){const i=this.y(),o=(0,M.$ic)(this.c,i.backupFolder);try{await d.Promises.rename(h,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const h=[];for(const i of this.d)await this.A(i)&&h.push(i);for(const i of this.e)await this.A(i)&&h.push(i);return h}A(h){let i;return(0,c.$m8b)(h)?i=(0,M.$ic)(this.c,h.backupFolder):(0,m.$$eb)(h)?i=(0,M.$ic)(this.c,this.D(h)):i=(0,M.$ic)(this.c,h.workspace.id),this.B(i)}async B(h){try{const i=await d.Promises.readdir(h);for(const o of i)try{if((await d.Promises.readdir((0,M.$ic)(h,o))).length>0)return!0}catch{}}catch{}return!1}C(){const h={workspaces:this.d.map(({workspace:i,remoteAuthority:o})=>{const r={id:i.id,configURIPath:i.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:i,remoteAuthority:o})=>{const r={folderUri:i.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:o})=>{const r={backupFolder:i};return o&&(r.remoteAuthority=o),r})};this.m.setItem(u.a,h)}D(h){const i=h.folderUri;let o;return i.scheme===s.Schemas.file?o=C.$k?i.fsPath:i.fsPath.toLowerCase():o=i.toString().toLowerCase(),(0,S.createHash)("md5").update(o).digest("hex")}};e.$O8b=a,e.$O8b=a=u=ve([te(0,p.$97b),te(1,$.$pi),te(2,y.$dj),te(3,v.$ON)],a)}),define(re[20],oe([0,1,15,36,8,3,2,4,35,12,6,5,34,24]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=e.LifecycleMainPhase=e.ShutdownReason=e.$$7b=void 0,e.$$7b=(0,$.$Vh)("lifecycleMainService");var m;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var b;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let g=class extends C.$Rc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(a,E,h){super(),this.F=a,this.G=E,this.H=h,this.c=this.B(new M.$Rd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Rd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Rd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Rd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const a=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",a);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&S.app.quit()};S.app.addListener("window-all-closed",E),S.app.once("will-quit",h=>{this.S("Lifecycle#app.on(will-quit) - begin"),h.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",a),S.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(a){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const h=[];return this.f.fire({reason:a,join(i,o){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),h.push(o.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(h)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(a){if(a<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===a)return;this.S(`lifecycle (main): phase changed (value: ${a})`),this.n=a;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(a){if(a<=this.n)return;let E=this.C.get(a);E||(E=new s.$Wg,this.C.set(a,E)),await E.wait()}registerWindow(a){const E=new C.$Qc;this.t++,E.add(a.onWillLoad(i=>this.g.fire({window:a,workspace:i.workspace,reason:i.reason})));const h=(0,c.$Nf)(a.win);h.on("close",i=>{const o=a.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${a.id}`),i.preventDefault(),this.unload(a,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(a),a.close()})}),h.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${a.id}`),this.t--,E.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}async reload(a,E){await this.unload(a,3)||a.reload(E)}unload(a,E){const h=this.z.get(a.id);if(h)return h;const i=this.M(a,E).finally(()=>{this.z.delete(a.id)});return this.z.set(a.id,i),i}async M(a,E){if(!a.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${a.id}`);const h=this.j?2:E,i=await this.P(a,h);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${a.id})`),this.N(i)):(await this.Q(a,h),!1)}N(a){return a?(this.O(!0),this.j=!1,!0):!1}O(a){this.w&&(this.w(a),this.w=void 0,this.u=void 0)}P(a,E){return new Promise(h=>{const i=this.s++,o=`vscode:ok${i}`,r=`vscode:cancel${i}`;A.$VT.once(o,()=>{h(!1)}),A.$VT.once(r,()=>{h(!0)}),a.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:E})})}Q(a,E){return new Promise(h=>{const o=`vscode:reply${this.s++}`;A.$VT.once(o,()=>h()),a.send("vscode:onWillUnload",{replyChannel:o,reason:E})})}quit(a){return this.R(a).then(E=>{if(!E&&a)try{if(P.$i){const h=(0,d.cwd)();h!==process.cwd()&&process.chdir(h)}}catch(h){this.F.error(h)}return E})}R(a){return this.S(`Lifecycle#quit() - begin (willRestart: ${a})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(a&&this.G.setItem(y.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(a){this.H.args["enable-smoke-test-driver"]?this.F.info(a):this.F.trace(a)}setRelaunchHandler(a){this.D=a}async relaunch(a){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(a?.addArgs&&E.push(...a.addArgs),a?.removeArgs)for(const o of a.removeArgs){const r=E.indexOf(o);r>=0&&E.splice(r,1)}const h=()=>{this.D?.handleRelaunch(a)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:E}))};S.app.once("quit",h),await this.quit(!0)&&S.app.removeListener("quit",h)}async kill(a){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Yg)(1e3),(async()=>{for(const E of S.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let h;E.webContents&&!E.webContents.isDestroyed()?h=new Promise(i=>E.once("closed",i)):h=Promise.resolve(),E.destroy(),await h}})()]),S.app.exit(a)}};e.$_7b=g,e.$_7b=g=y=ve([te(0,p.$dj),te(1,v.$ON),te(2,f.$97b)],g)}),define(re[284],oe([0,1,4,3,2,6,20]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_8b=e.$$8b=void 0,e.$$8b=(0,M.$Vh)("keyboardLayoutMainService");let P=class extends s.$Rc{constructor($){super(),this.a=this.B(new A.$Rd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,$.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const $=await new Promise((p,v)=>{Z(["native-keymap"],p,v)});this.c=d($),S.$t||$.onDidChangeKeyboardLayout(()=>{this.c=d($),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$_8b=P,e.$_8b=P=ve([te(0,C.$$7b)],P);function d(c){const $=c.getKeyMap(),p=c.getCurrentKeyboardLayout();return{keyboardMapping:$,keyboardLayoutInfo:p}}}),define(re[285],oe([0,1,246,8,18,14,12,17,37,94,5,51,245,282,286]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;let m=class extends p.$Zo{constructor(a,E,h,i){super(i),this.m=a,this.n=E,this.r=h,this.s(),this.B(a.onDidChangeConfiguration(o=>{o.affectsConfiguration("http")&&this.s()}))}s(){const a=this.m.getValue("http");this.f=a?.proxy,this.g=!!a?.proxyStrictSSL,this.h=a?.proxyAuthorization}async request(a,E){const{f:h,g:i}=this;let o;try{o=await(0,c.$Zl)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$9)(n)))}const r={...process.env,...o},t=a.agent?a.agent:await(0,v.$4q)(a.url||"",r,{proxyUrl:h,strictSSL:i});return a.agent=t,a.strictSSL=i,this.h&&(a.headers={...a.headers||{},"Proxy-Authorization":this.h}),this.c(a.isChromiumNetwork?"electron":"node",a,()=>g(a,E))}async resolveProxy(a){}async loadCertificates(){return(0,y.loadSystemCertificates)({log:this.r})}};e.$5q=m,e.$5q=m=ve([te(0,P.$pi),te(1,d.$4h),te(2,$.$dj),te(3,$.$ej)],m);async function b(u){return((0,S.parse)(u.url).protocol==="https:"?await new Promise((h,i)=>{Z(["https"],h,i)}):await new Promise((h,i)=>{Z(["http"],h,i)})).request}async function g(u,a){return A.Promises.withAsyncBody(async(E,h)=>{const i=(0,S.parse)(u.url),o=u.getRawRequest?u.getRawRequest(u):await b(u),r={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,C.$If)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(r.auth=u.user+":"+u.password);const t=o(r,n=>{const l=(0,C.$Gf)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&l>0&&n.headers.location)g({...u,url:n.headers.location,followRedirects:l-1},a).then(E,h);else{let w=n;!u.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(w=n.pipe((0,f.createGunzip)())),E({res:n,stream:(0,s.$ue)(w)})}});t.on("error",h),u.timeout&&t.setTimeout(u.timeout),u.isChromiumNetwork&&t.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&t.write(u.data),t.end(),a.onCancellationRequested(()=>{t.abort(),h(new M.$4)})})}e.$6q=g}),define(re[287],oe([0,1,15,285]),function(Z,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=void 0;function s(C){return S.net.request}class M extends A.$5q{request(P,d){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},d)}}e.$b0b=M}),define(re[82],oe([0,1,7,3,2,37,16,6,20,5,96,279,41,54,40,13]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=e.$i8b=e.$h8b=e.$g8b=void 0,e.$g8b=(0,P.$Vh)("storageMainService");let b=class extends s.$Rc{constructor(a,E,h,i,o,r){super(),this.c=a,this.f=E,this.g=h,this.h=i,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new A.$Rd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(a=>{a.window.profile&&this.profileStorage(a.window.profile).init(),a.workspace&&this.workspaceStorage(a.workspace).init()})),this.B(this.h.onWillShutdown(a=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=a.reason,a.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)a.join("profileStorage",E.close());for(const[,E]of this.w)a.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(a=>{a.join((async()=>{await this.j.exists(a.profile.globalStorageHome)||await this.j.createFolder(a.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(a=>{const E=this.t.get(a.profile.id);E&&a.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const a=new p.$b8b(this.n(),this.g,this.c,this.j);return this.B(A.Event.once(a.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),a}profileStorage(a){if((0,$.$cp)(a))return this.applicationStorage;let E=this.t.get(a.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${a.name})`),E=this.B(this.u(a)),this.t.set(a.id,E);const h=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:a})));this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${a.name})`),this.t.delete(a.id),h.dispose()}))}return E}u(a){return this.a===2?new p.$d8b(this.c,this.j):new p.$a8b(a,this.n(),this.c,this.j)}workspaceStorage(a){let E=this.w.get(a.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${a.id})`),E=this.B(this.y(a)),this.w.set(a.id,E),this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${a.id})`),this.w.delete(a.id)}))),E}y(a){return this.a===2?new p.$d8b(this.c,this.j):new p.$c8b(a,this.n(),this.c,this.f,this.j)}isUsed(a){const E=S.URI.file(a);for(const h of[this.applicationStorage,...this.t.values(),...this.w.values()])if(h.path&&this.m.extUri.isEqualOrParent(S.URI.file(h.path),E))return!0;return!1}};e.$h8b=b,e.$h8b=b=ve([te(0,c.$dj),te(1,M.$3h),te(2,f.$e8b),te(3,d.$$7b),te(4,C.$ek),te(5,y.$Ok)],b),e.$i8b=(0,P.$Vh)("applicationStorageMainService");let g=class extends $.$bp{constructor(a,E){super(),this.s=a,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(a){if(a===-1)return this.U.applicationStorage.storage}Q(a){if(a===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$j8b=g,e.$j8b=g=ve([te(0,v.$Qk),te(1,e.$g8b)],g)}),define(re[288],oe([0,1,87,28,103,99,8,2,4,17,5,25,241,242,95,126,18]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a0b=e.$_9b=e.$$9b=e.$09b=void 0;async function g(i,o,r,t,n){let l;for(let w=3;w&&(l?.dispose(),l=await new u(i,o,r,t,n).waitForReady(),!(n&&s.$lg[n]||!s.$lg[l.tunnelLocalPort]));w--);return l}class u extends P.$Rc{constructor(o,r,t,n,l){super(),this.m=r,this.n=l,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=S.createServer(),this.c=new C.$Wg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,m.$kv)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$mg)(o,2,1e3,r),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,m.$iv)(this.tunnelRemoteHost)||(0,m.$kv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,v.$_k)(this.a,r,this.tunnelRemotePort),n=t.getSocket(),l=t.readEntireBuffer();t.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Kh?n.socket.destroy():n.end()}),n instanceof M.$Kh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(t=>o.write(t.buffer)),o.on("data",t=>r.write(b.$fe.wrap(t))),o.resume()}t(o,r){const t=r.socket;t.on("end",()=>o.end()),t.on("close",()=>o.end()),t.on("error",()=>{o.destroy()}),t.pipe(o),o.pipe(t)}}e.$09b=u;let a=class extends m.$nv{constructor(o,r,t,n,l){super(r,l),this.u=o,this.v=t,this.w=n}isPortPrivileged(o){return(0,m.$lv)(o,this.l,d.OS,A.release())}s(o,r,t,n,l,w,D,I){const k=this.r(r,t);if(k)return++k.refcount,k.value;if((0,m.$fv)(o))return this.t(o,r,t,l,w,D,I);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${t} on local port ${l}.`);const R={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=g(R,n,r,t,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,t,L),L}}};e.$$9b=a,e.$$9b=a=ve([te(0,f.$6k),te(1,$.$dj),te(2,y.$9k),te(3,p.$vj),te(4,c.$pi)],a);let E=class extends a{constructor(o,r,t,n,l){super(o,r,t,n,l)}};e.$_9b=E,e.$_9b=E=ve([te(0,f.$6k),te(1,$.$dj),te(2,y.$9k),te(3,p.$vj),te(4,c.$pi)],E);let h=class extends P.$Rc{constructor(o,r,t,n,l){super(),this.b=o,this.c=r,this.f=t,this.g=n,this.h=l,this.a=new Map}async openTunnel(o,r,t,n,l,w,D,I,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${w}.`),!this.a.has(o)){const R=new E(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(o,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,t,n,l,w,D,I,k)}};e.$a0b=h,e.$a0b=h=ve([te(0,f.$6k),te(1,$.$dj),te(2,p.$vj),te(3,y.$9k),te(4,c.$pi)],h)}),define(re[100],oe([0,1,8,22,3,17,24,20,5,25,51,49]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=e.$v9b=void 0;function v(y,m,b){return`${b.updateUrl}/api/update/${y}/${m}/${b.commit}`}e.$v9b=v;let f=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,b,g,u,a,E){this.f=m,this.g=b,this.h=g,this.i=u,this.j=a,this.k=E,this.b=p.$VU.Uninitialized,this.c=new s.$Rd,this.onStateChange=this.c.event,m.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(p.$VU.Disabled(0));return}if(this.h.disableUpdates){this.d(p.$VU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(p.$VU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),b=this.m(m);if(!b){this.d(p.$VU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(b),!this.a){this.d(p.$VU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const g=new URL(this.a);g.searchParams.set("prss","true"),this.a=g.toString()}if(this.d(p.$VU.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,S.$Yg)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(b){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(b);return}}async _applySpecificUpdate(m){}q(){return 1}r(){}};e.$w9b=f,e.$w9b=f=ve([te(0,P.$$7b),te(1,M.$pi),te(2,C.$97b),te(3,$.$Yo),te(4,d.$dj),te(5,c.$vj)],f)}),define(re[289],oe([0,1,15,56,3,45,2,17,24,20,5,25,51,26,49,100]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9b=void 0;let b=class extends m.$w9b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(u,a)=>a)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(u,a,E)=>({url:a,version:E,productVersion:E}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(u,a,E,h)=>({releaseNotes:a,version:E,productVersion:E,date:h}))}constructor(u,a,E,h,i,o,r){super(u,a,h,i,o,r),this.z=E,this.u=new C.$Qc,u.setRelaunchHandler(this)}handleRelaunch(u){return u?.addArgs||u?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(u){this.z.publicLog2("update:error",{messageHash:String((0,M.$Ji)(String(u)))}),this.j.error("UpdateService error:",u);const a=this.state.type==="checking for updates"&&this.state.explicit?u:void 0;this.d(y.$VU.Idle(1,a))}s(u){let a;this.k.darwinUniversalAssetId?a=this.k.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,m.$v9b)(a,u,this.k);try{S.autoUpdater.setFeedURL({url:E})}catch(h){this.j.error("Failed to set update feed URL",h);return}return E}t(u){this.d(y.$VU.CheckingForUpdates(u)),S.autoUpdater.checkForUpdates()}E(u){this.state.type==="checking for updates"&&this.d(y.$VU.Downloading(u))}F(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(y.$VU.Ready(u)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(y.$VU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$x9b=b,ve([A.$nh],b.prototype,"v",null),ve([A.$nh],b.prototype,"w",null),ve([A.$nh],b.prototype,"x",null),ve([A.$nh],b.prototype,"y",null),e.$x9b=b=ve([te(0,c.$$7b),te(1,P.$pi),te(2,f.$il),te(3,d.$97b),te(4,v.$Yo),te(5,$.$dj),te(6,p.$vj)],b)}),define(re[290],oe([0,1,48,46,8,3,9,24,20,5,26,49]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z9b=void 0;let v=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,b,g){if(this.f=m,this.g=g,this.a=p.$VU.Uninitialized,this.b=new M.$Rd,this.onStateChange=this.b.event,b.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(p.$VU.Idle(this.k())),this.h(30*1e3).then(void 0,u=>this.g.error(u))}h(m=60*60*1e3){return(0,s.$Yg)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(m){}};v=ve([te(0,d.$$7b),te(1,P.$97b),te(2,c.$dj)],v);let f=class extends v{constructor(m,b,g,u,a,E){super(g,u,a),this.o=m,this.p=b,this.q=E;const h=(0,A.watch)(C.$lc(this.o)),i=M.Event.fromNodeEventEmitter(h,"change",(n,l)=>l),o=M.Event.filter(i,n=>n==="current"),t=M.Event.debounce(o,(n,l)=>l,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{t.dispose(),h.close()})}m(){this.d(p.$VU.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(p.$VU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$VU.Idle(2)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$VU.Idle(2,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+C.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise((g,u)=>(0,A.realpath)(`${C.$lc(this.o)}/current`,(a,E)=>a?u(a):g(E))),b=C.$mc(m);return this.p!==b}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$z9b=f,e.$z9b=f=ve([te(2,d.$$7b),te(3,P.$97b),te(4,c.$dj),te(5,$.$il)],f)}),define(re[29],oe([0,1,4,6,60,69,25,17,24,9,64]),function(Z,e,S,A,s,M,C,P,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=e.$L8b=e.$K8b=e.OpenContext=e.$J8b=void 0,e.$J8b=(0,A.$Vh)("windowsMainService");var p;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(p||(e.OpenContext=p={}));function v(m,b,g){const u=m.get(M.$k8b),a=m.get(C.$vj),E=m.get(P.$pi),h=m.get(d.$97b),i=E.getValue("window"),o={backgroundColor:u.getBackgroundColor(),minWidth:s.$mC.WIDTH,minHeight:s.$mC.HEIGHT,title:a.nameLong,...g,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$uC)(i?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...g?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return b&&(o.x=b.x,o.y=b.y,o.width=b.width,o.height=b.height),S.$k?o.icon=(0,c.$ic)(h.appRoot,"resources/linux/code.png"):S.$i&&!h.isBuilt&&(o.icon=(0,c.$ic)(h.appRoot,"resources/win32/code_150x150.png")),S.$j&&(o.acceptFirstMouse=!0,i?.clickThroughInactive===!1&&(o.acceptFirstMouse=!1)),o}e.$K8b=v;function f(m){const b=m.get(e.$J8b),g=m.get($.$H8b),u=b.getFocusedWindow()??g.getFocusedWindow();if(u)return u;const a=b.getLastActiveWindow(),E=g.getLastActiveWindow();return a&&E?a.lastFocusTime<E.lastFocusTime?E:a:a??E}e.$L8b=f;function y(m){let b,g=Number.MIN_VALUE;for(const u of m)u.lastFocusTime>g&&(g=u.lastFocusTime,b=u);return b}e.$M8b=y}),define(re[291],oe([0,1,15,22,3,45,2,32,116,5,82,29]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=void 0;var v;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let f=class extends C.$Rc{constructor(m,b,g,u){super(),this.g=m,this.h=b,this.j=g,this.m=u,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const m=s.Event.fromNodeEventEmitter(S.app,"login",(b,g,u,a,E)=>({event:b,webContents:g,req:u,authInfo:a,callback:E}));this.B(m(this.r,this))}async r({event:m,authInfo:b,req:g,callback:u}){if(!b.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let a;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(b);try{a=await this.b}finally{this.b=void 0}}u(a?.username,a?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.t(m);if(b)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const b=String((0,M.$Ji)({scheme:m.scheme,host:m.host,port:m.port}));let g,u;try{const i=this.m.get(this.a+b,-1);if(i){const o=JSON.parse(await this.j.decrypt(i));g=o.username,u=o.password}}catch(i){this.g.error(i)}if(this.c!==v.StoredCredentialsUsed&&typeof g=="string"&&typeof u=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:g,password:u};const a=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!a){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const E={authInfo:m,username:this.f?.username??g,password:this.f?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,P.$ig)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,E),this.c=v.LoginDialogShown;const h=await new Promise(i=>{const o=async(r,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",o),n){const l={username:n.username,password:n.password};try{if(n.remember){const w=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+b,w,-1,1)}else this.m.remove(this.a+b,-1)}catch(w){this.g.error(w)}i({username:l.username,password:l.password})}else i(void 0)};a.win?.webContents.on("ipc-message",o)});return this.f=h,h}};e.$N8b=f,e.$N8b=f=ve([te(0,c.$dj),te(1,p.$J8b),te(2,d.$EU),te(3,$.$i8b)],f)}),define(re[292],oe([0,1,15,23,4,7,21,17,63,6,5,127,29]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9b=e.$b9b=e.ID=void 0,e.ID="launchMainService",e.$b9b=(0,c.$Vh)(e.ID);let f=class{constructor(m,b,g,u){this.a=m,this.b=b,this.c=g,this.d=u}async start(m,b){this.a.trace("Received data from other instance: ",m,b),s.$j&&S.app.focus({steal:!0});const g=this.e(m);if(g.length){let u=Promise.resolve();if(this.b.getWindowCount()===0){const a=(0,A.$Nb)(await this.b.openEmptyWindow({context:4}));a&&(u=a.ready())}u.then(()=>{for(const{uri:a,originalUrl:E}of g)this.c.open(a,{originalUrl:E})})}else return this.f(m,b)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,A.$Gb)(m._urls.map(b=>{try{return{uri:M.URI.parse(b),originalUrl:b}}catch{return null}})):[]}async f(m,b){const g=(0,d.$Tl)(b)?0:4;let u=[];const a=m.wait&&m.waitMarkerFilePath?M.URI.file(m.waitMarkerFilePath):void 0,E=m.remote||void 0,h={context:g,cli:m,userEnv:b,waitMarkerFileURI:a,remoteAuthority:E,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,h);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let i=!1;if(m["new-window"]||m["unity-launch"]||h.forceProfile||h.forceTempProfile)i=!0;else if(m["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$j}if(i)u=await this.b.open({...h,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,h),u=[o]):u=await this.b.open({...h,forceEmpty:!0})}}else u=await this.b.open({...h,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(a&&u.length===1&&u[0])return Promise.race([u[0].whenClosedOrLoaded,(0,C.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$c9b=f,e.$c9b=f=ve([te(0,$.$dj),te(1,v.$J8b),te(2,p.$KU),te(3,P.$pi)],f)}),define(re[293],oe([0,1,2,20,54,30,8,29]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=void 0;let d=class extends S.$Rc{constructor($,p,v){super(),this.a=p,this.b=v,this.B($.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B($.onBeforeCloseWindow(f=>this.c(f))),this.B(new C.$0g(()=>this.g(),30*1e3)).schedule()}async c($){const p=this.f($),v=this.a.getProfileForWorkspace(p);v?.isTransient&&(this.a.unsetWorkspace(p,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f($){return $.openedWorkspace??(0,M.$0h)($.backupPath,$.isExtensionDevelopmentHost)}g(){const $=this.a.getAssociatedEmptyWindows();if($.length===0)return;const p=this.b.getWindows().map(v=>this.f(v));for(const v of $)p.some(f=>f.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$R9b=d,e.$R9b=d=ve([te(0,A.$$7b),te(1,s.$e8b),te(2,P.$J8b)],d)}),define(re[61],oe([0,1,15,2,3,5,314,8,13,29,74,26,20,76,38,4,131]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=e.$Q8b=void 0;function u(h){return typeof h.responseWindowId=="number"}let a=class extends A.$Rc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(i,o,r){super(),this.u=i,this.w=o,this.y=r,this.c=String(++g.a),this.f=this.B(new s.$Rd),this.onStdout=this.f.event,this.g=this.B(new s.$Rd),this.onStderr=this.g.event,this.h=this.B(new s.$Rd),this.onMessage=this.h.event,this.j=this.B(new s.$Rd),this.onSpawn=this.j.event,this.m=this.B(new s.$Rd),this.onExit=this.m.event,this.n=this.B(new s.$Rd),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(i,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${i}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${i}`,o){case $.default.Error:this.u.error(r);break;case $.default.Warning:this.u.warn(r);break;case $.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",$.default.Error),!1):!0}start(i){const o=this.D(i);return o&&i.payload&&this.postMessage(i.payload),o}D(i){if(!this.C())return!1;this.t=i;const o=`${this.t.type}-${this.c}`,r=d.$gg.asFileUri("bootstrap-fork.js").fsPath,t=this.t.args??[],n=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,w=this.t.forceAllocationsToV8Sandbox,D="pipe",I=this.F(i);return this.z("creating new...",$.default.Info),this.r=S.utilityProcess.fork(r,t,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:w,stdio:D}),this.G(this.r,this.t,o),!0}F(i){const o=i.env?{...i.env}:{...(0,y.$an)(process.env)};o.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,m.$i&&((0,b.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,b.getUNCHostAllowlist)().join("\\")),(0,f.$Gl)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(i,o,r){if(i.stdout){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.s=i.pid,typeof i.pid=="number"&&g.b.set(i.pid,{pid:i.pid,name:u(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",$.default.Info),this.j.fire(i.pid)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.z(`received exit event with code ${t}`,$.default.Info),this.m.fire({pid:this.s,code:t,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===r&&(this.z(`crashed with code ${t.exitCode} and reason '${t.reason}'`,$.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:t.reason,code:t.exitCode}),this.n.fire({pid:this.s,code:t.exitCode,reason:t.reason}),this.H())}))}once(i,o){const r=this.B(this.h.event(t=>{t===i&&(r.dispose(),o())}))}postMessage(i,o){this.r&&this.r.postMessage(i,o)}connect(i){const{port1:o,port2:r}=new S.MessageChannelMain;return this.postMessage(i,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",$.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",$.default.Info),this.r.kill()?(this.z("successfully killed the process",$.default.Info),this.H()):this.z("unable to kill the process",$.default.Warning)}H(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(i){this.r&&(this.z("waiting to exit...",$.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$Yg)(i)]),this.r&&(this.z(`did not exit within ${i}ms, will kill it now...`,$.default.Info),this.kill()))}};e.$Q8b=a,e.$Q8b=a=g=ve([te(0,M.$dj),te(1,p.$il),te(2,v.$$7b)],a);let E=class extends a{constructor(i,o,r,t){super(i,r,t),this.I=o}start(i){const o=this.I.getWindowById(i.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",$.default.Error),!0;if(!super.D(i))return!1;this.J(o.win,i);const t=this.connect(i.payload);return o.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}J(i,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$R8b=E,e.$R8b=E=ve([te(0,M.$dj),te(1,c.$J8b),te(2,p.$il),te(3,v.$$7b)],E)}),define(re[294],oe([0,1,14,3,5,20,8,61,29,26]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8b=void 0;let p=class{static{$=this}static{this.a=0}constructor(f,y,m,b){this.d=f,this.f=y,this.g=m,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(f){const y=this.b.get(f);if(!y)throw new Error("Unknown extension host!");return y}onDynamicStdout(f){return this.i(f).onStdout}onDynamicStderr(f){return this.i(f).onStderr}onDynamicMessage(f){return this.i(f).onMessage}onDynamicExit(f){return this.i(f).onExit}async createExtensionHost(){if(this.c)throw(0,S.$5)();const f=String(++$.a),y=new P.$R8b(this.d,this.g,this.h,this.f);return this.b.set(f,y),y.onExit(({pid:m,code:b,signal:g})=>{this.d.info(`Extension host with pid ${m} exited with code: ${b}, signal: ${g}.`),setTimeout(()=>{y.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(m,0),this.d.error(`Extension host with pid ${m} still exists, forcefully killing it...`),process.kill(m)}catch{}},1e3)}),{id:f}}async start(f,y){if(this.c)throw(0,S.$5)();const m=this.i(f);return m.start({...y,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:y.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:f}),{pid:await A.Event.toPromise(m.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,S.$5)();const y=this.b.get(f);return y?y.enableInspectPort():!1}async kill(f){if(this.c)throw(0,S.$5)();const y=this.b.get(f);y&&y.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const y=[];for(const[,m]of this.b)y.push(m.waitForExit(f));return C.Promises.settled(y).then(()=>{})}};e.$Y8b=p,e.$Y8b=p=$=ve([te(0,s.$dj),te(1,M.$$7b),te(2,d.$J8b),te(3,c.$il)],p)}),define(re[295],oe([0,1,36,8,2,24,20,5,41,39,68,61,52,90,12,247]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p9b=void 0;let b=class extends s.$Rc{constructor(u,a,E,h,i,o,r,t){super(),this.c=u,this.f=a,this.g=E,this.h=h,this.j=i,this.m=o,this.n=r,this.r=t,this.a=new A.$Wg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$VT.on(m.$n9b.request,(u,a)=>this.t(u,a,m.$n9b.response)),S.$VT.on(m.$o9b.request,(u,a)=>this.t(u,a,m.$o9b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(u,a,E){this.m.trace(`[SharedProcess] onWindowConnection for: ${E}`),this.a.isOpen()||this.a.open(),await this.whenReady();const h=await this.connect(E);if(u.sender.isDestroyed())return h.close();u.sender.postMessage(E,a,[h])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$m9b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const u=new A.$ih;this.b?this.b.once(m.$m9b.initDone,()=>u.complete()):S.$VT.once(m.$m9b.initDone,()=>u.complete()),await u.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const u=new A.$ih;this.b?this.b.once(m.$m9b.ipcReady,()=>u.complete()):S.$VT.once(m.$m9b.ipcReady,()=>u.complete()),await u.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new p.$Q8b(this.m,v.$ro,this.j));const u=(0,f.$rm)(this.g.args,this.g.isBuilt);let a;u.port&&(a=["--nolazy"],u.break?a.push(`--inspect-brk=${u.port}`):a.push(`--inspect=${u.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:a})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(u){return await this.z,(0,y.$Nf)(this.b).connect(u)}};e.$p9b=b,e.$p9b=b=ve([te(2,M.$97b),te(3,d.$Qk),te(4,C.$$7b),te(5,P.$dj),te(6,$.$C8b),te(7,c.$on)],b)}),define(re[296],oe([0,1,24,90,20,5,52,61,110,36,2,3,38,17,13]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$29b=void 0;let m=class extends $.$Rc{constructor(g,u,a,E,h){super(),this.f=g,this.g=u,this.h=a,this.j=E,this.m=h,this.a=void 0,this.b=new p.$Rd,this.onRequestConnection=this.b.event,this.c=new p.$Rd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$VT.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,$.$Pc)(()=>{c.$VT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$Q8b(this.m,C.$ro,this.j);const g=(0,A.$qm)(this.h.args,this.h.isBuilt),u=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:u,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const a=this.a.connect(),E=new d.$4T(a,"ptyHost"),h=new $.$Qc;return h.add(E),h.add((0,$.$Pc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:h,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,v.$an)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},u=this.g.getValue("terminal.integrated.developer.ptyHost.latency");u&&typeof u=="number"&&(g.VSCODE_LATENCY=String(u));const a=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return a&&typeof a=="number"&&(g.VSCODE_STARTUP_DELAY=String(a)),this.h.restoreSnapExportedVariables(),g}r(g,u){this.b.fire();const a=this.a.connect();if(g.sender.isDestroyed()){a.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",u,[a])}};e.$29b=m,e.$29b=m=ve([te(1,f.$pi),te(2,S.$97b),te(3,s.$$7b),te(4,M.$dj)],m)}),define(re[297],oe([0,1,2,6,5,29,61,26,45,3,8,20]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=e.$Z9b=void 0,e.$Z9b=(0,A.$Vh)("utilityProcessWorker");let v=class extends S.$Rc{constructor(m,b,g,u){super(),this.b=m,this.c=b,this.f=g,this.g=u,this.a=new Map}async createWorker(m){const b=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${b})`);const g=this.h(m);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${b})`),this.disposeWorker(m));const u=new f(this.b,this.c,this.f,this.g,m);if(!u.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,u);const a=new $.$ih;return c.Event.once(u.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(g),a.complete({reason:E})}),a.p}h(m){return(0,d.$Ji)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const b=this.h(m),g=this.a.get(b);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),g.kill(),this.a.delete(b))}};e.$19b=v,e.$19b=v=ve([te(0,s.$dj),te(1,M.$J8b),te(2,P.$il),te(3,p.$$7b)],v);let f=class extends S.$Rc{constructor(m,b,g,u,a){super(),this.c=m,this.f=b,this.g=g,this.h=u,this.j=a,this.a=this.B(new c.$Rd),this.onDidTerminate=this.a.event,this.b=new C.$R8b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const b=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:b,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=ve([te(0,s.$dj),te(1,M.$J8b),te(2,P.$il),te(3,p.$$7b)],f)}),define(re[298],oe([0,1,15,3,2,273,29]),function(Z,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=void 0;let P=class extends s.$Rc{constructor(c){super(),this.b=c,this.a=this.B(new A.$Rd),this.onFoundInFrame=this.a.event,this.B(new M.$G9b)}async setIgnoreMenuShortcuts(c,$){let p;if(typeof c.windowId=="number"){const{windowId:v}=c,f=this.b.getWindowById(v);if(!f?.win)throw new Error(`Invalid windowId: ${v}`);p=f.win.webContents}else{const{webContentsId:v}=c;if(p=S.webContents.fromId(v),!p)throw new Error(`Invalid webContentsId: ${v}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts($)}async findInFrame(c,$,p,v){const y=this.c(c,$);if(typeof y.findInFrame=="function"){y.findInFrame(p,{findNext:v.findNext,forward:v.forward});const m=(b,g)=>{g.finalUpdate&&(this.a.fire(g),y.removeListener("found-in-frame",m))};y.on("found-in-frame",m)}}async stopFindInFrame(c,$,p){const f=this.c(c,$);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(p.keepSelection?"keepSelection":"clearSelection")}c(c,$){const p=this.b.getWindowById(c.windowId);if(!p?.win)throw new Error(`Invalid windowId: ${c}`);const v=p.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===$);if(!v)throw new Error(`Unknown frame: ${$}`);return v}};e.$H9b=P,e.$H9b=P=ve([te(0,C.$J8b)],P)}),define(re[299],oe([0,1,15,2,4,19,7,17,20,5,34,29,128,30]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=e.$J9b=e.$I9b=void 0;let m=class extends A.$Rc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(h,i,o,r,t){super(),this.g=h,this.h=i,this.j=o,this.m=r,this.n=t,this.b=b(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(h=>this.u(h)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(h=>this.u(h))}s(){this.f=!0,this.t()}t(){const h=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&h.add(i.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(i.lastPluginDevelopmentHostWindow=this.w(o),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(h.has(n.uiState.display)?s.$j&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):h.add(n.uiState.display)),n}));const r=u(i);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(h){if(this.j.quitRequested)return;const i=this.w(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,f.$$h)(h.openedWorkspace)&&o.workspace?.id===h.openedWorkspace.id,t=(0,f.$6h)(h.openedWorkspace)&&o.folderUri&&M.$qg.isEqual(o.folderUri,h.openedWorkspace.uri);(r||t)&&(o.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(h){return{windowId:h.id,workspace:(0,f.$$h)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,f.$6h)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const i=this.z(h),o=this.n.getValue("window");if(i.mode===3){let r;i.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(i.mode=1)}return i}z(h){const i=this.g.getLastActiveWindow();if(!h.extensionTestsPath){if(h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const w=h.workspace;if((0,f.$$h)(w)){const I=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===w.id).map(k=>k.uiState);if(I.length)return I[0]}if((0,f.$6h)(w)){const I=this.state.openedWindows.filter(k=>k.folderUri&&M.$qg.isEqual(k.folderUri,w.uri)).map(k=>k.uiState);if(I.length)return I[0]}else if(h.backupPath){const I=this.state.openedWindows.filter(k=>k.backupPath===h.backupPath).map(k=>k.uiState);if(I.length)return I[0]}const D=this.c||this.state.lastActiveWindow;if(!i&&D)return D.uiState}let o;const r=S.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const w=S.screen.getCursorScreenPoint();o=S.screen.getDisplayNearestPoint(w)}!o&&i&&(o=S.screen.getDisplayMatching(i.getBounds())),o||(o=S.screen.getPrimaryDisplay()||r[0])}let t=(0,v.$87b)();t.x=Math.round(o.bounds.x+o.bounds.width/2-t.width/2),t.y=Math.round(o.bounds.y+o.bounds.height/2-t.height/2);const n=this.n.getValue("window");let l=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,l=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,l=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const w=i.serializeWindowState();w.mode===3?t.mode=3:t=w,l=t.mode!==3&&n.newWindowDimensions==="offset"}}return l&&(t=this.C(t)),t.hasDefaultState=!0,t}C(h){if(this.g.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const i=this.g.getWindows().map(o=>o.getBounds());for(;i.some(o=>o.x===h.x||o.y===h.y);)h.x+=30,h.y+=30;return h}};e.$I9b=m,e.$I9b=m=y=ve([te(0,p.$J8b),te(1,$.$ON),te(2,d.$$7b),te(3,c.$dj),te(4,P.$pi)],m);function b(E){const h={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(h.lastActiveWindow=g(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(h.openedWindows=i.openedWindows.map(o=>g(o))),h}e.$J9b=b;function g(E){const h={uiState:E.uiState};return E.backupPath&&(h.backupPath=E.backupPath),E.remoteAuthority&&(h.remoteAuthority=E.remoteAuthority),E.folder&&(h.folderUri=C.URI.parse(E.folder)),E.workspaceIdentifier&&(h.workspace={id:E.workspaceIdentifier.id,configPath:C.URI.parse(E.workspaceIdentifier.configURIPath)}),h}function u(E){return{lastActiveWindow:E.lastActiveWindow&&a(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&a(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(h=>a(h))}}e.$K9b=u;function a(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(re[55],oe([0,1,15,3,44,2,13,9,19,21,194,65,53,24,6,5,54,130,30,97,98]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=e.$A8b=void 0,e.$A8b=(0,y.$Vh)("workspacesManagementMainService");let h=class extends M.$Rc{constructor(o,r,t,n,l){super(),this.g=o,this.h=r,this.j=t,this.m=n,this.n=l,this.a=this.B(new A.$Rd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.$Rd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await c.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,d.$zg)(this.c,r,u.$ii));for(const r of o){const t=(0,E.$x8b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>c.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===C.Schemas.file)try{const t=r(o.fsPath);return t instanceof Promise?t.then(n=>this.t(o,n),n=>{}):this.t(o,t)}catch{return}}s(o){return(0,u.$ji)(o,this.g)||(0,u.$oi)(o)}t(o,r){try{const t=this.u(o,r),n=(0,E.$x8b)(o);return{id:n.id,configPath:n.configPath,folders:(0,a.$gfb)(t.folders,n.configPath,d.$qg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(o,r){const t=(0,s.$3m)(r);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,a.$efb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(o,r){const{workspace:t,storedWorkspace:n}=this.w(o,r),l=t.configPath.fsPath;return await c.Promises.mkdir((0,P.$lc)(l),{recursive:!0}),await c.Promises.writeFile(l,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:r}),t}w(o=[],r){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,d.$zg)(this.c,t),l=(0,d.$zg)(n,u.$ii),w=[];for(const D of o)w.push((0,a.$ffb)(D.uri,!0,D.name,n,d.$qg));return{workspace:(0,E.$x8b)(l),storedWorkspace:{folders:w,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,E.$x8b)(o)}isUntitledWorkspace(o){return(0,u.$ji)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,d.$ng)(o.configPath);try{await c.Promises.rm((0,P.$lc)(r));const t=(0,P.$ic)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,o.id);await c.Promises.exists(t)&&await c.Promises.writeFile((0,P.$ic)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${r} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,t){if(!o||!o.win||!o.isReady||!await this.z(o,r,t))return;const l=await this.C(o,(0,E.$x8b)(t));if(l)return this.b.fire({window:o,workspace:l.workspace}),l}async z(o,r,t){return t?(0,u.$$h)(o.openedWorkspace)&&d.$qg.isEqual(o.openedWorkspace.configPath,t)?!1:(0,g.$u8b)(r,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:(0,$.localize)(1,null,(0,d.$wg)(t)),detail:(0,$.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let t;return o.config.extensionDevelopmentPath||(o.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,u.$$h)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=t,{workspace:r,backupPath:t}}};e.$B8b=h,e.$B8b=h=ve([te(0,f.$97b),te(1,m.$dj),te(2,b.$e8b),te(3,p.$p8b),te(4,v.$q8b)],h)}),define(re[132],oe([0,1,15,36,22,6,29,30,55,12,5,61]),function(Z,e,S,A,s,M,C,P,d,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U8b=e.$T8b=e.ID=void 0,e.ID="diagnosticsMainService",e.$T8b=(0,M.$Vh)(e.ID);let v=class{constructor(y,m,b){this.a=y,this.b=m,this.c=b}async getRemoteDiagnostics(y){const m=this.a.getWindows();return(await Promise.all(m.map(async g=>{const u=g.remoteAuthority;if(!u)return;const a=`vscode:getDiagnosticInfoResponse${g.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(h=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:a,args:E}),A.$VT.once(a,(i,o)=>{o||h({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),h(o)}),setTimeout(()=>{h({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const b of S.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(b.id);g?y.push(await this.d(g)):y.push(this.e(b))}const m=[];for(const{pid:b,name:g}of p.$Q8b.getAll())m.push({pid:b,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:m,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(y){const m=await this.f(y),b=(0,c.$Nf)(y.win);return this.e(b,m,y.remoteAuthority)}e(y,m=[],b){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:m,remoteAuthority:b}}async f(y){const m=[],b=y.openedWorkspace;if((0,P.$6h)(b))m.push(b.uri);else if((0,P.$$h)(b)){const g=await this.b.resolveLocalWorkspace(b.configPath);g&&g.folders.forEach(a=>{m.push(a.uri)})}return m}};e.$U8b=v,e.$U8b=v=ve([te(0,C.$J8b),te(1,d.$A8b),te(2,$.$dj)],v)}),define(re[70],oe([0,1,48,15,28,156,56,3,2,13,9,4,7,105,88,21,103,182,53,24,6,20,5,25,69,29,30,55,18,243,235,64,286]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i,o,r,t,n,l,w,D,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$98b=e.$88b=void 0,e.$88b=(0,E.$Vh)("nativeHostMainService");let L=class extends d.$Rc{constructor(N,K,Q,ae,ne,ce,X,Y,V,q){super(),this.a=N,this.b=K,this.c=Q,this.f=ae,this.g=ne,this.h=ce,this.j=X,this.m=Y,this.n=V,this.r=q,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,j=>j.id),this.onDidTriggerMainWindowSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:j,x:H,y:B})=>({windowId:j.id,x:H,y:B})),({windowId:j})=>!!this.a.getWindowById(j)),this.onDidMaximizeMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(j,H)=>H.id),j=>!!this.a.getWindowById(j)),this.onDidUnmaximizeMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(j,H)=>H.id),j=>!!this.a.getWindowById(j)),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(j,H)=>H.id),j=>!!this.a.getWindowById(j)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),j=>!!j),j=>j.id),P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(j,H)=>H.id),j=>!!this.a.getWindowById(j))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(j,H)=>H),j=>(0,k.$I8b)(j.webContents)),j=>j.id)),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(j,H)=>H),j=>(0,k.$I8b)(j.webContents)),j=>j.id)),this.onDidResumeOS=P.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new P.$Rd),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(j,H,B)=>B),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),P.Event.fromNodeEventEmitter(A.screen,"display-added"),P.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(N,K){const Q=this.a.getWindows().map(ne=>({id:ne.id,workspace:ne.openedWorkspace??(0,n.$0h)(ne.backupPath,ne.isExtensionDevelopmentHost),title:ne.win?.getTitle()??"",filename:ne.getRepresentedFilename(),dirty:ne.isDocumentEdited()})),ae=[];return K.includeAuxiliaryWindows&&ae.push(...this.b.getWindows().map(ne=>({id:ne.id,parentId:ne.parentId,title:ne.win?.getTitle()??"",filename:ne.getRepresentedFilename()}))),[...Q,...ae]}async getWindowCount(N){return this.a.getWindowCount()}async getActiveWindowId(N){const K=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(K)return K.id}openWindow(N,K,Q){return Array.isArray(K)?this.t(N,K,Q):this.u(N,K)}async t(N,K,Q=Object.create(null)){K.length>0&&await this.a.open({context:5,contextWindowId:N,urisToOpen:K,cli:this.g.args,forceNewWindow:Q.forceNewWindow,forceReuseWindow:Q.forceReuseWindow,preferNewWindow:Q.preferNewWindow,diffMode:Q.diffMode,mergeMode:Q.mergeMode,addMode:Q.addMode,gotoLineMode:Q.gotoLineMode,noRecentEntry:Q.noRecentEntry,waitMarkerFileURI:Q.waitMarkerFileURI,remoteAuthority:Q.remoteAuthority||void 0,forceProfile:Q.forceProfile,forceTempProfile:Q.forceTempProfile})}async u(N,K){await this.a.openEmptyWindow({context:5,contextWindowId:N},K)}async toggleFullScreen(N,K){this.D(K?.targetWindowId,N)?.toggleFullScreen()}async handleTitleDoubleClick(N){this.F(N)?.handleTitleDoubleClick()}async getCursorScreenPoint(N){const K=A.screen.getCursorScreenPoint(),Q=A.screen.getDisplayNearestPoint(K);return{point:K,display:Q.bounds}}async isMaximized(N){const K=this.F(N);return K?.win?K.win.isMaximized():!1}async maximizeWindow(N){const K=this.F(N);K?.win&&K.win.maximize()}async unmaximizeWindow(N){const K=this.F(N);K?.win&&K.win.unmaximize()}async minimizeWindow(N){const K=this.F(N);K?.win&&K.win.minimize()}async moveWindowTop(N,K){const Q=this.D(K?.targetWindowId,N);Q?.win&&Q.win.moveTop()}async positionWindow(N,K,Q){const ae=this.D(Q?.targetWindowId,N);if(ae?.win){if(ae.win.isFullScreen()){const ne=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(ae.win,"leave-full-screen")));ae.win.setFullScreen(!1),await ne}ae.win.setBounds(K)}}async updateWindowControls(N,K){const Q=this.F(N);Q&&Q.updateWindowControls(K)}async focusWindow(N,K){this.D(K?.targetWindowId,N)?.focus({force:K?.force??!1})}async setMinimumSize(N,K,Q){const ae=this.F(N);if(ae?.win){const[ne,ce]=ae.win.getSize(),[X,Y]=ae.win.getMinimumSize(),[V,q]=[K??X,Q??Y],[j,H]=[Math.max(ne,V),Math.max(ce,q)];(X!==V||Y!==q)&&ae.win.setMinimumSize(V,q),(ne!==j||ce!==H)&&ae.win.setSize(j,H)}}async saveWindowSplash(N,K){this.m.saveWindowSplash(N,K)}async installShellCommand(N){const{source:K,target:Q}=await this.w();try{const{symbolicLink:ae}=await m.SymlinkSupport.stat(K);if(ae&&!ae.dangling){const ne=await(0,f.$aq)(K);if(Q===ne)return}await m.Promises.unlink(K)}catch(ae){if(ae.code!=="ENOENT")throw ae}try{await m.Promises.symlink(Q,K)}catch(ae){if(ae.code!=="EACCES"&&ae.code!=="ENOENT")throw ae;const{response:ne}=await this.showMessageBox(N,{type:"info",message:(0,g.localize)(0,null,this.j.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ne===0)try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Q}' '${K}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ce)}catch{throw new Error((0,g.localize)(3,null,K))}}}async uninstallShellCommand(N){const{source:K}=await this.w();try{await m.Promises.unlink(K)}catch(Q){switch(Q.code){case"EACCES":{const{response:ae}=await this.showMessageBox(N,{type:"info",message:(0,g.localize)(4,null,this.j.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(ae===0)try{const ne=`osascript -e "do shell script \\"rm '${K}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ne)}catch{throw new Error((0,g.localize)(7,null,K))}break}case"ENOENT":break;default:throw Q}}}async w(){const N=(0,$.$jc)(this.g.appRoot,"bin","code"),K=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(N))throw new Error((0,g.localize)(8,null,N));return{source:K,target:N}}async showMessageBox(N,K){const Q=this.H(N);return this.c.showMessageBox(K,Q?.win??void 0)}async showSaveDialog(N,K){const Q=this.H(N);return this.c.showSaveDialog(K,Q?.win??void 0)}async showOpenDialog(N,K){const Q=this.H(N);return this.c.showOpenDialog(K,Q?.win??void 0)}async pickFileFolderAndOpen(N,K){const Q=await this.c.pickFileFolder(K);Q&&await this.z(await Promise.all(Q.map(async ae=>await m.SymlinkSupport.existsDirectory(ae)?{folderUri:v.URI.file(ae)}:{fileUri:v.URI.file(ae)})),K,N)}async pickFolderAndOpen(N,K){const Q=await this.c.pickFolder(K);Q&&await this.z(Q.map(ae=>({folderUri:v.URI.file(ae)})),K,N)}async pickFileAndOpen(N,K){const Q=await this.c.pickFile(K);Q&&await this.z(Q.map(ae=>({fileUri:v.URI.file(ae)})),K,N)}async pickWorkspaceAndOpen(N,K){const Q=await this.c.pickWorkspace(K);Q&&await this.z(Q.map(ae=>({workspaceUri:v.URI.file(ae)})),K,N)}async z(N,K,Q){await this.a.open({context:3,contextWindowId:Q,cli:this.g.args,urisToOpen:N,forceNewWindow:K.forceNewWindow})}async showItemInFolder(N,K){A.shell.showItemInFolder(K)}async setRepresentedFilename(N,K,Q){this.D(Q?.targetWindowId,N)?.setRepresentedFilename(K)}async setDocumentEdited(N,K,Q){this.D(Q?.targetWindowId,N)?.setDocumentEdited(K)}async openExternal(N,K){return this.g.unsetSnapExportedVariables(),A.shell.openExternal(K),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(N,K){return A.shell.trashItem(K)}async isAdmin(){let N;return p.$i?N=(await new Promise((K,Q)=>{Z(["native-is-elevated"],K,Q)}))():N=process.getuid?.()===0,N}async writeElevated(N,K,Q,ae){const ne=await new Promise((ce,X)=>{Z(["@vscode/sudo-prompt"],ce,X)});return new Promise((ce,X)=>{const Y=[`"${this.C}"`];ae?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${K.fsPath}"`,`"${Q.fsPath}"`);const V={name:this.j.nameLong.replace("-",""),icns:p.$j&&this.g.isBuilt?(0,$.$ic)((0,$.$lc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ne.exec(Y.join(" "),V,(q,j,H)=>{j&&this.h.trace(`[sudo-prompt] received stdout: ${j}`),H&&this.h.trace(`[sudo-prompt] received stderr: ${H}`),q?X(q):ce(void 0)})})}async isRunningUnderARM64Translation(){return p.$k||p.$i?!1:A.app.runningUnderARM64Translation}get C(){return p.$i?this.g.isBuilt?(0,$.$ic)((0,$.$lc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,$.$ic)(this.g.appRoot,"scripts","code-cli.bat"):p.$k?this.g.isBuilt?(0,$.$ic)((0,$.$lc)(process.execPath),"bin",`${this.j.applicationName}`):(0,$.$ic)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,$.$ic)(this.g.appRoot,"bin","code"):(0,$.$ic)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Xm.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return p.$i&&(0,D.$68b)()}async killProcess(N,K,Q){process.kill(K,Q)}async readClipboardText(N,K){return A.clipboard.readText(K)}async writeClipboardText(N,K,Q){return A.clipboard.writeText(K,Q)}async readClipboardFindText(N){return A.clipboard.readFindText()}async writeClipboardFindText(N,K){return A.clipboard.writeFindText(K)}async writeClipboardBuffer(N,K,Q,ae){return A.clipboard.writeBuffer(K,Buffer.from(Q.buffer),ae)}async readClipboardBuffer(N,K){return w.$fe.wrap(A.clipboard.readBuffer(K))}async hasClipboard(N,K,Q){return A.clipboard.has(K,Q)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(N,K){this.F(N)?.updateTouchBar(K)}async notifyReady(N){this.F(N)?.setReady()}async relaunch(N,K){return this.f.relaunch(K)}async reload(N,K){const Q=this.F(N);if(Q){if((0,n.$$h)(Q.openedWorkspace)){const ae=Q.openedWorkspace.configPath;if(ae.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(ae))?.transient)return this.openWindow(Q.id,{forceReuseWindow:!0})}return this.f.reload(Q,K?.disableExtensions!==void 0?{_:[],"disable-extensions":K.disableExtensions}:void 0)}}async closeWindow(N){this.closeWindowById(N,N)}async closeWindowById(N,K){return(this.D(K)??this.F(K))?.win?.close()}async quit(N){const K=this.a.getLastActiveWindow();K?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&K.win?K.win.close():this.f.quit()}async exit(N,K){await this.f.kill(K)}async resolveProxy(N,K){return this.F(N)?.win?.webContents?.session?.resolveProxy(K)}async loadCertificates(N){return(0,R.loadSystemCertificates)({log:this.h})}findFreePort(N,K,Q,ae,ne=1){return(0,b.$kg)(K,Q,ae,ne)}async openDevTools(N,K){this.H(N)?.win?.webContents.openDevTools(K)}async toggleDevTools(N){this.H(N)?.win?.webContents.toggleDevTools()}async profileRenderer(N,K,Q){const ae=this.F(N);if(!ae||!ae.win)throw new Error;return await new I.$78b(ae.win,K,this.h).inspect(Q)}async windowsGetStringRegKey(N,K,Q,ae){if(!p.$i)return;const ne=await new Promise((ce,X)=>{Z(["@vscode/windows-registry"],ce,X)});try{return ne.GetStringRegKey(K,Q,ae)}catch{return}}D(N,K){return this.F(N)??this.G(N)??this.F(K)}F(N){if(typeof N=="number")return this.a.getWindowById(N)}G(N){if(typeof N=="number")return this.b.getWindowById(N)}H(N){let K=this.r.invokeFunction(t.$L8b);return K||(K=this.D(N)),K}};e.$98b=L,ve([C.$nh],L.prototype,"C",null),e.$98b=L=ve([te(0,t.$J8b),te(1,k.$H8b),te(2,u.$q8b),te(3,h.$$7b),te(4,a.$97b),te(5,i.$dj),te(6,o.$vj),te(7,r.$k8b),te(8,l.$A8b),te(9,E.$Uh)],L)}),define(re[300],oe([0,1,15,28,8,22,33,2,13,4,7,107,36,180,91,132,53,24,5,70,79,25,80,34,61,60,29]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i,o,r,t,n){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=void 0;const w="issue.processExplorerWindowState";let D=class{static{l=this}static{this.a="#1E1E1E"}constructor(R,L,T,N,K,Q,ae,ne,ce,X,Y){this.g=R,this.h=L,this.i=T,this.j=N,this.k=K,this.l=Q,this.m=ae,this.n=ne,this.o=ce,this.p=X,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){v.$VT.on("vscode:listProcesses",async R=>{const L=[];try{L.push({name:(0,f.localize)(0,null),rootProcess:await(0,p.$Ir)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(N=>{(0,y.$xm)(N)?L.push({name:N.hostName,rootProcess:N}):N.processes&&L.push({name:N.hostName,rootProcess:N.processes})})}catch(T){this.i.error(`Listing processes failed: ${T}`)}this.t(R,"vscode:listProcessesResponse",L)}),v.$VT.on("vscode:workbenchCommand",(R,L)=>{const{id:T,from:N,args:K}=L;let Q;switch(N){case"processExplorer":Q=this.f;break;default:throw new Error(`Unexpected command source: ${N}`)}Q?.webContents.send("vscode:runAction",{id:T,from:N,args:K})}),v.$VT.on("vscode:closeProcessExplorer",R=>{this.d?.close()}),v.$VT.on("vscode:pidToNameRequest",async R=>{const L=await this.k.getMainDiagnostics(),T=[];for(const N of L.windows)T.push([N.pid,`window [${N.id}] (${N.title})`]);for(const{pid:N,name:K}of r.$Q8b.getAll())T.push([N,K]);this.t(R,"vscode:pidToNameResponse",T)})}async openReporter(R){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const L=new P.$Qc,T=L.add(this.n.createIPCObjectUrl()),N=this.v(this.c,700,800);this.b=this.u(N,T,{backgroundColor:R.styles.backgroundColor,title:(0,f.localize)(1,null),zoomLevel:R.zoomLevel,alwaysOnTop:!1},"issue-reporter"),T.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:R,disableExtensions:!!this.h.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:E.default}),this.b.loadURL(d.$gg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(R){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const L=new P.$Qc,T=L.add(this.n.createIPCObjectUrl()),N=this.p.getItem(w,void 0),K=I(N)?N:this.v(this.f,800,500);this.d=this.u(K,T,{backgroundColor:R.styles.backgroundColor,title:(0,f.localize)(2,null),zoomLevel:R.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:R,product:E.default}),this.d.loadURL(d.$gg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const Q=()=>{if(!this.d)return;const ae=this.d.getSize(),ne=this.d.getPosition();if(!ae||!ne)return;const ce={width:ae[0],height:ae[1],x:ne[0],y:ne[1]};this.p.setItem(w,ce)};this.d.on("moved",Q),this.d.on("resized",Q)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const R=await S.contentTracing.stopRecording(`${(0,C.$0f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null,R),buttons:[(0,f.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,R)}async getSystemStatus(){const[R,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(R,L)}async $getSystemInfo(){const[R,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(R,L)}async $getPerformanceInfo(){try{const[R,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(R,L)}catch(R){throw this.i.warn("issueService#getPerformanceInfo ",R.message),R}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(R){this.i.error(R)}}async $showConfirmCloseDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(6,null),buttons:[(0,f.localize)(7,null),(0,f.localize)(8,null)]},this.b);R===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(9,null),buttons:[(0,f.localize)(10,null),(0,f.localize)(11,null)]},this.b);return R===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const R=this.q.getWindowById(this.c.id);if(!R)throw new Error("Window not found");return R}async $getIssueReporterUri(R){const L=this.issueReporterWindowCheck(),T=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return s.Promises.withAsyncBody(async(N,K)=>{const Q=new M.$2d;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",Q.token,{replyChannel:T,extensionId:R}),v.$VT.once(T,(ae,ne)=>{N($.URI.parse(ne))});try{await(0,s.$Yg)(5e3),Q.cancel(),K(new Error("Timed out waiting for issue reporter URI"))}finally{v.$VT.removeHandler(T)}})}async $getIssueReporterData(R){const L=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataProviderResponse${L.id}`;return s.Promises.withAsyncBody(async N=>{const K=new M.$2d;L.sendWhenReady("vscode:triggerIssueDataProvider",K.token,{replyChannel:T,extensionId:R}),v.$VT.once(T,(Q,ae)=>{N(ae)});try{await(0,s.$Yg)(5e3),K.cancel(),N("Error: Extension timed out waiting for issue reporter data")}finally{v.$VT.removeHandler(T)}})}async $getIssueReporterTemplate(R){const L=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataTemplateResponse${L.id}`;return s.Promises.withAsyncBody(async N=>{const K=new M.$2d;L.sendWhenReady("vscode:triggerIssueDataTemplate",K.token,{replyChannel:T,extensionId:R}),v.$VT.once(T,(Q,ae)=>{N(ae)});try{await(0,s.$Yg)(5e3),K.cancel(),N("Error: Extension timed out waiting for issue reporter template")}finally{v.$VT.removeHandler(T)}})}async $getReporterStatus(R,L){const T=[!1,!1],N=this.issueReporterWindowCheck(),K="vscode:triggerReporterStatus",Q=new M.$2d;return N.sendWhenReady(K,Q.token,{replyChannel:K,extensionId:R,extensionName:L}),await(0,s.$Pg)(new Promise(ne=>v.$VT.once("vscode:triggerReporterStatusResponse",(ce,X)=>ne(X))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),Q.cancel()})??T}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(R){R.isMinimized()&&R.restore(),R.focus()}t(R,L,...T){R.sender.isDestroyed()||R.sender.send(L,...T)}u(R,L,T,N){const K=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:R.width,height:R.height,minWidth:300,minHeight:200,x:R.x,y:R.y,title:T.title,backgroundColor:T.backgroundColor||l.a,webPreferences:{preload:d.$gg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$uC)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return K.setMenuBarVisibility(!1),K}v(R,L,T){let N;const K=S.screen.getAllDisplays();if(K.length===1)N=K[0];else{if(c.$j){const ne=S.screen.getCursorScreenPoint();N=S.screen.getDisplayNearestPoint(ne)}!N&&R&&(N=S.screen.getDisplayMatching(R.getBounds())),N||(N=S.screen.getPrimaryDisplay()||K[0])}const Q=N.bounds,ae={width:L,height:T,x:Q.x+Q.width/2-L/2,y:Q.y+Q.height/2-T/2};return Q.width>0&&Q.height>0&&(ae.x<Q.x&&(ae.x=Q.x),ae.y<Q.y&&(ae.y=Q.y),ae.x>Q.x+Q.width&&(ae.x=Q.x),ae.y>Q.y+Q.height&&(ae.y=Q.y),ae.width>Q.width&&(ae.width=Q.width),ae.height>Q.height&&(ae.height=Q.height)),ae}};e.$08b=D,e.$08b=D=l=ve([te(1,g.$97b),te(2,u.$dj),te(3,y.$wm),te(4,m.$T8b),te(5,b.$q8b),te(6,a.$88b),te(7,i.$s8b),te(8,h.$vj),te(9,o.$ON),te(10,n.$J8b)],D);function I(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(re[301],oe([0,1,22,17,24,20,5,70,25,51,26,49,100]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9b=void 0;let f=class extends v.$w9b{constructor(m,b,g,u,a,E,h,i){super(m,b,u,a,E,i),this.e=g,this.u=h}s(m){return(0,v.$v9b)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(p.$VU.CheckingForUpdates(m)),this.i.request({url:this.a},S.CancellationToken.None).then(c.$5o).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(p.$VU.Idle(1))):this.d(p.$VU.AvailableForDownload(b))}).then(void 0,b=>{this.j.error(b);const g=m?b.message||b:void 0;this.d(p.$VU.Idle(1,g))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(p.$VU.Idle(1))}};e.$y9b=f,e.$y9b=f=ve([te(0,M.$$7b),te(1,A.$pi),te(2,$.$il),te(3,s.$97b),te(4,c.$Yo),te(5,C.$dj),te(6,P.$88b),te(7,d.$vj)],f)}),define(re[302],oe([0,1,48,46,28,8,22,56,45,9,7,144,21,17,24,16,20,5,70,25,51,26,49,100]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=void 0;async function r(w,D=1e3){for(;!w();)await(0,M.$Yg)(D)}let t;function n(){return typeof t>"u"&&(t=A.existsSync(c.$ic(c.$lc(process.execPath),"unins000.exe"))?0:1),t}let l=class extends o.$w9b{get cachePath(){const D=c.$ic((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return v.Promises.mkdir(D,{recursive:!0}).then(()=>D)}constructor(D,I,k,R,L,T,N,K,Q){super(D,I,R,L,T,Q),this.u=k,this.v=N,this.w=K,D.setRelaunchHandler(this)}handleRelaunch(D){return D?.addArgs||D?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(i.$VU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(D){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$v9b)(I,D,this.k)}t(D){this.a&&(this.d(i.$VU.CheckingForUpdates(D)),this.i.request({url:this.a},C.CancellationToken.None).then(E.$5o).then(I=>{const k=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!D}),this.d(i.$VU.Idle(k)),Promise.resolve(null)):k===1?(this.d(i.$VU.AvailableForDownload(I)),Promise.resolve(null)):(this.d(i.$VU.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(R=>v.Promises.exists(R).then(L=>{if(L)return Promise.resolve(R);const T=I.url,N=I.hash,K=`${R}.tmp`;return this.i.request({url:T},C.CancellationToken.None).then(Q=>this.v.writeFile($.URI.file(K),Q.stream)).then(N?()=>(0,p.$QT)(K,I.hash):()=>{}).then(()=>v.Promises.rename(K,R,!1)).then(()=>R)})).then(R=>{const L=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:R},L?this.k.target==="user"?this.p():this.d(i.$VU.Downloaded(I)):this.d(i.$VU.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,d.$Ji)(String(I)))}),this.j.error(I);const k=D?I.message||I:void 0;this.d(i.$VU.Idle(n(),k))}))}async o(D){D.update.url&&this.w.openExternal(void 0,D.update.url),this.d(i.$VU.Idle(n()))}async B(D){const I=await this.cachePath;return c.$ic(I,`CodeSetup-${this.k.quality}-${D}.exe`)}async C(D=null){const I=D?T=>!new RegExp(`${this.k.quality}-${D}\\.exe$`).test(T):()=>!0,k=await this.cachePath,L=(await v.Promises.readdir(k)).filter(I).map(async T=>{try{await v.Promises.unlink(c.$ic(k,T))}catch{}});await Promise.all(L)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const D=this.state.update;this.d(i.$VU.Updating(D));const I=await this.cachePath;this.e.updateFilePath=c.$ic(I,`CodeSetup-${this.k.quality}-${D.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(i.$VU.Idle(n()))});const R=`${this.k.win32MutexName}-ready`,L=await new Promise((T,N)=>{Z(["@vscode/windows-mutex"],T,N)});r(()=>L.isActive(R)).then(()=>this.d(i.$VU.Ready(D)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(D){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),k={version:"unknown",productVersion:"unknown"};this.d(i.$VU.Downloading(k)),this.e={packagePath:D},I?this.k.target==="user"?this.p():this.d(i.$VU.Downloaded(k)):this.d(i.$VU.Ready(k))}};e.$A9b=l,ve([P.$nh],l.prototype,"cachePath",null),e.$A9b=l=ve([te(0,b.$$7b),te(1,f.$pi),te(2,h.$il),te(3,y.$97b),te(4,E.$Yo),te(5,g.$dj),te(6,m.$ek),te(7,u.$88b),te(8,a.$vj)],l)}),define(re[133],oe([0,1,15,8,22,50,3,2,13,67,4,7,190,65,17,53,24,63,16,20,5,25,80,252,82,26,102,69,60,29,30,55,128,136,39,34,54,68,23,6]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i,o,r,t,n,l,w,D,I,k,R,L,T,N,K,Q,ae,ne){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=e.$E8b=void 0;var X;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(X||(X={}));class Y extends P.$Rc{constructor(j){super(),this.a=j,this.f=void 0,this.g=void 0}setRepresentedFilename(j){$.$j?this.win?.setRepresentedFilename(j):this.b=j}getRepresentedFilename(){return $.$j?this.win?.getRepresentedFilename():this.b}setDocumentEdited(j){$.$j&&this.win?.setDocumentEdited(j),this.c=j}isDocumentEdited(){return $.$j?!!this.win?.isDocumentEdited():!!this.c}focus(j){$.$j&&j?.force&&S.app.focus({steal:!0});const H=this.win;H&&(H.isMinimized()&&H.restore(),H.focus())}toggleFullScreen(){this.h(!this.isFullScreen)}h(j){this.r()?this.j(j):this.n(j)}get isFullScreen(){if($.$j&&typeof this.f=="boolean")return this.f;const j=this.win,H=j?.isFullScreen(),B=j?.isSimpleFullScreen();return!!(H||B)}j(j){const H=this.win;H?.isSimpleFullScreen()&&H?.setSimpleFullScreen(!1),this.m(j)}m(j){$.$j&&(this.f=j,this.g=new A.$ih,Promise.race([this.g.p,(0,A.$Yg)(1e4)]).finally(()=>{this.f=void 0})),this.win?.setFullScreen(j)}n(j){const H=this.win;H?.isFullScreen()&&this.m(!1),H?.setSimpleFullScreen(j),H?.webContents.focus()}r(){const j=this.a.getValue("window");return!j||typeof j.nativeFullScreen!="boolean"||j.nativeTabs?!0:j.nativeFullScreen!==!1}}e.$E8b=Y;let V=class extends Y{static{ce=this}static{this.s="windowControlHeight"}get id(){return this.D}get win(){return this.F}get lastFocusTime(){return this.G}get backupPath(){return this.H?.backupPath}get openedWorkspace(){return this.H?.workspace}get profile(){if(!this.config)return;const j=this.Z.profiles.find(H=>H.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.Z.getProfileForWorkspace(this.config.workspace??(0,I.$0h)(this.backupPath,this.isExtensionDevelopmentHost))??this.Z.defaultProfile}get remoteAuthority(){return this.H?.remoteAuthority}get config(){return this.H}get isExtensionDevelopmentHost(){return!!this.H?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.H?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.H?.debugId}constructor(j,H,B,_,se,J,O,U,G,F,z,W,x,he,de,le,we,be,Ee,Se,Fe){super(F),this.U=H,this.W=B,this.X=_,this.Y=se,this.Z=J,this.$=O,this.ab=U,this.bb=G,this.db=z,this.eb=W,this.fb=x,this.gb=he,this.hb=de,this.ib=le,this.jb=we,this.kb=be,this.lb=Ee,this.mb=Se,this.t=this.B(new C.$Rd),this.onWillLoad=this.t.event,this.u=this.B(new C.$Rd),this.onDidSignalReady=this.u.event,this.w=this.B(new C.$Rd),this.onDidTriggerSystemContextMenu=this.w.event,this.z=this.B(new C.$Rd),this.onDidClose=this.z.event,this.C=this.B(new C.$Rd),this.onDidDestroy=this.C.event,this.G=-1,this.L=!1,this.M=[],this.N=[],this.O=void 0,this.P=void 0,this.Q=this.B(this.kb.createIPCObjectUrl()),this.S=!1,this.nb=0;{const[ke,pe]=this.xb(j.state);this.I=ke,this.U.trace("window#ctor: using window state",ke);const ee=this.I.mode===0||this.I.mode===3,ue=this.a.getValue("window"),ge=Fe.invokeFunction(D.$K8b,this.I,{show:!ee,webPreferences:{preload:d.$gg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.Q.resource.toString()}`],v8CacheOptions:this.X.useCodeCache?"bypassHeatCheck":"none"}});$.$j&&!this.r()&&(ge.fullscreenable=!1);const Re=$.$j&&ue?.nativeTabs===!0;Re&&(ge.tabbingIdentifier=this.jb.nameShort);const De=(0,w.$sC)(this.a)==="custom";if(De&&(ge.titleBarStyle="hidden",$.$j||(ge.frame=!1),(0,w.$tC)(this.a))){const je=this.db.getWindowSplash()?.colorInfo.titleBarBackground??this.db.getBackgroundColor(),Me=L.$4s.fromHex(je).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:je,symbolColor:Me},this.L=!0}if((0,c.mark)("code/willCreateCodeBrowserWindow"),this.F=new S.BrowserWindow(ge),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.D=this.F.id,$.$j&&De&&this.F.setSheetOffset(22),De&&($.$i&&(0,w.$tC)(this.a)||$.$j)){const je=this.mb.getItem(ce.s);je&&this.updateWindowControls({height:je})}$.$i&&De&&this.F.hookWindowMessage(278,()=>{const[Me,Ve]=this.F.getPosition(),ze=S.screen.getCursorScreenPoint(),ie=ze.x-Me,fe=ze.y-Ve;return(()=>!(ie>30&&fe>=0&&fe<=Math.max(this.F.getBounds().height*.15,35)))()||(this.F.setEnabled(!1),this.F.setEnabled(!0),this.w.fire({x:ie,y:fe})),0}),($.$j||$.$i)&&pe&&(!Re||S.BrowserWindow.getAllWindows().length===1)&&[this.I.width,this.I.height,this.I.x,this.I.y].every(je=>typeof je=="number")&&this.F.setBounds({width:this.I.width,height:this.I.height,x:this.I.x,y:this.I.y}),ee&&((0,c.mark)("code/willMaximizeCodeWindow"),this.F.maximize(),this.I.mode===3&&this.h(!0),this.F.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.G=Date.now()}this.X.args["open-devtools"]===!0&&this.F.webContents.openDevTools(),this.ub(),this.Eb(),this.ob()}setReady(){for(this.U.trace(`window#load: window reported ready (id: ${this.D})`),this.nb=2;this.M.length;)this.M.pop()(this);this.u.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.M.push(j)})}get isReady(){return this.nb===2}get whenClosedOrLoaded(){return new Promise(j=>{function H(){B.dispose(),_.dispose(),j()}const B=this.onDidClose(()=>H()),_=this.onWillLoad(()=>H())})}ob(){this.F.on("unresponsive",()=>this.rb(1)),this.F.webContents.on("render-process-gone",(H,B)=>this.rb(2,{...B})),this.F.webContents.on("did-fail-load",(H,B,_)=>this.rb(3,{reason:_,exitCode:B})),this.F.webContents.on("will-prevent-unload",H=>{H.preventDefault()}),this.F.on("closed",()=>{this.z.fire(),this.dispose()}),this.F.webContents.on("did-finish-load",()=>{this.R&&(this.H=this.R,this.R=void 0)}),this.F.on("focus",()=>{this.G=Date.now()}),this.F.on("maximize",H=>{this.H&&(this.H.maximized=!0),S.app.emit("browser-window-maximize",H,this.F)}),this.F.on("unmaximize",H=>{this.H&&(this.H.maximized=!1),S.app.emit("browser-window-unmaximize",H,this.F)}),this.F.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.g?.complete(),this.g=void 0}),this.F.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.g?.complete(),this.g=void 0}),this.B(this.a.onDidChangeConfiguration(H=>this.ub(H))),this.B(this.eb.onDidDeleteUntitledWorkspace(H=>this.tb(H)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.F.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(H,B)=>{const _=await this.qb();B({cancel:!1,requestHeaders:Object.assign(H.requestHeaders,_)})})}qb(){return this.pb||(this.pb=(0,o.$gp)(this.jb.version,this.jb,this.X,this.a,this.$,this.ab,this.gb)),this.pb}async rb(j,H){switch(j){case 2:this.U.error(`CodeWindow: renderer process gone (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break;case 1:this.U.error("CodeWindow: detected unresponsive");break;case 3:this.U.error(`CodeWindow: failed to load (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break}switch(this.gb.publicLog2("windowerror",{type:j,reason:H?.reason,code:H?.exitCode}),j){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ib.kill(1);return}if(this.X.args["enable-smoke-test-driver"]){await this.sb(!1,!1),this.ib.quit();return}if(j===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.F&&this.F.webContents&&this.F.webContents.isDevToolsOpened())return;const{response:B,checkboxChecked:_}=await this.hb.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.H?.workspace?(0,v.localize)(5,null):void 0},this.F);if(B!==2){const se=B===0;await this.sb(se,_)}}else if(j===2){let B;H?B=(0,v.localize)(7,null,H.reason,H.exitCode??"<unknown>"):B=(0,v.localize)(6,null);const{response:_,checkboxChecked:se}=await this.hb.showMessageBox({type:"warning",buttons:[this.H?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:B,detail:this.H?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.H?.workspace?(0,v.localize)(13,null):void 0},this.F),J=_===0;await this.sb(J,se)}break}}async sb(j,H){const B=this.H?.workspace;if(H&&B)try{const _=this.bb.workspaceStorage(B);await _.init(),_.delete("memento/workbench.parts.editor"),await _.close()}catch(_){this.U.error(_)}if(this.C.fire(),this.F?.destroy(),j&&this.H){let _,se;(0,I.$6h)(B)?_={folderUri:B.uri}:(0,I.$$h)(B)?_={workspaceUri:B.configPath}:se=!0,(0,ae.$Nb)(await this.lb.open({context:5,userEnv:this.H.userEnv,cli:{...this.X.args,_:[]},urisToOpen:_?[_]:void 0,forceEmpty:se,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}tb(j){this.H?.workspace?.id===j.id&&(this.H.workspace=void 0)}ub(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const H=this.Bb();H!==this.J&&(this.J=H,this.Cb(H))}if(!j||j.affectsConfiguration("http.proxy")){let H=(this.a.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;H?.endsWith("/")&&(H=H.substr(0,H.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((H||"").indexOf("@")===-1&&(H!==this.O||B!==this.P)){this.O=H,this.P=B;const _=H||"",se=B?`${B},<local>`:"<local>";this.U.trace(`Setting proxy to '${_}', bypassing '${se}'`),this.F.webContents.session.setProxy({proxyRules:_,proxyBypassRules:se,pacScript:""})}}}addTabbedWindow(j){$.$j&&j.win&&this.F.addTabbedWindow(j.win)}load(j,H=Object.create(null)){this.U.trace(`window#load: attempt to load window (id: ${this.D})`),this.isDocumentEdited()&&(!H.isReload||!this.fb.isHotExitEnabled())&&this.setDocumentEdited(!1),H.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.F.setTitle(this.jb.nameLong)),this.vb(j,H),this.nb===0?this.H=j:this.R=j,this.nb=1,this.F.loadURL(d.$gg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.X.isBuilt?"":"-dev"}.html`).toString(!0));const B=this.S;this.S=!0,!this.X.isBuilt&&!this.X.extensionTestsLocationURI&&this.B(new A.$0g(()=>{this.F&&!this.F.isVisible()&&!this.F.isMinimized()&&(this.F.show(),this.focus({force:!0}),this.F.webContents.openDevTools())},1e4)).schedule(),this.t.fire({workspace:j.workspace,reason:H.isReload?3:B?2:1})}vb(j,H){const B=(this.H??this.R)?.userEnv;if(B){const _=(0,g.$Tl)(B)&&!(0,g.$Tl)(j.userEnv),se=this.isExtensionDevelopmentHost;(_||se)&&(j.userEnv={...B,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),H.disableExtensions!==void 0&&(j["disable-extensions"]=H.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.F.isMaximized(),j.partsSplash=this.db.getWindowSplash(),(0,c.mark)("code/willOpenNewWindow"),j.perfMarks=(0,c.getMarks)(),this.Q.update(j)}async reload(j){const H=Object.assign({},this.H);H.workspace=await this.wb(H),delete H.filesToOpenOrCreate,delete H.filesToDiff,delete H.filesToMerge,delete H.filesToWait,this.isExtensionDevelopmentHost&&j&&(H.verbose=j.verbose,H.debugId=j.debugId,H.extensionEnvironment=j.extensionEnvironment,H["inspect-extensions"]=j["inspect-extensions"],H["inspect-brk-extensions"]=j["inspect-brk-extensions"],H["extensions-dir"]=j["extensions-dir"]),H.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),H.isInitialStartup=!1,H.policiesData=this.Y.serialize(),H.continueOn=this.X.continueOn,H.profiles={all:this.Z.profiles,profile:this.profile||this.Z.defaultProfile,home:this.Z.profilesHome},H.logLevel=this.W.getLogLevel(),H.loggers={window:this.W.getRegisteredLoggers(this.id),global:this.W.getRegisteredLoggers()},this.load(H,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async wb(j){if((0,I.$$h)(j.workspace)){const H=j.workspace.configPath;if(H.scheme===d.Schemas.file&&!await this.$.exists(H))return}else if((0,I.$6h)(j.workspace)){const H=j.workspace.uri;if(H.scheme===d.Schemas.file&&!await this.$.exists(H))return}return j.workspace}serializeWindowState(){if(!this.F)return(0,R.$87b)();if(this.isFullScreen){let B;try{B=S.screen.getDisplayMatching(this.getBounds())}catch{}const _=(0,R.$87b)();return{mode:3,display:B?B.id:void 0,width:this.I.width||_.width,height:this.I.height||_.height,x:this.I.x||0,y:this.I.y||0}}const j=Object.create(null);let H;if(!$.$j&&this.F.isMaximized()?H=0:H=1,H===0?j.mode=0:j.mode=1,H===1||H===0){let B;H===1?B=this.getBounds():B=this.F.getNormalBounds(),j.x=B.x,j.y=B.y,j.width=B.width,j.height=B.height}return j}updateWindowControls(j){if(j.height&&this.mb.setItem(ce.s,j.height),$.$i&&this.L)this.F.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if($.$j&&j.height!==void 0){const H=(j.height-15)/2;H?this.F.setWindowButtonPosition({x:H,y:H}):this.F.setWindowButtonPosition(null)}}xb(j){(0,c.mark)("code/willRestoreCodeWindowState");let H=!1;if(j)try{const B=S.screen.getAllDisplays();H=B.length>1,j=this.yb(j,B)}catch(B){this.U.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,c.mark)("code/didRestoreCodeWindowState"),[j||(0,R.$87b)(),H]}yb(j,H){if(this.U.trace(`window#validateWindowState: validating window state on ${H.length} display(s)`,j),typeof j.x!="number"||typeof j.y!="number"||typeof j.width!="number"||typeof j.height!="number"){this.U.trace("window#validateWindowState: unexpected type of state values");return}if(j.width<=0||j.height<=0){this.U.trace("window#validateWindowState: unexpected negative values");return}if(H.length===1){const se=this.zb(H[0]);if(se){let J=function(){!j||typeof j.x!="number"||typeof j.y!="number"||!se||(j.x<se.x&&(j.x=se.x),j.y<se.y&&(j.y=se.y))};this.U.trace("window#validateWindowState: 1 monitor working area",se),J(),j.width>se.width&&(j.width=se.width),j.height>se.height&&(j.height=se.height),j.x>se.x+se.width-128&&(j.x=se.x+se.width-j.width),j.y>se.y+se.height-128&&(j.y=se.y+se.height-j.height),J()}return j}if(j.display&&j.mode===3){const se=H.find(J=>J.id===j.display);if(se&&typeof se.bounds?.x=="number"&&typeof se.bounds?.y=="number"){this.U.trace("window#validateWindowState: restoring fullscreen to previous display");const J=(0,R.$87b)(3);return J.x=se.bounds.x,J.y=se.bounds.y,J}}let B,_;try{B=S.screen.getDisplayMatching({x:j.x,y:j.y,width:j.width,height:j.height}),_=this.zb(B)}catch{}if(B&&_&&j.x+j.width>_.x&&j.y+j.height>_.y&&j.x<_.x+_.width&&j.y<_.y+_.height)return this.U.trace("window#validateWindowState: multi-monitor working area",_),j}zb(j){if(j.workArea.width>0&&j.workArea.height>0)return j.workArea;if(j.bounds.width>0&&j.bounds.height>0)return j.bounds}getBounds(){const[j,H]=this.F.getPosition(),[B,_]=this.F.getSize();return{x:j,y:H,width:B,height:_}}h(j){super.h(j),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.J&&this.Cb(this.J,!1)}Bb(){let j=(0,w.$rC)(this.a);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Cb(j,H=!0){$.$j||(j==="toggle"&&H&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),j==="hidden"?setTimeout(()=>{this.Db(j)}):this.Db(j))}Db(j){const H=this.isFullScreen;switch(j){case"classic":this.F.setMenuBarVisibility(!H),this.F.autoHideMenuBar=H;break;case"visible":this.F.setMenuBarVisibility(!0),this.F.autoHideMenuBar=!1;break;case"toggle":this.F.setMenuBarVisibility(!1),this.F.autoHideMenuBar=!0;break;case"hidden":this.F.setMenuBarVisibility(!1),this.F.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if($.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.F.minimize();break;case"None":break;case"Maximize":default:this.F.isMaximized()?this.F.unmaximize():this.F.maximize()}else this.F.isMaximized()?this.F.unmaximize():this.F.maximize()}close(){this.F?.close()}sendWhenReady(j,H,...B){this.isReady?this.send(j,...B):this.ready().then(()=>{H.isCancellationRequested||this.send(j,...B)})}send(j,...H){if(this.F){if(this.F.isDestroyed()||this.F.webContents.isDestroyed()){this.U.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.F.webContents.send(j,...H)}catch(B){this.U.warn(`Error sending IPC message to channel '${j}' of window ${this.D}: ${(0,M.$Gi)(B)}`)}}}updateTouchBar(j){$.$j&&this.N.forEach((H,B)=>{const _=j[B];H.segments=this.Gb(_)})}Eb(){if($.$j){for(let j=0;j<10;j++){const H=this.Fb();this.N.push(H)}this.F.setTouchBar(new S.TouchBar({items:this.N}))}}Fb(j=[]){const H=this.Gb(j),B=new S.TouchBar.TouchBarSegmentedControl({segments:H,mode:"buttons",segmentStyle:"automatic",change:_=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:B.segments[_].id,from:"touchbar"})}});return B}Gb(j=[]){return j.map(B=>{let _;B.icon&&!n.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===d.Schemas.file&&(_=S.nativeImage.createFromPath(p.URI.revive(B.icon.dark).fsPath),_.isEmpty()&&(_=void 0));let se;return typeof B.title=="string"?se=B.title:se=B.title.value,{id:B.id,label:_?void 0:se,icon:_}})}dispose(){super.dispose(),this.W.deregisterLoggers(this.id),this.F=null}};e.$F8b=V,e.$F8b=V=ce=ve([te(1,E.$dj),te(2,Q.$C8b),te(3,b.$97b),te(4,T.$on),te(5,K.$e8b),te(6,u.$ek),te(7,r.$i8b),te(8,r.$g8b),te(9,y.$pi),te(10,l.$k8b),te(11,k.$A8b),te(12,f.$p8b),te(13,t.$il),te(14,m.$q8b),te(15,a.$$7b),te(16,h.$vj),te(17,i.$s8b),te(18,D.$J8b),te(19,N.$ON),te(20,ne.$Uh)],V)}),define(re[303],oe([0,1,15,3,17,24,5,133]),function(Z,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;let d=class extends P.$E8b{get win(){return this.t||this.tryClaimWindow(),this.t}get lastFocusTime(){return this.u}constructor($,p,v,f){super(f),this.w=$,this.z=p,this.C=v,this.s=this.B(new A.$Rd),this.onDidClose=this.s.event,this.id=this.w.id,this.parentId=-1,this.t=null,this.u=Date.now(),this.D()}D(){this.z.args["open-devtools"]===!0&&this.w.openDevTools({mode:"bottom"}),this.tryClaimWindow()}tryClaimWindow(){if(this.t||this.q.isDisposed||this.w.isDestroyed())return;const $=S.BrowserWindow.fromWebContents(this.w);$&&(this.C.trace("[aux window] Claimed browser window instance"),this.t=$,$.setMenu(null),this.F($))}F($){$.on("closed",()=>{this.C.trace("[aux window] Closed window"),this.s.fire(),this.dispose()}),$.on("focus",()=>{this.u=Date.now()})}dispose(){super.dispose(),this.t=null}};e.$G8b=d,e.$G8b=d=ve([te(1,M.$97b),te(2,C.$dj),te(3,s.$pi)],d)}),define(re[304],oe([0,1,15,3,13,36,303,6,5,29]),function(Z,e,S,A,s,M,C,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=void 0;let $=class{constructor(v,f){this.b=v,this.c=f,this.a=new Map,this.d()}d(){S.app.on("browser-window-created",(v,f)=>{const y=this.getWindowById(f.id);y&&(this.c.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),y.tryClaimWindow())}),M.$VT.handle("vscode:registerAuxiliaryWindow",async(v,f)=>{const y=this.getWindowById(v.sender.id);return y&&(this.c.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),y.parentId=f),v.sender.id})}createWindow(){return this.b.invokeFunction(c.$K8b,void 0,{webPreferences:{preload:s.$gg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(v){const f=this.b.createInstance(C.$G8b,v);this.a.set(f.id,f),A.Event.once(f.onDidClose)(()=>this.a.delete(f.id))}getWindowById(v){return this.a.get(v)}getFocusedWindow(){const v=S.BrowserWindow.getFocusedWindow();if(v)return this.getWindowById(v.id)}getLastActiveWindow(){return(0,c.$M8b)(Array.from(this.a.values()))}getWindows(){return Array.from(this.a.values())}};e.$69b=$,e.$69b=$=ve([te(0,P.$Uh),te(1,d.$dj)],$)}),define(re[83],oe([0,1,15,23,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,55,31,53]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$i9b=e.$h9b=void 0,e.$h9b=(0,y.$Vh)("workspacesHistoryMainService");let r=class extends P.$Rc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,l,w,D,I){super(),this.f=n,this.g=l,this.h=w,this.j=D,this.m=I,this.c=this.B(new M.$Rd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$Vg(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let l=[],w=[];for(const I of n)if((0,u.$bfb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(l,I.workspace)&&l.push(I);else if((0,u.$cfb)(I))this.y(l,I.folderUri)||l.push(I);else{const k=this.z(w,I.fileUri),R=I.fileUri.scheme===d.Schemas.file&&o.G.indexOf((0,$.$wg)(I.fileUri))>=0;!k&&!R&&(w.push(I),c.$i&&I.fileUri.scheme===d.Schemas.file&&S.app.addRecentDocument(I.fileUri.fsPath))}const D=await this.r({workspaces:l,files:w});l=D.workspaces,w=D.files,l.length>o.a&&(l.length=o.a),w.length>o.a&&(w.length=o.a),await this.t({workspaces:l,files:w}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const l=k=>{const R=this.u(k);for(const L of n)if($.$qg.isEqual(L,R))return!1;return!0},w=await this.getRecentlyOpened(),D=w.workspaces.filter(l),I=w.files.filter(l);(D.length!==w.workspaces.length||I.length!==w.files.length)&&(await this.t({files:I,workspaces:D}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:l}=await this.m.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null)],message:(0,f.localize)(2,null),detail:(0,f.localize)(3,null),cancelId:1});if(l!==0)return}await this.t({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const l=new h.$zc(I=>$.$qg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)l.set(this.u(I),I);const w=new h.$zc(I=>$.$qg.getComparisonKey(I));if(n?.files)for(const I of n.files)w.set(this.u(I),I);const D=await this.s();for(const I of D.workspaces){const k=l.get(this.u(I));k?k.label=k.label??I.label:l.set(this.u(I),I)}for(const I of D.files){const k=w.get(this.u(I));k?k.label=k.label??I.label:w.set(this.u(I),I)}return{workspaces:[...l.values()],files:[...w.values()]}}async s(){await this.j.whenReady;let n;const l=this.j.get(o.b,-1);if(typeof l=="string")try{n=JSON.parse(l)}catch(w){this.f.error("Unexpected error parsing opened paths list",w)}return(0,u.$ifb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,u.$jfb)(n)),-1,1)}u(n){return(0,u.$cfb)(n)?n.folderUri:(0,u.$dfb)(n)?n.fileUri:n.workspace.configPath}w(n,l){return!!n.find(w=>(0,u.$bfb)(w)&&w.workspace.id===l.id)}y(n,l){return!!n.find(w=>(0,u.$cfb)(w)&&$.$qg.isEqual(w.folderUri,l))}z(n,l){return!!n.find(w=>$.$qg.isEqual(w.fileUri,l))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(4,null),description:(0,f.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const I of S.app.getJumpListSettings().removedItems){const k=I.args;if(k){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(k);R&&l.push(p.URI.parse(R[2]))}}await this.removeRecentlyOpened(l);let w=!1;const D=(0,A.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const k=(0,u.$bfb)(I)?I.workspace:I.folderUri,{title:R,description:L}=this.L(k,I.label);let T;return p.URI.isUri(k)?T=`--folder-uri "${k.toString()}"`:(w=!0,T=`--file-uri "${k.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:L.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&n.push({type:"custom",name:w?(0,f.localize)(6,null):(0,f.localize)(7,null),items:D})}n.push({type:"recent"});try{const l=S.app.setJumpList(n);l&&l!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.f.warn("updateWindowsJumpList#setJumpList",l)}}L(n,l){if(l)return{title:(0,C.$Hv)(l).name,description:l};if(p.URI.isUri(n))return{title:(0,$.$wg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,f.localize)(8,null),description:""};let w=(0,$.$wg)(n.configPath);return w.endsWith(a.$fi)&&(w=w.substr(0,w.length-a.$fi.length-1)),{title:(0,f.localize)(9,null,w),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,C.$zv)(n.fsPath):n.toString()}async N(){if(!c.$j)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),l=[];let w=0;for(let I=0;I<n.workspaces.length&&w<o.C;I++){const k=this.u(n.workspaces[I]);if(k.scheme===d.Schemas.file){const R=(0,$.$ng)(k);await v.Promises.exists(R)&&(l.push(R),w++)}}const D=[];for(let I=0;I<n.files.length&&w<o.D;I++){const k=this.u(n.files[I]);if(k.scheme===d.Schemas.file){const R=(0,$.$ng)(k);if(o.G.includes((0,$.$wg)(k))||l.includes(R))continue;await v.Promises.exists(R)&&(D.push(R),w++)}}D.reverse().forEach(I=>S.app.addRecentDocument(I)),l.reverse().forEach(I=>S.app.addRecentDocument(I))}};e.$i9b=r,e.$i9b=r=o=ve([te(0,b.$dj),te(1,E.$A8b),te(2,m.$$7b),te(3,g.$i8b),te(4,i.$q8b)],r)}),define(re[305],oe([0,1,15,8,22,47,4,7,181,64,17,24,20,5,231,70,25,34,26,49,60,29,83]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=void 0;const r="menu";let t=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(w,D,I,k,R,L,T,N,K,Q,ae,ne){this.n=w,this.o=D,this.p=I,this.q=k,this.r=R,this.s=L,this.t=T,this.u=N,this.v=K,this.w=Q,this.x=ae,this.y=ne,this.m=Object.create(null),this.g=new A.$0g(()=>this.F(),0),this.h=new A.$0g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$j||(0,E.$sC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const w=this.t.getItem(o.a);w&&(w.menus&&(this.k=w.menus),w.keybindings&&(this.l=w.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(L,T,N)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:T?.id})},this.m["workbench.action.newWindow"]=(L,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(L,T,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(L,T,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(L,T,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const w=this.x.youTubeUrl;w&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(w,"openYouTubeUrl"));const D=this.x.requestFeatureUrl;D&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(D,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const k=this.x.licenseUrl;k&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const L=k.indexOf("?")>0?"&":"?";this.ab(`${k}${L}lang=${C.$w}`,"openLicenseUrl")}else this.ab(k,"openLicenseUrl")});const R=this.x.privacyStatementUrl;R&&k&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(R,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(w=>this.G(w)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const w=this.o.getValue("window.enableMenuBarMnemonics");return typeof w!="boolean"?!0:w}get D(){if(!C.$j)return!1;const w=this.o.getValue("window.nativeTabs");return typeof w!="boolean"?!1:w}updateMenu(w,D){this.k=w.menus,this.l=w.keybindings,this.t.setItem(o.a,w),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(w){C.$j&&(w.oldCount===0&&w.newCount>0||w.oldCount>0&&w.newCount===0)&&(this.d=w.newCount===0,this.E())}H(){if(!C.$j)return;const w=S.BrowserWindow.getFocusedWindow();this.f=!w||!!this.y.getWindowById(w.id),this.E()}I(){const w=S.Menu.getApplicationMenu();if(w&&this.j.push(w),Object.keys(this.k).length===0){this.J(C.$j?new S.Menu:null);return}const D=new S.Menu;let I;if(C.$j){const R=new S.Menu;I=new S.MenuItem({label:this.x.nameShort,submenu:R}),this.K(R),D.append(I)}if(C.$j&&!this.c){this.c=!0;const R=new S.Menu;R.append(new S.MenuItem({label:this.cb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(R)}if(this.M("File")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(1,null)),submenu:R});this.O(R,"File"),D.append(L)}if(this.M("Edit")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(2,null)),submenu:R});this.O(R,"Edit"),D.append(L)}if(this.M("Selection")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(3,null)),submenu:R});this.O(R,"Selection"),D.append(L)}if(this.M("View")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(4,null)),submenu:R});this.O(R,"View"),D.append(L)}if(this.M("Go")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(5,null)),submenu:R});this.O(R,"Go"),D.append(L)}if(this.M("Run")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(6,null)),submenu:R});this.O(R,"Run"),D.append(L)}if(this.M("Terminal")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(7,null)),submenu:R});this.O(R,"Terminal"),D.append(L)}let k;if(this.M("Window")){const R=new S.Menu;k=new S.MenuItem({label:this.cb(d.localize(8,null)),submenu:R,role:"window"}),this.U(R)}if(k&&D.append(k),this.M("Help")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(9,null)),submenu:R,role:"help"});this.O(R,"Help"),D.append(L)}D.items&&D.items.length>0?this.J(D):this.J(null),this.h.schedule()}J(w){if(S.Menu.setApplicationMenu(w),w)for(const D of this.y.getWindows())D.win?.setMenu(null)}K(w){const D=this.W(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let k;if(this.M("Preferences")){const ne=new S.Menu;this.O(ne,"Preferences"),k=new S.MenuItem({label:this.cb(d.localize(11,null)),submenu:ne})}const R=new S.Menu,L=new S.MenuItem({label:d.localize(12,null),role:"services",submenu:R}),T=new S.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new S.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new S.MenuItem({label:d.localize(15,null),role:"unhide"}),Q=new S.MenuItem(this.$("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(ne,ce,X)=>{const Y=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||Y?.win?.isMinimized())&&await this.L(X)&&this.w.quit(void 0)}})),ae=[D];ae.push(...I),k&&ae.push(n(),k),ae.push(n(),L,n(),T,N,K,n(),Q),ae.forEach(ne=>w.append(ne))}async L(w){if(this.p.getWindowCount()===0)return!0;const D=this.o.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.S(w)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return I===0}return!0}M(w){if(!C.$j&&(0,E.$sC)(this.o)==="custom")return!1;switch(w){case"File":case"Help":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[w];case"Window":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[w]}}N(w,D){D.forEach(I=>{if((0,y.$e9b)(I))w.append(n());else if((0,y.$d9b)(I)){const k=new S.Menu,R=new S.MenuItem({label:this.cb(I.label),submenu:k});this.N(k,I.submenu.items),w.append(R)}else(0,y.$f9b)(I)?w.append(this.Q(I)):(0,y.$g9b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(w),C.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?w.append(new S.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):w.append(this.W(I.label,I.id,!1,I.checked)):w.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):w.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(w,D){this.k&&this.k[D]&&this.N(w,this.k[D].items)}P(w){const D=this.V();D.length&&(D.forEach(I=>w.append(I)),w.append(n()))}Q(w){const D=P.URI.revive(w.uri),I=w.id,k=I==="openRecentFile"?{fileUri:D}:I==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new S.MenuItem(this.$(I,{label:w.label,click:async(R,L,T)=>{const N=this.R(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[k],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:w.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([D])}},!1))}R(w){return!!(w&&(!C.$j&&(w.ctrlKey||w.shiftKey)||C.$j&&(w.metaKey||w.altKey)))}S(w){return!!(w.triggeredByAccelerator||w.altKey||w.ctrlKey||w.metaKey||w.shiftKey)}T(w,D,I){const k={label:this.cb(w),role:I,enabled:!0};return new S.MenuItem(this.Z(D,k))}U(w){const D=new S.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new S.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),k=new S.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),R=this.W(d.localize(23,null),"workbench.action.switchWindow"),L=[];this.D&&(L.push(n()),L.push(this.W(d.localize(24,null),"workbench.action.newWindowTab")),L.push(this.T(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.T(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.T(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.T(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,I,n(),R,...L,n(),k].forEach(T=>w.append(T))}V(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.cb(d.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.cb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.cb(d.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.cb(d.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(w,D,I,k){const R=this.cb(w),L=typeof D=="function"?D:(ae,ne,ce)=>{const X=ae?ae.userSettingsLabel:null;let Y=D;Array.isArray(D)&&(Y=this.R(ce)?D[1]:D[0]),X&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:X}):this.Y({type:"commandId",commandId:Y})},T=typeof I=="boolean"?I:this.p.getWindowCount()>0,N=typeof k=="boolean"?k:!1,K={label:R,click:L,enabled:T};N&&(K.type="checkbox",K.checked=N);let Q;return typeof D=="string"?Q=D:Array.isArray(D)&&(Q=D[0]),C.$j&&(Q==="editor.action.clipboardCutAction"?K.role="cut":Q==="editor.action.clipboardCopyAction"?K.role="copy":Q==="editor.action.clipboardPasteAction"&&(K.role="paste"),Q==="undo"?K.click=this.X(L,{inDevTools:ae=>ae.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):Q==="redo"?K.click=this.X(L,{inDevTools:ae=>ae.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):Q==="editor.action.selectAll"&&(K.click=this.X(L,{inDevTools:ae=>ae.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.Z(Q,K))}X(w,D){return(I,k,R)=>{const L=S.BrowserWindow.getFocusedWindow();if(!L)return D.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return D.inDevTools(L.webContents.devToolsWebContents);w(I,k||L,R)}}Y(w){let D=S.BrowserWindow.getFocusedWindow();if(D){const k=this.y.getWindowById(D.id);k&&(D=this.p.getWindowById(k.parentId)?.win??null)}if(!D){const k=this.p.getLastActiveWindow();k?.win?.isMinimized()&&(D=k.win)}const I=D?this.p.getWindowById(D.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",w),C.$j&&!this.q.isBuilt&&!I.isReady&&(w.type==="commandId"&&w.commandId==="workbench.action.toggleDevTools"||w.type!=="commandId"&&w.userSettingsLabel==="alt+cmd+i"))return!1;if(w.type==="commandId"){const k={id:w.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,k)}else{const k={userSettingsLabel:w.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,k)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",w),!1}Z(w,D){const I=typeof w=="string"?this.l[w]:void 0;if(I?.label){if(I.isNative!==!1)D.accelerator=I.label,D.userSettingsLabel=I.userSettingsLabel;else if(typeof D.label=="string"){const k=D.label.indexOf("[");k>=0?D.label=`${D.label.substr(0,k)} [${I.label}]`:D.label=`${D.label} [${I.label}]`}}else D.accelerator=void 0;return D}$(w,D,I=!D.accelerator){I&&(D=this.Z(w,D));const k=D.click;return D.click=(R,L,T)=>{this.bb(w),k?.(R,L,T)},D}ab(w,D){this.w.openExternal(void 0,w),this.bb(D)}bb(w){this.r.publicLog2("workbenchActionExecuted",{id:w,from:r})}cb(w){return(0,M.$Ev)(w,!this.C)}};e.$j9b=t,e.$j9b=t=o=ve([te(0,a.$WU),te(1,$.$pi),te(2,h.$J8b),te(3,p.$97b),te(4,u.$il),te(5,i.$h9b),te(6,g.$ON),te(7,v.$$7b),te(8,f.$dj),te(9,m.$88b),te(10,b.$vj),te(11,c.$H8b)],t);function n(){return new S.MenuItem({type:"separator"})}}),define(re[306],oe([0,1,6,20,5,305]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l9b=e.$k9b=void 0,e.$k9b=(0,S.$Vh)("menubarMainService");let C=class{constructor(d,c,$){this.b=d,this.c=c,this.d=$,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$j9b)}async updateMenubar(d,c){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(c,d)}};e.$l9b=C,e.$l9b=C=ve([te(0,S.$Uh),te(1,A.$$7b),te(2,s.$dj)],C)}),define(re[307],oe([0,1,15,21,131,28,23,22,3,33,47,2,13,9,67,4,35,19,12,7,191,65,17,53,24,16,6,20,5,79,80,59,34,60,133,29,130,299,30,98,83,55,69,39,54,68,64]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i,o,r,t,n,l,w,D,I,k,R,L,T,N,K,Q,ae,ne,ce,X,Y,V,q,j,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=void 0;function B(J){return(0,ae.$$h)(J?.workspace)}function _(J){return(0,ae.$6h)(J?.workspace)}let se=class extends p.$Rc{constructor(O,U,G,F,z,W,x,he,de,le,we,be,Ee,Se,Fe,ke,pe,ee,ue,ge){super(),this.m=O,this.n=U,this.r=G,this.s=F,this.t=z,this.u=W,this.w=x,this.z=he,this.C=de,this.D=le,this.F=we,this.G=be,this.H=Ee,this.I=Se,this.J=Fe,this.L=ke,this.M=pe,this.N=ee,this.O=ue,this.P=ge,this.a=this.B(new d.$Rd),this.onDidOpenWindow=this.a.event,this.b=this.B(new d.$Rd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new d.$Rd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new d.$Rd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new d.$Rd),this.onDidTriggerSystemContextMenu=this.g.event,this.h=new Map,this.j=this.B(new Q.$I9b(this,this.u,this.D,this.s,this.G)),this.Q()}Q(){this.B(this.I.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const U=new p.$Qc;if(U.add(d.Event.any(O.onDidClose,O.onDidDestroy)(()=>U.dispose())),O.config.extensionDevelopmentPath)for(const G of O.config.extensionDevelopmentPath)U.add(this.N.addValidFileRoot(G));O.config.extensionTestsPath&&U.add(this.N.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,U){const G=this.z.args,F=U?.remoteAuthority||void 0,z=!0,W=U?.forceReuseWindow,x=!W;return this.open({...O,cli:G,forceEmpty:z,forceNewWindow:x,forceReuseWindow:W,remoteAuthority:F})}openExistingWindow(O,U){O.focus(),this.R(U,[O])}async open(O){this.s.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const U=[],G=[],F=[],z=[],W=[];let x,he=0;const de=await this.$(O);this.s.trace("windowsManager#open pathsToOpen",de);for(const Se of de)_(Se)?O.addMode?U.push(Se):G.push(Se):B(Se)?F.push(Se):Se.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),x.filesToOpenOrCreate.push(Se)):Se.backupPath?W.push({backupFolder:(0,f.$mc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):he++;O.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),O.mergeMode&&x&&x.filesToOpenOrCreate.length===4&&(x.filesToMerge=x.filesToOpenOrCreate.slice(0,4),x.filesToOpenOrCreate=[],x.filesToDiff=[]),x&&O.waitMarkerFileURI&&(x.filesToWait={paths:(0,C.$Gb)([...x.filesToDiff,x.filesToMerge[3],...x.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(z.push(...this.I.getUntitledWorkspaces()),F.push(...z),W.push(...this.F.getEmptyWindowBackups())):W.length=0;const{windows:le,filesOpenedInWindow:we}=await this.S(O,F,G,W,he,x,U);if(this.s.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${F.length}, foldersToOpen: ${G.length}, emptyToRestore: ${W.length}, emptyToOpen: ${he})`),le.length>1)if(we)we.focus();else{const Se=this.j.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Fe=!0,ke=!0;if(Se){const pe=le.filter(ee=>this.j.state.lastActiveWindow&&ee.backupPath===this.j.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Fe=!1,ke=!1)}if(Fe)for(let pe=le.length-1;pe>=0;pe--){const ee=le[pe];if(!(ee.openedWorkspace&&z.some(ue=>ee.openedWorkspace&&ue.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&W.some(ue=>ee.backupPath&&ue.backupFolder===(0,f.$mc)(ee.backupPath)))){ee.focus(),ke=!1;break}}ke&&le[le.length-1].focus()}const be=x&&x.filesToDiff.length>0,Ee=x&&x.filesToMerge.length>0;if(!le.some(Se=>Se.isExtensionDevelopmentHost)&&!be&&!Ee&&!O.noRecentEntry){const Se=[];for(const Fe of de)B(Fe)&&!Fe.transient?Se.push({label:Fe.label,workspace:Fe.workspace,remoteAuthority:Fe.remoteAuthority}):_(Fe)?Se.push({label:Fe.label,folderUri:Fe.workspace.uri,remoteAuthority:Fe.remoteAuthority}):Fe.fileUri&&Se.push({label:Fe.label,fileUri:Fe.fileUri,remoteAuthority:Fe.remoteAuthority});this.H.addRecentlyOpened(Se)}return this.R(O,le),le}R(O,U){const G=O.waitMarkerFileURI;O.context===0&&G&&U.length===1&&U[0]&&(async()=>{await U[0].whenClosedOrLoaded;try{await this.M.del(G)}catch{}})()}async S(O,U,G,F,z,W,x){const he=[];let de;function le(pe,ee){he.push(pe),ee&&(de=pe,W=void 0)}let{openFolderInNewWindow:we,openFilesInNewWindow:be}=this.lb(O);if(!O.initialStartup&&x.length>0){const pe=x[0].remoteAuthority,ee=this.qb(pe);ee&&le(this.X(ee,x.map(ue=>ue.workspace.uri)))}const Ee=G.length+U.length+F.length;if(W&&Ee===0){const pe=W.filesToOpenOrCreate[0]||W.filesToDiff[0]||W.filesToMerge[3],ee=this.getWindows().filter(ge=>W&&(0,g.$Eg)(ge.remoteAuthority,W.remoteAuthority));let ue;pe?.fileUri&&!be&&((O.context===4||O.context===0||O.context===1)&&(ue=await(0,K.$t8b)(ee,pe.fileUri,async ge=>ge.configPath.scheme===v.Schemas.file?this.I.resolveLocalWorkspace(ge.configPath):void 0)),ue||(ue=this.rb(ee))),ue?(0,ae.$$h)(ue.openedWorkspace)?U.push({workspace:ue.openedWorkspace,remoteAuthority:ue.remoteAuthority}):(0,ae.$6h)(ue.openedWorkspace)?G.push({workspace:ue.openedWorkspace,remoteAuthority:ue.remoteAuthority}):le(this.U(O,ue,W),!0):le(await this.mb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:W,forceNewWindow:!0,remoteAuthority:W.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Se=(0,C.$Lb)(U,pe=>pe.workspace.id);if(Se.length>0){const pe=(0,C.$Gb)(Se.map(ee=>(0,K.$u8b)(this.getWindows(),ee.workspace.configPath)));if(pe.length>0){const ee=pe[0],ue=(0,g.$Eg)(W?.remoteAuthority,ee.remoteAuthority)?W:void 0;le(this.U(O,ee,ue),!!ue),we=!0}for(const ee of Se){if(pe.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===ee.workspace.id))continue;const ue=ee.remoteAuthority,ge=(0,g.$Eg)(W?.remoteAuthority,ue)?W:void 0;le(await this.Z(O,ee,we,ge),!!ge),we=!0}}const Fe=(0,C.$Lb)(G,pe=>g.$qg.getComparisonKey(pe.workspace.uri));if(Fe.length>0){const pe=(0,C.$Gb)(Fe.map(ee=>(0,K.$u8b)(this.getWindows(),ee.workspace.uri)));if(pe.length>0){const ee=pe[0],ue=(0,g.$Eg)(W?.remoteAuthority,ee.remoteAuthority)?W:void 0;le(this.U(O,ee,ue),!!ue),we=!0}for(const ee of Fe){if(pe.some(Re=>(0,ae.$6h)(Re.openedWorkspace)&&g.$qg.isEqual(Re.openedWorkspace.uri,ee.workspace.uri)))continue;const ue=ee.remoteAuthority,ge=(0,g.$Eg)(W?.remoteAuthority,ue)?W:void 0;le(await this.Z(O,ee,we,ge),!!ge),we=!0}}const ke=(0,C.$Lb)(F,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const ee=pe.remoteAuthority,ue=(0,g.$Eg)(W?.remoteAuthority,ee)?W:void 0;le(await this.Y(O,!0,ee,ue,pe),!!ue),we=!0}if(he.length===0||W){W&&!z&&z++;const pe=W?W.remoteAuthority:O.remoteAuthority;for(let ee=0;ee<z;ee++)le(await this.Y(O,we,pe,W),!!W),we=!0}return{windows:(0,C.$Lb)(he),filesOpenedInWindow:de}}U(O,U,G){this.s.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:G}),this.W(U);const F={filesToOpenOrCreate:G?.filesToOpenOrCreate,filesToDiff:G?.filesToDiff,filesToMerge:G?.filesToMerge,filesToWait:G?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return U.sendWhenReady("vscode:openFiles",P.CancellationToken.None,F),U}W(O){let U=O;const G=S.BrowserWindow.getFocusedWindow();if(G&&G.id!==O.id){const F=this.P.getWindowById(G.id);F&&F.parentId===O.id&&(U=F)}U.focus()}X(O,U){this.s.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:U}),O.focus();const G={foldersToAdd:U};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,G),O}Y(O,U,G,F,z){this.s.trace("windowsManager#doOpenEmpty",{restore:!!z,remoteAuthority:G,filesToOpen:F,forceNewWindow:U});let W;return!U&&typeof O.contextWindowId=="number"&&(W=this.getWindowById(O.contextWindowId)),this.mb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:G,forceNewWindow:U,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:F,windowToUse:W,emptyWindowBackupInfo:z,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}Z(O,U,G,F,z){return this.s.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:U,filesToOpen:F}),!G&&!z&&typeof O.contextWindowId=="number"&&(z=this.getWindowById(O.contextWindowId)),this.mb({workspace:U.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:U.remoteAuthority,forceNewWindow:G,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:F,windowToUse:z,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async $(O){let U,G=!1,F=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(U=await this.ab(O),G=!0):O.forceEmpty?U=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(U=await this.bb(O.cli),U.length===0&&U.push(Object.create(null)),G=!0):(U=await this.db(),U.length===0&&U.push(Object.create(null)),F=!0),!O.addMode&&G){const z=U.filter(W=>_(W));if(z.length>1){const W=z[0].remoteAuthority;if(z.every(x=>(0,g.$Eg)(x.remoteAuthority,W))){const x=await this.I.createUntitledWorkspace(z.map(he=>({uri:he.workspace.uri})));U.push({workspace:x,remoteAuthority:W}),U=U.filter(he=>!_(he))}}}if(O.initialStartup&&!F&&this.G.getValue("window")?.restoreWindows==="preserve"){const z=await this.db();U.unshift(...z.filter(W=>B(W)||_(W)||W.backupPath))}return U}async ab(O){const U={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},G=await Promise.all((0,C.$Gb)(O.urisToOpen||[]).map(async F=>{const z=await this.fb(F,U);if(z)return z.label=F.label,z;const W=this.hb(F);this.L.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:W.scheme===v.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:W.scheme===v.Schemas.file?(0,E.localize)(3,null,(0,$.$yv)(W,{os:m.OS,tildify:this.z})):(0,E.localize)(4,null,W.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Gb)(G)}async bb(O){const U=[],G={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},F=O["folder-uri"];if(F){const x=await Promise.all(F.map(he=>{const de=this.cb(he);if(de)return this.fb({folderUri:de},G)}));U.push(...(0,C.$Gb)(x))}const z=O["file-uri"];if(z){const x=await Promise.all(z.map(he=>{const de=this.cb(he);if(de)return this.fb((0,ae.$oi)(he)?{workspaceUri:de}:{fileUri:de},G)}));U.push(...(0,C.$Gb)(x))}const W=await Promise.all(O._.map(x=>G.remoteAuthority?this.kb(x,G):this.ib(x,G)));return U.push(...(0,C.$Gb)(W)),U}cb(O){try{const U=a.URI.parse(O);if(!U.scheme){this.s.error(`Invalid URI input string, scheme missing: ${O}`);return}return U.path?U:U.with({path:"/"})}catch(U){this.s.error(`Invalid URI input string: ${O}, ${U.message}`)}}async db(){const O=this.eb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const U=[];O!=="one"&&U.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&U.push(this.j.state.lastActiveWindow);const G=await Promise.all(U.map(async F=>{if(F.workspace){const z=await this.fb({workspaceUri:F.workspace.configPath},{remoteAuthority:F.remoteAuthority,rejectTransientWorkspaces:!0});if(B(z))return z}else if(F.folderUri){const z=await this.fb({folderUri:F.folderUri},{remoteAuthority:F.remoteAuthority});if(_(z))return z}else if(O!=="folders"&&F.backupPath)return{backupPath:F.backupPath,remoteAuthority:F.remoteAuthority}}));return(0,C.$Gb)(G)}}}eb(){let O;return this.D.wasRestarted?O="all":(O=this.G.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async fb(O,U=Object.create(null)){const G=this.hb(O);return G.scheme===v.Schemas.file?((0,L.$qC)(O)&&(U={...U,forceOpenWorkspaceAsFile:!0}),this.ib(G.fsPath,U)):this.gb(O,U)}gb(O,U){let G=this.hb(O);const F=(0,k.$1k)(G)||U.remoteAuthority;if(G=(0,g.$Gg)((0,g.$Ag)(G)),(0,L.$qC)(O)){if(U.gotoLineMode){const{path:z,line:W,column:x}=(0,c.$9f)(G.path);return{fileUri:G.with({path:z}),options:{selection:W?{startLineNumber:W,startColumn:x||1}:void 0},remoteAuthority:F}}return{fileUri:G,remoteAuthority:F}}else if((0,L.$oC)(O))return{workspace:(0,ne.$x8b)(G),remoteAuthority:F};return{workspace:(0,ne.$y8b)(G),remoteAuthority:F}}hb(O){return(0,L.$oC)(O)?O.workspaceUri:(0,L.$pC)(O)?O.folderUri:O.fileUri}async ib(O,U,G){let F,z;U.gotoLineMode&&({path:O,line:F,column:z}=(0,c.$9f)(O)),O=(0,c.$4f)((0,f.$gc)(O),(0,b.cwd)());try{const W=await A.Promises.stat(O);if(W.isFile()){if(!U.forceOpenWorkspaceAsFile){const x=await this.I.resolveLocalWorkspace(a.URI.file(O));if(x)return x.transient&&U.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:t.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:a.URI.file(O),type:t.FileType.File,exists:!0,options:{selection:F?{startLineNumber:F,startColumn:z||1}:void 0}}}else{if(W.isDirectory())return{workspace:(0,ne.$y8b)(a.URI.file(O),W),type:t.FileType.Directory,exists:!0};if(!m.$i&&O==="/dev/null")return{fileUri:a.URI.file(O),type:t.FileType.File,exists:!0}}}catch(W){if(W.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!G)return this.jb(O,U);const x=a.URI.file(O);if(this.H.removeRecentlyOpened([x]),U.ignoreFileNotFound)return{fileUri:x,type:t.FileType.File,exists:!1}}}async jb(O,U){const G=a.URI.file(O),{response:F,checkboxChecked:z}=await this.L.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,G.authority),detail:(0,E.localize)(9,null,(0,$.$yv)(G,{os:m.OS,tildify:this.z})),checkboxLabel:(0,E.localize)(10,null,G.authority),cancelId:1});if(F===0){if((0,s.addUNCHostToAllowlist)(G.authority),z){const W={channel:"vscode:configureAllowedUNCHost",args:G.authority};this.sendToFocused(W.channel,W.args),this.sendToOpeningWindow(W.channel,W.args)}return this.ib(O,U,!0)}if(F===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.jb(O,U)}kb(O,U){const G=O.charCodeAt(0),F=U.remoteAuthority;let z,W;U.gotoLineMode&&({path:O,line:z,column:W}=(0,c.$9f)(O)),G!==47&&((0,c.$3f)(G)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,c.$Vf)(O)),O=`/${O}`);const x=a.URI.from({scheme:v.Schemas.vscodeRemote,authority:F,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,ae.$oi)(O))return U.forceOpenWorkspaceAsFile?{fileUri:x,options:{selection:z?{startLineNumber:z,startColumn:W||1}:void 0},remoteAuthority:U.remoteAuthority}:{workspace:(0,ne.$x8b)(x),remoteAuthority:F};if(U.gotoLineMode||f.$fc.basename(O).indexOf(".")!==-1)return{fileUri:x,options:{selection:z?{startLineNumber:z,startColumn:W||1}:void 0},remoteAuthority:F}}return{workspace:(0,ne.$y8b)(x),remoteAuthority:F}}lb(O){const U=this.G.getValue("window"),G=U?.openFoldersInNewWindow||"default",F=U?.openFilesInNewWindow||"off";let z=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(G==="on"||G==="off")&&(z=G==="on");let W=!1;return O.forceNewWindow||O.forceReuseWindow?W=!!O.forceNewWindow&&!O.forceReuseWindow:(m.$j?O.context===1&&(W=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(W=!0),!O.cli.extensionDevelopmentPath&&(F==="on"||F==="off")&&(W=F==="on")),{openFolderInNewWindow:!!z,openFilesInNewWindow:W}}async openExtensionDevelopmentHostWindow(O,U){const G=(0,K.$v8b)(this.getWindows(),O);if(G)return this.D.reload(G,U.cli),G.focus(),[G];let F=U.cli["folder-uri"]||[],z=U.cli["file-uri"]||[],W=U.cli._;if(!W.length&&!F.length&&!z.length&&!U.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,le=de?.workspace??de?.folderUri;le&&(a.URI.isUri(le)?le.scheme===v.Schemas.file?W=[le.fsPath]:F=[le.toString()]:le.configPath.scheme===v.Schemas.file?W=[(0,g.$ng)(le.configPath)]:z=[le.configPath.toString()])}let x=U.remoteAuthority;for(const de of O)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=a.URI.parse(de),we=(0,k.$1k)(le);we&&(x?(0,g.$Eg)(we,x)||this.s.error("more than one extension development path authority"):x=we)}W=W.filter(de=>{const le=a.URI.file(de);return(0,K.$u8b)(this.getWindows(),le)?!1:(0,g.$Eg)((0,k.$1k)(le),x)}),F=F.filter(de=>{const le=this.cb(de);return le&&(0,K.$u8b)(this.getWindows(),le)?!1:le?(0,g.$Eg)((0,k.$1k)(le),x):!1}),z=z.filter(de=>{const le=this.cb(de);return le&&(0,K.$u8b)(this.getWindows(),le)?!1:le?(0,g.$Eg)((0,k.$1k)(le),x):!1}),U.cli._=W,U.cli["folder-uri"]=F,U.cli["file-uri"]=z;const he={context:U.context,cli:U.cli,forceNewWindow:!0,forceEmpty:!W.length&&!F.length&&!z.length,userEnv:U.userEnv,noRecentEntry:!0,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:x,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile};return this.open(he)}async mb(O){const U=this.G.getValue("window"),G=this.getLastActiveWindow(),F=G?.profile??this.C.defaultProfile;let z;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(z=O.windowToUse||G,z&&z.focus());const W={...this.z.args,...O.cli,machineId:this.m,sqmId:this.n,windowId:-1,mainPid:process.pid,appRoot:this.z.appRoot,execPath:process.execPath,codeCachePath:this.z.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,f.$ic)(this.z.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.C.profilesHome,all:this.C.profiles,profile:F},homeDir:this.z.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.z.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.z.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.r,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.t.getLogLevel(),loggers:{window:[],global:this.t.getRegisteredLoggers()},logsPath:this.z.logsHome.with({scheme:v.Schemas.file}).fsPath,product:D.default,isInitialStartup:O.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof U?.zoomLevel=="number"?U.zoomLevel:void 0,autoDetectHighContrast:U?.autoDetectHighContrast??!0,autoDetectColorScheme:U?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.O.getColorScheme(),policiesData:this.w.serialize(),continueOn:this.z.continueOn};if(z){const x=z.config;!W.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&(W.extensionDevelopmentPath=x.extensionDevelopmentPath,W.extensionDevelopmentKind=x.extensionDevelopmentKind,W["enable-proposed-api"]=x["enable-proposed-api"],W.verbose=x.verbose,W["inspect-extensions"]=x["inspect-extensions"],W["inspect-brk-extensions"]=x["inspect-brk-extensions"],W.debugId=x.debugId,W.extensionEnvironment=x.extensionEnvironment,W["extensions-dir"]=x["extensions-dir"],W["disable-extensions"]=x["disable-extensions"]),W.loggers={global:W.loggers.global,window:x?.loggers.window??W.loggers.window}}else{const x=this.j.getNewWindowState(W);(0,y.mark)("code/willCreateCodeWindow");const he=z=this.J.createInstance(T.$F8b,{state:x,extensionDevelopmentPath:W.extensionDevelopmentPath,isExtensionTestHost:!!W.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(he),this.h.set(he.id,he),this.a.fire(he),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new p.$Qc;de.add(he.onDidSignalReady(()=>this.b.fire(he))),de.add(d.Event.once(he.onDidClose)(()=>this.pb(he,de))),de.add(d.Event.once(he.onDidDestroy)(()=>this.c.fire(he))),de.add(he.onDidTriggerSystemContextMenu(({x:we,y:be})=>this.g.fire({window:he,x:we,y:be})));const le=(0,u.$Nf)(he.win?.webContents);le.removeAllListeners("devtools-reload-page"),le.on("devtools-reload-page",()=>this.D.reload(he)),this.D.registerWindow(he)}return W.windowId=z.id,z.isReady?this.D.unload(z,4).then(async x=>{x||await this.nb(z,W,O,F)}):await this.nb(z,W,O,F),z}async nb(O,U,G,F){if(U.extensionDevelopmentPath||((0,ae.$$h)(U.workspace)?U.backupPath=this.F.registerWorkspaceBackup({workspace:U.workspace,remoteAuthority:U.remoteAuthority}):(0,ae.$6h)(U.workspace)?U.backupPath=this.F.registerFolderBackup({folderUri:U.workspace.uri,remoteAuthority:U.remoteAuthority}):U.backupPath=this.F.registerEmptyWindowBackup({backupFolder:G.emptyWindowBackupInfo?.backupFolder??(0,ne.$z8b)().id,remoteAuthority:U.remoteAuthority})),this.C.isEnabled()){const z=U.workspace??(0,ae.$0h)(U.backupPath,!1),W=this.ob(G,z,F),x=W instanceof Promise?await W:W;U.profiles.profile=x,U.extensionDevelopmentPath||await this.C.setProfileForWorkspace(z,x)}O.load(U)}ob(O,U,G){return O.forceProfile?this.C.profiles.find(F=>F.name===O.forceProfile)??this.C.createNamedProfile(O.forceProfile):O.forceTempProfile?this.C.createTransientProfile():this.C.getProfileForWorkspace(U)??G}pb(O,U){this.h.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),U.dispose()}getFocusedWindow(){const O=S.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.rb(this.getWindows())}qb(O){return this.rb(this.getWindows().filter(U=>(0,g.$Eg)(U.remoteAuthority,O)))}rb(O){return(0,N.$M8b)(O)}sendToFocused(O,...U){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,P.CancellationToken.None,...U)}sendToOpeningWindow(O,...U){this.B(d.Event.once(this.onDidSignalReadyWindow)(G=>{G.sendWhenReady(O,P.CancellationToken.None,...U)}))}sendToAll(O,U,G){for(const F of this.getWindows())G&&G.indexOf(F.id)>=0||F.sendWhenReady(O,P.CancellationToken.None,U)}getWindows(){return Array.from(this.h.values())}getWindowCount(){return this.h.size}getWindowById(O){return this.h.get(O)}getWindowByWebContents(O){const U=S.BrowserWindow.fromWebContents(O);if(U)return this.getWindowById(U.id)}};e.$L9b=se,e.$L9b=se=ve([te(3,w.$dj),te(4,j.$C8b),te(5,R.$ON),te(6,V.$on),te(7,r.$97b),te(8,q.$e8b),te(9,l.$$7b),te(10,h.$p8b),te(11,i.$pi),te(12,ce.$h9b),te(13,X.$A8b),te(14,n.$Uh),te(15,o.$q8b),te(16,t.$ek),te(17,I.$s8b),te(18,Y.$k8b),te(19,H.$H8b)],se)}),define(re[308],oe([0,1,65,29,83,55]),function(Z,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=void 0;let C=class{constructor(d,c,$,p){this.a=d,this.b=c,this.c=$,this.d=p,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,c){const $=this.b.getWindowById(d);if($)return this.a.enterWorkspace($,this.b.getWindows(),c)}createUntitledWorkspace(d,c,$){return this.a.createUntitledWorkspace(c,$)}deleteUntitledWorkspace(d,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(d,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(d,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$N9b=C,e.$N9b=C=ve([te(0,M.$A8b),te(1,A.$J8b),te(2,s.$h9b),te(3,S.$p8b)],C)}),define(re[309],oe([0,1,15,131,36,28,18,50,14,33,3,44,47,2,13,9,4,12,7,32,158,42,159,110,291,162,65,283,17,200,91,132,53,116,220,24,63,94,209,294,211,212,213,16,224,93,78,6,92,219,300,284,292,20,5,306,70,25,59,295,95,34,275,82,122,26,251,253,52,49,265,289,301,290,302,127,267,268,269,272,298,60,29,307,274,30,97,83,308,55,39,233,54,244,51,81,129,277,293,280,8,255,276,228,68,297,271,23,125,296,263,239,72,64,304]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i,o,r,t,n,l,w,D,I,k,R,L,T,N,K,Q,ae,ne,ce,X,Y,V,q,j,H,B,_,se,J,O,U,G,F,z,W,x,he,de,le,we,be,Ee,Se,Fe,ke,pe,ee,ue,ge,Re,De,je,Me,Ve,ze,ie,fe,$e,ye,Ce,Ue,Le,We,qe,Ge,Je,_e,Ze,it,st,rt,bt,pt,yt,vt,kt,Et,Pt,ot,dt,St,It,Rt,at,Ct,gt,ct,Dt,At,lt,Ot,ut,Mt){"use strict";var ht;Object.defineProperty(e,"__esModule",{value:!0}),e.$79b=void 0;let ft=class extends f.$Rc{static{ht=this}static{this.a={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Pe,Ie,Oe,me,Ae,Be,He,Ke,Ne,Te,Qe,Ye){super(),this.g=Pe,this.h=Ie,this.j=Oe,this.m=me,this.n=Ae,this.s=Be,this.t=He,this.u=Ke,this.w=Ne,this.y=Te,this.z=Qe,this.C=Ye,this.D(),this.F()}D(){const Pe=Ne=>Ne?.startsWith(`${y.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ne,Te,Qe,Ye)=>Pe(Ye.requestingUrl)?Qe(Ie.has(Te)):Qe(!1)),S.session.defaultSession.setPermissionCheckHandler((Ne,Te,Qe,Ye)=>Pe(Ye.requestingUrl)?Ie.has(Te):!1);const Oe=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),me=Ne=>{for(let Te=Ne;Te;Te=Te.parent)if(Te.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ae=Ne=>Ne.resourceType==="xhr"||me(Ne.frame),Be=Ne=>{const Te=Ne.frame;if(!Te||!this.b)return!1;const Qe=S.BrowserWindow.getAllWindows();for(const Ye of Qe)if(Te.processId===Ye.webContents.mainFrame.processId)return!0;return!1},He=(Ne,Te)=>{if(Ne.path!=="/index.html")return!0;const Qe=Te.frame;if(!Qe||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Qe.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ne,Te)=>{const Qe=u.URI.parse(Ne.url);return Qe.scheme===y.Schemas.vscodeWebview&&!He(Qe,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),Te({cancel:!0})):Qe.scheme===y.Schemas.vscodeFileResource&&!Be(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),Te({cancel:!0})):Qe.path.endsWith(".svg")&&!Oe.has(Qe.scheme)?Te({cancel:!Ae(Ne)}):Te({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ne,Te)=>{const Qe=Ne.responseHeaders,Ye=Qe["content-type"]||Qe["Content-Type"];if(Ye&&Array.isArray(Ye)){const Xe=u.URI.parse(Ne.url);if(Xe.path.endsWith(".svg")&&Oe.has(Xe.scheme))return Qe["Content-Type"]=["image/svg+xml"],Te({cancel:!1,responseHeaders:Qe});if(!Xe.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(et=>et.toLowerCase().includes("image/svg")))return Te({cancel:!Ae(Ne)})}return Te({cancel:!1})});const Ke=S.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,m.$ic)(this.s.codeCachePath,"chrome")),b.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,d.setUnexpectedErrorHandler)(Oe=>this.H(Oe)),process.on("uncaughtException",Oe=>{(0,d.$Y)(Oe)||(0,d.$Z)(Oe)}),process.on("unhandledRejection",Oe=>(0,d.$Z)(Oe)),this.t.onWillShutdown(()=>this.dispose()),(0,E.$WT)(),S.app.on("accessibility-support-changed",(Oe,me)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",me)}),S.app.on("activate",async(Oe,me)=>{this.m.trace("app#activate"),me||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Oe,me)=>{(0,ut.$I8b)(me)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(me)),me.on("will-navigate",Ae=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),me.setWindowOpenHandler(Ae=>Ae.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ae.url}}`),this.f?.openExternal(void 0,Ae.url),{action:"deny"}))});let Pe=[],Ie;S.app.on("open-file",(Oe,me)=>{this.m.trace("app#open-file: ",me),Oe.preventDefault(),Pe.push((0,qe.$oi)(me)?{workspaceUri:u.URI.file(me)}:{fileUri:u.URI.file(me)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$VT.handle("vscode:fetchShellEnv",Oe=>{const me=this.b?.getWindowByWebContents(Oe.sender);let Ae,Be;return me?.config?(Ae=me.config,Be={...process.env,...me.config.userEnv}):(Ae=this.s.args,Be=process.env),this.X(Ae,Be,!1)}),s.$VT.handle("vscode:writeNlsFile",(Oe,me,Ae)=>{const Be=this.G([me]);if(!Be||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Be,C.$fe.fromString(Ae))}),s.$VT.handle("vscode:readNlsFile",async(Oe,...me)=>{const Ae=this.G(me);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ae)).value.toString()}),s.$VT.on("vscode:toggleDevTools",Oe=>Oe.sender.toggleDevTools()),s.$VT.on("vscode:openDevTools",Oe=>Oe.sender.openDevTools()),s.$VT.on("vscode:reloadWindow",Oe=>Oe.sender.reload())}G(Pe){let Ie;for(const Oe of Pe)typeof Oe=="string"&&(typeof Ie!="string"?Ie=Oe:Ie=(0,m.$ic)(Ie,Oe));if(!(typeof Ie!="string"||!(0,m.$hc)(Ie)||!(0,c.$2f)(Ie,this.s.cachedLanguagesPath,!b.$k)))return u.URI.file(Ie)}H(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.m.error(Pe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Pe=this.z.win32AppUserModelId;b.$i&&Pe&&S.app.setAppUserModelId(Pe);try{b.$j&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.m.error(Te)}const Ie=new i.$3T;this.t.onWillShutdown(Te=>{Te.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[Oe,me]=await Promise.all([(0,dt.$V9b)(this.w,this.m),(0,dt.$W9b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Oe}`);const{sharedProcessReady:Ae,sharedProcessClient:Be}=this.P(Oe,me),He=await this.Q(Oe,me,Ae);this.B(He.createInstance(r.$N8b)),this.B(He.createInstance(Et.$R9b)),He.invokeFunction(Te=>this.R(Te,Ie,Be));const Ke=await He.invokeFunction(Te=>this.I(Te,Ie));this.J(Ie),this.t.phase=2,await He.invokeFunction(Te=>this.S(Te,Ke)),this.t.phase=3,this.U(),this.B(new ot.$0g(()=>{this.B((0,ot.$bh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Pe,Ie){const Oe=this.b=Pe.get(Ue.$J8b),me=Pe.get(Ve.$KU),Ae=this.f=Pe.get(W.$88b),Be=Pe.get(R.$q8b),He=this;me.registerHandler({async handleURL(Xe,et){return He.O(Oe,Be,me,Xe,et)}});const Ke=this.B(new We.$M9b({onDidOpenMainWindow:Ae.onDidOpenMainWindow,onDidFocusMainWindow:Ae.onDidFocusMainWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),Ne=new h.$Dh(Xe=>Ke.getActiveClientId().then(et=>Xe===et)),Te=new ze.$D9b(Ne,this.m),Qe=Ie.getChannel("urlHandler",Te);me.registerHandler(new ze.$C9b(Qe));const Ye=await this.L(Oe,Be);return this.B(new fe.$E9b(Ye?.urls,me,Oe,this.s,this.z,this.m)),Ye}J(Pe){const Ie=()=>({statusCode:404,data:"Not found"}),Oe=new Ot.$U(()=>Pe.getChannel(lt.$49b,new lt.$59b));S.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(me,Ae)=>{const Be=u.URI.parse(me.url);if(!Be.authority.startsWith("window:"))return Ae(Ie());Oe.value.call(lt.$39b,[Be]).then(He=>Ae({...He,data:Buffer.from(He.body,"base64")}),He=>{this.m.warn("error dispatching remote resource call",He),Ae({statusCode:500,data:String(He)})})})}async L(Pe,Ie){const Oe=this.s.args["open-url"]?this.s.args._urls||[]:[];Oe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Oe);const me=global.getOpenUrls()||[];if(me.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",me),Oe.length+me.length===0)return;const Ae=[...Oe,...me].map(Ke=>{try{return{uri:u.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Be=[],He=[];for(const Ke of Ae){if(!Ke)continue;const Ne=this.N(Ke.uri);if(Ne)if(await this.M(Ne,Pe,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Ne),Be.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),He.push(Ke)}return{urls:He,openables:Be}}async M(Pe,Ie,Oe){let me,Ae;if((0,Ce.$oC)(Pe)?(me=Pe.workspaceUri,Ae=(0,t.localize)(0,null,me.scheme===y.Schemas.file?(0,v.$yv)(me,{os:b.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)):(0,Ce.$pC)(Pe)?(me=Pe.folderUri,Ae=(0,t.localize)(1,null,me.scheme===y.Schemas.file?(0,v.$yv)(me,{os:b.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)):(me=Pe.fileUri,Ae=(0,t.localize)(2,null,me.scheme===y.Schemas.file?(0,v.$yv)(me,{os:b.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)),me.scheme!==y.Schemas.file&&me.scheme!==y.Schemas.vscodeRemote||this.u.getValue(ht.a[me.scheme])===!1)return!1;const{response:He,checkboxChecked:Ke}=await Oe.showMessageBox({type:"warning",buttons:[(0,t.localize)(3,null),(0,t.localize)(4,null)],message:Ae,detail:(0,t.localize)(5,null),checkboxLabel:me.scheme===y.Schemas.file?(0,t.localize)(6,null):(0,t.localize)(7,null),cancelId:1});if(He!==0)return!0;if(Ke){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:me.scheme===y.Schemas.file?"local":"remote"};Ie.sendToFocused(Ne.channel,Ne.args),Ie.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}N(Pe){if(Pe.path){if(Pe.authority===y.Schemas.file){const Ie=u.URI.file(Pe.fsPath);return(0,qe.$oi)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===y.Schemas.vscodeRemote){const Ie=Pe.path.indexOf(m.$fc.sep,1);if(Ie!==-1){const Oe=Pe.path.substring(1,Ie),me=Pe.path.substring(Ie);let Ae=Pe.query;const Be=new URLSearchParams(Pe.query);Be.get("windowId")==="_blank"&&(Be.delete("windowId"),Ae=Be.toString());const He=u.URI.from({scheme:y.Schemas.vscodeRemote,authority:Oe,path:me,query:Ae,fragment:Pe.fragment});return(0,qe.$oi)(me)?{workspaceUri:He}:/:[\d]+$/.test(me)?{fileUri:He}:{folderUri:He}}}}}async O(Pe,Ie,Oe,me,Ae){this.m.trace("app#handleProtocolUrl():",me.toString(!0),Ae),me.scheme===this.z.urlProtocol&&me.path==="workspace"&&(me=me.with({authority:"file",path:u.URI.parse(me.query).path,query:""}));let Be=!1;const He=new URLSearchParams(me.query);He.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",me.toString(!0)),He.delete("windowId"),me=me.with({query:He.toString()}),Be=!0):b.$j&&Pe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",me.toString(!0)),Be=!0);const Ke=He.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",me.toString(!0)),He.delete("continueOn"),me=me.with({query:He.toString()}),this.s.continueOn=Ke??void 0);const Ne=this.N(me);return Ne?await this.M(Ne,Pe,Ie)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",me.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,me.toString(!0)),(0,gt.$Nb)(await Pe.open({context:5,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:Be,gotoLineMode:!0}))?.focus(),!0):Be?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",me.toString(!0)),await(0,gt.$Nb)(await Pe.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,he.$1k)(me)}))?.ready(),Oe.open(me,Ae)):(this.m.trace("app#handleProtocolUrl(): not handled",me.toString(!0),Ae),!1)}P(Pe,Ie){const Oe=this.B(this.j.createInstance(de.$p9b,Pe,Ie)),me=(async()=>{this.m.trace("Main->SharedProcess#connect");const Be=await Oe.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$4T(Be,"main")})();return{sharedProcessReady:(async()=>(await Oe.whenReady(),me))(),sharedProcessClient:me}}async Q(Pe,Ie,Oe){const me=new _.$Th;switch(process.platform){case"win32":me.set(ue.$WU,new H.$Sh(Me.$A9b));break;case"linux":b.$l?me.set(ue.$WU,new H.$Sh(je.$z9b,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(ue.$WU,new H.$Sh(De.$y9b));break;case"darwin":me.set(ue.$WU,new H.$Sh(Re.$x9b));break}me.set(Ue.$J8b,new H.$Sh(Le.$L9b,[Pe,Ie,this.h],!1)),me.set(ut.$H8b,new H.$Sh(Mt.$69b,void 0,!1));const Ae=new R.$r8b(this.m,this.z);me.set(R.$q8b,Ae),me.set(U.$b9b,new H.$Sh(U.$c9b,void 0,!1)),me.set(k.$T8b,new H.$Sh(k.$U8b,void 0,!1)),me.set(I.$wm,h.ProxyChannel.toService((0,h.$Bh)(Oe.then(Te=>Te.getChannel("diagnostics"))))),me.set(se.$_xb,new H.$Sh(J.$08b,[this.h])),me.set(L.$EU,new H.$Sh(T.$V8b)),me.set(O.$$8b,new H.$Sh(O.$_8b)),me.set(W.$88b,new H.$Sh(W.$98b,void 0,!1)),me.set($e.$F9b,new H.$Sh(ye.$H9b)),me.set(z.$k9b,new H.$Sh(z.$l9b)),me.set(ae.$W8b,new H.$Sh(ne.$Y8b)),me.set(Ee.$g8b,new H.$Sh(Ee.$h8b)),me.set(Ee.$i8b,new H.$Sh(Ee.$j8b));const Be=new Dt.$29b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),He=new At.$Br(Be,this.u,this.m,this.n);me.set(ct.$cr,He),b.$i?me.set(ce.$Z8b,new H.$Sh(X.$18b)):b.$j?me.set(ce.$Z8b,new H.$Sh(X.$28b)):b.$k&&me.set(ce.$Z8b,new H.$Sh(X.$38b));const Ke=new l.$O8b(this.s,this.u,this.m,this.w);me.set(n.$p8b,Ke);const Ne=new Ze.$B8b(this.s,this.m,this.C,Ke,Ae);if(me.set(Ze.$A8b,Ne),me.set(Ge.$afb,new H.$Sh(_e.$N9b,void 0,!1)),me.set(Je.$h9b,new H.$Sh(Je.$i9b,void 0,!1)),me.set(Ve.$KU,new H.$Sh(ie.$MU,void 0,!1)),(0,ee.$xo)(this.z,this.s)){const Te=(0,ee.$Co)(this.z,this.u),Qe=(0,h.$Bh)(Oe.then(nt=>nt.getChannel("telemetryAppender"))),Ye=new ke.$s9b(Qe),Xe=(0,Se.$no)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Pe,Ie,Te),et=(0,ee.$Do)(this.s),tt={appenders:[Ye],commonProperties:Xe,piiPaths:et,sendErrorTelemetry:!0};me.set(Fe.$il,new H.$Sh(pe.$7q,[tt],!1))}else me.set(Fe.$il,ee.$ro);return me.set(yt.$Ap,new H.$Sh(St.$VN,void 0,!0)),me.set(vt.$Ep,new H.$Sh(kt.$Q9b,void 0,!0)),me.set(at.$Z9b,new H.$Sh(at.$19b,void 0,!0)),await ot.Promises.settled([Ke.initialize(),Ne.initialize()]),this.j.createChild(me)}R(Pe,Ie,Oe){const me=this.B(new f.$Qc),Ae=h.ProxyChannel.fromService(Pe.get(U.$b9b),me,{disableMarshalling:!0});this.g.registerChannel("launch",Ae);const Be=h.ProxyChannel.fromService(Pe.get(k.$T8b),me,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Be);const He=new st.$O9b(Pe.get(it.$on));Ie.registerChannel("policy",He),Oe.then(xe=>xe.registerChannel("policy",He));const Ke=this.y.getProvider(y.Schemas.file);(0,g.$Mf)(Ke instanceof j.$gq);const Ne=new q.$48b(Ke,this.m,this.s);Ie.registerChannel(Y.$EN,Ne),Oe.then(xe=>xe.registerChannel(Y.$EN,Ne));const Te=h.ProxyChannel.fromService(Pe.get(rt.$e8b),me);Ie.registerChannel("userDataProfiles",Te),Oe.then(xe=>xe.registerChannel("userDataProfiles",Te));const Qe=new bt.$2q(Pe.get(pt.$Yo));Oe.then(xe=>xe.registerChannel("request",Qe));const Ye=new ge.$t9b(Pe.get(ue.$WU));Ie.registerChannel("update",Ye);const Xe=h.ProxyChannel.fromService(Pe.get(se.$_xb),me);Ie.registerChannel("issue",Xe);const et=h.ProxyChannel.fromService(Pe.get(L.$EU),me);Ie.registerChannel("encryption",et);const tt=h.ProxyChannel.fromService(Pe.get(le.$9k),me);Ie.registerChannel("sign",tt);const nt=h.ProxyChannel.fromService(Pe.get(O.$$8b),me);Ie.registerChannel("keyboardLayout",nt),this.f=Pe.get(W.$88b);const $t=h.ProxyChannel.fromService(this.f,me);Ie.registerChannel("nativeHost",$t),Oe.then(xe=>xe.registerChannel("nativeHost",$t));const Lt=h.ProxyChannel.fromService(Pe.get(Ge.$afb),me);Ie.registerChannel("workspaces",Lt);const Ft=h.ProxyChannel.fromService(Pe.get(z.$k9b),me);Ie.registerChannel("menubar",Ft);const jt=h.ProxyChannel.fromService(Pe.get(Ve.$KU),me);Ie.registerChannel("url",jt);const Ut=h.ProxyChannel.fromService(Pe.get($e.$F9b),me);Ie.registerChannel("webview",Ut);const mt=this.B(new be.$q9b(this.m,Pe.get(Ee.$g8b)));Ie.registerChannel("storage",mt),Oe.then(xe=>xe.registerChannel("storage",mt));const Nt=this.B(new Pt.$S9b(Pe.get(Ee.$g8b),Pe.get(rt.$e8b),this.m));Oe.then(xe=>xe.registerChannel("profileStorageListener",Nt));const Wt=h.ProxyChannel.fromService(Pe.get(ct.$cr),me);Ie.registerChannel(ct.TerminalIpcChannels.LocalPty,Wt);const Tt=h.ProxyChannel.fromService(Pe.get(ce.$Z8b),me);Ie.registerChannel("externalTerminal",Tt);const wt=new It.$X9b(Pe.get(Rt.$C8b));Ie.registerChannel("logger",wt),Oe.then(xe=>xe.registerChannel("logger",wt));const zt=new D.$P8b(Pe.get(Ue.$J8b));Ie.registerChannel("extensionhostdebugservice",zt);const Bt=h.ProxyChannel.fromService(Pe.get(ae.$W8b),me);Ie.registerChannel(ae.$X8b,Bt);const qt=h.ProxyChannel.fromService(Pe.get(at.$Z9b),me);Ie.registerChannel(Ct.$Y9b,qt)}async S(Pe,Ie){const Oe=this.b=Pe.get(Ue.$J8b);this.c=Pe.get(ut.$H8b);const me=(0,K.$Tl)(process.env)?0:4,Ae=this.s.args;if(Ie){if(Ie.openables.length>0)return Oe.open({context:me,cli:Ae,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const tt of Ie.urls){const nt=new URLSearchParams(tt.uri.query);if(nt.get("windowId")==="_blank")return nt.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:nt.toString()}),Oe.open({context:me,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,He=Ae._.length,Ke=!!Ae["folder-uri"],Ne=!!Ae["file-uri"],Te=Ae["skip-add-to-recently-opened"]===!0,Qe=Ae.wait&&Ae.waitMarkerFilePath?u.URI.file(Ae.waitMarkerFilePath):void 0,Ye=Ae.remote||void 0,Xe=Ae.profile,et=Ae["profile-temp"];if(!He&&!Ke&&!Ne){if(Ae["new-window"]||Xe||et)return Oe.open({context:me,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Te,waitMarkerFileURI:Qe,initialStartup:!0,remoteAuthority:Ye,forceProfile:Xe,forceTempProfile:et});if(Be.length)return Oe.open({context:1,cli:Ae,urisToOpen:Be.map(tt=>(0,qe.$oi)(tt)?{workspaceUri:u.URI.file(tt)}:{fileUri:u.URI.file(tt)}),noRecentEntry:Te,waitMarkerFileURI:Qe,initialStartup:!0})}return Oe.open({context:me,cli:Ae,forceNewWindow:Ae["new-window"]||!He&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:Te,waitMarkerFileURI:Qe,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:Xe,forceTempProfile:et})}U(){this.W(),S.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.X(this.s.args,process.env,!0),this.Y(),b.$j&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Pe=this.z.win32MutexName;if(b.$i&&Pe)try{const Ie=await new Promise((me,Ae)=>{Z(["@vscode/windows-mutex"],me,Ae)}),Oe=new Ie.Mutex(Pe);$.Event.once(this.t.onWillShutdown)(()=>Oe.release())}catch(Ie){this.m.error(Ie)}}async X(Pe,Ie,Oe){try{return await(0,Q.$Zl)(this.u,this.m,Pe,Ie)}catch(me){const Ae=(0,P.$Gi)(me);Oe?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.m.error(Ae)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),Oe=JSON.parse((0,p.$$m)(Ie)),Ae=(0,ee.$zo)(this.u)>=1;if(Oe["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,a.$ig)()}"`,"}"],He=Ie.substring(0,Ie.length-2).concat(`,
`,Be.join(`
`));await this.y.writeFile(this.s.argvResource,C.$fe.fromString(He))}else{const Be=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);Be!==Ie&&await this.y.writeFile(this.s.argvResource,C.$fe.fromString(Be))}}catch(Pe){this.m.error(Pe)}}};e.$79b=ft,e.$79b=ft=ht=ve([te(2,B.$Uh),te(3,F.$dj),te(4,F.$ej),te(5,N.$97b),te(6,G.$$7b),te(7,w.$pi),te(8,we.$ON),te(9,V.$ek),te(10,x.$vj),te(11,rt.$e8b)],ft)}),define(re[315],oe([0,1,15,46,7,23,8,50,14,33,3,47,13,9,67,4,35,27,21,42,99,309,10,17,238,250,24,63,202,16,222,93,78,218,92,20,225,5,79,25,80,278,126,288,51,287,95,249,34,52,69,54,39,234,232,2,40,266,68,227,115,121,270,264]),function(Z,e,S,A,s,M,C,P,d,c,$,p,v,f,y,m,b,g,u,a,E,h,i,o,r,t,n,l,w,D,I,k,R,L,T,N,K,Q,ae,ne,ce,X,Y,V,q,j,H,B,_,se,J,O,U,G,F,z,W,x,he,de,le,we,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(ke){console.error(ke.message),S.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(Me=>console.error(Me));const[ke,pe,ee,ue,ge,Re,De,je]=this.b();try{try{await this.d(ee,je,ue,ge,De)}catch(Me){throw this.f(ee,De,Me),Me}await ke.invokeFunction(async Me=>{const Ve=Me.get(Q.$dj),ze=Me.get(N.$$7b),ie=Me.get(D.$ek),fe=Me.get(Q.$ej),$e=await this.e(Ve,ee,ze,ke,De,!0);return u.Promises.writeFile(ee.mainLockfile,String(process.pid)).catch(ye=>{Ve.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Re.logger=fe.createLogger("main",{name:(0,i.localize)(0,null)}),$.Event.once(ze.onWillShutdown)(ye=>{ie.dispose(),ue.dispose(),ye.join("instanceLockfile",u.Promises.unlink(ee.mainLockfile).catch(()=>{}))}),ke.createInstance(h.$79b,$e,pe).startup()})}catch(Me){ke.invokeFunction(this.i,Me)}}b(){const ke=new T.$Th,pe=new z.$Qc;process.once("exit",()=>pe.dispose());const ee={_serviceBrand:void 0,...ae.default};ke.set(ne.$vj,ee);const ue=new n.$07b(this.j(),ee),ge=this.c(ue);ke.set(n.$97b,ue);const Re=new he.$D8b((0,Q.$rj)(ue),ue.logsHome);ke.set(he.$C8b,Re);const De=new K.$P5b(Re.getLogLevel()),je=pe.add(new de.$WN(De,[new Q.$kj(Re.getLogLevel())]));ke.set(Q.$dj,je);const Me=new I.$Tp(je);ke.set(D.$ek,Me);const Ve=new k.$gq(je);Me.registerProvider(v.Schemas.file,Ve);const ze=new x.$Fr(Me);ke.set(W.$Ok,ze);const ie=new we.$RN(1,ue,je,Me);ke.set(_.$NN,ie),ke.set(_.$ON,ie);const fe=new O.$f8b(ie,ze,ue,Me,je);ke.set(O.$e8b,fe),Me.registerProvider(v.Schemas.vscodeUserData,new be.$f0b(v.Schemas.file,Ve,v.Schemas.vscodeUserData,fe,ze,je));const $e=m.$i&&ee.win32RegValueName?pe.add(new G.$d0b(je,ee.win32RegValueName)):ue.policyFile?pe.add(new F.$e0b(ue.policyFile,Me,je)):new U.$qn;ke.set(U.$on,$e);const ye=new r.$Qn(fe.defaultProfile.settingsResource,Me,$e,je);return ke.set(o.$pi,ye),ke.set(N.$$7b,new R.$Sh(N.$_7b,void 0,!1)),ke.set(q.$Yo,new R.$Sh(j.$b0b,void 0,!0)),ke.set(J.$k8b,new R.$Sh(J.$l8b)),ke.set(H.$9k,new R.$Sh(B.$c0b,void 0,!1)),ke.set(Y.$dv,new R.$Sh(V.$_9b)),ke.set(ce.$s8b,new X.$99b(ue,fe,je)),[new L.$jq(ke,!0),ge,ue,ye,ie,De,ee,fe]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ee=>{const ue=process.env[ee];typeof ue=="string"&&(pe[ee]=ue)}),Object.assign(process.env,pe),pe}async d(ke,pe,ee,ue,ge){await C.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:v.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,ke.backupHome].map(Re=>Re?u.Promises.mkdir(Re,{recursive:!0}):void 0)),ue.init(),ee.initialize()]),pe.init()}async e(ke,pe,ee,ue,ge,Re){let De;try{(0,y.mark)("code/willStartMainServer"),De=await(0,E.$Qh)(pe.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),$.Event.once(ee.onWillShutdown)(()=>De.dispose())}catch(je){if(je.code!=="EADDRINUSE")throw this.f(pe,ge,je),je;let Me;try{Me=await(0,E.$Rh)(pe.mainIPCHandle,"main")}catch(fe){if(!Re||m.$i||fe.code!=="ECONNREFUSED")throw fe.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),fe;try{(0,A.unlinkSync)(pe.mainIPCHandle)}catch($e){throw ke.warn("Could not delete obsolete instance handle",$e),$e}return this.e(ke,pe,ee,ue,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const fe=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ke.error(fe),Me.dispose(),new Error(fe)}let Ve;!pe.args.wait&&!pe.args.status&&(Ve=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=a.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),ie=a.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ue.invokeFunction(async()=>{const fe=new t.$Mr(se.$ro,ge),$e=await ie.getMainDiagnostics(),ye=await ie.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ce=await fe.getDiagnostics($e,ye);throw console.log(Ce),new d.$_});throw m.$i&&await this.h(ze,ke),ke.trace("Sending env to running instance..."),await ze.start(pe.args,process.env),Me.dispose(),Ve&&clearTimeout(Ve),new d.$_("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new d.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),De}f(ke,pe,ee){if(ee.code==="EACCES"||ee.code==="EPERM"){const ue=(0,M.$Gb)([ke.userDataPath,ke.extensionsPath,E.$Mh]).map(ge=>(0,p.$yv)(s.URI.file(ge),{os:m.OS,tildify:ke}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,P.$Gi)(ee),ue.join(`
`)),pe)}}g(ke,pe,ee){S.dialog.showMessageBoxSync((0,le.$Mv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:ke,detail:pe},ee).options)}async h(ke,pe){if(m.$i){const ee=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",ee);try{(await new Promise((ue,ge)=>{Z(["windows-foreground-love"],ue,ge)})).allowSetForegroundWindow(ee)}catch(ue){pe.error(ue)}}}i(ke,pe){const ee=ke.get(Q.$dj),ue=ke.get(N.$$7b);let ge=0;pe&&(pe.isExpected?pe.message&&ee.trace(pe.message):(ge=1,pe.stack?ee.error(pe.stack):ee.error(`Startup error: ${pe.toString()}`))),ue.kill(ge)}j(){const ke=this.k((0,l.$Ql)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,w.$89b)(ke.verbose);pe&&((0,l.$Sl)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const ee=(0,b.cwd)(),ue=ke.map(De=>{let je=String(De),Me;pe&&(Me=(0,c.$9f)(je),je=Me.path),je&&(je=this.m(ee,je));const Ve=(0,c.$4f)(je,ee),ze=(0,f.$mc)(Ve);return ze&&!(0,c.$Zf)(ze)?null:pe&&Me?(Me.path=Ve,this.n(Me)):Ve}),ge=m.$i||m.$j,Re=(0,M.$Lb)(ue,De=>De&&ge?De.toLowerCase():De||"");return(0,M.$Gb)(Re)}m(ke,pe){return m.$i&&(pe=(0,g.$Oe)(pe,'"')),pe=(0,g.$Me)((0,g.$Me)(pe," "),"	"),m.$i&&(pe=(0,f.$jc)(ke,pe),pe=(0,g.$Oe)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a7a67c4d7460b0f0e26ad96ea9c35197d3d085f1/core/vs/code/electron-main/main.js.map
