/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],D=0,T=me.length;D<T;D++)e[D]=ke[me[D]];return e};define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const g=new Map,R=new Map,L=new Map,b=new Map;function y(v,S){v.has(S.detail)||v.set(S.detail,-S.timestamp)}function m(v,S){const w=v.get(S.detail);w&&(w>=0||v.set(S.detail,w+S.timestamp))}let A=[];typeof me=="function"&&typeof me.getStats=="function"&&(A=me.getStats().slice(0).sort((v,S)=>v.timestamp-S.timestamp));for(const v of A)switch(v.type){case 10:y(g,v);break;case 11:case 12:m(g,v);break;case 21:y(R,v);break;case 22:m(R,v);break;case 33:y(L,v);break;case 34:m(L,v);break;case 31:y(b,v);break;case 32:m(b,v);break}let C=0;L.forEach(v=>C+=v);function $(v){const S=[];return v.forEach((w,u)=>S.push([u,w])),S}return{amdLoad:$(g),amdInvoke:$(R),nodeRequire:$(L),nodeEval:$(b),nodeRequireTotal:C}}static toMarkdownTable(g,R){let L="";const b=[];return g.forEach((y,m)=>{b[m]=y.length}),R.forEach(y=>{y.forEach((m,A)=>{typeof m>"u"&&(m=y[A]="-");const C=m.toString().length;b[A]=Math.max(C,b[A])})}),g.forEach((y,m)=>{L+=`| ${y+" ".repeat(b[m]-y.toString().length)} `}),L+=`|
`,g.forEach((y,m)=>{L+=`| ${"-".repeat(b[m])} `}),L+=`|
`,R.forEach(y=>{y.forEach((m,A)=>{typeof m<"u"&&(L+=`| ${m+" ".repeat(b[A]-m.toString().length)} `)}),L+=`|
`}),L}}e.$T=D}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(w,u,o){const i=T(w,u);if(i!==-1)return w[i]}e.$eb=D;function T(w,u,o=w.length-1){for(let i=o;i>=0;i--){const n=w[i];if(u(n))return i}return-1}e.$fb=T;function g(w,u){const o=R(w,u);return o===-1?void 0:w[o]}e.$gb=g;function R(w,u,o=0,i=w.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);u(w[a])?n=a+1:r=a}return n-1}e.$hb=R;function L(w,u){const o=b(w,u);return o===w.length?void 0:w[o]}e.$ib=L;function b(w,u,o=0,i=w.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);u(w[a])?r=a:n=a+1}return n}e.$jb=b;function y(w,u,o=0,i=w.length){const n=b(w,u,o,i);return n===w.length?-1:n}e.$kb=y;class m{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(m.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!u(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const o=R(this.e,u,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$lb=m;function A(w,u){if(w.length===0)return;let o=w[0];for(let i=1;i<w.length;i++){const n=w[i];u(n,o)>0&&(o=n)}return o}e.$mb=A;function C(w,u){if(w.length===0)return;let o=w[0];for(let i=1;i<w.length;i++){const n=w[i];u(n,o)>=0&&(o=n)}return o}e.$nb=C;function $(w,u){return A(w,(o,i)=>-u(o,i))}e.$ob=$;function v(w,u){if(w.length===0)return-1;let o=0;for(let i=1;i<w.length;i++){const n=w[i];u(n,w[o])>0&&(o=i)}return o}e.$pb=v;function S(w,u){for(const o of w){const i=u(o);if(i!==void 0)return i}}e.$qb=S}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(L,b){const y=Object.create(null);for(const m of L){const A=b(m);let C=y[A];C||(C=y[A]=[]),C.push(m)}return y}e.$J=D;function T(L,b){const y=[],m=[];for(const A of L)b.has(A)||y.push(A);for(const A of b)L.has(A)||m.push(A);return{removed:y,added:m}}e.$K=T;function g(L,b){const y=[],m=[];for(const[A,C]of L)b.has(A)||y.push(C);for(const[A,C]of b)L.has(A)||m.push(C);return{removed:y,added:m}}e.$L=g;function R(L,b){const y=new Set;for(const m of b)L.has(m)&&y.add(m);return y}e.$M=R}),define(ke[59],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function D(L){return(b,y,m)=>{let A=null,C=null;if(typeof m.value=="function"?(A="value",C=m.value):typeof m.get=="function"&&(A="get",C=m.get),!C)throw new Error("not supported");m[A]=L(C,y)}}function T(L,b,y){let m=null,A=null;if(typeof y.value=="function"?(m="value",A=y.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(m="get",A=y.get),!A)throw new Error("not supported");const C=`$memoize$${b}`;y[m]=function(...$){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[C]}}e.$nh=T;function g(L,b,y){return D((m,A)=>{const C=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...v){this[$]||(this[$]=y?y():void 0),clearTimeout(this[C]),b&&(this[$]=b(this[$],...v),v=[this[$]]),this[C]=setTimeout(()=>{m.apply(this,v),this[$]=y?y():void 0},L)}})}e.$oh=g;function R(L,b,y){return D((m,A)=>{const C=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...w){if(this[$]||(this[$]=y?y():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[$]=b(this[$],...w)),this[S])return;const u=this[v]+L;u<=Date.now()?(this[v]=Date.now(),m.apply(this,[this[$]]),this[$]=y?y():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[v]=Date.now(),m.apply(this,[this[$]]),this[$]=y?y():void 0},u-Date.now()))}})}e.$ph=R}),define(ke[8],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=D,e.$W=new D;function T(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=T;function g(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=g;function R(a){m(a)||e.$W.onUnexpectedError(a)}e.$Z=R;function L(a){m(a)||e.$W.onUnexpectedExternalError(a)}e.$1=L;function b(a){if(a instanceof Error){const{name:t,message:s}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=b;const y="Canceled";function m(a){return a instanceof A?!0:a instanceof Error&&a.name===y&&a.message===y}e.$3=m;class A extends Error{constructor(){super(y),this.name=this.message}}e.$4=A;function C(){const a=new Error(y);return a.name=a.message,a}e.$5=C;function $(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=$;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=v;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=S;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=w;class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=u;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const s=new n;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$bb=r}),define(ke[19],Se([1,0,8,121]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function g(H,_=0){return H[H.length-(1+_)]}e.$rb=g;function R(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.$sb=R;function L(H,_,Z=($e,re)=>$e===re){if(H===_)return!0;if(!H||!_||H.length!==_.length)return!1;for(let $e=0,re=H.length;$e<re;$e++)if(!Z(H[$e],_[$e]))return!1;return!0}e.$tb=L;function b(H,_){const Z=H.length-1;_<Z&&(H[_]=H[Z]),H.pop()}e.$ub=b;function y(H,_,Z){return m(H.length,$e=>Z(H[$e],_))}e.$vb=y;function m(H,_){let Z=0,$e=H-1;for(;Z<=$e;){const re=(Z+$e)/2|0,fe=_(re);if(fe<0)Z=re+1;else if(fe>0)$e=re-1;else return re}return-(Z+1)}e.$wb=m;function A(H,_,Z){if(H=H|0,H>=_.length)throw new TypeError("invalid index");const $e=_[Math.floor(_.length*Math.random())],re=[],fe=[],te=[];for(const de of _){const pe=Z(de,$e);pe<0?re.push(de):pe>0?fe.push(de):te.push(de)}return H<re.length?A(H,re,Z):H<re.length+te.length?te[0]:A(H-(re.length+te.length),fe,Z)}e.$xb=A;function C(H,_){const Z=[];let $e;for(const re of H.slice(0).sort(_))!$e||_($e[0],re)!==0?($e=[re],Z.push($e)):$e.push(re);return Z}e.$yb=C;function*$(H,_){let Z,$e;for(const re of H)$e!==void 0&&_($e,re)?Z.push(re):(Z&&(yield Z),Z=[re]),$e=re;Z&&(yield Z)}e.$zb=$;function v(H,_){for(let Z=0;Z<=H.length;Z++)_(Z===0?void 0:H[Z-1],Z===H.length?void 0:H[Z])}e.$Ab=v;function S(H,_){for(let Z=0;Z<H.length;Z++)_(Z===0?void 0:H[Z-1],H[Z],Z+1===H.length?void 0:H[Z+1])}e.$Bb=S;function w(H,_,Z){const $e=[];function re(de,pe,Pe){if(pe===0&&Pe.length===0)return;const B=$e[$e.length-1];B&&B.start+B.deleteCount===de?(B.deleteCount+=pe,B.toInsert.push(...Pe)):$e.push({start:de,deleteCount:pe,toInsert:Pe})}let fe=0,te=0;for(;;){if(fe===H.length){re(fe,0,_.slice(te));break}if(te===_.length){re(fe,H.length-fe,[]);break}const de=H[fe],pe=_[te],Pe=Z(de,pe);Pe===0?(fe+=1,te+=1):Pe<0?(re(fe,1,[]),fe+=1):Pe>0&&(re(fe,0,[pe]),te+=1)}return $e}e.$Cb=w;function u(H,_,Z){const $e=w(H,_,Z),re=[],fe=[];for(const te of $e)re.push(...H.slice(te.start,te.start+te.deleteCount)),fe.push(...te.toInsert);return{removed:re,added:fe}}e.$Db=u;function o(H,_,Z){if(Z===0)return[];const $e=H.slice(0,Z).sort(_);return n(H,_,$e,Z,H.length),$e}e.top=o;function i(H,_,Z,$e,re){return Z===0?Promise.resolve([]):new Promise((fe,te)=>{(async()=>{const de=H.length,pe=H.slice(0,Z).sort(_);for(let Pe=Z,B=Math.min(Z+$e,de);Pe<de;Pe=B,B=Math.min(B+$e,de)){if(Pe>Z&&await new Promise(X=>setTimeout(X)),re&&re.isCancellationRequested)throw new D.$4;n(H,_,pe,Pe,B)}return pe})().then(fe,te)})}e.$Fb=i;function n(H,_,Z,$e,re){for(const fe=Z.length;$e<re;$e++){const te=H[$e];if(_(te,Z[fe-1])<0){Z.pop();const de=(0,T.$jb)(Z,pe=>_(te,pe)<0);Z.splice(de,0,te)}}}function r(H){return H.filter(_=>!!_)}e.$Gb=r;function a(H){let _=0;for(let Z=0;Z<H.length;Z++)H[Z]&&(H[_]=H[Z],_+=1);H.length=_}e.$Hb=a;function t(H,_,Z){H.splice(Z,0,H.splice(_,1)[0])}e.$Ib=t;function s(H){return!Array.isArray(H)||H.length===0}e.$Jb=s;function d(H){return Array.isArray(H)&&H.length>0}e.$Kb=d;function l(H,_=Z=>Z){const Z=new Set;return H.filter($e=>{const re=_($e);return Z.has(re)?!1:(Z.add(re),!0)})}e.$Lb=l;function c(H){const _=new Set;return Z=>{const $e=H(Z);return _.has($e)?!1:(_.add($e),!0)}}e.$Mb=c;function h(H,_){return H.length>0?H[0]:_}e.$Nb=h;function E(H,_){return H.length>0?H[H.length-1]:_}e.$Ob=E;function I(H,_,Z=($e,re)=>$e===re){let $e=0;for(let re=0,fe=Math.min(H.length,_.length);re<fe&&Z(H[re],_[re]);re++)$e++;return $e}e.$Pb=I;function f(H){return[].concat(...H)}e.$Qb=f;function p(H,_){let Z=typeof _=="number"?H:0;typeof _=="number"?Z=H:(Z=0,_=H);const $e=[];if(Z<=_)for(let re=Z;re<_;re++)$e.push(re);else for(let re=Z;re>_;re--)$e.push(re);return $e}e.$Rb=p;function k(H,_,Z){return H.reduce(($e,re)=>($e[_(re)]=Z?Z(re):re,$e),Object.create(null))}e.$Sb=k;function P(H,_){return H.push(_),()=>j(H,_)}e.$Tb=P;function j(H,_){const Z=H.indexOf(_);if(Z>-1)return H.splice(Z,1),_}e.$Ub=j;function z(H,_,Z){const $e=H.slice(0,_),re=H.slice(_);return $e.concat(Z,re)}e.$Vb=z;function M(H,_){let Z;if(typeof _=="number"){let $e=_;Z=()=>{const re=Math.sin($e++)*179426549;return re-Math.floor(re)}}else Z=Math.random;for(let $e=H.length-1;$e>0;$e-=1){const re=Math.floor(Z()*($e+1)),fe=H[$e];H[$e]=H[re],H[re]=fe}}e.$Wb=M;function F(H,_){const Z=H.indexOf(_);Z>-1&&(H.splice(Z,1),H.unshift(_))}e.$Xb=F;function N(H,_){const Z=H.indexOf(_);Z>-1&&(H.splice(Z,1),H.push(_))}e.$Yb=N;function O(H,_){for(const Z of _)H.push(Z)}e.$Zb=O;function W(H,_){return Array.isArray(H)?H.map(_):_(H)}e.$1b=W;function x(H){return Array.isArray(H)?H:[H]}e.$2b=x;function ce(H){return H[Math.floor(Math.random()*H.length)]}e.$3b=ce;function Y(H,_,Z){const $e=J(H,_),re=H.length,fe=Z.length;H.length=re+fe;for(let te=re-1;te>=$e;te--)H[te+fe]=H[te];for(let te=0;te<fe;te++)H[te+$e]=Z[te]}e.$4b=Y;function G(H,_,Z,$e){const re=J(H,_);let fe=H.splice(re,Z);return fe===void 0&&(fe=[]),Y(H,re,$e),fe}e.$5b=G;function J(H,_){return _<0?Math.max(_+H.length,0):Math.min(_,H.length)}var le;(function(H){function _(fe){return fe<0}H.isLessThan=_;function Z(fe){return fe<=0}H.isLessThanOrEqual=Z;function $e(fe){return fe>0}H.isGreaterThan=$e;function re(fe){return fe===0}H.isNeitherLessOrGreaterThan=re,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(le||(e.CompareResult=le={}));function Q(H,_){return(Z,$e)=>_(H(Z),H($e))}e.$6b=Q;function Ee(...H){return(_,Z)=>{for(const $e of H){const re=$e(_,Z);if(!le.isNeitherLessOrGreaterThan(re))return re}return le.neitherLessOrGreaterThan}}e.$7b=Ee;const he=(H,_)=>H-_;e.$8b=he;const K=(H,_)=>(0,e.$8b)(H?1:0,_?1:0);e.$9b=K;function U(H){return(_,Z)=>-H(_,Z)}e.$0b=U;class ie{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let Z=this.c;for(;Z<this.g.length&&_(this.g[Z]);)Z++;const $e=Z===this.c?null:this.g.slice(this.c,Z);return this.c=Z,$e}takeFromEndWhile(_){let Z=this.d;for(;Z>=0&&_(this.g[Z]);)Z--;const $e=Z===this.d?null:this.g.slice(Z+1,this.d+1);return this.d=Z,$e}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const Z=this.g.slice(this.c,this.c+_);return this.c+=_,Z}}e.$$b=ie;class be{static{this.empty=new be(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(Z=>(_(Z),!0))}toArray(){const _=[];return this.iterate(Z=>(_.push(Z),!0)),_}filter(_){return new be(Z=>this.iterate($e=>_($e)?Z($e):!0))}map(_){return new be(Z=>this.iterate($e=>Z(_($e))))}some(_){let Z=!1;return this.iterate($e=>(Z=_($e),!Z)),Z}findFirst(_){let Z;return this.iterate($e=>_($e)?(Z=$e,!1):!0),Z}findLast(_){let Z;return this.iterate($e=>(_($e)&&(Z=$e),!0)),Z}findLastMaxBy(_){let Z,$e=!0;return this.iterate(re=>(($e||le.isGreaterThan(_(re,Z)))&&($e=!1,Z=re),!0)),Z}}e.$_b=be}),define(ke[60],Se([1,0,8]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function T(y,m){if(!y)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=T;function g(y,m="Unreachable"){throw new Error(m)}e.$4c=g;function R(y){if(!y)throw new D.$bb("Assertion Failed")}e.$5c=R;function L(y){if(!y()){debugger;y(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$6c=L;function b(y,m){let A=0;for(;A<y.length-1;){const C=y[A],$=y[A+1];if(!m(C,$))return!1;A++}return!0}e.$7c=b}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(T,g){const R=this;let L=!1,b;return function(){if(L)return b;if(L=!0,g)try{b=T.apply(R,arguments)}finally{g()}else b=T.apply(R,arguments);return b}}e.$cb=D}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$EM=D,e.$FM=new D("id#")}),define(ke[51],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function g(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}T.is=g;const R=Object.freeze([]);function L(){return R}T.empty=L;function*b(a){yield a}T.single=b;function y(a){return g(a)?a:b(a)}T.wrap=y;function m(a){return a||R}T.from=m;function*A(a){for(let t=a.length-1;t>=0;t--)yield a[t]}T.reverse=A;function C(a){return!a||a[Symbol.iterator]().next().done===!0}T.isEmpty=C;function $(a){return a[Symbol.iterator]().next().value}T.first=$;function v(a,t){for(const s of a)if(t(s))return!0;return!1}T.some=v;function S(a,t){for(const s of a)if(t(s))return s}T.find=S;function*w(a,t){for(const s of a)t(s)&&(yield s)}T.filter=w;function*u(a,t){let s=0;for(const d of a)yield t(d,s++)}T.map=u;function*o(...a){for(const t of a)for(const s of t)yield s}T.concat=o;function i(a,t,s){let d=s;for(const l of a)d=t(d,l);return d}T.reduce=i;function*n(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}T.slice=n;function r(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const d=a[Symbol.iterator]();for(let l=0;l<t;l++){const c=d.next();if(c.done)return[s,T.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return d}}]}T.consume=r})(D||(e.Iterable=D={}))}),define(ke[160],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,s=!1){let d=0;const l=t.length;let c="",h=0,E=16,I=0;function f(F){let N=0,O=0;for(;N<F;){const W=t.charCodeAt(d);if(W>=48&&W<=57)O=O*16+W-48;else if(W>=65&&W<=70)O=O*16+W-65+10;else if(W>=97&&W<=102)O=O*16+W-97+10;else break;d++,N++}return N<F&&(O=-1),O}function p(F){d=F,c="",h=0,E=16,I=0}function k(){const F=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&m(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&m(t.charCodeAt(d)))for(d++;d<t.length&&m(t.charCodeAt(d));)d++;else return I=3,t.substring(F,d);let N=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&m(t.charCodeAt(d))){for(d++;d<t.length&&m(t.charCodeAt(d));)d++;N=d}else I=3;return t.substring(F,N)}function P(){let F="",N=d;for(;;){if(d>=l){F+=t.substring(N,d),I=2;break}const O=t.charCodeAt(d);if(O===34){F+=t.substring(N,d),d++;break}if(O===92){if(F+=t.substring(N,d),d++,d>=l){I=2;break}switch(t.charCodeAt(d++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const x=f(4);x>=0?F+=String.fromCharCode(x):I=4;break}default:I=5}N=d;continue}if(O>=0&&O<=31)if(y(O)){F+=t.substring(N,d),I=2;break}else I=6;d++}return F}function j(){if(c="",I=0,h=d,d>=l)return h=l,E=17;let F=t.charCodeAt(d);if(b(F)){do d++,c+=String.fromCharCode(F),F=t.charCodeAt(d);while(b(F));return E=15}if(y(F))return d++,c+=String.fromCharCode(F),F===13&&t.charCodeAt(d)===10&&(d++,c+=`
`),E=14;switch(F){case 123:return d++,E=1;case 125:return d++,E=2;case 91:return d++,E=3;case 93:return d++,E=4;case 58:return d++,E=6;case 44:return d++,E=5;case 34:return d++,c=P(),E=10;case 47:{const N=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!y(t.charCodeAt(d));)d++;return c=t.substring(N,d),E=12}if(t.charCodeAt(d+1)===42){d+=2;const O=l-1;let W=!1;for(;d<O;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,W=!0;break}d++}return W||(d++,I=1),c=t.substring(N,d),E=13}return c+=String.fromCharCode(F),d++,E=16}case 45:if(c+=String.fromCharCode(F),d++,d===l||!m(t.charCodeAt(d)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),E=11;default:for(;d<l&&z(F);)d++,F=t.charCodeAt(d);if(h!==d){switch(c=t.substring(h,d),c){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return c+=String.fromCharCode(F),d++,E=16}}function z(F){if(b(F)||y(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let F;do F=j();while(F>=12&&F<=15);return F}return{setPosition:p,getPosition:()=>d,scan:s?M:j,getToken:()=>E,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>I}}e.$1m=L;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,s){const d=[],l=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function I(f,p,k,P){h.value=f,h.offset=p,h.length=k,h.type=P,h.colonOffset=void 0,c=h}try{n(t,{onObjectBegin:(f,p)=>{if(s<=f)throw l;c=void 0,E=s>f,d.push("")},onObjectProperty:(f,p,k)=>{if(s<p||(I(f,p,k,"property"),d[d.length-1]=f,s<=p+k))throw l},onObjectEnd:(f,p)=>{if(s<=f)throw l;c=void 0,d.pop()},onArrayBegin:(f,p)=>{if(s<=f)throw l;c=void 0,d.push(0)},onArrayEnd:(f,p)=>{if(s<=f)throw l;c=void 0,d.pop()},onLiteralValue:(f,p,k)=>{if(s<p||(I(f,p,k,a(f)),s<=p+k))throw l},onSeparator:(f,p,k)=>{if(s<=p)throw l;if(f===":"&&c&&c.type==="property")c.colonOffset=p,E=!1,c=void 0;else if(f===","){const P=d[d.length-1];typeof P=="number"?d[d.length-1]=P+1:(E=!0,d[d.length-1]=""),c=void 0}}})}catch(f){if(f!==l)throw f}return{path:d,previousNode:c,isAtPropertyKey:E,matches:f=>{let p=0;for(let k=0;p<f.length&&k<d.length;k++)if(f[p]===d[k]||f[p]==="*")p++;else if(f[p]!=="**")return!1;return p===f.length}}}e.$2m=C;function $(t,s=[],d=R.DEFAULT){let l=null,c=[];const h=[];function E(f){Array.isArray(c)?c.push(f):l!==null&&(c[l]=f)}return n(t,{onObjectBegin:()=>{const f={};E(f),h.push(c),c=f,l=null},onObjectProperty:f=>{l=f},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const f=[];E(f),h.push(c),c=f,l=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:E,onError:(f,p,k)=>{s.push({error:f,offset:p,length:k})}},d),c[0]}e.$3m=$;function v(t,s=[],d=R.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(f){l.type==="property"&&(l.length=f-l.offset,l=l.parent)}function h(f){return l.children.push(f),f}n(t,{onObjectBegin:f=>{l=h({type:"object",offset:f,length:-1,parent:l,children:[]})},onObjectProperty:(f,p,k)=>{l=h({type:"property",offset:p,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:f,offset:p,length:k,parent:l})},onObjectEnd:(f,p)=>{l.length=f+p-l.offset,l=l.parent,c(f+p)},onArrayBegin:(f,p)=>{l=h({type:"array",offset:f,length:-1,parent:l,children:[]})},onArrayEnd:(f,p)=>{l.length=f+p-l.offset,l=l.parent,c(f+p)},onLiteralValue:(f,p,k)=>{h({type:a(f),offset:p,length:k,parent:l,value:f}),c(p+k)},onSeparator:(f,p,k)=>{l.type==="property"&&(f===":"?l.colonOffset=p:f===","&&c(p))},onError:(f,p,k)=>{s.push({error:f,offset:p,length:k})}},d);const I=l.children[0];return I&&delete I.parent,I}e.$4m=v;function S(t,s){if(!t)return;let d=t;for(const l of s)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],c=!0;break}if(!c)return}else{const c=l;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}e.$5m=S;function w(t){if(!t.parent||!t.parent.children)return[];const s=w(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;s.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&s.push(d)}return s}e.$6m=w;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const s=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(s[d.children[0].value]=u(l))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$7m=u;function o(t,s,d=!1){return s>=t.offset&&s<t.offset+t.length||d&&s===t.offset+t.length}e.$8m=o;function i(t,s,d=!1){if(o(t,s,d)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=s;c++){const h=i(l[c],s,d);if(h)return h}return t}}e.$9m=i;function n(t,s,d=R.DEFAULT){const l=L(t,!1);function c(Q){return Q?()=>Q(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(Q){return Q?Ee=>Q(Ee,l.getTokenOffset(),l.getTokenLength()):()=>!0}const E=c(s.onObjectBegin),I=h(s.onObjectProperty),f=c(s.onObjectEnd),p=c(s.onArrayBegin),k=c(s.onArrayEnd),P=h(s.onLiteralValue),j=h(s.onSeparator),z=c(s.onComment),M=h(s.onError),F=d&&d.disallowComments,N=d&&d.allowTrailingComma;function O(){for(;;){const Q=l.scan();switch(l.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:F||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Q){case 12:case 13:F?W(10):z();break;case 16:W(1);break;case 15:case 14:break;default:return Q}}}function W(Q,Ee=[],he=[]){if(M(Q),Ee.length+he.length>0){let K=l.getToken();for(;K!==17;){if(Ee.indexOf(K)!==-1){O();break}else if(he.indexOf(K)!==-1)break;K=O()}}}function x(Q){const Ee=l.getTokenValue();return Q?P(Ee):I(Ee),O(),!0}function ce(){switch(l.getToken()){case 11:{let Q=0;try{Q=JSON.parse(l.getTokenValue()),typeof Q!="number"&&(W(2),Q=0)}catch{W(2)}P(Q);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function Y(){return l.getToken()!==10?(W(3,[],[2,5]),!1):(x(!1),l.getToken()===6?(j(":"),O(),le()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function G(){E(),O();let Q=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(Q||W(4,[],[]),j(","),O(),l.getToken()===2&&N)break}else Q&&W(6,[],[]);Y()||W(4,[],[2,5]),Q=!0}return f(),l.getToken()!==2?W(7,[2],[]):O(),!0}function J(){p(),O();let Q=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(Q||W(4,[],[]),j(","),O(),l.getToken()===4&&N)break}else Q&&W(6,[],[]);le()||W(4,[],[4,5]),Q=!0}return k(),l.getToken()!==4?W(8,[4],[]):O(),!0}function le(){switch(l.getToken()){case 3:return J();case 1:return G();case 10:return x(!0);default:return ce()}}return O(),l.getToken()===17?d.allowEmptyContent?!0:(W(4,[],[]),!1):le()?(l.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$0m=n;function r(t,s){const d=L(t),l=[];let c,h=0,E;do switch(E=d.getPosition(),c=d.scan(),c){case 12:case 13:case 17:h!==E&&l.push(t.substring(h,E)),s!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,s)),h=d.getPosition();break}while(c!==17);return l.join("")}e.$$m=r;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=a}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(R){this.element=R,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let R=this.a;for(;R!==D.Undefined;){const L=R.next;R.prev=D.Undefined,R.next=D.Undefined,R=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const b=new D(R);if(this.a===D.Undefined)this.a=b,this.b=b;else if(L){const m=this.b;this.b=b,b.prev=m,m.next=b}else{const m=this.a;this.a=b,b.next=m,m.prev=b}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==D.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==D.Undefined&&R.next!==D.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===D.Undefined&&R.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):R.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):R.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==D.Undefined;)yield R.element,R=R.next}}e.$2c=T}),define(ke[28],Se([1,0]),function(me,e){"use strict";var D,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function R(i,n,r){let a=i.get(n);return a===void 0&&(a=r,i.set(n,a)),a}e.$wc=R;function L(i){const n=[];return i.forEach((r,a)=>{n.push(`${a} => ${r}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=L;function b(i){const n=[];return i.forEach(r=>{n.push(r)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=b;class y{constructor(n,r){this.uri=n,this.value=r}}function m(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,r){if(this[D]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=r??A.a;else if(m(n)){this.b=new Map,this.c=r??A.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??A.a}set(n,r){return this.b.set(this.c(n),new y(n,r)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,r){typeof r<"u"&&(n=n.bind(r));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=A;class C{constructor(n,r){this[T]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(r),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,r){this.a.forEach((a,t)=>n.call(r,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=C;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class v{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,r=0){const a=this.a.get(n);if(a)return r!==0&&this.j(a,r),a.value}set(n,r,a=0){let t=this.a.get(n);if(t)t.value=r,a!==0&&this.j(t,a);else{switch(t={key:n,value:r,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this.a.get(n);if(r)return this.a.delete(n),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,r){const a=this.e;let t=this.b;for(;t;){if(r?n.bind(r)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:a.key,done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}values(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:a.value,done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}entries(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:[a.key,a.value],done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.b,a=this.size;for(;r&&a>n;)this.a.delete(r.key),r=r.next,a--;this.b=r,this.d=a,r&&(r.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const r=n.next,a=n.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}n.next=void 0,n.previous=void 0,this.e++}j(n,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(r===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((r,a)=>{n.push([a,r])}),n}fromJSON(n){this.clear();for(const[r,a]of n)this.set(r,a)}}e.$Bc=v;class S extends v{constructor(n,r=1){super(),this.k=n,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=S;class w{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let r=this.a.get(n)||0;return r===0?!1:(r--,r===0?this.a.delete(n):this.a.set(n,r),!0)}has(n){return this.a.has(n)}}e.$Dc=w;class u{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[r,a]of n)this.set(r,a)}clear(){this.a.clear(),this.b.clear()}set(n,r){this.a.set(n,r),this.b.set(r,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const r=this.a.get(n);return r===void 0?!1:(this.a.delete(n),this.b.delete(r),!0)}forEach(n,r){this.a.forEach((a,t)=>{n.call(r,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=u;class o{constructor(){this.a=new Map}add(n,r){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(r)}delete(n,r){const a=this.a.get(n);a&&(a.delete(r),a.size===0&&this.a.delete(n))}forEach(n,r){const a=this.a.get(n);a&&a.forEach(r)}get(n){const r=this.a.get(n);return r||new Set}}e.$Fc=o}),define(ke[3],Se([1,0,19,73,28,74,51]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const b=!1;let y=null;class m{constructor(){this.b=new Map}static{this.a=0}c(P){let j=this.b.get(P);return j||(j={parent:null,source:null,isSingleton:!1,value:P,idx:m.a++},this.b.set(P,j)),j}trackDisposable(P){const j=this.c(P);j.source||(j.source=new Error().stack)}setParent(P,j){const z=this.c(P);z.parent=j}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,j){const z=j.get(P);if(z)return z;const M=P.parent?this.f(this.c(P.parent),j):P;return j.set(P,M),M}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,P).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(P=10,j){let z;if(j)z=j;else{const W=new Map,x=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,W).isSingleton);if(x.length===0)return;const ce=new Set(x.map(Y=>Y.value));if(z=x.filter(Y=>!(Y.parent&&ce.has(Y.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function M(W){function x(Y,G){for(;Y.length>0&&G.some(J=>typeof J=="string"?J===Y[0]:Y[0].match(J));)Y.shift()}const ce=W.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return x(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const F=new g.$Fc;for(const W of z){const x=M(W);for(let ce=0;ce<=x.length;ce++)F.add(x.slice(0,ce).join(`
`),W)}z.sort((0,D.$6b)(W=>W.idx,D.$8b));let N="",O=0;for(const W of z.slice(0,P)){O++;const x=M(W),ce=[];for(let Y=0;Y<x.length;Y++){let G=x[Y];G=`(shared with ${F.get(x.slice(0,Y+1).join(`
`)).size}/${z.length} leaks) at ${G}`;const le=F.get(x.slice(0,Y).join(`
`)),Q=(0,T.$J)([...le].map(Ee=>M(Ee)[Y]),Ee=>Ee);delete Q[x[Y]];for(const[Ee,he]of Object.entries(Q))ce.unshift(`    - stacktraces of ${he.length} other leaks continue with ${Ee}`);ce.unshift(G)}N+=`


==================== Leaking disposable ${O}/${z.length}: ${W.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return z.length>P&&(N+=`


... and ${z.length-P} more leaking disposables

`),{leaks:z,details:N}}}e.$Gc=m;function A(k){y=k}if(e.$Hc=A,b){const k="__is_disposable_tracked__";A(new class{trackDisposable(P){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(j)},3e3)}setParent(P,j){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function C(k){return y?.trackDisposable(k),k}e.$Ic=C;function $(k){y?.markAsDisposed(k)}e.$Jc=$;function v(k,P){y?.setParent(k,P)}function S(k,P){if(y)for(const j of k)y.setParent(j,P)}function w(k){return y?.markAsSingleton(k),k}e.$Kc=w;function u(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Lc=u;function o(k){if(L.Iterable.is(k)){const P=[];for(const j of k)if(j)try{j.dispose()}catch(z){P.push(z)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Mc=o;function i(k){for(const P of k)u(P)&&P.dispose();return[]}e.$Nc=i;function n(...k){const P=r(()=>o(k));return S(k,P),P}e.$Oc=n;function r(k){const P=C({dispose:(0,R.$cb)(()=>{$(P),k()})});return P}e.$Pc=r;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return v(P,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),v(P,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,C(this),v(this.q,this)}dispose(){$(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Rc=t;class s{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&v(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&v(P,null),P}}e.$Sc=s;class d{constructor(P){this.a=new s,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=d;class l{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let j=P;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,$(this))},this}}e.$Vc=c;class h{constructor(){this.a=new Map}acquire(P,...j){let z=this.a.get(P);z||(z={counter:0,object:this.b(P,...j)},this.a.set(P,z));const{object:M}=z,F=(0,R.$cb)(()=>{--z.counter===0&&(this.c(P,z.object),this.a.delete(P))});return z.counter++,{object:M,dispose:F}}}e.$Wc=h;class E{constructor(P){this.a=P}async acquire(P,...j){const z=this.a.acquire(P,...j);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(M){throw z.dispose(),M}}}e.$Xc=E;class I{constructor(P){this.object=P}dispose(){}}e.$Yc=I;function f(k){const P=new a;try{k(P)}finally{P.dispose()}}e.$Zc=f;class p{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,j,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(P)?.dispose(),this.a.set(P,j)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=p}),function(me,e){typeof define=="function"&&define.amd?define(ke[161],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(_,Z){for(var $e=0;$e<Z.length;$e++){var re=Z[$e];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(_,re.key,re)}}function D(_,Z,$e){return Z&&e(_.prototype,Z),$e&&e(_,$e),Object.defineProperty(_,"prototype",{writable:!1}),_}function T(_,Z){if(_){if(typeof _=="string")return g(_,Z);var $e=Object.prototype.toString.call(_).slice(8,-1);if($e==="Object"&&_.constructor&&($e=_.constructor.name),$e==="Map"||$e==="Set")return Array.from(_);if($e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($e))return g(_,Z)}}function g(_,Z){(Z==null||Z>_.length)&&(Z=_.length);for(var $e=0,re=new Array(Z);$e<Z;$e++)re[$e]=_[$e];return re}function R(_,Z){var $e=typeof Symbol<"u"&&_[Symbol.iterator]||_["@@iterator"];if($e)return($e=$e.call(_)).next.bind($e);if(Array.isArray(_)||($e=T(_))||Z&&_&&typeof _.length=="number"){$e&&(_=$e);var re=0;return function(){return re>=_.length?{done:!0}:{done:!1,value:_[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function b(_){me.defaults=_}var y=/[&<>"']/,m=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(Z){return $[Z]};function S(_,Z){if(Z){if(y.test(_))return _.replace(m,v)}else if(A.test(_))return _.replace(C,v);return _}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(_){return _.replace(w,function(Z,$e){return $e=$e.toLowerCase(),$e==="colon"?":":$e.charAt(0)==="#"?$e.charAt(1)==="x"?String.fromCharCode(parseInt($e.substring(2),16)):String.fromCharCode(+$e.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(_,Z){_=typeof _=="string"?_:_.source,Z=Z||"";var $e={replace:function(fe,te){return te=te.source||te,te=te.replace(o,"$1"),_=_.replace(fe,te),$e},getRegex:function(){return new RegExp(_,Z)}};return $e}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(_,Z,$e){if(_){var re;try{re=decodeURIComponent(u($e)).replace(n,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Z&&!r.test($e)&&($e=c(Z,$e));try{$e=encodeURI($e).replace(/%25/g,"%")}catch{return null}return $e}var t={},s=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(_,Z){t[" "+_]||(s.test(_)?t[" "+_]=_+"/":t[" "+_]=f(_,"/",!0)),_=t[" "+_];var $e=_.indexOf(":")===-1;return Z.substring(0,2)==="//"?$e?Z:_.replace(d,"$1")+Z:Z.charAt(0)==="/"?$e?Z:_.replace(l,"$1")+Z:_+Z}var h={exec:function(){}};function E(_){for(var Z=1,$e,re;Z<arguments.length;Z++){$e=arguments[Z];for(re in $e)Object.prototype.hasOwnProperty.call($e,re)&&(_[re]=$e[re])}return _}function I(_,Z){var $e=_.replace(/\|/g,function(te,de,pe){for(var Pe=!1,B=de;--B>=0&&pe[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),re=$e.split(/ \|/),fe=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>Z)re.splice(Z);else for(;re.length<Z;)re.push("");for(;fe<re.length;fe++)re[fe]=re[fe].trim().replace(/\\\|/g,"|");return re}function f(_,Z,$e){var re=_.length;if(re===0)return"";for(var fe=0;fe<re;){var te=_.charAt(re-fe-1);if(te===Z&&!$e)fe++;else if(te!==Z&&$e)fe++;else break}return _.slice(0,re-fe)}function p(_,Z){if(_.indexOf(Z[1])===-1)return-1;for(var $e=_.length,re=0,fe=0;fe<$e;fe++)if(_[fe]==="\\")fe++;else if(_[fe]===Z[0])re++;else if(_[fe]===Z[1]&&(re--,re<0))return fe;return-1}function k(_){_&&_.sanitize&&!_.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(_,Z){if(Z<1)return"";for(var $e="";Z>1;)Z&1&&($e+=_),Z>>=1,_+=_;return $e+_}function j(_,Z,$e,re){var fe=Z.href,te=Z.title?S(Z.title):null,de=_[1].replace(/\\([\[\]])/g,"$1");if(_[0].charAt(0)!=="!"){re.state.inLink=!0;var pe={type:"link",raw:$e,href:fe,title:te,text:de,tokens:re.inlineTokens(de)};return re.state.inLink=!1,pe}return{type:"image",raw:$e,href:fe,title:te,text:S(de)}}function z(_,Z){var $e=_.match(/^(\s+)(?:```)/);if($e===null)return Z;var re=$e[1];return Z.split(`
`).map(function(fe){var te=fe.match(/^\s+/);if(te===null)return fe;var de=te[0];return de.length>=re.length?fe.slice(re.length):fe}).join(`
`)}var M=function(){function _($e){this.options=$e||me.defaults}var Z=_.prototype;return Z.space=function(re){var fe=this.rules.block.newline.exec(re);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},Z.code=function(re){var fe=this.rules.block.code.exec(re);if(fe){var te=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?te:f(te,`
`)}}},Z.fences=function(re){var fe=this.rules.block.fences.exec(re);if(fe){var te=fe[0],de=z(te,fe[3]||"");return{type:"code",raw:te,lang:fe[2]?fe[2].trim():fe[2],text:de}}},Z.heading=function(re){var fe=this.rules.block.heading.exec(re);if(fe){var te=fe[2].trim();if(/#$/.test(te)){var de=f(te,"#");(this.options.pedantic||!de||/ $/.test(de))&&(te=de.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:te,tokens:this.lexer.inline(te)}}},Z.hr=function(re){var fe=this.rules.block.hr.exec(re);if(fe)return{type:"hr",raw:fe[0]}},Z.blockquote=function(re){var fe=this.rules.block.blockquote.exec(re);if(fe){var te=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},Z.list=function(re){var fe=this.rules.block.list.exec(re);if(fe){var te,de,pe,Pe,B,X,se,oe,ee,ge,ye,je,We=fe[1].trim(),et=We.length>1,Ye={type:"list",raw:"",ordered:et,start:et?+We.slice(0,-1):"",loose:!1,items:[]};We=et?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=et?We:"[*+-]");for(var rt=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(je=!1,!(!(fe=rt.exec(re))||this.rules.block.hr.test(re)));){if(te=fe[0],re=re.substring(te.length),oe=fe[2].split(`
`,1)[0],ee=re.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=oe.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=oe.slice(Pe),Pe+=fe[1].length),X=!1,!oe&&/^ *$/.test(ee)&&(te+=ee+`
`,re=re.substring(ee.length+1),je=!0),!je)for(var nt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");re&&(ge=re.split(`
`,1)[0],oe=ge,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(oe)||Ve.test(oe)||nt.test(oe)||Ae.test(re)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())ye+=`
`+oe.slice(Pe);else if(!X)ye+=`
`+oe;else break;!X&&!oe.trim()&&(X=!0),te+=ge+`
`,re=re.substring(ge.length+1)}Ye.loose||(se?Ye.loose=!0:/\n *\n *$/.test(te)&&(se=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(ye),de&&(pe=de[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:te,task:!!de,checked:pe,loose:!1,text:ye}),Ye.raw+=te}Ye.items[Ye.items.length-1].raw=te.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Ze=Ye.items[B].tokens.filter(function(ae){return ae.type==="space"}),ue=Ze.every(function(ae){for(var Ie=ae.raw.split(""),Ke=0,Ge=R(Ie),_e;!(_e=Ge()).done;){var st=_e.value;if(st===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ye.loose&&Ze.length&&ue&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},Z.html=function(re){var fe=this.rules.block.html.exec(re);if(fe){var te={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]);te.type="paragraph",te.text=de,te.tokens=this.lexer.inline(de)}return te}},Z.def=function(re){var fe=this.rules.block.def.exec(re);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var te=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:fe[0],href:fe[2],title:fe[3]}}},Z.table=function(re){var fe=this.rules.block.table.exec(re);if(fe){var te={type:"table",header:I(fe[1]).map(function(se){return{text:se}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=fe[0];var de=te.align.length,pe,Pe,B,X;for(pe=0;pe<de;pe++)/^ *-+: *$/.test(te.align[pe])?te.align[pe]="right":/^ *:-+: *$/.test(te.align[pe])?te.align[pe]="center":/^ *:-+ *$/.test(te.align[pe])?te.align[pe]="left":te.align[pe]=null;for(de=te.rows.length,pe=0;pe<de;pe++)te.rows[pe]=I(te.rows[pe],te.header.length).map(function(se){return{text:se}});for(de=te.header.length,Pe=0;Pe<de;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(de=te.rows.length,Pe=0;Pe<de;Pe++)for(X=te.rows[Pe],B=0;B<X.length;B++)X[B].tokens=this.lexer.inline(X[B].text);return te}}},Z.lheading=function(re){var fe=this.rules.block.lheading.exec(re);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},Z.paragraph=function(re){var fe=this.rules.block.paragraph.exec(re);if(fe){var te=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:te,tokens:this.lexer.inline(te)}}},Z.text=function(re){var fe=this.rules.block.text.exec(re);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},Z.escape=function(re){var fe=this.rules.inline.escape.exec(re);if(fe)return{type:"escape",raw:fe[0],text:S(fe[1])}},Z.tag=function(re){var fe=this.rules.inline.tag.exec(re);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]}},Z.link=function(re){var fe=this.rules.inline.link.exec(re);if(fe){var te=fe[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var de=f(te.slice(0,-1),"\\");if((te.length-de.length)%2===0)return}else{var pe=p(fe[2],"()");if(pe>-1){var Pe=fe[0].indexOf("!")===0?5:4,B=Pe+fe[1].length+pe;fe[2]=fe[2].substring(0,pe),fe[0]=fe[0].substring(0,B).trim(),fe[3]=""}}var X=fe[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);oe&&(X=oe[1],se=oe[3])}else se=fe[3]?fe[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(te)?X=X.slice(1):X=X.slice(1,-1)),j(fe,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},Z.reflink=function(re,fe){var te;if((te=this.rules.inline.reflink.exec(re))||(te=this.rules.inline.nolink.exec(re))){var de=(te[2]||te[1]).replace(/\s+/g," ");if(de=fe[de.toLowerCase()],!de||!de.href){var pe=te[0].charAt(0);return{type:"text",raw:pe,text:pe}}return j(te,de,te[0],this.lexer)}},Z.emStrong=function(re,fe,te){te===void 0&&(te="");var de=this.rules.inline.emStrong.lDelim.exec(re);if(de&&!(de[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=de[1]||de[2]||"";if(!pe||pe&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=de[0].length-1,B,X,se=Pe,oe=0,ee=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,fe=fe.slice(-1*re.length+Pe);(de=ee.exec(fe))!=null;)if(B=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!B){if(X=B.length,de[3]||de[4]){se+=X;continue}else if((de[5]||de[6])&&Pe%3&&!((Pe+X)%3)){oe+=X;continue}if(se-=X,!(se>0)){if(X=Math.min(X,X+se+oe),Math.min(Pe,X)%2){var ge=re.slice(1,Pe+de.index+X);return{type:"em",raw:re.slice(0,Pe+de.index+X+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var ye=re.slice(2,Pe+de.index+X-1);return{type:"strong",raw:re.slice(0,Pe+de.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},Z.codespan=function(re){var fe=this.rules.inline.code.exec(re);if(fe){var te=fe[2].replace(/\n/g," "),de=/[^ ]/.test(te),pe=/^ /.test(te)&&/ $/.test(te);return de&&pe&&(te=te.substring(1,te.length-1)),te=S(te,!0),{type:"codespan",raw:fe[0],text:te}}},Z.br=function(re){var fe=this.rules.inline.br.exec(re);if(fe)return{type:"br",raw:fe[0]}},Z.del=function(re){var fe=this.rules.inline.del.exec(re);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},Z.autolink=function(re,fe){var te=this.rules.inline.autolink.exec(re);if(te){var de,pe;return te[2]==="@"?(de=S(this.options.mangle?fe(te[1]):te[1]),pe="mailto:"+de):(de=S(te[1]),pe=de),{type:"link",raw:te[0],text:de,href:pe,tokens:[{type:"text",raw:de,text:de}]}}},Z.url=function(re,fe){var te;if(te=this.rules.inline.url.exec(re)){var de,pe;if(te[2]==="@")de=S(this.options.mangle?fe(te[0]):te[0]),pe="mailto:"+de;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);de=S(te[0]),te[1]==="www."?pe="http://"+de:pe=de}return{type:"link",raw:te[0],text:de,href:pe,tokens:[{type:"text",raw:de,text:de}]}}},Z.inlineText=function(re,fe){var te=this.rules.inline.text.exec(re);if(te){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]):te[0]:de=S(this.options.smartypants?fe(te[0]):te[0]),{type:"text",raw:te[0],text:de}}},_}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=i(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=i(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=i(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=i(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=i(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=E({},F),F.gfm=E({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=i(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=E({},F.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(F._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",F._label).getRegex(),N.nolink=i(N.nolink).replace("ref",F._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=E({},N),N.pedantic=E({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=E({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=E({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(_){return _.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(_){var Z="",$e,re,fe=_.length;for($e=0;$e<fe;$e++)re=_.charCodeAt($e),Math.random()>.5&&(re="x"+re.toString(16)),Z+="&#"+re+";";return Z}var x=function(){function _($e){this.tokens=[],this.tokens.links=Object.create(null),this.options=$e||me.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:F.normal,inline:N.normal};this.options.pedantic?(re.block=F.pedantic,re.inline=N.pedantic):this.options.gfm&&(re.block=F.gfm,this.options.breaks?re.inline=N.breaks:re.inline=N.gfm),this.tokenizer.rules=re}_.lex=function(re,fe){var te=new _(fe);return te.lex(re)},_.lexInline=function(re,fe){var te=new _(fe);return te.inlineTokens(re)};var Z=_.prototype;return Z.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},Z.blockTokens=function(re,fe){var te=this;fe===void 0&&(fe=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(se,oe,ee){return oe+"    ".repeat(ee.length)});for(var de,pe,Pe,B;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(de=se.call({lexer:te},re,fe))?(re=re.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.space(re)){re=re.substring(de.raw.length),de.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(de);continue}if(de=this.tokenizer.code(re)){re=re.substring(de.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de);continue}if(de=this.tokenizer.fences(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.heading(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.hr(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.blockquote(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.list(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.html(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.def(re)){re=re.substring(de.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.lheading(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(Pe=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=re.slice(1),ee=void 0;te.options.extensions.startBlock.forEach(function(ge){ee=ge.call({lexer:this},oe),typeof ee=="number"&&ee>=0&&(se=Math.min(se,ee))}),se<1/0&&se>=0&&(Pe=re.substring(0,se+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Pe))){pe=fe[fe.length-1],B&&pe.type==="paragraph"?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de),B=Pe.length!==re.length,re=re.substring(de.raw.length);continue}if(de=this.tokenizer.text(re)){re=re.substring(de.raw.length),pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de);continue}if(re){var X="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,fe},Z.inline=function(re,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:re,tokens:fe}),fe},Z.inlineTokens=function(re,fe){var te=this;fe===void 0&&(fe=[]);var de,pe,Pe,B=re,X,se,oe;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)ee.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,X.index)+"["+P("a",X[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,X.index)+"["+P("a",X[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,X.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(de=ye.call({lexer:te},re,fe))?(re=re.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.escape(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.tag(re)){re=re.substring(de.raw.length),pe=fe[fe.length-1],pe&&de.type==="text"&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.link(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(de.raw.length),pe=fe[fe.length-1],pe&&de.type==="text"&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.emStrong(re,B,oe)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.codespan(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.br(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.del(re)){re=re.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.autolink(re,W)){re=re.substring(de.raw.length),fe.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(re,W))){re=re.substring(de.raw.length),fe.push(de);continue}if(Pe=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=re.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(et){We=et.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=re.substring(0,ye+1))}(),de=this.tokenizer.inlineText(Pe,O)){re=re.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(oe=de.raw.slice(-1)),se=!0,pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return fe},D(_,null,[{key:"rules",get:function(){return{block:F,inline:N}}}]),_}(),ce=function(){function _($e){this.options=$e||me.defaults}var Z=_.prototype;return Z.code=function(re,fe,te){var de=(fe||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(re,de);pe!=null&&pe!==re&&(te=!0,re=pe)}return re=re.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+S(de,!0)+'">'+(te?re:S(re,!0))+`</code></pre>
`:"<pre><code>"+(te?re:S(re,!0))+`</code></pre>
`},Z.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Z.html=function(re){return re},Z.heading=function(re,fe,te,de){if(this.options.headerIds){var pe=this.options.headerPrefix+de.slug(te);return"<h"+fe+' id="'+pe+'">'+re+"</h"+fe+`>
`}return"<h"+fe+">"+re+"</h"+fe+`>
`},Z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Z.list=function(re,fe,te){var de=fe?"ol":"ul",pe=fe&&te!==1?' start="'+te+'"':"";return"<"+de+pe+`>
`+re+"</"+de+`>
`},Z.listitem=function(re){return"<li>"+re+`</li>
`},Z.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Z.paragraph=function(re){return"<p>"+re+`</p>
`},Z.table=function(re,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+fe+`</table>
`},Z.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Z.tablecell=function(re,fe){var te=fe.header?"th":"td",de=fe.align?"<"+te+' align="'+fe.align+'">':"<"+te+">";return de+re+("</"+te+`>
`)},Z.strong=function(re){return"<strong>"+re+"</strong>"},Z.em=function(re){return"<em>"+re+"</em>"},Z.codespan=function(re){return"<code>"+re+"</code>"},Z.br=function(){return this.options.xhtml?"<br/>":"<br>"},Z.del=function(re){return"<del>"+re+"</del>"},Z.link=function(re,fe,te){if(re=a(this.options.sanitize,this.options.baseUrl,re),re===null)return te;var de='<a href="'+S(re)+'"';return fe&&(de+=' title="'+fe+'"'),de+=">"+te+"</a>",de},Z.image=function(re,fe,te){if(re=a(this.options.sanitize,this.options.baseUrl,re),re===null)return te;var de='<img src="'+re+'" alt="'+te+'"';return fe&&(de+=' title="'+fe+'"'),de+=this.options.xhtml?"/>":">",de},Z.text=function(re){return re},_}(),Y=function(){function _(){}var Z=_.prototype;return Z.strong=function(re){return re},Z.em=function(re){return re},Z.codespan=function(re){return re},Z.del=function(re){return re},Z.html=function(re){return re},Z.text=function(re){return re},Z.link=function(re,fe,te){return""+te},Z.image=function(re,fe,te){return""+te},Z.br=function(){return""},_}(),G=function(){function _(){this.seen={}}var Z=_.prototype;return Z.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Z.getNextSafeSlug=function(re,fe){var te=re,de=0;if(this.seen.hasOwnProperty(te)){de=this.seen[re];do de++,te=re+"-"+de;while(this.seen.hasOwnProperty(te))}return fe||(this.seen[re]=de,this.seen[te]=0),te},Z.slug=function(re,fe){fe===void 0&&(fe={});var te=this.serialize(re);return this.getNextSafeSlug(te,fe.dryrun)},_}(),J=function(){function _($e){this.options=$e||me.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new G}_.parse=function(re,fe){var te=new _(fe);return te.parse(re)},_.parseInline=function(re,fe){var te=new _(fe);return te.parseInline(re)};var Z=_.prototype;return Z.parse=function(re,fe){fe===void 0&&(fe=!0);var te="",de,pe,Pe,B,X,se,oe,ee,ge,ye,je,We,et,Ye,rt,nt,Ae,Oe,Ve,Le=re.length;for(de=0;de<Le;de++){if(ye=re[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){te+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,u(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ee="",oe="",B=ye.header.length,pe=0;pe<B;pe++)oe+=this.renderer.tablecell(this.parseInline(ye.header[pe].tokens),{header:!0,align:ye.align[pe]});for(ee+=this.renderer.tablerow(oe),ge="",B=ye.rows.length,pe=0;pe<B;pe++){for(se=ye.rows[pe],oe="",X=se.length,Pe=0;Pe<X;Pe++)oe+=this.renderer.tablecell(this.parseInline(se[Pe].tokens),{header:!1,align:ye.align[Pe]});ge+=this.renderer.tablerow(oe)}te+=this.renderer.table(ee,ge);continue}case"blockquote":{ge=this.parse(ye.tokens),te+=this.renderer.blockquote(ge);continue}case"list":{for(je=ye.ordered,We=ye.start,et=ye.loose,B=ye.items.length,ge="",pe=0;pe<B;pe++)rt=ye.items[pe],nt=rt.checked,Ae=rt.task,Ye="",rt.task&&(Oe=this.renderer.checkbox(nt),et?rt.tokens.length>0&&rt.tokens[0].type==="paragraph"?(rt.tokens[0].text=Oe+" "+rt.tokens[0].text,rt.tokens[0].tokens&&rt.tokens[0].tokens.length>0&&rt.tokens[0].tokens[0].type==="text"&&(rt.tokens[0].tokens[0].text=Oe+" "+rt.tokens[0].tokens[0].text)):rt.tokens.unshift({type:"text",text:Oe}):Ye+=Oe),Ye+=this.parse(rt.tokens,et),ge+=this.renderer.listitem(Ye,Ae,nt);te+=this.renderer.list(ge,je,We);continue}case"html":{te+=this.renderer.html(ye.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ge=ye.tokens?this.parseInline(ye.tokens):ye.text;de+1<Le&&re[de+1].type==="text";)ye=re[++de],ge+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);te+=fe?this.renderer.paragraph(ge):ge;continue}default:{var Ze='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return te},Z.parseInline=function(re,fe){fe=fe||this.renderer;var te="",de,pe,Pe,B=re.length;for(de=0;de<B;de++){if(pe=re[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Pe=this.options.extensions.renderers[pe.type].call({parser:this},pe),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(pe.type))){te+=Pe||"";continue}switch(pe.type){case"escape":{te+=fe.text(pe.text);break}case"html":{te+=fe.html(pe.text);break}case"link":{te+=fe.link(pe.href,pe.title,this.parseInline(pe.tokens,fe));break}case"image":{te+=fe.image(pe.href,pe.title,pe.text);break}case"strong":{te+=fe.strong(this.parseInline(pe.tokens,fe));break}case"em":{te+=fe.em(this.parseInline(pe.tokens,fe));break}case"codespan":{te+=fe.codespan(pe.text);break}case"br":{te+=fe.br();break}case"del":{te+=fe.del(this.parseInline(pe.tokens,fe));break}case"text":{te+=fe.text(pe.text);break}default:{var X='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return te},_}();function le(_,Z,$e){if(typeof _>"u"||_===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");if(typeof Z=="function"&&($e=Z,Z=null),Z=E({},le.defaults,Z||{}),k(Z),$e){var re=Z.highlight,fe;try{fe=x.lex(_,Z)}catch(B){return $e(B)}var te=function(X){var se;if(!X)try{Z.walkTokens&&le.walkTokens(fe,Z.walkTokens),se=J.parse(fe,Z)}catch(oe){X=oe}return Z.highlight=re,X?$e(X):$e(null,se)};if(!re||re.length<3||(delete Z.highlight,!fe.length))return te();var de=0;le.walkTokens(fe,function(B){B.type==="code"&&(de++,setTimeout(function(){re(B.text,B.lang,function(X,se){if(X)return te(X);se!=null&&se!==B.text&&(B.text=se,B.escaped=!0),de--,de===0&&te()})},0))}),de===0&&te();return}function pe(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+S(B.message+"",!0)+"</pre>";throw B}try{var Pe=x.lex(_,Z);if(Z.walkTokens){if(Z.async)return Promise.all(le.walkTokens(Pe,Z.walkTokens)).then(function(){return J.parse(Pe,Z)}).catch(pe);le.walkTokens(Pe,Z.walkTokens)}return J.parse(Pe,Z)}catch(B){pe(B)}}le.options=le.setOptions=function(_){return E(le.defaults,_),b(le.defaults),le},le.getDefaults=L,le.defaults=me.defaults,le.use=function(){for(var _=arguments.length,Z=new Array(_),$e=0;$e<_;$e++)Z[$e]=arguments[$e];var re=E.apply(void 0,[{}].concat(Z)),fe=le.defaults.extensions||{renderers:{},childTokens:{}},te;Z.forEach(function(de){if(de.extensions&&(te=!0,de.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=fe.renderers?fe.renderers[Pe.name]:null;B?fe.renderers[Pe.name]=function(){for(var X=arguments.length,se=new Array(X),oe=0;oe<X;oe++)se[oe]=arguments[oe];var ee=Pe.renderer.apply(this,se);return ee===!1&&(ee=B.apply(this,se)),ee}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),de.renderer&&function(){var Pe=le.defaults.renderer||new ce,B=function(oe){var ee=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=de.renderer[oe].apply(Pe,ye);return We===!1&&(We=ee.apply(Pe,ye)),We}};for(var X in de.renderer)B(X);re.renderer=Pe}(),de.tokenizer&&function(){var Pe=le.defaults.tokenizer||new M,B=function(oe){var ee=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=de.tokenizer[oe].apply(Pe,ye);return We===!1&&(We=ee.apply(Pe,ye)),We}};for(var X in de.tokenizer)B(X);re.tokenizer=Pe}(),de.walkTokens){var pe=le.defaults.walkTokens;re.walkTokens=function(Pe){var B=[];return B.push(de.walkTokens.call(this,Pe)),pe&&(B=B.concat(pe.call(this,Pe))),B}}te&&(re.extensions=fe),le.setOptions(re)})},le.walkTokens=function(_,Z){for(var $e=[],re=function(){var pe=te.value;switch($e=$e.concat(Z.call(le,pe)),pe.type){case"table":{for(var Pe=R(pe.header),B;!(B=Pe()).done;){var X=B.value;$e=$e.concat(le.walkTokens(X.tokens,Z))}for(var se=R(pe.rows),oe;!(oe=se()).done;)for(var ee=oe.value,ge=R(ee),ye;!(ye=ge()).done;){var je=ye.value;$e=$e.concat(le.walkTokens(je.tokens,Z))}break}case"list":{$e=$e.concat(le.walkTokens(pe.items,Z));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[pe.type]?le.defaults.extensions.childTokens[pe.type].forEach(function(We){$e=$e.concat(le.walkTokens(pe[We],Z))}):pe.tokens&&($e=$e.concat(le.walkTokens(pe.tokens,Z)))}},fe=R(_),te;!(te=fe()).done;)re();return $e},le.parseInline=function(_,Z){if(typeof _>"u"||_===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");Z=E({},le.defaults,Z||{}),k(Z);try{var $e=x.lexInline(_,Z);return Z.walkTokens&&le.walkTokens($e,Z.walkTokens),J.parseInline($e,Z)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+S(re.message+"",!0)+"</pre>";throw re}},le.Parser=J,le.parser=J.parse,le.Renderer=ce,le.TextRenderer=Y,le.Lexer=x,le.lexer=x.lex,le.Tokenizer=M,le.Slugger=G,le.parse=le;var Q=le.options,Ee=le.setOptions,he=le.use,K=le.walkTokens,U=le.parseInline,ie=le,be=J.parse,H=x.lex;me.Lexer=x,me.Parser=J,me.Renderer=ce,me.Slugger=G,me.TextRenderer=Y,me.Tokenizer=M,me.getDefaults=L,me.lexer=H,me.marked=le,me.options=Q,me.parse=ie,me.parseInline=U,me.parser=be,me.setOptions=Ee,me.use=he,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[76],Se([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.$ul=void 0;const T=new D.$Cc(1e4);function g(m){return y(m,"NFC",T)}e.$ul=g;const R=new D.$Cc(1e4);function L(m){return y(m,"NFD",R)}e.$vl=L;const b=/[^\u0000-\u0080]/;function y(m,A,C){if(!m)return m;const $=C.get(m);if($)return $;let v;return b.test(m)?v=m.normalize(A):v=m,C.set(m,v),v}e.$wl=function(){const m=/[\u0300-\u036f]/g;return function(A){return L(A).replace(m,"")}}()}),define(ke[123],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function D(b,y,m){return Math.min(Math.max(b,y),m)}e.$Ul=D;function T(b,y){return(y+b%y)%y}e.rot=T;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=g;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=R;class L{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const m=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=L}),function(){function me(g){const R=[];typeof g=="number"&&R.push("code/timeOrigin",g);function L(y){R.push(y,Date.now())}function b(){const y=[];for(let m=0;m<R.length;m+=2)y.push({name:R[m],startTime:R[m+1]});return y}return{mark:L,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(g+L.startTime)});return R}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:me)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(T){if(e[T])return e[T].exports;var g=e[T]={i:T,l:!1,exports:{}};return me[T].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(T,g,R){D.o(T,g)||Object.defineProperty(T,g,{enumerable:!0,get:R})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,g){if(1&g&&(T=D(T)),8&g||4&g&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&g&&typeof T!="string")for(var L in T)D.d(R,L,function(b){return T[b]}.bind(null,L));return R},D.n=function(T){var g=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(g,"a",g),g},D.o=function(T,g){return Object.prototype.hasOwnProperty.call(T,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(T){var g;e=me.exports=he,g=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],y=e.src=[],m=0,A=m++;y[A]="0|[1-9]\\d*";var C=m++;y[C]="[0-9]+";var $=m++;y[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=m++;y[v]="("+y[A]+")\\.("+y[A]+")\\.("+y[A]+")";var S=m++;y[S]="("+y[C]+")\\.("+y[C]+")\\.("+y[C]+")";var w=m++;y[w]="(?:"+y[A]+"|"+y[$]+")";var u=m++;y[u]="(?:"+y[C]+"|"+y[$]+")";var o=m++;y[o]="(?:-("+y[w]+"(?:\\."+y[w]+")*))";var i=m++;y[i]="(?:-?("+y[u]+"(?:\\."+y[u]+")*))";var n=m++;y[n]="[0-9A-Za-z-]+";var r=m++;y[r]="(?:\\+("+y[n]+"(?:\\."+y[n]+")*))";var a=m++,t="v?"+y[v]+y[o]+"?"+y[r]+"?";y[a]="^"+t+"$";var s="[v=\\s]*"+y[S]+y[i]+"?"+y[r]+"?",d=m++;y[d]="^"+s+"$";var l=m++;y[l]="((?:<|>)?=?)";var c=m++;y[c]=y[C]+"|x|X|\\*";var h=m++;y[h]=y[A]+"|x|X|\\*";var E=m++;y[E]="[v=\\s]*("+y[h]+")(?:\\.("+y[h]+")(?:\\.("+y[h]+")(?:"+y[o]+")?"+y[r]+"?)?)?";var I=m++;y[I]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[i]+")?"+y[r]+"?)?)?";var f=m++;y[f]="^"+y[l]+"\\s*"+y[E]+"$";var p=m++;y[p]="^"+y[l]+"\\s*"+y[I]+"$";var k=m++;y[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=m++;y[P]="(?:~>?)";var j=m++;y[j]="(\\s*)"+y[P]+"\\s+",b[j]=new RegExp(y[j],"g");var z=m++;y[z]="^"+y[P]+y[E]+"$";var M=m++;y[M]="^"+y[P]+y[I]+"$";var F=m++;y[F]="(?:\\^)";var N=m++;y[N]="(\\s*)"+y[F]+"\\s+",b[N]=new RegExp(y[N],"g");var O=m++;y[O]="^"+y[F]+y[E]+"$";var W=m++;y[W]="^"+y[F]+y[I]+"$";var x=m++;y[x]="^"+y[l]+"\\s*("+s+")$|^$";var ce=m++;y[ce]="^"+y[l]+"\\s*("+t+")$|^$";var Y=m++;y[Y]="(\\s*)"+y[l]+"\\s*("+s+"|"+y[E]+")",b[Y]=new RegExp(y[Y],"g");var G=m++;y[G]="^\\s*("+y[E]+")\\s+-\\s+("+y[E]+")\\s*$";var J=m++;y[J]="^\\s*("+y[I]+")\\s+-\\s+("+y[I]+")\\s*$";var le=m++;y[le]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)g(Q,y[Q]),b[Q]||(b[Q]=new RegExp(y[Q]));function Ee(ee,ge){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>R||!(ge?b[d]:b[a]).test(ee))return null;try{return new he(ee,ge)}catch{return null}}function he(ee,ge){if(ee instanceof he){if(ee.loose===ge)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof he))return new he(ee,ge);g("SemVer",ee,ge),this.loose=ge;var ye=ee.trim().match(ge?b[d]:b[a]);if(!ye)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<L)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=Ee,e.valid=function(ee,ge){var ye=Ee(ee,ge);return ye?ye.version:null},e.clean=function(ee,ge){var ye=Ee(ee.trim().replace(/^[=v]+/,""),ge);return ye?ye.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return g("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),U(this.major,ee.major)||U(this.minor,ee.minor)||U(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ge=0;do{var ye=this.prerelease[ge],je=ee.prerelease[ge];if(g("prerelease compare",ge,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++ge)},he.prototype.inc=function(ee,ge){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ge,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new he(ee,ye).inc(ge,je).version}catch{return null}},e.diff=function(ee,ge){if(_(ee,ge))return null;var ye=Ee(ee),je=Ee(ge);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var K=/^[0-9]+$/;function U(ee,ge){var ye=K.test(ee),je=K.test(ge);return ye&&je&&(ee=+ee,ge=+ge),ye&&!je?-1:je&&!ye?1:ee<ge?-1:ee>ge?1:0}function ie(ee,ge,ye){return new he(ee,ye).compare(new he(ge,ye))}function be(ee,ge,ye){return ie(ee,ge,ye)>0}function H(ee,ge,ye){return ie(ee,ge,ye)<0}function _(ee,ge,ye){return ie(ee,ge,ye)===0}function Z(ee,ge,ye){return ie(ee,ge,ye)!==0}function $e(ee,ge,ye){return ie(ee,ge,ye)>=0}function re(ee,ge,ye){return ie(ee,ge,ye)<=0}function fe(ee,ge,ye,je){var We;switch(ge){case"===":typeof ee=="object"&&(ee=ee.version),typeof ye=="object"&&(ye=ye.version),We=ee===ye;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ye=="object"&&(ye=ye.version),We=ee!==ye;break;case"":case"=":case"==":We=_(ee,ye,je);break;case"!=":We=Z(ee,ye,je);break;case">":We=be(ee,ye,je);break;case">=":We=$e(ee,ye,je);break;case"<":We=H(ee,ye,je);break;case"<=":We=re(ee,ye,je);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function te(ee,ge){if(ee instanceof te){if(ee.loose===ge)return ee;ee=ee.value}if(!(this instanceof te))return new te(ee,ge);g("comparator",ee,ge),this.loose=ge,this.parse(ee),this.semver===de?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(ee,ge){return U(ge,ee)},e.major=function(ee,ge){return new he(ee,ge).major},e.minor=function(ee,ge){return new he(ee,ge).minor},e.patch=function(ee,ge){return new he(ee,ge).patch},e.compare=ie,e.compareLoose=function(ee,ge){return ie(ee,ge,!0)},e.rcompare=function(ee,ge,ye){return ie(ge,ee,ye)},e.sort=function(ee,ge){return ee.sort(function(ye,je){return e.compare(ye,je,ge)})},e.rsort=function(ee,ge){return ee.sort(function(ye,je){return e.rcompare(ye,je,ge)})},e.gt=be,e.lt=H,e.eq=_,e.neq=Z,e.gte=$e,e.lte=re,e.cmp=fe,e.Comparator=te;var de={};function pe(ee,ge){if(ee instanceof pe)return ee.loose===ge?ee:new pe(ee.raw,ge);if(ee instanceof te)return new pe(ee.value,ge);if(!(this instanceof pe))return new pe(ee,ge);if(this.loose=ge,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Pe(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function B(ee,ge,ye,je,We,et,Ye,rt,nt,Ae,Oe,Ve,Le){return((ge=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+ge)+" "+(rt=Pe(nt)?"":Pe(Ae)?"<"+(+nt+1)+".0.0":Pe(Oe)?"<"+nt+"."+(+Ae+1)+".0":Ve?"<="+nt+"."+Ae+"."+Oe+"-"+Ve:"<="+rt)).trim()}function X(ee,ge){for(var ye=0;ye<ee.length;ye++)if(!ee[ye].test(ge))return!1;if(ge.prerelease.length){for(ye=0;ye<ee.length;ye++)if(g(ee[ye].semver),ee[ye].semver!==de&&ee[ye].semver.prerelease.length>0){var je=ee[ye].semver;if(je.major===ge.major&&je.minor===ge.minor&&je.patch===ge.patch)return!0}return!1}return!0}function se(ee,ge,ye){try{ge=new pe(ge,ye)}catch{return!1}return ge.test(ee)}function oe(ee,ge,ye,je){var We,et,Ye,rt,nt;switch(ee=new he(ee,je),ge=new pe(ge,je),ye){case">":We=be,et=re,Ye=H,rt=">",nt=">=";break;case"<":We=H,et=$e,Ye=be,rt="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(ee,ge,je))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Oe=ge.set[Ae],Ve=null,Le=null;if(Oe.forEach(function(Ze){Ze.semver===de&&(Ze=new te(">=0.0.0")),Ve=Ve||Ze,Le=Le||Ze,We(Ze.semver,Ve.semver,je)?Ve=Ze:Ye(Ze.semver,Le.semver,je)&&(Le=Ze)}),Ve.operator===rt||Ve.operator===nt||(!Le.operator||Le.operator===rt)&&et(ee,Le.semver)||Le.operator===nt&&Ye(ee,Le.semver))return!1}return!0}te.prototype.parse=function(ee){var ge=this.loose?b[x]:b[ce],ye=ee.match(ge);if(!ye)throw new TypeError("Invalid comparator: "+ee);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new he(ye[2],this.loose):this.semver=de},te.prototype.toString=function(){return this.value},te.prototype.test=function(ee){return g("Comparator.test",ee,this.loose),this.semver===de||(typeof ee=="string"&&(ee=new he(ee,this.loose)),fe(ee,this.operator,this.semver,this.loose))},te.prototype.intersects=function(ee,ge){if(!(ee instanceof te))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new pe(ee.value,ge),se(this.value,ye,ge);if(ee.operator==="")return ye=new pe(this.value,ge),se(ee.semver,ye,ge);var je=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),et=this.semver.version===ee.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),rt=fe(this.semver,"<",ee.semver,ge)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),nt=fe(this.semver,">",ee.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return je||We||et&&Ye||rt||nt},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(ee){var ge=this.loose;ee=ee.trim(),g("range",ee,ge);var ye=ge?b[J]:b[G];ee=ee.replace(ye,B),g("hyphen replace",ee),ee=ee.replace(b[Y],"$1$2$3"),g("comparator trim",ee,b[Y]),ee=(ee=(ee=ee.replace(b[j],"$1~")).replace(b[N],"$1^")).split(/\s+/).join(" ");var je=ge?b[x]:b[ce],We=ee.split(" ").map(function(et){return function(Ye,rt){return g("comp",Ye),Ye=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){g("caret",Ve,Le);var Ze=Le?b[W]:b[O];return Ve.replace(Ze,function(ue,ae,Ie,Ke,Ge){var _e;return g("caret",Ve,ue,ae,Ie,Ke,Ge),Pe(ae)?_e="":Pe(Ie)?_e=">="+ae+".0.0 <"+(+ae+1)+".0.0":Pe(Ke)?_e=ae==="0"?">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+".0 <"+(+ae+1)+".0.0":Ge?(g("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=ae==="0"?Ie==="0"?">="+ae+"."+Ie+"."+Ke+Ge+" <"+ae+"."+Ie+"."+(+Ke+1):">="+ae+"."+Ie+"."+Ke+Ge+" <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+"."+Ke+Ge+" <"+(+ae+1)+".0.0"):(g("no pr"),_e=ae==="0"?Ie==="0"?">="+ae+"."+Ie+"."+Ke+" <"+ae+"."+Ie+"."+(+Ke+1):">="+ae+"."+Ie+"."+Ke+" <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+"."+Ke+" <"+(+ae+1)+".0.0"),g("caret return",_e),_e})}(Oe,Ae)}).join(" ")}(Ye,rt),g("caret",Ye),Ye=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){var Ze=Le?b[M]:b[z];return Ve.replace(Ze,function(ue,ae,Ie,Ke,Ge){var _e;return g("tilde",Ve,ue,ae,Ie,Ke,Ge),Pe(ae)?_e="":Pe(Ie)?_e=">="+ae+".0.0 <"+(+ae+1)+".0.0":Pe(Ke)?_e=">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0":Ge?(g("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=">="+ae+"."+Ie+"."+Ke+Ge+" <"+ae+"."+(+Ie+1)+".0"):_e=">="+ae+"."+Ie+"."+Ke+" <"+ae+"."+(+Ie+1)+".0",g("tilde return",_e),_e})}(Oe,Ae)}).join(" ")}(Ye,rt),g("tildes",Ye),Ye=function(nt,Ae){return g("replaceXRanges",nt,Ae),nt.split(/\s+/).map(function(Oe){return function(Ve,Le){Ve=Ve.trim();var Ze=Le?b[p]:b[f];return Ve.replace(Ze,function(ue,ae,Ie,Ke,Ge,_e){g("xRange",Ve,ue,ae,Ie,Ke,Ge,_e);var st=Pe(Ie),lt=st||Pe(Ke),wt=lt||Pe(Ge);return ae==="="&&wt&&(ae=""),st?ue=ae===">"||ae==="<"?"<0.0.0":"*":ae&&wt?(lt&&(Ke=0),wt&&(Ge=0),ae===">"?(ae=">=",lt?(Ie=+Ie+1,Ke=0,Ge=0):wt&&(Ke=+Ke+1,Ge=0)):ae==="<="&&(ae="<",lt?Ie=+Ie+1:Ke=+Ke+1),ue=ae+Ie+"."+Ke+"."+Ge):lt?ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":wt&&(ue=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),g("xRange return",ue),ue})}(Oe,Ae)}).join(" ")}(Ye,rt),g("xrange",Ye),Ye=function(nt,Ae){return g("replaceStars",nt,Ae),nt.trim().replace(b[le],"")}(Ye,rt),g("stars",Ye),Ye}(et,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(et){return!!et.match(je)})),We=We.map(function(et){return new te(et,ge)})},pe.prototype.intersects=function(ee,ge){if(!(ee instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return ee.set.some(function(We){return We.every(function(et){return je.intersects(et,ge)})})})})},e.toComparators=function(ee,ge){return new pe(ee,ge).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var ge=0;ge<this.set.length;ge++)if(X(this.set[ge],ee))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(ee,ge,ye){var je=null,We=null;try{var et=new pe(ge,ye)}catch{return null}return ee.forEach(function(Ye){et.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new he(je=Ye,ye)))}),je},e.minSatisfying=function(ee,ge,ye){var je=null,We=null;try{var et=new pe(ge,ye)}catch{return null}return ee.forEach(function(Ye){et.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new he(je=Ye,ye)))}),je},e.validRange=function(ee,ge){try{return new pe(ee,ge).range||"*"}catch{return null}},e.ltr=function(ee,ge,ye){return oe(ee,ge,"<",ye)},e.gtr=function(ee,ge,ye){return oe(ee,ge,">",ye)},e.outside=oe,e.prerelease=function(ee,ge){var ye=Ee(ee,ge);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ee,ge,ye){return ee=new pe(ee,ye),ge=new pe(ge,ye),ee.intersects(ge)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var ge=ee.match(b[k]);return ge==null?null:Ee((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(me,e){var D,T,g=me.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(u){if(D===setTimeout)return setTimeout(u,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(u,0);try{return D(u,0)}catch{try{return D.call(null,u,0)}catch{return D.call(this,u,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch{D=R}try{T=typeof clearTimeout=="function"?clearTimeout:L}catch{T=L}})();var y,m=[],A=!1,C=-1;function $(){A&&y&&(A=!1,y.length?m=y.concat(m):C=-1,m.length&&v())}function v(){if(!A){var u=b($);A=!0;for(var o=m.length;o;){for(y=m,m=[];++C<o;)y&&y[C].run();C=-1,o=m.length}y=null,A=!1,function(i){if(T===clearTimeout)return clearTimeout(i);if((T===L||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(i);try{T(i)}catch{try{return T.call(null,i)}catch{return T.call(this,i)}}}(u)}}function S(u,o){this.fun=u,this.array=o}function w(){}g.nextTick=function(u){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];m.push(new S(u,o)),m.length!==1||A||b(v)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=w,g.addListener=w,g.once=w,g.off=w,g.removeListener=w,g.removeAllListeners=w,g.emit=w,g.prependListener=w,g.prependOnceListener=w,g.listeners=function(u){return[]},g.binding=function(u){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(u){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(R){return new T(R)}constructor(R){this.c=D&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=T}),define(ke[4],Se([1,0,8,74,3,75,38]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const b=!1,y=!1;var m;(function(f){f.None=()=>g.$Rc.None;function p(fe){if(y){const{onDidAddListener:te}=fe,de=S.create();let pe=0;fe.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),te?.()}}}function k(fe,te){return ce(fe,()=>{},0,void 0,!0,void 0,te)}f.defer=k;function P(fe){return(te,de=null,pe)=>{let Pe=!1,B;return B=fe(X=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(de,X)},null,pe),Pe&&B.dispose(),B}}f.once=P;function j(fe,te,de){return W((pe,Pe=null,B)=>fe(X=>pe.call(Pe,te(X)),null,B),de)}f.map=j;function z(fe,te,de){return W((pe,Pe=null,B)=>fe(X=>{te(X),pe.call(Pe,X)},null,B),de)}f.forEach=z;function M(fe,te,de){return W((pe,Pe=null,B)=>fe(X=>te(X)&&pe.call(Pe,X),null,B),de)}f.filter=M;function F(fe){return fe}f.signal=F;function N(...fe){return(te,de=null,pe)=>{const Pe=(0,g.$Oc)(...fe.map(B=>B(X=>te.call(de,X))));return x(Pe,pe)}}f.any=N;function O(fe,te,de,pe){let Pe=de;return j(fe,B=>(Pe=te(Pe,B),Pe),pe)}f.reduce=O;function W(fe,te){let de;const pe={onWillAddFirstListener(){de=fe(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};te||p(pe);const Pe=new n(pe);return te?.add(Pe),Pe.event}function x(fe,te){return te instanceof Array?te.push(fe):te&&te.add(fe),fe}function ce(fe,te,de=100,pe=!1,Pe=!1,B,X){let se,oe,ee,ge=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){se=fe(et=>{ge++,oe=te(oe,et),pe&&!ee&&(We.fire(oe),oe=void 0),ye=()=>{const Ye=oe;oe=void 0,ee=void 0,(!pe||ge>1)&&We.fire(Ye),ge=0},typeof de=="number"?(clearTimeout(ee),ee=setTimeout(ye,de)):ee===void 0&&(ee=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&ge>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,se.dispose()}};X||p(je);const We=new n(je);return X?.add(We),We.event}f.debounce=ce;function Y(fe,te=0,de){return f.debounce(fe,(pe,Pe)=>pe?(pe.push(Pe),pe):[Pe],te,void 0,!0,void 0,de)}f.accumulate=Y;function G(fe,te=(pe,Pe)=>pe===Pe,de){let pe=!0,Pe;return M(fe,B=>{const X=pe||!te(B,Pe);return pe=!1,Pe=B,X},de)}f.latch=G;function J(fe,te,de){return[f.filter(fe,te,de),f.filter(fe,pe=>!te(pe),de)]}f.split=J;function le(fe,te=!1,de=[],pe){let Pe=de.slice(),B=fe(oe=>{Pe?Pe.push(oe):se.fire(oe)});pe&&pe.add(B);const X=()=>{Pe?.forEach(oe=>se.fire(oe)),Pe=null},se=new n({onWillAddFirstListener(){B||(B=fe(oe=>se.fire(oe)),pe&&pe.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(X):X())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return pe&&pe.add(se),se.event}f.buffer=le;function Q(fe,te){return(pe,Pe,B)=>{const X=te(new he);return fe(function(se){const oe=X.evaluate(se);oe!==Ee&&pe.call(Pe,oe)},void 0,B)}}f.chain=Q;const Ee=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(de=>(te(de),de)),this}filter(te){return this.f.push(de=>te(de)?de:Ee),this}reduce(te,de){let pe=de;return this.f.push(Pe=>(pe=te(pe,Pe),pe)),this}latch(te=(de,pe)=>de===pe){let de=!0,pe;return this.f.push(Pe=>{const B=de||!te(Pe,pe);return de=!1,pe=Pe,B?Pe:Ee}),this}evaluate(te){for(const de of this.f)if(te=de(te),te===Ee)break;return te}}function K(fe,te,de=pe=>pe){const pe=(...se)=>X.fire(de(...se)),Pe=()=>fe.on(te,pe),B=()=>fe.removeListener(te,pe),X=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return X.event}f.fromNodeEventEmitter=K;function U(fe,te,de=pe=>pe){const pe=(...se)=>X.fire(de(...se)),Pe=()=>fe.addEventListener(te,pe),B=()=>fe.removeEventListener(te,pe),X=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return X.event}f.fromDOMEventEmitter=U;function ie(fe){return new Promise(te=>P(fe)(te))}f.toPromise=ie;function be(fe){const te=new n;return fe.then(de=>{te.fire(de)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}f.fromPromise=be;function H(fe,te,de){return te(de),fe(pe=>te(pe))}f.runAndSubscribe=H;function _(fe,te){let de=null;function pe(B){de?.dispose(),de=new g.$Qc,te(B,de)}pe(void 0);const Pe=fe(B=>pe(B));return(0,g.$Pc)(()=>{Pe.dispose(),de?.dispose()})}f.runAndSubscribeWithStore=_;class Z{constructor(te,de){this._observable=te,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};de||p(pe),this.emitter=new n(pe),de&&de.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,de){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(fe,te){return new Z(fe,te).emitter.event}f.fromObservable=$e;function re(fe){return te=>{let de=0,pe=!1;const Pe={beginUpdate(){de++},endUpdate(){de--,de===0&&(fe.reportChanges(),pe&&(pe=!1,te()))},handlePossibleChange(){},handleChange(){pe=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}f.fromObservableLight=re})(m||(e.Event=m={}));class A{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${A.f++}`,A.all.add(this)}start(p){this.g=new L.$Nd,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Pd=A;let C=-1;function $(f){const p=C;return C=f,{dispose(){C=p}}}e.$Qd=$;class v{constructor(p,k=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=k,this.g=0}dispose(){this.f?.clear()}check(p,k){const P=this.threshold;if(P<=0||k<P)return;this.f||(this.f=new Map);const j=this.f.get(p.value)||0;if(this.f.set(p.value,j+1),this.g-=1,this.g<=0){this.g=P*.5;let z,M=0;for(const[F,N]of this.f)(!z||M<N)&&(z=F,M=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${M}):`),console.warn(z)}return()=>{const z=this.f.get(p.value)||0;this.f.set(p.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class u{constructor(p){this.value=p,this.id=w++}}const o=2,i=(f,p)=>{if(f instanceof u)p(f);else for(let k=0;k<f.length;k++){const P=f[k];P&&p(P)}};class n{constructor(p){this.w=0,this.f=p,this.g=C>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,k=>k.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,k,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Rc.None;if(this.m)return g.$Rc.None;k&&(p=p.bind(k));const j=new u(p);let z,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(j.stack=S.create(),z=this.g.check(j.stack,this.w+1)),b&&(j.stack=M??S.create()),this.t?this.t instanceof u?(this.u??=new a,this.t=[this.t,j]):this.t.push(j):(this.f?.onWillAddFirstListener?.(this),this.t=j,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,g.$Pc)(()=>{z?.(),this.x(j)});return P instanceof g.$Qc?P.add(F):Array.isArray(P)&&P.push(F),F},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const k=this.t,P=k.indexOf(p);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,k[P]=void 0;const j=this.u.current===this;if(this.w*o<=k.length){let z=0;for(let M=0;M<k.length;M++)k[M]?k[z++]=k[M]:j&&(this.u.end--,z<this.u.i&&this.u.i--);k.length=z}}y(p,k){if(!p)return;const P=this.f?.onListenerError||D.$Z;if(!P){p.value(k);return}try{p.value(k)}catch(j){P(j)}}z(p){const k=p.current.t;for(;p.i<p.end;)this.y(k[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,p);else{const k=this.u;k.enqueue(this,p,this.t.length),this.z(k)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=n;const r=()=>new a;e.$Sd=r;class a{constructor(){this.i=-1,this.end=0}enqueue(p,k,P){this.i=0,this.end=P,this.current=p,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,k,P){if(this.t)for(this.h||(this.h=new R.$2c),i(this.t,j=>this.h.push([j.value,p]));this.h.size>0&&!k.isCancellationRequested;){const[j,z]=this.h.shift(),M=[],F={...z,token:k,waitUntil:N=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(N=P(N,j)),M.push(N)}};try{j(F)}catch(N){(0,D.$Z)(N);continue}Object.freeze(M),await Promise.allSettled(M).then(N=>{for(const O of N)O.status==="rejected"&&(0,D.$Z)(O.reason)})}}}e.$Td=t;class s extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new R.$2c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Ud=s;class d extends s{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Vd=d;class l extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(k=>super.fire(k)),this.h=[]}))}}e.$Wd=l;class c{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const k={event:p,listener:null};this.h.push(k),this.g&&this.m(k);const P=()=>{this.g&&this.o(k);const j=this.h.indexOf(k);this.h.splice(j,1)};return(0,g.$Pc)((0,T.$cb)(P))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(k=>this.f.fire(k))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Xd=c;class h{constructor(p,k,P,j){this.f=new g.$Qc;const z=this.f.add(new c),M=this.f.add(new g.$1c);function F(N){M.set(N,z.add(j(N)))}for(const N of p)F(N);this.f.add(k(N=>{F(N)})),this.f.add(P(N=>{M.deleteAndDispose(N)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Yd=h;class E{constructor(){this.f=[]}wrapEvent(p){return(k,P,j)=>p(z=>{const M=this.f[this.f.length-1];M?M.push(()=>k.call(P,z)):k.call(P,z)},void 0,j)}bufferEvents(p){const k=[];this.f.push(k);const P=p();return this.f.pop(),k.forEach(j=>j()),P}}e.$Zd=E;class I{constructor(){this.f=!1,this.g=m.None,this.h=g.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=I}),define(ke[21],Se([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const T=Object.freeze(function(b,y){const m=setTimeout(b.bind(y),0);return{dispose(){clearTimeout(m)}}});var g;(function(b){function y(m){return m===b.None||m===b.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}b.isCancellationToken=y,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(g||(e.CancellationToken=g={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(y){this.f=void 0,this.g=void 0,this.g=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=g.Cancelled}dispose(y=!1){y&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=g.None}}e.$2d=L}),define(ke[162],Se([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class T{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$2d,y=this.b(b.token);return this.a={promise:y,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ae=T;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const y=JSON.stringify(b);return this.b!==y&&(this.b=y,this.a=this.c(b)),this.a}}e.$Be=g;class R{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const y=this.b(b);return this.a.set(b,y),y}}e.$Ce=R}),define(ke[98],Se([1,0,8,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function g(r){const a=r;return a?typeof a.read=="function":!1}e.$3d=g;function R(r){const a=r;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$4d=R;function L(r){const a=r;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$5d=L;function b(r,a){return new y(r,a)}e.$6d=b;class y{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,D.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let s;switch(a){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const d=s.indexOf(t);d>=0&&s.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(r,a){const t=[];let s;for(;(s=r.read())!==null;)t.push(s);return a(t)}e.$7d=m;function A(r,a,t){const s=[];let d;for(;(d=r.read())!==null&&s.length<t;)s.push(d);return d===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}e.$8d=A;function C(r,a){return new Promise((t,s)=>{const d=[];$(r,{onData:l=>{a&&d.push(l)},onError:l=>{a?s(l):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$9d=C;function $(r,a,t){r.on("error",s=>{t?.isCancellationRequested||a.onError(s)}),r.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),r.on("data",s=>{t?.isCancellationRequested||a.onData(s)})}e.$0d=$;function v(r,a){return new Promise((t,s)=>{const d=new T.$Qc,l=[],c=I=>{if(l.push(I),l.length>a)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=I=>(d.dispose(),s(I)),E=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,T.$Pc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,T.$Pc)(()=>r.removeListener("end",E))),r.on("end",E),d.add((0,T.$Pc)(()=>r.removeListener("data",c))),r.on("data",c)})}e.$$d=v;function S(r,a){const t=b(a);return t.end(r),t}e.$_d=S;function w(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}e.$ae=w;function u(r){let a=!1;return{read:()=>a?null:(a=!0,r)}}e.$be=u;function o(r,a,t){const s=b(t);return $(r,{onData:d=>s.write(a.data(d)),onError:d=>s.error(a.error?a.error(d):d),onEnd:()=>s.end()}),s}e.$ce=o;function i(r,a,t){let s=!1;return{read:()=>{const d=a.read();return s?d:(s=!0,d!==null?t([r,d]):r)}}}e.$de=i;function n(r,a,t){let s=!1;const d=b(t);return $(a,{onData:l=>s?d.write(l):(s=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{s||(s=!0,d.write(r)),d.end()}}),d}e.$ee=n}),define(ke[22],Se([1,0,48,98]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const g=typeof Buffer<"u",R=new D.$U(()=>new Uint8Array(256));let L,b;class y{static alloc(k){return g?new y(Buffer.allocUnsafe(k)):new y(new Uint8Array(k))}static wrap(k){return g&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new y(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&g?new y(Buffer.from(k)):(L||(L=new TextEncoder),new y(L.encode(k)))}static fromByteArray(k){const P=y.alloc(k.length);for(let j=0,z=k.length;j<z;j++)P.buffer[j]=k[j];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let M=0,F=k.length;M<F;M++)P+=k[M].byteLength}const j=y.alloc(P);let z=0;for(let M=0,F=k.length;M<F;M++){const N=k[M];j.set(N,z),z+=N.byteLength}return j}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=y.alloc(this.byteLength);return k.set(this),k}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(k,P){return new y(this.buffer.subarray(k,P))}set(k,P){if(k instanceof y)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return $(this.buffer,k)}writeUInt32BE(k,P){v(this.buffer,k,P)}readUInt32LE(k){return S(this.buffer,k)}writeUInt32LE(k,P){w(this.buffer,k,P)}readUInt8(k){return u(this.buffer,k)}writeUInt8(k,P){o(this.buffer,k,P)}indexOf(k,P=0){return m(this.buffer,k instanceof y?k.buffer:k,P)}}e.$fe=y;function m(p,k,P=0){const j=k.byteLength,z=p.byteLength;if(j===0)return 0;if(j===1)return p.indexOf(k[0]);if(j>z-P)return-1;const M=R.value;M.fill(k.length);for(let W=0;W<k.length;W++)M[k[W]]=k.length-W-1;let F=P+k.length-1,N=F,O=-1;for(;F<z;)if(p[F]===k[N]){if(N===0){O=F;break}F--,N--}else F+=Math.max(k.length-N,M[p[F]]),N=k.length-1;return O}e.$ge=m;function A(p,k){return p[k+0]<<0>>>0|p[k+1]<<8>>>0}e.$he=A;function C(p,k,P){p[P+0]=k&255,k=k>>>8,p[P+1]=k&255}e.$ie=C;function $(p,k){return p[k]*2**24+p[k+1]*2**16+p[k+2]*2**8+p[k+3]}e.$je=$;function v(p,k,P){p[P+3]=k,k=k>>>8,p[P+2]=k,k=k>>>8,p[P+1]=k,k=k>>>8,p[P]=k}e.$ke=v;function S(p,k){return p[k+0]<<0>>>0|p[k+1]<<8>>>0|p[k+2]<<16>>>0|p[k+3]<<24>>>0}e.$le=S;function w(p,k,P){p[P+0]=k&255,k=k>>>8,p[P+1]=k&255,k=k>>>8,p[P+2]=k&255,k=k>>>8,p[P+3]=k&255}e.$me=w;function u(p,k){return p[k]}e.$ne=u;function o(p,k,P){p[P]=k}e.$oe=o;function i(p){return T.$7d(p,k=>y.concat(k))}e.$pe=i;function n(p){return T.$be(p)}e.$qe=n;function r(p){return T.$9d(p,k=>y.concat(k))}e.$re=r;async function a(p){return p.ended?y.concat(p.buffer):y.concat([...p.buffer,await r(p.stream)])}e.$se=a;function t(p){return T.$_d(p,k=>y.concat(k))}e.$te=t;function s(p){return T.$ce(p,{data:k=>typeof k=="string"?y.fromString(k):y.wrap(k)},k=>y.concat(k))}e.$ue=s;function d(p){return T.$6d(k=>y.concat(k),p)}e.$ve=d;function l(p,k){return T.$de(p,k,P=>y.concat(P))}e.$we=l;function c(p,k){return T.$ee(p,k,P=>y.concat(P))}e.$xe=c;function h(p){let k=0,P=0,j=0;const z=new Uint8Array(Math.floor(p.length/4*3)),M=N=>{switch(P){case 3:z[j++]=k|N,P=0;break;case 2:z[j++]=k|N>>>2,k=N<<6,P=3;break;case 1:z[j++]=k|N>>>4,k=N<<4,P=2;break;default:k=N<<2,P=1}};for(let N=0;N<p.length;N++){const O=p.charCodeAt(N);if(O>=65&&O<=90)M(O-65);else if(O>=97&&O<=122)M(O-97+26);else if(O>=48&&O<=57)M(O-48+52);else if(O===43||O===45)M(62);else if(O===47||O===95)M(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${p[N]}`)}}const F=j;for(;P>0;)M(0);return y.wrap(z).slice(0,F)}e.$ye=h;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:p},k=!0,P=!1){const j=P?I:E;let z="";const M=p.byteLength%3;let F=0;for(;F<p.byteLength-M;F+=3){const N=p[F+0],O=p[F+1],W=p[F+2];z+=j[N>>>2],z+=j[(N<<4|O>>>4)&63],z+=j[(O<<2|W>>>6)&63],z+=j[W&63]}if(M===1){const N=p[F+0];z+=j[N>>>2],z+=j[N<<4&63],k&&(z+="==")}else if(M===2){const N=p[F+0],O=p[F+1];z+=j[N>>>2],z+=j[(N<<4|O>>>4)&63],z+=j[O<<2&63],k&&(z+="=")}return z}e.$ze=f}),define(ke[13],Se([1,0,162,48]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function g(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Fe=g;const R=/{(\d+)}/g;function L(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(R,function(Ve,Le){const Ze=parseInt(Le,10);return isNaN(Ze)||Ze<0||Ze>=Oe.length?Ve:Oe[Ze]})}e.$Ge=L;const b=/{([^}]+)}/g;function y(Ae,Oe){return Object.keys(Oe).length===0?Ae:Ae.replace(b,(Ve,Le)=>Oe[Le]??Ve)}e.$He=y;function m(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$Ie=m;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=A;function C(Ae,Oe){let Ve=0;const Le=Oe.charCodeAt(0);for(let Ze=Ae.length-1;Ze>=0;Ze--)Ae.charCodeAt(Ze)===Le&&Ve++;return Ve}e.$Ke=C;function $(Ae,Oe,Ve="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${Ve}`}e.$Le=$;function v(Ae,Oe=" "){const Ve=S(Ae,Oe);return w(Ve,Oe)}e.$Me=v;function S(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length;if(Ve===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Oe,Le)===Le;)Le=Le+Ve;return Ae.substring(Le)}e.$Ne=S;function w(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length,Le=Ae.length;if(Ve===0||Le===0)return Ae;let Ze=Le,ue=-1;for(;ue=Ae.lastIndexOf(Oe,Ze-1),!(ue===-1||ue+Ve!==Ze);){if(ue===0)return"";Ze=ue}return Ae.substring(0,Ze)}e.$Oe=w;function u(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=u;function o(Ae){return Ae.replace(/\*/g,"")}e.$Qe=o;function i(Ae,Oe,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=A(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return Ve.global&&(Le+="g"),Ve.matchCase||(Le+="i"),Ve.multiline&&(Le+="m"),Ve.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Re=i;function n(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Se=n;function r(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Te=r;function a(Ae){for(let Oe=0,Ve=Ae.length;Oe<Ve;Oe++){const Le=Ae.charCodeAt(Oe);if(Le!==32&&Le!==9)return Oe}return-1}e.$Ue=a;function t(Ae,Oe=0,Ve=Ae.length){for(let Le=Oe;Le<Ve;Le++){const Ze=Ae.charCodeAt(Le);if(Ze!==32&&Ze!==9)return Ae.substring(Oe,Le)}return Ae.substring(Oe,Ve)}e.$Ve=t;function s(Ae,Oe=Ae.length-1){for(let Ve=Oe;Ve>=0;Ve--){const Le=Ae.charCodeAt(Ve);if(Le!==32&&Le!==9)return Ve}return-1}e.$We=s;function d(Ae,Oe,Ve){const Le=[];let Ze=0;for(const ue of Ae.matchAll(Oe)){if(Le.push(Ae.slice(Ze,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");Ze=ue.index+ue[0].length,Le.push(Ve(ue[0],...ue.slice(1),ue.index,Ae,ue.groups))}return Le.push(Ae.slice(Ze)),Promise.all(Le).then(ue=>ue.join(""))}e.$Xe=d;function l(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Ye=l;function c(Ae,Oe,Ve=0,Le=Ae.length,Ze=0,ue=Oe.length){for(;Ve<Le&&Ze<ue;Ve++,Ze++){const Ke=Ae.charCodeAt(Ve),Ge=Oe.charCodeAt(Ze);if(Ke<Ge)return-1;if(Ke>Ge)return 1}const ae=Le-Ve,Ie=ue-Ze;return ae<Ie?-1:ae>Ie?1:0}e.$Ze=c;function h(Ae,Oe){return E(Ae,Oe,0,Ae.length,0,Oe.length)}e.$1e=h;function E(Ae,Oe,Ve=0,Le=Ae.length,Ze=0,ue=Oe.length){for(;Ve<Le&&Ze<ue;Ve++,Ze++){let Ke=Ae.charCodeAt(Ve),Ge=Oe.charCodeAt(Ze);if(Ke===Ge)continue;if(Ke>=128||Ge>=128)return c(Ae.toLowerCase(),Oe.toLowerCase(),Ve,Le,Ze,ue);f(Ke)&&(Ke-=32),f(Ge)&&(Ge-=32);const _e=Ke-Ge;if(_e!==0)return _e}const ae=Le-Ve,Ie=ue-Ze;return ae<Ie?-1:ae>Ie?1:0}e.$2e=E;function I(Ae){return Ae>=48&&Ae<=57}e.$3e=I;function f(Ae){return Ae>=97&&Ae<=122}e.$4e=f;function p(Ae){return Ae>=65&&Ae<=90}e.$5e=p;function k(Ae,Oe){return Ae.length===Oe.length&&E(Ae,Oe)===0}e.$6e=k;function P(Ae,Oe){const Ve=Oe.length;return Oe.length>Ae.length?!1:E(Ae,Oe,0,Ve)===0}e.$7e=P;function j(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Le)!==Oe.charCodeAt(Le))return Le;return Ve}e.$8e=j;function z(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;const Ze=Ae.length-1,ue=Oe.length-1;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Ze-Le)!==Oe.charCodeAt(ue-Le))return Le;return Ve}e.$9e=z;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$0e=M;function F(Ae){return 56320<=Ae&&Ae<=57343}e.$$e=F;function N(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$_e=N;function O(Ae,Oe,Ve){const Le=Ae.charCodeAt(Ve);if(M(Le)&&Ve+1<Oe){const Ze=Ae.charCodeAt(Ve+1);if(F(Ze))return N(Le,Ze)}return Le}e.$af=O;function W(Ae,Oe){const Ve=Ae.charCodeAt(Oe-1);if(F(Ve)&&Oe>1){const Le=Ae.charCodeAt(Oe-2);if(M(Le))return N(Le,Ve)}return Ve}class x{get offset(){return this.e}constructor(Oe,Ve=0){this.c=Oe,this.d=Oe.length,this.e=Ve}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=W(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=O(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$bf=x;class ce{get offset(){return this.c.offset}constructor(Oe,Ve=0){this.c=new x(Oe,Ve)}nextGraphemeLength(){const Oe=ge.getInstance(),Ve=this.c,Le=Ve.offset;let Ze=Oe.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const ue=Ve.offset,ae=Oe.getGraphemeBreakType(Ve.nextCodePoint());if(oe(Ze,ae)){Ve.setOffset(ue);break}Ze=ae}return Ve.offset-Le}prevGraphemeLength(){const Oe=ge.getInstance(),Ve=this.c,Le=Ve.offset;let Ze=Oe.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const ue=Ve.offset,ae=Oe.getGraphemeBreakType(Ve.prevCodePoint());if(oe(ae,Ze)){Ve.setOffset(ue);break}Ze=ae}return Le-Ve.offset}eol(){return this.c.eol()}}e.$cf=ce;function Y(Ae,Oe){return new ce(Ae,Oe).nextGraphemeLength()}e.$df=Y;function G(Ae,Oe){return new ce(Ae,Oe).prevGraphemeLength()}e.$ef=G;function J(Ae,Oe){Oe>0&&F(Ae.charCodeAt(Oe))&&Oe--;const Ve=Oe+Y(Ae,Oe);return[Ve-G(Ae,Ve),Ve]}e.$ff=J;function le(Ae){const Oe=new ce(Ae);let Ve=0;for(;!Oe.eol();)Ve++,Oe.nextGraphemeLength();return Ve}e.$gf=le;let Q;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function he(Ae){return Q||(Q=Ee()),Q.test(Ae)}e.$hf=he;const K=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return K.test(Ae)}e.$if=U,e.$jf=/[\u2028\u2029]/;function ie(Ae){return e.$jf.test(Ae)}e.$kf=ie;function be(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$lf=be;function H(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$mf=H;function _(Ae,Oe){if(Ae.length<Oe)return Ae;const Ve=/\b/g;let Le=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Oe);)Le=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$nf=_;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,$e=/\x1b\].*?\x07/g;function re(Ae){return Ae&&(Ae=Ae.replace(Z,"").replace($e,"")),Ae}e.$of=re,e.$pf=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$qf=fe;function te(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$rf=te;function de(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const Ve=Oe.length,Le=Ae.toLowerCase();let Ze=0,ue=-1;for(;Ze<Ve;){const ae=Le.indexOf(Oe[Ze],ue+1);if(ae<0)return!1;ue=ae,Ze++}return!0}e.$sf=de;function pe(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$tf=pe;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$uf=Pe;function B(Ae,Oe=1){if(Oe===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Oe--;while(Oe>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$vf=B;function X(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$wf=X;function se(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$xf=se;function oe(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var ee;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(ee||(e.GraphemeBreakType=ee={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=ye()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const Ve=this.d,Le=Ve.length/3;let Ze=1;for(;Ze<=Le;)if(Oe<Ve[3*Ze])Ze=2*Ze;else if(Oe>Ve[3*Ze+1])Ze=2*Ze+1;else return Ve[3*Ze+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Oe){if(Ae===0)return 0;const Ve=We(Ae,Oe);if(Ve!==void 0)return Ve;const Le=new x(Oe,Ae);return Le.prevCodePoint(),Le.offset}e.$yf=je;function We(Ae,Oe){const Ve=new x(Oe,Ae);let Le=Ve.prevCodePoint();for(;et(Le)||Le===65039||Le===8419;){if(Ve.offset===0)return;Le=Ve.prevCodePoint()}if(!H(Le))return;let Ze=Ve.offset;return Ze>0&&Ve.prevCodePoint()===8205&&(Ze=Ve.offset),Ze}function et(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$zf="\xA0";class rt{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Be(Oe=>{function Ve(_e){const st=new Map;for(let lt=0;lt<_e.length;lt+=2)st.set(_e[lt],_e[lt+1]);return st}function Le(_e,st){const lt=new Map(_e);for(const[wt,Ue]of st)lt.set(wt,Ue);return lt}function Ze(_e,st){if(!_e)return st;const lt=new Map;for(const[wt,Ue]of _e)st.has(wt)&&lt.set(wt,Ue);return lt}const ue=this.c.value;let ae=Oe.filter(_e=>!_e.startsWith("_")&&_e in ue);ae.length===0&&(ae=["_default"]);let Ie;for(const _e of ae){const st=Ve(ue[_e]);Ie=Ze(Ie,st)}const Ke=Ve(ue._common),Ge=Le(Ke,Ie);return new rt(Ge)})}static getInstance(Oe){return rt.d.get(Array.from(Oe))}static{this.e=new T.$U(()=>Object.keys(rt.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return rt.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=rt;class nt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(nt.c())),this.d}static isInvisibleCharacter(Oe){return nt.e().has(Oe)}static get codePoints(){return nt.e()}}e.$Bf=nt}),define(ke[124],Se([1,0,28,13]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function g(...te){return function(de,pe){for(let Pe=0,B=te.length;Pe<B;Pe++){const X=te[Pe](de,pe);if(X)return X}return null}}e.or=g,e.$Ij=R.bind(void 0,!1),e.$Jj=R.bind(void 0,!0);function R(te,de,pe){if(!pe||pe.length<de.length)return null;let Pe;return te?Pe=T.$7e(pe,de):Pe=pe.indexOf(de)===0,Pe?de.length>0?[{start:0,end:de.length}]:[]:null}function L(te,de){const pe=de.toLowerCase().indexOf(te.toLowerCase());return pe===-1?null:[{start:pe,end:pe+te.length}]}e.$Kj=L;function b(te,de){return y(te.toLowerCase(),de.toLowerCase(),0,0)}e.$Lj=b;function y(te,de,pe,Pe){if(pe===te.length)return[];if(Pe===de.length)return null;if(te[pe]===de[Pe]){let B=null;return(B=y(te,de,pe+1,Pe+1))?o({start:Pe,end:Pe+1},B):null}return y(te,de,pe,Pe+1)}function m(te){return 97<=te&&te<=122}function A(te){return 65<=te&&te<=90}e.$Mj=A;function C(te){return 48<=te&&te<=57}function $(te){return te===32||te===9||te===10||te===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>v.add(te.charCodeAt(0)));function S(te){return $(te)||v.has(te)}function w(te,de){return te===de||S(te)&&S(de)}function u(te){return m(te)||A(te)||C(te)}function o(te,de){return de.length===0?de=[te]:te.end===de[0].start?de[0].start=te.start:de.unshift(te),de}function i(te,de){for(let pe=de;pe<te.length;pe++){const Pe=te.charCodeAt(pe);if(A(Pe)||C(Pe)||pe>0&&!u(te.charCodeAt(pe-1)))return pe}return te.length}function n(te,de,pe,Pe){if(pe===te.length)return[];if(Pe===de.length)return null;if(te[pe]!==de[Pe].toLowerCase())return null;{let B=null,X=Pe+1;for(B=n(te,de,pe+1,Pe+1);!B&&(X=i(de,X))<de.length;)B=n(te,de,pe+1,X),X++;return B===null?null:o({start:Pe,end:Pe+1},B)}}function r(te){let de=0,pe=0,Pe=0,B=0,X=0;for(let ye=0;ye<te.length;ye++)X=te.charCodeAt(ye),A(X)&&de++,m(X)&&pe++,u(X)&&Pe++,C(X)&&B++;const se=de/te.length,oe=pe/te.length,ee=Pe/te.length,ge=B/te.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:ee,numericPercent:ge}}function a(te){const{upperPercent:de,lowerPercent:pe}=te;return pe===0&&de>.6}function t(te){const{upperPercent:de,lowerPercent:pe,alphaPercent:Pe,numericPercent:B}=te;return pe>.2&&de<.8&&Pe>.6&&B<.2}function s(te){let de=0,pe=0,Pe=0,B=0;for(let X=0;X<te.length;X++)Pe=te.charCodeAt(X),A(Pe)&&de++,m(Pe)&&pe++,$(Pe)&&B++;return(de===0||pe===0)&&B===0?te.length<=30:de<=5}function d(te,de){if(!de||(de=de.trim(),de.length===0)||!s(te)||de.length>60)return null;const pe=r(de);if(!t(pe)){if(!a(pe))return null;de=de.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<de.length&&(Pe=n(te,de,0,B))===null;)B=i(de,B+1);return Pe}e.$Nj=d;function l(te,de,pe=!1){if(!de||de.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),de=de.toLowerCase();B<de.length&&(Pe=c(te,de,0,B,pe))===null;)B=h(de,B+1);return Pe}e.$Oj=l;function c(te,de,pe,Pe,B){if(pe===te.length)return[];if(Pe===de.length)return null;if(w(te.charCodeAt(pe),de.charCodeAt(Pe))){let X=null,se=Pe+1;if(X=c(te,de,pe+1,Pe+1,B),!B)for(;!X&&(se=h(de,se))<de.length;)X=c(te,de,pe+1,se,B),se++;return X?te.charCodeAt(pe)!==de.charCodeAt(Pe)?X:o({start:Pe,end:Pe+1},X):null}else return null}function h(te,de){for(let pe=de;pe<te.length;pe++)if(S(te.charCodeAt(pe))||pe>0&&S(te.charCodeAt(pe-1)))return pe;return te.length}const E=g(e.$Jj,d,L),I=g(e.$Jj,d,b),f=new D.$Cc(1e4);function p(te,de,pe=!1){if(typeof te!="string"||typeof de!="string")return null;let Pe=f.get(te);Pe||(Pe=new RegExp(T.$Pe(te),"i"),f.set(te,Pe));const B=Pe.exec(de);return B?[{start:B.index,end:B.index+B[0].length}]:pe?I(te,de):E(te,de)}e.$Pj=p;function k(te,de){const pe=be(te,te.toLowerCase(),0,de,de.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?j(pe):null}e.$Qj=k;function P(te,de,pe,Pe,B,X){const se=Math.min(13,te.length);for(;pe<se;pe++){const oe=be(te,de,pe,Pe,B,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,X]}e.$Rj=P;function j(te){if(typeof te>"u")return[];const de=[],pe=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+pe,X=de[de.length-1];X&&X.end===B?X.end=B+1:de.push({start:B,end:B+1})}return de}e.$Sj=j;const z=128;function M(){const te=[],de=[];for(let pe=0;pe<=z;pe++)de[pe]=0;for(let pe=0;pe<=z;pe++)te.push(de.slice(0));return te}function F(te){const de=[];for(let pe=0;pe<=te;pe++)de[pe]=0;return de}const N=F(2*z),O=F(2*z),W=M(),x=M(),ce=M(),Y=!1;function G(te,de,pe,Pe,B){function X(oe,ee,ge=" "){for(;oe.length<ee;)oe=ge+oe;return oe}let se=` |   |${Pe.split("").map(oe=>X(oe,3)).join("|")}
`;for(let oe=0;oe<=pe;oe++)oe===0?se+=" |":se+=`${de[oe-1]}|`,se+=te[oe].slice(0,B+1).map(ee=>X(ee.toString(),3)).join("|")+`
`;return se}function J(te,de,pe,Pe){te=te.substr(de),pe=pe.substr(Pe),console.log(G(x,te,te.length,pe,pe.length)),console.log(G(ce,te,te.length,pe,pe.length)),console.log(G(W,te,te.length,pe,pe.length))}function le(te,de){if(de<0||de>=te.length)return!1;const pe=te.codePointAt(de);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$mf(pe)}}function Q(te,de){if(de<0||de>=te.length)return!1;switch(te.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function Ee(te,de,pe){return de[te]!==pe[te]}function he(te,de,pe,Pe,B,X,se=!1){for(;de<pe&&B<X;)te[de]===Pe[B]&&(se&&(N[de]=B),de+=1),B+=1;return de===pe}e.$Tj=he;var K;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(K||(K={}));var U;(function(te){te.Default=[-100,0];function de(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}te.isDefault=de})(U||(e.FuzzyScore=U={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(de,pe){this.firstMatchCanBeWeak=de,this.boostFullMatch=pe}}e.$Uj=ie;function be(te,de,pe,Pe,B,X,se=ie.default){const oe=te.length>z?z:te.length,ee=Pe.length>z?z:Pe.length;if(pe>=oe||X>=ee||oe-pe>ee-X||!he(de,pe,oe,B,X,ee,!0))return;H(oe,ee,pe,X,de,B);let ge=1,ye=1,je=pe,We=X;const et=[!1];for(ge=1,je=pe;je<oe;ge++,je++){const Oe=N[je],Ve=O[je],Le=je+1<oe?O[je+1]:ee;for(ye=Oe-X+1,We=Oe;We<Le;ye++,We++){let Ze=Number.MIN_SAFE_INTEGER,ue=!1;We<=Ve&&(Ze=_(te,de,je,pe,Pe,B,We,ee,X,W[ge-1][ye-1]===0,et));let ae=0;Ze!==Number.MAX_SAFE_INTEGER&&(ue=!0,ae=Ze+x[ge-1][ye-1]);const Ie=We>Oe,Ke=Ie?x[ge][ye-1]+(W[ge][ye-1]>0?-5:0):0,Ge=We>Oe+1&&W[ge][ye-1]>0,_e=Ge?x[ge][ye-2]+(W[ge][ye-2]>0?-5:0):0;if(Ge&&(!Ie||_e>=Ke)&&(!ue||_e>=ae))x[ge][ye]=_e,ce[ge][ye]=3,W[ge][ye]=0;else if(Ie&&(!ue||Ke>=ae))x[ge][ye]=Ke,ce[ge][ye]=2,W[ge][ye]=0;else if(ue)x[ge][ye]=ae,ce[ge][ye]=1,W[ge][ye]=W[ge-1][ye-1]+1;else throw new Error("not possible")}}if(Y&&J(te,pe,Pe,X),!et[0]&&!se.firstMatchCanBeWeak)return;ge--,ye--;const Ye=[x[ge][ye],X];let rt=0,nt=0;for(;ge>=1;){let Oe=ye;do{const Ve=ce[ge][Oe];if(Ve===3)Oe=Oe-2;else if(Ve===2)Oe=Oe-1;else break}while(Oe>=1);rt>1&&de[pe+ge-1]===B[X+ye-1]&&!Ee(Oe+X-1,Pe,B)&&rt+1>W[ge][Oe]&&(Oe=ye),Oe===ye?rt++:rt=1,nt||(nt=Oe),ge--,ye=Oe-1,Ye.push(ye)}ee===oe&&se.boostFullMatch&&(Ye[0]+=2);const Ae=nt-oe;return Ye[0]-=Ae,Ye}e.$Vj=be;function H(te,de,pe,Pe,B,X){let se=te-1,oe=de-1;for(;se>=pe&&oe>=Pe;)B[se]===X[oe]&&(O[se]=oe,se--),oe--}function _(te,de,pe,Pe,B,X,se,oe,ee,ge,ye){if(de[pe]!==X[se])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return se===pe-Pe?je=te[pe]===B[se]?7:5:Ee(se,B,X)&&(se===0||!Ee(se-1,B,X))?(je=te[pe]===B[se]?7:5,We=!0):le(X,se)&&(se===0||!le(X,se-1))?je=5:(le(X,se-1)||Q(X,se-1))&&(je=5,We=!0),je>1&&pe===Pe&&(ye[0]=!0),We||(We=Ee(se,B,X)||le(X,se-1)||Q(X,se-1)),pe===Pe?se>ee&&(je-=We?3:5):ge?je+=We?2:0:je+=We?0:1,se+1===oe&&(je-=We?3:5),je}function Z(te,de,pe,Pe,B,X,se){return re(te,de,pe,Pe,B,X,!0,se)}e.$Wj=Z;function $e(te,de,pe,Pe,B,X,se){return re(te,de,pe,Pe,B,X,!1,se)}e.$Xj=$e;function re(te,de,pe,Pe,B,X,se,oe){let ee=be(te,de,pe,Pe,B,X,oe);if(ee&&!se)return ee;if(te.length>=3){const ge=Math.min(7,te.length-1);for(let ye=pe+1;ye<ge;ye++){const je=fe(te,ye);if(je){const We=be(je,je.toLowerCase(),pe,Pe,B,X,oe);We&&(We[0]-=3,(!ee||We[0]>ee[0])&&(ee=We))}}}return ee}function fe(te,de){if(de+1>=te.length)return;const pe=te[de],Pe=te[de+1];if(pe!==Pe)return te.slice(0,de)+Pe+pe+te.slice(de+2)}}),define(ke[52],Se([1,0,13]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;function T(o){return g(o,0)}e.$Ji=T;function g(o,i){switch(typeof o){case"object":return o===null?R(349,i):Array.isArray(o)?y(o,i):m(o,i);case"string":return b(o,i);case"boolean":return L(o,i);case"number":return R(o,i);case"undefined":return R(937,i);default:return R(617,i)}}e.$Ki=g;function R(o,i){return(i<<5)-i+o|0}e.$Li=R;function L(o,i){return R(o?433:863,i)}function b(o,i){i=R(149417,i);for(let n=0,r=o.length;n<r;n++)i=R(o.charCodeAt(n),i);return i}e.$Mi=b;function y(o,i){return i=R(104579,i),o.reduce((n,r)=>g(r,n),i)}function m(o,i){return i=R(181387,i),Object.keys(o).sort().reduce((n,r)=>(n=b(r,n),g(o[r],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Ni=A;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function $(o,i,n=32){const r=n-i,a=~((1<<r)-1);return(o<<i|(a&o)>>>r)>>>0}function v(o,i=0,n=o.byteLength,r=0){for(let a=0;a<n;a++)o[i+a]=r}function S(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function w(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Oi=w;class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let a=this.r,t=this.u,s,d;for(t!==0?(s=t,d=-1,t=0):(s=i.charCodeAt(0),d=0);;){let l=s;if(D.$0e(s))if(d+1<n){const c=i.charCodeAt(d+1);D.$$e(c)?(d++,l=D.$_e(s,c)):l=65533}else{t=s;break}else D.$$e(s)&&(l=65533);if(a=this.w(r,a,l),d++,d<n)s=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=u.g,n=this.q;for(let E=0;E<64;E+=4)i.setUint32(E,n.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)i.setUint32(E,$(i.getUint32(E-12,!1)^i.getUint32(E-32,!1)^i.getUint32(E-56,!1)^i.getUint32(E-64,!1),1),!1);let r=this.h,a=this.l,t=this.m,s=this.n,d=this.o,l,c,h;for(let E=0;E<80;E++)E<20?(l=a&t|~a&s,c=1518500249):E<40?(l=a^t^s,c=1859775393):E<60?(l=a&t|a&s|t&s,c=2400959708):(l=a^t^s,c=3395469782),h=$(r,5)+l+d+c+i.getUint32(E*4,!1)&4294967295,d=s,s=t,t=$(a,30),a=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}e.$Pi=u}),define(ke[39],Se([1,0,13]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(T||(T={})),function(g){const R="error",L="warning",b="warn",y="info",m="ignore";function A($){return $?D.$6e(R,$)?g.Error:D.$6e(L,$)||D.$6e(b,$)?g.Warning:D.$6e(y,$)?g.Info:g.Ignore:g.Ignore}g.fromValue=A;function C($){switch($){case g.Error:return R;case g.Warning:return L;case g.Info:return y;default:return m}}g.toString=C}(T||(T={})),e.default=T}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,13]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class g{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const S=v.charCodeAt(0),w=this.b.charCodeAt(this.c);return S-w}value(){return this.b[this.c]}}e.$Xh=g;class R{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.$Ze)(v,this.b,0,v.length,this.c,this.d):(0,T.$2e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=R;class L{constructor(v=!0,S=!0){this.f=v,this.g=S}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let S=v.length-1;S>=0;S--,this.c--){const w=this.b.charCodeAt(S);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.$Ze)(v,this.b,0,v.length,this.d,this.e):(0,T.$2e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=L;var b;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(b||(b={}));class y{constructor(v,S){this.f=v,this.g=S,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.$1e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.$1e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.$Ye)(v,this.c.query);if(this.d[this.e]===5)return(0,T.$Ye)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=y;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class C{static forUris(v=()=>!1,S=()=>!1){return new C(new y(v,S))}static forPaths(v=!1){return new C(new L(void 0,!v))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new R)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,S){if(S){const w=S.slice(0);(0,D.$Wb)(w);for(const u of w)this.set(u,v)}else{const w=v.slice(0);(0,D.$Wb)(w);for(const u of w)this.set(u[0],u[1])}}set(v,S){const w=this.b.reset(v);let u;this.c||(this.c=new m,this.c.segment=w.value());const o=[];for(u=this.c;;){const n=w.cmp(u.segment);if(n>0)u.left||(u.left=new m,u.left.segment=w.value()),o.push([-1,u]),u=u.left;else if(n<0)u.right||(u.right=new m,u.right.segment=w.value()),o.push([1,u]),u=u.right;else if(w.hasNext())w.next(),u.mid||(u.mid=new m,u.mid.segment=w.value()),o.push([0,u]),u=u.mid;else break}const i=u.value;u.value=S,u.key=v;for(let n=o.length-1;n>=0;n--){const r=o[n][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=o[n][0],s=o[n+1][0];if(t===1&&s===1)o[n][1]=r.rotateLeft();else if(t===-1&&s===-1)o[n][1]=r.rotateRight();else if(t===1&&s===-1)r.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=r.rotateLeft();else if(t===-1&&s===1)r.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const S=this.b.reset(v);let w=this.c;for(;w;){const u=S.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(S.hasNext())S.next(),w=w.mid;else break}return w}has(v){const S=this.d(v);return!(S?.value===void 0&&S?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,S){const w=this.b.reset(v),u=[];let o=this.c;for(;o;){const i=w.cmp(o.segment);if(i>0)u.push([-1,o]),o=o.left;else if(i<0)u.push([1,o]),o=o.right;else if(w.hasNext())w.next(),u.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:r,segment:a}=i;this.e(i.key,!1),o.key=n,o.value=r,o.segment=a}}else{const i=o.left??o.right;if(u.length>0){const[n,r]=u[u.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=u.length-1;i>=0;i--){const n=u[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),u[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),u[i][1]=n.rotateRight()),i>0)switch(u[i-1][0]){case-1:u[i-1][1].left=u[i][1];break;case 1:u[i-1][1].right=u[i][1];break;case 0:u[i-1][1].mid=u[i][1];break}else this.c=u[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const S=this.b.reset(v);let w=this.c,u;for(;w;){const o=S.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(S.hasNext())S.next(),u=w.value||u,w=w.mid;else break}return w&&w.value||u}findSuperstr(v){return this.g(v,!1)}g(v,S){const w=this.b.reset(v);let u=this.c;for(;u;){const o=w.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(w.hasNext())w.next(),u=u.mid;else return u.mid?this.h(u.mid):S?u.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[S,w]of this)v(w,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const S=[];return this.j(v,S),S[Symbol.iterator]()}j(v,S){v&&(v.left&&this.j(v.left,S),v.value&&S.push([v.key,v.value]),v.mid&&this.j(v.mid,S),v.right&&this.j(v.right,S))}_isBalanced(){const v=S=>{if(!S)return!0;const w=S.balanceFactor();return w<-1||w>1?!1:v(S.left)&&v(S.right)};return v(this.c)}}e.$2h=C}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function D(a){return typeof a=="string"}e.$Cf=D;function T(a){return Array.isArray(a)&&a.every(t=>D(t))}e.$Df=T;function g(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Ef=g;function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Ff=R;function L(a){return typeof a=="number"&&!isNaN(a)}e.$Gf=L;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Hf=b;function y(a){return a===!0||a===!1}e.$If=y;function m(a){return typeof a>"u"}e.$Jf=m;function A(a){return!C(a)}e.$Kf=A;function C(a){return m(a)||a===null}e.$Lf=C;function $(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Mf=$;function v(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Nf=v;function S(...a){const t=[];for(let s=0;s<a.length;s++){const d=a[s];if(C(d))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(d)}return t}e.$Of=S;const w=Object.prototype.hasOwnProperty;function u(a){if(!g(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.$Pf=u;function o(a){return typeof a=="function"}e.$Qf=o;function i(...a){return a.length>0&&a.every(o)}e.$Rf=i;function n(a,t){const s=Math.min(a.length,t.length);for(let d=0;d<s;d++)r(a[d],t[d])}e.$Sf=n;function r(a,t){if(D(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!C(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=r}),define(ke[78],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=void 0;const T=Object.create(null);function g(b,y){if((0,D.$Cf)(y)){const m=T[y];if(m===void 0)throw new Error(`${b} references an unknown codicon: ${y}`);y=m}return T[b]=y,{id:b}}function R(){return T}e.$Yj=R;function L(){return Object.values(e.$1j)}e.$Zj=L,e.$1j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function T(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?T(r):r}),i}e.$an=T;function g(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(R.call(n,r)){const a=n[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.$Ff)(a)&&i.push(a)}}return o}e.$bn=g;const R=Object.prototype.hasOwnProperty;function L(o,i){return b(o,i,new Set)}e.$cn=L;function b(o,i,n){if((0,D.$Lf)(o))return o;const r=i(o);if(typeof r<"u")return r;if(Array.isArray(o)){const a=[];for(const t of o)a.push(b(t,i,n));return a}if((0,D.$Ef)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const a={};for(const t in o)R.call(o,t)&&(a[t]=b(o[t],i,n));return n.delete(o),a}return o}function y(o,i,n=!0){return(0,D.$Ef)(o)?((0,D.$Ef)(i)&&Object.keys(i).forEach(r=>{r in o?n&&((0,D.$Ef)(o[r])&&(0,D.$Ef)(i[r])?y(o[r],i[r],n):o[r]=i[r]):o[r]=i[r]}),o):i}e.$dn=y;function m(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!m(o[n],i[n]))return!1}else{const a=[];for(r in o)a.push(r);a.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!m(a,t))return!1;for(n=0;n<a.length;n++)if(!m(o[a[n]],i[a[n]]))return!1}return!0}e.$en=m;function A(o){const i=new Set;return JSON.stringify(o,(n,r)=>{if((0,D.$Ef)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.$fn=A;function C(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],s=i[a];m(t,s)||(n[a]=s)}),n}e.$gn=C;function $(o,i){const n=i.toLowerCase(),r=Object.keys(o).find(a=>a.toLowerCase()===n);return r?o[r]:o[i]}e.$hn=$;function v(o,i){const n=Object.create(null);for(const[r,a]of Object.entries(o))i(r,a)&&(n[r]=a);return n}e.$in=v;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$jn=S;function w(o){const i=[];for(const n of S(o))typeof o[n]=="function"&&i.push(n);return i}e.$kn=w;function u(o,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},r={};for(const a of o)r[a]=n(a);return r}e.$ln=u}),define(ke[61],Se([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var T;(function(L){function b(y){return y&&typeof y=="object"&&typeof y.id=="string"}L.isThemeColor=b})(T||(e.ThemeColor=T={}));function g(L){return{id:L}}e.$2j=g;var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function y(i){const n=b.exec(i.id);if(!n)return y(D.$1j.error);const[,r,a]=n,t=["codicon","codicon-"+r];return a&&t.push("codicon-modifier-"+a.substring(1)),t}L.asClassNameArray=y;function m(i){return y(i).join(" ")}L.asClassName=m;function A(i){return"."+y(i).join(".")}L.asCSSSelector=A;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||T.isThemeColor(i.color))}L.isThemeIcon=C;const $=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function v(i){const n=$.exec(i);if(!n)return;const[,r]=n;return{id:r}}L.fromString=v;function S(i){return{id:i}}L.fromId=S;function w(i,n){let r=i.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),n&&(r=`${r}~${n}`),{id:r}}L.modify=w;function u(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}L.getModifier=u;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}L.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(ke[164],Se([1,0,124,13,61]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const R="$(",L=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${L.source}`,"g");function y(o){return o.replace(b,(i,n)=>n?i:`\\${i}`)}e.$3j=y;const m=new RegExp(`\\\\${L.source}`,"g");function A(o){return o.replace(m,i=>`\\${i}`)}e.$4j=A;const C=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function $(o){return o.indexOf(R)===-1?o:o.replace(C,(i,n,r,a)=>r?i:n||a||"")}e.$5j=$;function v(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$6j=v;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(o){S.lastIndex=0;let i="";const n=[];let r=0;for(;;){const a=S.lastIndex,t=S.exec(o),s=o.substring(a,t?.index);if(s.length>0){i+=s;for(let d=0;d<s.length;d++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.$7j=w;function u(o,i,n=!1){const{text:r,iconOffsets:a}=i;if(!a||a.length===0)return(0,D.$Pj)(o,r,n);const t=(0,T.$Ne)(r," "),s=r.length-t.length,d=(0,D.$Pj)(o,t,n);if(d)for(const l of d){const c=a[l.start+s]+s;l.start+=c,l.end+=c}return d}e.$8j=u}),define(ke[125],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.Constants=void 0;var D;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(R){return R<0?0:R>255?255:R|0}e.$De=T;function g(R){return R<0?0:R>4294967295?4294967295:R|0}e.$Ee=g}),define(ke[30],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(g){return D.test(g)}e.$hg=T,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let y=0;y<b.length;y++)b[y]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));return function(){g(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,m="";return m+=L[R[y++]],m+=L[R[y++]],m+=L[R[y++]],m+=L[R[y++]],m+="-",m+=L[R[y++]],m+=L[R[y++]],m+="-",m+=L[R[y++]],m+=L[R[y++]],m+="-",m+=L[R[y++]],m+=L[R[y++]],m+="-",m+=L[R[y++]],m+=L[R[y++]],m+=L[R[y++]],m+=L[R[y++]],m+=L[R[y++]],m+=L[R[y++]],m}}()}),define(ke[165],Se([1,0,19,51,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function R(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$5s=R;function L(C,$,v){const S={id:(0,g.$ig)(),name:C,uri:$,data:v};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$6s=L;class b{constructor(){this.a=new Map}get size(){let $=0;for(const v of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const v=[...this.a.keys()];return T.Iterable.some(this,([S,w])=>w.asFile())&&v.push("files"),A(y($),v)}get($){return this.a.get(this.b($))?.[0]}append($,v){const S=this.a.get($);S?S.push(v):this.a.set(this.b($),[v])}replace($,v){this.a.set(this.b($),[v])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,v]of this.a)for(const S of v)yield[$,S]}b($){return y($)}}e.$7s=b;function y(C){return C.toLowerCase()}function m(C,$){return A(y(C),$.map(y))}e.$8s=m;function A(C,$){if(C==="*/*")return $.length>0;if($.includes(C))return!0;const v=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[S,w,u]=v;return u==="*"?$.some(o=>o.startsWith(w+"/")):!1}e.$9s=Object.freeze({create:C=>(0,D.$Lb)(C.map($=>$.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$9s.split(C).filter($=>!$.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=e.$kg=void 0;function T(b,y,m,A=1){let C=!1;return new Promise($=>{const v=setTimeout(()=>{if(!C)return C=!0,$(0)},m);g(b,y,A,S=>{if(!C)return C=!0,clearTimeout(v),$(S)})})}e.$kg=T;function g(b,y,m,A){if(y===0)return A(0);const C=new D.Socket;C.once("connect",()=>(L(C),g(b+m,y-1,m,A))),C.once("data",()=>{}),C.once("error",$=>(L(C),$.code!=="ECONNREFUSED"?g(b+m,y-1,m,A):A(b))),C.connect(b,"127.0.0.1")}e.$lg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,y,m,A="127.0.0.1"){let C=!1,$,v=1;const S=D.createServer({pauseOnConnect:!0});function w(u,o){C||(C=!0,S.removeAllListeners(),S.close(),$&&clearTimeout($),o(u))}return new Promise(u=>{$=setTimeout(()=>{w(0,u)},m),S.on("listening",()=>{w(b,u)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&v<y?(b++,v++,S.listen(b,A)):w(0,u)}),S.on("close",()=>{w(0,u)}),S.listen(b,A)})}e.$mg=R;function L(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(y){console.error(y)}}}),define(ke[126],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=void 0;class T{constructor(b){const y=(0,D.$De)(b);this.c=y,this.a=T.d(y),this.b=new Map}static d(b){const y=new Uint8Array(256);return y.fill(b),y}set(b,y){const m=(0,D.$De)(y);b>=0&&b<256?this.a[b]=m:this.b.set(b,m)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ws=T;var g;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(g||(g={}));class R{constructor(){this.a=new T(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Xs=R}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function T(g){let R=0,L=0,b=0,y=0;for(let m=0,A=g.length;m<A;m++){const C=g.charCodeAt(m);C===13?(R===0&&(L=m),R++,m+1<A&&g.charCodeAt(m+1)===10?(y|=2,m++):y|=3,b=m+1):C===10&&(y|=1,R===0&&(L=m),R++,b=m+1)}return R===0&&(L=g.length),[R,L,g.length-b,y]}e.$_s=T}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class D{constructor(g,R){this.lineNumber=g,this.column=R}with(g=this.lineNumber,R=this.column){return g===this.lineNumber&&R===this.column?this:new D(g,R)}delta(g=0,R=0){return this.with(this.lineNumber+g,this.column+R)}equals(g){return D.equals(this,g)}static equals(g,R){return!g&&!R?!0:!!g&&!!R&&g.lineNumber===R.lineNumber&&g.column===R.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,R){return g.lineNumber<R.lineNumber?!0:R.lineNumber<g.lineNumber?!1:g.column<R.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,R){return g.lineNumber<R.lineNumber?!0:R.lineNumber<g.lineNumber?!1:g.column<=R.column}static compare(g,R){const L=g.lineNumber|0,b=R.lineNumber|0;if(L===b){const y=g.column|0,m=R.column|0;return y-m}return L-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}}e.$ys=D}),define(ke[29],Se([1,0,53]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class T{constructor(R,L,b,y){R>b||R===b&&L>y?(this.startLineNumber=b,this.startColumn=y,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=b,this.endColumn=y)}isEmpty(){return T.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return T.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return T.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return T.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return T.plusRange(this,R)}static plusRange(R,L){let b,y,m,A;return L.startLineNumber<R.startLineNumber?(b=L.startLineNumber,y=L.startColumn):L.startLineNumber===R.startLineNumber?(b=L.startLineNumber,y=Math.min(L.startColumn,R.startColumn)):(b=R.startLineNumber,y=R.startColumn),L.endLineNumber>R.endLineNumber?(m=L.endLineNumber,A=L.endColumn):L.endLineNumber===R.endLineNumber?(m=L.endLineNumber,A=Math.max(L.endColumn,R.endColumn)):(m=R.endLineNumber,A=R.endColumn),new T(b,y,m,A)}intersectRanges(R){return T.intersectRanges(this,R)}static intersectRanges(R,L){let b=R.startLineNumber,y=R.startColumn,m=R.endLineNumber,A=R.endColumn;const C=L.startLineNumber,$=L.startColumn,v=L.endLineNumber,S=L.endColumn;return b<C?(b=C,y=$):b===C&&(y=Math.max(y,$)),m>v?(m=v,A=S):m===v&&(A=Math.min(A,S)),b>m||b===m&&y>A?null:new T(b,y,m,A)}equalsRange(R){return T.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(R){return new D.$ys(R.endLineNumber,R.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(R){return new D.$ys(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new T(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new T(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(R){return new T(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(R){return new T(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new T(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new T(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const m=R.startLineNumber|0,A=L.startLineNumber|0;if(m===A){const C=R.startColumn|0,$=L.startColumn|0;if(C===$){const v=R.endLineNumber|0,S=L.endLineNumber|0;if(v===S){const w=R.endColumn|0,u=L.endColumn|0;return w-u}return v-S}return C-$}return m-A}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$zs=T}),define(ke[168],Se([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class T{static insert(R,L){return{range:new D.$zs(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$As=T}),define(ke[169],Se([1,0,53,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.SelectionDirection=void 0;var g;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class R extends T.$zs{constructor(b,y,m,A){super(b,y,m,A),this.selectionStartLineNumber=b,this.selectionStartColumn=y,this.positionLineNumber=m,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,y){return b.selectionStartLineNumber===y.selectionStartLineNumber&&b.selectionStartColumn===y.selectionStartColumn&&b.positionLineNumber===y.positionLineNumber&&b.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,y):new R(b,y,this.startLineNumber,this.startColumn)}getPosition(){return new D.$ys(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$ys(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,y){return this.getDirection()===0?new R(b,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,y)}static fromPositions(b,y=b){return new R(b.lineNumber,b.column,y.lineNumber,y.column)}static fromRange(b,y){return y===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,y){if(b&&!y||!b&&y)return!1;if(!b&&!y)return!0;if(b.length!==y.length)return!1;for(let m=0,A=b.length;m<A;m++)if(!this.selectionsEqual(b[m],y[m]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,y,m,A,C){return C===0?new R(b,y,m,A):new R(m,A,b,y)}}e.$Bs=R}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,126]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=e.WordCharacterClass=void 0;var T;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class g extends D.$Ws{constructor(b){super(0);for(let y=0,m=b.length;y<m;y++)this.set(b.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.$Ys=g;function R(L){const b={};return y=>(b.hasOwnProperty(y)||(b[y]=L(y)),b[y])}e.$Zs=R(L=>new g(L))}),define(ke[127],Se([1,0,51,3,75]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=e.$$r=e.$0r=void 0,e.$0r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(C=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$0r)C.indexOf(v)>=0||($+="\\"+v);return $+="\\s]+)",new RegExp($,"g")}e.$$r=R();function L(C){let $=e.$$r;if(C&&C instanceof RegExp)if(C.global)$=C;else{let v="g";C.ignoreCase&&(v+="i"),C.multiline&&(v+="m"),C.unicode&&(v+="u"),$=new RegExp(C.source,v)}return $.lastIndex=0,$}e.$_r=L;const b=new g.$2c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(C){const $=b.unshift(C);return(0,T.$Pc)($)}e.$as=y;function m(C,$,v,S,w){if(w||(w=D.Iterable.first(b)),v.length>w.maxLen){let r=C-w.maxLen/2;return r<0?r=0:S+=r,v=v.substring(r,C+w.maxLen/2),m(C,$,v,S,w)}const u=Date.now(),o=C-1-S;let i=-1,n=null;for(let r=1;!(Date.now()-u>=w.timeBudget);r++){const a=o-w.windowSize*r;$.lastIndex=Math.max(0,a);const t=A($,v,o,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const r={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return $.lastIndex=0,r}return null}e.$bs=m;function A(C,$,v,S){let w;for(;w=C.exec($);){const u=w.index||0;if(u<=v&&C.lastIndex>=v)return w;if(S>0&&u>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var D;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let y=0,m=b.notIn.length;y<m;y++)switch(b.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,y){if(b.getTokenCount()===0)return!0;const m=b.findTokenIndexAtOffset(y-2),A=b.getStandardTokenType(m);return this.isOK(A)}g(b,y){for(let m=b;m<=y;m++){const A=String.fromCharCode(m);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=T;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of b)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.$wt=g;function R(L,b,y){L.has(b)?L.get(b).push(y):L.set(b,[y])}}),define(ke[173],Se([1,0,126]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Y=e.$4Y=e.$3Y=e.State=void 0;var T;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class g{constructor(S,w,u){const o=new Uint8Array(S*w);for(let i=0,n=S*w;i<n;i++)o[i]=u;this.a=o,this.rows=S,this.cols=w}get(S,w){return this.a[S*this.cols+w]}set(S,w,u){this.a[S*this.cols+w]=u}}class R{constructor(S){let w=0,u=0;for(let i=0,n=S.length;i<n;i++){const[r,a,t]=S[i];a>w&&(w=a),r>u&&(u=r),t>u&&(u=t)}w++,u++;const o=new g(u,w,0);for(let i=0,n=S.length;i<n;i++){const[r,a,t]=S[i];o.set(r,a,t)}this.a=o,this.b=w}nextState(S,w){return w<0||w>=this.b?0:this.a.get(S,w)}}e.$3Y=R;let L=null;function b(){return L===null&&(L=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var y;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let m=null;function A(){if(m===null){m=new D.$Ws(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<v.length;w++)m.set(v.charCodeAt(w),1);const S=".,;:";for(let w=0;w<S.length;w++)m.set(S.charCodeAt(w),2)}return m}class C{static a(S,w,u,o,i){let n=i-1;do{const r=w.charCodeAt(n);if(S.get(r)!==2)break;n--}while(n>o);if(o>0){const r=w.charCodeAt(o-1),a=w.charCodeAt(n);(r===40&&a===41||r===91&&a===93||r===123&&a===125)&&n--}return{range:{startLineNumber:u,startColumn:o+1,endLineNumber:u,endColumn:n+2},url:w.substring(o,n+1)}}static computeLinks(S,w=b()){const u=A(),o=[];for(let i=1,n=S.getLineCount();i<=n;i++){const r=S.getLineContent(i),a=r.length;let t=0,s=0,d=0,l=1,c=!1,h=!1,E=!1,I=!1;for(;t<a;){let f=!1;const p=r.charCodeAt(t);if(l===13){let k;switch(p){case 40:c=!0,k=0;break;case 41:k=c?0:1;break;case 91:E=!0,h=!0,k=0;break;case 93:E=!1,k=h?0:1;break;case 123:I=!0,k=0;break;case 125:k=I?0:1;break;case 39:case 34:case 96:d===p?k=1:d===39||d===34||d===96?k=0:k=1;break;case 42:k=d===42?1:0;break;case 124:k=d===124?1:0;break;case 32:k=E?0:1;break;default:k=u.get(p)}k===1&&(o.push(C.a(u,r,i,s,t)),f=!0)}else if(l===12){let k;p===91?(h=!0,k=0):k=u.get(p),k===1?f=!0:l=13}else l=w.nextState(l,p),l===0&&(f=!0);f&&(l=1,c=!1,h=!1,I=!1,s=t+1,d=p),t++}l===13&&o.push(C.a(u,r,i,s,a))}return o}}e.$4Y=C;function $(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:C.computeLinks(v)}e.$5Y=$}),define(ke[79],Se([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.$Tu=e.$Su=e.ModelConstants=e.PositionAffinity=e.$Ru=e.TrackedRangeStickiness=e.$Qu=e.$Pu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var g;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var R;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var b;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var y;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var m;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(m||(e.EndOfLineSequence=m={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.$en)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Pu=A;class C{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Qu=C;var $;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function v(r){return r&&typeof r.read=="function"}e.$Ru=v;var S;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var w;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class u{constructor(a,t,s,d,l,c){this.identifier=a,this.range=t,this.text=s,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=l,this._isTracked=c}}e.$Su=u;class o{constructor(a,t,s){this.regex=a,this.wordSeparators=t,this.simpleSearch=s}}e.$Tu=o;class i{constructor(a,t,s){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=s}}e.$Uu=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$Vu=n}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.NodeColor=e.$rB=void 0;class D{constructor(u,o){this.piece=u,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$sB)return g(this.right);let u=this;for(;u.parent!==e.$sB&&u.parent.left!==u;)u=u.parent;return u.parent===e.$sB?e.$sB:u.parent}prev(){if(this.left!==e.$sB)return R(this.left);let u=this;for(;u.parent!==e.$sB&&u.parent.right!==u;)u=u.parent;return u.parent===e.$sB?e.$sB:u.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$rB=D;var T;(function(w){w[w.Black=0]="Black",w[w.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$sB=new D(null,0),e.$sB.parent=e.$sB,e.$sB.left=e.$sB,e.$sB.right=e.$sB,e.$sB.color=0;function g(w){for(;w.left!==e.$sB;)w=w.left;return w}e.$tB=g;function R(w){for(;w.right!==e.$sB;)w=w.right;return w}e.$uB=R;function L(w){return w===e.$sB?0:w.size_left+w.piece.length+L(w.right)}function b(w){return w===e.$sB?0:w.lf_left+w.piece.lineFeedCnt+b(w.right)}function y(){e.$sB.parent=e.$sB}function m(w,u){const o=u.right;o.size_left+=u.size_left+(u.piece?u.piece.length:0),o.lf_left+=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),u.right=o.left,o.left!==e.$sB&&(o.left.parent=u),o.parent=u.parent,u.parent===e.$sB?w.root=o:u.parent.left===u?u.parent.left=o:u.parent.right=o,o.left=u,u.parent=o}e.$vB=m;function A(w,u){const o=u.left;u.left=o.right,o.right!==e.$sB&&(o.right.parent=u),o.parent=u.parent,u.size_left-=o.size_left+(o.piece?o.piece.length:0),u.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),u.parent===e.$sB?w.root=o:u===u.parent.right?u.parent.right=o:u.parent.left=o,o.right=u,u.parent=o}e.$wB=A;function C(w,u){let o,i;if(u.left===e.$sB?(i=u,o=i.right):u.right===e.$sB?(i=u,o=i.left):(i=g(u.right),o=i.right),i===w.root){w.root=o,o.color=0,u.detach(),y(),w.root.parent=e.$sB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===u?(o.parent=i.parent,S(w,o)):(i.parent===u?o.parent=i:o.parent=i.parent,S(w,o),i.left=u.left,i.right=u.right,i.parent=u.parent,i.color=u.color,u===w.root?w.root=i:u===u.parent.left?u.parent.left=i:u.parent.right=i,i.left!==e.$sB&&(i.left.parent=i),i.right!==e.$sB&&(i.right.parent=i),i.size_left=u.size_left,i.lf_left=u.lf_left,S(w,i)),u.detach(),o.parent.left===o){const a=L(o),t=b(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const s=a-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,v(w,o.parent,s,d)}}if(S(w,o.parent),n){y();return}let r;for(;o!==w.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,m(w,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(w,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,m(w,o.parent),o=w.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(w,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,m(w,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(w,o.parent),o=w.root));o.color=0,y()}e.$xB=C;function $(w,u){for(S(w,u);u!==w.root&&u.parent.color===1;)if(u.parent===u.parent.parent.left){const o=u.parent.parent.right;o.color===1?(u.parent.color=0,o.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.right&&(u=u.parent,m(w,u)),u.parent.color=0,u.parent.parent.color=1,A(w,u.parent.parent))}else{const o=u.parent.parent.left;o.color===1?(u.parent.color=0,o.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.left&&(u=u.parent,A(w,u)),u.parent.color=0,u.parent.parent.color=1,m(w,u.parent.parent))}w.root.color=0}e.$yB=$;function v(w,u,o,i){for(;u!==w.root&&u!==e.$sB;)u.parent.left===u&&(u.parent.size_left+=o,u.parent.lf_left+=i),u=u.parent}e.$zB=v;function S(w,u){let o=0,i=0;if(u!==w.root){for(;u!==w.root&&u===u.parent.right;)u=u.parent;if(u!==w.root)for(u=u.parent,o=L(u.left)-u.size_left,i=b(u.left)-u.lf_left,u.size_left+=o,u.lf_left+=i;u!==w.root&&(o!==0||i!==0);)u.parent.left===u&&(u.parent.size_left+=o,u.parent.lf_left+=i),u=u.parent}}e.$AB=S}),define(ke[175],Se([1,0,19,125]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.$Yu=void 0;class g{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,m){y=(0,T.$Ee)(y);const A=this.a,C=this.b,$=m.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,y),0),this.a.set(A.subarray(y),y+$),this.a.set(m,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(y,m){return y=(0,T.$Ee)(y),m=(0,T.$Ee)(m),this.a[y]===m?!1:(this.a[y]=m,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,m){y=(0,T.$Ee)(y),m=(0,T.$Ee)(m);const A=this.a,C=this.b;if(y>=A.length)return!1;const $=A.length-y;return m>=$&&(m=$),m===0?!1:(this.a=new Uint32Array(A.length-m),this.a.set(A.subarray(0,y),0),this.a.set(A.subarray(y+m),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,T.$Ee)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let m=this.c[0]+1;m===0&&(this.b[0]=this.a[0],m++),y>=this.a.length&&(y=this.a.length-1);for(let A=m;A<=y;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let m=0,A=this.a.length-1,C=0,$=0,v=0;for(;m<=A;)if(C=m+(A-m)/2|0,$=this.b[C],v=$-this.a[C],y<v)A=C-1;else if(y>=$)m=C+1;else break;return new L(C,y-v)}}e.$Yu=g;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const m=this.e[y],A=m>0?this.d[m-1]:0;return new L(m,y-A)}removeValues(y,m){this.a.splice(y,m),this.f(y)}insertValues(y,m){this.a=(0,D.$Vb)(this.a,y,m),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,m=this.a.length;y<m;y++){const A=this.a[y],C=y>0?this.d[y-1]:0;this.d[y]=C+A;for(let $=0;$<A;$++)this.e[C+$]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,m){this.a[y]!==m&&(this.a[y]=m,this.f(y))}}e.$Zu=R;class L{constructor(y,m){this.index=y,this.remainder=m,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=m}}e.$1u=L}),define(ke[176],Se([1,0,13,53,175]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=void 0;class R{constructor(b,y,m,A){this.d=b,this.f=y,this.g=m,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const y=b.changes;for(const m of y)this.o(m.range),this.p(new T.$ys(m.range.startLineNumber,m.range.startColumn),m.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,y=this.f.length,m=new Uint32Array(y);for(let A=0;A<y;A++)m[A]=this.f[A].length+b;this.j=new g.$Yu(m)}}n(b,y){this.f[b]=y,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,y){if(y.length===0)return;const m=(0,D.$Te)(y);if(m.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+m[0]+this.f[b.lineNumber-1].substring(b.column-1));return}m[m.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+m[0]);const A=new Uint32Array(m.length-1);for(let C=1;C<m.length;C++)this.f.splice(b.lineNumber+C-1,0,m[C]),A[C-1]=m[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$2u=R}),define(ke[99],Se([1,0,13,171,53,29,79]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=void 0;const b=999;class y{constructor(i,n,r,a){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=m(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Re(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new L.$Tu(n,this.wordSeparators?(0,T.$Zs)(this.wordSeparators):null,r?this.searchString:null)}}e.$BB=y;function m(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const r=o.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$CB=m;function A(o,i,n){if(!n)return new L.$Qu(o,null);const r=[];for(let a=0,t=i.length;a<t;a++)r[a]=i[a];return new L.$Qu(o,r)}e.$DB=A;class C{constructor(i){const n=[];let r=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[r++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;r<a;){const t=r+((a-r)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(r=t,a=t):r=t+1}return r+1}}class ${static findMatches(i,n,r,a,t){const s=n.parseSearchRequest();return s?s.regex.multiline?this.b(i,r,new u(s.wordSeparators,s.regex),a,t):this.c(i,r,s,a,t):[]}static a(i,n,r,a,t,s){let d,l=0;a?(l=a.findLineFeedCountBeforeOffset(t),d=n+t+l):d=n+t;let c;if(a){const f=a.findLineFeedCountBeforeOffset(t+s.length)-l;c=d+s.length+f}else c=d+s.length;const h=i.getPositionAt(d),E=i.getPositionAt(c);return new R.$zs(h.lineNumber,h.column,E.lineNumber,E.column)}static b(i,n,r,a,t){const s=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),l=i.getEOL()===`\r
`?new C(d):null,c=[];let h=0,E;for(r.reset(0);E=r.next(d);)if(c[h++]=A(this.a(i,s,d,l,E.index,E[0]),E,a),h>=t)return c;return c}static c(i,n,r,a,t){const s=[];let d=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(r,c,n.startLineNumber,n.startColumn-1,d,s,a,t),s}const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(r,l,n.startLineNumber,n.startColumn-1,d,s,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&d<t;c++)d=this.d(r,i.getLineContent(c),c,0,d,s,a,t);if(d<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(r,c,n.endLineNumber,0,d,s,a,t)}return s}static d(i,n,r,a,t,s,d,l){const c=i.wordSeparators;if(!d&&i.simpleSearch){const I=i.simpleSearch,f=I.length,p=n.length;let k=-f;for(;(k=n.indexOf(I,k+f))!==-1;)if((!c||w(c,n,p,k,f))&&(s[t++]=new L.$Qu(new R.$zs(r,k+1+a,r,k+1+f+a),null),t>=l))return t;return t}const h=new u(i.wordSeparators,i.regex);let E;h.reset(0);do if(E=h.next(n),E&&(s[t++]=A(new R.$zs(r,E.index+1+a,r,E.index+1+E[0].length+a),E,d),t>=l))return t;while(E);return t}static findNextMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const s=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,s,a):this.f(i,r,s,a)}static e(i,n,r,a){const t=new g.$ys(n.lineNumber,1),s=i.getOffsetAt(t),d=i.getLineCount(),l=i.getValueInRange(new R.$zs(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),c=i.getEOL()===`\r
`?new C(l):null;r.reset(n.column-1);const h=r.next(l);return h?A(this.a(i,s,l,c,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new g.$ys(1,1),r,a):null}static f(i,n,r,a){const t=i.getLineCount(),s=n.lineNumber,d=i.getLineContent(s),l=this.g(r,d,s,n.column,a);if(l)return l;for(let c=1;c<=t;c++){const h=(s+c-1)%t,E=i.getLineContent(h+1),I=this.g(r,E,h+1,1,a);if(I)return I}return null}static g(i,n,r,a,t){i.reset(a-1);const s=i.next(n);return s?A(new R.$zs(r,s.index+1,r,s.index+1+s[0].length),s,t):null}static findPreviousMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const s=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,s,a):this.j(i,r,s,a)}static h(i,n,r,a){const t=this.b(i,new R.$zs(1,1,n.lineNumber,n.column),r,a,10*b);if(t.length>0)return t[t.length-1];const s=i.getLineCount();return n.lineNumber!==s||n.column!==i.getLineMaxColumn(s)?this.h(i,new g.$ys(s,i.getLineMaxColumn(s)),r,a):null}static j(i,n,r,a){const t=i.getLineCount(),s=n.lineNumber,d=i.getLineContent(s).substring(0,n.column-1),l=this.k(r,d,s,a);if(l)return l;for(let c=1;c<=t;c++){const h=(t+s-c-1)%t,E=i.getLineContent(h+1),I=this.k(r,E,h+1,a);if(I)return I}return null}static k(i,n,r,a){let t=null,s;for(i.reset(0);s=i.next(n);)t=A(new R.$zs(r,s.index+1,r,s.index+1+s[0].length),s,a);return t}}e.$EB=$;function v(o,i,n,r,a){if(r===0)return!0;const t=i.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const s=i.charCodeAt(r);if(o.get(s)!==0)return!0}return!1}function S(o,i,n,r,a){if(r+a===n)return!0;const t=i.charCodeAt(r+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const s=i.charCodeAt(r+a-1);if(o.get(s)!==0)return!0}return!1}function w(o,i,n,r,a){return v(o,i,n,r,a)&&S(o,i,n,r,a)}e.$FB=w;class u{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const a=r.index,t=r[0].length;if(a===this.b&&t===this.c){if(t===0){D.$af(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||w(this._wordSeparators,i,n,a,t))return r}while(r);return null}}e.$GB=u}),define(ke[128],Se([1,0,53,29,79,174,99]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;const b=65535;function y(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class m{constructor(i,n,r,a,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=a,this.isBasicASCII=t}}function A(o,i=!0){const n=[0];let r=1;for(let a=0,t=o.length;a<t;a++){const s=o.charCodeAt(a);s===13?a+1<t&&o.charCodeAt(a+1)===10?(n[r++]=a+2,a++):n[r++]=a+1:s===10&&(n[r++]=a+1)}return i?y(n):n}e.$HB=A;function C(o,i){o.length=0,o[0]=0;let n=1,r=0,a=0,t=0,s=!0;for(let l=0,c=i.length;l<c;l++){const h=i.charCodeAt(l);h===13?l+1<c&&i.charCodeAt(l+1)===10?(t++,o[n++]=l+2,l++):(r++,o[n++]=l+1):h===10?(a++,o[n++]=l+1):s&&h!==9&&(h<32||h>126)&&(s=!1)}const d=new m(y(o),r,a,t,s);return o.length=0,d}e.$IB=C;class ${constructor(i,n,r,a,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=a,this.length=t}}e.$JB=$;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$KB=v;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$sB&&i.iterate(i.root,r=>(r!==R.$sB&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class w{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let a=0;a<r.length;a++){const t=r[a];if(t.node.parent===null||t.nodeStartOffset>=i){r[a]=null,n=!0;continue}}if(n){const a=[];for(const t of r)t!==null&&a.push(t);this.b=a}}}class u{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=R.$sB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let a=null;for(let t=0,s=i.length;t<s;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new $(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new w(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,r=n-Math.floor(n/3),a=r*2;let t="",s=0;const d=[];if(this.iterate(this.root,l=>{const c=this.R(l),h=c.length;if(s<=r||s+h<a)return t+=c,s+=h,!0;const E=t.replace(/\r\n|\r|\n/g,i);return d.push(new v(E,A(E))),t=c,s=h,!0}),s>0){const l=t.replace(/\r\n|\r|\n/g,i);d.push(new v(l,A(l)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===R.$sB)return!0;const t=this.R(a),s=t.length,d=i.G(n),l=i.G(n+s),c=i.getValueInRange2(d,l);return n+=s,t===c})}getOffsetAt(i,n){let r=0,a=this.root;for(;a!==R.$sB;)if(a.left!==R.$sB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){r+=a.size_left;const t=this.B(a,i-a.lf_left-2);return r+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const a=i;for(;n!==R.$sB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const s=this.getOffsetAt(r+1,1),d=a-s;return new D.$ys(r+1,d+1)}return new D.$ys(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$sB){const t=this.getOffsetAt(r+1,1),s=a-i-t;return new D.$ys(r+1,s+1)}else n=n.right;return new D.$ys(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,l=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(c+i.remainder,c+n.remainder)}let r=i.node;const a=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let s=a.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==R.$sB;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){s+=d.substring(l,l+n.remainder);break}else s+=d.substr(l,r.piece.length);r=r.next()}return s}getLinesContent(){const i=[];let n=0,r="",a=!1;return this.iterate(this.root,t=>{if(t===R.$sB)return!0;const s=t.piece;let d=s.length;if(d===0)return!0;const l=this.a[s.bufferIndex].buffer,c=this.a[s.bufferIndex].lineStarts,h=s.start.line,E=s.end.line;let I=c[h]+s.start.column;if(a&&(l.charCodeAt(I)===10&&(I++,d--),i[n++]=r,r="",a=!1,d===0))return!0;if(h===E)return!this.f&&l.charCodeAt(I+d-1)===13?(a=!0,r+=l.substr(I,d-1)):r+=l.substr(I,d),!0;r+=this.f?l.substring(I,Math.max(I,c[h+1]-this.e)):l.substring(I,c[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let f=h+1;f<E;f++)r=this.f?l.substring(c[f],c[f+1]-this.e):l.substring(c[f],c[f+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&l.charCodeAt(c[E]+s.end.column-1)===13?(a=!0,s.end.column===0?n--:r=l.substr(c[E],s.end.column-1)):r=l.substr(c[E],s.end.column),!0}),a&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,a,t,s,d,l,c,h,E){const I=this.a[i.piece.bufferIndex],f=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,s);let P;const j={line:0,column:0};let z,M;n._wordSeparators?(z=I.buffer.substring(p,k),M=F=>F+p,n.reset(0)):(z=I.buffer,M=F=>F,n.reset(p));do if(P=n.next(z),P){if(M(P.index)>=k)return h;this.s(i,M(P.index)-f,j);const F=this.t(i.piece.bufferIndex,t,j),N=j.line===t.line?j.column-t.column+a:j.column+1,O=N+P[0].length;if(E[h++]=(0,L.$DB)(new T.$zs(r+F,N,r+F,O),P,l),M(P.index)+P[0].length>=k||h>=c)return h}while(P);return h}findMatchesLineByLine(i,n,r,a){const t=[];let s=0;const d=new L.$GB(n.wordSeparators,n.regex);let l=this.H(i.startLineNumber,i.startColumn);if(l===null)return[];const c=this.H(i.endLineNumber,i.endColumn);if(c===null)return[];let h=this.s(l.node,l.remainder);const E=this.s(c.node,c.remainder);if(l.node===c.node)return this.findMatchesInNode(l.node,d,i.startLineNumber,i.startColumn,h,E,n,r,a,s,t),t;let I=i.startLineNumber,f=l.node;for(;f!==c.node;){const k=this.t(f.piece.bufferIndex,h,f.piece.end);if(k>=1){const j=this.a[f.piece.bufferIndex].lineStarts,z=this.u(f.piece.bufferIndex,f.piece.start),M=j[h.line+k],F=I===i.startLineNumber?i.startColumn:1;if(s=this.findMatchesInNode(f,d,I,F,h,this.s(f,M-z),n,r,a,s,t),s>=a)return t;I+=k}const P=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const j=this.getLineContent(I).substring(P,i.endColumn-1);return s=this.n(n,d,j,i.endLineNumber,P,s,t,r,a),t}if(s=this.n(n,d,this.getLineContent(I).substr(P),I,P,s,t,r,a),s>=a)return t;I++,l=this.H(I,1),f=l.node,h=this.s(l.node,l.remainder)}if(I===i.endLineNumber){const k=I===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(I).substring(k,i.endColumn-1);return s=this.n(n,d,P,i.endLineNumber,k,s,t,r,a),t}const p=I===i.startLineNumber?i.startColumn:1;return s=this.findMatchesInNode(c.node,d,I,p,h,E,n,r,a,s,t),t}n(i,n,r,a,t,s,d,l,c){const h=i.wordSeparators;if(!l&&i.simpleSearch){const I=i.simpleSearch,f=I.length,p=r.length;let k=-f;for(;(k=r.indexOf(I,k+f))!==-1;)if((!h||(0,L.$FB)(h,r,p,k,f))&&(d[s++]=new g.$Qu(new T.$zs(a,k+1+t,a,k+1+f+t),null),s>=c))return s;return s}let E;n.reset(0);do if(E=n.next(r),E&&(d[s++]=(0,L.$DB)(new T.$zs(a,E.index+1+t,a,E.index+1+E[0].length+t),E,l),s>=c))return s;while(E);return s}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==R.$sB){const{node:a,remainder:t,nodeStartOffset:s}=this.G(i),d=a.piece,l=d.bufferIndex,c=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&s+d.length===i&&n.length<b){this.F(a,n),this.y();return}if(s===i)this.o(n,a),this.h.validate(i);else if(s+a.piece.length>i){const h=[];let E=new $(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),this.u(l,d.end)-this.u(l,c));if(this.K()&&this.M(n)&&this.I(a,t)===10){const k={line:E.start.line+1,column:0};E=new $(E.bufferIndex,k,E.end,this.t(E.bufferIndex,k,E.end),E.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const k=this.s(a,t-1);this.C(a,k),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,c);else this.C(a,c);const I=this.w(n);E.length>0&&this.S(a,E);let f=a;for(let p=0;p<I.length;p++)f=this.S(f,I[p]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let s=1;s<a.length;s++)t=this.S(t,a[s])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$sB)return;const r=this.G(i),a=this.G(i+n),t=r.node,s=a.node;if(t===s){const I=this.s(t,r.remainder),f=this.s(t,a.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,R.$xB)(this,t),this.N(p),this.y();return}this.D(t,f),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,I),this.O(t),this.y();return}this.E(t,I,f),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(i),t.piece.length===0&&d.push(t);const c=this.s(s,a.remainder);this.D(s,c),s.piece.length===0&&d.push(s);const h=t.next();for(let I=h;I!==R.$sB&&I!==s;I=I.next())d.push(I);const E=t.piece.length===0?t.prev():t;this.v(d),this.O(E),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const s=n.piece,d={line:s.start.line+1,column:0},l=new $(s.bufferIndex,d,s.end,this.t(s.bufferIndex,d,s.end),s.length-1);n.piece=l,i+=`
`,(0,R.$zB)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let s=a.length-2;s>=0;s--)t=this.T(t,a[s]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),a=this.S(n,r[0]);let t=a;for(let s=1;s<r.length;s++)t=this.S(t,r[s]);this.N(a)}s(i,n,r){const a=i.piece,t=i.piece.bufferIndex,s=this.a[t].lineStarts,l=s[a.start.line]+a.start.column+n;let c=a.start.line,h=a.end.line,E=0,I=0,f=0;for(;c<=h&&(E=c+(h-c)/2|0,f=s[E],E!==h);)if(I=s[E+1],l<f)h=E-1;else if(l>=I)c=E+1;else break;return r?(r.line=E,r.column=l-f,null):{line:E,column:l-f}}t(i,n,r){if(r.column===0)return r.line-n.line;const a=this.a[i].lineStarts;if(r.line===a.length-1)return r.line-n.line;const t=a[r.line+1],s=a[r.line]+r.column;if(t>s+1)return r.line-n.line;const d=s-1;return this.a[i].buffer.charCodeAt(d)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$xB)(this,i[n])}w(i){if(i.length>b){const h=[];for(;i.length>b;){const I=i.charCodeAt(b-1);let f;I===13||I>=55296&&I<=56319?(f=i.substring(0,b-1),i=i.substring(b-1)):(f=i.substring(0,b),i=i.substring(b));const p=A(f);h.push(new $(this.a.length,{line:0,column:0},{line:p.length-1,column:f.length-p[p.length-1]},p.length-1,f.length)),this.a.push(new v(f,p))}const E=A(i);return h.push(new $(this.a.length,{line:0,column:0},{line:E.length-1,column:i.length-E[E.length-1]},E.length-1,i.length)),this.a.push(new v(i,E)),h}let n=this.a[0].buffer.length;const r=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<r.length;h++)r[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<r.length;h++)r[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[s],l={line:s,column:d},c=new $(0,a,l,this.t(0,a,l),t-n);return this.g=l,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,a="";const t=this.h.get2(i);if(t){r=t.node;const s=this.B(r,i-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)a=d.substring(l+s,l+r.piece.length);else{const c=this.B(r,i-t.nodeStartLineNumber);return d.substring(l+s,l+c-n)}}else{let s=0;const d=i;for(;r!==R.$sB;)if(r.left!==R.$sB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const l=this.B(r,i-r.lf_left-2),c=this.B(r,i-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,E=this.u(r.piece.bufferIndex,r.piece.start);return s+=r.size_left,this.h.set({node:r,nodeStartOffset:s,nodeStartLineNumber:d-(i-1-r.lf_left)}),h.substring(E+l,E+c-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const l=this.B(r,i-r.lf_left-2),c=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);a=c.substring(h+l,h+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.$sB;){const s=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return a+=s.substring(l,l+d-n),a}else{const d=this.u(r.piece.bufferIndex,r.piece.start);a+=s.substr(d,r.piece.length)}r=r.next()}return a}y(){let i=this.root,n=1,r=0;for(;i!==R.$sB;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,a=this.s(i,n),t=a.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const s=this.t(i.piece.bufferIndex,r.start,a);if(s!==t)return{index:s,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const r=i.piece,a=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?a[r.end.line]+r.end.column-a[r.start.line]-r.start.column:a[t]-a[r.start.line]-r.start.column}C(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),s=n,d=this.u(r.bufferIndex,s),l=this.t(r.bufferIndex,r.start,s),c=l-a,h=d-t,E=r.length+h;i.piece=new $(r.bufferIndex,r.start,s,l,E),(0,R.$zB)(this,i,h,c)}D(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),s=n,d=this.t(r.bufferIndex,s,r.end),l=this.u(r.bufferIndex,s),c=d-a,h=t-l,E=r.length+h;i.piece=new $(r.bufferIndex,s,r.end,d,E),(0,R.$zB)(this,i,h,c)}E(i,n,r){const a=i.piece,t=a.start,s=a.end,d=a.length,l=a.lineFeedCnt,c=n,h=this.t(a.bufferIndex,a.start,c),E=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new $(a.bufferIndex,a.start,c,h,E),(0,R.$zB)(this,i,E-d,h-l);const I=new $(a.bufferIndex,r,s,this.t(a.bufferIndex,r,s),this.u(a.bufferIndex,s)-this.u(a.bufferIndex,r)),f=this.S(i,I);this.N(f)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let f=0;f<t.length;f++)t[f]+=a;if(r){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const s=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[s],l={line:s,column:d},c=i.piece.length+n.length,h=i.piece.lineFeedCnt,E=this.t(0,i.piece.start,l),I=E-h;i.piece=new $(i.piece.bufferIndex,i.piece.start,l,E,c),this.g=l,(0,R.$zB)(this,i,n.length,I)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let a=0;for(;n!==R.$sB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,a=0;for(;r!==R.$sB;)if(r.left!==R.$sB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),s=this.B(r,i-r.lf_left-1);return a+=r.size_left,{node:r,remainder:Math.min(t+n-1,s),nodeStartOffset:a}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:a};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.$sB;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),s=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:s}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$sB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=r[a]+n.start.column;return a===r.length-1||r[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$sB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const s=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new $(i.piece.bufferIndex,i.piece.start,t,d,s),(0,R.$zB)(this,i,-1,-1),i.piece.length===0&&r.push(i);const l={line:n.piece.start.line+1,column:0},c=n.piece.length-1,h=this.t(n.piece.bufferIndex,l,n.piece.end);n.piece=new $(n.piece.bufferIndex,l,n.piece.end,h,c),(0,R.$zB)(this,n,-1,-1),n.piece.length===0&&r.push(n);const E=this.w(`\r
`);this.S(i,E[0]);for(let I=0;I<r.length;I++)(0,R.$xB)(this,r[I])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,R.$xB)(this,r);else{const a=r.piece,t={line:a.start.line+1,column:0},s=a.length-1,d=this.t(a.bufferIndex,t,a.end);r.piece=new $(a.bufferIndex,t,a.end,d,s),(0,R.$zB)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$sB)return n(R.$sB);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$sB)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,a=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,a)}S(i,n){const r=new R.$rB(n,1);if(r.left=R.$sB,r.right=R.$sB,r.parent=R.$sB,r.size_left=0,r.lf_left=0,this.root===R.$sB)this.root=r,r.color=0;else if(i.right===R.$sB)i.right=r,r.parent=i;else{const t=(0,R.$tB)(i.right);t.left=r,r.parent=t}return(0,R.$yB)(this,r),r}T(i,n){const r=new R.$rB(n,1);if(r.left=R.$sB,r.right=R.$sB,r.parent=R.$sB,r.size_left=0,r.lf_left=0,this.root===R.$sB)this.root=r,r.color=0;else if(i.left===R.$sB)i.left=r,r.parent=i;else{const a=(0,R.$uB)(i.left);a.right=r,r.parent=a}return(0,R.$yB)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$LB=u}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7=e.$Q7=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$Q7=D;class T{constructor(R){this.identifier=R}}e.$R7=T}),define(ke[178],Se([1,0,4,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Rd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,y){return this.a.set(b,y),this.handleChange([b]),(0,T.$Pc)(()=>{this.a.get(b)===y&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,y){this.b.get(b)?.dispose();const m=new R(this,b,y);return this.b.set(b,m),(0,T.$Pc)(()=>{const A=this.b.get(b);!A||A!==m||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const y=this.get(b);if(y)return y;const m=this.b.get(b);return!m||m.isResolved?null:(await m.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const m=this.b.get(b);return!!(!m||m.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$$s=g;class R extends T.$Rc{get isResolved(){return this.c}constructor(b,y,m){super(),this.f=b,this.g=y,this.h=m,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[179],Se([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class R extends T.$Rc{constructor($,v="",S="",w=!0,u){super(),this.h=this.B(new D.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=v,this.u=S,this.w=w,this.C=u}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,v){this.C&&await this.C($)}}e.$Ai=R;class L extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new D.$Rd),this.onWillRun=this.f.event,this.m=this.B(new D.$Rd),this.onDidRun=this.m.event}async run($,v){if(!$.enabled)return;this.f.fire({action:$});let S;try{await this.u($,v)}catch(w){S=w}this.m.fire({action:$,error:S})}async u($,v){await $.run(v)}}e.$Bi=L;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let v=[];for(const S of $)S.length&&(v.length?v=[...v,new b,...S]:v=S);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=b;class y{get actions(){return this.a}constructor($,v,S,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=v,this.class=w,this.a=S}async run(){}}e.$Di=y;class m extends R{static{this.ID="vs.actions.empty"}constructor(){super(m.ID,g.localize(0,null),void 0,!1)}}e.$Ei=m;function A(C){return{id:C.id,label:C.label,class:void 0,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...$)=>C.run(...$),tooltip:C.label}}e.$Fi=A}),define(ke[181],Se([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const T=60,g=T*60,R=g*24,L=R*7,b=R*30,y=R*365;function m(C,$,v,S){typeof C!="number"&&(C=C.getTime());const w=Math.round((new Date().getTime()-C)/1e3);if(w<-30)return(0,D.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,D.localize)(1,null);let u;return w<T?(u=w,$?u===1?v?(0,D.localize)(2,null,u):(0,D.localize)(3,null,u):v?(0,D.localize)(4,null,u):(0,D.localize)(5,null,u):u===1?v?(0,D.localize)(6,null,u):(0,D.localize)(7,null,u):v?(0,D.localize)(8,null,u):(0,D.localize)(9,null,u)):w<g?(u=Math.floor(w/T),$?u===1?v?(0,D.localize)(10,null,u):(0,D.localize)(11,null,u):v?(0,D.localize)(12,null,u):(0,D.localize)(13,null,u):u===1?v?(0,D.localize)(14,null,u):(0,D.localize)(15,null,u):v?(0,D.localize)(16,null,u):(0,D.localize)(17,null,u)):w<R?(u=Math.floor(w/g),$?u===1?v?(0,D.localize)(18,null,u):(0,D.localize)(19,null,u):v?(0,D.localize)(20,null,u):(0,D.localize)(21,null,u):u===1?v?(0,D.localize)(22,null,u):(0,D.localize)(23,null,u):v?(0,D.localize)(24,null,u):(0,D.localize)(25,null,u)):w<L?(u=Math.floor(w/R),$?u===1?(0,D.localize)(26,null,u):(0,D.localize)(27,null,u):u===1?(0,D.localize)(28,null,u):(0,D.localize)(29,null,u)):w<b?(u=Math.floor(w/L),$?u===1?v?(0,D.localize)(30,null,u):(0,D.localize)(31,null,u):v?(0,D.localize)(32,null,u):(0,D.localize)(33,null,u):u===1?v?(0,D.localize)(34,null,u):(0,D.localize)(35,null,u):v?(0,D.localize)(36,null,u):(0,D.localize)(37,null,u)):w<y?(u=Math.floor(w/b),$?u===1?v?(0,D.localize)(38,null,u):(0,D.localize)(39,null,u):v?(0,D.localize)(40,null,u):(0,D.localize)(41,null,u):u===1?v?(0,D.localize)(42,null,u):(0,D.localize)(43,null,u):v?(0,D.localize)(44,null,u):(0,D.localize)(45,null,u)):(u=Math.floor(w/y),$?u===1?v?(0,D.localize)(46,null,u):(0,D.localize)(47,null,u):v?(0,D.localize)(48,null,u):(0,D.localize)(49,null,u):u===1?v?(0,D.localize)(50,null,u):(0,D.localize)(51,null,u):v?(0,D.localize)(52,null,u):(0,D.localize)(53,null,u))}e.$jm=m;function A(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=A}),define(ke[183],Se([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[43],Se([1,0,19,18,183]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function R(C,$){return $&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),L(C.stack)||L(C.stacktrace)):b(C)}function L(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function y(C=null,$=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const v=D.$Gb(C),S=y(v[0],$);return v.length>1?g.localize(4,null,S,v.length):S}if(T.$Cf(C))return C;if(C.detail){const v=C.detail;if(v.error)return R(v.error,$);if(v.exception)return R(v.exception,$)}return C.stack?R(C,$):C.message?C.message:g.localize(5,null)}e.$Gi=y;function m(C){const $=C;return $ instanceof Error&&Array.isArray($.actions)}e.$Hi=m;function A(C,$){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=$,v}e.$Ii=A}),define(ke[184],Se([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let T=!1,g=!1,R=!1,L=!1,b=!1,y=!1,m=!1,A=!1,C=!1,$=!1,v,S=e.$g,w=e.$g,u,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",a=r&&n?.type==="renderer";if(typeof navigator=="object"&&!a)o=navigator.userAgent,T=o.indexOf("Windows")>=0,g=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,y=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=v,w=navigator.language;else if(typeof n=="object"){T=n.platform==="win32",g=n.platform==="darwin",R=n.platform==="linux",L=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,m=r,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,S=e.$g;const f=n.env.VSCODE_NLS_CONFIG;if(f)try{const p=JSON.parse(f),k=p.availableLanguages["*"];v=p.locale,w=p.osLocale,S=k||e.$g,u=p._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var t;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=s;let d=0;g?d=1:T?d=3:R&&(d=2),e.$i=T,e.$j=g,e.$k=R,e.$l=L,e.$m=b,e.$n=m,e.$o=y,e.$p=y&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=$,e.$t=C,e.$u=d,e.$v=o,e.$w=S;var l;(function(f){function p(){return e.$w}f.value=p;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}f.isDefaultVariant=k;function P(){return e.$w==="en"}f.isDefault=P})(l||(e.Language=l={})),e.$x=v,e.$y=w,e.$z=u,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const f=[];i.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let P=0,j=f.length;P<j;P++){const z=f[P];if(z.id===k.data.vscodeScheduleAsyncWork){f.splice(P,1),z.callback();return}}});let p=0;return k=>{const P=++p;f.push({id:P,callback:k}),i.postMessage({vscodeScheduleAsyncWork:P},"*")}}return f=>setTimeout(f)})();var c;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=g||A?2:T?1:3;let h=!0,E=!1;function I(){if(!E){E=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,h=new Uint16Array(f.buffer)[0]===(2<<8)+1}return h}e.$D=I,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ke[49],Se([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const R=g.process;T={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$cc=T.platform,e.$dc=T.arch}),define(ke[16],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const T=65,g=97,R=90,L=122,b=46,y=47,m=92,A=58,C=63;class $ extends Error{constructor(s,d,l){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const h=s.indexOf(".")!==-1?"property":"argument";let E=`The "${s}" ${h} ${c} of type ${d}`;E+=`. Received type ${typeof l}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,s){if(t===null||typeof t!="object")throw new $(s,"Object",t)}function S(t,s){if(typeof t!="string")throw new $(s,"string",t)}const w=D.$cc==="win32";function u(t){return t===y||t===m}function o(t){return t===y}function i(t){return t>=T&&t<=R||t>=g&&t<=L}function n(t,s,d,l){let c="",h=0,E=-1,I=0,f=0;for(let p=0;p<=t.length;++p){if(p<t.length)f=t.charCodeAt(p);else{if(l(f))break;f=y}if(l(f)){if(!(E===p-1||I===1))if(I===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const k=c.lastIndexOf(d);k===-1?(c="",h=0):(c=c.slice(0,k),h=c.length-1-c.lastIndexOf(d)),E=p,I=0;continue}else if(c.length!==0){c="",h=0,E=p,I=0;continue}}s&&(c+=c.length>0?`${d}..`:"..",h=2)}else c.length>0?c+=`${d}${t.slice(E+1,p)}`:c=t.slice(E+1,p),h=p-E-1;E=p,I=0}else f===b&&I!==-1?++I:I=-1}return c}function r(t,s){v(s,"pathObject");const d=s.dir||s.root,l=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${l}`:`${d}${t}${l}`:l}e.$ec={resolve(...t){let s="",d="",l=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],S(h,"path"),h.length===0)continue}else s.length===0?h=D.cwd():(h=D.env[`=${s}`]||D.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==s.toLowerCase()&&h.charCodeAt(2)===m)&&(h=`${s}\\`));const E=h.length;let I=0,f="",p=!1;const k=h.charCodeAt(0);if(E===1)u(k)&&(I=1,p=!0);else if(u(k))if(p=!0,u(h.charCodeAt(1))){let P=2,j=P;for(;P<E&&!u(h.charCodeAt(P));)P++;if(P<E&&P!==j){const z=h.slice(j,P);for(j=P;P<E&&u(h.charCodeAt(P));)P++;if(P<E&&P!==j){for(j=P;P<E&&!u(h.charCodeAt(P));)P++;(P===E||P!==j)&&(f=`\\\\${z}\\${h.slice(j,P)}`,I=P)}}}else I=1;else i(k)&&h.charCodeAt(1)===A&&(f=h.slice(0,2),I=2,E>2&&u(h.charCodeAt(2))&&(p=!0,I=3));if(f.length>0)if(s.length>0){if(f.toLowerCase()!==s.toLowerCase())continue}else s=f;if(l){if(s.length>0)break}else if(d=`${h.slice(I)}\\${d}`,l=p,p&&s.length>0)break}return d=n(d,!l,"\\",u),l?`${s}\\${d}`:`${s}${d}`||"."},normalize(t){S(t,"path");const s=t.length;if(s===0)return".";let d=0,l,c=!1;const h=t.charCodeAt(0);if(s===1)return o(h)?"\\":t;if(u(h))if(c=!0,u(t.charCodeAt(1))){let I=2,f=I;for(;I<s&&!u(t.charCodeAt(I));)I++;if(I<s&&I!==f){const p=t.slice(f,I);for(f=I;I<s&&u(t.charCodeAt(I));)I++;if(I<s&&I!==f){for(f=I;I<s&&!u(t.charCodeAt(I));)I++;if(I===s)return`\\\\${p}\\${t.slice(f)}\\`;I!==f&&(l=`\\\\${p}\\${t.slice(f,I)}`,d=I)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(l=t.slice(0,2),d=2,s>2&&u(t.charCodeAt(2))&&(c=!0,d=3));let E=d<s?n(t.slice(d),!c,"\\",u):"";return E.length===0&&!c&&(E="."),E.length>0&&u(t.charCodeAt(s-1))&&(E+="\\"),l===void 0?c?`\\${E}`:E:c?`${l}\\${E}`:`${l}${E}`},isAbsolute(t){S(t,"path");const s=t.length;if(s===0)return!1;const d=t.charCodeAt(0);return u(d)||s>2&&i(d)&&t.charCodeAt(1)===A&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,d;for(let h=0;h<t.length;++h){const E=t[h];S(E,"path"),E.length>0&&(s===void 0?s=d=E:s+=`\\${E}`)}if(s===void 0)return".";let l=!0,c=0;if(typeof d=="string"&&u(d.charCodeAt(0))){++c;const h=d.length;h>1&&u(d.charCodeAt(1))&&(++c,h>2&&(u(d.charCodeAt(2))?++c:l=!1))}if(l){for(;c<s.length&&u(s.charCodeAt(c));)c++;c>=2&&(s=`\\${s.slice(c)}`)}return e.$ec.normalize(s)},relative(t,s){if(S(t,"from"),S(s,"to"),t===s)return"";const d=e.$ec.resolve(t),l=e.$ec.resolve(s);if(d===l||(t=d.toLowerCase(),s=l.toLowerCase(),t===s))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===m;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===m;)h--;const E=h-c;let I=0;for(;I<s.length&&s.charCodeAt(I)===m;)I++;let f=s.length;for(;f-1>I&&s.charCodeAt(f-1)===m;)f--;const p=f-I,k=E<p?E:p;let P=-1,j=0;for(;j<k;j++){const M=t.charCodeAt(c+j);if(M!==s.charCodeAt(I+j))break;M===m&&(P=j)}if(j!==k){if(P===-1)return l}else{if(p>k){if(s.charCodeAt(I+j)===m)return l.slice(I+j+1);if(j===2)return l.slice(I+j)}E>k&&(t.charCodeAt(c+j)===m?P=j:j===2&&(P=3)),P===-1&&(P=0)}let z="";for(j=c+P+1;j<=h;++j)(j===h||t.charCodeAt(j)===m)&&(z+=z.length===0?"..":"\\..");return I+=P,z.length>0?`${z}${l.slice(I,f)}`:(l.charCodeAt(I)===m&&++I,l.slice(I,f))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$ec.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===m){if(s.charCodeAt(1)===m){const d=s.charCodeAt(2);if(d!==C&&d!==b)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(i(s.charCodeAt(0))&&s.charCodeAt(1)===A&&s.charCodeAt(2)===m)return`\\\\?\\${s}`;return t},dirname(t){S(t,"path");const s=t.length;if(s===0)return".";let d=-1,l=0;const c=t.charCodeAt(0);if(s===1)return u(c)?t:".";if(u(c)){if(d=l=1,u(t.charCodeAt(1))){let I=2,f=I;for(;I<s&&!u(t.charCodeAt(I));)I++;if(I<s&&I!==f){for(f=I;I<s&&u(t.charCodeAt(I));)I++;if(I<s&&I!==f){for(f=I;I<s&&!u(t.charCodeAt(I));)I++;if(I===s)return t;I!==f&&(d=l=I+1)}}}}else i(c)&&t.charCodeAt(1)===A&&(d=s>2&&u(t.charCodeAt(2))?3:2,l=d);let h=-1,E=!0;for(let I=s-1;I>=l;--I)if(u(t.charCodeAt(I))){if(!E){h=I;break}}else E=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,s){s!==void 0&&S(s,"ext"),S(t,"path");let d=0,l=-1,c=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let E=s.length-1,I=-1;for(h=t.length-1;h>=d;--h){const f=t.charCodeAt(h);if(u(f)){if(!c){d=h+1;break}}else I===-1&&(c=!1,I=h+1),E>=0&&(f===s.charCodeAt(E)?--E===-1&&(l=h):(E=-1,l=I))}return d===l?l=I:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(u(t.charCodeAt(h))){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){S(t,"path");let s=0,d=-1,l=0,c=-1,h=!0,E=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(s=l=2);for(let I=t.length-1;I>=s;--I){const f=t.charCodeAt(I);if(u(f)){if(!h){l=I+1;break}continue}c===-1&&(h=!1,c=I+1),f===b?d===-1?d=I:E!==1&&(E=1):d!==-1&&(E=-1)}return d===-1||c===-1||E===0||E===1&&d===c-1&&d===l+1?"":t.slice(d,c)},format:r.bind(null,"\\"),parse(t){S(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.length;let l=0,c=t.charCodeAt(0);if(d===1)return u(c)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(u(c)){if(l=1,u(t.charCodeAt(1))){let P=2,j=P;for(;P<d&&!u(t.charCodeAt(P));)P++;if(P<d&&P!==j){for(j=P;P<d&&u(t.charCodeAt(P));)P++;if(P<d&&P!==j){for(j=P;P<d&&!u(t.charCodeAt(P));)P++;P===d?l=P:P!==j&&(l=P+1)}}}}else if(i(c)&&t.charCodeAt(1)===A){if(d<=2)return s.root=s.dir=t,s;if(l=2,u(t.charCodeAt(2))){if(d===3)return s.root=s.dir=t,s;l=3}}l>0&&(s.root=t.slice(0,l));let h=-1,E=l,I=-1,f=!0,p=t.length-1,k=0;for(;p>=l;--p){if(c=t.charCodeAt(p),u(c)){if(!f){E=p+1;break}continue}I===-1&&(f=!1,I=p+1),c===b?h===-1?h=p:k!==1&&(k=1):h!==-1&&(k=-1)}return I!==-1&&(h===-1||k===0||k===1&&h===I-1&&h===E+1?s.base=s.name=t.slice(E,I):(s.name=t.slice(E,h),s.base=t.slice(E,I),s.ext=t.slice(h,I))),E>0&&E!==l?s.dir=t.slice(0,E-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const s=D.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...t){let s="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const c=l>=0?t[l]:a();S(c,"path"),c.length!==0&&(s=`${c}/${s}`,d=c.charCodeAt(0)===y)}return s=n(s,!d,"/",o),d?`/${s}`:s.length>0?s:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===y,d=t.charCodeAt(t.length-1)===y;return t=n(t,!s,"/",o),t.length===0?s?"/":d?"./":".":(d&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let s;for(let d=0;d<t.length;++d){const l=t[d];S(l,"path"),l.length>0&&(s===void 0?s=l:s+=`/${l}`)}return s===void 0?".":e.$fc.normalize(s)},relative(t,s){if(S(t,"from"),S(s,"to"),t===s||(t=e.$fc.resolve(t),s=e.$fc.resolve(s),t===s))return"";const d=1,l=t.length,c=l-d,h=1,E=s.length-h,I=c<E?c:E;let f=-1,p=0;for(;p<I;p++){const P=t.charCodeAt(d+p);if(P!==s.charCodeAt(h+p))break;P===y&&(f=p)}if(p===I)if(E>I){if(s.charCodeAt(h+p)===y)return s.slice(h+p+1);if(p===0)return s.slice(h+p)}else c>I&&(t.charCodeAt(d+p)===y?f=p:p===0&&(f=0));let k="";for(p=d+f+1;p<=l;++p)(p===l||t.charCodeAt(p)===y)&&(k+=k.length===0?"..":"/..");return`${k}${s.slice(h+f)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===y;let d=-1,l=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===y){if(!l){d=c;break}}else l=!1;return d===-1?s?"/":".":s&&d===1?"//":t.slice(0,d)},basename(t,s){s!==void 0&&S(s,"ext"),S(t,"path");let d=0,l=-1,c=!0,h;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let E=s.length-1,I=-1;for(h=t.length-1;h>=0;--h){const f=t.charCodeAt(h);if(f===y){if(!c){d=h+1;break}}else I===-1&&(c=!1,I=h+1),E>=0&&(f===s.charCodeAt(E)?--E===-1&&(l=h):(E=-1,l=I))}return d===l?l=I:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===y){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){S(t,"path");let s=-1,d=0,l=-1,c=!0,h=0;for(let E=t.length-1;E>=0;--E){const I=t.charCodeAt(E);if(I===y){if(!c){d=E+1;break}continue}l===-1&&(c=!1,l=E+1),I===b?s===-1?s=E:h!==1&&(h=1):s!==-1&&(h=-1)}return s===-1||l===-1||h===0||h===1&&s===l-1&&s===d+1?"":t.slice(s,l)},format:r.bind(null,"/"),parse(t){S(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.charCodeAt(0)===y;let l;d?(s.root="/",l=1):l=0;let c=-1,h=0,E=-1,I=!0,f=t.length-1,p=0;for(;f>=l;--f){const k=t.charCodeAt(f);if(k===y){if(!I){h=f+1;break}continue}E===-1&&(I=!1,E=f+1),k===b?c===-1?c=f:p!==1&&(p=1):c!==-1&&(p=-1)}if(E!==-1){const k=h===0&&d?1:h;c===-1||p===0||p===1&&c===E-1&&c===h+1?s.base=s.name=t.slice(k,E):(s.name=t.slice(k,c),s.base=t.slice(k,E),s.ext=t.slice(c,E))}return h>0?s.dir=t.slice(0,h-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ke[129],Se([1,0,48,16]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const g=new D.$U(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),R=new D.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new D.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(I,f,p=!1){const k=I||"",P=f||"",j=g.value.collator.compare(k,P);return g.value.collatorIsNumeric&&j===0&&k!==P?k<P?-1:1:j}e.$nq=b;function y(I,f){const p=R.value.collator;return I=I||"",f=f||"",r(p,I,f)}e.$oq=y;function m(I,f){const p=R.value.collator;return I=I||"",f=f||"",d(I,f)||r(p,I,f)}e.$pq=m;function A(I,f){const p=R.value.collator;return I=I||"",f=f||"",s(I,f)||r(p,I,f)}e.$qq=A;function C(I,f){return I=I||"",f=f||"",I===f?0:I<f?-1:1}e.$rq=C;function $(I,f){const[p,k]=i(I),[P,j]=i(f);let z=g.value.collator.compare(k,j);if(z===0){if(g.value.collatorIsNumeric&&k!==j)return k<j?-1:1;if(z=g.value.collator.compare(p,P),g.value.collatorIsNumeric&&z===0&&p!==P)return p<P?-1:1}return z}e.$sq=$;function v(I,f){I=I||"",f=f||"";const p=n(I),k=n(f),P=R.value.collator,j=L.value.collator;return r(j,p,k)||r(P,I,f)}e.$tq=v;function S(I,f){I=I||"",f=f||"";const p=n(I),k=n(f),P=R.value.collator,j=L.value.collator;return r(j,p,k)||d(I,f)||r(P,I,f)}e.$uq=S;function w(I,f){I=I||"",f=f||"";const p=n(I),k=n(f),P=R.value.collator,j=L.value.collator;return r(j,p,k)||s(I,f)||r(P,I,f)}e.$vq=w;function u(I,f){I=I||"",f=f||"";const p=n(I).toLowerCase(),k=n(f).toLowerCase();return p!==k?p<k?-1:1:I!==f?I<f?-1:1:0}e.$wq=u;const o=/^(.*?)(\.([^.]*))?$/;function i(I,f=!1){const p=I?o.exec(I):[];let k=[p&&p[1]||"",p&&p[3]||""];return f&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(I){const f=I?o.exec(I):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function r(I,f,p){const k=I.compare(f,p);return k!==0?k:f.length!==p.length?f.length<p.length?-1:1:0}function a(I){const f=I.charAt(0);return f.toLocaleUpperCase()!==f}function t(I){const f=I.charAt(0);return f.toLocaleLowerCase()!==f}function s(I,f){return a(I)&&t(f)?-1:t(I)&&a(f)?1:0}function d(I,f){return t(I)&&a(f)?-1:a(I)&&t(f)?1:0}function l(I,f,p=!1){return p||(I=I&&I.toLowerCase(),f=f&&f.toLowerCase()),I===f?0:I<f?-1:1}function c(I,f,p=!1){const k=I.split(T.sep),P=f.split(T.sep),j=k.length-1,z=P.length-1;let M,F;for(let N=0;;N++){if(M=j===N,F=z===N,M&&F)return b(k[N],P[N],p);if(M)return-1;if(F)return 1;const O=l(k[N],P[N],p);if(O!==0)return O}}e.$xq=c;function h(I,f,p){const k=I.toLowerCase(),P=f.toLowerCase(),j=E(I,f,p);if(j)return j;const z=k.endsWith(p),M=P.endsWith(p);if(z!==M)return z?-1:1;const F=b(k,P);return F!==0?F:k.localeCompare(P)}e.$yq=h;function E(I,f,p){const k=I.toLowerCase(),P=f.toLowerCase(),j=k.startsWith(p),z=P.startsWith(p);if(j!==z)return j?-1:1;if(j&&z){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}e.$zq=E}),define(ke[33],Se([1,0,16,11,13,18]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function L(h){return h===47||h===92}e.$Uf=L;function b(h){return h.replace(/[\\/]/g,D.$fc.sep)}e.$Vf=b;function y(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Wf=y;function m(h,E=D.$fc.sep){if(!h)return"";const I=h.length,f=h.charCodeAt(0);if(L(f)){if(L(h.charCodeAt(1))&&!L(h.charCodeAt(2))){let k=3;const P=k;for(;k<I&&!L(h.charCodeAt(k));k++);if(P!==k&&!L(h.charCodeAt(k+1))){for(k+=1;k<I;k++)if(L(h.charCodeAt(k)))return h.slice(0,k+1).replace(/[\\/]/g,E)}}return E}else if(o(f)&&h.charCodeAt(1)===58)return L(h.charCodeAt(2))?h.slice(0,2)+E:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<I;p++)if(L(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.$Xf=m;function A(h){if(!T.$i||!h||h.length<5)return!1;let E=h.charCodeAt(0);if(E!==92||(E=h.charCodeAt(1),E!==92))return!1;let I=2;const f=I;for(;I<h.length&&(E=h.charCodeAt(I),E!==92);I++);return!(f===I||(E=h.charCodeAt(I+1),isNaN(E)||E===92))}e.$Yf=A;const C=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(h,E=T.$i){const I=E?C:$;return!(!h||h.length===0||/^\s+$/.test(h)||(I.lastIndex=0,I.test(h))||E&&v.test(h)||h==="."||h===".."||E&&h[h.length-1]==="."||E&&h.length!==h.trim().length||h.length>255)}e.$Zf=S;function w(h,E,I){const f=h===E;return!I||f?f:!h||!E?!1:(0,g.$6e)(h,E)}e.$1f=w;function u(h,E,I,f=D.sep){if(h===E)return!0;if(!h||!E||E.length>h.length)return!1;if(I){if(!(0,g.$7e)(h,E))return!1;if(E.length===h.length)return!0;let k=E.length;return E.charAt(E.length-1)===f&&k--,h.charAt(k)===f}return E.charAt(E.length-1)!==f&&(E+=f),h.indexOf(E)===0}e.$2f=u;function o(h){return h>=65&&h<=90||h>=97&&h<=122}e.$3f=o;function i(h,E){return T.$i&&h.endsWith(":")&&(h+=D.sep),(0,D.$hc)(h)||(h=(0,D.$ic)(E,h)),h=(0,D.$gc)(h),T.$i?(h=(0,g.$Oe)(h,D.sep),h.endsWith(":")&&(h+=D.sep)):(h=(0,g.$Oe)(h,D.sep),h||(h=D.sep)),h}e.$4f=i;function n(h){const E=(0,D.$gc)(h);return T.$i?h.length>3?!1:r(E)&&(h.length===2||E.charCodeAt(2)===92):E===D.$fc.sep}e.$5f=n;function r(h,E=T.$i){return E?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$6f=r;function a(h,E=T.$i){return r(h,E)?h[0]:void 0}e.$7f=a;function t(h,E,I){return E.length>h.length?-1:h===E?0:(I&&(h=h.toLowerCase(),E=E.toLowerCase()),h.indexOf(E))}e.$8f=t;function s(h){const E=h.split(":");let I,f,p;for(const k of E){const P=Number(k);(0,R.$Gf)(P)?f===void 0?f=P:p===void 0&&(p=P):I=I?[I,k].join(":"):k}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:f!==void 0?f:void 0,column:p!==void 0?p:f!==void 0?1:void 0}}e.$9f=s;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,E,I=8){let f="";for(let k=0;k<I;k++){let P;k===0&&T.$i&&!E&&(I===3||I===4)?P=l:P=d,f+=P.charAt(Math.floor(Math.random()*P.length))}let p;return E?p=`${E}-${f}`:p=f,h?(0,D.$ic)(h,p):p}e.$0f=c}),define(ke[130],Se([1,0,129,124,52,16,11,13]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=void 0;const y=0,m=[y,[]];function A(W,x,ce,Y){if(!W||!x)return m;const G=W.length,J=x.length;if(G<J)return m;const le=W.toLowerCase();return C(x,ce,J,W,le,G,Y)}e.$Aq=A;function C(W,x,ce,Y,G,J,le){const Q=[],Ee=[];for(let ie=0;ie<ce;ie++){const be=ie*J,H=be-J,_=ie>0,Z=W[ie],$e=x[ie];for(let re=0;re<J;re++){const fe=re>0,te=be+re,de=te-1,pe=H+re-1,Pe=fe?Q[de]:0,B=_&&fe?Q[pe]:0,X=_&&fe?Ee[pe]:0;let se;!B&&_?se=0:se=$(Z,$e,Y,G,re,X),se&&B+se>=Pe&&(le||_||G.startsWith(x,re))?(Ee[te]=X+1,Q[te]=B+se):(Ee[te]=y,Q[te]=Pe)}}const he=[];let K=ce-1,U=J-1;for(;K>=0&&U>=0;){const ie=K*J+U;Ee[ie]===y||(he.push(U),K--),U--}return[Q[ce*J-1],he.reverse()]}function $(W,x,ce,Y,G,J){let le=0;if(!v(x,Y[G]))return le;if(le+=1,J>0&&(le+=J*5),W===ce[G]&&(le+=1),G===0)le+=8;else{const Q=S(ce.charCodeAt(G-1));Q?le+=Q:(0,T.$Mj)(ce.charCodeAt(G))&&J===0&&(le+=2)}return le}function v(W,x){return W===x?!0:W==="/"||W==="\\"?x==="/"||x==="\\":!1}function S(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function u(W,x,ce=0,Y=0){const G=x;return G.values&&G.values.length>1?o(W,G.values,ce,Y):i(W,x,ce,Y)}e.$Bq=u;function o(W,x,ce,Y){let G=0;const J=[];for(const le of x){const[Q,Ee]=i(W,le,ce,Y);if(typeof Q!="number")return w;G+=Q,J.push(...Ee)}return[G,I(J)]}function i(W,x,ce,Y){const G=(0,T.$Vj)(x.original,x.originalLowercase,ce,W,W.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,T.$Sj)(G)]:w}const n=Object.freeze({score:0}),r=1<<18,a=1<<17,t=1<<16;function s(W,x,ce,Y){const G=Y.values?Y.values:[Y];return(0,g.$Ji)({[Y.normalized]:{values:G.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:W,description:x,allowNonContiguousMatches:ce}})}function d(W,x,ce,Y,G){if(!W||!x.normalized)return n;const J=Y.getItemLabel(W);if(!J)return n;const le=Y.getItemDescription(W),Q=s(J,le,ce,x),Ee=G[Q];if(Ee)return Ee;const he=l(J,le,Y.getItemPath(W),x,ce);return G[Q]=he,he}e.$Cq=d;function l(W,x,ce,Y,G){const J=!ce||!Y.containsPathSeparator;return ce&&(L.$k?Y.pathNormalized===ce:(0,b.$6e)(Y.pathNormalized,ce))?{score:r,labelMatch:[{start:0,end:W.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:Y.values&&Y.values.length>1?c(W,x,ce,Y.values,J,G):h(W,x,ce,Y,J,G)}function c(W,x,ce,Y,G,J){let le=0;const Q=[],Ee=[];for(const he of Y){const{score:K,labelMatch:U,descriptionMatch:ie}=h(W,x,ce,he,G,J);if(K===y)return n;le+=K,U&&Q.push(...U),ie&&Ee.push(...ie)}return{score:le,labelMatch:I(Q),descriptionMatch:I(Ee)}}function h(W,x,ce,Y,G,J){if(G||!x){const[le,Q]=A(W,Y.normalized,Y.normalizedLowercase,J&&!Y.expectContiguousMatch);if(le){const Ee=(0,T.$Jj)(Y.normalized,W);let he;if(Ee){he=a;const K=Math.round(Y.normalized.length/W.length*100);he+=K}else he=t;return{score:he+le,labelMatch:Ee||E(Q)}}}if(x){let le=x;ce&&(le=`${x}${R.sep}`);const Q=le.length,Ee=`${le}${W}`,[he,K]=A(Ee,Y.normalized,Y.normalizedLowercase,J&&!Y.expectContiguousMatch);if(he){const U=E(K),ie=[],be=[];return U.forEach(H=>{H.start<Q&&H.end>Q?(ie.push({start:0,end:H.end-Q}),be.push({start:H.start,end:Q})):H.start>=Q?ie.push({start:H.start-Q,end:H.end-Q}):be.push(H)}),{score:he,labelMatch:ie,descriptionMatch:be}}}return n}function E(W){const x=[];if(!W)return x;let ce;for(const Y of W)ce&&ce.end===Y?ce.end+=1:(ce={start:Y,end:Y+1},x.push(ce));return x}function I(W){const x=W.sort((G,J)=>G.start-J.start),ce=[];let Y;for(const G of x)!Y||!f(Y,G)?(Y=G,ce.push(G)):(Y.start=Math.min(Y.start,G.start),Y.end=Math.max(Y.end,G.end));return ce}function f(W,x){return!(W.end<x.start||x.end<W.start)}function p(W,x,ce,Y,G,J){const le=d(W,ce,Y,G,J),Q=d(x,ce,Y,G,J),Ee=le.score,he=Q.score;if((Ee===r||he===r)&&Ee!==he)return Ee===r?-1:1;if(Ee>t||he>t){if(Ee!==he)return Ee>he?-1:1;if(Ee<a&&he<a){const Z=P(le.labelMatch,Q.labelMatch);if(Z!==0)return Z}const H=G.getItemLabel(W)||"",_=G.getItemLabel(x)||"";if(H.length!==_.length)return H.length-_.length}if(Ee!==he)return Ee>he?-1:1;const K=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,U=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(K&&!U)return-1;if(U&&!K)return 1;const ie=k(W,le,G),be=k(x,Q,G);return ie&&be&&ie!==be?be>ie?-1:1:j(W,x,ce,G)}e.$Dq=p;function k(W,x,ce){let Y=-1,G=-1;if(x.descriptionMatch&&x.descriptionMatch.length?Y=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(Y=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(G=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const J=ce.getItemDescription(W);J&&(G+=J.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(G=x.descriptionMatch[x.descriptionMatch.length-1].end);return G-Y}function P(W,x){if(!W&&!x||(!W||!W.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!W||!W.length)return 1;const ce=W[0].start,G=W[W.length-1].end-ce,J=x[0].start,Q=x[x.length-1].end-J;return G===Q?0:Q<G?1:-1}function j(W,x,ce,Y){const G=Y.getItemLabel(W)||"",J=Y.getItemLabel(x)||"",le=Y.getItemDescription(W),Q=Y.getItemDescription(x),Ee=G.length+(le?le.length:0),he=J.length+(Q?Q.length:0);if(Ee!==he)return Ee-he;const K=Y.getItemPath(W),U=Y.getItemPath(x);return K&&U&&K.length!==U.length?K.length-U.length:G!==J?(0,D.$yq)(G,J,ce.normalized):le&&Q&&le!==Q?(0,D.$yq)(le,Q,ce.normalized):K&&U&&K!==U?(0,D.$yq)(K,U,ce.normalized):0}function z(W){return W.startsWith('"')&&W.endsWith('"')}const M=" ";function F(W){typeof W!="string"&&(W="");const x=W.toLowerCase(),{pathNormalized:ce,normalized:Y,normalizedLowercase:G}=N(W),J=ce.indexOf(R.sep)>=0,le=z(W);let Q;const Ee=W.split(M);if(Ee.length>1)for(const he of Ee){const K=z(he),{pathNormalized:U,normalized:ie,normalizedLowercase:be}=N(he);ie&&(Q||(Q=[]),Q.push({original:he,originalLowercase:he.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:be,expectContiguousMatch:K}))}return{original:W,originalLowercase:x,pathNormalized:ce,normalized:Y,normalizedLowercase:G,values:Q,containsPathSeparator:J,expectContiguousMatch:le}}e.$Eq=F;function N(W){let x;L.$i?x=W.replace(/\//g,R.sep):x=W.replace(/\\/g,R.sep);const ce=(0,b.$Qe)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:ce,normalizedLowercase:ce.toLowerCase()}}function O(W){return Array.isArray(W)?F(W.map(x=>x.original).join(M)):F(W.original)}e.$Fq=O}),define(ke[100],Se([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const C=(0,D.$nc)(A),$=T[C.toLowerCase()];return $!==void 0?$:L(A)}e.$Wr=R;function L(A){const C=(0,D.$nc)(A);return g[C.toLowerCase()]}e.$Xr=L;function b(A){for(const C in g)if(g[C]===A)return C}e.$Yr=b;const y=/^(.+)\/(.+?)(;.+)?$/;function m(A,C){const $=y.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:C?void 0:A}e.$Zr=m}),define(ke[101],Se([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0;var T;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(T||(e.Source=T={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function R(b,...y){const m=y.reduce(($,v)=>($[v]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter($=>!m[$]).forEach($=>{for(let v=0;v<A.length;v++)if($.search(A[v])!==-1){delete b[$];break}})}e.$Fl=R;function L(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Gl=L}),define(ke[2],Se([1,0,16,11]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,R=/^\//,L=/^\/\//;function b(l,c){if(!l.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!g.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!R.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(l,c){return!l&&!c?"file":l}function m(l,c){switch(l){case"https":case"http":case"file":c?c[0]!==C&&(c=C+c):c=C;break}return c}const A="",C="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,E,I,f,p=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=y(c,p),this.authority=h||A,this.path=m(this.scheme,E||A),this.query=I||A,this.fragment=f||A,b(this,p))}get fsPath(){return r(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:E,path:I,query:f,fragment:p}=c;return h===void 0?h=this.scheme:h===null&&(h=A),E===void 0?E=this.authority:E===null&&(E=A),I===void 0?I=this.path:I===null&&(I=A),f===void 0?f=this.query:f===null&&(f=A),p===void 0?p=this.fragment:p===null&&(p=A),h===this.scheme&&E===this.authority&&I===this.path&&f===this.query&&p===this.fragment?this:new u(h,E,I,f,p)}static parse(c,h=!1){const E=$.exec(c);return E?new u(E[2]||A,d(E[4]||A),d(E[5]||A),d(E[7]||A),d(E[9]||A),h):new u(A,A,A,A,A)}static file(c){let h=A;if(T.$i&&(c=c.replace(/\\/g,C)),c[0]===C&&c[1]===C){const E=c.indexOf(C,2);E===-1?(h=c.substring(2),c=C):(h=c.substring(2,E),c=c.substring(E)||C)}return new u("file",h,c,A,A)}static from(c,h){return new u(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return T.$i&&c.scheme==="file"?E=v.file(D.$ec.join(r(c,!0),...h)).path:E=D.$fc.join(c.path,...h),c.with({path:E})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const h=new u(c);return h._formatted=c.external??null,h._fsPath=c._sep===w?c.fsPath??null:null,h}}else return c}}e.URI=v;function S(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}e.$uc=S;const w=T.$i?1:void 0;class u extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=w),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(l,c,h){let E,I=-1;for(let f=0;f<l.length;f++){const p=l.charCodeAt(f);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||c&&p===47||h&&p===91||h&&p===93||h&&p===58)I!==-1&&(E+=encodeURIComponent(l.substring(I,f)),I=-1),E!==void 0&&(E+=l.charAt(f));else{E===void 0&&(E=l.substr(0,f));const k=o[p];k!==void 0?(I!==-1&&(E+=encodeURIComponent(l.substring(I,f)),I=-1),E+=k):I===-1&&(I=f)}}return I!==-1&&(E+=encodeURIComponent(l.substring(I))),E!==void 0?E:l}function n(l){let c;for(let h=0;h<l.length;h++){const E=l.charCodeAt(h);E===35||E===63?(c===void 0&&(c=l.substr(0,h)),c+=o[E]):c!==void 0&&(c+=l[h])}return c!==void 0?c:l}function r(l,c){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?c?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,T.$i&&(h=h.replace(/\//g,"\\")),h}e.$vc=r;function a(l,c){const h=c?n:i;let E="",{scheme:I,authority:f,path:p,query:k,fragment:P}=l;if(I&&(E+=I,E+=":"),(f||I==="file")&&(E+=C,E+=C),f){let j=f.indexOf("@");if(j!==-1){const z=f.substr(0,j);f=f.substr(j+1),j=z.lastIndexOf(":"),j===-1?E+=h(z,!1,!1):(E+=h(z.substr(0,j),!1,!1),E+=":",E+=h(z.substr(j+1),!1,!0)),E+="@"}f=f.toLowerCase(),j=f.lastIndexOf(":"),j===-1?E+=h(f,!1,!0):(E+=h(f.substr(0,j),!1,!0),E+=f.substr(j))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const j=p.charCodeAt(1);j>=65&&j<=90&&(p=`/${String.fromCharCode(j+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const j=p.charCodeAt(0);j>=65&&j<=90&&(p=`${String.fromCharCode(j+32)}:${p.substr(2)}`)}E+=h(p,!0,!1)}return k&&(E+="?",E+=h(k,!1,!1)),P&&(E+="#",E+=c?P:i(P,!1,!1)),E}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(s)?l.replace(s,c=>t(c)):l}}),define(ke[185],Se([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$6p=e.$5p=e.$4p=void 0;function T(m){const A=m;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$4p=T;function g(m){const A=[];let C;try{const $=JSON.parse(m.arguments),v=$[$.length-1];v&&v.__$stack&&($.pop(),C=v.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",m.arguments)}return{args:A,stack:C}}e.$5p=g;function R(m){if(typeof m!="string")return R(g(m).stack);const A=m;if(A){const C=L(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if($&&$.length===4)return{uri:D.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$6p=R;function L(m){if(!m)return m;const A=m.indexOf(`
`);return A===-1?m:m.substring(0,A)}function b(m,A){const{args:C,stack:$}=g(m),v=typeof C[0]=="string"&&C.length===1;let S=L($);S&&(S=`(${S.trim()})`);let w=[];if(typeof C[0]=="string"?S&&v?w=[`%c[${A}] %c${C[0]} %c${S}`,y("blue"),y(""),y("grey")]:w=[`%c[${A}] %c${C[0]}`,y("blue"),y(""),...C.slice(1)]:w=[`%c[${A}]%`,y("blue"),...C],S&&!v&&w.push(S),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,w)}e.log=b;function y(m){return`color: ${m}`}}),define(ke[54],Se([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function g(y){return JSON.stringify(y,L)}e.$qh=g;function R(y){let m=JSON.parse(y);return m=b(m),m}e.$rh=R;function L(y,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function b(y,m=0){if(!y||m>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return T.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 17:return new Date(y.source)}if(y instanceof D.$fe||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let A=0;A<y.length;++A)y[A]=b(y[A],m+1);else for(const A in y)Object.hasOwnProperty.call(y,A)&&(y[A]=b(y[A],m+1))}return y}e.$sh=b}),define(ke[17],Se([1,0,8,11,2]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var R;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$$f="vscode-tkn",e.$_f="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${R.vscodeRemoteResource}`}set(A,C,$){this.a[A]=C,this.b[A]=$}setConnectionToken(A,C){this.c[A]=C}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(u){return D.$Z(u),A}const C=A.authority;let $=this.a[C];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const v=this.b[C],S=this.c[C];let w=`path=${encodeURIComponent(A.path)}`;return typeof S=="string"&&(w+=`&${e.$_f}=${encodeURIComponent(S)}`),g.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${$}:${v}`,path:this.f,query:w})}}e.$ag=new L,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class b{static{this.a=e.$fg}asBrowserUri(A){const C=this.b(A,me);return this.uriToBrowserUri(C)}uriToBrowserUri(A){return A.scheme===R.vscodeRemote?e.$ag.rewrite(A):A.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${b.a}`)?A.with({scheme:R.vscodeFileResource,authority:A.authority||b.a,query:null,fragment:null}):A}asFileUri(A){const C=this.b(A,me);return this.uriToFileUri(C)}uriToFileUri(A){return A.scheme===R.vscodeFileResource?A.with({scheme:R.file,authority:A.authority!==b.a?A.authority:null,query:null,fragment:null}):A}b(A,C){return g.URI.isUri(A)?A:g.URI.parse(C.toUrl(A))}}e.$gg=new b;var y;(function(m){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(A.get("3"));const C="vscode-coi";function $(S){let w;typeof S=="string"?w=new URL(S).searchParams:S instanceof URL?w=S.searchParams:g.URI.isUri(S)&&(w=new URL(S.toString(!0)).searchParams);const u=w?.get(C);if(u)return A.get(u)}m.getHeadersFromQuery=$;function v(S,w,u){if(!globalThis.crossOriginIsolated)return;const o=w&&u?"3":u?"2":"1";S instanceof URLSearchParams?S.set(C,o):S[C]=o}m.addSearchParam=v})(y||(e.COI=y={}))}),define(ke[186],Se([1,0,159,17,11,2]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=void 0;class L{constructor($,v,S){this.id=$,this.dependencies=v,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,v,S)=>{typeof $!="string"&&(S=v,v=$,$=null),(typeof v!="object"||!Array.isArray(v))&&(S=v,v=null),this.c.push(new L($,v,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const v=await(this.a?this.i($):this.b?this.h($):this.j($));if(!v)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h($){return new Promise((v,S)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const u=()=>{w.removeEventListener("load",o),w.removeEventListener("error",i)},o=n=>{u(),v(this.c.pop())},i=n=>{u(),S(n)};w.addEventListener("load",o),w.addEventListener("error",i),this.f&&($=this.f.createScriptURL($)),w.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(w)})}i($){return new Promise((v,S)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),v(this.c.pop())}catch(w){S(w)}})}async j($){try{const v=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,u=R.URI.parse($).fsPath,o=v.readFileSync(u).toString(),i=w.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const y=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function A(C,$,v){if(D.$S){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[C]&&(C=m[C]);const S=`${C}/${$}`;if(y.has(S))return y.get(S);let w;if(/^\w[\w\d+.-]*:\/\//.test(S))w=S;else{const n=`${v&&!g.$o?T.$dg:T.$cg}/${S}`;w=T.$gg.asBrowserUri(n).toString(!0)}const u=b.INSTANCE.load(w);return y.set(S,u),u}else return await new Promise((S,w)=>{me([C],S,w)})}e.$OC=A}),define(ke[23],Se([1,0,33,17,16,11,13,2]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function y(v){return(0,b.$vc)(v,!0)}e.$ng=y;class m{constructor(S){this.a=S}compare(S,w,u=!1){return S===w?0:(0,L.$Ye)(this.getComparisonKey(S,u),this.getComparisonKey(w,u))}isEqual(S,w,u=!1){return S===w?!0:!S||!w?!1:this.getComparisonKey(S,u)===this.getComparisonKey(w,u)}getComparisonKey(S,w=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,w,u=!1){if(S.scheme===w.scheme){if(S.scheme===T.Schemas.file)return D.$2f(y(S),y(w),this.a(S))&&S.query===w.query&&(u||S.fragment===w.fragment);if((0,e.$Eg)(S.authority,w.authority))return D.$2f(S.path,w.path,this.a(S),"/")&&S.query===w.query&&(u||S.fragment===w.fragment)}return!1}joinPath(S,...w){return b.URI.joinPath(S,...w)}basenameOrAuthority(S){return(0,e.$wg)(S)||S.authority}basename(S){return g.$fc.basename(S.path)}extname(S){return g.$fc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let w;return S.scheme===T.Schemas.file?w=b.URI.file(g.$lc(y(S))).path:(w=g.$fc.dirname(S.path),S.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),w="/")),S.with({path:w})}normalizePath(S){if(!S.path.length)return S;let w;return S.scheme===T.Schemas.file?w=b.URI.file(g.$gc(y(S))).path:w=g.$fc.normalize(S.path),S.with({path:w})}relativePath(S,w){if(S.scheme!==w.scheme||!(0,e.$Eg)(S.authority,w.authority))return;if(S.scheme===T.Schemas.file){const i=g.$kc(y(S),y(w));return R.$i?D.$Vf(i):i}let u=S.path||"/";const o=w.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(u.length,o.length);i<n&&!(u.charCodeAt(i)!==o.charCodeAt(i)&&u.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);u=o.substr(0,i)+u.substr(i)}return g.$fc.relative(u,o)}resolvePath(S,w){if(S.scheme===T.Schemas.file){const u=b.URI.file(g.$jc(y(S),w));return S.with({authority:u.authority,path:u.path})}return w=D.$Wf(w),S.with({path:g.$fc.resolve(S.path,w)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,w){return S===w||S!==void 0&&w!==void 0&&(0,L.$6e)(S,w)}hasTrailingPathSeparator(S,w=g.sep){if(S.scheme===T.Schemas.file){const u=y(S);return u.length>D.$Xf(u).length&&u[u.length-1]===w}else{const u=S.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,w=g.sep){return(0,e.$Fg)(S,w)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,w=g.sep){let u=!1;if(S.scheme===T.Schemas.file){const o=y(S);u=o!==void 0&&o.length===D.$Xf(o).length&&o[o.length-1]===w}else{w="/";const o=S.path;u=o.length===1&&o.charCodeAt(o.length-1)===47}return!u&&!(0,e.$Fg)(S,w)?S.with({path:S.path+"/"}):S}}e.$og=m,e.$pg=new m(()=>!1),e.$qg=new m(v=>v.scheme===T.Schemas.file?!R.$k:!0),e.$rg=new m(v=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function A(v,S){const w=[];for(let u=0;u<v.length;u++){const o=S(v[u]);v.some((i,n)=>n===u?!1:(0,e.$tg)(o,S(i)))||w.push(v[u])}return w}e.$Ig=A;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function S(w){const u=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,a]=n.split(":");r&&a&&u.set(r,a)});const i=w.path.substring(0,w.path.indexOf(";"));return i&&u.set(v.META_DATA_MIME,i),u}v.parseMetaData=S})(C||(e.DataUri=C={}));function $(v,S,w){if(S){let u=v.path;return u&&u[0]!==g.$fc.sep&&(u=g.$fc.sep+u),v.with({scheme:w,authority:S,path:u})}return v.with({scheme:w})}e.$Jg=$}),define(ke[12],Se([1,0,21,8,4,3,23,11,163]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function m(be){return!!be&&typeof be.then=="function"}e.$Kg=m;function A(be){const H=new D.$2d,_=be(H.token),Z=new Promise(($e,re)=>{const fe=H.token.onCancellationRequested(()=>{fe.dispose(),H.dispose(),re(new T.$4)});Promise.resolve(_).then(te=>{fe.dispose(),H.dispose(),$e(te)},te=>{fe.dispose(),H.dispose(),re(te)})});return new class{cancel(){H.cancel()}then($e,re){return Z.then($e,re)}catch($e){return this.then(void 0,$e)}finally($e){return Z.finally($e)}}}e.$Lg=A;function C(be,H,_){return new Promise((Z,$e)=>{const re=H.onCancellationRequested(()=>{re.dispose(),Z(_)});be.then(Z,$e).finally(()=>re.dispose())})}e.$Mg=C;function $(be,H){return new Promise((_,Z)=>{const $e=H.onCancellationRequested(()=>{$e.dispose(),Z(new T.$4)});be.then(_,Z).finally(()=>$e.dispose())})}e.$Ng=$;async function v(be){let H=-1;const _=be.map((Z,$e)=>Z.then(re=>(H=$e,re)));try{return await Promise.race(_)}finally{be.forEach((Z,$e)=>{$e!==H&&Z.cancel()})}}e.$Og=v;function S(be,H,_){let Z;const $e=setTimeout(()=>{Z?.(void 0),_?.()},H);return Promise.race([be.finally(()=>clearTimeout($e)),new Promise(re=>Z=re)])}e.$Pg=S;function w(be){return new Promise((H,_)=>{const Z=be();m(Z)?Z.then(H,_):H(Z)})}e.$Qg=w;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const _=()=>{if(this.b=null,this.f)return;const Z=this.queue(this.d);return this.d=null,Z};this.b=new Promise(Z=>{this.a.then(_,_).then(Z)})}return new Promise((_,Z)=>{this.b.then(_,Z)})}return this.a=H(),new Promise((_,Z)=>{this.a.then($e=>{this.a=null,_($e)},$e=>{this.a=null,Z($e)})})}dispose(){this.f=!0}}e.$Rg=u;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Sg=o;class i{constructor(){this.a=new Map}queue(H,_){const $e=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(H)===$e&&this.a.delete(H)});return this.a.set(H,$e),$e}}e.$Tg=i;const n=(be,H)=>{let _=!0;const Z=setTimeout(()=>{_=!1,H()},be);return{isTriggered:()=>_,dispose:()=>{clearTimeout(Z),_=!1}}},r=be=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,be())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class a{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,_=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise(($e,re)=>{this.d=$e,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const Z=()=>{this.a=null,this.d?.(null)};return this.a=_===y.$Od?r(Z):n(_,Z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=a;class t{constructor(H){this.a=new a(H),this.b=new u}trigger(H,_){return this.a.trigger(()=>this.b.queue(H),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=t;class s{constructor(){this.a=!1,this.b=new Promise((H,_)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class d extends s{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Xg=d;function l(be,H){return H?new Promise((_,Z)=>{const $e=setTimeout(()=>{re.dispose(),_()},be),re=H.onCancellationRequested(()=>{clearTimeout($e),re.dispose(),Z(new T.$4)})}):A(_=>l(be,_))}e.$Yg=l;function c(be,H=0,_){const Z=setTimeout(()=>{be(),_&&$e.dispose()},H),$e=(0,R.$Pc)(()=>{clearTimeout(Z),_?.deleteAndLeak($e)});return _?.add($e),$e}e.$Zg=c;function h(be){const H=[];let _=0;const Z=be.length;function $e(){return _<Z?be[_++]():null}function re(fe){fe!=null&&H.push(fe);const te=$e();return te?te.then(re):Promise.resolve(H)}return Promise.resolve(null).then(re)}e.$1g=h;function E(be,H=Z=>!!Z,_=null){let Z=0;const $e=be.length,re=()=>{if(Z>=$e)return Promise.resolve(_);const fe=be[Z++];return Promise.resolve(fe()).then(de=>H(de)?Promise.resolve(de):re())};return re()}e.$2g=E;function I(be,H=Z=>!!Z,_=null){if(be.length===0)return Promise.resolve(_);let Z=be.length;const $e=()=>{Z=-1;for(const re of be)re.cancel?.()};return new Promise((re,fe)=>{for(const te of be)te.then(de=>{--Z>=0&&H(de)?($e(),re(de)):Z===0&&re(_)}).catch(de=>{--Z>=0&&($e(),fe(de))})})}e.$3g=I;class f{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new g.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((_,Z)=>{this.f.push({factory:H,c:_,e:Z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const _=H.factory();_.then(H.c,H.e),_.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=f;class p extends f{constructor(){super(1)}}e.$5g=p;class k{constructor(){this.a=new Y,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$6g=k;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new le;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,_=L.$pg){const Z=_.getComparisonKey(H);let $e=this.a.get(Z);if(!$e){$e=new p;const re=this.f++,fe=g.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(Z),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$1c),this.d.set(re,fe),this.a.set(Z,$e)}return $e}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=P;class j{constructor(H,_){this.a=-1,typeof H=="function"&&typeof _=="number"&&this.setIfNotSet(H,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},_)}setIfNotSet(H,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},_))}}e.$8g=j;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,_,Z=globalThis){this.cancel();const $e=Z.setInterval(()=>{H()},_);this.d=(0,R.$Pc)(()=>{Z.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$9g=z;class M{constructor(H,_){this.b=-1,this.a=H,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=M;class F{constructor(H,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=H,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=F;class N extends M{constructor(H,_){super(H,_),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$_g=N;class O extends R.$Rc{constructor(H,_){super(),this.g=H,this.h=_,this.a=[],this.b=this.B(new R.$Sc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of H)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(be,H)=>{(0,b.$B)(()=>{if(_)return;const Z=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Z-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$ch=(be,H,_)=>{const Z=be.requestIdleCallback(H,typeof _=="number"?{timeout:_}:void 0);let $e=!1;return{dispose(){$e||($e=!0,be.cancelIdleCallback(Z))}}},e.$bh=be=>(0,e.$ch)(globalThis,be)}();class W{constructor(H,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(Z){this.l=Z}finally{this.g=!0}},this.f=(0,e.$ch)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=W;class x extends W{constructor(H){super(globalThis,H)}}e.$eh=x;async function ce(be,H,_){let Z;for(let $e=0;$e<_;$e++)try{return await be()}catch(re){Z=re,await l(H)}throw Z}e.$fh=ce;class Y{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,_,Z){return this.a={taskId:H,cancel:()=>Z?.(),promise:_},_.then(()=>this.d(H),()=>this.d(H)),_}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{let _,Z;const $e=new Promise((re,fe)=>{_=re,Z=fe});this.b={run:H,promise:$e,promiseResolve:_,promiseReject:Z}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=Y;class G{constructor(H,_=()=>Date.now()){this.d=H,this.f=_,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$hh=G;var J;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(J||(J={}));class le{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,_)=>{this.a=H,this.b=_})}complete(H){return new Promise(_=>{this.a(H),this.d={outcome:0,value:H},_()})}error(H){return new Promise(_=>{this.b(H),this.d={outcome:1,value:H},_()})}cancel(){return this.error(new T.$4)}}e.$ih=le;var Q;(function(be){async function H(Z){let $e;const re=await Promise.all(Z.map(fe=>fe.then(te=>te,te=>{$e||($e=te)})));if(typeof $e<"u")throw $e;return re}be.settled=H;function _(Z){return new Promise(async($e,re)=>{try{await Z($e,re)}catch(fe){re(fe)}})}be.withAsyncBody=_})(Q||(e.Promises=Q={}));var Ee;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(Ee||(Ee={}));class he{static fromArray(H){return new he(_=>{_.emitMany(H)})}static fromPromise(H){return new he(async _=>{_.emitMany(await H)})}static fromPromises(H){return new he(async _=>{await Promise.all(H.map(async Z=>_.emitOne(await Z)))})}static merge(H){return new he(async _=>{await Promise.all(H.map(async Z=>{for await(const $e of Z)_.emitOne($e)}))})}static{this.EMPTY=he.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new g.$Rd,queueMicrotask(async()=>{const _={emitOne:Z=>this.g(Z),emitMany:Z=>this.h(Z),reject:Z=>this.k(Z)};try{await Promise.resolve(H(_)),this.j()}catch(Z){this.k(Z)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(H,_){return new he(async Z=>{for await(const $e of H)Z.emitOne(_($e))})}map(H){return he.map(this,H)}static filter(H,_){return new he(async Z=>{for await(const $e of H)_($e)&&Z.emitOne($e)})}filter(H){return he.filter(this,H)}static coalesce(H){return he.filter(H,_=>!!_)}coalesce(){return he.coalesce(this)}static async toPromise(H){const _=[];for await(const Z of H)_.push(Z);return _}toPromise(){return he.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$jh=he;class K extends he{constructor(H,_){super(_),this.l=H}cancel(){this.l.cancel()}}e.$kh=K;function U(be){const H=new D.$2d,_=be(H.token);return new K(H,async Z=>{const $e=H.token.onCancellationRequested(()=>{$e.dispose(),H.dispose(),Z.reject(new T.$4)});try{for await(const re of _){if(H.token.isCancellationRequested)return;Z.emitOne(re)}$e.dispose(),H.dispose()}catch(re){$e.dispose(),H.dispose(),Z.reject(re)}})}e.$lh=U;class ie{constructor(){this.a=new le,this.b=new he(Z=>{if(H){Z.reject(H);return}return _&&Z.emitMany(_),this.d=$e=>Z.reject($e),this.f=$e=>Z.emitOne($e),this.a.p});let H,_;this.f=Z=>{_||(_=[]),_.push(Z)},this.d=Z=>{H||(H=Z)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$mh=ie}),define(ke[34],Se([1,0,19,12,33,28,16,11,13]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function m(){return Object.create(null)}e.$xj=m,e.$yj="**",e.$zj="/";const A="[/\\\\]",C="[^/\\\\]",$=/\//g;function v(ce,Y){switch(ce){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${Y?`|${A}${C}+`:""})*?`}}function S(ce,Y){if(!ce)return[];const G=[];let J=!1,le=!1,Q="";for(const Ee of ce){switch(Ee){case Y:if(!J&&!le){G.push(Q),Q="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":le=!0;break;case"]":le=!1;break}Q+=Ee}return Q&&G.push(Q),G}e.$Aj=S;function w(ce){if(!ce)return"";let Y="";const G=S(ce,e.$zj);if(G.every(J=>J===e.$yj))Y=".*";else{let J=!1;G.forEach((le,Q)=>{if(le===e.$yj){if(J)return;Y+=v(2,Q===G.length-1)}else{let Ee=!1,he="",K=!1,U="";for(const ie of le){if(ie!=="}"&&Ee){he+=ie;continue}if(K&&(ie!=="]"||!U)){let be;ie==="-"?be=ie:(ie==="^"||ie==="!")&&!U?be="^":ie===e.$zj?be="":be=(0,y.$Je)(ie),U+=be;continue}switch(ie){case"{":Ee=!0;continue;case"[":K=!0;continue;case"}":{const H=`(?:${S(he,",").map(_=>w(_)).join("|")})`;Y+=H,Ee=!1,he="";break}case"]":{Y+="["+U+"]",K=!1,U="";break}case"?":Y+=C;continue;case"*":Y+=v(1);continue;default:Y+=(0,y.$Je)(ie)}}Q<G.length-1&&(G[Q+1]!==e.$yj||Q+2<G.length)&&(Y+=A)}J=le===e.$yj})}return Y}const u=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Cc(1e4),s=function(){return!1},d=function(){return null};function l(ce,Y){if(!ce)return d;let G;typeof ce!="string"?G=ce.pattern:G=ce,G=G.trim();const J=`${G}_${!!Y.trimForExclusions}`;let le=t.get(J);if(le)return c(le,ce);let Q;return u.test(G)?le=E(G.substr(4),G):(Q=o.exec(h(G,Y)))?le=I(Q[1],G):(Y.trimForExclusions?n:i).test(G)?le=f(G,Y):(Q=r.exec(h(G,Y)))?le=p(Q[1].substr(1),G,!0):(Q=a.exec(h(G,Y)))?le=p(Q[1],G,!1):le=k(G),t.set(J,le),c(le,ce)}function c(ce,Y){if(typeof Y=="string")return ce;const G=function(J,le){return(0,g.$2f)(J,Y.base,!b.$k)?ce((0,y.$Ne)(J.substr(Y.base.length),L.sep),le):null};return G.allBasenames=ce.allBasenames,G.allPaths=ce.allPaths,G.basenames=ce.basenames,G.patterns=ce.patterns,G}function h(ce,Y){return Y.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function E(ce,Y){return function(G,J){return typeof G=="string"&&G.endsWith(ce)?Y:null}}function I(ce,Y){const G=`/${ce}`,J=`\\${ce}`,le=function(Ee,he){return typeof Ee!="string"?null:he?he===ce?Y:null:Ee===ce||Ee.endsWith(G)||Ee.endsWith(J)?Y:null},Q=[ce];return le.basenames=Q,le.patterns=[Y],le.allBasenames=Q,le}function f(ce,Y){const G=W(ce.slice(1,-1).split(",").map(he=>l(he,Y)).filter(he=>he!==d),ce),J=G.length;if(!J)return d;if(J===1)return G[0];const le=function(he,K){for(let U=0,ie=G.length;U<ie;U++)if(G[U](he,K))return ce;return null},Q=G.find(he=>!!he.allBasenames);Q&&(le.allBasenames=Q.allBasenames);const Ee=G.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return Ee.length&&(le.allPaths=Ee),le}function p(ce,Y,G){const J=L.sep===L.$fc.sep,le=J?ce:ce.replace($,L.sep),Q=L.sep+le,Ee=L.$fc.sep+ce;let he;return G?he=function(K,U){return typeof K=="string"&&(K===le||K.endsWith(Q)||!J&&(K===ce||K.endsWith(Ee)))?Y:null}:he=function(K,U){return typeof K=="string"&&(K===le||!J&&K===ce)?Y:null},he.allPaths=[(G?"*/":"./")+ce],he}function k(ce){try{const Y=new RegExp(`^${w(ce)}$`);return function(G){return Y.lastIndex=0,typeof G=="string"&&Y.test(G)?ce:null}}catch{return d}}function P(ce,Y,G){return!ce||typeof Y!="string"?!1:j(ce)(Y,void 0,G)}e.$Bj=P;function j(ce,Y={}){if(!ce)return s;if(typeof ce=="string"||z(ce)){const G=l(ce,Y);if(G===d)return s;const J=function(le,Q){return!!G(le,Q)};return G.allBasenames&&(J.allBasenames=G.allBasenames),G.allPaths&&(J.allPaths=G.allPaths),J}return N(ce,Y)}e.$Cj=j;function z(ce){const Y=ce;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.$Dj=z;function M(ce){return ce.allBasenames||[]}e.$Ej=M;function F(ce){return ce.allPaths||[]}e.$Fj=F;function N(ce,Y){const G=W(Object.getOwnPropertyNames(ce).map(he=>O(he,ce[he],Y)).filter(he=>he!==d)),J=G.length;if(!J)return d;if(!G.some(he=>!!he.requiresSiblings)){if(J===1)return G[0];const he=function(ie,be){let H;for(let _=0,Z=G.length;_<Z;_++){const $e=G[_](ie,be);if(typeof $e=="string")return $e;(0,T.$Kg)($e)&&(H||(H=[]),H.push($e))}return H?(async()=>{for(const _ of H){const Z=await _;if(typeof Z=="string")return Z}return null})():null},K=G.find(ie=>!!ie.allBasenames);K&&(he.allBasenames=K.allBasenames);const U=G.reduce((ie,be)=>be.allPaths?ie.concat(be.allPaths):ie,[]);return U.length&&(he.allPaths=U),he}const le=function(he,K,U){let ie,be;for(let H=0,_=G.length;H<_;H++){const Z=G[H];Z.requiresSiblings&&U&&(K||(K=(0,L.$mc)(he)),ie||(ie=K.substr(0,K.length-(0,L.$nc)(he).length)));const $e=Z(he,K,ie,U);if(typeof $e=="string")return $e;(0,T.$Kg)($e)&&(be||(be=[]),be.push($e))}return be?(async()=>{for(const H of be){const _=await H;if(typeof _=="string")return _}return null})():null},Q=G.find(he=>!!he.allBasenames);Q&&(le.allBasenames=Q.allBasenames);const Ee=G.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return Ee.length&&(le.allPaths=Ee),le}function O(ce,Y,G){if(Y===!1)return d;const J=l(ce,G);if(J===d)return d;if(typeof Y=="boolean")return J;if(Y){const le=Y.when;if(typeof le=="string"){const Q=(Ee,he,K,U)=>{if(!U||!J(Ee,he))return null;const ie=le.replace("$(basename)",()=>K),be=U(ie);return(0,T.$Kg)(be)?be.then(H=>H?ce:null):be?ce:null};return Q.requiresSiblings=!0,Q}}return J}function W(ce,Y){const G=ce.filter(he=>!!he.basenames);if(G.length<2)return ce;const J=G.reduce((he,K)=>{const U=K.basenames;return U?he.concat(U):he},[]);let le;if(Y){le=[];for(let he=0,K=J.length;he<K;he++)le.push(Y)}else le=G.reduce((he,K)=>{const U=K.patterns;return U?he.concat(U):he},[]);const Q=function(he,K){if(typeof he!="string")return null;if(!K){let ie;for(ie=he.length;ie>0;ie--){const be=he.charCodeAt(ie-1);if(be===47||be===92)break}K=he.substr(ie)}const U=J.indexOf(K);return U!==-1?le[U]:null};Q.basenames=J,Q.patterns=le,Q.allBasenames=J;const Ee=ce.filter(he=>!he.basenames);return Ee.push(Q),Ee}function x(ce,Y){return(0,D.$tb)(ce,Y,(G,J)=>typeof G=="string"&&typeof J=="string"?G===J:typeof G!="string"&&typeof J!="string"?G.base===J.base&&G.pattern===J.pattern:!1)}e.$Gj=x}),define(ke[80],Se([1,0,8,164,23,13,2]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class y{constructor(o="",i=!1){if(this.value=o,typeof this.value!="string")throw(0,D.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(o,i=0){return this.value+=$(this.supportThemeIcons?(0,T.$3j)(o):o).replace(/([ \t]+)/g,(n,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,i){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(o,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(o),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(o,i){const n=new RegExp((0,R.$Je)(i),"g");return o.replace(n,(r,a)=>o.charAt(a-1)!=="\\"?`\\${r}`:r)}}e.$9j=y;function m(u){return A(u)?!u.value:Array.isArray(u)?u.every(m):!0}e.$0j=m;function A(u){return u instanceof y?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.$$j=A;function C(u,o){return u===o?!0:!u||!o?!1:u.value===o.value&&u.isTrusted===o.isTrusted&&u.supportThemeIcons===o.supportThemeIcons&&u.supportHtml===o.supportHtml&&(u.baseUri===o.baseUri||!!u.baseUri&&!!o.baseUri&&(0,g.$sg)(L.URI.from(u.baseUri),L.URI.from(o.baseUri)))}e.$_j=C;function $(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=$;function v(u){return u.replace(/"/g,"&quot;")}e.$bk=v;function S(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=S;function w(u){const o=[],i=u.split("|").map(r=>r.trim());u=i[0];const n=i[1];if(n){const r=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=r?r[1]:"",s=a?a[1]:"",d=isFinite(parseInt(s)),l=isFinite(parseInt(t));d&&o.push(`width="${s}"`),l&&o.push(`height="${t}"`)}return{href:u,dimensions:o}}e.$dk=w}),define(ke[102],Se([1,0,19,33,16,11,23,13]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=void 0;function y(l,c){const{os:h,tildify:E,relative:I}=c;if(I){const k=m(l,I,h);if(typeof k=="string")return k}let f=l.fsPath;if(h===1&&!R.$i?f=f.replace(/\//g,"\\"):h!==1&&R.$i&&(f=f.replace(/\\/g,"/")),h!==1&&E?.userHome){const k=E.userHome.fsPath;let P;l.scheme!==E.userHome.scheme&&l.path[0]===g.$fc.sep&&l.path[1]!==g.$fc.sep?P=E.userHome.with({path:l.path}).fsPath:P=f,f=$(P,k,h)}return(h===1?g.$ec:g.$fc).normalize(A(f,h===1))}e.$yv=y;function m(l,c,h){const E=h===1?g.$ec:g.$fc,I=h===3?L.$pg:L.$rg,f=c.getWorkspace(),p=(0,D.$Nb)(f.folders);if(!p)return;l.scheme!==p.uri.scheme&&l.path[0]===g.$fc.sep&&l.path[1]!==g.$fc.sep&&(l=p.uri.with({path:l.path}));const k=c.getWorkspaceFolder(l);if(!k)return;let P;if(I.isEqual(k.uri,l)?P="":P=I.relativePath(k.uri,l)??"",P&&(P=E.normalize(P)),f.folders.length>1&&!c.noPrefix){const j=k.name?k.name:I.basenameOrAuthority(k.uri);P=P?`${j} \u2022 ${P}`:j}return P}function A(l,c=R.$i){return(0,T.$6f)(l,c)?l.charAt(0).toUpperCase()+l.slice(1):l}e.$zv=A;let C=Object.create(null);function $(l,c,h=R.OS){if(h===1||!l||!c)return l;let E=C.original===c?C.normalized:void 0;E||(E=c,R.$i&&(E=(0,T.$Vf)(E)),E=`${(0,b.$Oe)(E,g.$fc.sep)}${g.$fc.sep}`,C={original:c,normalized:E});let I=l;return R.$i&&(I=(0,T.$Vf)(I)),(h===3?I.startsWith(E):(0,b.$7e)(I,E))?`~/${I.substr(E.length)}`:l}e.$Av=$;function v(l,c){return l.replace(/^~($|\/|\\)/,`${c}$1`)}e.$Bv=v;const S="\u2026",w="\\\\",u="~";function o(l,c=g.sep){const h=new Array(l.length);let E=!1;for(let I=0;I<l.length;I++){const f=l[I];if(f===""){h[I]=`.${c}`;continue}if(!f){h[I]=f;continue}E=!0;let p="",k=f;k.indexOf(w)===0?(p=k.substr(0,k.indexOf(w)+w.length),k=k.substr(k.indexOf(w)+w.length)):k.indexOf(c)===0?(p=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length)):k.indexOf(u)===0&&(p=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length));const P=k.split(c);for(let j=1;E&&j<=P.length;j++)for(let z=P.length-j;E&&z>=0;z--){E=!1;let M=P.slice(z,z+j).join(c);for(let F=0;!E&&F<l.length;F++)if(F!==I&&l[F]&&l[F].indexOf(M)>-1){const N=z+j===P.length,O=z>0&&l[F].indexOf(c)>-1?c+M:M,W=l[F].endsWith(O);E=!N||W}if(!E){let F="";(P[0].endsWith(":")||p!=="")&&(z===1&&(z=0,j++,M=P[0]+c+M),z>0&&(F=P[0]+c),F=p+F),z>0&&(F=F+S+c),F=F+M,z+j<P.length&&(F=F+c+S),h[I]=F}}E&&(h[I]=f)}return h}e.$Cv=o;var i;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(l,c=Object.create(null)){const h=[];let E=!1,I="";for(const f of l)if(f==="$"||E&&f==="{")I&&h.push({value:I,type:i.TEXT}),I="",E=!0;else if(f==="}"&&E){const p=c[I];if(typeof p=="string")p.length&&h.push({value:p,type:i.VARIABLE});else if(p){const k=h[h.length-1];(!k||k.type!==i.SEPARATOR)&&h.push({value:p.label,type:i.SEPARATOR})}I="",E=!1}else I+=f;return I&&!E&&h.push({value:I,type:i.TEXT}),h.filter((f,p)=>{if(f.type===i.SEPARATOR){const k=h[p-1],P=h[p+1];return[k,P].every(j=>j&&(j.type===i.VARIABLE||j.type===i.TEXT)&&j.value.length>0)}return!0}).map(f=>f.value).join("")}e.$Dv=n;function r(l,c){return R.$j||c?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Ev=r;function a(l,c){return R.$j||c?l.replace(/\(&&\w\)|&&/g,""):R.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.$Fv=a;function t(l){return l.replace(/&/g,"&&")}e.$Gv=t;function s(l){if(l.endsWith("]")){const c=l.lastIndexOf(" [",l.length-2);if(c!==-1){const h=d(l.substring(0,c));return{name:h.name,parentPath:h.parentPath+l.substring(c)}}}return d(l)}e.$Hv=s;function d(l){const c=l.indexOf("/")!==-1?g.$fc:g.$ec,h=c.basename(l),E=c.dirname(l);return h.length?{name:h,parentPath:E}:{name:E,parentPath:""}}}),define(ke[131],Se([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function g(C){return C.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const v=this.a.transformIncoming($);return v===$?$:g(T.URI.from(v))}transformOutgoing($){const v=this.a.transformOutgoing($);return v===$?$:g(T.URI.from(v))}transformOutgoingURI($){const v=this.a.transformOutgoing($);return v===$?$:T.URI.from(v)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Rm=R,e.$Sm=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function L(C,$,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof T.URI)return $.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const w=L(C[S],$,v+1);w!==null&&(C[S]=w)}}return null}function b(C,$){const v=L(C,$,0);return v===null?C:v}e.$Tm=b;function y(C,$,v,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?T.URI.revive($.transformIncoming(C)):$.transformIncoming(C);if(C instanceof D.$fe)return null;for(const w in C)if(Object.hasOwnProperty.call(C,w)){const u=y(C[w],$,v,S+1);u!==null&&(C[w]=u)}}return null}function m(C,$){const v=y(C,$,!1,0);return v===null?C:v}e.$Um=m;function A(C,$){const v=y(C,$,!0,0);return v===null?C:v}e.$Vm=A}),define(ke[31],Se([1,0,55,63,385,12,33,76,16,11,23,2]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function v(O,W=$.UNLINK,x){if((0,L.$5f)(O))throw new Error("rimraf - will refuse to recursively delete root");return W===$.UNLINK?w(O):S(O,x)}async function S(O,W=(0,L.$0f)((0,T.tmpdir)())){try{try{await D.promises.rename(O,W)}catch(x){return x.code==="ENOENT"?void 0:w(O)}w(W).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function w(O){return(0,g.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function u(O){if((0,L.$5f)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function o(O,W){return r(await(W?i(O):(0,g.promisify)(D.readdir)(O)))}async function i(O){try{return await(0,g.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const W=[],x=await o(O);for(const ce of x){let Y=!1,G=!1,J=!1;try{const le=await e.Promises.lstat((0,y.$ic)(O,ce));Y=le.isFile(),G=le.isDirectory(),J=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}W.push({name:ce,isFile:()=>Y,isDirectory:()=>G,isSymbolicLink:()=>J})}return W}function n(O){return r(D.readdirSync(O))}e.readdirSync=n;function r(O){return O.map(W=>typeof W=="string"?m.$j?(0,b.$ul)(W):W:(W.name=m.$j?(0,b.$ul)(W.name):W.name,W))}async function a(O){const W=await o(O),x=[];for(const ce of W)await s.existsDirectory((0,y.$ic)(O,ce))&&x.push(ce);return x}function t(O,W=1e3){return new Promise(x=>{let ce=!1;const Y=setInterval(()=>{ce||(ce=!0,D.access(O,G=>{ce=!1,G&&(clearInterval(Y),x(void 0))}))},W)})}e.whenDeleted=t;var s;(function(O){async function W(Y){let G;try{if(G=await e.Promises.lstat(Y),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(m.$i&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw le}throw J}}O.stat=W;async function x(Y){try{const{stat:G,symbolicLink:J}=await O.stat(Y);return G.isFile()&&J?.dangling!==!0}catch{}return!1}O.existsFile=x;async function ce(Y){try{const{stat:G,symbolicLink:J}=await O.stat(Y);return G.isDirectory()&&J?.dangling!==!0}catch{}return!1}O.existsDirectory=ce})(s||(e.SymlinkSupport=s={}));const d=new R.$7g;function l(O,W,x){return d.queueFor(C.URI.file(O),A.$qg).queue(()=>{const ce=f(x);return new Promise((Y,G)=>E(O,W,ce,J=>J?G(J):Y()))})}let c=!0;function h(O){c=O}e.configureFlushOnWrite=h;function E(O,W,x,ce){if(!c)return D.writeFile(O,W,{mode:x.mode,flag:x.flag},ce);D.open(O,x.flag,x.mode,(Y,G)=>{if(Y)return ce(Y);D.writeFile(G,W,J=>{if(J)return D.close(G,()=>ce(J));D.fdatasync(G,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),h(!1)),D.close(G,Q=>ce(Q))))})})}function I(O,W,x){const ce=f(x);if(!c)return D.writeFileSync(O,W,{mode:ce.mode,flag:ce.flag});const Y=D.openSync(O,ce.flag,ce.mode);try{D.writeFileSync(Y,W);try{D.fdatasyncSync(Y)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),h(!1)}}finally{D.closeSync(Y)}}e.writeFileSync=I;function f(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function p(O,W,x=6e4){if(O!==W)try{m.$i&&typeof x=="number"?await k(O,W,Date.now(),x):await(0,g.promisify)(D.rename)(O,W)}catch(ce){if(O.toLowerCase()!==W.toLowerCase()&&ce.code==="EXDEV"||O.endsWith("."))await P(O,W,{preserveSymlinks:!1}),await v(O,$.MOVE);else throw ce}}async function k(O,W,x,ce,Y=0){try{return await(0,g.promisify)(D.rename)(O,W)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-x>=ce)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${G}`),G;if(Y===0){let J=!1;try{const{stat:le}=await s.stat(W);le.isFile()||(J=!0)}catch{}if(J)throw G}return await(0,R.$Yg)(Math.min(100,Y*10)),k(O,W,x,ce,Y+1)}}async function P(O,W,x){return z(O,W,{root:{source:O,target:W},options:x,handledSourcePaths:new Set})}const j=511;async function z(O,W,x){if(x.handledSourcePaths.has(O))return;x.handledSourcePaths.add(O);const{stat:ce,symbolicLink:Y}=await s.stat(O);if(Y){if(x.options.preserveSymlinks)try{return await N(O,W,x)}catch{}if(Y.dangling)return}return ce.isDirectory()?M(O,W,ce.mode&j,x):F(O,W,ce.mode&j)}async function M(O,W,x,ce){await e.Promises.mkdir(W,{recursive:!0,mode:x});const Y=await o(O);for(const G of Y)await z((0,y.$ic)(O,G),(0,y.$ic)(W,G),ce)}async function F(O,W,x){await e.Promises.copyFile(O,W),await e.Promises.chmod(W,x)}async function N(O,W,x){let ce=await e.Promises.readlink(O);(0,L.$2f)(ce,x.root.source,!m.$k)&&(ce=(0,y.$ic)(x.root.target,ce.substr(x.root.source.length+1))),await e.Promises.symlink(ce,W)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(O,W,x,ce,Y)=>new Promise((G,J)=>{D.read(O,W,x,ce,Y,(le,Q,Ee)=>le?J(le):G({bytesRead:Q,buffer:Ee}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(O,W,x,ce,Y)=>new Promise((G,J)=>{D.write(O,W,x,ce,Y,(le,Q,Ee)=>le?J(le):G({bytesWritten:Q,buffer:Ee}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return l}get rm(){return v}get rename(){return p}get copy(){return P}}}),define(ke[103],Se([1,0,55,16,11,13,31]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=void 0;function b($){if(g.$k)return $;const v=(0,T.$lc)($);if($===v)return $;const S=((0,T.$mc)($)||$).toLowerCase();try{const u=(0,L.readdirSync)(v).filter(o=>o.toLowerCase()===S);if(u.length===1){const o=b(v);if(o)return(0,T.$ic)(o,u[0])}else if(u.length>1){const o=u.indexOf(S);if(o>=0){const i=b(v);if(i)return(0,T.$ic)(i,u[o])}}}catch{}return null}e.$$p=b;async function y($){if(g.$k)return $;const v=(0,T.$lc)($);if($===v)return $;const S=((0,T.$mc)($)||$).toLowerCase();try{const u=(await L.Promises.readdir(v)).filter(o=>o.toLowerCase()===S);if(u.length===1){const o=await y(v);if(o)return(0,T.$ic)(o,u[0])}else if(u.length>1){const o=u.indexOf(S);if(o>=0){const i=await y(v);if(i)return(0,T.$ic)(i,u[o])}}}catch{}return null}e.$_p=y;async function m($){try{return await L.Promises.realpath($)}catch{const S=C($);return await L.Promises.access(S,D.constants.R_OK),S}}e.$aq=m;function A($){try{return D.realpathSync($)}catch{const S=C($);return D.accessSync(S,D.constants.R_OK),S}}e.$bq=A;function C($){return(0,R.$Oe)((0,T.$gc)($),T.sep)}}),define(ke[104],Se([1,0,16,11,49,101,18,31]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(C=g.env){return C.comspec||"cmd.exe"}e.$Hl=y;function m(C){let $=[],v=!1;const S=function(w){if(v){$.push(w);return}(!C.send(w,o=>{if(o&&console.error(o),v=!1,$.length>0){const i=$.slice(0);$=[],i.forEach(n=>S(n))}})||T.$i)&&(v=!0)};return{send:S}}e.$Il=m;var A;(function(C){async function $(v,S,w){if(D.$hc(v))return v;if(S===void 0&&(S=g.cwd()),D.$lc(v)!=="."||(w===void 0&&L.$Cf(g.env.PATH)&&(w=g.env.PATH.split(D.$sc)),w===void 0||w.length===0))return D.$ic(S,v);async function o(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of w){let n;if(D.$hc(i)?n=D.$ic(i,v):n=D.$ic(S,i,v),await o(n))return n;let r=n+".com";if(await o(r)||(r=n+".exe",await o(r)))return r}return D.$ic(S,v)}C.findExecutable=$})(A||(e.win32=A={}))});var He=this&&this.__decorate||function(me,e,D,T){var g=arguments.length,R=g<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(me,e,D,T);else for(var b=me.length-1;b>=0;b--)(L=me[b])&&(R=(g<3?L(R):g>3?L(e,D,R):L(e,D))||R);return g>3&&R&&Object.defineProperty(e,D,R),R};define(ke[81],Se([1,0,19,12,22,21,59,8,4,3,54,13,18]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.ProxyChannel=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.RequestInitiator=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=void 0;var v;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(v||(v={}));function S(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(w||(w={}));function u(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(o||(o={}));function i(Y){let G=0;for(let J=0;;J+=7){const le=Y.read(1);if(G|=(le.buffer[0]&127)<<J,!(le.buffer[0]&128))return G}}const n=d(0);function r(Y,G){if(G===0){Y.write(n);return}let J=0;for(let Q=G;Q!==0;Q=Q>>>7)J++;const le=g.$fe.alloc(J);for(let Q=0;G!==0;Q++)le.buffer[Q]=G&127,G=G>>>7,G>0&&(le.buffer[Q]|=128);Y.write(le)}class a{constructor(G){this.b=G,this.a=0}read(G){const J=this.b.slice(this.a,this.a+G);return this.a+=J.byteLength,J}}e.$th=a;class t{constructor(){this.a=[]}get buffer(){return g.$fe.concat(this.a)}write(G){this.a.push(G)}}e.$uh=t;var s;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(s||(s={}));function d(Y){const G=g.$fe.alloc(1);return G.writeUInt8(Y,0),G}const l={Undefined:d(s.Undefined),String:d(s.String),Buffer:d(s.Buffer),VSBuffer:d(s.VSBuffer),Array:d(s.Array),Object:d(s.Object),Uint:d(s.Int)},c=typeof Buffer<"u";function h(Y,G){if(typeof G>"u")Y.write(l.Undefined);else if(typeof G=="string"){const J=g.$fe.fromString(G);Y.write(l.String),r(Y,J.byteLength),Y.write(J)}else if(c&&Buffer.isBuffer(G)){const J=g.$fe.wrap(G);Y.write(l.Buffer),r(Y,J.byteLength),Y.write(J)}else if(G instanceof g.$fe)Y.write(l.VSBuffer),r(Y,G.byteLength),Y.write(G);else if(Array.isArray(G)){Y.write(l.Array),r(Y,G.length);for(const J of G)h(Y,J)}else if(typeof G=="number"&&(G|0)===G)Y.write(l.Uint),r(Y,G);else{const J=g.$fe.fromString(JSON.stringify(G));Y.write(l.Object),r(Y,J.byteLength),Y.write(J)}}e.$vh=h;function E(Y){switch(Y.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return Y.read(i(Y)).toString();case s.Buffer:return Y.read(i(Y)).buffer;case s.VSBuffer:return Y.read(i(Y));case s.Array:{const J=i(Y),le=[];for(let Q=0;Q<J;Q++)le.push(E(Y));return le}case s.Object:return JSON.parse(Y.read(i(Y)).toString());case s.Int:return i(Y)}}e.$wh=E;class I{constructor(G,J,le=null,Q=1e3){this.h=G,this.j=J,this.k=le,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Ee=>this.q(Ee)),this.m({type:200})}registerChannel(G,J){this.b.set(G,J),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const J=this.o([G.type]);this.k?.logOutgoing(J,0,1,u(G.type));return}case 201:case 202:case 204:case 203:{const J=this.o([G.type,G.id],G.data);this.k?.logOutgoing(J,G.id,1,u(G.type),G.data);return}}}o(G,J=void 0){const le=new t;return h(le,G),h(le,J),this.p(le.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const J=new a(G),le=E(J),Q=E(J),Ee=le[0];switch(Ee){case 100:return this.k?.logIncoming(G.byteLength,le[1],1,`${S(Ee)}: ${le[2]}.${le[3]}`,Q),this.s({type:Ee,id:le[1],channelName:le[2],name:le[3],arg:Q});case 102:return this.k?.logIncoming(G.byteLength,le[1],1,`${S(Ee)}: ${le[2]}.${le[3]}`,Q),this.t({type:Ee,id:le[1],channelName:le[2],name:le[3],arg:Q});case 101:return this.k?.logIncoming(G.byteLength,le[1],1,`${S(Ee)}`),this.u({type:Ee,id:le[1]});case 103:return this.k?.logIncoming(G.byteLength,le[1],1,`${S(Ee)}`),this.u({type:Ee,id:le[1]})}}s(G){const J=this.b.get(G.channelName);if(!J){this.v(G);return}const le=new R.$2d;let Q;try{Q=J.call(this.j,G.name,G.arg,le.token)}catch(K){Q=Promise.reject(K)}const Ee=G.id;Q.then(K=>{this.m({id:Ee,data:K,type:201})},K=>{K instanceof Error?this.m({id:Ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:Ee,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(G.id)});const he=(0,m.$Pc)(()=>le.cancel());this.d.set(G.id,he)}t(G){const J=this.b.get(G.channelName);if(!J){this.v(G);return}const le=G.id,Ee=J.listen(this.j,G.name,G.arg)(he=>this.m({id:le,data:he,type:204}));this.d.set(G.id,Ee)}u(G){const J=this.d.get(G.id);J&&(J.dispose(),this.d.delete(G.id))}v(G){let J=this.g.get(G.channelName);J||(J=[],this.g.set(G.channelName,J));const le=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:G,timeoutTimer:le})}w(G){const J=this.g.get(G);if(J){for(const le of J)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.$Mc)(this.d.values()),this.d.clear()}}e.$xh=I;var f;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(f||(e.RequestInitiator=f={}));class p{constructor(G,J=null){this.l=G,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=J}getChannel(G){const J=this;return{call(le,Q,Ee){return J.a?Promise.reject(new b.$4):J.m(G,le,Q,Ee)},listen(le,Q){return J.a?y.Event.None:J.o(G,le,Q)}}}m(G,J,le,Q=R.CancellationToken.None){const Ee=this.g++,K={id:Ee,type:100,channelName:G,name:J,arg:le};if(Q.isCancellationRequested)return Promise.reject(new b.$4);let U;return new Promise((be,H)=>{if(Q.isCancellationRequested)return H(new b.$4);const _=()=>{const fe=te=>{switch(te.type){case 201:this.f.delete(Ee),be(te.data);break;case 202:{this.f.delete(Ee);const de=new Error(te.data.message);de.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,de.name=te.data.name,H(de);break}case 203:this.f.delete(Ee),H(te.data);break}};this.f.set(Ee,fe),this.p(K)};let Z=null;this.b===o.Idle?_():(Z=(0,T.$Lg)(fe=>this.u()),Z.then(()=>{Z=null,_()}));const $e=()=>{Z?(Z.cancel(),Z=null):this.p({id:Ee,type:101}),H(new b.$4)},re=Q.onCancellationRequested($e);U=(0,m.$Oc)((0,m.$Pc)($e),re),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(G,J,le){const Q=this.g++,he={id:Q,type:102,channelName:G,name:J,arg:le};let K=null;const U=new y.$Rd({onWillAddFirstListener:()=>{K=(0,T.$Lg)(be=>this.u()),K.then(()=>{K=null,this.d.add(U),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(U),this.p({id:Q,type:103}))}}),ie=be=>U.fire(be.data);return this.f.set(Q,ie),U.event}p(G){switch(G.type){case 100:case 102:{const J=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(J,G.id,0,`${S(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const J=this.q([G.type,G.id]);this.j?.logOutgoing(J,G.id,0,S(G.type));return}}}q(G,J=void 0){const le=new t;return h(le,G),h(le,J),this.r(le.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const J=new a(G),le=E(J),Q=E(J),Ee=le[0];switch(Ee){case 200:return this.j?.logIncoming(G.byteLength,0,0,u(Ee)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,le[1],0,u(Ee),Q),this.t({type:le[0],id:le[1],data:Q})}}t(G){if(G.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.$Mc)(this.d.values()),this.d.clear()}}e.$yh=p,He([L.$nh],p.prototype,"onDidInitializePromise",null);class k{get connections(){const G=[];return this.f.forEach(J=>G.push(J)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new y.$Rd,this.onDidAddConnection=this.g.event,this.h=new y.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new m.$Qc,this.j.add(G(({protocol:J,onDidClientDisconnect:le})=>{const Q=y.Event.once(J.onMessage);this.j.add(Q(Ee=>{const he=new a(Ee),K=E(he),U=new I(J,K),ie=new p(J);this.a.forEach((H,_)=>U.registerChannel(_,H));const be={channelServer:U,channelClient:ie,ctx:K};this.f.add(be),this.g.fire(be),this.j.add(le(()=>{U.dispose(),ie.dispose(),this.f.delete(be),this.h.fire(be)}))}))}))}getChannel(G,J){const le=this;return{call(Q,Ee,he){let K;if((0,$.$Qf)(J)){const ie=(0,D.$3b)(le.connections.filter(J));K=ie?Promise.resolve(ie):y.Event.toPromise(y.Event.filter(le.onDidAddConnection,J))}else K=J.routeCall(le,Q,Ee);const U=K.then(ie=>ie.channelClient.getChannel(G));return j(U).call(Q,Ee,he)},listen(Q,Ee){if((0,$.$Qf)(J))return le.k(G,J,Q,Ee);const he=J.routeEvent(le,Q,Ee).then(K=>K.channelClient.getChannel(G));return j(he).listen(Q,Ee)}}}k(G,J,le,Q){const Ee=this;let he;const K=new y.$Rd({onWillAddFirstListener:()=>{he=new m.$Qc;const U=new y.$Xd,ie=new Map,be=_=>{const $e=_.channelClient.getChannel(G).listen(le,Q),re=U.add($e);ie.set(_,re)},H=_=>{const Z=ie.get(_);Z&&(Z.dispose(),ie.delete(_))};Ee.connections.filter(J).forEach(be),y.Event.filter(Ee.onDidAddConnection,J)(be,void 0,he),Ee.onDidRemoveConnection(H,void 0,he),U.event(K.fire,K,he),he.add(U)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(G,J){this.a.set(G,J);for(const le of this.f)le.channelServer.registerChannel(G,J)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$zh=k;class P{constructor(G,J,le=null){const Q=new t;h(Q,J),G.send(Q.buffer),this.a=new p(G,le),this.d=new I(G,J,le)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,J){this.d.registerChannel(G,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ah=P;function j(Y){return{call(G,J,le){return Y.then(Q=>Q.call(G,J,le))},listen(G,J){const le=new y.$1d;return Y.then(Q=>le.input=Q.listen(G,J)),le.event}}}e.$Bh=j;function z(Y){let G=!1;return{call(J,le,Q){return G?Y.call(J,le,Q):(0,T.$Yg)(0).then(()=>G=!0).then(()=>Y.call(J,le,Q))},listen(J,le){if(G)return Y.listen(J,le);const Q=new y.$1d;return(0,T.$Yg)(0).then(()=>G=!0).then(()=>Q.input=Y.listen(J,le)),Q.event}}}e.$Ch=z;class M{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const J of G.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$Dh=M;var F;(function(Y){function G(Ee,he,K){const U=Ee,ie=K&&K.disableMarshalling,be=new Map;for(const H in U)le(H)&&be.set(H,y.Event.buffer(U[H],!0,void 0,he));return new class{listen(H,_,Z){const $e=be.get(_);if($e)return $e;if(Q(_)){const re=U[_];if(typeof re=="function")return re.call(U,Z)}throw new b.$ab(`Event not found: ${_}`)}call(H,_,Z){const $e=U[_];if(typeof $e=="function"){if(!ie&&Array.isArray(Z))for(let fe=0;fe<Z.length;fe++)Z[fe]=(0,A.$sh)(Z[fe]);let re=$e.apply(U,Z);return re instanceof Promise||(re=Promise.resolve(re)),re}throw new b.$ab(`Method not found: ${_}`)}}}Y.fromService=G;function J(Ee,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return he?.properties?.has(ie)?he.properties.get(ie):Q(ie)?function(be){return Ee.listen(ie,be)}:le(ie)?Ee.listen(ie):async function(...be){let H;he&&!(0,$.$Lf)(he.context)?H=[he.context,...be]:H=be;const _=await Ee.call(ie,H);return K?_:(0,A.$sh)(_)};throw new b.$ab(`Property not found: ${String(ie)}`)}})}Y.toService=J;function le(Ee){return Ee[0]==="o"&&Ee[1]==="n"&&C.$5e(Ee.charCodeAt(2))}function Q(Ee){return/^onDynamic/.test(Ee)&&C.$5e(Ee.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const G=Y.toString();if(G!=="[object Object]")return G}return Y}function W(Y){return Array.isArray(Y)?Y.map(O):O(Y)}function x(Y,G,J,le,Q,Ee,he){he=W(he);const K=N[Q],U=K[le%K.length];let ie=[`%c[${Y}]%c[${String(G).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${Ee}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(Ee)?(ie=ie.concat(he),ie.push(")")):ie.push(he),console.log.apply(console,ie)}class ce{constructor(G,J){this.d=G,this.f=J,this.a=0,this.b=0}logOutgoing(G,J,le,Q,Ee){this.b+=G,x(this.d,this.b,G,J,le,Q,Ee)}logIncoming(G,J,le,Q,Ee){this.a+=G,x(this.f,this.a,G,J,le,Q,Ee)}}e.$Eh=ce}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.ProtocolConstants=e.$Fh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const c=new WeakMap;let h=0;function E(f,p){if(!c.has(f)){const k=String(++h);c.set(f,k)}return c.get(f)}function I(f,p,k,P){if(!l.enableDiagnostics)return;const j=E(f,p);if(P instanceof D.$fe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const z=D.$fe.alloc(P.byteLength);z.set(P),l.records.push({timestamp:Date.now(),id:j,label:p,type:k,buff:z})}else l.records.push({timestamp:Date.now(),id:j,label:p,type:k,data:P})}l.traceSocketEvent=I})(b||(e.SocketDiagnostics=b={}));var y;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let m=null;function A(){return m||(m=D.$fe.alloc(0)),m}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const p=this.a[0];return h&&(this.a.shift(),this.b-=c),p}if(this.a[0].byteLength>c){const p=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),p}const E=D.$fe.alloc(c);let I=0,f=0;for(;c>0;){const p=this.a[f];if(p.byteLength>c){const k=p.slice(0,c);E.set(k,I),I+=c,h&&(this.a[f]=p.slice(c),this.b-=c),c-=c}else E.set(p,I),I+=p.byteLength,h?(this.a.shift(),this.b-=p.byteLength):f++,c-=p.byteLength}return E}}e.$Fh=C;var $;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})($||($={}));function v(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class w{constructor(c,h,E,I){this.type=c,this.id=h,this.ack=E,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends g.$Rc{constructor(c){super(),this.f=this.B(new T.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new C,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const E=this.g.messageType,I=this.g.id,f=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new w(E,I,f,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.$fe.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const E=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,E}h(){const c=D.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class i extends g.$Rc{constructor(c){super(),this.f=new T.$Rd,this.onMessage=this.f.event,this.g=new T.$Rd,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new o(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new w(1,0,0,c))}}e.$Gh=i;class n extends R.$Ah{static fromSocket(c,h){return new n(new i(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,E=null){super(c,h,E),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$Hh=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$Ih=r;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,E=this.a;for(;E;)c[h++]=E.data,E=E.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new a(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<s.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=s.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+s.a)*1e3;let E=0;for(let I=0;I<s.a;I++)c-this.c[I]<=h&&E++;return 1-E/s.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??s.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Qc,this.o=c.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new w(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new w(7,0,0,A());this.p.write(c)}sendResume(){const c=new w(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new g.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(E=>this.z(E))),this.r.add(this.o.onClose(E=>this.x.fire(E))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new w(3,0,this.h,A());this.p.write(c);const h=this.b.toArray();for(let E=0,I=h.length;E<I;E++)this.p.write(h[E]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new w(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let E=0,I=h.length;E<I;E++)this.p.write(h[E]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const E=new w(1,h,this.h,c);this.b.push(E),this.a||(this.p.write(E),this.B())}sendControl(c){const h=new w(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,E=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(h>=2e4&&E>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:E});return}const f=Math.max(2e4-h,2e4-E,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},f)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new w(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new w(9,0,this.h,A());this.p.write(c)}}e.$Jh=d}),define(ke[187],Se([1,0,50,12,22,21,185,8,4,3,24,104,101,81]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;class S extends v.$xh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",i=>g.$fe.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$8p=S;class w{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new y.$Rd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new T.$Ug(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,r,a){return i.k(o,n,r,a)},listen(n,r){return i.l(o,n,r)}}}k(o,i,n,r=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const a=this.n(o),t=(0,T.$Lg)(l=>a.call(i,n,l)),s=r.onCancellationRequested(()=>t.cancel()),d=(0,m.$Pc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{s.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return y.Event.None;this.b.cancel();let r;const a=new y.$Rd({onWillAddFirstListener:()=>{r=this.n(o).listen(i,n)(a.fire,a),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$an)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,$.$Gl)(i.env),this.d=(0,D.fork)(this.i,o,i);const n=new y.$Rd;y.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,L.$4p)(c)){(0,L.log)(c,`IPC Library: ${this.j.serverName}`);return}n.fire(g.$fe.wrap(Buffer.from(c,"base64")))});const a=this.j.useQueue?(0,C.$Il)(this.d):this.d,t=c=>this.d&&this.d.connected&&a.send(c.buffer.toString("base64")),s=n.event,d={send:t,onMessage:s};this.f=new v.$yh(d);const l=()=>this.o();process.once("exit",l),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,h)=>{process.removeListener("exit",l),this.c.forEach(E=>(0,m.$Mc)(E)),this.c.clear(),c!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:h})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9p=w}),define(ke[188],Se([1,0,12,4,3,54,18]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.StorageState=e.$7o=e.StorageHint=void 0;var b;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function y($){const v=$;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$7o=y;var m;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(m||(e.StorageState=m={}));class A extends g.$Rc{static{this.a=100}constructor(v,S=Object.create(null)){super(),this.r=v,this.s=S,this.b=this.B(new T.$Ud),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=this.B(new D.$Vg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((S,w)=>this.w(w,S)),v.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(v,S){if(this.c===m.Closed)return;let w=!1;(0,L.$Lf)(S)?w=this.f.delete(v):this.f.get(v)!==S&&(this.f.set(v,S),w=!0),w&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,S){const w=this.f.get(v);return(0,L.$Lf)(w)?S:w}getBoolean(v,S){const w=this.get(v);return(0,L.$Lf)(w)?S:w==="true"}getNumber(v,S){const w=this.get(v);return(0,L.$Lf)(w)?S:parseInt(w,10)}getObject(v,S){const w=this.get(v);return(0,L.$Lf)(w)?S:(0,R.$rh)(w)}async set(v,S,w=!1){if(this.c===m.Closed)return;if((0,L.$Lf)(S))return this.delete(v,w);const u=(0,L.$Ef)(S)||Array.isArray(S)?(0,R.$qh)(S):String(S);if(this.f.get(v)!==u)return this.f.set(v,u),this.j.set(v,u),this.h.delete(v),this.b.fire({key:v,external:w}),this.D()}async delete(v,S=!1){if(!(this.c===m.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:S}),this.D()}async optimize(){if(this.c!==m.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=m.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$8o=A;class C{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((S,w)=>this.a.set(w,S)),v.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$9o=C}),define(ke[189],Se([1,0,13,11,22]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function y(){return b||(b=new TextDecoder("UTF-16BE")),b}let m;function A(){return m||(m=T.$D()?L():y()),m}e.$Rs=A;function C(S,w,u){const o=new Uint16Array(S.buffer,w,u);return u>0&&(o[0]===65279||o[0]===65534)?$(S,w,u):L().decode(o)}e.$Ss=C;function $(S,w,u){const o=[];let i=0;for(let n=0;n<u;n++){const r=g.$he(S,w);w+=2,o[i++]=String.fromCharCode(r)}return o.join("")}class v{constructor(w){this.a=w|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const w=new Uint16Array(this.b.buffer,0,this.d);return A().decode(w)}f(){const w=this.e();this.d=0,this.c===null?this.c=[w]:this.c[this.c.length]=w}appendCharCode(w){const u=this.a-this.d;u<=1&&(u===0||D.$0e(w))&&this.f(),this.b[this.d++]=w}appendASCIICharCode(w){this.d===this.a&&this.f(),this.b[this.d++]=w}appendString(w){const u=w.length;if(this.d+u>=this.a){this.f(),this.c[this.c.length]=w;return}for(let o=0;o<u;o++)this.b[this.d++]=w.charCodeAt(o)}}e.$Ts=v}),define(ke[190],Se([1,0,22,189]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function g(y){return y.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(m,A,C,$){this.oldPosition=m,this.oldText=A,this.newPosition=C,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(m){return 4+2*m.length}static c(m,A,C){const $=A.length;D.$ke(m,$,C),C+=4;for(let v=0;v<$;v++)D.$ie(m,A.charCodeAt(v),C),C+=2;return C}static d(m,A){const C=D.$je(m,A);return A+=4,(0,T.$Ss)(m,A,C)}writeSize(){return 4+4+R.a(this.oldText)+R.a(this.newText)}write(m,A){return D.$ke(m,this.oldPosition,A),A+=4,D.$ke(m,this.newPosition,A),A+=4,A=R.c(m,this.oldText,A),A=R.c(m,this.newText,A),A}static read(m,A,C){const $=D.$je(m,A);A+=4;const v=D.$je(m,A);A+=4;const S=R.d(m,A);A+=R.a(S);const w=R.d(m,A);return A+=R.a(w),C.push(new R($,S,v,w)),A}}e.$Us=R;function L(y,m){return y===null||y.length===0?m:new b(y,m).compress()}e.$Vs=L;class b{constructor(m,A){this.a=m,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let m=0,A=0,C=this.n(m),$=this.l(A);for(;m<this.f||A<this.h;){if(C===null){this.k($),$=this.l(++A);continue}if($===null){this.m(C),C=this.n(++m);continue}if($.oldEnd<=C.newPosition){this.k($),$=this.l(++A);continue}if(C.newEnd<=$.oldPosition){this.m(C),C=this.n(++m);continue}if($.oldPosition<C.newPosition){const[o,i]=b.r($,C.newPosition-$.oldPosition);this.k(o),$=i;continue}if(C.newPosition<$.oldPosition){const[o,i]=b.q(C,$.oldPosition-C.newPosition);this.m(o),C=i;continue}let w,u;if($.oldEnd===C.newEnd)w=C,u=$,C=this.n(++m),$=this.l(++A);else if($.oldEnd<C.newEnd){const[o,i]=b.q(C,$.oldLength);w=o,u=$,C=i,$=this.l(++A)}else{const[o,i]=b.r($,C.newLength);w=C,u=o,C=this.n(++m),$=i}this.d[this.e++]=new R(w.oldPosition,w.oldText,u.newPosition,u.newText),this.g+=w.newLength-w.oldLength,this.j+=u.newLength-u.oldLength}const v=b.s(this.d);return b.t(v)}k(m){this.d[this.e++]=b.o(this.g,m),this.j+=m.newLength-m.oldLength}l(m){return m<this.h?this.c[m]:null}m(m){this.d[this.e++]=b.p(this.j,m),this.g+=m.newLength-m.oldLength}n(m){return m<this.f?this.a[m]:null}static o(m,A){return new R(A.oldPosition-m,A.oldText,A.newPosition,A.newText)}static p(m,A){return new R(A.oldPosition,A.oldText,A.newPosition+m,A.newText)}static q(m,A){const C=m.newText.substr(0,A),$=m.newText.substr(A);return[new R(m.oldPosition,m.oldText,m.newPosition,C),new R(m.oldEnd,"",m.newPosition+A,$)]}static r(m,A){const C=m.oldText.substr(0,A),$=m.oldText.substr(A);return[new R(m.oldPosition,C,m.newPosition,m.newText),new R(m.oldPosition+A,$,m.newEnd,"")]}static s(m){if(m.length===0)return m;const A=[];let C=0,$=m[0];for(let v=1;v<m.length;v++){const S=m[v];$.oldEnd===S.oldPosition?$=new R($.oldPosition,$.oldText+S.oldText,$.newPosition,$.newText+S.newText):(A[C++]=$,$=S)}return A[C++]=$,A}static t(m){if(m.length===0)return m;const A=[];let C=0;for(let $=0;$<m.length;$++){const v=m[$];v.oldText!==v.newText&&(A[C++]=v)}return A}}}),define(ke[191],Se([1,0,34,16]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=void 0;function g(R,L,b,y,m,A){if(Array.isArray(R)){let C=0;for(const $ of R){const v=g($,L,b,y,m,A);if(v===10)return v;v>C&&(C=v)}return C}else{if(typeof R=="string")return y?R==="*"?5:R===b?10:0:0;if(R){const{language:C,pattern:$,scheme:v,hasAccessToAllModels:S,notebookType:w}=R;if(!y&&!S)return 0;w&&m&&(L=m);let u=0;if(v)if(v===L.scheme)u=10;else if(v==="*")u=5;else return 0;if(C)if(C===b)u=10;else if(C==="*")u=Math.max(u,5);else return 0;if(w)if(w===A)u=10;else if(w==="*"&&A!==void 0)u=Math.max(u,5);else return 0;if($){let o;if(typeof $=="string"?o=$:o={...$,base:(0,T.$gc)($.base)},o===L.fsPath||(0,D.$Bj)(o,L.fsPath))u=10;else return 0}return u}else return 0}}e.$LE=g}),define(ke[192],Se([1,0,4,13,29,79,128,167,190,3]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class A extends m.$Rc{constructor($,v,S,w,u,o,i){super(),this.m=this.B(new D.$Rd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!o,this.g=w,this.h=u,this.c=new L.$LB($,S,i)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,v){return this.c.getOffsetAt($,v)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,v){const S=$+v,w=this.getPositionAt($),u=this.getPositionAt(S);return new g.$zs(w.lineNumber,w.column,u.lineNumber,u.column)}getValueInRange($,v=0){if($.isEmpty())return"";const S=this.n(v);return this.c.getValueInRange($,S)}getValueLengthInRange($,v=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const S=this.getOffsetAt($.startLineNumber,$.startColumn),w=this.getOffsetAt($.endLineNumber,$.endColumn);let u=0;const o=this.n(v),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,r=$.endLineNumber-$.startLineNumber;u=n*r}return w-S+u}getCharacterCountInRange($,v=0){if(this.j){let S=0;const w=$.startLineNumber,u=$.endLineNumber;for(let o=w;o<=u;o++){const i=this.getLineContent(o),n=o===w?$.startColumn-1:0,r=o===u?$.endColumn-1:i.length;for(let a=n;a<r;a++)T.$0e(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(v).length*(u-w),S}return this.getValueLengthInRange($,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,v){return this.c.getLineCharCode($,v)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const v=T.$Ue(this.getLineContent($));return v===-1?0:v+1}getLineLastNonWhitespaceColumn($){const v=T.$We(this.getLineContent($));return v===-1?0:v+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,v,S){let w=this.g,u=this.h,o=this.j,i=!0,n=[];for(let c=0;c<$.length;c++){const h=$[c];i&&h._isTracked&&(i=!1);const E=h.range;if(h.text){let P=!0;o||(P=!T.$if(h.text),o=P),!w&&P&&(w=T.$hf(h.text)),!u&&P&&(u=T.$kf(h.text))}let I="",f=0,p=0,k=0;if(h.text){let P;[f,p,k,P]=(0,b.$_s)(h.text);const j=this.getEOL();P===0||P===(j===`\r
`?2:1)?I=h.text:I=h.text.replace(/\r\n|\r|\n/g,j)}n[c]={sortIndex:c,identifier:h.identifier||null,range:E,rangeOffset:this.getOffsetAt(E.startLineNumber,E.startColumn),rangeLength:this.getValueLengthInRange(E),text:I,eolCount:f,firstLineLength:p,lastLineLength:k,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(A.u);let r=!1;for(let c=0,h=n.length-1;c<h;c++){const E=n[c].range.getEndPosition(),I=n[c+1].range.getStartPosition();if(I.isBeforeOrEqual(E)){if(I.isBefore(E))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const a=S||v?A._getInverseEditRanges(n):[],t=[];if(v)for(let c=0;c<n.length;c++){const h=n[c],E=a[c];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let I=E.startLineNumber;I<=E.endLineNumber;I++){let f="";I===E.startLineNumber&&(f=this.getLineContent(h.range.startLineNumber),T.$Ue(f)!==-1)||t.push({lineNumber:I,oldContent:f})}}let s=null;if(S){let c=0;s=[];for(let h=0;h<n.length;h++){const E=n[h],I=a[h],f=this.getValueInRange(E.range),p=E.rangeOffset+c;c+=E.text.length-f.length,s[h]={sortIndex:E.sortIndex,identifier:E.identifier,range:I,text:f,textChange:new y.$Us(E.rangeOffset,f,p,E.text)}}r||s.sort((h,E)=>h.sortIndex-E.sortIndex)}this.g=w,this.h=u,this.j=o;const d=this.t(n);let l=null;if(v&&t.length>0){t.sort((c,h)=>h.lineNumber-c.lineNumber),l=[];for(let c=0,h=t.length;c<h;c++){const E=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===E)continue;const I=t[c].oldContent,f=this.getLineContent(E);f.length===0||f===I||T.$Ue(f)!==-1||l.push(E)}}return this.m.fire(),new R.$Uu(s,d,l)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let v=!1;const S=$[0].range,w=$[$.length-1].range,u=new g.$zs(S.startLineNumber,S.startColumn,w.endLineNumber,w.endColumn);let o=S.startLineNumber,i=S.startColumn;const n=[];for(let d=0,l=$.length;d<l;d++){const c=$[d],h=c.range;v=v||c.forceMoveMarkers,n.push(this.getValueInRange(new g.$zs(o,i,h.startLineNumber,h.startColumn))),c.text.length>0&&n.push(c.text),o=h.endLineNumber,i=h.endColumn}const r=n.join(""),[a,t,s]=(0,b.$_s)(r);return{sortIndex:0,identifier:$[0].identifier,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u,0),text:r,eolCount:a,firstLineLength:t,lastLineLength:s,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const v=[];for(let S=0;S<$.length;S++){const w=$[S],u=w.range.startLineNumber,o=w.range.startColumn,i=w.range.endLineNumber,n=w.range.endColumn;if(u===i&&o===n&&w.text.length===0)continue;w.text?(this.c.delete(w.rangeOffset,w.rangeLength),this.c.insert(w.rangeOffset,w.text,!0)):this.c.delete(w.rangeOffset,w.rangeLength);const r=new g.$zs(u,o,i,n);v.push({range:r,rangeLength:w.rangeLength,text:w.text,rangeOffset:w.rangeOffset,forceMoveMarkers:w.forceMoveMarkers})}return v}findMatchesLineByLine($,v,S,w){return this.c.findMatchesLineByLine($,v,S,w)}getPieceTree(){return this.c}static _getInverseEditRange($,v){const S=$.startLineNumber,w=$.startColumn,[u,o,i]=(0,b.$_s)(v);let n;if(v.length>0){const r=u+1;r===1?n=new g.$zs(S,w,S,w+o):n=new g.$zs(S,w,S+r-1,i+1)}else n=new g.$zs(S,w,S,w);return n}static _getInverseEditRanges($){const v=[];let S=0,w=0,u=null;for(let o=0,i=$.length;o<i;o++){const n=$[o];let r,a;u?u.range.endLineNumber===n.range.startLineNumber?(r=S,a=w+(n.range.startColumn-u.range.endColumn)):(r=S+(n.range.startLineNumber-u.range.endLineNumber),a=n.range.startColumn):(r=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const s=n.eolCount+1;s===1?t=new g.$zs(r,a,r,a+n.firstLineLength):t=new g.$zs(r,a,r+s-1,n.lastLineLength+1)}else t=new g.$zs(r,a,r,a);S=t.endLineNumber,w=t.endColumn,v.push(t),u=n}return v}static u($,v){const S=g.$zs.compareRangesUsingEnds($.range,v.range);return S===0?$.sortIndex-v.sortIndex:S}static w($,v){const S=g.$zs.compareRangesUsingEnds($.range,v.range);return S===0?v.sortIndex-$.sortIndex:-S}}e.$MB=A}),define(ke[193],Se([1,0,13,128,192]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=void 0;class R{constructor(y,m,A,C,$,v,S,w,u){this.a=y,this.b=m,this.c=A,this.d=C,this.e=$,this.f=v,this.g=S,this.h=w,this.j=u}k(y){const m=this.c+this.d+this.e,A=this.c+this.e;return m===0?y===1?`
`:`\r
`:A>m/2?`\r
`:`
`}create(y){const m=this.k(y),A=this.a;if(this.j&&(m===`\r
`&&(this.c>0||this.d>0)||m===`
`&&(this.c>0||this.e>0)))for(let $=0,v=A.length;$<v;$++){const S=A[$].buffer.replace(/\r\n|\r|\n/g,m),w=(0,T.$HB)(S);A[$]=new T.$KB(S,w)}const C=new g.$MB(A,this.b,m,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(y){return this.a[0].buffer.substr(0,y).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(y){if(y.length===0)return;this.a.length===0&&D.$qf(y)&&(this.b=D.$pf,y=y.substr(1));const m=y.charCodeAt(y.length-1);m===13||m>=55296&&m<=56319?(this.m(y.substr(0,y.length-1),!1),this.c=!0,this.d=m):(this.m(y,!1),this.c=!1,this.d=m)}m(y,m){!m&&y.length===0||(this.c?this.n(String.fromCharCode(this.d)+y):this.n(y))}n(y){const m=(0,T.$IB)(this.e,y);this.a.push(new T.$KB(y,m.lineStarts)),this.f+=m.cr,this.g+=m.lf,this.h+=m.crlf,m.isBasicASCII||(this.l=!1,this.j||(this.j=D.$hf(y)),this.k||(this.k=D.$kf(y)))}finish(y=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,y)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const y=this.a[this.a.length-1];y.buffer+=String.fromCharCode(this.d);const m=(0,T.$HB)(y.buffer);y.lineStarts=m,this.d===13&&this.f++}}}e.$NB=L}),define(ke[132],Se([1,0,22,11]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$10=e.$Z0=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function R(C){for(let $=0,v=C.length;$<v;$+=4){const S=C[$+0],w=C[$+1],u=C[$+2],o=C[$+3];C[$+0]=o,C[$+1]=u,C[$+2]=w,C[$+3]=S}}function L(C){const $=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return T.$D()||R($),D.$fe.wrap($)}function b(C){const $=C.buffer;if(T.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const v=new Uint8Array($.byteLength);return v.set($),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function y(C){const $=new Uint32Array(m(C));let v=0;if($[v++]=C.id,C.type==="full")$[v++]=1,$[v++]=C.data.length,$.set(C.data,v),v+=C.data.length;else{$[v++]=2,$[v++]=C.deltas.length;for(const S of C.deltas)$[v++]=S.start,$[v++]=S.deleteCount,S.data?($[v++]=S.data.length,$.set(S.data,v),v+=S.data.length):$[v++]=0}return L($)}e.$Z0=y;function m(C){let $=0;if($+=1+1,C.type==="full")$+=1+C.data.length;else{$+=1,$+=(1+1+1)*C.deltas.length;for(const v of C.deltas)v.data&&($+=v.data.length)}return $}function A(C){const $=b(C);let v=0;const S=$[v++];if($[v++]===1){const i=$[v++],n=$.subarray(v,v+i);return v+=i,{id:S,type:"full",data:n}}const u=$[v++],o=[];for(let i=0;i<u;i++){const n=$[v++],r=$[v++],a=$[v++];let t;a>0&&(t=$.subarray(v,v+a),v+=a),o[i]={start:n,deleteCount:r,data:t}}return{id:S,type:"delta",deltas:o}}e.$10=A}),define(ke[194],Se([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[133],Se([1,0,19,24,11,170,127,194]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=m;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(ae,Ie,Ke,Ge){this.id=ae,this.name=Ie,this.defaultValue=Ke,this.schema=Ge}applyUpdate(ae,Ie){return v(ae,Ie)}compute(ae,Ie,Ke){return Ke}}class ${constructor(ae,Ie){this.newValue=ae,this.didChange=Ie}}e.ApplyUpdateResult=$;function v(ue,ae){if(typeof ue!="object"||typeof ae!="object"||!ue||!ae)return new $(ae,ue!==ae);if(Array.isArray(ue)||Array.isArray(ae)){const Ke=Array.isArray(ue)&&Array.isArray(ae)&&D.$tb(ue,ae);return new $(ae,!Ke)}let Ie=!1;for(const Ke in ae)if(ae.hasOwnProperty(Ke)){const Ge=v(ue[Ke],ae[Ke]);Ge.didChange&&(ue[Ke]=Ge.newValue,Ie=!0)}return new $(ue,Ie)}class S{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ie){return v(ae,Ie)}validate(ae){return this.defaultValue}}class w{constructor(ae,Ie,Ke,Ge){this.id=ae,this.name=Ie,this.defaultValue=Ke,this.schema=Ge}applyUpdate(ae,Ie){return v(ae,Ie)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ie,Ke){return Ke}}function u(ue,ae){return typeof ue>"u"?ae:ue==="false"?!1:!!ue}e.boolean=u;class o extends w{constructor(ae,Ie,Ke,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=Ke),super(ae,Ie,Ke,Ge)}validate(ae){return u(ae,this.defaultValue)}}function i(ue,ae,Ie,Ke){if(typeof ue>"u")return ae;let Ge=parseInt(ue,10);return isNaN(Ge)?ae:(Ge=Math.max(Ie,Ge),Ge=Math.min(Ke,Ge),Ge|0)}e.clampedInt=i;class n extends w{static clampedInt(ae,Ie,Ke,Ge){return i(ae,Ie,Ke,Ge)}constructor(ae,Ie,Ke,Ge,_e,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ke,st.minimum=Ge,st.maximum=_e),super(ae,Ie,Ke,st),this.minimum=Ge,this.maximum=_e}validate(ae){return n.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function r(ue,ae,Ie,Ke){if(typeof ue>"u")return ae;const Ge=a.float(ue,ae);return a.clamp(Ge,Ie,Ke)}e.clampedFloat=r;class a extends w{static clamp(ae,Ie,Ke){return ae<Ie?Ie:ae>Ke?Ke:ae}static float(ae,Ie){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ie;const Ke=parseFloat(ae);return isNaN(Ke)?Ie:Ke}constructor(ae,Ie,Ke,Ge,_e){typeof _e<"u"&&(_e.type="number",_e.default=Ke),super(ae,Ie,Ke,_e),this.validationFn=Ge}validate(ae){return this.validationFn(a.float(ae,this.defaultValue))}}class t extends w{static string(ae,Ie){return typeof ae!="string"?Ie:ae}constructor(ae,Ie,Ke,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=Ke),super(ae,Ie,Ke,Ge)}validate(ae){return t.string(ae,this.defaultValue)}}function s(ue,ae,Ie,Ke){return typeof ue!="string"?ae:Ke&&ue in Ke?Ke[ue]:Ie.indexOf(ue)===-1?ae:ue}e.stringSet=s;class d extends w{constructor(ae,Ie,Ke,Ge,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.enum=Ge,_e.default=Ke),super(ae,Ie,Ke,_e),this.c=Ge}validate(ae){return s(ae,this.defaultValue,this.c)}}class l extends C{constructor(ae,Ie,Ke,Ge,_e,st,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=_e,lt.default=Ge),super(ae,Ie,Ke,lt),this.c=_e,this.d=st}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function c(ue){switch(ue){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ie,Ke){return Ke===0?ae.accessibilitySupport:Ke}}class E extends C{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertSpace:u(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function f(ue){switch(ue){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function k(ue){switch(ue){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function P(ue){switch(ue){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class j extends S{constructor(){super(140)}compute(ae,Ie,Ke){const Ge=["monaco-editor"];return Ie.get(39)&&Ge.push(Ie.get(39)),ae.extraEditorClassName&&Ge.push(ae.extraEditorClassName),Ie.get(73)==="default"?Ge.push("mouse-default"):Ie.get(73)==="copy"&&Ge.push("mouse-copy"),Ie.get(110)&&Ge.push("showUnused"),Ie.get(138)&&Ge.push("showDeprecated"),Ge.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ae,Ie,Ke){return Ke&&ae.emptySelectionClipboard}}class M extends C{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:b.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{cursorMoveOnType:u(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":s(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":s(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(Ie.loop,this.defaultValue.loop)}}}class F extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?F.OFF:ae==="true"?F.ON:ae:ae?F.ON:F.OFF}}e.EditorFontLigatures=F;class N extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?N.OFF:ae==="true"?N.TRANSLATE:ae:ae?N.TRANSLATE:N.OFF}compute(ae,Ie,Ke){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class O extends S{constructor(){super(50)}compute(ae,Ie,Ke){return ae.fontInfo}}class W extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ae){const Ie=a.float(ae,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ae,Ie,Ke){return ae.fontInfo.fontSize}}class x extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.d,maximum:x.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(n.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,x.d,x.e))}}class ce extends C{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{multiple:s(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??s(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??s(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??s(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??s(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??s(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends C{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:b.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:u(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(Ie.above,this.defaultValue.above)}}}var G;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class J extends S{constructor(){super(143)}compute(ae,Ie,Ke){return J.computeLayout(Ie,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ie=ae.height/ae.lineHeight,Ke=Math.floor(ae.paddingTop/ae.lineHeight);let Ge=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(Ge=Math.max(Ge,Ie-1));const _e=(Ke+ae.viewLineCount+Ge)/(ae.pixelRatio*ae.height),st=Math.floor(ae.viewLineCount/_e);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ge,desiredRatio:_e,minimapLineCount:st}}static c(ae,Ie){const Ke=ae.outerWidth,Ge=ae.outerHeight,_e=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(_e*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const st=Ie.stableMinimapLayoutInput,lt=st&&ae.outerHeight===st.outerHeight&&ae.lineHeight===st.lineHeight&&ae.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&ae.pixelRatio===st.pixelRatio&&ae.scrollBeyondLastLine===st.scrollBeyondLastLine&&ae.paddingTop===st.paddingTop&&ae.paddingBottom===st.paddingBottom&&ae.minimap.enabled===st.minimap.enabled&&ae.minimap.side===st.minimap.side&&ae.minimap.size===st.minimap.size&&ae.minimap.showSlider===st.minimap.showSlider&&ae.minimap.renderCharacters===st.minimap.renderCharacters&&ae.minimap.maxColumn===st.minimap.maxColumn&&ae.minimap.scale===st.minimap.scale&&ae.verticalScrollbarWidth===st.verticalScrollbarWidth&&ae.isViewportWrapping===st.isViewportWrapping,wt=ae.lineHeight,Ue=ae.typicalHalfwidthCharacterWidth,Kt=ae.scrollBeyondLastLine,Ht=ae.minimap.renderCharacters;let Et=_e>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Ut=ae.minimap.maxColumn,Nt=ae.minimap.size,Gt=ae.minimap.side,Bt=ae.verticalScrollbarWidth,Dt=ae.viewLineCount,Mt=ae.remainingWidth,Wt=ae.isViewportWrapping,tt=Ht?2:3;let Vt=Math.floor(_e*Ge);const qt=Vt/_e;let ut=!1,mt=!1,Ot=tt*Et,Pt=Et/_e,At=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Fe,desiredRatio:Ce,minimapLineCount:ne}=J.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:Ge,lineHeight:wt,pixelRatio:_e});if(Dt/ne>1)ut=!0,mt=!0,Et=1,Ot=1,Pt=Et/_e;else{let qe=!1,xe=Et+1;if(Nt==="fit"){const Qe=Math.ceil((Me+Dt+Fe)*Ot);Wt&&lt&&Mt<=Ie.stableFitRemainingWidth?(qe=!0,xe=Ie.stableFitMaxMinimapScale):qe=Qe>Vt}if(Nt==="fill"||qe){ut=!0;const Qe=Et;Ot=Math.min(wt*_e,Math.max(1,Math.floor(1/Ce))),Wt&&lt&&Mt<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),Et=Math.min(xe,Math.max(1,Math.floor(Ot/tt))),Et>Qe&&(At=Math.min(2,Et/Qe)),Pt=Et/_e/At,Vt=Math.ceil(Math.max(Jt,Me+Dt+Fe)*Ot),Wt?(Ie.stableMinimapLayoutInput=ae,Ie.stableFitRemainingWidth=Mt,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const gt=Math.floor(Ut*Pt),St=Math.min(gt,Math.max(0,Math.floor((Mt-Bt-2)*Pt/(Ue+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(_e*St);const It=Rt/_e;Rt=Math.floor(Rt*At);const Je=Ht?1:2,jt=Gt==="left"?0:Ke-St-Bt;return{renderMinimap:Je,minimapLeft:jt,minimapWidth:St,minimapHeightIsEditorHeight:ut,minimapIsSampling:mt,minimapScale:Et,minimapLineHeight:Ot,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:It,minimapCanvasOuterHeight:qt}}static computeLayout(ae,Ie){const Ke=Ie.outerWidth|0,Ge=Ie.outerHeight|0,_e=Ie.lineHeight|0,st=Ie.lineNumbersDigitCount|0,lt=Ie.typicalHalfwidthCharacterWidth,wt=Ie.maxDigitWidth,Ue=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ae.get(135),Et=Ht==="inherit"?ae.get(134):Ht,Ut=Et==="inherit"?ae.get(130):Et,Nt=ae.get(133),Gt=Ie.isDominatedByLongLines,Bt=ae.get(57),Dt=ae.get(67).renderType!==0,Mt=ae.get(68),Wt=ae.get(104),tt=ae.get(83),Vt=ae.get(72),qt=ae.get(102),ut=qt.verticalScrollbarSize,mt=qt.verticalHasArrows,Ot=qt.arrowSize,Pt=qt.horizontalScrollbarSize,At=ae.get(43),gt=ae.get(109)!=="never";let St=ae.get(65);At&&gt&&(St+=16);let Rt=0;if(Dt){const pt=Math.max(st,Mt);Rt=Math.round(pt*wt)}let It=0;Bt&&(It=_e*Ie.glyphMarginDecorationLaneCount);let Je=0,jt=Je+It,Jt=jt+Rt,Me=Jt+St;const Fe=Ke-It-Rt-St;let Ce=!1,ne=!1,Te=-1;Et==="inherit"&&Gt?(Ce=!0,ne=!0):Ut==="on"||Ut==="bounded"?ne=!0:Ut==="wordWrapColumn"&&(Te=Nt);const qe=J.c({outerWidth:Ke,outerHeight:Ge,lineHeight:_e,typicalHalfwidthCharacterWidth:lt,pixelRatio:Ue,scrollBeyondLastLine:Wt,paddingTop:tt.top,paddingBottom:tt.bottom,minimap:Vt,verticalScrollbarWidth:ut,viewLineCount:Kt,remainingWidth:Fe,isViewportWrapping:ne},Ie.memory||new A);qe.renderMinimap!==0&&qe.minimapLeft===0&&(Je+=qe.minimapWidth,jt+=qe.minimapWidth,Jt+=qe.minimapWidth,Me+=qe.minimapWidth);const xe=Fe-qe.minimapWidth,Qe=Math.max(1,Math.floor((xe-ut-2)/lt)),ot=mt?Ot:0;return ne&&(Te=Math.max(1,Qe),Ut==="bounded"&&(Te=Math.min(Te,Nt))),{width:Ke,height:Ge,glyphMarginLeft:Je,glyphMarginWidth:It,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:jt,lineNumbersWidth:Rt,decorationsLeft:Jt,decorationsWidth:St,contentLeft:Me,contentWidth:xe,minimap:qe,viewportColumn:Qe,isWordWrapMinified:Ce,isViewportWrapping:ne,wrappingColumn:Te,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Pt,overviewRuler:{top:ot,width:ut,height:Ge-2*ot,right:0}}}}e.EditorLayoutInfoComputer=J;class le extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ae){return s(ae,"simple",["simple","advanced"])}compute(ae,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class Q extends C{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:b.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:u(ae.enabled,this.defaultValue.enabled)}}}class Ee extends C{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:b.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class he extends C{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:b.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:s(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:u(Ie.padding,this.defaultValue.padding)}}}class K extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):n.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ie,Ke){return Ke<0?n.clampedInt(-Ke*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>a.clamp(ae,0,150),{markdownDescription:b.localize(63,null)})}compute(ae,Ie,Ke){return ae.fontInfo.lineHeight}}class ie extends C{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:ae.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:b.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),autohide:u(Ie.autohide,this.defaultValue.autohide),size:s(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ie.side,this.defaultValue.side,["right","left"]),showSlider:s(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(ue){return ue==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class H extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends C{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:b.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),cycle:u(Ie.cycle,this.defaultValue.cycle)}}}class Z extends S{constructor(){super(141)}compute(ae,Ie,Ke){return ae.pixelRatio}}class $e extends C{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ae.strings,description:b.localize(82,null)},comments:{anyOf:Ie,default:ae.comments,description:b.localize(83,null)},other:{anyOf:Ie,default:ae.other,description:b.localize(84,null)}},default:ae,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const Ue=ae?"on":"off";return{comments:Ue,strings:Ue,other:Ue}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ge}=ae,_e=["on","inline","off"];let st,lt,wt;return typeof Ie=="boolean"?st=Ie?"on":"off":st=s(Ie,this.defaultValue.other,_e),typeof Ke=="boolean"?lt=Ke?"on":"off":lt=s(Ke,this.defaultValue.comments,_e),typeof Ge=="boolean"?wt=Ge?"on":"off":wt=s(Ge,this.defaultValue.strings,_e),{other:st,comments:lt,strings:wt}}}var re;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(ae){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ie=4,Ke=ae):ae==="interval"?Ie=3:ae==="relative"?Ie=2:ae==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function te(ue){const ae=ue.get(97);return ae==="editable"?ue.get(90):ae!=="on"}e.filterValidationDecorations=te;class de extends C{constructor(){const ae=[],Ie={type:"number",description:b.localize(91,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:ae,description:b.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const Ie=[];for(const Ke of ae)if(typeof Ke=="number")Ie.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ge=Ke;Ie.push({column:n.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return Ie.sort((Ke,Ge)=>Ke.column-Ge.column),Ie}return this.defaultValue}}class pe extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function Pe(ue,ae){if(typeof ue!="string")return ae;switch(ue){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends C{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:b.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ae.ignoreHorizontalScrollbarInContentHeight,description:b.localize(105,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae,Ke=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:u(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ge,0,1e3),scrollByPage:u(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:u(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends C{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:b.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:b.localize(112,null)}})}applyUpdate(ae,Ie){let Ke=!1;Ie.allowedCharacters&&ae&&(T.$en(ae.allowedCharacters,Ie.allowedCharacters)||(ae={...ae,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ae&&(T.$en(ae.allowedLocales,Ie.allowedLocales)||(ae={...ae,allowedLocales:Ie.allowedLocales},Ke=!0));const Ge=super.applyUpdate(ae,Ie);return Ke?new $(Ge.newValue,!0):Ge}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Ie){if(typeof ae!="object"||!ae)return Ie;const Ke={};for(const[Ge,_e]of Object.entries(ae))_e===!0&&(Ke[Ge]=!0);return Ke}}class se extends C{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:b.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(114,null),b.localize(115,null),b.localize(116,null)],description:b.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:b.localize(118,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),mode:s(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:u(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends C{constructor(){const ae={enabled:R.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:b.localize(120,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ee extends C{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(121,null),b.localize(122,null),b.localize(123,null)],default:ae.bracketPairs,description:b.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(125,null),b.localize(126,null),b.localize(127,null)],default:ae.bracketPairsHorizontal,description:b.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:b.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:b.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(131,null),b.localize(132,null),b.localize(133,null)],default:ae.highlightActiveIndentation,description:b.localize(134,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(ue,ae,Ie){const Ke=Ie.indexOf(ue);return Ke===-1?ae:Ie[Ke]}class ye extends C{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(135,null),b.localize(136,null)],default:ae.insertMode,description:b.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:b.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:b.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:b.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(141,null),b.localize(142,null),b.localize(143,null),b.localize(144,null)],default:ae.selectionMode,markdownDescription:b.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:b.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:b.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:b.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:b.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:b.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertMode:s(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:u(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:u(Ie.preview,this.defaultValue.preview),previewMode:s(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(Ie.showMethods,this.defaultValue.showMethods),showFunctions:u(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:u(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(Ie.showFields,this.defaultValue.showFields),showVariables:u(Ie.showVariables,this.defaultValue.showVariables),showClasses:u(Ie.showClasses,this.defaultValue.showClasses),showStructs:u(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:u(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:u(Ie.showModules,this.defaultValue.showModules),showProperties:u(Ie.showProperties,this.defaultValue.showProperties),showEvents:u(Ie.showEvents,this.defaultValue.showEvents),showOperators:u(Ie.showOperators,this.defaultValue.showOperators),showUnits:u(Ie.showUnits,this.defaultValue.showUnits),showValues:u(Ie.showValues,this.defaultValue.showValues),showConstants:u(Ie.showConstants,this.defaultValue.showConstants),showEnums:u(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:u(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(Ie.showKeywords,this.defaultValue.showKeywords),showWords:u(Ie.showWords,this.defaultValue.showWords),showColors:u(Ie.showColors,this.defaultValue.showColors),showFiles:u(Ie.showFiles,this.defaultValue.showFiles),showReferences:u(Ie.showReferences,this.defaultValue.showReferences),showFolders:u(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:u(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:u(Ie.showUsers,this.defaultValue.showUsers),showIssues:u(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(184,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class et extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(185,null),b.localize(186,null),b.localize(187,null),b.localize(188,null)],description:b.localize(189,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Ye extends S{constructor(){super(144)}compute(ae,Ie,Ke){const Ge=Ie.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class rt extends C{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(192,null),b.localize(193,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showDropSelector:s(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends C{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(196,null),b.localize(197,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showPasteSelector:s(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Oe:g.$k?Ve:Ae,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Ze;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.letterSpacing=63]="letterSpacing",ue[ue.lightbulb=64]="lightbulb",ue[ue.lineDecorationsWidth=65]="lineDecorationsWidth",ue[ue.lineHeight=66]="lineHeight",ue[ue.lineNumbers=67]="lineNumbers",ue[ue.lineNumbersMinChars=68]="lineNumbersMinChars",ue[ue.linkedEditing=69]="linkedEditing",ue[ue.links=70]="links",ue[ue.matchBrackets=71]="matchBrackets",ue[ue.minimap=72]="minimap",ue[ue.mouseStyle=73]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=75]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=77]="multiCursorModifier",ue[ue.multiCursorPaste=78]="multiCursorPaste",ue[ue.multiCursorLimit=79]="multiCursorLimit",ue[ue.occurrencesHighlight=80]="occurrencesHighlight",ue[ue.overviewRulerBorder=81]="overviewRulerBorder",ue[ue.overviewRulerLanes=82]="overviewRulerLanes",ue[ue.padding=83]="padding",ue[ue.pasteAs=84]="pasteAs",ue[ue.parameterHints=85]="parameterHints",ue[ue.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=88]="quickSuggestions",ue[ue.quickSuggestionsDelay=89]="quickSuggestionsDelay",ue[ue.readOnly=90]="readOnly",ue[ue.readOnlyMessage=91]="readOnlyMessage",ue[ue.renameOnType=92]="renameOnType",ue[ue.renderControlCharacters=93]="renderControlCharacters",ue[ue.renderFinalNewline=94]="renderFinalNewline",ue[ue.renderLineHighlight=95]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=97]="renderValidationDecorations",ue[ue.renderWhitespace=98]="renderWhitespace",ue[ue.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ue[ue.roundedSelection=100]="roundedSelection",ue[ue.rulers=101]="rulers",ue[ue.scrollbar=102]="scrollbar",ue[ue.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=104]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=105]="scrollPredominantAxis",ue[ue.selectionClipboard=106]="selectionClipboard",ue[ue.selectionHighlight=107]="selectionHighlight",ue[ue.selectOnLineNumbers=108]="selectOnLineNumbers",ue[ue.showFoldingControls=109]="showFoldingControls",ue[ue.showUnused=110]="showUnused",ue[ue.snippetSuggestions=111]="snippetSuggestions",ue[ue.smartSelect=112]="smartSelect",ue[ue.smoothScrolling=113]="smoothScrolling",ue[ue.stickyScroll=114]="stickyScroll",ue[ue.stickyTabStops=115]="stickyTabStops",ue[ue.stopRenderingLineAfter=116]="stopRenderingLineAfter",ue[ue.suggest=117]="suggest",ue[ue.suggestFontSize=118]="suggestFontSize",ue[ue.suggestLineHeight=119]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ue[ue.suggestSelection=121]="suggestSelection",ue[ue.tabCompletion=122]="tabCompletion",ue[ue.tabIndex=123]="tabIndex",ue[ue.unicodeHighlighting=124]="unicodeHighlighting",ue[ue.unusualLineTerminators=125]="unusualLineTerminators",ue[ue.useShadowDOM=126]="useShadowDOM",ue[ue.useTabStops=127]="useTabStops",ue[ue.wordBreak=128]="wordBreak",ue[ue.wordSeparators=129]="wordSeparators",ue[ue.wordWrap=130]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=133]="wordWrapColumn",ue[ue.wordWrapOverride1=134]="wordWrapOverride1",ue[ue.wordWrapOverride2=135]="wordWrapOverride2",ue[ue.wrappingIndent=136]="wrappingIndent",ue[ue.wrappingStrategy=137]="wrappingStrategy",ue[ue.showDeprecated=138]="showDeprecated",ue[ue.inlayHints=139]="inlayHints",ue[ue.editorClassName=140]="editorClassName",ue[ue.pixelRatio=141]="pixelRatio",ue[ue.tabFocusMode=142]="tabFocusMode",ue[ue.layoutInfo=143]="layoutInfo",ue[ue.wrappingInfo=144]="wrappingInfo",ue[ue.defaultColorDecorators=145]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(198,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(199,null),""],markdownDescription:b.localize(200,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(201,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(202,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(204,null),b.localize(205,null),""],description:b.localize(206,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(207,null),b.localize(208,null),""],description:b.localize(209,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(210,null),""],description:b.localize(211,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(212,null),""],description:b.localize(213,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(214,null),b.localize(215,null),""],description:b.localize(216,null)})),autoIndent:Le(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null),b.localize(220,null),b.localize(221,null)],description:b.localize(222,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(223,null),b.localize(224,null),b.localize(225,null),""],description:b.localize(226,null)})),bracketPairColorization:Le(new oe),bracketPairGuides:Le(new ee),stickyTabStops:Le(new o(115,"stickyTabStops",!1,{description:b.localize(227,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:b.localize(228,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(229,null)})),codeLensFontSize:Le(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(230,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:b.localize(231,null)})),colorDecoratorActivatedOn:Le(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),colorDecoratorsLimit:Le(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(236,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:b.localize(237,null)})),comments:Le(new E),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(238,null)})),cursorBlinking:Le(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:b.localize(239,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(240,null),b.localize(241,null),b.localize(242,null)],description:b.localize(243,null)})),cursorStyle:Le(new l(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(244,null)})),cursorSurroundingLines:Le(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(245,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(246,null),b.localize(247,null)],markdownDescription:b.localize(248,null)})),cursorWidth:Le(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(249,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:b.localize(250,null)})),emptySelectionClipboard:Le(new z),dropIntoEditor:Le(new rt),stickyScroll:Le(new Ee),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(251,null),b.localize(252,null),b.localize(253,null)],description:b.localize(254,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(40,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:b.localize(255,null)})),find:Le(new M),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:b.localize(256,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:b.localize(260,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:b.localize(261,null)})),foldingMaximumRegions:Le(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(262,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(263,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(264,null)})),fontInfo:Le(new O),fontLigatures2:Le(new F),fontSize:Le(new W),fontWeight:Le(new x),fontVariations:Le(new N),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:b.localize(265,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:b.localize(266,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:b.localize(267,null)})),gotoLocation:Le(new ce),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(268,null)})),hover:Le(new Y),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>a.clamp(ue,-5,20),{description:b.localize(269,null)})),lightbulb:Le(new Q),lineDecorationsWidth:Le(new K),lineHeight:Le(new U),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:b.localize(270,null)})),links:Le(new o(70,"links",!0,{description:b.localize(271,null)})),matchBrackets:Le(new d(71,"matchBrackets","always",["always","near","never"],{description:b.localize(272,null)})),minimap:Le(new ie),mouseStyle:Le(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(74,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:b.localize(273,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(274,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(275,null)})),multiCursorModifier:Le(new l(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[b.localize(276,null),b.localize(277,null)],markdownDescription:b.localize(278,null)})),multiCursorPaste:Le(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(279,null),b.localize(280,null)],markdownDescription:b.localize(281,null)})),multiCursorLimit:Le(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(282,null)})),occurrencesHighlight:Le(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null),b.localize(285,null)],markdownDescription:b.localize(286,null)})),overviewRulerBorder:Le(new o(81,"overviewRulerBorder",!0,{description:b.localize(287,null)})),overviewRulerLanes:Le(new n(82,"overviewRulerLanes",3,0,3)),padding:Le(new H),pasteAs:Le(new nt),parameterHints:Le(new _),peekWidgetDefaultFocus:Le(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(288,null),b.localize(289,null)],description:b.localize(290,null)})),definitionLinkOpensInPeek:Le(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(291,null)})),quickSuggestions:Le(new $e),quickSuggestionsDelay:Le(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(292,null)})),readOnly:Le(new o(90,"readOnly",!1)),readOnlyMessage:Le(new pe),renameOnType:Le(new o(92,"renameOnType",!1,{description:b.localize(293,null),markdownDeprecationMessage:b.localize(294,null)})),renderControlCharacters:Le(new o(93,"renderControlCharacters",!0,{description:b.localize(295,null),restricted:!0})),renderFinalNewline:Le(new d(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(296,null)})),renderLineHighlight:Le(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(297,null)],description:b.localize(298,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(299,null)})),renderValidationDecorations:Le(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(300,null),b.localize(301,null),b.localize(302,null),""],description:b.localize(303,null)})),revealHorizontalRightPadding:Le(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(100,"roundedSelection",!0,{description:b.localize(304,null)})),rulers:Le(new de),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(305,null)})),scrollBeyondLastLine:Le(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(306,null)})),scrollPredominantAxis:Le(new o(105,"scrollPredominantAxis",!0,{description:b.localize(307,null)})),selectionClipboard:Le(new o(106,"selectionClipboard",!0,{description:b.localize(308,null),included:g.$k})),selectionHighlight:Le(new o(107,"selectionHighlight",!0,{description:b.localize(309,null)})),selectOnLineNumbers:Le(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(310,null),b.localize(311,null),b.localize(312,null)],description:b.localize(313,null)})),showUnused:Le(new o(110,"showUnused",!0,{description:b.localize(314,null)})),showDeprecated:Le(new o(138,"showDeprecated",!0,{description:b.localize(315,null)})),inlayHints:Le(new he),snippetSuggestions:Le(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(316,null),b.localize(317,null),b.localize(318,null),b.localize(319,null)],description:b.localize(320,null)})),smartSelect:Le(new je),smoothScrolling:Le(new o(113,"smoothScrolling",!1,{description:b.localize(321,null)})),stopRenderingLineAfter:Le(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new se),inlineCompletionsAccessibilityVerbose:Le(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(322,null)})),suggestFontSize:Le(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(325,null)})),suggestSelection:Le(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(326,null),b.localize(327,null),b.localize(328,null)],description:b.localize(329,null)})),tabCompletion:Le(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabIndex:Le(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new X),unusualLineTerminators:Le(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),useShadowDOM:Le(new o(126,"useShadowDOM",!0)),useTabStops:Le(new o(127,"useTabStops",!0,{description:b.localize(338,null)})),wordBreak:Le(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),wordSeparators:Le(new t(129,"wordSeparators",L.$0r,{description:b.localize(342,null)})),wordWrap:Le(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null),b.localize(346,null)],description:b.localize(347,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(348,null)})),wordWrapOverride1:Le(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new j),defaultColorDecorators:Le(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(349,null)})),pixelRatio:Le(new Z),tabFocusMode:Le(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(350,null)})),layoutInfo:Le(new J),wrappingInfo:Le(new Ye),wrappingIndent:Le(new et),wrappingStrategy:Le(new le)}}),define(ke[195],Se([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$qt=e.$pt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$ot=e.$nt=e.SymbolKinds=e.SymbolTag=e.$mt=e.$lt=e.SymbolKind=e.$kt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$jt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$it=e.$ht=e.$gt=void 0;class y{constructor(F,N,O){this.offset=F,this.type=N,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$gt=y;class m{constructor(F,N){this.tokens=F,this.endState=N,this._tokenizationResultBrand=void 0}}e.$ht=m;class A{constructor(F,N){this.tokens=F,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$it=A;var C;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var $;(function(M){const F=new Map;F.set(0,D.$1j.symbolMethod),F.set(1,D.$1j.symbolFunction),F.set(2,D.$1j.symbolConstructor),F.set(3,D.$1j.symbolField),F.set(4,D.$1j.symbolVariable),F.set(5,D.$1j.symbolClass),F.set(6,D.$1j.symbolStruct),F.set(7,D.$1j.symbolInterface),F.set(8,D.$1j.symbolModule),F.set(9,D.$1j.symbolProperty),F.set(10,D.$1j.symbolEvent),F.set(11,D.$1j.symbolOperator),F.set(12,D.$1j.symbolUnit),F.set(13,D.$1j.symbolValue),F.set(15,D.$1j.symbolEnum),F.set(14,D.$1j.symbolConstant),F.set(15,D.$1j.symbolEnum),F.set(16,D.$1j.symbolEnumMember),F.set(17,D.$1j.symbolKeyword),F.set(27,D.$1j.symbolSnippet),F.set(18,D.$1j.symbolText),F.set(19,D.$1j.symbolColor),F.set(20,D.$1j.symbolFile),F.set(21,D.$1j.symbolReference),F.set(22,D.$1j.symbolCustomColor),F.set(23,D.$1j.symbolFolder),F.set(24,D.$1j.symbolTypeParameter),F.set(25,D.$1j.account),F.set(26,D.$1j.issues);function N(x){let ce=F.get(x);return ce||(console.info("No codicon found for CompletionItemKind "+x),ce=D.$1j.symbolProperty),ce}M.toIcon=N;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function W(x,ce){let Y=O.get(x);return typeof Y>"u"&&!ce&&(Y=9),Y}M.fromString=W})($||(e.CompletionItemKinds=$={}));var v;(function(M){M[M.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var w;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var u;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class o{constructor(F,N,O,W){this.range=F,this.text=N,this.completionKind=O,this.isSnippetText=W}equals(F){return R.$zs.lift(this.range).equalsRange(F.range)&&this.text===F.text&&this.completionKind===F.completionKind&&this.isSnippetText===F.isSnippetText}}e.$jt=o;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function a(M){return M&&T.URI.isUri(M.uri)&&R.$zs.isIRange(M.range)&&(R.$zs.isIRange(M.originSelectionRange)||R.$zs.isIRange(M.targetSelectionRange))}e.$kt=a;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$lt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function s(M,F){return(0,b.localize)(26,null,M,e.$lt[F])}e.$mt=s;var d;(function(M){M[M.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var l;(function(M){const F=new Map;F.set(0,D.$1j.symbolFile),F.set(1,D.$1j.symbolModule),F.set(2,D.$1j.symbolNamespace),F.set(3,D.$1j.symbolPackage),F.set(4,D.$1j.symbolClass),F.set(5,D.$1j.symbolMethod),F.set(6,D.$1j.symbolProperty),F.set(7,D.$1j.symbolField),F.set(8,D.$1j.symbolConstructor),F.set(9,D.$1j.symbolEnum),F.set(10,D.$1j.symbolInterface),F.set(11,D.$1j.symbolFunction),F.set(12,D.$1j.symbolVariable),F.set(13,D.$1j.symbolConstant),F.set(14,D.$1j.symbolString),F.set(15,D.$1j.symbolNumber),F.set(16,D.$1j.symbolBoolean),F.set(17,D.$1j.symbolArray),F.set(18,D.$1j.symbolObject),F.set(19,D.$1j.symbolKey),F.set(20,D.$1j.symbolNull),F.set(21,D.$1j.symbolEnumMember),F.set(22,D.$1j.symbolStruct),F.set(23,D.$1j.symbolEvent),F.set(24,D.$1j.symbolOperator),F.set(25,D.$1j.symbolTypeParameter);function N(O){let W=F.get(O);return W||(console.info("No codicon found for SymbolKind "+O),W=D.$1j.symbolProperty),W}M.toIcon=N})(l||(e.SymbolKinds=l={}));class c{static asEditOperation(F){return g.$As.replace(R.$zs.lift(F.range),F.text)}}e.$nt=c;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(F){switch(F){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(F)}constructor(F){this.value=F}}e.$ot=h;var E;(function(M){function F(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}M.is=F})(E||(e.Command=E={}));var I;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var f;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(f||(e.CommentThreadState=f={}));var p;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var k;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(k||(e.CommentState=k={}));var P;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class j{constructor(F){this.b=F,this.a=null}dispose(){this.a&&this.a.then(F=>{F&&F.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$pt=j,e.$qt=new L.$$s;var z;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(ke[196],Se([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[217],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[218],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[219],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[220],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[221],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[222],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[223],Se([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[224],Se([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[225],Se([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[226],Se([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[227],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[228],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[229],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[230],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[231],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[232],Se([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[233],Se([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[234],Se([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[235],Se([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[236],Se([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[237],Se([1,0,8,198]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var g;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(g||(e.TokenType=g={}));function R(...m){switch(m.length){case 1:return(0,T.localize)(0,null,m[0]);case 2:return(0,T.localize)(1,null,m[0],m[1]);case 3:return(0,T.localize)(2,null,m[0],m[1],m[2]);default:return}}const L=(0,T.localize)(3,null),b=(0,T.localize)(4,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,$=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:$};this.g.push({offset:C,lexeme:$,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),$=y.b.get(C);$?this.k($):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const S=this.c.charCodeAt(A);if(C)C=!1;else if(S===47&&!$){A++;break}else S===91?$=!0:S===92?C=!0:S===93&&($=!1);A++}for(;A<this.c.length&&y.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=y}),define(ke[238],Se([1,0,23,39,201,386]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function y(o){return o=o.trim(),o==="*"||L.test(o)}e.$Ro=y;function m(o){if(!y(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$So=m;function A(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,r=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let s=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),s=!1);let d=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,c,h,E]=l;d=Date.UTC(Number(c),Number(h)-1,Number(E))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:a,patchBase:t,patchMustEqual:s,isMinimum:o.hasGreaterEquals,notBefore:d}}e.$To=A;function C(o,i,n){let r;typeof o=="string"?r=A(m(o)):r=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=A(m(n)):t=n,!r||!t)return!1;const s=r.majorBase,d=r.minorBase,l=r.patchBase;let c=t.majorBase,h=t.minorBase,E=t.patchBase;const I=t.notBefore;let f=t.majorMustEqual,p=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?s>c?!0:s<c?!1:d>h?!0:d<h||a&&a<I?!1:l>=E:(s===1&&c===0&&(!f||!p||!k)&&(c=1,h=0,E=0,f=!0,p=!1,k=!1),s<c?!1:s>c?!f:d<h?!1:d>h?!p:l<E?!1:l>E?!k:!(a&&a<I))}e.$Uo=C;function $(o,i,n,r,a){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([T.default.Error,g.localize(0,null)]),t;if(typeof r.name!="string")return t.push([T.default.Error,g.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([T.default.Error,g.localize(2,null,"version")]),t;if(!r.engines)return t.push([T.default.Error,g.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([T.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!u(r.extensionDependencies))return t.push([T.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!u(r.activationEvents))return t.push([T.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([T.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([T.default.Warning,g.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([T.default.Error,g.localize(9,null,"main")]),t;{const l=(0,D.$zg)(n,r.main);(0,D.$tg)(l,n)||t.push([T.default.Warning,g.localize(10,null,l.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([T.default.Error,g.localize(11,null,"browser")]),t;{const l=(0,D.$zg)(n,r.browser);(0,D.$tg)(l,n)||t.push([T.default.Warning,g.localize(12,null,l.path,n.path)])}}if(!R.valid(r.version))return t.push([T.default.Error,g.localize(13,null)]),t;const s=[];if(!v(o,i,r,a,s))for(const l of s)t.push([T.default.Error,l]);return t}e.$Vo=$;function v(o,i,n,r,a){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:w(o,i,n.engines.vscode,a)}e.$Wo=v;function S(o,i,n){return o==="*"||w(i,n,o)}e.$Xo=S;function w(o,i,n,r=[]){const a=A(m(n));if(!a)return r.push(g.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return r.push(g.localize(15,null,n)),!1}else if(!a.majorMustEqual)return r.push(g.localize(16,null,n)),!1;return C(o,i,a)?!0:(r.push(g.localize(17,null,o,n)),!1)}function u(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class D{constructor(g,R=[],L=!1){this.ctor=g,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$Sh=D}),define(ke[106],Se([1,0,105]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const T=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function R(b,y,m){y instanceof D.$Sh||(y=new D.$Sh(y,[],!!m)),T.push([b,y])}e.$Cr=R;function L(){return T}e.$Dr=L}),define(ke[239],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class D{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$hq=D;class T{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const b=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(L);b.outgoing.set(y.key,y),y.incoming.set(b.key,b)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const b of this.a.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let b=this.a.get(L);return b||(b=new D(L,R),this.a.set(L,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,b]of this.a)R.push(`${L}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const b=new Set([R]),y=this.c(L,b);if(y)return y}}c(R,L){for(const[b,y]of R.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const m=this.c(y,L);if(m)return m;L.delete(b)}}}e.$iq=T}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function b(y){return y[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=b})(D||(e._util=D={})),e.$Uh=g("instantiationService");function T(L,b,y){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:L,index:y}):(b[D.DI_DEPENDENCIES]=[{id:L,index:y}],b[D.DI_TARGET]=b)}function g(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const b=function(y,m,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(b,y,A)};return b.toString=()=>L,D.serviceIds.set(L,b),b}e.$Vh=g;function R(L){return L}e.$Wh=R}),define(ke[44],Se([1,0,18,2,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,g.$Vh)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof T.URI)}e.$qi=R;function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof T.URI)}e.$ri=L;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function y(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=y;function m(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$ti=m;function A(o,i){const n=Object.create(null);for(const r in o)C(n,r,o[r],i);return n}e.$ui=A;function C(o,i,n,r){const a=i.split("."),t=a.pop();let s=o;for(let d=0;d<a.length;d++){const l=a[d];let c=s[l];switch(typeof c){case"undefined":c=s[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}s=c}if(typeof s=="object"&&s!==null)try{s[t]=n}catch{r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(s)}`)}else r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(s)}`)}e.$vi=C;function $(o,i){const n=i.split(".");v(o,n)}e.$wi=$;function v(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const r=o[n];typeof r=="object"&&!Array.isArray(r)&&(v(r,i),Object.keys(r).length===0&&delete o[n])}}function S(o,i,n){function r(s,d){let l=s;for(const c of d){if(typeof l!="object"||l===null)return;l=l[c]}return l}const a=i.split("."),t=r(o,a);return typeof t>"u"?n:t}e.$xi=S;function w(o,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in o?D.$Ef(o[r])&&D.$Ef(i[r])?w(o[r],i[r],n):n&&(o[r]=i[r]):o[r]=i[r])})}e.$yi=w;function u(o){return o.replace(/[\[\]]/g,"")}e.$zi=u}),define(ke[45],Se([1,0,11,13,237,5,197,8]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",D.$j),y.set("isLinux",D.$k),y.set("isWindows",D.$i),y.set("isWeb",D.$o),y.set("isMacNative",D.$j&&!D.$o),y.set("isEdge",D.$H),y.set("isFirefox",D.$F),y.set("isChrome",D.$E),y.set("isSafari",D.$G);function m(K,U){if(y.get(K)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(K,U)}e.$Ri=m;const A=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const $={regexParsingWithErrorRecovery:!0},v=(0,L.localize)(0,null),S=(0,L.localize)(1,null),w=(0,L.localize)(2,null),u=(0,L.localize)(3,null),o=(0,L.localize)(4,null),i=(0,L.localize)(5,null),n=(0,L.localize)(6,null),r=(0,L.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new g.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const be=this.D(),H=be.type===17?i:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:g.$Qi.getLexeme(be),additionalInfo:H}),a.c}return ie}catch(ie){if(ie!==a.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,u),ie?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,u),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==10)throw this.B("REGEX",H);const _=H.lexeme,Z=_.lastIndexOf("/"),$e=Z===_.length-1?void 0:this.w(_.substring(Z+1));let re;try{re=new RegExp(_.substring(1,Z),$e)}catch{throw this.B("REGEX",H)}return O.create(ie,re)}switch(H.type){case 10:case 19:{const _=[H.lexeme];this.z();let Z=this.D(),$e=0;for(let pe=0;pe<H.lexeme.length;pe++)H.lexeme.charCodeAt(pe)===40?$e++:H.lexeme.charCodeAt(pe)===41&&$e--;for(;!this.E()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:$e++;break;case 1:$e--;break;case 10:case 18:for(let pe=0;pe<Z.lexeme.length;pe++)Z.lexeme.charCodeAt(pe)===40?$e++:H.lexeme.charCodeAt(pe)===41&&$e--}if($e<0)break;_.push(g.$Qi.getLexeme(Z)),this.z(),Z=this.D()}const re=_.join(""),fe=re.lastIndexOf("/"),te=fe===re.length-1?void 0:this.w(re.substring(fe+1));let de;try{de=new RegExp(re.substring(1,fe),te)}catch{throw this.B("REGEX",H)}return t.regex(ie,de)}case 18:{const _=H.lexeme;this.z();let Z=null;if(!(0,T.$Fe)(_)){const $e=_.indexOf("/"),re=_.lastIndexOf("/");if($e!==re&&$e>=0){const fe=_.slice($e+1,re),te=_[re+1]==="i"?"i":"";try{Z=new RegExp(fe,te)}catch{throw this.B("REGEX",H)}}}if(Z===null)throw this.B("REGEX",H);return O.create(ie,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const H=this.u();return t.notIn(ie,H)}switch(this.D().type){case 3:{this.z();const H=this.u();if(this.x().type===18)return t.equals(ie,H);switch(H){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,H)}}case 4:{this.z();const H=this.u();if(this.x().type===18)return t.notEquals(ie,H);switch(H){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,H)}}case 5:return this.z(),F.create(ie,this.u());case 6:return this.z(),N.create(ie,this.u());case 7:return this.z(),z.create(ie,this.u());case 8:return this.z(),M.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:r}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,be){const H=(0,L.localize)(8,null,U,g.$Qi.getLexeme(ie)),_=ie.offset,Z=g.$Qi.getLexeme(ie);return this.h.push({message:H,offset:_,lexeme:Z,additionalInfo:be}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=a;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(U){return E.create(U)}static equals(U,ie){return I.create(U,ie)}static notEquals(U,ie){return k.create(U,ie)}static regex(U,ie){return O.create(U,ie)}static in(U,ie){return f.create(U,ie)}static notIn(U,ie){return p.create(U,ie)}static not(U){return P.create(U)}static and(...U){return ce.create(U,null,!0)}static or(...U){return Y.create(U,null,!0)}static greater(U,ie){return z.create(U,ie)}static greaterEquals(U,ie){return M.create(U,ie)}static smaller(U,ie){return F.create(U,ie)}static smallerEquals(U,ie){return N.create(U,ie)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ti=t;function s(K){const U=new a({regexParsingWithErrorRecovery:!1});return K.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,L.localize)(9,null,be.additionalInfo):(0,L.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}e.$Ui=s;function d(K,U){const ie=K?K.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ie&&!be?!0:!ie||!be?!1:ie.equals(be)}e.$Vi=d;function l(K,U){return K.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Wi=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$Xi=h;class E{static create(U,ie=null){const be=y.get(U);return typeof be=="boolean"?be?h.INSTANCE:c.INSTANCE:new E(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:J(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=y.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Yi=E;class I{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?E.create(U,be):P.create(U,be);const H=y.get(U);return typeof H=="boolean"?ie===(H?"true":"false")?h.INSTANCE:c.INSTANCE:new I(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:le(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=y.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?h.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Zi=I;class f{static create(U,ie){return new f(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:le(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ie)?ie.includes(be):typeof be=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$1i=f;class p{static create(U,ie){return new p(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=f.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=p;class k{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?P.create(U,be):E.create(U,be);const H=y.get(U);return typeof H=="boolean"?ie===(H?"true":"false")?c.INSTANCE:h.INSTANCE:new k(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:le(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=y.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?c.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$3i=k;class P{static create(U,ie=null){const be=y.get(U);return typeof be=="boolean"?be?c.INSTANCE:h.INSTANCE:new P(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:J(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=y.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$4i=P;function j(K,U){if(typeof K=="string"){const ie=parseFloat(K);isNaN(ie)||(K=ie)}return typeof K=="string"||typeof K=="number"?U(K):c.INSTANCE}class z{static create(U,ie,be=null){return j(ie,H=>new z(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:le(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$5i=z;class M{static create(U,ie,be=null){return j(ie,H=>new M(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:le(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$6i=M;class F{static create(U,ie,be=null){return j(ie,H=>new F(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:le(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$7i=F;class N{static create(U,ie,be=null){return j(ie,H=>new N(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:le(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$8i=N;class O{static create(U,ie){return new O(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return ie<be?-1:ie>be?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ie===be}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$9i=O;class W{static create(U){return new W(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new W(this.c.map(U))}negate(){return this.c}}e.$0i=W;function x(K){let U=null;for(let ie=0,be=K.length;ie<be;ie++){const H=K[ie].substituteConstants();if(K[ie]!==H&&U===null){U=[];for(let _=0;_<ie;_++)U[_]=K[_]}U!==null&&(U[ie]=H)}return U===null?K:U}class ce{static create(U,ie,be){return ce.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const H=l(this.expr[ie],U.expr[ie]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=x(this.expr);return U===this.expr?this:ce.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,be){const H=[];let _=!1;for(const Z of U)if(Z){if(Z.type===1){_=!0;continue}if(Z.type===0)return c.INSTANCE;if(Z.type===6){H.push(...Z.expr);continue}H.push(Z)}if(H.length===0&&_)return h.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(l);for(let Z=1;Z<H.length;Z++)H[Z-1].equals(H[Z])&&(H.splice(Z,1),Z--);if(H.length===1)return H[0];for(;H.length>1;){const Z=H[H.length-1];if(Z.type!==9)break;H.pop();const $e=H.pop(),re=H.length===0,fe=Y.create(Z.expr.map(te=>ce.create([te,$e],null,be)),null,re);fe&&(H.push(fe),H.sort(l))}if(H.length===1)return H[0];if(be){for(let Z=0;Z<H.length;Z++)for(let $e=Z+1;$e<H.length;$e++)if(H[Z].negate().equals(H[$e]))return c.INSTANCE;if(H.length===1)return H[0]}return new ce(H,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new ce(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=Y.create(U,this,!0)}return this.c}}e.$$i=ce;class Y{static create(U,ie,be){return Y.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const H=l(this.expr[ie],U.expr[ie]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=x(this.expr);return U===this.expr?this:Y.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,be){let H=[],_=!1;if(U){for(let Z=0,$e=U.length;Z<$e;Z++){const re=U[Z];if(re){if(re.type===0){_=!0;continue}if(re.type===1)return h.INSTANCE;if(re.type===9){H=H.concat(re.expr);continue}H.push(re)}}if(H.length===0&&_)return c.INSTANCE;H.sort(l)}if(H.length!==0){if(H.length===1)return H[0];for(let Z=1;Z<H.length;Z++)H[Z-1].equals(H[Z])&&(H.splice(Z,1),Z--);if(H.length===1)return H[0];if(be){for(let Z=0;Z<H.length;Z++)for(let $e=Z+1;$e<H.length;$e++)if(H[Z].negate().equals(H[$e]))return h.INSTANCE;if(H.length===1)return H[0]}return new Y(H,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new Y(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),be=U.shift(),H=[];for(const _ of he(ie))for(const Z of he(be))H.push(ce.create([_,Z],null,!1));U.unshift(Y.create(H,null,!1))}this.c=Y.create(U,this,!0)}return this.c}}e.$_i=Y;class G extends E{static{this.d=[]}static all(){return G.d.values()}constructor(U,ie,be){super(U,null),this.f=ie,typeof be=="object"?G.d.push({...be,key:U}):be!==!0&&G.d.push({key:U,description:be,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return I.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$aj=G,e.$bj=(0,R.$Vh)("contextKeyService");function J(K,U){return K<U?-1:K>U?1:0}function le(K,U,ie,be){return K<ie?-1:K>ie?1:U<be?-1:U>be?1:0}function Q(K,U){if(K.type===0||U.type===1)return!0;if(K.type===9)return U.type===9?Ee(K.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(Q(K,ie))return!0;return!1}if(K.type===6){if(U.type===6)return Ee(U.expr,K.expr);for(const ie of K.expr)if(Q(ie,U))return!0;return!1}return K.equals(U)}e.$cj=Q;function Ee(K,U){let ie=0,be=0;for(;ie<K.length&&be<U.length;){const H=K[ie].cmp(U[be]);if(H<0)return!1;H===0&&ie++,be++}return ie===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(ke[240],Se([1,0,23,39,199,5,102,11,24]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.ConfirmResult=e.$Kv=e.$Jv=e.$Iv=void 0,e.$Iv=(0,R.$Vh)("dialogService");var m;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(m||(m={}));class A{a(u){return this.d(u,m.Confirmation)}b(u){return this.d(u,m.Prompt)}c(u){return this.d(u,m.Input)}d(u,o){const i=[];switch(o){case m.Confirmation:{const n=u;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(1,null));break}case m.Prompt:{const n=u;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case m.Input:{const n=u;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(u){if(typeof u=="string")return u;if(typeof u=="number")return u===T.default.Info?"info":u===T.default.Error?"error":u===T.default.Warning?"warning":"none"}f(u,o,i){const n=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&n.push(u.cancelButton);let r=n[o]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$Jv=A,e.$Kv=(0,R.$Vh)("fileDialogService");var C;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const $=10;function v(w){const u=[];return u.push(...w.slice(0,$).map(o=>typeof o=="string"?o:(0,D.$wg)(o))),w.length>$&&(w.length-$===1?u.push((0,g.localize)(7,null)):u.push((0,g.localize)(8,null,w.length-$))),u.push(""),u.join(`
`)}e.$Lv=v;function S(w,u){const o=(0,y.$an)(w);let i=(o.buttons??[]).map(t=>(0,L.$Fv)(t)),n=(w.buttons||[]).map((t,s)=>s),r=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const s=n[a];n.splice(a,1),n.splice(1,0,s),a=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(a=r-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const s=n[a];n.splice(a,1),n.push(s),a=i.length-1}}return o.buttons=i,o.defaultId=r,o.cancelId=a,o.noLink=!0,o.title=o.title||u.nameLong,{options:o,buttonIndeces:n}}e.$Mv=S}),define(ke[134],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,D.$Vh)("environmentService"),e.$4h=(0,D.$Wh)(e.$3h)}),define(ke[135],Se([1,0,200,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function g(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=g;function R(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=R;function L(o,i){switch(o){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=L;function b(o,i){return i==="web"&&!o.includes("web")}e.$ao=b;function y(o,i,n){return b(i,n)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===n}e.$bo=y;function m(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$co=m;var A;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var $;(function(o){o.Install="install",o.Uninstall="uninstall"})($||(e.StatisticType=$={}));var v;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$do=(0,T.$Vh)("extensionGalleryService");var S;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var w;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class u extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$eo=u,e.$fo=(0,T.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,T.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,T.$Vh)("IExtensionTipsService"),e.$ko=(0,D.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(ke[241],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Zb=e.$3Zb=void 0,e.$3Zb=(0,D.$Vh)("externalTerminal"),e.$4Zb="Terminal.app"}),define(ke[242],Se([1,0,50,17,16,11,101,31,104,202,241]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=e.$28b=e.$18b=void 0;const C=m.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends ${static{this.b="cmd.exe"}openTerminal(r,a){return this.spawnTerminal(D,r,y.$Hl(),a)}spawnTerminal(r,a,t,s){const d=a.windowsExec||v.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const l=g.$mc(d,".exe").toLowerCase();if(l==="cmder")return r.spawn(d,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return d.indexOf(" ")>=0&&c.push('""'),c.push(d),l==="wt"&&c.push("-d ."),new Promise((h,E)=>{const I=u(process),f=r.spawn(t,c,{cwd:s,env:I});f.on("error",E),f.on("exit",()=>h())})}runInTerminal(r,a,t,s,d){const l="windowsExec"in d&&d.windowsExec?d.windowsExec:v.getDefaultTerminalWindows();return new Promise((c,h)=>{const E=`"${a} - ${C}"`,I=`""${t.join('" "')}" & pause"`,f=Object.assign({},u(process),s);Object.keys(f).filter(z=>f[z]===null).forEach(z=>delete f[z]);const p={cwd:a,env:f,windowsVerbatimArguments:!0};let k,P;g.$mc(l,".exe")==="wt"?(k=l,P=["-d",".",v.b,"/c",I]):(k=v.b,P=["/c","start",E,"/wait",l,"/c",I]),D.spawn(k,P,p).on("error",z=>{h(o(z))}),c(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return v.d}}e.$18b=v;class S extends ${static{this.b="/usr/bin/osascript"}openTerminal(r,a){return this.spawnTerminal(D,r,a)}runInTerminal(r,a,t,s,d){const l=d.osxExec||A.$4Zb;return new Promise((c,h)=>{if(l===A.$4Zb||l==="iTerm.app"){const E=l===A.$4Zb?"TerminalHelper":"iTermHelper",f=[T.$gg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",r||C,"-w",a];for(const P of t)f.push("-a"),f.push(P);if(s){const P=Object.assign({},u(process),s);for(const j in P){const z=P[j];z===null?(f.push("-u"),f.push(j)):(f.push("-e"),f.push(`${j}=${z}`))}}let p="";const k=D.spawn(S.b,f);k.on("error",P=>{h(o(P))}),k.stderr.on("data",P=>{p+=P.toString()}),k.on("exit",P=>{if(P===0)c(void 0);else if(p){const j=p.split(`
`,1);h(new Error(j[0]))}else h(new Error(m.localize(1,null,E,P)))})}else h(new Error(m.localize(2,null,l)))})}spawnTerminal(r,a,t){const s=a.osxExec||A.$4Zb;return new Promise((d,l)=>{const c=["-a",s];t&&c.push(t);const h=u(process),E=r.spawn("/usr/bin/open",c,{cwd:t,env:h});E.on("error",l),E.on("exit",()=>d())})}}e.$28b=S;class w extends ${static{this.b=m.localize(3,null)}openTerminal(r,a){return this.spawnTerminal(D,r,a)}runInTerminal(r,a,t,s,d){const l=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((c,h)=>{const E=[];l.then(I=>{I.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const f=`${i(t)}; echo; read -p "${w.b}" -n1;`;E.push(`''${f}''`);const p=Object.assign({},u(process),s);Object.keys(p).filter(z=>p[z]===null).forEach(z=>delete p[z]);const k={cwd:a,env:p};let P="";const j=D.spawn(I,E,k);j.on("error",z=>{h(o(z))}),j.stderr.on("data",z=>{P+=z.toString()}),j.on("exit",z=>{if(z===0)c(void 0);else if(P){const M=P.split(`
`,1);h(new Error(M[0]))}else h(new Error(m.localize(4,null,I,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!R.$k)w.d=Promise.resolve("xterm");else{const r=await b.Promises.exists("/etc/debian_version");w.d=new Promise(a=>{r?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return w.d}spawnTerminal(r,a,t){const s=a.linuxExec?Promise.resolve(a.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,l)=>{s.then(c=>{const h=u(process),E=r.spawn(c,[],{cwd:t,env:h});E.on("error",l),E.on("exit",()=>d())})})}}e.$38b=w;function u(n){const r={...n.env};return(0,L.$Fl)(r),r}function o(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(m.localize(5,null,n.path)):n}function i(n){let r="";for(const a of n)a.indexOf(" ")>=0?r+='"'+a+'"':r+=a,r+=" ";return r}}),define(ke[32],Se([1,0,77,16,13,18,2,203,5,11,17,48]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,y.$Vh)("fileService");function $(Q){return Q.create===!0}e.$fk=$;var v;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.File=1]="File",Q[Q.Directory=2]="Directory",Q[Q.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var S;(function(Q){Q[Q.Readonly=1]="Readonly",Q[Q.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function w(Q){const Ee=Q;return!!Ee&&typeof Ee.onDidChange=="function"}e.$gk=w;var u;(function(Q){Q[Q.None=0]="None",Q[Q.FileReadWrite=2]="FileReadWrite",Q[Q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Q[Q.FileReadStream=16]="FileReadStream",Q[Q.FileFolderCopy=8]="FileFolderCopy",Q[Q.PathCaseSensitive=1024]="PathCaseSensitive",Q[Q.Readonly=2048]="Readonly",Q[Q.Trash=4096]="Trash",Q[Q.FileWriteUnlock=8192]="FileWriteUnlock",Q[Q.FileAtomicRead=16384]="FileAtomicRead",Q[Q.FileAtomicWrite=32768]="FileAtomicWrite",Q[Q.FileAtomicDelete=65536]="FileAtomicDelete",Q[Q.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function o(Q){return!!(Q.capabilities&2)}e.$hk=o;function i(Q){return!!(Q.capabilities&8)}e.$ik=i;function n(Q){return!!(Q.capabilities&131072)}e.$jk=n;function r(Q){return!!(Q.capabilities&4)}e.$kk=r;function a(Q){return!!(Q.capabilities&16)}e.$lk=a;function t(Q){return o(Q)?!!(Q.capabilities&16384):!1}e.$mk=t;function s(Q){return o(Q)?!!(Q.capabilities&32768):!1}e.$nk=s;function d(Q){return!!(Q.capabilities&65536)}e.$ok=d;function l(Q){return!!(Q.capabilities&2048)}e.$pk=l;var c;(function(Q){Q.FileExists="EntryExists",Q.FileNotFound="EntryNotFound",Q.FileNotADirectory="EntryNotADirectory",Q.FileIsADirectory="EntryIsADirectory",Q.FileExceedsStorageQuota="EntryExceedsStorageQuota",Q.FileTooLarge="EntryTooLarge",Q.FileWriteLocked="EntryWriteLocked",Q.NoPermissions="NoPermissions",Q.Unavailable="Unavailable",Q.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class h extends Error{static create(Ee,he){const K=new h(Ee.toString(),he);return f(K,he),K}constructor(Ee,he){super(Ee),this.code=he}}e.$qk=h;function E(Q,Ee){return h.create(Q,Ee)}e.$rk=E;function I(Q){return Q||E((0,b.localize)(0,null),c.Unknown)}e.$sk=I;function f(Q,Ee){return Q.name=Ee?`${Ee} (FileSystemError)`:"FileSystemError",Q}e.$tk=f;function p(Q){if(!Q)return c.Unknown;if(Q instanceof h)return Q.code;const Ee=/^(.+) \(FileSystemError\)$/.exec(Q.name);if(!Ee)return c.Unknown;switch(Ee[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.$uk=p;function k(Q){if(Q instanceof N)return Q.fileOperationResult;switch(p(Q)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.$vk=k;var P;(function(Q){Q[Q.CREATE=0]="CREATE",Q[Q.DELETE=1]="DELETE",Q[Q.MOVE=2]="MOVE",Q[Q.COPY=3]="COPY",Q[Q.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class j{constructor(Ee,he,K){this.resource=Ee,this.operation=he,this.target=K}isOperation(Ee){return this.operation===Ee}}e.$wk=j;var z;(function(Q){Q[Q.UPDATED=0]="UPDATED",Q[Q.ADDED=1]="ADDED",Q[Q.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class M{static{this.a=null}constructor(Ee,he){this.c=he,this.b=void 0,this.d=new C.$U(()=>{const K=D.$2h.forUris(()=>this.c);return K.fill(this.rawAdded.map(U=>[U,!0])),K}),this.f=new C.$U(()=>{const K=D.$2h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(U=>[U,!0])),K}),this.g=new C.$U(()=>{const K=D.$2h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(U=>[U,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of Ee){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==M.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Ee,...he){return this.h(Ee,{includeChildren:!1},...he)}affects(Ee,...he){return this.h(Ee,{includeChildren:!0},...he)}h(Ee,he,...K){if(!Ee)return!1;const U=K.length>0;return!!((!U||K.includes(1))&&(this.d.value.get(Ee)||he.includeChildren&&this.d.value.findSuperstr(Ee))||(!U||K.includes(0))&&(this.f.value.get(Ee)||he.includeChildren&&this.f.value.findSuperstr(Ee))||(!U||K.includes(2))&&(this.g.value.findSubstr(Ee)||he.includeChildren&&this.g.value.findSuperstr(Ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ee){return this.b===Ee}hasCorrelation(){return typeof this.b=="number"}}e.$xk=M;function F(Q,Ee,he){return!Q||!Ee||Q===Ee||Ee.length>Q.length?!1:(Ee.charAt(Ee.length-1)!==T.sep&&(Ee+=T.sep),he?(0,g.$7e)(Q,Ee):Q.indexOf(Ee)===0)}e.$yk=F;class N extends Error{constructor(Ee,he,K){super(Ee),this.fileOperationResult=he,this.options=K}}e.$zk=N;class O extends N{constructor(Ee,he,K,U){super(Ee,he,U),this.fileOperationResult=he,this.size=K}}e.$Ak=O;class W extends N{constructor(Ee,he,K){super(Ee,2,K),this.stat=he}}e.$Bk=W;var x;(function(Q){Q[Q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Q[Q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Q[Q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Q[Q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Q[Q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Q[Q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Q[Q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Q[Q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Q[Q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Q[Q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Q[Q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var ce;(function(Q){Q[Q.FILE=0]="FILE",Q[Q.FOLDER=1]="FOLDER",Q[Q.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$Jk="";function Y(Q){if(!(typeof Q.size!="number"||typeof Q.mtime!="number"))return Q.mtime.toString(29)+Q.size.toString(31)}e.$Kk=Y;async function G(Q,Ee){if(!Ee.hasProvider(L.URI.from({scheme:Q.scheme})))return new Promise(he=>{const K=Ee.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===Q.scheme&&U.added&&(K.dispose(),he())})})}e.$Lk=G;class J{static{this.KB=1024}static{this.MB=J.KB*J.KB}static{this.GB=J.MB*J.KB}static{this.TB=J.GB*J.KB}static formatSize(Ee){return(0,R.$Gf)(Ee)||(Ee=0),Ee<J.KB?(0,b.localize)(1,null,Ee.toFixed(0)):Ee<J.MB?(0,b.localize)(2,null,(Ee/J.KB).toFixed(2)):Ee<J.GB?(0,b.localize)(3,null,(Ee/J.MB).toFixed(2)):Ee<J.TB?(0,b.localize)(4,null,(Ee/J.GB).toFixed(2)):(0,b.localize)(5,null,(Ee/J.TB).toFixed(2))}}e.$Mk=J;function le(Q){const Ee=typeof Q=="string"||Q?.scheme===A.Schemas.vscodeRemote;return typeof Q!="string"&&Q?.scheme===A.Schemas.file?1024*J.MB:Ee?10*J.MB:m.$o?50*J.MB:1024*J.MB}e.$Nk=le}),define(ke[243],Se([1,0,22,8,204,32]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;async function L(A,C,$,v,S,w){let u;try{await b(A,C,$,v,S,w)}catch(o){u=o}finally{u&&S.errorTransformer&&(u=S.errorTransformer(u)),typeof u<"u"&&$.error(u),$.end()}}e.$Sp=L;async function b(A,C,$,v,S,w){y(w);const u=await A.open(C,{create:!1});try{y(w);let o=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,r=D.$fe.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await A.read(u,a,r.buffer,t,r.byteLength-t),a+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await $.write(v(r)),r=D.$fe.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&y(w)&&m(o,S));if(t>0){let s=t;typeof n=="number"&&(s=Math.min(t,n)),$.write(v(r.slice(0,s)))}}catch(o){throw(0,R.$sk)(o)}finally{await A.close(u)}}function y(A){if(A.isCancellationRequested)throw(0,T.$5)();return!0}function m(A,C){if(typeof C?.limits?.size=="number"&&A>C.limits.size)throw(0,R.$rk)((0,g.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Se([1,0,34,3,16,11,2,32]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function y(o){return o.recursive===!0}e.$Up=y;class m extends T.$Rc{static{this.a=5}constructor(i,n,r,a){super(),this.h=i,this.j=n,this.m=r,this.n=a,this.c=this.B(new T.$Sc),this.f=void 0,this.g=0}s(){const i=new T.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<m.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Vp=m;class A extends m{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.$Wp=A;class C extends m{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.$Xp=C;function $(o){return o.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}e.$Yp=$;function v(o){const i=new u;for(const n of o)i.processEvent(n);return i.coalesce()}e.$Zp=v;function S(o,i){return typeof i=="string"&&!i.startsWith(D.$yj)&&!(0,g.$hc)(i)?{base:o,pattern:i}:i}e.$1p=S;function w(o,i){const n=[];for(const r of i)n.push((0,D.$Cj)(S(o,r)));return n}e.$2p=w;class u{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let r=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>n.some(a=>(0,b.$yk)(r.resource.fsPath,a,!R.$k))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(ke[244],Se([1,0,55,12,21,33,3,76,16,11,23,2,103,31,84]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class w extends L.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,r,a){super(),this.m=i,this.n=n,this.r=r,this.s=a,this.c=this.B(new T.$ah({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$_g(t=>this.z(t),w.b)),this.g=(0,S.$2p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$2p)(this.m.path,this.m.includes):void 0,this.j=new g.$2d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await v.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await v.Promises.realpath(i.path),i.path===n&&(n=await(0,$.$_p)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(m.$j&&(0,R.$2f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Rc.None;const r=new g.$2d(this.j.token),a=new L.$Qc;try{const t=C.URI.file(this.m.path),s=(0,y.$mc)(i),d=(0,D.watch)(i);a.add((0,L.$Pc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const l=new Set;if(n)try{for(const h of await v.Promises.readdir(i))l.add(h)}catch(h){this.D(h)}const c=new Map;a.add((0,L.$Pc)(()=>{for(const[,h]of c)h.dispose();c.clear()})),d.on("error",(h,E)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${E})`),this.dispose()}),d.on("change",(h,E)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${E}`);let I="";if(E&&(I=E.toString(),m.$j&&(I=(0,b.$ul)(I))),!(!I||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){c.get(I)?.dispose();const f=setTimeout(async()=>{if(c.delete(I),I===s&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,y.$ic)(i,I));if(r.token.isCancellationRequested)return;let k;p?l.has(I)?k=0:(k=1,l.add(I)):(l.delete(I),k=2),this.y({resource:(0,A.$zg)(t,I),type:k,cId:this.m.correlationId})},w.a);c.set(I,(0,L.$Pc)(()=>clearTimeout(f)))}else{let f;l.has(I)?f=0:(f=1,l.add(I)),this.y({resource:(0,A.$zg)(t,I),type:f,cId:this.m.correlationId})}else if(h==="rename"||I!==s){const f=setTimeout(async()=>{const p=await v.Promises.exists(i);r.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);a.clear(),a.add((0,L.$Pc)(()=>clearTimeout(f)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,L.$Pc)(()=>{r.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$Zp)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(m.$k)return v.Promises.exists(i);try{const n=(0,y.$mc)(i);return(await v.Promises.readdir((0,y.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$cq=w;async function u(o,i,n,r,a=512){const t=await v.Promises.open(o,"r"),s=Buffer.allocUnsafe(a),d=new g.$2d(r);let l,c=!1;const h={path:o,excludes:[],recursive:!1},E=new w(h,I=>{(async()=>{for(const{type:f}of I)if(f===0){if(c)return;c=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await v.Promises.read(t,s,0,a,null);if(!p||d.token.isCancellationRequested)break;i(s.slice(0,p))}}catch(p){l=new Error(p),d.dispose(!0)}finally{c=!1}}})()});return await E.ready,n(),new Promise((I,f)=>{d.token.onCancellationRequested(async()=>{E.dispose();try{await v.Promises.close(t)}catch(p){l=new Error(p)}l?f(l):I()})})}e.$dq=u}),define(ke[245],Se([1,0,4,34,3,11,244]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class b extends g.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(m){const A=this.j(m),C=A.filter(v=>{const S=this.c.get(v.path);return S?!(0,T.$Gj)(S.request.excludes,v.excludes)||!(0,T.$Gj)(S.request.includes,v.includes):!0}),$=Array.from(this.c.values()).filter(({request:v})=>!A.find(S=>S.path===v.path&&(0,T.$Gj)(S.excludes,v.excludes)&&(0,T.$Gj)(S.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.m(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const v of $)this.h(v);for(const v of C)this.g(v)}g(m){const A=new L.$cq(m,$=>this.a.fire($),$=>this.b.fire($),this.f),C={request:m,instance:A};this.c.set(m.path,C)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const A=this.c.get(m);A&&(this.c.delete(m),A.instance.dispose())}j(m){const A=new Map;for(const C of m){const $=R.$k?C.path:C.path.toLowerCase();let v=A.get(C.correlationId);v||(v=new Map,A.set(C.correlationId,v)),v.set($,C)}return Array.from(A.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(m){this.f=m;for(const[,A]of this.c)A.instance.setVerboseLogging(m)}m(m){this.f&&this.b.fire({type:"trace",message:this.n(m)})}n(m,A){return A?`[File Watcher (node.js)] ${m} (path: ${A.request.path})`:`[File Watcher (node.js)] ${m}`}}e.$eq=b}),define(ke[246],Se([1,0,84,245]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class g extends D.$Wp{constructor(L,b,y){super(L,b,y),this.s()}r(L){return L.add(new T.$eq)}}e.$fq=g}),define(ke[247],Se([1,0,17,81,187,84]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class L extends R.$Xp{constructor(y,m,A){super(y,m,A),this.s()}r(y){const m=y.add(new g.$9p(D.$gg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(m.onDidProcessExit(({code:A,signal:C})=>this.t(`terminated by itself with code ${A}, signal: ${C}`))),T.ProxyChannel.toService((0,T.$Ch)(m.getChannel("watcher")))}}e.$0p=L}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class D{constructor(...g){this.a=new Map;for(const[R,L]of g)this.set(R,L)}set(g,R){const L=this.a.get(g);return this.a.set(g,R),L}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$Th=D}),define(ke[248],Se([1,0,12,8,3,105,239,5,107,75]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const A=!1;class C extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class ${constructor(u=new y.$Th,o=!1,i,n=A){this.f=u,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$Uh,this),this._globalGraph=n?i?._globalGraph??new L.$iq(r=>r):void 0}createChild(u){return new $(u,this.g,this,this.i)}invokeFunction(u,...o){const i=S.traceInvocation(this.i,u);let n=!1;try{return u({get:a=>{if(n)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(u,...o){let i,n;return u instanceof R.$Sh?(i=S.traceCreation(this.i,u.ctor),n=this.j(u.ctor,u.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,u),n=this.j(u,o,i)),i.stop(),n}j(u,o=[],i){const n=b._util.getServiceDependencies(u).sort((t,s)=>t.index-s.index),r=[];for(const t of n){const s=this.m(t.id,i);s||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(s)}const a=n.length>0?n[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${u.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(u,o.concat(r))}k(u,o){if(this.f.get(u)instanceof R.$Sh)this.f.set(u,o);else if(this.h)this.h.k(u,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const o=this.f.get(u);return!o&&this.h?this.h.l(u):o}m(u,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const i=this.l(u);return i instanceof R.$Sh?this.q(u,i,o.branch(u,!0)):(o.branch(u,!1),i)}q(u,o,i){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,o,i)}finally{this.o.delete(u)}}r(u,o,i){const n=new L.$iq(t=>t.id.toString());let r=0;const a=[{id:u,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new C(n);for(const s of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(s.id);if(d||this.u(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),d instanceof R.$Sh){const l={id:s.id,desc:d,_trace:t._trace.branch(s.id,!0)};n.insertEdge(t,l),a.push(l)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:s}of t){if(this.l(s.id)instanceof R.$Sh){const l=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,l)}n.removeNode(s)}}return this.l(u)}s(u,o,i=[],n,r){if(this.f.get(u)instanceof R.$Sh)return this.t(u,o,i,n,r);if(this.h)return this.h.s(u,o,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(u,o,i=[],n,r){if(n){const a=new $(void 0,this.g,this,this.i);a.c=String(u);const t=new Map,s=new D.$eh(()=>{const d=a.j(o,i,r);for(const[l,c]of t){const h=d[l];if(typeof h=="function")for(const E of c)h.apply(d,E)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,l){if(!s.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let E=t.get(l);return E||(E=new m.$2c,t.set(l,E)),(f,p,k)=>{const P=E.push([f,p,k]);return(0,g.$Pc)(P)}}if(l in d)return d[l];const c=s.value;let h=c[l];return typeof h!="function"||(h=h.bind(c),d[l]=h),h},set(d,l,c){return s.value[l]=c,!0},getPrototypeOf(d){return o.prototype}})}else return this.j(o,i,r)}u(u,o){if(o&&console.warn(u),this.g)throw new Error(u)}}e.$jq=$;var v;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(v||(v={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,o){return u?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(u,o){return u?new S(1,o.name):S.c}static{this.f=0}constructor(u,o){this.type=u,this.name=o,this.g=Date.now(),this.h=[]}branch(u,o){const i=new S(3,u.toString());return this.h.push([u,o,i]),i}stop(){const u=Date.now()-this.g;S.f+=u;let o=!1;function i(r,a){const t=[],s=new Array(r+1).join("	");for(const[d,l,c]of a.h)if(l&&c){o=!0,t.push(`${s}CREATES -> ${d}`);const h=i(r+1,c);h&&t.push(h)}else t.push(`${s}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(u>2||o)&&S.all.add(n.join(`
`))}}e.$kq=S}),define(ke[14],Se([1,0,43,4,52,3,28,11,23,18,2,45,5]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,$.$Vh)("logService"),e.$ej=(0,$.$Vh)("loggerService");function v(){return new Date().toISOString()}function S(f){return(0,m.$Gf)(f)}e.$fj=S;var w;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$gj=w.Info;function u(f,p,k){switch(p){case w.Trace:f.trace(k);break;case w.Debug:f.debug(k);break;case w.Info:f.info(k);break;case w.Warning:f.warn(k);break;case w.Error:f.error(k);break;case w.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=u;function o(f,p=!1){let k="";for(let P=0;P<f.length;P++){let j=f[P];if(j instanceof Error&&(j=(0,D.$Gi)(j,p)),typeof j=="object")try{j=JSON.stringify(j)}catch{}k+=(P>0?" ":"")+j}return k}class i extends R.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new T.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==w.Off&&this.b<=p}}e.$ij=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...k){this.f(w.Trace)&&this.g(w.Trace,o([p,...k],!0))}debug(p,...k){this.f(w.Debug)&&this.g(w.Debug,o([p,...k]))}info(p,...k){this.f(w.Info)&&this.g(w.Info,o([p,...k]))}warn(p,...k){this.f(w.Warning)&&this.g(w.Warning,o([p,...k]))}error(p,...k){if(this.f(w.Error))if(p instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=p.stack,this.g(w.Error,o(P))}else this.g(w.Error,o([p,...k]))}flush(){}}e.$jj=n;class r extends i{constructor(p=e.$gj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...k){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}debug(p,...k){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}info(p,...k){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}warn(p,...k){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,p,...k):console.warn(`[main ${v()}]`,p,...k))}error(p,...k){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,p,...k):console.error(`[main ${v()}]`,p,...k))}dispose(){}flush(){}}e.$kj=r;class a extends i{constructor(p=e.$gj,k=!0){super(),this.g=k,this.setLevel(p)}trace(p,...k){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...k):console.log(p,...k))}debug(p,...k){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...k):console.log(p,...k))}info(p,...k){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...k):console.log(p,...k))}warn(p,...k){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...k):console.log(p,...k))}error(p,...k){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...k):console.error(p,...k))}dispose(){}flush(){}}e.$lj=a;class t extends i{constructor(p,k=e.$gj){super(),this.g=p,this.setLevel(k)}trace(p,...k){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(p),...k])}debug(p,...k){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(p),...k])}info(p,...k){this.f(w.Info)&&this.g.log(w.Info,[this.h(p),...k])}warn(p,...k){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(p),...k])}error(p,...k){this.f(w.Error)&&this.g.log(w.Error,[this.h(p),...k])}h(p){return typeof p=="string"?p:(0,D.$Gi)(p,this.f(w.Trace))}dispose(){}flush(){}}e.$mj=t;class s extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const k of this.g)k.setLevel(p);super.setLevel(p)}trace(p,...k){for(const P of this.g)P.trace(p,...k)}debug(p,...k){for(const P of this.g)P.debug(p,...k)}info(p,...k){for(const P of this.g)P.info(p,...k)}warn(p,...k){for(const P of this.g)P.warn(p,...k)}error(p,...k){for(const P of this.g)P.error(p,...k)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$nj=s;class d extends R.$Rc{constructor(p,k,P){if(super(),this.h=p,this.j=k,this.b=new L.$zc,this.c=this.B(new T.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Rd),this.onDidChangeVisibility=this.g.event,P)for(const j of P)this.b.set(j.resource,{logger:void 0,info:j})}m(p){return(0,m.$Cf)(p)?[...this.b.values()].find(k=>k.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,k){const P=this.n(p),j=(0,m.$Cf)(p)?p:k?.id??(0,g.$Ji)(P.toString()).toString(16);let z=this.b.get(P)?.logger;const M=k?.logLevel==="always"?w.Trace:k?.logLevel;z||(z=this.s(P,M??this.getLogLevel(P)??this.h,{...k,id:j}));const F={logger:z,info:{resource:P,id:j,logLevel:M,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(F.info),this.b.set(P,F),z}n(p){return(0,m.$Cf)(p)?(0,y.$zg)(this.j,`${p}.log`):p}setLogLevel(p,k){if(A.URI.isUri(p)){const P=p,j=k,z=this.b.get(P);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([P,j]))}else{this.h=p;for(const[P,j]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,k){const P=this.m(p);P&&k!==!P.info.hidden&&(P.info.hidden=!k,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,k]))}getLogLevel(p){let k;return p&&(k=this.b.get(p)?.info.logLevel),k??this.h}registerLogger(p){const k=this.b.get(p.resource);k?k.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const k=this.b.get(p);k&&(k.logger&&k.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=d;class l{constructor(){this.onDidChangeLogLevel=new T.$Rd().event}setLevel(p){}getLevel(){return w.Info}trace(p,...k){}debug(p,...k){}info(p,...k){}warn(p,...k){}error(p,...k){}critical(p,...k){}dispose(){}flush(){}}e.$pj=l;class c extends l{}e.$qj=c;function h(f){if(f.verbose)return w.Trace;if(typeof f.logLevel=="string"){const p=I(f.logLevel.toLowerCase());if(p!==void 0)return p}return e.$gj}e.$rj=h;function E(f){switch(f){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$sj=E;function I(f){switch(f){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$tj=I,e.$uj=new C.$aj("logLevel",E(w.Info))}),define(ke[249],Se([1,0,19,12,8,4,3,16,84,14]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class A extends L.$Rc{constructor($,v){super(),this.a=$,this.b=v,this.c=this.B(new R.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Vg(0)),this.w=[],this.y=this.B(new T.$Vg(0))}watch($,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n($,v):this.z($,v)}n($,v){const S={path:this.H($),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},w=(0,D.$Tb)(this.j,S);return this.r(),(0,L.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,g.$Z)($))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,y.$Yp)(v)),v=>this.G(v),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const v of this.j)(0,y.$Up)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const v of this.j)(0,y.$Up)(v)&&$.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,v){const S={path:this.H($),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},w=(0,D.$Tb)(this.w,S);return this.C(),(0,L.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,g.$Z)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,y.$Yp)($)),$=>this.G($),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,b.$gc)($.fsPath)}}e.$3p=A}),define(ke[250],Se([1,0,55,387,12,28,22,4,33,3,16,11,23,98,31,205,32,243,249,43,247,246]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(s){console.error(`Error enabling graceful-fs: ${(0,n.$Gi)(s)}`)}})();class t extends i.$3p{static{this.I=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=b.Event.None,this.N=new R.$zc(c=>$.$qg.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:l,symbolicLink:c}=await S.SymlinkSupport.stat(this.H(d));return{type:this.M(l,c),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:u.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await S.Promises.readdir(this.H(d),{withFileTypes:!0}),c=[];return await Promise.all(l.map(async h=>{try{let E;h.isSymbolicLink()?E=(await this.stat((0,$.$zg)(d,h.name))).type:E=this.M(h),c.push([h.name,E])}catch(E){this.a.trace(E)}})),c}catch(l){throw this.fb(l)}}M(d,l){let c;return l?.dangling?c=u.FileType.Unknown:d.isFile()?c=u.FileType.File:d.isDirectory()?c=u.FileType.Directory:c=u.FileType.Unknown,l&&(c|=u.FileType.SymbolicLink),c}async O(d){const l=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let c;for(;c=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await c.wait();const h=new g.$Wg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,m.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let c;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),c=await this.O(d));const h=this.H(d);return await S.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{c?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,l,c){const h=(0,v.$6d)(E=>L.$fe.concat(E.map(I=>L.$fe.wrap(I))).buffer);return(0,o.$Sp)(this,d,h,E=>E.buffer,{...l,bufferSize:256*1024},c),h}async writeFile(d,l,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,$.$zg)((0,$.$yg)(d),`${(0,$.$wg)(d)}${c.atomic.postfix}`),l,c):this.S(d,l,c)}async Q(d){try{const l=this.H(d),{symbolicLink:c}=await S.SymlinkSupport.stat(l);if(c)return!1}catch{}return!0}async R(d,l,c,h){const E=new m.$Qc;try{E.add(await this.O(d)),E.add(await this.O(l)),await this.S(l,c,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(I){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{E.dispose()}}async S(d,l,c,h){let E;try{const I=this.H(d);if(!c.create||!c.overwrite){if(await S.Promises.exists(I)){if(!c.overwrite)throw(0,u.$rk)((0,w.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,u.$rk)((0,w.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(d,{create:!0,unlock:c.unlock},h),await this.write(E,0,l,0,l.byteLength)}catch(I){throw await this.gb(d,I)}finally{typeof E=="number"&&await this.close(E)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,l,c){const h=this.H(d);let E;(0,u.$fk)(l)&&!c&&(E=await this.O(d));let I;try{if((0,u.$fk)(l)&&l.unlock)try{const{stat:p}=await S.SymlinkSupport.stat(h);p.mode&128||await S.Promises.chmod(h,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let f;if((0,u.$fk)(l)){if(C.$i)try{await S.Promises.truncate(h,0),f="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}f||(f="w")}else f="r";I=await S.Promises.open(h,f)}catch(f){throw E?.dispose(),(0,u.$fk)(l)?await this.gb(d,f):this.fb(f)}if(this.U.set(I,0),(0,u.$fk)(l)&&this.X.set(I,d),E){const f=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${h})`),this.W.set(I,E),f&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${h})`),f.dispose())}return I}async close(d){const l=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await S.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await S.Promises.close(d)}catch(c){throw this.fb(c)}finally{l&&(this.W.get(d)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,c,h,E){const I=this.Z(d,l);let f=null;try{f=(await S.Promises.read(d,c,h,E,I)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(d,I,f)}return f}Z(d,l){return l===this.U.get(d)?null:l}$(d,l,c){const h=this.U.get(d);typeof h=="number"&&(typeof l=="number"||(typeof c=="number"?this.U.set(d,h+c):this.U.delete(d)))}async write(d,l,c,h,E){return(0,g.$fh)(()=>this.ab(d,l,c,h,E),100,3)}async ab(d,l,c,h,E){const I=this.Z(d,l);let f=null;try{f=(await S.Promises.write(d,c,h,E,I)).bytesWritten}catch(p){throw await this.gb(this.X.get(d),p)}finally{this.$(d,I,f)}return f}async mkdir(d){try{await S.Promises.mkdir(this.H(d))}catch(l){throw this.fb(l)}}async delete(d,l){try{const c=this.H(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(c),`${(0,A.$mc)(c)}${l.atomic.postfix}`)),await S.Promises.rm(c,S.RimRafMode.MOVE,h)}else try{await S.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let E=!1;try{const{stat:I,symbolicLink:f}=await S.SymlinkSupport.stat(c);E=I.isDirectory()&&!f}catch{}if(E)await S.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.fb(c)}}async rename(d,l,c){const h=this.H(d),E=this.H(l);if(h!==E)try{await this.bb(d,l,"move",c.overwrite),await S.Promises.rename(h,E)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(E)),I.toString()))),this.fb(I)}}async copy(d,l,c){const h=this.H(d),E=this.H(l);if(h!==E)try{await this.bb(d,l,"copy",c.overwrite),await S.Promises.copy(h,E,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(E)),I.toString()))),this.fb(I)}}async bb(d,l,c,h){const E=this.H(d),I=this.H(l);let f=!1;if(!!(this.capabilities&1024)||(f=(0,y.$1f)(E,I,!0)),f){if(c==="copy")throw(0,u.$rk)((0,w.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const k=await this.L(d);if(!k)throw(0,u.$rk)((0,w.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(l);if(P){if(!h)throw(0,u.$rk)((0,w.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);k.type&u.FileType.File&&P.type&u.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.cb(d,l,!1)}async cb(d,l,c){const h=this.H(d),E=this.H(l),I=!!(this.capabilities&1024);if((0,y.$1f)(h,E,!I))return;const f=new m.$Qc;try{f.add(await this.O(d)),f.add(await this.O(l)),c&&await S.Promises.mkdir((0,A.$lc)(E),{recursive:!0}),await S.Promises.copyFile(h,E)}catch(p){if(p.code==="ENOENT"&&!c)return this.cb(d,l,!0);throw this.fb(p)}finally{f.dispose()}}t(d,l,c){return new r.$0p(h=>d(h),h=>l(h),c)}F(d,l,c){return new a.$fq(h=>d(h),h=>l(h),c)}fb(d){if(d instanceof u.$qk)return d;let l=d,c;switch(d.code){case"ENOENT":c=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=u.FileSystemProviderErrorCode.Unknown;break;default:c=u.FileSystemProviderErrorCode.Unknown}return(0,u.$rk)(l,c)}async gb(d,l){let c=this.fb(l);if(d&&c.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await S.SymlinkSupport.stat(this.H(d));h.mode&128||(c=(0,u.$rk)(l,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$gq=t}),define(ke[251],Se([1,0,3,14]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=void 0;class g extends D.$Rc{constructor(L,b=[]){super(),this.a=new T.$nj([L,...b]),this.B(L.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...b){this.a.trace(L,...b)}debug(L,...b){this.a.debug(L,...b)}info(L,...b){this.a.info(L,...b)}warn(L,...b){this.a.warn(L,...b)}error(L,...b){this.a.error(L,...b)}flush(){this.a.flush()}}e.$WN=g}),define(ke[252],Se([1,0,32,14]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=void 0;var g;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(g||(g={}));async function R(m,A,C,$,v){try{const S=await new Promise((u,o)=>{me(["@vscode/spdlog"],u,o)});S.setFlushOn(g.Trace);const w=await S.createAsyncRotatingLogger(m,A,C,$);return v?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function L(m,A,C){switch(A){case T.LogLevel.Trace:m.trace(C);break;case T.LogLevel.Debug:m.debug(C);break;case T.LogLevel.Info:m.info(C);break;case T.LogLevel.Warning:m.warn(C);break;case T.LogLevel.Error:m.error(C);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(m,A){switch(A){case T.LogLevel.Trace:m.setLevel(g.Trace);break;case T.LogLevel.Debug:m.setLevel(g.Debug);break;case T.LogLevel.Info:m.setLevel(g.Info);break;case T.LogLevel.Warning:m.setLevel(g.Warning);break;case T.LogLevel.Error:m.setLevel(g.Error);break;case T.LogLevel.Off:m.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class y extends T.$jj{constructor(A,C,$,v,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,C,$,v),this.B(this.onDidChangeLogLevel(w=>{this.r&&b(this.r,w)}))}async s(A,C,$,v){const S=$?6:1,w=30/S*D.$Mk.MB,u=await R(A,C,w,S,v);if(u){this.r=u,b(this.r,this.getLevel());for(const{level:o,message:i}of this.m)L(this.r,o,i);this.m=[]}}g(A,C){this.r?L(this.r,A,C):this.getLevel()<=A&&this.m.push({level:A,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$LN=y}),define(ke[136],Se([1,0,39,206,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(y){function m(S,w){return w-S}y.compare=m;const A=Object.create(null);A[y.Error]=(0,T.localize)(0,null),A[y.Warning]=(0,T.localize)(1,null),A[y.Info]=(0,T.localize)(2,null);function C(S){return A[S]||""}y.toString=C;function $(S){switch(S){case D.default.Error:return y.Error;case D.default.Warning:return y.Warning;case D.default.Info:return y.Info;case D.default.Ignore:return y.Hint}}y.fromSeverity=$;function v(S){switch(S){case y.Error:return D.default.Error;case y.Warning:return D.default.Warning;case y.Info:return D.default.Info;case y.Hint:return D.default.Ignore}}y.toSeverity=v}(L||(e.MarkerSeverity=L={}));var b;(function(y){const m="";function A($){return C($,!0)}y.makeKey=A;function C($,v){const S=[m];return $.source?S.push($.source.replace("\xA6","\\\xA6")):S.push(m),$.code?typeof $.code=="string"?S.push($.code.replace("\xA6","\\\xA6")):S.push($.code.value.replace("\xA6","\\\xA6")):S.push(m),$.severity!==void 0&&$.severity!==null?S.push(L.toString($.severity)):S.push(m),$.message&&v?S.push($.message.replace("\xA6","\\\xA6")):S.push(m),$.startLineNumber!==void 0&&$.startLineNumber!==null?S.push($.startLineNumber.toString()):S.push(m),$.startColumn!==void 0&&$.startColumn!==null?S.push($.startColumn.toString()):S.push(m),$.endLineNumber!==void 0&&$.endLineNumber!==null?S.push($.endLineNumber.toString()):S.push(m),$.endColumn!==void 0&&$.endColumn!==null?S.push($.endColumn.toString()):S.push(m),S.push(m),S.join("\xA6")}y.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$ft=(0,g.$Vh)("markerService")}),define(ke[253],Se([1,0,4,39,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=T.default,e.$6u=(0,g.$Vh)("notificationService");var R;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));var b;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class y{constructor(){this.progress=new m,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$7u=y;class m{infinite(){}done(){}total(C){}worked(C){}}e.$8u=m}),define(ke[137],Se([1,0,13,2,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TU=e.$SU=e.$RU=e.$QU=e.$PU=void 0,e.$PU=(0,g.$Vh)("openerService");function R(m,A){return T.URI.isUri(m)?(0,D.$6e)(m.scheme,A):(0,D.$7e)(m,A+":")}e.$QU=R;function L(m,...A){return A.some(C=>R(m,C))}e.$RU=L;function b(m,A){return m.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$SU=b;function y(m){let A;const C=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return C&&(A={startLineNumber:parseInt(C[1]),startColumn:C[2]?parseInt(C[2]):1,endLineNumber:C[4]?parseInt(C[4]):void 0,endColumn:C[4]?C[5]?parseInt(C[5]):1:void 0},m=m.with({fragment:""})),{selection:A,uri:m}}e.$TU=y}),define(ke[254],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const R=g.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:R.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ke[138],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,D.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(me,e){return function(D,T){e(D,T,me)}};define(ke[85],Se([1,0,12,21,3,5]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,R.$Vh)("progressService");var L;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$$u=b;class y{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const v=this.d;this.d=()=>{v?.(),$()}}):Promise.resolve()}}e.$_u=y;let m=class extends g.$Rc{constructor($,v){super(),this.a=new D.$ih,v.withProgress($,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,g.$Pc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$av=m,e.$av=m=He([Be(1,e.$9u)],m);class A extends g.$Rc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new g.$Qc)}start($){this.stop();const v=++this.a,S=new T.$2d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,g.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Pc)(()=>S.cancel())),this.b.add((0,g.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:S.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$bv=A,e.$cv=(0,R.$Vh)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class g{constructor(){this.a=new Map}add(L,b){D.ok(T.$Cf(L)),D.ok(T.$Ef(b)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,b)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$mn=new g}),define(ke[108],Se([1,0,4,37]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new D.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,m){this.a[g(y)]=m,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;T.$mn.add(e.$nn.JSONContribution,L)}),define(ke[86],Se([1,0,19,4,18,196,44,108,37]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var m;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$rn={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const C=y.$mn.as(b.$nn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new T.$Rd,this.onDidSchemaChange=this.i.event,this.j=new T.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const d=new Set;this.n(t,s,d),C.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const s=new Set;this.o(t,s),C.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const d=new Set;this.o(s,d),this.n(t,!1,d),C.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const d=[];for(const{overrides:l,source:c}of t)for(const h in l)if(s.add(h),e.$Bn.test(h)){const E=this.a.get(h),I=E?.valuesSources??new Map;if(c)for(const P of Object.keys(l[h]))I.set(P,c);const f={...E?.value||{},...l[h]};this.a.set(h,{source:c,value:f,valuesSources:I});const p=(0,L.$zi)(h),k={type:"object",default:f,description:R.localize(1,null,p),$ref:e.$yn,defaultDefaultValue:f,source:g.$Cf(c)?void 0:c,defaultValueSource:c};d.push(...w(h)),this.d[h]=k,this.b.properties[h]=k}else{this.a.set(h,{value:l[h],source:c});const E=this.d[h];E&&(this.w(h,E),this.r(h,E))}this.m(d)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:d,source:l}of t)for(const c in d){const h=this.a.get(c),E=g.$Cf(l)?l:l?.id,I=g.$Cf(h?.source)?h?.source:h?.source?.id;if(E===I)if(s.add(c),this.a.delete(c),e.$Bn.test(c))delete this.d[c],delete this.b.properties[c];else{const f=this.d[c];f&&(this.w(c,f),this.r(c,f))}}this.u()}deltaConfiguration(t){let s=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,d){t.forEach(l=>{this.p(l,s,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,s){const d=l=>{if(l.properties)for(const c in l.properties){s.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>d(c))};for(const l of t){d(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(t,s=!0,d,l,c=3,h){c=g.$Lf(t.scope)?c:t.scope;const E=t.properties;if(E)for(const f in E){const p=E[f];if(s&&n(f,p)){delete E[f];continue}if(p.source=d,p.defaultDefaultValue=E[f].default,this.w(f,p),e.$Bn.test(f)?p.scope=void 0:(p.scope=g.$Lf(p.scope)?c:p.scope,p.restricted=g.$Lf(p.restricted)?!!l?.includes(f):p.restricted),E[f].hasOwnProperty("included")&&!E[f].included){this.f[f]=E[f],delete E[f];continue}else this.d[f]=E[f],E[f].policy?.name&&this.e.set(E[f].policy.name,f);!E[f].deprecationMessage&&E[f].markdownDeprecationMessage&&(E[f].deprecationMessage=E[f].markdownDeprecationMessage),h.add(f)}const I=t.allOf;if(I)for(const f of I)this.p(f,s,d,l,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$sn.properties[t]=s,s.scope){case 1:e.$tn.properties[t]=s;break;case 2:e.$un.properties[t]=s;break;case 6:e.$vn.properties[t]=s;break;case 3:e.$wn.properties[t]=s;break;case 4:e.$xn.properties[t]=s;break;case 5:e.$xn.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$sn.properties[t],s.scope){case 1:delete e.$tn.properties[t];break;case 2:delete e.$un.properties[t];break;case 6:delete e.$vn.properties[t];break;case 3:delete e.$wn.properties[t];break;case 4:case 5:delete e.$xn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$yn};this.w(s,d),e.$sn.properties[s]=d,e.$tn.properties[s]=d,e.$un.properties[s]=d,e.$vn.properties[s]=d,e.$wn.properties[s]=d,e.$xn.properties[s]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=t,e.$tn.patternProperties[e.$An]=t,e.$un.patternProperties[e.$An]=t,e.$vn.patternProperties[e.$An]=t,e.$wn.patternProperties[e.$An]=t,e.$xn.patternProperties[e.$An]=t,this.i.fire()}w(t,s){const d=this.a.get(t);let l=d?.value,c=d?.source;g.$Jf(l)&&(l=s.defaultDefaultValue,c=void 0),g.$Jf(l)&&(l=o(s.type)),s.default=l,s.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",S=new RegExp(v,"g");e.$An=`^(${v})+$`,e.$Bn=new RegExp(e.$An);function w(a){const t=[];if(e.$Bn.test(a)){let s=S.exec(a);for(;s?.length;){const d=s[1].trim();d&&t.push(d),s=S.exec(a)}}return(0,D.$Lb)(t)}e.$Cn=w;function u(a){return a.reduce((t,s)=>`${t}[${s}]`,"")}e.$Dn=u;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=o;const i=new $;y.$mn.add(e.$rn.Configuration,i);function n(a,t){return a.trim()?e.$Bn.test(a)?R.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$Fn=n;function r(){const a=[],t=i.getConfigurationProperties();for(const s of Object.keys(t))a.push([s,t[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Gn=r}),define(ke[255],Se([1,0,19,4,160,3,28,24,18,2,44,86,37]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function v(s){return Object.isFrozen(s)?s:b.$bn(s)}class S{constructor(d={},l=[],c=[],h){this.b=d,this.c=l,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof S)return l;const c=new w("");return c.parseRaw(l),c.configurationModel});this.f=d.reduce((l,c)=>c===l?c:l.merge(c),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$xi)(this.contents,d):this.contents}inspect(d,l){const c=this.rawConfiguration.getValue(d),h=l?this.rawConfiguration.getOverrideValue(d,l):void 0,E=l?this.rawConfiguration.override(l).getValue(d):c;return{value:c,override:h,merged:E}}getOverrideValue(d,l){const c=this.i(l);return c?d?(0,A.$xi)(c,d):c:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const c of this.overrides)c.identifiers.includes(d)&&l.push(...c.keys);return D.$Lb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return D.$Lb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=b.$an(this.contents),c=b.$an(this.overrides),h=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const I of d)if(E.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(l,I.contents);for(const f of I.overrides){const[p]=c.filter(k=>D.$tb(k.identifiers,f.identifiers));p?(this.h(p.contents,f.contents),p.keys.push(...f.keys),p.keys=D.$Lb(p.keys)):c.push(b.$an(f))}for(const f of I.keys)h.indexOf(f)===-1&&h.push(f)}return new S(l,h,c,E.every(I=>I instanceof S)?void 0:E)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const h of D.$Lb([...Object.keys(this.contents),...Object.keys(l)])){let E=this.contents[h];const I=l[h];I&&(typeof E=="object"&&typeof I=="object"?(E=b.$an(E),this.h(E,I)):E=I),c[h]=E}return new S(c,this.keys,this.overrides)}h(d,l){for(const c of Object.keys(l)){if(c in d&&y.$Ef(d[c])&&y.$Ef(l[c])){this.h(d[c],l[c]);continue}d[c]=b.$an(l[c])}}i(d){let l=null,c=null;const h=E=>{E&&(c?this.h(c,E):c=b.$an(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===d?l=E.contents:E.identifiers.includes(d)&&h(E.contents);return h(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,A.$wi)(this.contents,d),C.$Bn.test(d)&&this.overrides.splice(this.overrides.findIndex(c=>D.$tb(c.identifiers,(0,C.$Cn)(d))),1))}j(d,l,c){(0,A.$vi)(this.contents,d,l,h=>console.error(h)),c=c||this.keys.indexOf(d)===-1,c&&this.keys.push(d),C.$Bn.test(d)&&this.overrides.push({identifiers:(0,C.$Cn)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$ui)(this.contents[d],h=>console.error(h))})}}e.$Hn=S;class w{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!y.$Lf(d)){const c=this.g(d);this.parseRaw(c,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:c,keys:h,overrides:E,restricted:I,hasExcludedProperties:f}=this.h(d,l);this.b=new S(c,h,E,f?[d]:void 0),this.c=I||[]}g(d){let l={},c=null,h=[];const E=[],I=[];function f(k){Array.isArray(h)?h.push(k):c!==null&&(h[c]=k)}const p={onObjectBegin:()=>{const k={};f(k),E.push(h),h=k,c=null},onObjectProperty:k=>{c=k},onObjectEnd:()=>{h=E.pop()},onArrayBegin:()=>{const k=[];f(k),E.push(h),h=k,c=null},onArrayEnd:()=>{h=E.pop()},onLiteralValue:f,onError:(k,P,j)=>{I.push({error:k,offset:P,length:j})}};if(d)try{g.$0m(d,p),l=h[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return l}h(d,l){const c=$.$mn.as(C.$rn.Configuration).getConfigurationProperties(),h=this.i(d,c,!0,l);d=h.raw;const E=(0,A.$ui)(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),I=Object.keys(d),f=this.j(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:E,keys:I,overrides:f,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,c,h){let E=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:E};const I={},f=[];for(const p in d)if(C.$Bn.test(p)&&c){const k=this.i(d[p],l,!1,h);I[p]=k.raw,E=E||k.hasExcludedProperties,f.push(...k.restricted)}else{const k=l[p],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&f.push(p),!h.exclude?.includes(p)&&(h.include?.includes(p)||(P===void 0||h.scopes===void 0||h.scopes.includes(P))&&!(h.skipRestricted&&k?.restricted))?I[p]=d[p]:E=!0}return{raw:I,restricted:f,hasExcludedProperties:E}}j(d,l){const c=[];for(const h of Object.keys(d))if(C.$Bn.test(h)){const E={};for(const I in d[h])E[I]=d[h][I];c.push({identifiers:(0,C.$Cn)(h),keys:Object.keys(E),contents:(0,A.$ui)(E,l)})}return c}}e.$In=w;class u extends R.$Rc{constructor(d,l,c,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new T.$Rd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&c.isEqual(E.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=u;class o{constructor(d,l,c,h,E,I,f,p,k,P,j,z,M){this.a=d,this.b=l,this.c=c,this.overrideIdentifiers=h,this.d=E,this.f=I,this.g=f,this.h=p,this.i=k,this.j=P,this.k=j,this.l=z,this.m=M}get value(){return v(this.c)}n(d,l,c){const h=d.inspect(l,c);return{get value(){return v(h.value)},get override(){return v(h.override)},get merged(){return v(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,l,c,h,E=new S,I=new S,f=new L.$zc,p=new S,k=new L.$zc){this.c=d,this.d=l,this.f=c,this.g=h,this.h=E,this.i=I,this.j=f,this.l=p,this.m=k,this.a=null,this.b=new L.$zc,this.n=null}getValue(d,l,c){return this.p(d,l,c).getValue(d)}updateValue(d,l,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new S,this.m.set(c.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),c.resource||(this.a=null)}inspect(d,l,c){const h=this.p(d,l,c),E=this.t(l.resource,c),I=l.resource?this.m.get(l.resource)||this.l:this.l,f=new Set;for(const p of h.overrides)for(const k of p.identifiers)h.getOverrideValue(d,k)!==void 0&&f.add(k);return new o(d,l,h.getValue(d),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,E||void 0,I)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const c=[];if(!l){const{added:h,updated:E,removed:I}=a(this.c,d);l=[...h,...E,...I]}for(const h of l)for(const E of(0,C.$Cn)(h)){const I=this.c.getKeysForOverrideIdentifier(E),f=d.getKeysForOverrideIdentifier(E),p=[...f.filter(k=>I.indexOf(k)===-1),...I.filter(k=>f.indexOf(k)===-1),...I.filter(k=>!b.$en(this.c.override(E).getValue(k),d.override(E).getValue(k)))];c.push([E,p])}return this.updateDefaultConfiguration(d),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:c,removed:h}=a(this.d,d),E=[...l,...c,...h];return E.length&&this.updatePolicyConfiguration(d),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:c,removed:h,overrides:E}=a(this.applicationConfiguration,d),I=[...l,...c,...h];return I.length&&this.updateApplicationConfiguration(d),{keys:I,overrides:E}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:E}=a(this.localUserConfiguration,d),I=[...l,...c,...h];return I.length&&this.updateLocalUserConfiguration(d),{keys:I,overrides:E}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:E}=a(this.remoteUserConfiguration,d),I=[...l,...c,...h];return I.length&&this.updateRemoteUserConfiguration(d),{keys:I,overrides:E}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:c,removed:h,overrides:E}=a(this.workspaceConfiguration,d),I=[...l,...c,...h];return I.length&&this.updateWorkspaceConfiguration(d),{keys:I,overrides:E}}compareAndUpdateFolderConfiguration(d,l){const c=this.folderConfigurations.get(d),{added:h,updated:E,removed:I,overrides:f}=a(c,l),p=[...h,...E,...I];return(p.length||!c)&&this.updateFolderConfiguration(d,l),{keys:p,overrides:f}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:c,updated:h,removed:E,overrides:I}=a(l,void 0);return{keys:[...c,...h,...E],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,c){let h=this.q(l,c);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},l){let c=this.r();if(l&&d){const h=l.getFolder(d);h&&(c=this.s(h.uri)||c);const E=this.m.get(d);E&&(c=c.merge(E))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const c=this.r(),h=this.j.get(d);h?(l=c.merge(h),this.b.set(d,l)):l=c}return l}t(d,l){if(l&&d){const c=l.getFolder(d);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:c,overrides:h,keys:E}=this.j.get(l);return d.push([l,{contents:c,overrides:h,keys:E}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(c=>d.add(c))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>d.add(c))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.i.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.w(d.defaults),c=this.w(d.policy),h=this.w(d.application),E=this.w(d.user),I=this.w(d.workspace),f=d.folders.reduce((p,k)=>(p.set(m.URI.revive(k[0]),this.w(k[1])),p),new L.$zc);return new i(l,c,h,E,new S,I,f,new S,new L.$zc)}static w(d){return new S(d.contents,d.keys,d.overrides)}}e.$Kn=i;function n(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const d=new Set,l=new Map;for(const h of s)h.keys.forEach(E=>d.add(E)),h.overrides.forEach(([E,I])=>{const f=(0,L.$wc)(l,E,new Set);I.forEach(p=>f.add(p))});const c=[];return l.forEach((h,E)=>c.push([E,[...h.values()]])),{keys:[...d.values()],overrides:c}}e.$Ln=n;class r{constructor(d,l,c,h){this.change=d,this.f=l,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const E of d.keys)this.affectedKeys.add(E);for(const[,E]of d.overrides)for(const I of E)this.affectedKeys.add(I);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,l){const c=this.a+d,h=this.d.indexOf(c);if(h<0)return!1;const E=h+c.length;if(E>=this.d.length)return!1;const I=this.d.charCodeAt(E);if(I!==this.b&&I!==this.c)return!1;if(l){const f=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,p=this.g.getValue(d,l,this.h);return!b.$en(f,p)}return!0}}e.$Mn=r;function a(s,d){const{added:l,removed:c,updated:h}=t(d?.rawConfiguration,s?.rawConfiguration),E=[],I=s?.getAllOverrideIdentifiers()||[],f=d?.getAllOverrideIdentifiers()||[];if(d){const p=f.filter(k=>!I.includes(k));for(const k of p)E.push([k,d.getKeysForOverrideIdentifier(k)])}if(s){const p=I.filter(k=>!f.includes(k));for(const k of p)E.push([k,s.getKeysForOverrideIdentifier(k)])}if(d&&s){for(const p of I)if(f.includes(p)){const k=t({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)});E.push([p,[...k.added,...k.removed,...k.updated]])}}return{added:l,removed:c,updated:h,overrides:E}}function t(s,d){const l=s?d?s.keys.filter(E=>d.keys.indexOf(E)===-1):[...s.keys]:[],c=d?s?d.keys.filter(E=>s.keys.indexOf(E)===-1):[...d.keys]:[],h=[];if(s&&d){for(const E of d.keys)if(s.keys.indexOf(E)!==-1){const I=(0,A.$xi)(d.contents,E),f=(0,A.$xi)(s.contents,E);b.$en(I,f)||h.push(E)}}return{added:l,removed:c,updated:h}}}),define(ke[256],Se([1,0,22,4,3,82]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqb=e.$fqb=e.$eqb=e.$dqb=void 0;const L=(m,A,C)=>{const $=new Uint8Array(16);for(let w=0;w<16;w++)$[w]=Math.round(Math.random()*256);const v=(0,D.$ze)(D.$fe.wrap($));return[`GET ws://localhost${m}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$dqb=L,e.$eqb=D.$fe.fromString(`\r
\r
`);async function b(m,A,C,$,v){m.write(D.$fe.fromString((0,e.$dqb)(A,C,$)));const S=new g.$Qc;try{return await new Promise((w,u)=>{let o;S.add(m.onData(i=>{o?o=D.$fe.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$eqb);if(n===-1)return;w(m),m.pauseData();const r=o.slice(n+e.$eqb.byteLength);r.byteLength&&v.onData.fire(r)})),S.add(m.onClose(i=>u(i??new Error("socket closed")))),S.add(m.onEnd(()=>u(new Error("socket ended"))))})}catch(w){throw m.dispose(),w}finally{S.dispose()}}e.$fqb=b;class y extends g.$Rc{constructor(A,C){super(),this.g=A,this.a=this.B(new T.$Ud),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new T.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event($=>this.a.fire($))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,C){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$gqb=y}),define(ke[64],Se([1,0,8,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,T.$Vh)("remoteAuthorityResolverService");var g;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class R{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=R;class L{constructor(C,$){this.host=C,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=L;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class y extends D.$ab{static isNotAvailable(C){return C instanceof y&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof y&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof y&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof y&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof y&&C.isHandled}constructor(C,$=b.Unknown,v){super(C),this._message=C,this._code=$,this._detail=v,this.isHandled=$===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,y.prototype)}}e.$Yk=y;function m(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}e.$Zk=m}),define(ke[65],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function T(m){return m.scheme===D.Schemas.vscodeRemote?m.authority:void 0}e.$1k=T;function g(m){if(!m)return;const A=m.indexOf("+");return A<0?m:m.substr(0,A)}e.$2k=g;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$3k=R;function L(m){const{host:A,port:C}=y(m);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:C}}e.$4k=L;function b(m,A){let{host:C,port:$}=y(m);return typeof $>"u"&&($=A),{host:C,port:$}}e.$5k=b;function y(m){const A=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const C=m.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const $=m.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:m,port:void 0}}}),define(ke[26],Se([1,0,13,5,65]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$0l=R,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(L||(e.ExtensionType=L={}));var b;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class y{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,o){if(typeof u>"u"||u===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof u=="string"||typeof o=="string"){const i=typeof u=="string"?u:u.value,n=typeof o=="string"?o:o.value;return D.$6e(i,n)}return u._lower===o._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$_l=y;class m{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const o of u)this.add(o)}add(u){this.c.add(y.toKey(u))}delete(u){return this.c.delete(y.toKey(u))}has(u){return this.c.has(y.toKey(u))}}e.$am=m;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(y.toKey(u))}get(u){return this.c.get(y.toKey(u))}has(u){return this.c.has(y.toKey(u))}set(u,o){this.c.set(y.toKey(u),o)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=A;function C(w){return $(w)}e.$cm=C;function $(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$dm=$;function v(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$em=v;function S(w,u){if(u){const o=`onResolveRemoteAuthority:${(0,g.$2k)(u)}`;return!!w.activationEvents?.includes(o)}return!1}e.$fm=S,e.$gm=(0,T.$Vh)("IBuiltinExtensionsScannerService")}),define(ke[139],Se([1,0,8,26]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(L,b){this.a.set(L,b)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const b=Object.create(null);for(const y of L){const m=this.readActivationEvents(y);m.length>0&&(b[T.$_l.toKey(y.identifier)]=m)}return b}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const b=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let y=0;y<b.length;y++)b[y]==="onUri"&&(b[y]=`onUri:${T.$_l.toKey(L.identifier)}`);if(!L.contributes)return b;for(const y in L.contributes){const m=this.a.get(y);if(!m)continue;const A=L.contributes[y],C=Array.isArray(A)?A:[A];try{m(C,b)}catch($){(0,D.$Z)($)}}return b}}e.$wF=g,e.$xF=new g}),define(ke[257],Se([1,0,12,22,21,8,4,3,56,38,30,82,64,65]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.PersistentConnectionEventType=e.$_k=e.$$k=e.$0k=e.ConnectionType=void 0;const S=30*1e3;var w;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function u(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(K){const U=new g.$2d;return setTimeout(()=>U.cancel(),K),U.token}function i(K,U){if(K.isCancellationRequested||U.isCancellationRequested)return g.CancellationToken.Cancelled;const ie=new g.$2d;return K.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Qc,this.promise=new Promise((ie,be)=>{this.f=ie,this.g=be}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(K,U){const ie=new n(U);return ie.registerDisposable(K.onControlMessage(be=>{const H=JSON.parse(be.toString()),_=G(H);_?ie.reject(_):ie.resolve(H)})),ie.promise}function a(K,U,ie,be,H,_,Z,$e){const re=new n($e),fe=m.$Nd.create(!1);return K.info(`Creating a socket (${Z})...`),y.mark(`code/willCreateSocket/${_}`),U.connect(ie,be,H,Z).then(te=>{re.didTimeout?(y.mark(`code/didCreateSocketError/${_}`),K.info(`Creating a socket (${Z}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(y.mark(`code/didCreateSocketOK/${_}`),K.info(`Creating a socket (${Z}) was successful after ${fe.elapsed()} ms.`),re.resolve(te))},te=>{y.mark(`code/didCreateSocketError/${_}`),K.info(`Creating a socket (${Z}) returned an error after ${fe.elapsed()} ms.`),K.error(te),re.reject(te)}),re.promise}function t(K,U){const ie=new n(U);return K.then(be=>{ie.didTimeout||ie.resolve(be)},be=>{ie.didTimeout||ie.reject(be)}),ie.promise}async function s(K,U,ie,be){const H=Ee(K,U);K.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let _;try{_=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,v.$3k)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,u(U),`renderer-${u(U)}-${K.reconnectionToken}`,be)}catch(te){throw K.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),K.logService.error(te),te}K.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let Z,$e;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(_,null),Z=K.reconnectionProtocol,$e=!1):(Z=new C.$Jh({socket:_}),$e=!0),K.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const re=await t(K.signService.createNewMessage((0,A.$ig)()),be),fe={type:"auth",auth:K.connectionToken||"00000000000000000000",data:re.data};Z.sendControl(T.$fe.fromString(JSON.stringify(fe)));try{const te=await r(Z,i(be,o(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(K.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(K.signService.validate(re,te.signedData),be)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const pe=await t(K.signService.sign(te.data),be),Pe={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:U};return ie&&(Pe.args=ie),K.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(T.$fe.fromString(JSON.stringify(Pe))),{protocol:Z,ownsProtocol:$e}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(K.logService.error(`${H} the handshake timed out. Error:`),K.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${H} received error control message when negotiating connection. Error:`),K.logService.error(te)),$e&&Y(Z),te}}async function d(K,U,ie,be){const H=Date.now(),_=Ee(K,U),{protocol:Z,ownsProtocol:$e}=await s(K,U,ie,be),re=new n(be);return re.registerDisposable(Z.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),de=G(te);de?(K.logService.error(`${_} received error control message when negotiating connection. Error:`),K.logService.error(de),$e&&Y(Z),re.reject(de)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${he(H)}!`),re.resolve({protocol:Z,firstMessage:te}))})),re.promise}async function l(K,U){const{protocol:ie}=await d(K,1,void 0,U);return{protocol:ie}}async function c(K,U,ie){const{protocol:be,firstMessage:H}=await d(K,2,U,ie),_=H&&H.debugPort;return{protocol:be,debugPort:_}}async function h(K,U,ie){const be=Date.now(),H=Ee(K,3),{protocol:_}=await s(K,3,U,ie);return K.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${he(be)}!`),_}async function E(K,U,ie){const{connectTo:be,connectionToken:H}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:be,connectionToken:H,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function I(K,U,ie){return p(K,async be=>{const{protocol:H}=await l(be,g.CancellationToken.None);return new x(K,U,ie,be.reconnectionToken,H)})}e.$0k=I;async function f(K,U){return p(K,async ie=>{const{protocol:be,debugPort:H}=await c(ie,U,g.CancellationToken.None);return new ce(K,U,ie.reconnectionToken,be,H)})}e.$$k=f;async function p(K,U){for(let be=1;;be++)try{const H=(0,A.$ig)(),_=await E(K,H,null);return await U(_)}catch(H){if(be<5)K.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(H);else throw K.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(H),W.triggerPermanentFailure(0,0,$.$Yk.isHandled(H)),H}}async function k(K,U,ie){const be=await E(K,(0,A.$ig)(),null);return await h(be,{host:U,port:ie},g.CancellationToken.None)}e.$_k=k;function P(K){return(0,D.$Lg)(U=>new Promise((ie,be)=>{const H=setTimeout(ie,K*1e3);U.onCancellationRequested(()=>{clearTimeout(H),ie()})}))}var j;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(j||(e.PersistentConnectionEventType=j={}));class z{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$al=z;class M{constructor(U,ie,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=be,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.$bl=M;class F{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=2}}e.$cl=F;class N{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=4}}e.$dl=N;class O{constructor(U,ie,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.handled=H,this.type=3}}e.$el=O;class W extends b.$Rc{static triggerPermanentFailure(U,ie,be){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=be,this.j.forEach(H=>H.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(U,ie,be,H,_){super(),this.t=U,this.u=ie,this.reconnectionToken=be,this.protocol=H,this.w=_,this.m=this.B(new L.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(H.onSocketClose(Z=>{const $e=Q(this.t,this.reconnectionToken,!0);Z?Z.type===0?(this.u.logService.info(`${$e} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${$e} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${$e} received socket close event.`),this.y()})),this.B(H.onSocketTimeout(Z=>{const $e=Q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${$e} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,b.$Pc)(()=>{const Z=W.j.indexOf(this);Z>=0&&W.j.splice(Z,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=Q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const H=be<ie.length?ie[be]:ie[ie.length-1];try{if(H>0){const Z=P(H);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,Z)),this.u.logService.info(`${U} waiting for ${H} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const _=await E(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${_.connectTo}...`),await this.G(_,o(S)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if($.$Yk.isTemporarilyNotAvailable(_)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,R.$3)(_)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof $.$Yk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,$.$Yk.isHandled(_));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,be){this.w?W.triggerPermanentFailure(U,ie,be):this.D(U,ie,be)}D(U,ie,be){this.m.fire(new O(this.reconnectionToken,U,ie,be)),Y(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$fl=W;class x extends W{constructor(U,ie,be,H,_){super(1,U,H,_,!0),this.client=this.B(new C.$Hh(_,{remoteAuthority:ie,clientId:be},U.ipcLogger))}async G(U,ie){await l(U,ie)}}e.$gl=x;class ce extends W{constructor(U,ie,be,H,_){super(2,U,be,H,!1),this.H=ie,this.debugPort=_}async G(U,ie){await c(U,this.H,ie)}}e.$hl=ce;function Y(K){try{K.acceptDisconnect();const U=K.getSocket();K.dispose(),U.dispose()}catch(U){(0,R.$Z)(U)}}function G(K){if(K&&K.type==="error"){const U=new Error(`Connection error: ${K.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function J(K,U){for(;K.length<U;)K+=" ";return K}function le(K,U){return`[remote-connection][${J(u(K),13)}][${U.substr(0,5)}\u2026]`}function Q(K,U,ie){return`${le(K,U)}[${ie?"reconnect":"initial"}]`}function Ee(K,U){return`${Q(U,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(ke[258],Se([1,0,3,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=void 0,e.$6k=(0,T.$Vh)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(L,b){return this.a[L]??=[],this.a[L].push(b),(0,D.$Pc)(()=>{const y=this.a[L]?.indexOf(b);typeof y=="number"&&y>=0&&this.a[L]?.splice(y,1)})}b(L){return(this.a[L.type]||[]).find(y=>y.supports(L))}connect(L,b,y,m){const A=this.b(L);if(!A)throw new Error(`No socket factory found for ${L}`);return A.connect(L,b,y,m)}}e.$7k=g}),define(ke[259],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f5b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const R=await this.c();if(R){const L=String(D.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,R){if(!g.id)return!0;const L=this.b.get(g.id);if(!L)return!1;this.b.delete(g.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$f5b=D}),define(ke[109],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=void 0,e.$8k="signService",e.$9k=(0,D.$Vh)(e.$8k)}),define(ke[140],Se([1,0,259]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c0b=void 0;class T extends D.$f5b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>me(["vsda"],R,L))}}e.$c0b=T}),define(ke[260],Se([1,0,11,49,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function R(y){if(D.$u===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function L(y,m,A,C,$,v,S,w,u){const o=Object.create(null);o["common.machineId"]=v,o["common.sqmId"]=S,o.sessionID=(0,g.$ig)()+Date.now(),o.commitHash=C,o.version=$,o["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,D.$h)(D.$u),o["common.nodePlatform"]=T.$cc,o["common.nodeArch"]=A,o["common.product"]=u||"desktop",w&&(o["common.msftInternal"]=w);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(o["common.snap"]="true");const r=R(m);return r&&(o["common.platformDetail"]=r),o}e.$no=L;function b(y){const m=T.env.USERDNSDOMAIN;if(!m)return!1;const A=m.toLowerCase();return y.some(C=>A===C)}e.$oo=b}),define(ke[261],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,D.$Vh)("telemetryService"),e.$jl=(0,D.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var g;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(ke[87],Se([1,0,24,18,4,44,65,260,261]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class m{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$po=m;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=A,e.$ro=new A;class C{async publicLog(c,h,E){}async publicLogError(c,h,E){}}e.$so=C,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function $(l,c){return g.Event.debounce(c.onDidChangeConfiguration,(E,I)=>{const f=E?new Set([...E.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:f}},1e3,!0)(E=>{E.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,R.$si)(E.source),configurationKeys:Array.from(E.affectedKeys)})})}e.$wo=$;function v(l,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!l.enableTelemetry)}e.$xo=v;function S(l,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.$yo=S;function w(l){const c=l.getValue(y.$ql),h=l.getValue(y.$rl);if(l.getValue(y.$sl)===!1||h===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=w;function u(l){const c={},h={},E={};n(l,E);for(let I in E){I=I.length>150?I.substr(I.length-149):I;const f=E[I];typeof f=="number"?h[I]=f:typeof f=="boolean"?h[I]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${f.length}`),c[I]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(c[I]=f)}return{properties:c,measurements:h}}e.$Ao=u;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(l){if(!l)return"none";const c=(0,L.$2k)(l);return o.has(c)?c:"other"}e.$Bo=i;function n(l,c,h=0,E){if(l)for(const I of Object.getOwnPropertyNames(l)){const f=l[I],p=E?E+I:I;Array.isArray(f)?c[p]=(0,D.$fn)(f):f instanceof Date?c[p]=f.toISOString():(0,T.$Ef)(f)?h<2?n(f,c,h+1,p+"."):c[p]=(0,D.$fn)(f):c[p]=f}}function r(l,c){const h=l.msftInternalDomains||[],E=c.getValue("telemetry.internalTesting");return(0,b.$oo)(h)||E}e.$Co=r;function a(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.$Do=a;function t(l,c){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let h=l;const E=[];for(const k of c)for(;;){const P=k.exec(l);if(!P)break;E.push([P.index,k.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(h="";;){const k=f.exec(l);if(!k)break;const P=E.some(([j,z])=>k.index<z&&j<f.lastIndex);!I.test(k[0])&&!P&&(h+=l.substring(p,k.index)+"<REDACTED: user-file-path>",p=f.lastIndex)}return p<l.length&&(h+=l.substr(p)),h}function s(l){if(!l)return l;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of c)if(h.regex.test(l))return`<REDACTED: ${h.label}>`;return l}function d(l,c){return(0,D.$cn)(l,h=>{if(h instanceof m||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let E=h.replaceAll("%20"," ");E=t(E,c);for(const I of c)E=E.replace(I,"");return E=s(E),E}})}e.$Eo=d}),define(ke[262],Se([1,0,13,135,26,11,2,8,49,87]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function A(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,D.$1e)(d.id,l.id)===0}e.$Fo=A;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(l){const c=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new $(l.identifier,c,h)}static parse(l){const c=C.exec(l);return c&&c[1]&&c[2]?new $({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof $?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Go=$;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(d){const l=v.exec(d);return l&&l[1]?[u(l[1]),l[2]]:[u(d),void 0]}e.$Ho=S;function w(d,l){return`${d}.${l}`}e.$Io=w;function u(d){return d.toLowerCase()}e.$Jo=u;function o(d,l){return u(w(d??g.$8l,l))}e.$Ko=o;function i(d,l){const c=[],h=E=>{for(const I of c)if(I.some(f=>A(l(f),l(E))))return I;return null};for(const E of d){const I=h(E);I?I.push(E):c.push([E])}return c}e.$Lo=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Mo=n;function r(d){return{id:new m.$po(d.identifier.id),name:new m.$po(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$No=r,e.$Oo=new g.$_l("pprice.better-merge");function a(d,l){const c=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const E=h.shift();if(E&&c.every(I=>!A(I.identifier,{id:E}))){const I=d.filter(f=>A(f.identifier,{id:E}));I.length===1&&(c.push(I[0]),h.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$Po=a;async function t(d,l){if(!R.$k)return!1;let c;try{c=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){l.debug("Error while getting the os-release file.",(0,b.$9)(E))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(d,l){const c=await t(d,l),h=(0,T.$_n)(c?"alpine":R.$u,y.$dc);return l.debug("ComputeTargetPlatform:",h),h}e.$Qo=s}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function D(y){return[...y.entries()]}e.$qr=D;function T(y){return y?[...y.entries()]:[]}e.$rr=T;function g(y){return new Map(y)}e.$sr=g;function R(y){return new Map(y??[])}e.$tr=R;function L(y){return Array.from(y.entries()).map(m=>[m[0],D(m[1].map),T(m[1].descriptionMap)])}e.$ur=L;function b(y){return new Map(y.map(m=>[m[0],{map:g(m[1]),descriptionMap:R(m[2])}]))}e.$vr=b}),define(ke[264],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,R,L=5){const b=R(y=>{const m=typeof y=="string"?y:y.data;let A=this.a.get(g);if(A){A.data.push(m);return}const C=setTimeout(()=>this.flushBuffer(g),L);A={data:[m],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,A)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const R=this.a.get(g);R&&(this.a.delete(g),this.b(g,R.data.join("")))}}e.$xqb=D}),define(ke[265],Se([1,0,12,78,61,4,18,2,207,108,37]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.IconFontDefinition=e.IconContribution=e.$_v=void 0,e.$_v={IconContribution:"base.contributions.icons"};var C;(function(r){function a(t,s){let d=t.defaults;for(;g.ThemeIcon.isThemeIcon(d);){const l=S.getIcon(d.id);if(!l)return;d=l.defaults}return d}r.getDefinition=a})(C||(e.IconContribution=C={}));var $;(function(r){function a(s){return{weight:s.weight,style:s.style,src:s.src.map(d=>({format:d.format,location:d.location.toString()}))}}r.toJSONObject=a;function t(s){const d=l=>(0,L.$Cf)(l)?l:void 0;if(s&&Array.isArray(s.src)&&s.src.every(l=>(0,L.$Cf)(l.format)&&(0,L.$Cf)(l.location)))return{weight:d(s.weight),style:d(s.style),src:s.src.map(l=>({format:l.format,location:b.URI.parse(l.location)}))}}r.fromJSONObject=t})($||(e.IconFontDefinition=$={}));class v{constructor(){this.a=new R.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,s,d){const l=this.b[a];if(l){if(s&&!l.description){l.description=s,this.d.properties[a].markdownDescription=`${s} $(${a})`;const E=this.e.enum.indexOf(a);E!==-1&&(this.e.enumDescriptions[E]=s),this.a.fire()}return l}const c={id:a,description:s,defaults:t,deprecationMessage:d};this.b[a]=c;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),s&&(h.markdownDescription=`${s}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const s=this.f[a];return s||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(l,c)=>l.id.localeCompare(c.id),t=l=>{for(;g.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(l=>this.b[l]);for(const l of d.filter(c=>!!c.description).sort(a))s.push(`|<i class="${t(l)}"></i>|${l.id}|${g.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const l of d.filter(c=>!g.ThemeIcon.isThemeIcon(c.defaults)).sort(a))s.push(`|<i class="${t(l)}"></i>|${l.id}|`);return s.join(`
`)}}const S=new v;A.$mn.add(e.$_v.IconContribution,S);function w(r,a,t,s){return S.registerIcon(r,a,t,s)}e.$aw=w;function u(){return S}e.$bw=u;function o(){const r=(0,T.$Yj)();for(const a in r){const t="\\"+r[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}o(),e.$cw="vscode://schemas/icons";const i=A.$mn.as(m.$nn.JSONContribution);i.registerSchema(e.$cw,S.getIconSchema());const n=new D.$0g(()=>i.notifySchemaChanged(e.$cw),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$dw=w("widget-close",T.$1j.close,(0,y.localize)(2,null)),e.$ew=w("goto-previous-location",T.$1j.arrowUp,(0,y.localize)(3,null)),e.$fw=w("goto-next-location",T.$1j.arrowDown,(0,y.localize)(4,null)),e.$gw=g.ThemeIcon.modify(T.$1j.sync,"spin"),e.$hw=g.ThemeIcon.modify(T.$1j.loading,"spin")}),define(ke[88],Se([1,0,4,44,5,14]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,g.$Vh)("tunnelService"),e.$ev=(0,g.$Vh)("sharedTunnelsService");var L;(function(u){u.Http="http",u.Https="https"})(L||(e.TunnelProtocol=L={}));var b;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(b||(e.TunnelPrivacyId=b={}));function y(u){return!!u.forwardPort}e.$fv=y;var m;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function A(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(o)return{address:o[1],port:+o[2]}}e.$gv=A,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(u){return e.$hv.indexOf(u)>=0}e.$iv=C,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(u){return e.$jv.indexOf(u)>=0}e.$kv=$;function v(u,o,i,n){if(i===1)return!1;if(i===2&&$(o)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(r?.length===4&&parseInt(r[1])>=18)return!1}return u<1024}e.$lv=v;class S{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this.b=n,this.a=new D.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=S;let w=class{constructor(o,i){this.j=o,this.k=i,this.a=new D.$Rd,this.onTunnelOpened=this.a.event,this.b=new D.$Rd,this.onTunnelClosed=this.b.event,this.c=new D.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],i=Array.from(this.e.values());for(const n of i){const r=Array.from(n.values());for(const a of r){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,n,r,a){this.p(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:r,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){($(o)||C(o))&&(o=e.$hv[0]);const n=this.r(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,r,a,t=!1,s,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const l=this.f??o;if(!l)return;if(i||(i="localhost"),r||(r=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(l,i,n,r,a,t,s,d);return c?c.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&h.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async o(o,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const r=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),r}}async closeTunnel(o,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this.e.get(o);if(n&&n.has(i)){const r=n.get(i);r.refcount=0,await this.o(o,i,r)}}p(o,i,n){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:n})}async q(o,i){const n=this.e.get(o);if(n){const r=n.get(i),a=r?await r.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(o)}}r(o,i){const n=[o];C(o)?(n.push(...e.$hv),n.push(...e.$jv)):$(o)&&n.push(...e.$jv);const r=n.map(a=>this.e.get(a));for(const a of r){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!A(o)}t(o,i,n,r,a,t,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${r}.`);const d=n;this.i.add(d);const l=r===void 0?n:r,c={elevationRequired:a?this.isPortPrivileged(l):!1},h={remoteAddress:{host:i,port:n},localAddressPort:r,privacy:t,public:t?t!==b.Private:void 0,protocol:s},E=o.forwardPort(h,c);return E?(this.p(i,n,E),E.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),E}};e.$nv=w,e.$nv=w=He([Be(0,R.$dj),Be(1,T.$pi)],w)}),define(ke[266],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=void 0,e.$Ok=(0,D.$Vh)("IUriIdentityService")}),define(ke[267],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,D.$Vh)("editSessionIdentityService");var T;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(ke[268],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=void 0;function T(y){return y.scheme!==D.Schemas.file&&y.scheme!==D.Schemas.vscodeRemote}e.$7J=T;function g(y){if(y.folders.length)return y.folders.every(m=>T(m.uri))?y.folders[0].uri:void 0;if(y.configuration&&T(y.configuration))return y.configuration}e.$8J=g;function R(y){return g(y)?.scheme}e.$9J=R;function L(y){return g(y)?.authority}e.$0J=L;function b(y){return g(y)!==void 0}e.$$J=b}),define(ke[40],Se([1,0,209,16,77,23,2,5,17]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,b.$Vh)("contextService");function m(l){const c=l;return typeof c?.id=="string"&&L.URI.isUri(c.uri)}e.$6h=m;function A(l){return typeof l?.id=="string"&&!m(l)&&!$(l)}e.$7h=A,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function C(l,c){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,T.$mc)(l)}:c?e.$8h:e.$9h;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$0h=C;function $(l){const c=l;return typeof c?.id=="string"&&L.URI.isUri(c.configPath)}e.$$h=$;function v(l){const c=l;if(c?.uri)return{id:c.id,uri:L.URI.revive(c.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:L.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}e.$_h=v;var S;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function w(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$ai=w;function u(l){const c=l;return!!(c&&typeof c=="object"&&L.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$bi=u;class o{constructor(c,h,E,I,f){this.h=c,this.j=E,this.k=I,this.l=f,this.c=g.$2h.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=g.$2h.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=o;class i{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.$zg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=i;function n(l){return new i({uri:l,index:0,name:(0,R.$vg)(l)},{uri:l.toString()})}e.$ei=n,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,D.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function r(l,c){return R.$qg.isEqualOrParent(l,c.untitledWorkspacesHome)}e.$ji=r;function a(l){let c;return L.URI.isUri(l)?c=l:c=l.configuration,c?.scheme===y.Schemas.tmp}e.$ki=a,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$li}e.$mi=t;function s(l,c){return!r(l,c)&&!a(l)}e.$ni=s;function d(l){return(typeof l=="string"?(0,T.$nc)(l):(0,R.$xg)(l))===e.$gi}e.$oi=d}),define(ke[269],Se([1,0,52,4,3,23,2,208,134,32,5,14,40,28,266,12,30,13,18]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.ProfileResourceType=void 0;var n;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&L.URI.isUri(c.location)&&L.URI.isUri(c.globalStorageHome)&&L.URI.isUri(c.settingsResource)&&L.URI.isUri(c.keybindingsResource)&&L.URI.isUri(c.tasksResource)&&L.URI.isUri(c.snippetsHome)&&L.URI.isUri(c.extensionsResource))}e.$Pk=r,e.$Qk=(0,A.$Vh)("IUserDataProfilesService");function a(l,c){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:L.URI.revive(l.location).with({scheme:c}),globalStorageHome:L.URI.revive(l.globalStorageHome).with({scheme:c}),settingsResource:L.URI.revive(l.settingsResource).with({scheme:c}),keybindingsResource:L.URI.revive(l.keybindingsResource).with({scheme:c}),tasksResource:L.URI.revive(l.tasksResource).with({scheme:c}),snippetsHome:L.URI.revive(l.snippetsHome).with({scheme:c}),extensionsResource:L.URI.revive(l.extensionsResource).with({scheme:c}),cacheHome:L.URI.revive(l.cacheHome).with({scheme:c}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}e.$Rk=a;function t(l,c,h,E,I,f){return{id:l,name:c,location:h,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:f&&I?.useDefaultFlags?.globalState?f.globalStorageHome:(0,R.$zg)(h,"globalStorage"),settingsResource:f&&I?.useDefaultFlags?.settings?f.settingsResource:(0,R.$zg)(h,"settings.json"),keybindingsResource:f&&I?.useDefaultFlags?.keybindings?f.keybindingsResource:(0,R.$zg)(h,"keybindings.json"),tasksResource:f&&I?.useDefaultFlags?.tasks?f.tasksResource:(0,R.$zg)(h,"tasks.json"),snippetsHome:f&&I?.useDefaultFlags?.snippets?f.snippetsHome:(0,R.$zg)(h,"snippets"),extensionsResource:f&&I?.useDefaultFlags?.extensions?f.extensionsResource:(0,R.$zg)(h,"extensions.json"),cacheHome:(0,R.$zg)(E,l),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$Sk=t;let s=class extends g.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,E,I){super(),this.t=c,this.u=h,this.w=E,this.y=I,this.f=!0,this.h=this.B(new T.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$zc,emptyWindows:new Map},this.profilesHome=(0,R.$zg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$zg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const f of this.O()){if(!f.name||!(0,i.$Cf)(f.name)||!f.location){this.y.warn("Skipping the invalid stored profile",f.location||f.name);continue}h.push(t((0,R.$wg)(f.location),f.name,f.location,this.g,{shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags},c))}}catch(f){this.y.error(f)}const E=new v.$zc,I=new Map;if(h.length)try{const f=this.Q();if(f.workspaces)for(const[p,k]of Object.entries(f.workspaces)){const P=L.URI.parse(p),j=h.find(z=>z.id===k);j&&E.set(P,j)}if(f.emptyWindows)for(const[p,k]of Object.entries(f.emptyWindows)){const P=h.find(j=>j.id===k);P&&I.set(p,P)}}catch(f){this.y.error(f)}this.z={profiles:h,workspaces:E,emptyWindows:I}}return this.z}D(){const c=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",E=new RegExp(`${(0,o.$Je)(h)}\\s(\\d+)`);let I=0;for(const p of this.profiles){const k=E.exec(p.name),P=k?parseInt(k[1]):0;I=P>I?P:I}const f=`${h} ${I+1}`;return this.createProfile((0,D.$Ji)((0,u.$ig)()).toString(16),f,{transient:!0},c)}async createNamedProfile(c,h,E){return this.createProfile((0,D.$Ji)((0,u.$ig)()).toString(16),c,h,E)}async createProfile(c,h,E,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=await this.F(c,h,E);return I&&await this.setProfileForWorkspace(I,f),f}async F(c,h,E){if(!(0,i.$Cf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(h);return I||(I=(async()=>{try{const f=this.profiles.find(P=>P.name===h||P.id===c);if(f)return f;const p=t(c,h,(0,R.$zg)(this.profilesHome,c),this.g,E,this.defaultProfile);await this.u.createFolder(p.location);const k=[];return this.j.fire({profile:p,join(P){k.push(P)}}),await w.Promises.settled(k),this.I([p],[],[]),p}finally{this.r.delete(h)}})(),this.r.set(h,I)),I}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(I=>I.id===c.id);if(!E)throw new Error(`Profile '${c.name}' does not exist`);return E=t(E.id,h.name??E.name,E.location,this.g,{shortName:h.shortName??E.shortName,icon:h.icon===null?void 0:h.icon??E.icon,transient:h.transient??E.isTransient,useDefaultFlags:h.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(I=>I.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const E=[];this.m.fire({profile:h,join(I){E.push(I)}});try{await Promise.allSettled(E)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(I){(0,m.$vk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(I=>I.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,E)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return L.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,$.$6h)(c)?c.uri:(0,$.$$h)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,E){const I=[...this.profiles,...c],f=[];this.s.profiles=[];for(let p of I)p.isDefault||h.some(k=>p.id===k.id)||(p=E.find(k=>p.id===k.id)??p,p.isTransient?this.s.profiles.push(p):f.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(f),this.z=void 0,this.J(c,h,E)}J(c,h,E){this.h.fire({added:c,removed:h,updated:E,all:this.profiles})}L(c,h,E){E=h?.isTransient?!0:E,E||this.L(c,void 0,!0);const I=this.G(c),f=E?this.s:this.C;L.URI.isUri(I)?(f.workspaces.delete(I),h&&f.workspaces.set(I,h)):(f.emptyWindows.delete(I),h&&f.emptyWindows.set(I,h)),E||this.M()}M(){const c={};for(const[E,I]of this.C.workspaces.entries())c[E.toString()]=I.id;const h={};for(const[E,I]of this.C.emptyWindows.entries())h[E.toString()]=I.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},E=this.D();if(c.workspaces)for(const[f,p]of Object.entries(c.workspaces)){const k=L.URI.parse(p);h[f]=this.w.extUri.isEqual(k,E.location)?E.id:this.w.extUri.basename(k)}const I={};if(c.emptyWindows)for(const[f,p]of Object.entries(c.emptyWindows)){const k=L.URI.parse(p);I[f]=this.w.extUri.isEqual(k,E.location)?E.id:this.w.extUri.basename(k)}return{workspaces:h,emptyWindows:I}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Tk=s,e.$Tk=s=He([Be(0,y.$3h),Be(1,m.$ek),Be(2,S.$Ok),Be(3,C.$dj)],s);class d extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Uk=d}),define(ke[270],Se([1,0,12,4,3,56,18,188,5,269]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_o=e.$$o=e.$0o=void 0,e.$0o="__$__isNewStorageMarker",e.$$o="__$__targetStorageMarker",e.$_o=(0,y.$Vh)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var $;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function v(i){const n=i.get(e.$$o);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$ap=v;class S extends g.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new T.$Ud),this.c=this.B(new T.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$0g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,a){return T.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),a)}n(){this.j.value=(0,D.$bh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:a,external:t}=r;if(a===e.$$o){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,r,a){return this.P(r)?.get(n,a)}getBoolean(n,r,a){return this.P(r)?.getBoolean(n,a)}getNumber(n,r,a){return this.P(r)?.getNumber(n,a)}getObject(n,r,a){return this.P(r)?.getObject(n,a)}storeAll(n,r){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,r)})}store(n,r,a,t,s=!1){if((0,L.$Lf)(r)){this.remove(n,a,s);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,r,s)})}remove(n,r,a=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const a=[],t=this.J(n);for(const s of Object.keys(t))t[s]===r&&a.push(s);return a}z(n,r,a,t=!1){const s=this.J(r);typeof a=="number"?s[n]!==a&&(s[n]=a,this.P(r)?.set(e.$$o,JSON.stringify(s),t)):typeof s[n]=="number"&&(delete s[n],this.P(r)?.set(e.$$o,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?v(r):Object.create(null)}isNew(n){return this.getBoolean(e.$0o,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const r=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case A.NONE:await D.Promises.settled([r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await D.Promises.settled([r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(n,r,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(A.NONE),(0,m.$Pk)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||w(r)&&w(n))}N(n,r,a){this.y(()=>{const t=new Set;for(const[s,d]of n)t.add(s),r.get(s)!==d&&this.u(a,{key:s,external:!0});for(const[s]of r.items)t.has(s)||this.u(a,{key:s,external:!0})})}}e.$bp=S;function w(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$cp=w;class u extends S{constructor(){super(),this.U=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$dp=u;async function o(i,n,r,a,t,s){const d=P=>{try{return JSON.parse(P)}catch{return P}},l=new Map,c=new Map;i.forEach((P,j)=>{l.set(j,P),c.set(j,d(P))});const h=new Map,E=new Map;n.forEach((P,j)=>{h.set(j,P),E.set(j,d(P))});const I=new Map,f=new Map;r.forEach((P,j)=>{I.set(j,P),f.set(j,d(P))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(l.forEach((P,j)=>{p.push({key:j,value:P})}),console.table(p),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];h.forEach((j,z)=>{P.push({key:z,value:j})}),console.table(P),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${s})`);const k=[];I.forEach((P,j)=>{k.push({key:j,value:P})}),console.table(k),console.groupEnd(),console.log(f)}e.$ep=o}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const R=this.c++;return this.b.set(R,g),this.e(),R}get(g,R){return this.b.has(g)?this.b.get(g)[R]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$4dc=D}),define(ke[57],Se([1,0,17,23,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=void 0;class R{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$og(b=>{const y=this.b.get(b.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(b,y){y===null?this.b.delete(b.scheme):this.b.set(b.scheme,y)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$7dc=R,e.$8dc=(0,g.$Vh)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=void 0,e.$PM=(0,D.$Vh)("IExtHostInitDataService")}),define(ke[271],Se([1,0,214,14,251,27]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;let L=class extends g.$WN{constructor(y,m,A){const C=A.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",$=A.remote.isRemote?(0,D.localize)(0,null):y?(0,D.localize)(1,null):(0,D.localize)(2,null);super(m.createLogger(C,{name:$}))}};e.$bgc=L,e.$bgc=L=He([Be(1,T.$ej),Be(2,R.$PM)],L)}),define(ke[272],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0;class T{constructor(L,b,y){this.h=new Map,this.a=L,this.b=b,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(m=>(this.f=m,this)),this.g=this.c.onDidChangeStorage(m=>{m.shared===this.b&&m.key===this.a&&(this.f=m.value)}),this.i=new D.$0g(()=>{const m=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of m.values())A.complete()}catch(A){for(const C of m.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,b){let y=this.f[L];return typeof y>"u"&&(y=b),y}update(L,b){this.f[L]=b;const y=this.h.get(L);if(y!==void 0)return y.p;const m=new D.$ih;return this.h.set(L,m),this.i.isScheduled()||this.i.schedule(),m.p}dispose(){this.g.dispose()}}e.$Pec=T;class g extends T{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,b){super(L.identifier.value,!0,b),this.j=L}}e.$Qec=g}),define(ke[273],Se([1,0,4,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class g{constructor(L){this.c=L,this.a=new D.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,b,y,m){const C=this.c.getNotebookDocument(T.URI.revive(L)).acceptModelChanged(b.value,y,m);this.b.fire(C)}$acceptDirtyStateChanged(L,b){this.c.getNotebookDocument(T.URI.revive(L)).acceptDirty(b)}$acceptModelSaved(L){const b=this.c.getNotebookDocument(T.URI.revive(L));this.a.fire(b.apiNotebook)}}e.$Dfc=g}),define(ke[20],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=void 0,e.$zM=(0,D.$Vh)("IExtHostRpcService");class T{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$AM=T}),define(ke[274],Se([1,0,26,4]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class g{#e;constructor(L,b){this.b=new T.$Rd,this.onDidChange=this.b.event,this.a=D.$_l.toKey(L.identifier),this.#e=b,this.#e.onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(L){return this.#e.get(this.a,L)}store(L,b){return this.#e.store(this.a,L,b)}delete(L){return this.#e.delete(this.a,L)}}e.$Xec=g}),define(ke[66],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=void 0,e.$nec=(0,D.$Vh)("IURITransformerService");class T{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$oec=T}),define(ke[275],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecb=e.$Dcb=void 0;class T{constructor(){this.buffers=[]}add(y){let m=this.buffers.indexOf(y);return m<0&&(m=this.buffers.length,this.buffers.push(y)),m}}function g(b,y){if(y.serializeBuffersForPostMessage){const m=new T,C=JSON.stringify(b,(v,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(S)};if(ArrayBuffer.isView(S)){const w=R(S);if(w)return{$$vscode_array_buffer_reference$$:!0,index:m.add(S.buffer),view:{type:w,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),$=m.buffers.map(v=>{const S=new Uint8Array(v);return D.$fe.wrap(S)});return{message:C,buffers:$}}else return{message:JSON.stringify(b),buffers:[]}}e.$Dcb=g;function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(b,y){const m=y.map($=>{const v=new ArrayBuffer($.byteLength);return new Uint8Array(v).set($.buffer),v}),A=y.length?($,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const S=v,{index:w}=S,u=m[w];if(S.view)switch(S.view.type){case 1:return new Int8Array(u,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return v}:void 0;return{message:JSON.parse(b,A),arrayBuffers:m}}e.$Ecb=L}),define(ke[276],Se([1,0,277,388,389,62,2,14,390]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;const m=!1;function A(n,r,a,t,s,d){const l=d.environment.useHostProxy,c=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:f=>n.resolveProxy(f),lookupProxyAuthorization:u.bind(void 0,t,s,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(r),addCertificatesV2:()=>v(r),log:t,getLogLevel:()=>{const f=t.getLevel();switch(f){case b.LogLevel.Trace:return y.LogLevel.Trace;case b.LogLevel.Debug:return y.LogLevel.Debug;case b.LogLevel.Info:return y.LogLevel.Info;case b.LogLevel.Warning:return y.LogLevel.Warning;case b.LogLevel.Error:return y.LogLevel.Error;case b.LogLevel.Off:return y.LogLevel.Off;default:return p(f)}function p(k){return t.error("Unknown log level",k),y.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const f=[];if(d.remote.isRemote&&f.push((0,y.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),f.push(p)}return(await Promise.all(f)).flat()},env:process.env},E=(0,y.createProxyResolver)(h),I=C(h,E);return w(a,I)}e.$Jgc=A;function C(n,r){return{http:Object.assign(D,(0,y.createHttpPatch)(n,D,r)),https:Object.assign(T,(0,y.createHttpPatch)(n,T,r)),net:Object.assign(R,(0,y.createNetPatch)(n,R)),tls:Object.assign(g,(0,y.createTlsPatch)(n,g))}}function $(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",m)&&!!r.get("systemCertificates")}function v(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",m)&&!!r.get("systemCertificates")}const S=new Map;function w(n,r){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,s=t._load;t._load=function(l,c,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return s.apply(this,arguments);const E=a.findSubstr(L.URI.file(c.filename));let I=S.get(E);if(I||S.set(E,I={}),!I[l]){const f=r[l];I[l]={...f}}return I[l]}})}async function u(n,r,a,t,s,d,l,c){const h=t[d];l&&(t[d]=l),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const E=l||h,I=Array.isArray(E)?E:typeof E=="string"?[E]:[];if(i(r,I,s),I.some(f=>/^(Negotiate|Kerberos)( |$)/i.test(f))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const f=await new Promise((z,M)=>{me(["kerberos"],z,M)}),p=new URL(d),k=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${k}`),"Negotiate "+await(await f.initializeClient(k)).step("")}catch(f){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",f)}}let o=!1;function i(n,r,a){o||!r.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[278],Se([1,0,131]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function T(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function g(R){return new D.$Rm(T(R))}e.$Gr=g}),define(ke[141],Se([1,0,225,18,2,3,5,37,32,17,43,180,39]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=e.$AE=e.$zE=e.EditorsOrder=e.$yE=e.CloseDirection=e.$xE=e.$wE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.EditorInputCapabilities=e.$nE=e.SaveReason=e.Verbosity=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=void 0,e.$aE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$cE="workbench.editor.sidebysideEditor",e.$dE="workbench.editors.textDiffEditor",e.$eE="workbench.editors.binaryResourceDiffEditor";var v;(function(he){he[he.PROGRAMMATIC=1]="PROGRAMMATIC",he[he.USER=2]="USER",he[he.EDIT=3]="EDIT",he[he.NAVIGATION=4]="NAVIGATION",he[he.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var S;(function(he){he[he.IDENTICAL=1]="IDENTICAL",he[he.SIMILAR=2]="SIMILAR",he[he.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function w(he){const K=he;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$fE=w;function u(he,K,U){for(const ie of U.visibleEditorPanes)if(ie.group.id===K&&he.matches(ie.input))return ie.getViewState()}e.$gE=u;function o(he){if(E(he))return!1;const K=he;return g.URI.isUri(K?.resource)}e.$hE=o;function i(he){if(E(he))return!1;const K=he;return K?.original!==void 0&&K.modified!==void 0}e.$iE=i;function n(he){if(E(he))return!1;const K=he;return Array.isArray(K?.resources)}e.$jE=n;function r(he){if(E(he)||i(he))return!1;const K=he;return K?.primary!==void 0&&K.secondary!==void 0}e.$kE=r;function a(he){if(E(he))return!1;const K=he;return K?K.resource===void 0||K.resource.scheme===m.Schemas.untitled||K.forceUntitled===!0:!1}e.$lE=a;function t(he){if(E(he))return!1;const K=he;return g.URI.isUri(K?.base?.resource)&&g.URI.isUri(K?.input1?.resource)&&g.URI.isUri(K?.input2?.resource)&&g.URI.isUri(K?.result?.resource)}e.$mE=t;var s;(function(he){he[he.SHORT=0]="SHORT",he[he.MEDIUM=1]="MEDIUM",he[he.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var d;(function(he){he[he.EXPLICIT=1]="EXPLICIT",he[he.AUTO=2]="AUTO",he[he.FOCUS_CHANGE=3]="FOCUS_CHANGE",he[he.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class l{constructor(){this.a=new Map}registerSource(K,U){let ie=this.a.get(K);return ie||(ie={source:K,label:U},this.a.set(K,ie)),ie.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$nE=new l;var c;(function(he){he[he.None=0]="None",he[he.Readonly=2]="Readonly",he[he.Untitled=4]="Untitled",he[he.Singleton=8]="Singleton",he[he.RequiresTrust=16]="RequiresTrust",he[he.CanSplitInGroup=32]="CanSplitInGroup",he[he.ForceDescription=64]="ForceDescription",he[he.CanDropIntoEditor=128]="CanDropIntoEditor",he[he.MultipleEditors=256]="MultipleEditors",he[he.Scratchpad=512]="Scratchpad",he[he.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class h extends R.$Rc{}e.$oE=h;function E(he){return he instanceof h}e.$pE=E;function I(he){const K=he;return g.URI.isUri(K?.preferredResource)}function f(he){const K=he;return E(K?.primary)&&E(K?.secondary)}e.$qE=f;function p(he){const K=he;return E(K?.modified)&&E(K?.original)}e.$rE=p;function k(he,K,U,ie,be){return Ee(ie,[(0,C.$Fi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const H={...U,limits:{size:Number.MAX_VALUE}};he.openEditor(K,H)}}),(0,C.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$sE=k;function P(he){return E(he?.editor)}e.$tE=P;function j(he){const K=he;return P(he)&&K?.group!==void 0}e.$uE=j;function z(he){const K=he;return typeof K?.groupId=="number"&&E(K.editor)}e.$vE=z;var M;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.REPLACE=1]="REPLACE",he[he.MOVE=2]="MOVE",he[he.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var F;(function(he){he[he.GROUP_ACTIVE=0]="GROUP_ACTIVE",he[he.GROUP_INDEX=1]="GROUP_INDEX",he[he.GROUP_LABEL=2]="GROUP_LABEL",he[he.GROUP_LOCKED=3]="GROUP_LOCKED",he[he.EDITOR_OPEN=4]="EDITOR_OPEN",he[he.EDITOR_CLOSE=5]="EDITOR_CLOSE",he[he.EDITOR_MOVE=6]="EDITOR_MOVE",he[he.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",he[he.EDITOR_LABEL=8]="EDITOR_LABEL",he[he.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",he[he.EDITOR_PIN=10]="EDITOR_PIN",he[he.EDITOR_STICKY=11]="EDITOR_STICKY",he[he.EDITOR_DIRTY=12]="EDITOR_DIRTY",he[he.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var N;(function(he){he[he.PRIMARY=1]="PRIMARY",he[he.SECONDARY=2]="SECONDARY",he[he.BOTH=3]="BOTH",he[he.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class O{getOriginalUri(K,U){if(!K)return;if(t(K))return e.$xE.getOriginalUri(K.result,U);if(U?.supportSideBySide){const{primary:be,secondary:H}=this.a(K);if(be&&H){if(U?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===N.ANY)return this.getOriginalUri(be,{filterByScheme:U.filterByScheme})??this.getOriginalUri(H,{filterByScheme:U.filterByScheme});K=U.supportSideBySide===N.PRIMARY?be:H}}if(i(K)||n(K)||r(K)||t(K))return;const ie=I(K)?K.preferredResource:K.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}a(K){return f(K)||r(K)?{primary:K.primary,secondary:K.secondary}:p(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,U){if(!K)return;if(t(K))return e.$xE.getCanonicalUri(K.result,U);if(U?.supportSideBySide){const{primary:be,secondary:H}=this.a(K);if(be&&H){if(U?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===N.ANY)return this.getCanonicalUri(be,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:U.filterByScheme});K=U.supportSideBySide===N.PRIMARY?be:H}}if(i(K)||n(K)||r(K)||t(K))return;const ie=K.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}b(K,U){if(Array.isArray(U)){if(U.some(ie=>K.scheme===ie))return K}else if(U===K.scheme)return K}}var W;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.KEYBOARD=1]="KEYBOARD",he[he.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function x(he,K,U,ie){if(!he.isSticky(K))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return U===W.MOUSE||U===W.KEYBOARD;case"mouse":return U===W.MOUSE;case"keyboard":return U===W.KEYBOARD}return!1}e.$wE=x,e.$xE=new O;var ce;(function(he){he[he.LEFT=0]="LEFT",he[he.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(K){const U=this.a=K.get(L.$Uh);for(const[ie,be]of this.c)this.e(ie,be,U);this.c.clear()}e(K,U,ie){const be=ie.createInstance(U);this.d.set(K,be)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,T.$Nf)(this.b)}registerEditorSerializer(K,U){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,U,this.a):this.c.set(K,U),(0,R.$Pc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}b.$mn.add(e.$aE.EditorFactory,new Y);async function G(he,K,U){return!he||!he.length?[]:await Promise.all(he.map(async ie=>{const be=g.URI.revive(ie.fileUri);if(!be){U.info("Cannot resolve the path because it is not valid.",ie);return}if(!await K.canHandleResource(be)){U.info("Cannot resolve the path because it cannot be handled",ie);return}let _=ie.exists,Z=ie.type;if(typeof _!="boolean"||typeof Z!="number")try{Z=(await K.stat(be)).isDirectory?y.FileType.Directory:y.FileType.Unknown,_=!0}catch(re){U.error(re),_=!1}if(!_&&ie.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ie);return}if(Z===y.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ie);return}const $e={...ie.options,pinned:!0};return _?{resource:be,options:$e}:{resource:be,options:$e,forceUntitled:!0}}))}e.$yE=G;var J;(function(he){he[he.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",he[he.SEQUENTIAL=1]="SEQUENTIAL"})(J||(e.EditorsOrder=J={}));function le(he){const K=he;if(!K)return!1;const U=K;if(U.modified)return le(U.modified);const ie=K;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$zE=le;function Q(he){return(0,A.$Hi)(he)}e.$AE=Q;function Ee(he,K,U){const ie=(0,A.$Ii)(he,K);return ie.forceMessage=U?.forceMessage,ie.forceSeverity=U?.forceSeverity,ie.allowDialog=U?.allowDialog,ie}e.$BE=Ee}),define(ke[279],Se([1,0,4,226,5,3,28,37,19,24,78,265]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IE=e.$HE=e.ViewContentGroups=e.$GE=e.$FE=e.ViewContainerLocation=e.Extensions=e.$EE=e.$DE=e.$CE=void 0,e.$CE="views",e.$DE=(0,T.localize)(0,null),e.$EE=(0,C.$aw)("default-view-icon",A.$1j.window,(0,T.localize)(1,null));var $;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$FE=[0,1,2];function S(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$GE=S;class w extends R.$Rc{constructor(){super(...arguments),this.c=this.B(new D.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.$Qb)([...this.g.values()])}registerViewContainer(d,l,c){const h=this.get(d.id);if(h)return h;const E=d;return E.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,L.$wc)(this.g,l,[]).push(E),c?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:l}),E}deregisterViewContainer(d){for(const l of this.g.keys()){const c=this.g.get(l),h=c?.indexOf(d);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(c=>c?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}b.$mn.add($.ViewContainersRegistry,new w);var u;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(u||(e.ViewContentGroups=u={}));function o(s,d){const l=s.group??u.More,c=d.group??u.More;return l!==c?l.localeCompare(c):(s.order??5)-(d.order??5)}class i extends R.$Rc{constructor(){super(...arguments),this.c=this.B(new D.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Fc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:c})=>this.r(l,c)),this.c.fire(d)}deregisterViews(d,l){const c=this.s(d,l);c.length&&this.f.fire({views:c,viewContainer:l})}moveViews(d,l){for(const c of this.m.keys())if(c!==l){const h=this.s(d,c);h.length&&(this.r(h,l),this.g.fire({views:h,from:c,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const c=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(c)return c}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,R.$Pc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const c=new Map;for(const[h,E]of l)this.n.add(d,E),c.set(h,(0,R.$Pc)(()=>{this.n.delete(d,E),this.h.fire(d)}));return this.h.fire(d),c}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,c=>l.push(c)),l.sort(o)}r(d,l){let c=this.m.get(l);c||(c=[],this.m.set(l,c),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(2,null,h.id));c.push(h)}}s(d,l){const c=this.m.get(l);if(!c)return[];const h=[],E=[];for(const I of c)d.includes(I)?h.push(I):E.push(I);return h.length&&(E.length?this.m.set(l,E):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}b.$mn.add($.ViewsRegistry,new i),e.$HE=(0,g.$Vh)("viewsService"),e.$IE=(0,g.$Vh)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class a{constructor(d,l){this.c=!1,this.d=!1,(0,m.$dn)(this,d),this.d=!!l,this.resolve=async c=>{if(l&&!this.c){const h=await l(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JE=a;class t extends Error{constructor(d){super((0,T.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$KE=t}),define(ke[280],Se([1,0,2,29,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$$E=e.$0E=void 0;function R(m){return!!m&&typeof m=="object"&&"uri"in m&&m.uri instanceof D.URI&&"version"in m&&typeof m.version=="number"&&"ranges"in m&&Array.isArray(m.ranges)&&m.ranges.every(T.$zs.isIRange)}e.$0E=R;function L(m){return!!m&&typeof m=="object"&&"documents"in m&&Array.isArray(m.documents)&&m.documents.every(R)}e.$$E=L;var b;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var y;(function(m){m[m.Action=1]="Action",m[m.Toolbar=2]="Toolbar"})(y||(e.InteractiveSessionCopyKind=y={})),e.$_E=(0,g.$Vh)("IChatService")}),define(ke[142],Se([1,0,4,12,227]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new D.$Rd,this.n=new D.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,y,m,A){const C={command:b};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.s("request",C),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const v=this.f.get(C.seq);if(v){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,A,b)};v(S)}},A)}return m&&this.f.set(C.seq,m),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,y){return b.type!=="event"||y.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,T.$Yg)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const y=b,m=this.f.get(y.request_seq);m&&(this.f.delete(y.request_seq),m(y));break}}}}s(b,y){y.type=b,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((y,m)=>b.set(m,y)),await(0,T.$Yg)(500),b.forEach((y,m)=>{y({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.f.delete(m)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$0cb=R}),define(ke[281],Se([1,0,228,45,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$kH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$jH=e.MemoryRangeType=e.$iH=e.State=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$fG="workbench.view.debug",e.$gG="workbench.debug.variablesView",e.$hG="workbench.debug.watchExpressionsView",e.$iG="workbench.debug.callStackView",e.$jG="workbench.debug.loadedScriptsView",e.$kG="workbench.debug.breakPointsView",e.$lG="workbench.debug.disassemblyView",e.$mG="workbench.panel.repl",e.$nG="workbench.panel.repl.view",e.$oG=new T.$aj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$pG=new T.$aj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$qG=new T.$aj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$rG="debugUx",e.$sG=new T.$aj(e.$rG,"default",{type:"string",description:D.localize(3,null)}),e.$tG=new T.$aj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$uG=new T.$aj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$vG=new T.$aj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$wG=new T.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$xG=new T.$aj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$yG=new T.$aj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$zG=new T.$aj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$AG=new T.$aj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$BG=new T.$aj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$CG=new T.$aj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$DG=new T.$aj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$EG=new T.$aj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$FG=new T.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$GG=new T.$aj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$HG=new T.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$IG=new T.$aj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$JG=new T.$aj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$KG=new T.$aj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$LG=new T.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$MG=new T.$aj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$NG=new T.$aj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$OG=new T.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$PG=new T.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$QG=new T.$aj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$RG=new T.$aj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$SG=new T.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$TG=new T.$aj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$UG=new T.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$VG=new T.$aj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$WG=new T.$aj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$XG=new T.$aj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$YG=new T.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$ZG=new T.$aj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$1G=new T.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$2G=new T.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$3G=new T.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$4G=new T.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$5G=new T.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$6G=new T.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$7G=new T.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$8G=new T.$aj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$9G=new T.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$0G=new T.$aj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$$G=new T.$aj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$_G=new T.$aj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$aH=new T.$aj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$bH=new T.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$cH=new T.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const R=$=>D.localize(52,null,$);e.$dH=R,e.$eH="editor.contrib.debug",e.$fH="editor.contrib.breakpoint",e.$gH="debug",e.$hH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var L;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(L||(e.State=L={}));function b($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$iH=b;var y;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.$jH="vscode-debug-memory";var m;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var A;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$kH=(0,g.$Vh)("debugService");var C;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(ke[282],Se([1,0,13,2,16,24,17,29,21,19]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const A=/{([^}]+)}/g;function C(I,f,p){return I.replace(A,function(k,P){return f&&P.length>0&&P[0]!=="_"?k:p&&p.hasOwnProperty(P)?p[P]:k})}e.$eF=C;function $(I){const f={};for(const p of Object.keys(I))p.startsWith("!")||(f[p]=I[p]);return f}e.$fF=$;function v(I){return I.configuration.request==="attach"&&!S(I)&&(!I.parentSession||v(I.parentSession))}e.$gF=v;function S(I){let f=I.configuration.type;if(f)return f==="vslsShare"&&(f=I.configuration.adapterProxy.configuration.type),(0,D.$6e)(f,"extensionhost")||(0,D.$6e)(f,"pwa-extensionhost")?I:I.parentSession?S(I.parentSession):void 0}e.$hF=S;function w(I){return I.type&&(I.label||I.program||I.runtime)}e.$iF=w;function u(I,f,p){let k,P=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=j.exec(I);){const M=z.index+1,F=M+z[0].length;if(M<=f&&F>=p){k=z[0],P=M;break}}if(k){const M=/\w+/g;let F=null;for(;(F=M.exec(k))&&!(F.index+1+P+F[0].length>=p););F&&(k=k.substring(0,M.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}e.$jF=u;async function o(I,f,p,k){if(I.evaluatableExpressionProvider.has(f)){const P=I.evaluatableExpressionProvider.ordered(f),j=(0,m.$Gb)(await Promise.all(P.map(async z=>{try{return await z.provideEvaluatableExpression(f,p,k??y.CancellationToken.None)}catch{return}})));if(j.length>0){let z=j[0].expression;const M=j[0].range;return z||(z=f.getLineContent(p.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:z}}}else{const P=f.getLineContent(p.lineNumber),{start:j,end:z}=u(P,p.column,p.column),M=P.substring(j-1,z);return{matchingExpression:M,range:new b.$zs(p.lineNumber,j,p.lineNumber,j+M.length)}}return null}e.$kF=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(I){return!!(I&&I.match(i))}e.$lF=n;function r(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(n(I.path))return T.URI.parse(I.path);if((0,g.$hc)(I.path))return T.URI.file(I.path)}return I.path}function a(I){if(typeof I.path=="object"){const f=T.URI.revive(I.path);if(f)return f.scheme===L.Schemas.file?f.fsPath:f.toString()}return I.path}function t(I,f){const p=f?r:a,k=(0,R.$an)(I);return d(k,(P,j)=>{P&&j&&(j.path=p(j))}),k}e.$mF=t;function s(I,f){const p=f?r:a,k=(0,R.$an)(I);return d(k,(P,j)=>{!P&&j&&(j.path=p(j))}),k}e.$nF=s;function d(I,f){switch(I.type){case"event":{const p=I;switch(p.event){case"output":f(!1,p.body.source);break;case"loadedSource":f(!1,p.body.source);break;case"breakpoint":f(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=I;switch(p.command){case"setBreakpoints":f(!0,p.arguments.source);break;case"breakpointLocations":f(!0,p.arguments.source);break;case"source":f(!0,p.arguments.source);break;case"gotoTargets":f(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(k=>f(!1,k));break;default:break}break}case"response":{const p=I;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(k=>f(!1,k.source));break;case"loadedSources":p.body.sources.forEach(k=>f(!1,k));break;case"scopes":p.body.scopes.forEach(k=>f(!1,k.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(k=>f(!1,k.source));break;case"setBreakpoints":p.body.breakpoints.forEach(k=>f(!1,k.source));break;case"disassemble":p.body?.instructions.forEach(P=>f(!1,P.location));break;default:break}break}}}function l(I){return I.filter(f=>!f.presentation?.hidden).sort((f,p)=>f.presentation?p.presentation?f.presentation.group?p.presentation.group?f.presentation.group!==p.presentation.group?f.presentation.group.localeCompare(p.presentation.group):c(f.presentation.order,p.presentation.order):-1:p.presentation.group?1:c(f.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$oF=l;function c(I,f){return typeof I!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:I-f}async function h(I,f){const p=I.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(p!=="none"&&(await f.saveAll(),p==="allEditorsInActiveGroup")){const k=f.activeEditorPane;k&&k.input.resource?.scheme===L.Schemas.untitled&&await f.save({editor:k.input,groupId:k.group.id})}await I.reloadConfiguration()}e.$pF=h;const E=(I,f)=>!I||!f?I===f:I.name===f.name&&I.path===f.path&&I.sourceReference===f.sourceReference;e.$qF=E}),define(ke[283],Se([1,0,50,62,24,16,11,13,31,229,142]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=e.$kgc=e.$jgc=e.$igc=e.$hgc=void 0;class C extends A.$0cb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",n=>this.w(n))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const r=this.r.toString("utf8",0,i).split(C.b);for(const a of r){const t=a.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$hgc=C;class $ extends C{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.m.fire(r):i(r)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$igc=$;class v extends ${constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$jgc=v;class S extends ${constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.path,o)}}e.$kgc=S;class w extends C{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(R.$hc(o)){if(!await y.Promises.exists(o))throw new Error(m.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(m.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=g.$dn(g.$an(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const s=D.fork(i[0],i.slice(1),t);if(!s.pid)throw new Error(m.localize(2,null,i[0]));this.x=s}else throw new Error(m.localize(3,null));else{const a={env:r};n.cwd&&(a.cwd=n.cwd),this.x=D.spawn(o,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(r){this.m.fire(r)}}async stopSession(){return this.x?(await this.u(),L.$i?new Promise((o,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,a,t){if(r)return i(r)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=R.$ic(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(R.$hc(o.program)?n.program=o.program:n.program=R.$ic(i,o.program)),o.args&&(n.args=o.args);const r=o;return r.win&&(n.win=w.A(r.win,i)),r.winx86&&(n.winx86=w.A(r.winx86,i)),r.windows&&(n.windows=w.A(r.windows,i)),r.osx&&(n.osx=w.A(r.osx,i)),r.linux&&(n.linux=w.A(r.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const l of o)if(l.contributes){const c=l.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&b.$6e(h.type,i)).forEach(h=>{const E=w.A(h,l.extensionLocation.fsPath);n=g.$dn(n,E,l.isBuiltin)})}let r;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:L.$i?r=n.win||n.windows:L.$j?r=n.osx:L.$k&&(r=n.linux),r=r||n;const a=r.program||n.program,t=r.args||n.args,s=r.runtime||n.runtime,d=r.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$lgc=w}),define(ke[284],Se([1,0,50,33,11]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=void 0;function R(m,A){return new Promise((C,$)=>{let v="";const S=D.spawn(m,A);S.pid&&S.stdout.on("data",w=>{v+=w.toString()}),S.on("error",w=>{$(w)}),S.on("close",w=>{C(v)})})}async function L(m){if(m)if(g.$i){const A=await new Promise((C,$)=>{me(["@vscode/windows-process-tree"],C,$)});return new Promise(C=>{A.getProcessTree(m,$=>{C(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(m)]).then(A=>{const C=A.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$mgc=L;var b;(function(m){m[m.cmd=0]="cmd",m[m.powershell=1]="powershell",m[m.bash=2]="bash"})(b||(b={}));function y(m,A,C,$,v){m=m.trim().toLowerCase();let S;m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0?S=1:m.indexOf("cmd.exe")>=0?S=0:m.indexOf("bash")>=0?S=2:g.$i?S=0:S=2;let w,u=" ";switch(S){case 1:if(w=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),$){const o=(0,T.$7f)($);o&&(u+=`${o}:; `),u+=`cd ${w($)}; `}if(v)for(const o in v){const i=v[o];i===null?u+=`Remove-Item env:${o}; `:u+=`\${env:${o}}='${i}'; `}if(A.length>0){const o=A.shift(),i=C?o:w(o);u+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)u+=n==="<"||n===">"||C?n:w(n),u+=" "}break;case 0:if(w=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),$){const o=(0,T.$7f)($);o&&(u+=`${o}: && `),u+=`cd ${w($)} && `}if(v){u+='cmd /C "';for(const o in v){let i=v[o];i===null?u+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),u+=`set "${o}=${i}" && `)}}for(const o of A)u+=o==="<"||o===">"||C?o:w(o),u+=" ";v&&(u+='"');break;case 2:{w=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if($&&(u+=`cd ${w($)} ; `),v){u+="/usr/bin/env";for(const i in v){const n=v[i];n===null?u+=` -u ${o(i)}`:u+=` ${o(`${i}=${n}`)}`}u+=" "}for(const i of A)u+=i==="<"||i===">"||C?i:w(i),u+=" ";break}}return u}e.$ngc=y}),define(ke[111],Se([1,0,22,34,51,100,17,16,11,45]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.$DI=e.$CI=e.$BI=e.CellStatusbarAlignment=e.$AI=e.$zI=e.$yI=e.NotebookEditorPriority=e.$xI=e.$wI=e.$vI=e.$uI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$tI=e.$sI=e.$rI=e.$qI=e.CellKind=e.$pI=e.$oI=e.$nI=void 0,e.$nI="workbench.editor.notebook",e.$oI="workbench.editor.notebookTextDiffEditor",e.$pI="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$qI=["application/json","application/javascript","text/html","image/svg+xml",R.$Vr.latex,R.$Vr.markdown,"image/png","image/jpeg",R.$Vr.text],e.$rI=[R.$Vr.latex,R.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Vr.text],e.$sI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$tI="_notAvailable";var C;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var $;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var v;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var S;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var w;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var u;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var o;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var i;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(O){O.scheme=L.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],x=new RegExp(`^[${W.join("")}]+`),ce=7;function Y(he,K){const U=K.toString(ce),be=`${U.length<W.length?W[U.length-1]:"z"}${U}s${(0,D.$ze)(D.$fe.fromString(he.scheme),!0,!0)}`;return he.with({scheme:O.scheme,fragment:be})}O.generate=Y;function G(he){if(he.scheme!==O.scheme)return;const K=he.fragment.indexOf("s");if(K<0)return;const U=parseInt(he.fragment.substring(0,K).replace(x,""),ce),ie=(0,D.$ye)(he.fragment.substring(K+1)).toString();if(!isNaN(U))return{handle:U,notebook:he.with({scheme:ie,fragment:null})}}O.parse=G;function J(he,K){return he.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${he.scheme!==L.Schemas.file?he.scheme:""}`})}O.generateCellOutputUri=J;function le(he){if(he.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!K)return;const U=K[1]&&K[1]!==""?K[1]:void 0,ie=K[2];return{outputId:U,notebook:he.with({scheme:ie||L.Schemas.file,fragment:null})}}O.parseCellOutputUri=le;function Q(he,K,U){return O.generate(he,K).with({scheme:U})}O.generateCellPropertyUri=Q;function Ee(he,K){if(he.scheme===K)return O.parse(he.with({scheme:O.scheme}))}O.parseCellPropertyUri=Ee})(n||(e.CellUri=n={}));const r=O=>y.$i?O.replace(/\//g,"\\"):O;class a{constructor(W=[],x=e.$qI){this.e=x,this.d=[...new Set(W)].map(ce=>({pattern:ce,matches:T.$Cj(r(ce))}))}sort(W){const x=new Map(g.Iterable.map(W,Y=>[Y,r(Y)]));let ce=[];for(const{matches:Y}of this.d)for(const[G,J]of x)if(Y(J)){ce.push(G),x.delete(G);break}return x.size&&(ce=ce.concat([...x.keys()].sort((Y,G)=>this.e.indexOf(Y)-this.e.indexOf(G)))),ce}prioritize(W,x){const ce=this.f(W);if(ce===-1){this.d.unshift({pattern:W,matches:T.$Cj(r(W))});return}const Y=new Set(x.map(J=>this.f(J,ce)));Y.delete(-1);const G=Array.from(Y).sort();this.d.splice(ce+1,0,...G.map(J=>this.d[J]));for(let J=G.length-1;J>=0;J--)this.d.splice(G[J],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,x=this.d.length){const ce=r(W);for(let Y=0;Y<x;Y++)if(this.d[Y].matches(ce))return Y;return-1}}e.$uI=a;function t(O,W,x,ce=(Y,G)=>Y===G){const Y=[];function G(Q,Ee,he){if(Ee===0&&he.length===0)return;const K=Y[Y.length-1];K&&K.start+K.deleteCount===Q?(K.deleteCount+=Ee,K.toInsert.push(...he)):Y.push({start:Q,deleteCount:Ee,toInsert:he})}let J=0,le=0;for(;;){if(J===O.length){G(J,0,W.slice(le));break}if(le===W.length){G(J,O.length-J,[]);break}const Q=O[J],Ee=W[le];if(ce(Q,Ee)){J+=1,le+=1;continue}x(Ee)?(G(J,1,[]),J+=1):(G(J,0,[Ee]),le+=1)}return Y}e.$vI=t,e.$wI=new m.$aj("notebookEditorCursorAtBoundary","none"),e.$xI=new m.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function d(O){const W=O;return!!((typeof W.include=="string"||T.$Dj(W.include))&&(typeof W.exclude=="string"||T.$Dj(W.exclude)))}e.$yI=d;function l(O,W,x){if(Array.isArray(O.viewType)&&O.viewType.indexOf(W)>=0||O.viewType===W)return!0;if(O.filenamePattern){const ce=d(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,Y=d(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$Bj(ce,(0,b.$mc)(x.fsPath).toLowerCase()))return!(Y&&T.$Bj(Y,(0,b.$mc)(x.fsPath).toLowerCase()))}return!1}e.$zI=l,e.$AI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var c;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class h{static{this.d="notebook/"}static create(W){return`${h.d}${W}`}static parse(W){if(W.startsWith(h.d))return W.substring(h.d.length)}}e.$BI=h;function E(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$CI=E;const I=new TextDecoder;function f(O){const W=[];let x=!1;for(const J of O)(W.length===0||x)&&(W.push(J),x=!0);let ce=P(W);const Y=D.$fe.concat(W.map(J=>D.$fe.wrap(J))),G=N(Y);return ce=ce||G.byteLength!==Y.byteLength,{data:G,didCompression:ce}}e.$DI=f,e.$EI=`${String.fromCharCode(27)}[A`;const p=e.$EI.split("").map(O=>O.charCodeAt(0)),k=10;function P(O){let W=!1;return O.forEach((x,ce)=>{if(ce===0||x.length<e.$EI.length)return;const Y=O[ce-1],G=x.subarray(0,e.$EI.length);if(G[0]===p[0]&&G[1]===p[1]&&G[2]===p[2]){const J=Y.lastIndexOf(k);if(J===-1)return;W=!0,O[ce-1]=Y.subarray(0,J),O[ce]=x.subarray(e.$EI.length)}}),W}function j(O){let W=O;do O=W,W=O.replace(/[^\n]\x08/gm,"");while(W.length<O.length);return O}function z(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const W=O.match(/^(.*)\r+/m)[1];let x=O.match(/\r+(.*)$/m)[1];x=x+W.slice(x.length,W.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return O}const M="\b".charCodeAt(0),F="\r".charCodeAt(0);function N(O){return!O.buffer.includes(M)&&!O.buffer.includes(F)?O:D.$fe.fromString(z(j(I.decode(O.buffer))))}}),define(ke[7],Se([1,0,19,8,80,28,100,13,18,2,30,26,32,64,111]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S){"use strict";var w,u,o,i,n,r,a,t,s,d,l,c,h,E,I,f,p,k;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$oM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.TestRunProfileKind=e.TestResultState=e.$7L=e.$6L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$5L=e.NotebookVariablesRequestKind=e.$4L=e.$3L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$2L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.ColorThemeKind=e.$VL=e.$UL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$TL=e.DebugConsoleMode=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$NL=e.$ML=e.FileChangeType=e.$LL=e.$KL=e.$JL=e.$IL=e.InlineCompletionTriggerKind=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.ConfigurationTarget=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lL=e.ViewBadge=e.ProgressLocation=e.$kL=e.$jL=e.TaskScope=e.ShellQuoting=e.$iL=e.$hL=e.$gL=e.TaskPanelKind=e.TaskRevealKind=e.$fL=e.TerminalLocation=e.$eL=e.$dL=e.$cL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bL=e.$aL=e.$_K=e.$$K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$0K=e.StatusBarAlignment=e.ViewColumn=e.$9K=e.$8K=e.$7K=e.$6K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5K=e.$4K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.LanguageStatusSeverity=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.CodeActionTriggerKind=e.$RK=e.$QK=e.SymbolTag=e.SymbolKind=e.$PK=e.DocumentHighlightKind=e.$OK=e.$NK=e.$MK=e.$LK=e.DiagnosticSeverity=e.DiagnosticTag=e.$KK=e.$JK=e.FileEditType=e.$IK=e.$HK=e.$GK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(q){return Object.assign(q,{apply:function(...ve){if(ve.length===0)return Reflect.construct(q,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(q,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(q,[]);{const[Re,...Xe]=ve;return Reflect.construct(q,Xe,Re.constructor)}}})}var j;(function(q){q[q.Top=0]="Top",q[q.Bottom=1]="Bottom"})(j||(e.TerminalOutputAnchor=j={}));var z;(function(q){q[q.TerminalCommand=0]="TerminalCommand",q[q.Opener=1]="Opener",q[q.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let M=w=class{static from(...V){let ve=V;return new w(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$zK=M,e.$zK=M=w=He([P],M);let F=u=class{static Min(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Re=1;Re<V.length;Re++){const Xe=V[Re];Xe.isBefore(ve)&&(ve=Xe)}return ve}static Max(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Re=1;Re<V.length;Re++){const Xe=V[Re];Xe.isAfter(ve)&&(ve=Xe)}return ve}static isPosition(V){if(!V)return!1;if(V instanceof u)return!0;const{line:ve,character:Re}=V;return typeof ve=="number"&&typeof Re=="number"}static of(V){if(V instanceof u)return V;if(this.isPosition(V))return new u(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,ve){if(V<0)throw(0,T.$6)("line must be non-negative");if(ve<0)throw(0,T.$6)("character must be non-negative");this.c=V,this.e=ve}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,ve=0){if(V===null||ve===null)throw(0,T.$6)();let Re;return typeof V>"u"?Re=0:typeof V=="number"?Re=V:(Re=typeof V.lineDelta=="number"?V.lineDelta:0,ve=typeof V.characterDelta=="number"?V.characterDelta:0),Re===0&&ve===0?this:new u(this.line+Re,this.character+ve)}with(V,ve=this.character){if(V===null||ve===null)throw(0,T.$6)();let Re;return typeof V>"u"?Re=this.line:typeof V=="number"?Re=V:(Re=typeof V.line=="number"?V.line:this.line,ve=typeof V.character=="number"?V.character:this.character),Re===this.line&&ve===this.character?this:new u(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$AK=F,e.$AK=F=u=He([P],F);let N=o=class{static isRange(V){return V instanceof o?!0:V?F.isPosition(V.start)&&F.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,ve,Re,Xe){let it,ct;if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Xe=="number"?(it=new F(V,ve),ct=new F(Re,Xe)):F.isPosition(V)&&F.isPosition(ve)&&(it=F.of(V),ct=F.of(ve)),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this.c=it,this.e=ct):(this.c=ct,this.e=it)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):F.isPosition(V)?!(F.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const ve=F.Max(V.start,this.c),Re=F.Min(V.end,this.e);if(!ve.isAfter(Re))return new o(ve,Re)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ve=F.Min(V.start,this.c),Re=F.Max(V.end,this.end);return new o(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,ve=this.end){if(V===null||ve===null)throw(0,T.$6)();let Re;return V?F.isPosition(V)?Re=V:(Re=V.start||this.start,ve=V.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new o(Re,ve)}toJSON(){return[this.start,this.end]}};e.$BK=N,e.$BK=N=o=He([P],N);let O=i=class extends N{static isSelection(V){return V instanceof i?!0:V?N.isRange(V)&&F.isPosition(V.anchor)&&F.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,ve,Re,Xe){let it,ct;if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Xe=="number"?(it=new F(V,ve),ct=new F(Re,Xe)):F.isPosition(V)&&F.isPosition(ve)&&(it=F.of(V),ct=F.of(ve)),!it||!ct)throw new Error("Invalid arguments");super(it,ct),this.f=it,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$CK=O,e.$CK=O=i=He([P],O);const W=q=>{if(typeof q!="string"||q.length===0||!/^[0-9A-Za-z_\-]+$/.test(q))throw(0,T.$6)("connectionToken")};class x{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve,Re){if(typeof V!="string"||V.length===0)throw(0,T.$6)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,T.$6)("port");typeof Re<"u"&&W(Re),this.host=V,this.port=Math.round(ve),this.connectionToken=Re}}e.$DK=x;class ce{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve){this.makeConnection=V,this.connectionToken=ve,typeof ve<"u"&&W(ve)}}e.$EK=ce;class Y extends Error{static NotAvailable(V,ve){return new Y(V,v.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(V){return new Y(V,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,ve=v.RemoteAuthorityResolverErrorCode.Unknown,Re){super(V),this._message=V,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,Y.prototype)}}e.$FK=Y;var G;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(G||(e.EndOfLine=G={}));var J;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let le=n=class{static isTextEdit(V){return V instanceof n?!0:V?N.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ve){return new n(V,ve)}static insert(V,ve){return n.replace(new N(V,V),ve)}static delete(V){return n.replace(V,"")}static setEndOfLine(V){const ve=new n(new N(new F(0,0),new F(0,0)),"");return ve.newEol=V,ve}get range(){return this.c}set range(V){if(V&&!N.isRange(V))throw(0,T.$6)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,T.$6)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,T.$6)("newEol");this.f=V}constructor(V,ve){this.c=V,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$GK=le,e.$GK=le=n=He([P],le);let Q=r=class{static isNotebookCellEdit(V){return V instanceof r?!0:V?_t.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,ve){return new r(V,ve)}static insertCells(V,ve){return new r(new _t(V,V),ve)}static deleteCells(V){return new r(V,[])}static updateCellMetadata(V,ve){const Re=new r(new _t(V,V),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(V){const ve=new r(new _t(0,0),[]);return ve.newNotebookMetadata=V,ve}constructor(V,ve){this.range=V,this.newCells=ve}};e.$HK=Q,e.$HK=Q=r=He([P],Q);class Ee{static isSnippetTextEdit(V){return V instanceof Ee?!0:V?N.isRange(V.range)&&U.isSnippetString(V.snippet):!1}static replace(V,ve){return new Ee(V,ve)}static insert(V,ve){return Ee.replace(new N(V,V),ve)}constructor(V,ve){this.range=V,this.snippet=ve}}e.$IK=Ee;var he;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(he||(e.FileEditType=he={}));let K=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,ve,Re,Xe){this.c.push({_type:1,from:V,to:ve,options:Re,metadata:Xe})}createFile(V,ve,Re){this.c.push({_type:1,from:void 0,to:V,options:ve,metadata:Re})}deleteFile(V,ve,Re){this.c.push({_type:1,from:V,to:void 0,options:ve,metadata:Re})}e(V,ve,Re){this.c.push({_type:3,metadata:Re,uri:V,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(V,ve,Re,Xe){const it=ve.start,ct=ve.end;(it!==ct||Re.length>0)&&this.c.push({_type:5,uri:V,index:it,count:ct-it,cells:Re,metadata:Xe})}g(V,ve,Re,Xe){this.c.push({_type:3,metadata:Xe,uri:V,edit:{editType:3,index:ve,metadata:Re}})}replace(V,ve,Re,Xe){this.c.push({_type:2,uri:V,edit:new le(ve,Re),metadata:Xe})}insert(V,ve,Re,Xe){this.replace(V,new N(ve,ve),Re,Xe)}delete(V,ve,Re){this.replace(V,ve,"",Re)}has(V){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===V.toString())}set(V,ve){if(ve)for(const Re of ve){if(!Re)continue;let Xe,it;Array.isArray(Re)?(Xe=Re[0],it=Re[1]):Xe=Re,Q.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(V,Xe.range.start,Xe.newCellMetadata,it):Xe.newNotebookMetadata?this.e(V,Xe.newNotebookMetadata,it):this.f(V,Xe.range,Xe.newCells,it):Ee.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:V,range:Xe.range,edit:Xe.snippet,metadata:it}):this.c.push({_type:2,uri:V,edit:Xe,metadata:it})}else{for(let Re=0;Re<this.c.length;Re++){const Xe=this.c[Re];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===V.toString()&&(this.c[Re]=void 0);break}}(0,D.$Hb)(this.c)}}get(V){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===V.toString()&&ve.push(Re.edit);return ve}entries(){const V=new R.$zc;for(const ve of this.c)if(ve._type===2){let Re=V.get(ve.uri);Re||(Re=[ve.uri,[]],V.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$JK=K,e.$JK=K=He([P],K);let U=a=class{static isSnippetString(V){return V instanceof a?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=a.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ve=this.e++){if(typeof V=="function"){const Re=new a;Re.e=this.e,V(Re),this.e=Re.e,V=Re.value}else V=a.c(V);return this.value+="${",this.value+=ve,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ve=this.e++){const Re=V.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(V,ve){if(typeof ve=="function"){const Re=new a;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$KK=U,e.$KK=U=a=He([P],U);var ie;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var be;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let H=t=class{static isLocation(V){return V instanceof t?!0:V?N.isRange(V.range)&&m.URI.isUri(V.uri):!1}constructor(V,ve){if(this.uri=V,ve)if(N.isRange(ve))this.range=N.of(ve);else if(F.isPosition(ve))this.range=new N(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$LK=H,e.$LK=H=t=He([P],H);let _=class{static is(V){return V?typeof V.message=="string"&&V.location&&N.isRange(V.location.range)&&m.URI.isUri(V.location.uri):!1}constructor(V,ve){this.location=V,this.message=ve}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.location.range.isEqual(ve.location.range)&&V.location.uri.toString()===ve.location.uri.toString()}};e.$MK=_,e.$MK=_=He([P],_);let Z=class{constructor(V,ve,Re=be.Error){if(!N.isRange(V))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=V,this.message=ve,this.severity=Re}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.severity===ve.severity&&V.code===ve.code&&V.severity===ve.severity&&V.source===ve.source&&V.range.isEqual(ve.range)&&(0,D.$tb)(V.tags,ve.tags)&&(0,D.$tb)(V.relatedInformation,ve.relatedInformation,_.isEqual)}};e.$NK=Z,e.$NK=Z=He([P],Z);let $e=class{constructor(V,ve){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ve}};e.$OK=$e,e.$OK=$e=He([P],$e);var re;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let fe=class{constructor(V,ve=re.Text){this.range=V,this.kind=ve}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$PK=fe,e.$PK=fe=He([P],fe);var te;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var de;(function(q){q[q.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let pe=s=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,ve,Re,Xe,it){this.name=V,this.kind=ve,this.containerName=it,typeof Re=="string"&&(this.containerName=Re),Xe instanceof H?this.location=Xe:Re instanceof N&&(this.location=new H(Xe,Re)),s.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$QK=pe,e.$QK=pe=s=He([P],pe);let Pe=d=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(d.validate)}constructor(V,ve,Re,Xe,it){this.name=V,this.detail=ve,this.kind=Re,this.range=Xe,this.selectionRange=it,this.children=[],d.validate(this)}};e.$RK=Pe,e.$RK=Pe=d=He([P],Pe);var B;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let X=class{constructor(V,ve){this.title=V,this.kind=ve}};e.$SK=X,e.$SK=X=He([P],X);let se=class{static{l=this}static{this.c="."}constructor(V){this.value=V}append(V){return new l(this.value?this.value+l.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+l.c)}};e.$TK=se,e.$TK=se=l=He([P],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(V,ve){if(this.range=V,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UK=oe,e.$UK=oe=He([P],oe);class ee{constructor(V,ve,Re,Xe,it,ct){this.kind=V,this.name=ve,this.detail=Re,this.uri=Xe,this.range=it,this.selectionRange=ct}}e.$VK=ee;class ge{constructor(V,ve){this.fromRanges=ve,this.from=V}}e.$WK=ge;class ye{constructor(V,ve){this.fromRanges=ve,this.to=V}}e.$XK=ye;var je;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(V,ve){this.range=V,this.command=ve}get isResolved(){return!!this.command}};e.$YK=We,e.$YK=We=He([P],We);let et=c=class{#e;static isMarkdownString(V){return V instanceof c?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,ve=!1){this.#e=new g.$9j(V,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,ve){return this.#e.appendCodeblock(ve??"",V),this}};e.$ZK=et,e.$ZK=et=c=He([P],et);let Ye=class{constructor(V,ve){this.label=V,this.documentation=ve}};e.$1K=Ye,e.$1K=Ye=He([P],Ye);let rt=class{constructor(V,ve){this.label=V,this.documentation=ve,this.parameters=[]}};e.$2K=rt,e.$2K=rt=He([P],rt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3K=nt,e.$3K=nt=He([P],nt);var Ae;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Oe;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let Ve=class{constructor(V){this.value=V}};e.$4K=Ve,e.$4K=Ve=He([P],Ve);let Le=class{constructor(V,ve,Re){this.position=V,this.label=ve,this.kind=Re}};e.$5K=Le,e.$5K=Le=He([P],Le);var Ze;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze||(e.CompletionTriggerKind=Ze={}));var ue;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ue||(e.CompletionItemKind=ue={}));var ae;(function(q){q[q.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let Ie=class{constructor(V,ve){this.label=V,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6K=Ie,e.$6K=Ie=He([P],Ie);let Ke=class{constructor(V=[],ve=!1){this.items=V,this.isIncomplete=ve}};e.$7K=Ke,e.$7K=Ke=He([P],Ke);let Ge=class{constructor(V,ve,Re){this.insertText=V,this.range=ve,this.command=Re}};e.$8K=Ge,e.$8K=Ge=He([P],Ge);let _e=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$9K=_e,e.$9K=_e=He([P],_e);var st;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var lt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(lt||(e.StatusBarAlignment=lt={}));function wt(q,V){return`${C.$_l.toKey(q)}.${V}`}e.$0K=wt;var Ue;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Ue||(e.TextEditorLineNumbersStyle=Ue={}));var Kt;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Et;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Ut;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Nt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(q){function V(ve){switch(ve){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=V}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Gt;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(q){function V(ve){switch(ve){case q.Other:return"other";case q.Comment:return"comment";case q.String:return"string";case q.RegEx:return"regex"}return"other"}q.toString=V}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(V,ve){if(ve&&!m.URI.isUri(ve))throw(0,T.$6)("target");if(!N.isRange(V)||V.isEmpty)throw(0,T.$6)("range");this.range=V,this.target=ve}};e.$$K=Bt,e.$$K=Bt=He([P],Bt);let Dt=class{constructor(V,ve,Re,Xe){this.red=V,this.green=ve,this.blue=Re,this.alpha=Xe}};e.$_K=Dt,e.$_K=Dt=He([P],Dt);let Mt=class{constructor(V,ve){if(ve&&!(ve instanceof Dt))throw(0,T.$6)("color");if(!N.isRange(V)||V.isEmpty)throw(0,T.$6)("range");this.range=V,this.color=ve}};e.$aL=Mt,e.$aL=Mt=He([P],Mt);let Wt=class{constructor(V){if(!V||typeof V!="string")throw(0,T.$6)("label");this.label=V}};e.$bL=Wt,e.$bL=Wt=He([P],Wt);var tt;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(tt||(e.ColorFormat=tt={}));var Vt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ut{constructor(V,ve,Re){if(this.startIndex=V,this.length=ve,this.tooltip=Re,typeof V!="number"||V<0)throw(0,T.$6)("startIndex");if(typeof ve!="number"||ve<1)throw(0,T.$6)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.$6)("tooltip")}}e.$cL=ut;class mt{constructor(V){this.uri=V}}e.$dL=mt;class Ot{constructor(V){this.terminalCommand=V}}e.$eL=Ot;var Pt;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class At{constructor(V){if(this.options=V,typeof V!="object")throw(0,T.$6)("options")}}e.$fL=At;var gt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(gt||(e.TaskRevealKind=gt={}));var St;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(St||(e.TaskPanelKind=St={}));let Rt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(V){switch(V){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(V,ve){if(this.label=ve,typeof V!="string"||typeof ve!="string")throw(0,T.$6)("name");this.c=V}get id(){return this.c}};e.$gL=Rt,e.$gL=Rt=h=He([P],Rt);function It(q){let V="";for(let ve=0;ve<q.length;ve++)V+=q[ve].replace(/,/g,",,")+",";return V}let Je=class{constructor(V,ve,Re){if(typeof V!="string")throw(0,T.$6)("process");this.e=[],this.c=V,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,T.$6)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)V.push(ve);return It(V)}};e.$hL=Je,e.$hL=Je=He([P],Je);let jt=class{constructor(V,ve,Re){if(this.f=[],Array.isArray(ve)){if(!V)throw(0,T.$6)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,T.$6)("command");this.e=V,this.f=ve,this.g=Re}else{if(typeof V!="string")throw(0,T.$6)("commandLine");this.c=V,this.g=ve}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,T.$6)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,T.$6)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)V.push(typeof ve=="string"?ve:ve.value);return It(V)}};e.$iL=jt,e.$iL=jt=He([P],jt);var Jt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Me;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Fe{constructor(V){this.c=V}computeId(){return"customExecution"+(0,A.$ig)()}set callback(V){this.c=V}get callback(){return this.c}}e.$jL=Fe;let Ce=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,ve,Re,Xe,it,ct){this.j=!1,this.k=this.definition=V;let ft;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Xe,ft=it,this.j=!0):ve===Me.Global||ve===Me.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Xe,this.execution=it,ft=ct):(this.target=ve,this.m=this.name=Re,this.t=this.source=Xe,this.execution=it,ft=ct),typeof ft=="string"?(this.o=[ft],this.q=!0):Array.isArray(ft)?(this.o=ft,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(V){this.h=V}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Je?this.k={type:E.e,id:this.n.computeId()}:this.n instanceof jt?this.k={type:E.f,id:this.n.computeId()}:this.n instanceof Fe?this.k={type:E.c,id:this.n.computeId()}:this.k={type:E.g,id:(0,A.$ig)()}}get definition(){return this.k}set definition(V){if(V==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=V}get scope(){return this.l}set target(V){this.z(),this.l=V}get name(){return this.m}set name(V){if(typeof V!="string")throw(0,T.$6)("name");this.z(),this.m=V}get execution(){return this.n}set execution(V){V===null&&(V=void 0),this.z(),this.n=V;const ve=this.k.type;(E.g===ve||E.e===ve||E.f===ve||E.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(V){if(Array.isArray(V))this.z(),this.o=V,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.z(),this.r=V}get source(){return this.t}set source(V){if(typeof V!="string"||V.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=V}get group(){return this.u}set group(V){V===null&&(V=void 0),this.z(),this.u=V}get detail(){return this.y}set detail(V){V===null&&(V=void 0),this.y=V}get presentationOptions(){return this.w}set presentationOptions(V){V==null&&(V=Object.create(null)),this.z(),this.w=V}get runOptions(){return this.x}set runOptions(V){V==null&&(V=Object.create(null)),this.z(),this.x=V}};e.$kL=Ce,e.$kL=Ce=E=He([P],Ce);var ne;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(ne||(e.ProgressLocation=ne={}));var Te;(function(q){function V(ve){const Re=ve;return(0,y.$Gf)(Re.value)?Re.tooltip&&!(0,y.$Cf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}q.isViewBadge=V})(Te||(e.ViewBadge=Te={}));let qe=I=class{static isTreeItem(V,ve){const Re=V;if(Re.checkboxState!==void 0){const Xe=(0,y.$Gf)(Re.checkboxState)?Re.checkboxState:(0,y.$Ef)(Re.checkboxState)&&(0,y.$Gf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,it=!(0,y.$Gf)(Re.checkboxState)&&(0,y.$Ef)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==Qe.Checked&&Xe!==Qe.Unchecked||it!==void 0&&!(0,y.$Cf)(it))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(V instanceof I)return!0;if(Re.label!==void 0&&!(0,y.$Cf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,y.$Cf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,y.$Cf)(Re.iconPath)&&!m.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,y.$Cf)(Re.iconPath.id))){const Xe=Re.iconPath;if(!Xe||!(0,y.$Cf)(Xe.light)&&!m.URI.isUri(Xe.light)&&!(0,y.$Cf)(Xe.dark)&&!m.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,y.$Cf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!m.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,y.$Cf)(Re.tooltip)&&!(Re.tooltip instanceof et)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<xe.None&&Re.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,y.$Cf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(V,ve=xe.None){this.collapsibleState=ve,m.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$lL=qe,e.$lL=qe=I=He([P],qe);var xe;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Qe;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(Qe||(e.TreeItemCheckboxState=Qe={}));let ot=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$mL=ot,e.$mL=ot=He([P],ot);class pt extends ot{}e.$nL=pt;class bt extends pt{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$oL=bt;class vt{constructor(V,ve,Re,Xe){this.name=V,this.uri=ve,this._itemId=Re,this.c=Xe}data(){return this.c()}}e.$pL=vt;let ht=class{#e=new Map;constructor(V){for(const[ve,Re]of V??[]){const Xe=this.#e.get(this.#t(ve));Xe?Xe.push(Re):this.#e.set(this.#t(ve),[Re])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,ve){this.#e.set(this.#t(V),[ve])}forEach(V,ve){for(const[Re,Xe]of this.#e)for(const it of Xe)V.call(ve,it,Re,this)}*[Symbol.iterator](){for(const[V,ve]of this.#e)for(const Re of ve)yield[V,Re]}#t(V){return V.toLowerCase()}};e.$qL=ht,e.$qL=ht=He([P],ht);let Lt=class{constructor(V){this.insertText=V}};e.$rL=Lt,e.$rL=Lt=He([P],Lt);let Qt=class{constructor(V,ve){this.label=ve,this.insertText=V}};e.$sL=Qt,e.$sL=Qt=He([P],Qt);let Zt=class{constructor(V,ve){this.id=V,this.color=ve}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$tL=Zt,e.$tL=Zt=He([P],Zt),Zt.File=new Zt("file"),Zt.Folder=new Zt("folder");let si=class{constructor(V){this.id=V}};e.$uL=si,e.$uL=si=He([P],si);var ki;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let Ct=class{get base(){return this.c}set base(V){this.c=V,this.e=m.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,ve){if(typeof V!="string"&&(!V||!m.URI.isUri(V)&&!m.URI.isUri(V.uri)))throw(0,T.$6)("base");if(typeof ve!="string")throw(0,T.$6)("pattern");typeof V=="string"?this.baseUri=m.URI.file(V):m.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vL=Ct,e.$vL=Ct=He([P],Ct);const Yi=new WeakMap;function hn(q,V){Yi.set(q,V)}e.$wL=hn;let kt=class{constructor(V,ve,Re,Xe){this.enabled=typeof V=="boolean"?V:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this.c||(this.c=Yi.get(this)??(0,A.$ig)()),this.c}};e.$xL=kt,e.$xL=kt=He([P],kt);let mi=class extends kt{constructor(V,ve,Re,Xe,it){if(super(ve,Re,Xe,it),V===null)throw(0,T.$6)("location");this.location=V}};e.$yL=mi,e.$yL=mi=He([P],mi);let $i=class extends kt{constructor(V,ve,Re,Xe,it){super(ve,Re,Xe,it),this.functionName=V}};e.$zL=$i,e.$zL=$i=He([P],$i);let oi=class extends kt{constructor(V,ve,Re,Xe,it,ct,ft){if(super(Xe,it,ct,ft),!ve)throw(0,T.$6)("dataId");this.label=V,this.dataId=ve,this.canPersist=Re}};e.$AL=oi,e.$AL=oi=He([P],oi);let Si=class{constructor(V,ve,Re){this.command=V,this.args=ve||[],this.options=Re}};e.$BL=Si,e.$BL=Si=He([P],Si);let Di=class{constructor(V,ve){this.port=V,this.host=ve}};e.$CL=Di,e.$CL=Di=He([P],Di);let Ft=class{constructor(V){this.path=V}};e.$DL=Ft,e.$DL=Ft=He([P],Ft);let bi=class{constructor(V){this.implementation=V}};e.$EL=bi,e.$EL=bi=He([P],bi);let Ci=class{constructor(V,ve,Re){this.session=V,this.threadId=ve,this.frameId=Re}};e.$FL=Ci,e.$FL=Ci=He([P],Ci);let ai=class{constructor(V,ve){this.session=V,this.threadId=ve}};e.$GL=ai,e.$GL=ai=He([P],ai);let ci=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$HL=ci,e.$HL=ci=He([P],ci);var dt;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(dt||(e.InlineCompletionTriggerKind=dt={}));let Ii=class{constructor(V,ve){this.range=V,this.text=ve}};e.$IL=Ii,e.$IL=Ii=He([P],Ii);let xt=class{constructor(V,ve,Re=!0){this.range=V,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$JL=xt,e.$JL=xt=He([P],xt);let ni=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$KL=ni,e.$KL=ni=He([P],ni);let hi=class{constructor(V,ve){this.frameId=V,this.stoppedLocation=ve}};e.$LL=hi,e.$LL=hi=He([P],hi);var Zi;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Pi=f=class extends Error{static FileExists(V){return new f(V,$.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(V){return new f(V,$.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(V){return new f(V,$.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(V){return new f(V,$.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(V){return new f(V,$.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(V){return new f(V,$.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(V,ve=$.FileSystemProviderErrorCode.Unknown,Re){super(m.URI.isUri(V)?V.toString(!0):V),this.code=Re?.name??"Unknown",(0,$.$tk)(this,ve),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$ML=Pi,e.$ML=Pi=f=He([P],Pi);let Ai=class{constructor(V,ve,Re){this.start=V,this.end=ve,this.kind=Re}};e.$NL=Ai,e.$NL=Ai=He([P],Ai);var Ri;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Ri||(e.FoldingRangeKind=Ri={}));var xi;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Li;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Mi{constructor(V,ve=[]){this.tokenTypes=V,this.tokenModifiers=ve}}e.$OL=Mi;function Fi(q){return typeof q>"u"||(0,y.$Df)(q)}class Ti{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,V){this.l=!0;for(let ve=0,Re=V.tokenTypes.length;ve<Re;ve++)this.j.set(V.tokenTypes[ve],ve);for(let ve=0,Re=V.tokenModifiers.length;ve<Re;ve++)this.k.set(V.tokenModifiers[ve],ve)}}push(V,ve,Re,Xe,it){if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Xe=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.n(V,ve,Re,Xe,it);if(N.isRange(V)&&typeof ve=="string"&&Fi(Re))return this.m(V,ve,Re);throw(0,T.$6)()}m(V,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Xe=V.start.line,it=V.start.character,ct=V.end.character-V.start.character,ft=this.j.get(ve);let zt=0;if(Re)for(const Yt of Re){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Yt);zt|=1<<ei>>>0}this.n(Xe,it,ct,ft,zt)}n(V,ve,Re,Xe,it){if(this.f&&(V<this.c||V===this.c&&ve<this.e)){this.f=!1;const zt=this.g.length/5|0;let Yt=0,ei=0;for(let ii=0;ii<zt;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Yt,Qi+=ei):ri+=Yt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Yt=ri,ei=Qi}}let ct=V,ft=ve;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ft-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ft,this.g[this.h++]=Re,this.g[this.h++]=Xe,this.g[this.h++]=it,this.c=V,this.e=ve}static o(V){const ve=[],Re=V.length/5|0;for(let ft=0;ft<Re;ft++)ve[ft]=ft;ve.sort((ft,zt)=>{const Yt=V[5*ft],ei=V[5*zt];if(Yt===ei){const ii=V[5*ft+1],ri=V[5*zt+1];return ii-ri}return Yt-ei});const Xe=new Uint32Array(V.length);let it=0,ct=0;for(let ft=0;ft<Re;ft++){const zt=5*ve[ft],Yt=V[zt+0],ei=V[zt+1],ii=V[zt+2],ri=V[zt+3],Qi=V[zt+4],Dn=Yt-it,On=Dn===0?ei-ct:ei,Xi=5*ft;Xe[Xi+0]=Dn,Xe[Xi+1]=On,Xe[Xi+2]=ii,Xe[Xi+3]=ri,Xe[Xi+4]=Qi,it=Yt,ct=ei}return Xe}build(V){return this.f?new Oi(new Uint32Array(this.g),V):new Oi(Ti.o(this.g),V)}}e.$PL=Ti;class Oi{constructor(V,ve){this.resultId=ve,this.data=V}}e.$QL=Oi;class di{constructor(V,ve,Re){this.start=V,this.deleteCount=ve,this.data=Re}}e.$RL=di;class dn{constructor(V,ve){this.resultId=ve,this.edits=V}}e.$SL=dn;var en;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Zt("arrow-left")}}constructor(){}};e.$TL=Ni,e.$TL=Ni=He([P],Ni);var pi;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(pi||(e.QuickPickItemKind=pi={}));var tn;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class wi{static validate(V){if(typeof V.badge=="string"){let ve=(0,b.$df)(V.badge,0);if(ve<V.badge.length&&(ve+=(0,b.$df)(V.badge,ve)),V.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!Zt.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,ve,Re){this.badge=V,this.tooltip=ve,this.color=Re}}e.$UL=wi;let vi=class{constructor(V){this.kind=V}};e.$VL=vi,e.$VL=vi=He([P],vi);var rn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(V){return V instanceof _t?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,ve){if(V<0)throw(0,T.$6)("start must be positive");if(ve<0)throw(0,T.$6)("end must be positive");V<=ve?(this.c=V,this.e=ve):(this.c=ve,this.e=V)}with(V){let ve=this.c,Re=this.e;return V.start!==void 0&&(ve=V.start),V.end!==void 0&&(Re=V.end),ve===this.c&&Re===this.e?this:new _t(ve,Re)}}e.$WL=_t;class fi{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ve=>fi.isNotebookCellData(ve))}static isNotebookCellData(V){return!0}constructor(V,ve,Re,Xe,it,ct,ft){this.kind=V,this.value=ve,this.languageId=Re,this.mime=Xe,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,fi.validate(this)}}e.$XL=fi;class fn{constructor(V){this.cells=V}}e.$YL=fn;class Xt{static isNotebookCellOutputItem(V){return V instanceof Xt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ve={name:V.name,message:V.message,stack:V.stack};return Xt.json(ve,"application/vnd.code.notebook.error")}static stdout(V){return Xt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Xt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ve="application/octet-stream"){return new Xt(V,ve)}static#e=new TextEncoder;static text(V,ve=L.$Vr.text){const Re=Xt.#e.encode(String(V));return new Xt(Re,ve)}static json(V,ve="text/x-json"){const Re=JSON.stringify(V,void 0,"	");return Xt.text(Re,ve)}constructor(V,ve){this.data=V,this.mime=ve;const Re=(0,L.$Zr)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$ZL=Xt;class yi{static isNotebookCellOutput(V){return V instanceof yi?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,ve=!1){const Re=new Set,Xe=new Set;for(let it=0;it<V.length;it++){const ct=V[it],ft=(0,L.$Zr)(ct.mime);if(!Re.has(ft)||(0,S.$CI)(ft)){Re.add(ft);continue}Xe.add(it),ve&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Xe.size===0?V:V.filter((it,ct)=>!Xe.has(ct))}constructor(V,ve,Re){this.items=yi.ensureUniqueMimeTypes(V,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,A.$ig)(),this.metadata=ve??Re)}}e.$1L=yi;var sn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var ji;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ji||(e.NotebookCellStatusBarAlignment=ji={}));var ze;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(ze||(e.NotebookEditorRevealType=ze={}));class ti{constructor(V,ve){this.text=V,this.alignment=ve}}e.$2L=ti;var zi;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(zi||(e.NotebookControllerAffinity=zi={}));var $t;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})($t||(e.NotebookControllerAffinity2=$t={}));class gn{constructor(V,ve=[]){this.uri=V,this.provides=(0,D.$2b)(ve)}}e.$3L=gn;class mn{constructor(V){this.label=V}}e.$4L=mn;var Ui;(function(q){q[q.Named=1]="Named",q[q.Indexed=2]="Indexed"})(Ui||(e.NotebookVariablesRequestKind=Ui={}));let Bi=class{constructor(V,ve){this.label=V,this.timestamp=ve}};e.$5L=Bi,e.$5L=Bi=He([P],Bi);var gi;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(gi||(e.ExtensionMode=gi={}));var on;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(on||(e.ExtensionRuntime=on={}));var an;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class $n{constructor(V,ve){this.ranges=V,this.wordPattern=ve}}e.$6L=$n;class cn{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$7L=cn;var un;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Wi=class{constructor(V=void 0,ve=void 0,Re=void 0,Xe=!1){this.include=V,this.exclude=ve,this.profile=Re,this.continuous=Xe}};e.$8L=Wi,e.$8L=Wi=He([P],Wi);let Vi=p=class{static diff(V,ve,Re){const Xe=new p(V);return Xe.expectedOutput=ve,Xe.actualOutput=Re,Xe}constructor(V){this.message=V}};e.$9L=Vi,e.$9L=Vi=p=He([P],Vi);let qi=class{constructor(V){this.id=V}};e.$0L=qi,e.$0L=qi=He([P],qi);let li=class{constructor(V,ve){this.covered=V,this.total=ve}};e.$$L=li,e.$$L=li=He([P],li);let Ki=k=class{static fromDetails(V,ve){const Re=new li(0,0),Xe=new li(0,0),it=new li(0,0);for(const ft of ve)if("branches"in ft){Re.total+=1,Re.covered+=ft.executionCount>0?1:0;for(const zt of ft.branches)Xe.total+=1,Xe.covered+=zt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new k(V,Re,Xe.total>0?Xe:void 0,it.total>0?it:void 0);return ct.detailedCoverage=ve,ct}constructor(V,ve,Re,Xe){this.uri=V,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Xe}};e.$_L=Ki,e.$_L=Ki=k=He([P],Ki);let Hi=class{constructor(V,ve,Re=[]){this.executionCount=V,this.location=ve,this.branches=Re}};e.$aM=Hi,e.$aM=Hi=He([P],Hi);let Gi=class{constructor(V,ve){this.executionCount=V,this.location=ve}};e.$bM=Gi,e.$bM=Gi=He([P],Gi);let Ji=class{constructor(V,ve){this.executionCount=V,this.location=ve}};e.$cM=Ji,e.$cM=Ji=He([P],Ji);var we;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(we||(e.ExternalUriOpenerPriority=we={}));var De;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(De||(e.WorkspaceTrustState=De={}));var Ne;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ne||(e.PortAutoForwardAction=Ne={}));class at{constructor(V,ve,Re,Xe,it,ct){this.kind=V,this.name=ve,this.detail=Re,this.uri=Xe,this.range=it,this.selectionRange=ct}}e.$dM=at;class yt{constructor(V){this.uri=V}}e.$eM=yt;class Tt{constructor(V,ve){this.original=V,this.modified=ve}}e.$fM=Tt;class Cn{constructor(V,ve,Re,Xe){this.base=V,this.input1=ve,this.input2=Re,this.result=Xe}}e.$gM=Cn;class In{constructor(V,ve){this.uri=V,this.viewType=ve}}e.$hM=In;class Pn{constructor(V){this.viewType=V}}e.$iM=Pn;class An{constructor(V,ve){this.uri=V,this.notebookType=ve}}e.$jM=An;class Rn{constructor(V,ve,Re){this.original=V,this.modified=ve,this.notebookType=Re}}e.$kM=Rn;class Ln{constructor(){}}e.$lM=Ln;class Mn{constructor(V,ve){this.uri=V,this.inputBoxUri=ve}}e.$mM=Mn;class Fn{constructor(V){this.providerId=V}}e.$nM=Fn;var bn;(function(q){q[q.Down=0]="Down",q[q.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var pn;(function(q){q[q.Action=1]="Action",q[q.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var wn;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful",q[q.Undone=2]="Undone",q[q.Accepted=3]="Accepted",q[q.Bug=4]="Bug"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}));var vn;(function(q){q[q.System=0]="System",q[q.User=1]="User",q[q.Assistant=2]="Assistant",q[q.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var yn;(function(q){q[q.Short=1]="Short",q[q.Medium=2]="Medium",q[q.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Tn{constructor(V,ve){this.role=V,this.content=ve}}e.$oM=Tn;var En;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var kn;(function(q){q[q.SymbolInformation=1]="SymbolInformation",q[q.CommandInformation=2]="CommandInformation",q[q.SearchInformation=3]="SearchInformation",q[q.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(q){q[q.Started=1]="Started",q[q.Recognizing=2]="Recognizing",q[q.Recognized=3]="Recognized",q[q.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(ke[143],Se([1,0,60,17,13,176,127,7,19]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=void 0;const m=new Map;function A(S,w){w?m.set(S,w):m.delete(S)}e.$BM=A;function C(S){return m.get(S)}class $ extends R.$2u{constructor(w,u,o,i,n,r,a,t){super(u,o,i,n),this.c=w,this.m=r,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(w){return(0,y.$tb)(this.f,w)}get document(){if(!this.a){const w=this;this.a={get uri(){return w.d},get fileName(){return w.d.fsPath},get isUntitled(){return w.d.scheme===T.Schemas.untitled},get languageId(){return w.m},get version(){return w.h},get isClosed(){return w.b},get isDirty(){return w.q},save(){return w.r()},getText(u){return u?w.s(u):w.getText()},get eol(){return w.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return w.f.length},lineAt(u){return w.t(u)},offsetAt(u){return w.u(u)},positionAt(u){return w.v(u)},validateRange(u){return w.w(u)},validatePosition(u){return w.x(u)},getWordRangeAtPosition(u,o){return w.y(u,o)}}}return Object.freeze(this.a)}_acceptLanguageId(w){(0,D.ok)(!this.b),this.m=w}_acceptIsDirty(w){(0,D.ok)(!this.b),this.q=w}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(w){const u=this.w(w);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const o=this.g,i=u.start.line,n=u.end.line,r=[];r.push(this.f[i].substring(u.start.character));for(let a=i+1;a<n;a++)r.push(this.f[a]);return r.push(this.f[n].substring(0,u.end.character)),r.join(o)}t(w){let u;if(w instanceof b.$AK?u=w.line:typeof w=="number"&&(u=w),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new v(u,this.f[u],u===this.f.length-1)}u(w){return w=this.x(w),this.l(),this.j.getPrefixSum(w.line-1)+w.character}v(w){w=Math.floor(w),w=Math.max(0,w),this.l();const u=this.j.getIndexOf(w),o=this.f[u.index].length;return new b.$AK(u.index,Math.min(u.remainder,o))}w(w){if(!(w instanceof b.$BK))throw new Error("Invalid argument");const u=this.x(w.start),o=this.x(w.end);return u===w.start&&o===w.end?w:new b.$BK(u.line,u.character,o.line,o.character)}x(w){if(!(w instanceof b.$AK))throw new Error("Invalid argument");if(this.f.length===0)return w.with(0,0);let{line:u,character:o}=w,i=!1;if(u<0)u=0,o=0,i=!0;else if(u>=this.f.length)u=this.f.length-1,o=this.f[u].length,i=!0;else{const n=this.f[u].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new b.$AK(u,o):w}y(w,u){const o=this.x(w);if(!u)u=C(this.m);else if((0,g.$Se)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const i=(0,L.$bs)(o.character+1,(0,L.$_r)(u),this.f[o.line],0);if(i)return new b.$BK(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$CM=$;class v{constructor(w,u,o){this.a=w,this.b=u,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$BK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$BK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DM=v}),define(ke[285],Se([1,0,7,20,4]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;let R=class{constructor(b){this.a=new D.$VL(D.ColorThemeKind.Dark),this.b=new g.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let y;switch(b){case"light":y=D.ColorThemeKind.Light;break;case"hcDark":y=D.ColorThemeKind.HighContrast;break;case"hcLight":y=D.ColorThemeKind.HighContrastLight;break;default:y=D.ColorThemeKind.Dark}this.a=new D.$VL(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$2fc=R,e.$2fc=R=He([Be(0,T.$zM)],R)}),define(ke[286],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=e.CellExecutionUpdateType=void 0;var T;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$GI=(0,D.$Vh)("INotebookExecutionService")}),define(ke[287],Se([1,0,3,29,193,99]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Ob=void 0;class L extends D.$Rc{constructor(y,m,A){super(),this._source=y,this.b=m,this.c=A,this.a=void 0}f(y){const m=y.getLineCount();return new T.$zs(1,1,m,this.g(y,m))}g(y,m){if(m<1||m>y.getLineCount())throw new Error("Illegal value for lineNumber");return y.getLineLength(m)+1}get inputTextBuffer(){if(!this.b){const y=new g.$NB;y.acceptChunk(this._source);const m=y.finish(!0),{textBuffer:A,disposable:C}=m.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(y=>{const m=new g.$NB;m.acceptChunk(y);const A=m.finish(!0),{textBuffer:C,disposable:$}=A.create(1);return this.B($),C})),this.a}findInInputs(y){const A=new R.$BB(y,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs(y){const A=new R.$BB(y,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const $=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if($.length!==0)return{textBuffer:C,matches:$}}).filter(C=>!!C):[]}}e.$$Ob=L}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(R){R.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class g{static fromExtHostTestItem(L,b,y=L.parent){if(L._isRoot)return new g([b]);const m=[L.id];for(let A=y;A&&A.id!==b;A=A.parent)m.push(A.id);return m.push(b),new g(m.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const b=L.indexOf("\0");return b===-1?L:L.slice(0,b)}static fromString(L){return new g(L.split("\0"))}static join(L,b){return new g([...L.path,b])}static joinToString(L,b){return L.toString()+"\0"+b}static parentId(L){const b=L.lastIndexOf("\0");return b===-1?void 0:L.slice(0,b)}static localId(L){const b=L.lastIndexOf("\0");return b===-1?L:L.slice(b+1)}static isChild(L,b){return b.startsWith(L)&&b[L.length]==="\0"}static compare(L,b){return L===b?0:g.isChild(L,b)?2:g.isChild(b,L)?3:1}constructor(L,b=L.length){if(this.path=L,this.d=b,L.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new g(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new g(this.path,L)}compare(L){if(typeof L=="string")return g.compare(this.toString(),L);for(let b=0;b<L.d&&b<this.d;b++)if(L.path[b]!==this.path[b])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$qJ=g}),define(ke[89],Se([1,0,2,29,67]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$wJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$vJ=e.$uJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$tJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$sJ=e.$rJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var L;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(L||(e.ExtTestRunProfileKind=L={}));var b;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$rJ=[2,4,8,16,32,64];const y=I=>"runId"in I;e.$sJ=y;var m;(function(I){I.serialize=f=>({range:f.range.toJSON(),uri:f.uri.toJSON()}),I.deserialize=f=>({range:T.$zs.lift(f.range),uri:D.URI.revive(f.uri)})})(m||(e.IRichLocation=m={}));var A;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(A||(e.TestMessageType=A={}));var C;(function(I){I.serialize=f=>({message:f.message,type:0,expected:f.expected,actual:f.actual,contextValue:f.contextValue,location:f.location&&m.serialize(f.location)}),I.deserialize=f=>({message:f.message,type:0,expected:f.expected,actual:f.actual,contextValue:f.contextValue,location:f.location&&m.deserialize(f.location)})})(C||(e.ITestErrorMessage=C={}));const $=(I,f)=>`${f?"s":"e"}${I}`;e.$tJ=$;var v;(function(I){I.serialize=f=>({message:f.message,type:1,offset:f.offset,length:f.length,location:f.location&&m.serialize(f.location)}),I.deserialize=f=>({message:f.message,type:1,offset:f.offset,length:f.length,location:f.location&&m.deserialize(f.location)})})(v||(e.ITestOutputMessage=v={}));var S;(function(I){I.serialize=f=>f.type===0?C.serialize(f):v.serialize(f),I.deserialize=f=>f.type===0?C.deserialize(f):v.deserialize(f)})(S||(e.ITestMessage=S={}));var w;(function(I){I.serializeWithoutMessages=f=>({state:f.state,duration:f.duration,messages:[]}),I.serialize=f=>({state:f.state,duration:f.duration,messages:f.messages.map(S.serialize)}),I.deserialize=f=>({state:f.state,duration:f.duration,messages:f.messages.map(S.deserialize)})})(w||(e.ITestTaskState=w={}));const u="\0",o=(I,f)=>I+u+f;e.$uJ=o;const i=I=>{const f=I.indexOf(u);return{ctrlId:I.slice(0,f),tagId:I.slice(f+1)}};e.$vJ=i;var n;(function(I){I.serialize=f=>({extId:f.extId,label:f.label,tags:f.tags,busy:f.busy,children:void 0,uri:f.uri?.toJSON(),range:f.range?.toJSON()||null,description:f.description,error:f.error,sortText:f.sortText}),I.deserialize=f=>({extId:f.extId,label:f.label,tags:f.tags,busy:f.busy,children:void 0,uri:f.uri?D.URI.revive(f.uri):void 0,range:f.range?T.$zs.lift(f.range):null,description:f.description,error:f.error,sortText:f.sortText})})(n||(e.ITestItem=n={}));var r;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var a;(function(I){I.serialize=f=>({expand:f.expand,item:n.serialize(f.item)}),I.deserialize=f=>({controllerId:g.$qJ.root(f.item.extId),expand:f.expand,item:n.deserialize(f.item)})})(a||(e.InternalTestItem=a={}));var t;(function(I){I.serialize=f=>{let p;return f.item&&(p={},f.item.label!==void 0&&(p.label=f.item.label),f.item.tags!==void 0&&(p.tags=f.item.tags),f.item.busy!==void 0&&(p.busy=f.item.busy),f.item.uri!==void 0&&(p.uri=f.item.uri?.toJSON()),f.item.range!==void 0&&(p.range=f.item.range?.toJSON()),f.item.description!==void 0&&(p.description=f.item.description),f.item.error!==void 0&&(p.error=f.item.error),f.item.sortText!==void 0&&(p.sortText=f.item.sortText)),{extId:f.extId,expand:f.expand,item:p}},I.deserialize=f=>{let p;return f.item&&(p={},f.item.label!==void 0&&(p.label=f.item.label),f.item.tags!==void 0&&(p.tags=f.item.tags),f.item.busy!==void 0&&(p.busy=f.item.busy),f.item.range!==void 0&&(p.range=f.item.range?T.$zs.lift(f.item.range):null),f.item.description!==void 0&&(p.description=f.item.description),f.item.error!==void 0&&(p.error=f.item.error),f.item.sortText!==void 0&&(p.sortText=f.item.sortText)),{extId:f.extId,expand:f.expand,item:p}}})(t||(e.ITestItemUpdate=t={}));const s=(I,f)=>{f.expand!==void 0&&(I.expand=f.expand),f.item!==void 0&&(I.item=I.item?Object.assign(I.item,f.item):f.item)};e.$wJ=s;var d;(function(I){I.serializeWithoutMessages=f=>({...a.serialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(w.serializeWithoutMessages)}),I.serialize=f=>({...a.serialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(w.serialize)}),I.deserialize=f=>({...a.deserialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(w.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var l;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(l||(e.DetailType=l={}));var c;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var h;(function(I){I.deserialize=f=>f.op===0?{op:f.op,item:a.deserialize(f.item)}:f.op===1?{op:f.op,item:t.deserialize(f.item)}:f.op===2?{op:f.op,uri:D.URI.revive(f.uri),docv:f.docv}:f,I.serialize=f=>f.op===0?{op:f.op,item:a.serialize(f.item)}:f.op===1?{op:f.op,item:t.serialize(f.item)}:f})(h||(e.TestsDiffOp=h={}));class E{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(f){const p=this.o();for(const k of f)switch(k.op){case 0:this.j(a.deserialize(k.item),p);break;case 1:this.k(t.deserialize(k.item),p);break;case 3:this.l(k.itemId,p);break;case 5:this.m(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this.c.set(k.tag.id,k.tag);break;case 7:this.c.delete(k.id);break}p.complete?.()}j(f,p){const k=g.$qJ.parentId(f.item.extId)?.toString();let P;if(!k)P=this.p(f),this.f.add(P),this.d.set(f.item.extId,P);else if(this.d.has(k)){const j=this.d.get(k);j.children.add(f.item.extId),P=this.p(f,j),this.d.set(f.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(f)}`);return}return p.add?.(P),f.expand===2&&this.g++,P}k(f,p){const k=this.d.get(f.extId);if(k)return f.expand!==void 0&&(k.expand===2&&this.g--,f.expand===2&&this.g++),(0,e.$wJ)(k,f),p.update?.(k),k}l(f,p){const k=this.d.get(f);if(!k)return;const P=g.$qJ.parentId(k.item.extId)?.toString();P?this.d.get(P).children.delete(k.item.extId):this.f.delete(k);const j=[[f]];for(;j.length;)for(const z of j.pop()){const M=this.d.get(z);M&&(j.push(M.children),this.d.delete(z),p.remove?.(M,M!==k),M.expand===2&&this.g--)}}m(f){}updatePendingRoots(f){this.h+=f}o(){return{}}}e.$xJ=E}),define(ke[112],Se([1,0,12,4,3,60,89,67]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TestItemEventOp=void 0;var y;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const m=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:m,label:m,description:m,error:m,sortText:m,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),$=(i,n)=>{let r;for(const[a,t]of C)t(i[a],n[a])||(r?r[a]=n[a]:r={[a]:n[a]});return r};class v extends g.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$0g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.I(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,L.$wJ)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,L.$wJ)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||r>a.expandLevels)&&(a.expandLevels=r),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,r-1):t.wait().then(()=>this.J(a,r-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,r-1)):this.J(a,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,r){switch(r.op){case 3:this.N(b.$qJ.joinToString(n.fullId,r.id));break;case 0:this.y(r.item,n);break;case 5:for(const a of r.ops)this.u(n,a);break;case 1:this.z(r.new,r.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.w(n.actual.uri);break;default:(0,R.$4c)(r)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,r){const a=b.$qJ.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let s=this.tree.get(a.toString());if(!s){s={fullId:a,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.H(n,s,r);return}if(s.actual===n){this.G(n,s,r);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,r);const d=this.s.getChildren(s.actual),l=s.actual,c=$(this.s.toITestItem(l),this.s.toITestItem(n));this.s.getApiFor(l).listener=void 0,s.actual=n,s.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(n.tags,l.tags,a.toString()),delete c.tags),this.u(s,{op:4,update:c})),this.H(n,s,r);for(const[h,E]of d)this.s.getChildren(n).get(E.id)||this.N(b.$qJ.joinToString(a,E.id));this.w(s.actual.uri)}z(n,r,a){const t=new Set(r.map(s=>s.id));for(const s of n)t.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(s=>(0,L.$uJ)(this.s.controllerId,s.id))}}}),t.forEach(this.D,this)}C(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$uJ)(this.s.controllerId,n.id)}}))}D(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,L.$uJ)(this.s.controllerId,n)}))}F(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}G(n,r,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=s=>this.u(r,s),this.I(r)}H(n,r,a){this.G(n,r,a);for(const[t,s]of this.s.getChildren(n))this.y(s,r)}I(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.L(n))}J(n,r){if(r<0)return;const a=[];for(const[t,s]of this.s.getChildren(n.actual)){const d=this.expand(b.$qJ.joinToString(n.fullId,s.id),r);(0,D.$Kg)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new D.$Wg;return s.open(),s}n.expand=2,this.M(n);const r=n.resolveBarrier=new D.$Wg,a=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(s){a(s)}return(0,D.$Kg)(t)?t.catch(a).then(()=>{r.open(),this.I(n)}):(r.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[r];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.D(s.id);this.tree.delete(t.fullId.toString());for(const[s,d]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$qJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$pM=v;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$qM=S;class w extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rM=w;class u extends Error{constructor(n,r,a){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${a}".`)}}e.$sM=u;const o=(i,n,r)=>{let a=new Map;return{get size(){return a.size},forEach(t,s){for(const d of a.values())t.call(s,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const s=new Map,d=new Set(a.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof r))throw new w(c.id);const h=n(c).controllerId;if(h!==i.controllerId)throw new u(c.id,h,i.controllerId);if(s.has(c.id))throw new S(c.id);s.set(c.id,c),d.delete(c.id),l.ops.push({op:0,item:c})}for(const c of d.keys())l.ops.push({op:3,id:c});i.listener?.(l),a=s},add(t){if(!(t instanceof r))throw new w(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$tM=o}),define(ke[144],Se([1,0,112]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=void 0;const T=new WeakMap,g=(L,b)=>{const y={controllerId:b};return T.set(L,y),y};e.$uM=g;const R=L=>{const b=T.get(L);if(!b)throw new D.$rM(L?.id||"<unknown>");return b};e.$vM=R}),define(ke[113],Se([1,0,17,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jub=e.$iub=e.$hub=e.$gub=e.$fub=void 0,e.$fub="vscode-cdn.net",e.$gub=`vscode-resource.${e.$fub}`,e.$hub=`'self' https://*.${e.$fub}`;function g(b,y){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:(y&&y.authority&&y.isRemote&&b.scheme===D.Schemas.file&&(b=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:y.authority,path:b.path})),T.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$gub}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$iub=g;function R(b){return b.replace(/./g,y=>{const m=y.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?y:"-"+m.toString(16).padStart(4,"0")})}function L(b){return b.replace(/-([0-9a-f]{4})/g,(y,m)=>String.fromCharCode(parseInt(m,16)))}e.$jub=L}),define(ke[288],Se([1,0,4,3,113]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class R{constructor(b,y,m){this.d=b,this.e=y,this.f=m,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const A=y.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,y,m,A,C){let $;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){$=n;break}if(!$)throw new Error("not a visible editor");const v=this,S=this.a++,w=new D.$Rd,u=new D.$Rd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,g.$iub)(n,v.f)}get cspSource(){return g.$hub}set options(n){this.b=n,v.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return w.event}postMessage(n){return v.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=b,this.line=y,this.height=m,this.webview=o,this.onDidDispose=u.event}dispose(){v.c.has(S)&&(v.c.delete(S),v.d.$disposeEditorInset(S),u.fire(),u.dispose(),w.dispose())}};return this.d.$createEditorInset(S,$.id,$.value.document.uri,y+1,m,A||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:b,inset:i,onDidReceiveMessage:w}),i}$onDidDispose(b){const y=this.c.get(b);y&&y.inset.dispose()}$onDidReceiveMessage(b,y){this.c.get(b)?.onDidReceiveMessage.fire(y)}}e.$lec=R}),define(ke[289],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.VariableKind=e.$lN=void 0,e.$lN=(0,D.$Vh)("configurationResolverService");var T;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class g extends Error{constructor(L,b){super(b),this.variable=L}}e.$mN=g}),define(ke[290],Se([1,0,16,49,18,24,11,102,232,289,13]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,S,w,u){this.h=new Map,this.a=v,this.b=S,this.g=w,u&&(this.c=u.then(o=>this.i(o)))}i(v){if(L.$i){const S=Object.create(null);return Object.keys(v).forEach(w=>{S[w.toLowerCase()]=v[w]}),S}return v}resolveWithEnvironment(v,S,w){return this.l({env:this.i(v),userHome:void 0},S?S.uri:void 0,w)}async resolveAsync(v,S){const w={env:await this.c,userHome:await this.g};return this.l(w,v?v.uri:void 0,S)}async j(v,S,w,u){const o=R.$an(S);L.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):L.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):L.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,o,w,u)}async resolveAnyAsync(v,S,w){return this.j(v,S,w)}async resolveAnyMap(v,S,w){const u=new Map;return{newConfig:await this.j(v,S,w,u),resolvedVariables:u}}resolveWithInteractionReplace(v,S,w,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,S,w,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,S){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,S)}async l(v,S,w,u,o){if(g.$Cf(w))return this.m(v,S,w,u,o);if(Array.isArray(w))return Promise.all(w.map(i=>this.l(v,S,i,u,o)));if(g.$Ef(w)){const i=Object.create(null),n=await Promise.all(Object.keys(w).map(async r=>[await this.m(v,S,r,u,o),await this.l(v,S,w[r],u,o)]));for(const[r,a]of n)i[r]=a;return i}return w}m(v,S,w,u,o){return(0,A.$Xe)(w,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let r=await this.o(v,i,n,S,u);return o?.set(n,r),r!==i&&g.$Cf(r)&&r.match(C.VARIABLE_REGEXP)&&(r=await this.m(v,S,r,u,o)),r})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,S,w,u,o){let i;const n=w.split(":");n.length>1&&(w=n[0],i=n[1]);const r=s=>{const d=this.a.getFilePath();if(d)return(0,b.$zv)(d);throw new m.$mN(s,(0,y.localize)(0,null,S))},a=s=>{const d=r(s);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$zv)(l)}throw new m.$mN(s,(0,y.localize)(1,null,S,D.$mc(d)))},t=s=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new m.$mN(s,(0,y.localize)(2,null,S,i))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new m.$mN(s,(0,y.localize)(3,null,S)):new m.$mN(s,(0,y.localize)(4,null,S))};switch(w){case"env":if(i){if(v.env){const s=v.env[L.$i?i.toLowerCase():i];if(g.$Cf(s))return s}return""}throw new m.$mN(m.VariableKind.Env,(0,y.localize)(5,null,S));case"config":if(i){const s=this.a.getConfigurationValue(u,i);if(g.$Lf(s))throw new m.$mN(m.VariableKind.Config,(0,y.localize)(6,null,S,i));if(g.$Ef(s))throw new m.$mN(m.VariableKind.Config,(0,y.localize)(7,null,S,i));return s}throw new m.$mN(m.VariableKind.Config,(0,y.localize)(8,null,S));case"command":return this.p(m.VariableKind.Command,S,i,o,"command");case"input":return this.p(m.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const s=await this.a.getExtension(i);if(!s)throw new m.$mN(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,S,i));return this.n(s.extensionLocation)}throw new m.$mN(m.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,S));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,b.$zv)(this.n(t(m.VariableKind.WorkspaceFolder)));case"cwd":return u||i?(0,b.$zv)(this.n(t(m.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$zv)(D.$mc(this.n(t(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new m.$mN(m.VariableKind.UserHome,(0,y.localize)(11,null,S))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new m.$mN(m.VariableKind.LineNumber,(0,y.localize)(12,null,S))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new m.$mN(m.VariableKind.SelectedText,(0,y.localize)(13,null,S))}case"file":return r(m.VariableKind.File);case"fileWorkspaceFolder":return a(m.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$mc(a(m.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return u||i?D.$kc(this.n(t(m.VariableKind.RelativeFile)),r(m.VariableKind.RelativeFile)):r(m.VariableKind.RelativeFile);case"relativeFileDirname":{const s=D.$lc(r(m.VariableKind.RelativeFileDirname));if(u||i){const d=D.$kc(this.n(t(m.VariableKind.RelativeFileDirname)),s);return d.length===0?".":d}return s}case"fileDirname":return D.$lc(r(m.VariableKind.FileDirname));case"fileExtname":return D.$nc(r(m.VariableKind.FileExtname));case"fileBasename":return D.$mc(r(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=D.$mc(r(m.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-D.$nc(s).length)}case"fileDirnameBasename":return D.$mc(D.$lc(r(m.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||S}case"execInstallFolder":{const s=this.a.getAppRoot();return s||S}case"pathSeparator":return D.sep;default:try{const s=i?`${w}:${i}`:w;return this.p(m.VariableKind.Unknown,S,s,o,void 0)}catch{return S}}}}p(v,S,w,u,o){if(w&&u){const i=o===void 0?u[w]:u[o+":"+w];if(typeof i=="string")return i;throw new m.$mN(v,(0,y.localize)(14,null,S))}return S}}e.$AN=C}),define(ke[145],Se([1,0,5,141]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.OpenEditorContext=e.GroupsOrder=e.$HC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$GC=void 0,e.$GC=(0,D.$Vh)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var R;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var y;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function m(S){const w=S;return(0,T.$pE)(w?.editor)&&(0,T.$pE)(w?.replacement)}e.$HC=m;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function $(S){const w=S;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.$IC=$;function v(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$JC=v}),define(ke[291],Se([1,0,5,145]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.$LC=e.$KC=void 0,e.$KC=(0,D.$Vh)("editorService"),e.$LC=-1,e.$MC=-2;function g(R){const L=R;return typeof R=="number"||(0,T.$IC)(L)}e.$NC=g}),define(ke[146],Se([1,0,5,134]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=void 0,e.$UJ=(0,D.$Wh)(T.$3h)}),define(ke[147],Se([1,0,26,4,16,3]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i6b=e.$h6b=e.$g6b=e.$f6b=e.$e6b=void 0;class L{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$e6b=L;class b{static isHostExtension(o,i,n){if(i.getExtensionDescription(o))return!1;const r=n.getExtensionDescription(o);return r?!!((r.main||r.browser)&&r.api==="none"):!1}constructor(o,i){this.j=o,this.c=new T.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$bm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=w(this.e,i),this.e=this.e.concat(o);const n=b.l(this.e);return this.e=w(this.e,n.map(r=>r.identifier)),this.k(),this.d++,this.c.fire(void 0),new L(this.d,n)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,d){this.addNode(s),this.addNode(d),this.c.has(s)?this.c.get(s).push(d):this.c.set(s,[d])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,d){const l=i.getArcs(s);for(let c=0;c<l.length;c++)if(!d.has(l[c]))return!1;return!0}getNodes(){return this.e}},n=new D.$bm;for(const s of o)if(n.set(s.identifier,s),s.extensionDependencies)for(const d of s.extensionDependencies)i.addArc(D.$_l.toKey(s.identifier),D.$_l.toKey(d));const r=new Set;i.getNodes().filter(s=>i.getArcs(s).length===0).forEach(s=>r.add(s));const a=i.getNodes().filter(s=>!r.has(s));let t;do{t=!1;for(let s=0;s<a.length;s++){const d=a[s];i.hasOnlyGoodArcs(d,r)&&(a.splice(s,1),s--,r.add(d),t=!0)}}while(t);return a.map(s=>n.get(s))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new y(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$f6b=b;class y{constructor(o,i){this.versionId=o,this.extensions=i}}e.$g6b=y;class m{constructor(o){this.d=new $,this.c=new b(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new A(this,i)}deltaExtensions(o,i,n){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$h6b=m;class A extends R.$Rc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$i6b=A;class C{constructor(o){this.name=o,this.promise=new Promise((i,n)=>{this.c=i})}resolve(o){this.c(o)}}class ${constructor(){this.c=[],this.d=!1}async acquire(o){const i=new C(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),r=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};o.resolve((0,R.$Pc)(r))}}var v;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(v||(v={}));function S(u,o){const i=u.isBuiltin?0:u.isUnderDevelopment?2:1,n=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==n)return i-n;const r=g.$fc.basename(u.extensionLocation.path),a=g.$fc.basename(o.extensionLocation.path);return r<a?-1:r>a?1:0}function w(u,o){const i=new D.$am(o);return u.filter(n=>!i.has(n.identifier))}}),define(ke[292],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.ExtHostConnectionType=void 0;var D;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[T.ENV_KEY]=this.pipeName}}e.$Dm=T;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Em=g;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[R.ENV_KEY]="1"}}e.$Fm=R;function L(A){delete A[T.ENV_KEY],delete A[g.ENV_KEY],delete A[R.ENV_KEY]}function b(A,C){L(C),A.serialize(C)}e.$Gm=b;function y(A){if(A[T.ENV_KEY])return m(A,new T(A[T.ENV_KEY]));if(A[g.ENV_KEY])return m(A,new g);if(A[R.ENV_KEY])return m(A,new R);throw new Error("No connection information defined in environment!")}e.$Hm=y;function m(A,C){return L(A),C}}),define(ke[114],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(T||(e.UIKind=T={}));var g;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var R;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(m){const A=D.$fe.alloc(1);switch(m){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$hm=L;function b(m,A){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$im=b;var y;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(ke[90],Se([1,0,5,4,14,27,114,65,87,24,2,3,218]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=e.$RM=e.$QM=void 0;let v=class extends C.$Rc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new T.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:y.$uo,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,g.$fj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const r=this.getTelemetryDetails(),a=new S(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=w(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$2k)((0,y.$Bo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(r):this.r.set(r,a)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let a=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$QM=v,e.$QM=v=He([Be(0,R.$PM),Be(1,g.$ej)],v);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,r,a,t,s){this.g=n,this.h=r,this.i=a,this.j=t,this.a=new T.$Rd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,y.$Eo)(i,[]),this.c&&(i=(0,m.$dn)(i,this.c)),this.b||(i=(0,m.$dn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,y.$Eo)(n,[]),a=new Error(r.message,{cause:r.cause});a.stack=r.stack,a.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$RM=S;function w(u){const o=Date.now()-new Date(u).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$SM=w,e.$TM=(0,D.$Vh)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,262,139,26,5]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new L.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,b.$Vh)("extensionService");class y{constructor(a){this.dependency=a}}e.$JF=y;var m;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,s){this.c=a,this.d=t.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$xF.createActivationEventsMap(this.d)}}set(a,t,s){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],l=[],c=[],h=[],E=C(this.d),I=C(t),f=(z,M)=>z.extensionLocation.toString()===M.extensionLocation.toString()||z.isBuiltin===M.isBuiltin||z.isUserBuiltin===M.isUserBuiltin||z.isUnderDevelopment===M.isUnderDevelopment;for(const z of this.d){const M=I.get(z.identifier);if(!M){d.push(z.identifier),E.delete(z.identifier);continue}if(!f(z,M)){d.push(z.identifier),E.delete(z.identifier);continue}}for(const z of t){const M=E.get(z.identifier);if(!M){l.push(z);continue}if(!f(M,z)){d.push(M.identifier),E.delete(M.identifier);continue}}const p=new L.$am(this.e),k=new L.$am(s);for(const z of this.e)k.has(z)||c.push(z);for(const z of s)p.has(z)||h.push(z);const P=R.$xF.createActivationEventsMap(l),j={versionId:a,toRemove:d,toAdd:l,addActivationEvents:P,myToRemove:c,myToAdd:h};return this.delta(j),j}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:s,myToRemove:d,myToAdd:l}=a,c=new L.$am(t),h=new L.$am(d);for(let E=0;E<this.d.length;E++)c.has(this.d[E].identifier)&&(this.d.splice(E,1),E--);for(let E=0;E<this.e.length;E++)h.has(this.e[E])&&(this.e.splice(E,1),E--);for(const E of s)this.d.push(E);for(const E of l)this.e.push(E);return this.f=null,a}containsExtension(a){for(const t of this.e)if(L.$_l.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const s=R.$xF.readActivationEvents(t);for(const d of s)a.add(d)}return a}}e.$KF=A;function C(r){const a=new L.$bm;for(const t of r)a.set(t.identifier,t);return a}function $(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.$LF=$;function v(r,a){if(!$(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$MF=v;class S{constructor(a,t,s,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=d}}e.$NF=S;class w{constructor(a,t){this.description=a,this.value=t}}e.$OF=w;var u;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,g.$Ko)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$PF=o;function i(r,a){return{identifier:new L.$_l((0,g.$Io)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$QF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=n}),define(ke[293],Se([1,0,8,147,26,25,14,12]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=e.$Lec=e.$Kec=e.$Jec=e.$Iec=e.$Hec=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(o,i,n,r){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$Hec=y;class m{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Iec=m;class A{constructor(o,i,n,r,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=a,this.subscriptions=t}}e.$Jec=A;class C extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kec=C;class $ extends A{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lec=$;class v extends A{constructor(o){super(!0,o,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,n,r){this.g=r,this.a=o,this.b=i,this.c=n,this.d=new g.$bm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new v(a));return this.c.onExtensionActivationError(o.id,a,new R.$JF(o.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of r){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const s=this.a.getExtensionDescription(a);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:o.reason}));continue}const d=i.displayName||i.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),c=this.k(o,i.displayName,[],new v(l));return this.c.onExtensionActivationError(i.identifier,l,new R.$JF(a)),c}return this.k(o,i.displayName,n,null)}k(o,i,n,r){const a=new w(o.id,i,o.reason,n,r,this.c,this.g);return this.d.set(o.id,a),a}l(o){return T.$f6b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$Mec=S,e.$Mec=S=He([Be(3,L.$dj)],S);let w=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,r,a,t,s){this.c=o,this.d=i,this.f=n,this.g=r,this.h=a,this.j=t,this.k=s,this.a=new b.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new v(i),this.b&&D.$3(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};w=He([Be(6,L.$dj)],w)}),define(ke[15],Se([1,0,19,22,165,74,80,28,161,54,100,24,18,2,29,83,136,144,141,111,67,89,291,7,25]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$yM=e.$xM=e.MarkdownString=e.$wM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Me){function Fe(ne){const{selectionStartLineNumber:Te,selectionStartColumn:qe,positionLineNumber:xe,positionColumn:Qe}=ne,ot=new s.$AK(Te-1,qe-1),pt=new s.$AK(xe-1,Qe-1);return new s.$CK(ot,pt)}Me.to=Fe;function Ce(ne){const{anchor:Te,active:qe}=ne;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Me.from=Ce})(l||(e.Selection=l={}));var c;(function(Me){function Fe(ne){if(!ne)return;const{start:Te,end:qe}=ne;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Me.from=Fe;function Ce(ne){if(!ne)return;const{startLineNumber:Te,startColumn:qe,endLineNumber:xe,endColumn:Qe}=ne;return new s.$BK(Te-1,qe-1,xe-1,Qe-1)}Me.to=Ce})(c||(e.Range=c={}));var h;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Fe})(h||(e.TokenType=h={}));var E;(function(Me){function Fe(ne){return new s.$AK(ne.lineNumber-1,ne.column-1)}Me.to=Fe;function Ce(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=Ce})(E||(e.Position=E={}));var I;(function(Me){function Fe(Te,qe,xe){return(0,D.$Gb)((0,D.$2b)(Te).map(Qe=>Ce(Qe,qe,xe)))}Me.from=Fe;function Ce(Te,qe,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:ne(Te.scheme,qe),pattern:ue.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function ne(Te,qe){return qe&&typeof Te=="string"?qe.transformOutgoingScheme(Te):Te}})(I||(e.DocumentSelector=I={}));var f;(function(Me){function Fe(ne){switch(ne){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Fe;function Ce(ne){switch(ne){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})(f||(e.DiagnosticTag=f={}));var p;(function(Me){function Fe(ne){let Te;return ne.code&&((0,$.$Cf)(ne.code)||(0,$.$Gf)(ne.code)?Te=String(ne.code):Te={value:String(ne.code.value),target:ne.code.target}),{...c.from(ne.range),message:ne.message,source:ne.source,code:Te,severity:P.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(k.from),tags:Array.isArray(ne.tags)?(0,D.$Gb)(ne.tags.map(f.from)):void 0}}Me.from=Fe;function Ce(ne){const Te=new s.$NK(c.to(ne),ne.message,P.to(ne.severity));return Te.source=ne.source,Te.code=(0,$.$Cf)(ne.code)?ne.code:ne.code?.value,Te.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(k.to),Te.tags=ne.tags&&(0,D.$Gb)(ne.tags.map(f.to)),Te}Me.to=Ce})(p||(e.Diagnostic=p={}));var k;(function(Me){function Fe(ne){return{...c.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=Fe;function Ce(ne){return new s.$MK(new s.$LK(ne.resource,c.to(ne)),ne.message)}Me.to=Ce})(k||(e.DiagnosticRelatedInformation=k={}));var P;(function(Me){function Fe(ne){switch(ne){case s.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Me.from=Fe;function Ce(ne){switch(ne){case u.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=Ce})(P||(e.DiagnosticSeverity=P={}));var j;(function(Me){function Fe(ne){return typeof ne=="number"&&ne>=s.ViewColumn.One?ne-1:ne===s.ViewColumn.Beside?t.$MC:t.$LC}Me.from=Fe;function Ce(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(j||(e.ViewColumn=j={}));function z(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!z(Me[0])}e.$wM=M;var F;(function(Me){function Fe(Qe){return Qe.map(Me.from)}Me.fromMany=Fe;function Ce(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ne(Qe){let ot;if(Ce(Qe)){const{language:ht,value:Lt}=Qe;ot={value:"```"+ht+`
`+Lt+"\n```\n"}}else s.$ZK.isMarkdownString(Qe)?ot={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ot={value:Qe}:ot={value:""};const pt=Object.create(null);ot.uris=pt;const bt=ht=>{try{let Lt=v.URI.parse(ht,!0);Lt=Lt.with({query:Te(Lt.query,pt)}),pt[ht]=Lt}catch{}return""},vt=new y.marked.Renderer;return vt.link=bt,vt.image=ht=>typeof ht=="string"?bt(L.$dk(ht).href):"",(0,y.marked)(ot.value,{renderer:vt}),ot}Me.from=ne;function Te(Qe,ot){if(!Qe)return Qe;let pt;try{pt=(0,m.$rh)(Qe)}catch{}if(!pt)return Qe;let bt=!1;return pt=(0,C.$cn)(pt,vt=>{if(v.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ht]=vt,bt=!0,ht}else return}),bt?JSON.stringify(pt):Qe}function qe(Qe){const ot=new s.$ZK(Qe.value,Qe.supportThemeIcons);return ot.isTrusted=Qe.isTrusted,ot.supportHtml=Qe.supportHtml,ot.baseUri=Qe.baseUri?v.URI.from(Qe.baseUri):void 0,ot}Me.to=qe;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Me.from(Qe)}Me.fromStrict=xe})(F||(e.MarkdownString=F={}));function N(Me){return M(Me)?Me.map(Fe=>({range:c.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?F.fromMany(Fe.hoverMessage):Fe.hoverMessage?F.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Me.map(Fe=>({range:c.from(Fe)}))}e.$xM=N;function O(Me){return typeof Me>"u"?Me:typeof Me=="string"?v.URI.file(Me):Me}e.$yM=O;var W;(function(Me){function Fe(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?O(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Fe})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var x;(function(Me){function Fe(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Fe})(x||(e.ThemableDecorationRenderOptions=x={}));var ce;(function(Me){function Fe(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Fe})(ce||(e.DecorationRangeBehavior=ce={}));var Y;(function(Me){function Fe(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ce.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?x.from(Ce.light):void 0,dark:Ce.dark?x.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Fe})(Y||(e.DecorationRenderOptions=Y={}));var G;(function(Me){function Fe(ne){return{text:ne.newText,eol:ne.newEol&&Ae.from(ne.newEol),range:c.from(ne.range)}}Me.from=Fe;function Ce(ne){const Te=new s.$GK(c.to(ne.range),ne.text);return Te.newEol=typeof ne.eol>"u"?void 0:Ae.to(ne.eol),Te}Me.to=Ce})(G||(e.TextEdit=G={}));var J;(function(Me){function Fe(ne,Te){const qe={edits:[]};if(ne instanceof s.$JK){const xe=new b.$Ac;for(const Qe of ne._allEntries())Qe._type===1&&v.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of ne._allEntries())if(Qe._type===1){let ot;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ot={type:"base64",value:(0,T.$ze)(T.$fe.wrap(Qe.options.contents))}:ot={type:"dataTransferItem",id:Qe.options.contents._itemId}),qe.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ot},metadata:Qe.metadata})}else Qe._type===2?qe.edits.push({resource:Qe.uri,textEdit:G.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?qe.edits.push({resource:Qe.uri,textEdit:{range:c.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(wt.from)}})}return qe}Me.from=Fe;function Ce(ne){const Te=new s.$JK,qe=new b.$zc;for(const xe of ne.edits)if(xe.textEdit){const Qe=xe,ot=v.URI.revive(Qe.resource),pt=c.to(Qe.textEdit.range),bt=Qe.textEdit.text,vt=Qe.textEdit.insertAsSnippet;let ht;vt?ht=s.$IK.replace(pt,new s.$KK(bt)):ht=s.$GK.replace(pt,bt);const Lt=qe.get(ot);Lt?Lt.push(ht):qe.set(ot,[ht])}else Te.renameFile(v.URI.revive(xe.oldResource),v.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of qe)Te.set(xe,Qe);return Te}Me.to=Ce})(J||(e.WorkspaceEdit=J={}));var le;(function(Me){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function Ce(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Me.from=Ce;function ne(Te){for(const qe in Fe)if(Fe[qe]===Te)return Number(qe);return s.SymbolKind.Property}Me.to=ne})(le||(e.SymbolKind=le={}));var Q;(function(Me){function Fe(ne){switch(ne){case s.SymbolTag.Deprecated:return 1}}Me.from=Fe;function Ce(ne){switch(ne){case 1:return s.SymbolTag.Deprecated}}Me.to=Ce})(Q||(e.SymbolTag=Q={}));var Ee;(function(Me){function Fe(ne){return{name:ne.name,kind:le.from(ne.kind),tags:ne.tags&&ne.tags.map(Q.from),containerName:ne.containerName,location:be.from(ne.location)}}Me.from=Fe;function Ce(ne){const Te=new s.$QK(ne.name,le.to(ne.kind),ne.containerName,be.to(ne.location));return Te.tags=ne.tags&&ne.tags.map(Q.to),Te}Me.to=Ce})(Ee||(e.WorkspaceSymbol=Ee={}));var he;(function(Me){function Fe(ne){const Te={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:c.from(ne.range),selectionRange:c.from(ne.selectionRange),kind:le.from(ne.kind),tags:ne.tags?.map(Q.from)??[]};return ne.children&&(Te.children=ne.children.map(Fe)),Te}Me.from=Fe;function Ce(ne){const Te=new s.$RK(ne.name,ne.detail,le.to(ne.kind),c.to(ne.range),c.to(ne.selectionRange));return(0,D.$Kb)(ne.tags)&&(Te.tags=ne.tags.map(Q.to)),ne.children&&(Te.children=ne.children.map(Ce)),Te}Me.to=Ce})(he||(e.DocumentSymbol=he={}));var K;(function(Me){function Fe(ne){const Te=new s.$VK(le.to(ne.kind),ne.name,ne.detail||"",v.URI.revive(ne.uri),c.to(ne.range),c.to(ne.selectionRange));return Te._sessionId=ne._sessionId,Te._itemId=ne._itemId,Te}Me.to=Fe;function Ce(ne,Te,qe){if(Te=Te??ne._sessionId,qe=qe??ne._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,name:ne.name,detail:ne.detail,kind:le.from(ne.kind),uri:ne.uri,range:c.from(ne.range),selectionRange:c.from(ne.selectionRange),tags:ne.tags?.map(Q.from)}}Me.from=Ce})(K||(e.CallHierarchyItem=K={}));var U;(function(Me){function Fe(Ce){return new s.$WK(K.to(Ce.from),Ce.fromRanges.map(ne=>c.to(ne)))}Me.to=Fe})(U||(e.CallHierarchyIncomingCall=U={}));var ie;(function(Me){function Fe(Ce){return new s.$XK(K.to(Ce.to),Ce.fromRanges.map(ne=>c.to(ne)))}Me.to=Fe})(ie||(e.CallHierarchyOutgoingCall=ie={}));var be;(function(Me){function Fe(ne){return{range:ne.range&&c.from(ne.range),uri:ne.uri}}Me.from=Fe;function Ce(ne){return new s.$LK(v.URI.revive(ne.uri),c.to(ne.range))}Me.to=Ce})(be||(e.location=be={}));var H;(function(Me){function Fe(ne){const Te=ne,qe=ne;return{originSelectionRange:Te.originSelectionRange?c.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:qe.uri,range:c.from(Te.targetRange?Te.targetRange:qe.range),targetSelectionRange:Te.targetSelectionRange?c.from(Te.targetSelectionRange):void 0}}Me.from=Fe;function Ce(ne){return{targetUri:v.URI.revive(ne.uri),targetRange:c.to(ne.range),targetSelectionRange:ne.targetSelectionRange?c.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?c.to(ne.originSelectionRange):void 0}}Me.to=Ce})(H||(e.DefinitionLink=H={}));var _;(function(Me){function Fe(ne){return{range:c.from(ne.range),contents:F.fromMany(ne.contents)}}Me.from=Fe;function Ce(ne){return new s.$OK(ne.contents.map(F.to),c.to(ne.range))}Me.to=Ce})(_||(e.Hover=_={}));var Z;(function(Me){function Fe(ne){return{range:c.from(ne.range),expression:ne.expression}}Me.from=Fe;function Ce(ne){return new s.$HL(c.to(ne.range),ne.expression)}Me.to=Ce})(Z||(e.EvaluatableExpression=Z={}));var $e;(function(Me){function Fe(ne){if(ne instanceof s.$IL)return{type:"text",range:c.from(ne.range),text:ne.text};if(ne instanceof s.$JL)return{type:"variable",range:c.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof s.$KL)return{type:"expression",range:c.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Fe;function Ce(ne){switch(ne.type){case"text":return{range:c.to(ne.range),text:ne.text};case"variable":return{range:c.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:c.to(ne.range),expression:ne.expression}}}Me.to=Ce})($e||(e.InlineValue=$e={}));var re;(function(Me){function Fe(ne){return{frameId:ne.frameId,stoppedLocation:c.from(ne.stoppedLocation)}}Me.from=Fe;function Ce(ne){return new s.$LL(ne.frameId,c.to(ne.stoppedLocation))}Me.to=Ce})(re||(e.InlineValueContext=re={}));var fe;(function(Me){function Fe(ne){return{range:c.from(ne.range),kind:ne.kind}}Me.from=Fe;function Ce(ne){return new s.$PK(c.to(ne.range),ne.kind)}Me.to=Ce})(fe||(e.DocumentHighlight=fe={}));var te;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Fe})(te||(e.CompletionTriggerKind=te={}));var de;(function(Me){function Fe(Ce){return{triggerKind:te.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Fe})(de||(e.CompletionContext=de={}));var pe;(function(Me){function Fe(ne){switch(ne){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Fe;function Ce(ne){switch(ne){case 1:return s.CompletionItemTag.Deprecated}}Me.to=Ce})(pe||(e.CompletionItemTag=pe={}));var Pe;(function(Me){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ce(qe){return Fe.get(qe)??9}Me.from=Ce;const ne=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(qe){return ne.get(qe)??s.CompletionItemKind.Property}Me.to=Te})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Me){function Fe(Ce,ne){const Te=new s.$6K(Ce.label);return Te.insertText=Ce.insertText,Te.kind=Pe.to(Ce.kind),Te.tags=Ce.tags?.map(pe.to),Te.detail=Ce.detail,Te.documentation=L.$$j(Ce.documentation)?F.to(Ce.documentation):Ce.documentation,Te.sortText=Ce.sortText,Te.filterText=Ce.filterText,Te.preselect=Ce.preselect,Te.commitCharacters=Ce.commitCharacters,S.$zs.isIRange(Ce.range)?Te.range=c.to(Ce.range):typeof Ce.range=="object"&&(Te.range={inserting:c.to(Ce.range.insert),replacing:c.to(Ce.range.replace)}),Te.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Te.insertText=new s.$KK(Ce.insertText):(Te.insertText=Ce.insertText,Te.textEdit=Te.range instanceof s.$BK?new s.$GK(Te.range,Te.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ce.additionalTextEdits.map(qe=>G.to(qe))),Te.command=ne&&Ce.command?ne.fromInternal(Ce.command):void 0,Te}Me.to=Fe})(B||(e.CompletionItem=B={}));var X;(function(Me){function Fe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:F.fromStrict(ne.documentation)}}Me.from=Fe;function Ce(ne){return{label:ne.label,documentation:L.$$j(ne.documentation)?F.to(ne.documentation):ne.documentation}}Me.to=Ce})(X||(e.ParameterInformation=X={}));var se;(function(Me){function Fe(ne){return{label:ne.label,documentation:F.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(X.from):[],activeParameter:ne.activeParameter}}Me.from=Fe;function Ce(ne){return{label:ne.label,documentation:L.$$j(ne.documentation)?F.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(X.to):[],activeParameter:ne.activeParameter}}Me.to=Ce})(se||(e.SignatureInformation=se={}));var oe;(function(Me){function Fe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.from):[]}}Me.from=Fe;function Ce(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.to):[]}}Me.to=Ce})(oe||(e.SignatureHelp=oe={}));var ee;(function(Me){function Fe(Ce,ne){const Te=new s.$5K(E.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(ge.to.bind(void 0,Ce)),ne.kind&&ye.to(ne.kind));return Te.textEdits=ne.textEdits&&ne.textEdits.map(G.to),Te.tooltip=L.$$j(ne.tooltip)?F.to(ne.tooltip):ne.tooltip,Te.paddingLeft=ne.paddingLeft,Te.paddingRight=ne.paddingRight,Te}Me.to=Fe})(ee||(e.InlayHint=ee={}));var ge;(function(Me){function Fe(Ce,ne){const Te=new s.$4K(ne.label);return Te.tooltip=L.$$j(ne.tooltip)?F.to(ne.tooltip):ne.tooltip,w.Command.is(ne.command)&&(Te.command=Ce.fromInternal(ne.command)),ne.location&&(Te.location=be.to(ne.location)),Te}Me.to=Fe})(ge||(e.InlayHintLabelPart=ge={}));var ye;(function(Me){function Fe(ne){return ne}Me.from=Fe;function Ce(ne){return ne}Me.to=Ce})(ye||(e.InlayHintKind=ye={}));var je;(function(Me){function Fe(ne){return{range:c.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=Fe;function Ce(ne){let Te;if(ne.url)try{Te=typeof ne.url=="string"?v.URI.parse(ne.url,!0):v.URI.revive(ne.url)}catch{}return new s.$$K(c.to(ne.range),Te)}Me.to=Ce})(je||(e.DocumentLink=je={}));var We;(function(Me){function Fe(ne){const Te=new s.$bL(ne.label);return ne.textEdit&&(Te.textEdit=G.to(ne.textEdit)),ne.additionalTextEdits&&(Te.additionalTextEdits=ne.additionalTextEdits.map(qe=>G.to(qe))),Te}Me.to=Fe;function Ce(ne){return{label:ne.label,textEdit:ne.textEdit?G.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Te=>G.from(Te)):void 0}}Me.from=Ce})(We||(e.ColorPresentation=We={}));var et;(function(Me){function Fe(ne){return new s.$_K(ne[0],ne[1],ne[2],ne[3])}Me.to=Fe;function Ce(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=Ce})(et||(e.Color=et={}));var Ye;(function(Me){function Fe(ne){return{range:c.from(ne.range)}}Me.from=Fe;function Ce(ne){return new s.$UK(c.to(ne.range))}Me.to=Ce})(Ye||(e.SelectionRange=Ye={}));var rt;(function(Me){function Fe(Ce){switch(Ce){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var nt;(function(Me){function Fe(ne){switch(ne){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Fe;function Ce(ne){switch(ne){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=Ce})(nt||(e.TextEditorLineNumbersStyle=nt={}));var Ae;(function(Me){function Fe(ne){if(ne===s.EndOfLine.CRLF)return 1;if(ne===s.EndOfLine.LF)return 0}Me.from=Fe;function Ce(ne){if(ne===1)return s.EndOfLine.CRLF;if(ne===0)return s.EndOfLine.LF}Me.to=Ce})(Ae||(e.EndOfLine=Ae={}));var Oe;(function(Me){function Fe(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Fe})(Oe||(e.ProgressLocation=Oe={}));var Ve;(function(Me){function Fe(ne){const Te={start:ne.start+1,end:ne.end+1};return ne.kind&&(Te.kind=Le.from(ne.kind)),Te}Me.from=Fe;function Ce(ne){const Te={start:ne.start-1,end:ne.end-1};return ne.kind&&(Te.kind=Le.to(ne.kind)),Te}Me.to=Ce})(Ve||(e.FoldingRange=Ve={}));var Le;(function(Me){function Fe(ne){if(ne)switch(ne){case s.FoldingRangeKind.Comment:return w.$ot.Comment;case s.FoldingRangeKind.Imports:return w.$ot.Imports;case s.FoldingRangeKind.Region:return w.$ot.Region}}Me.from=Fe;function Ce(ne){if(ne)switch(ne.value){case w.$ot.Comment.value:return s.FoldingRangeKind.Comment;case w.$ot.Imports.value:return s.FoldingRangeKind.Imports;case w.$ot.Region.value:return s.FoldingRangeKind.Region}}Me.to=Ce})(Le||(e.FoldingRangeKind=Le={}));var Ze;(function(Me){function Fe(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?c.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$bE.id:void 0}}Me.from=Fe})(Ze||(e.TextEditorOpenOptions=Ze={}));var ue;(function(Me){function Fe(qe){return qe instanceof s.$vL?qe.toJSON():typeof qe=="string"?qe:Ce(qe)||ne(qe)?new s.$vL(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Me.from=Fe;function Ce(qe){const xe=qe;return xe?v.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ne(qe){const xe=qe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(qe){return typeof qe=="string"?qe:new s.$vL(v.URI.revive(qe.baseUri),qe.pattern)}Me.to=Te})(ue||(e.GlobPattern=ue={}));var ae;(function(Me){function Fe(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Fe);if(typeof Ce=="string")return Ce;{const ne=Ce;return{language:ne.language,scheme:ne.scheme,pattern:ue.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=Fe})(ae||(e.LanguageSelector=ae={}));var Ie;(function(Me){function Fe(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Te=>Array.isArray(Te)&&Te.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&v.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(xe=>xe instanceof s.$BK)))}Me.is=Fe;function Ce(ne){return{documents:ne.documents.map(Te=>Te.map(qe=>({uri:v.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(xe=>c.from(xe))})))}}Me.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Fe(ne){return{start:ne.start,end:ne.end}}Me.from=Fe;function Ce(ne){return new s.$WL(ne.start,ne.end)}Me.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Ge;(function(Me){function Fe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=Fe;function Ce(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=Ce})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var _e;(function(Me){function Fe(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Fe})(_e||(e.NotebookCellExecutionState=_e={}));var st;(function(Me){function Fe(ne){switch(ne){case s.NotebookCellKind.Markup:return n.CellKind.Markup;case s.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Fe;function Ce(ne){switch(ne){case n.CellKind.Markup:return s.NotebookCellKind.Markup;case n.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=Ce})(st||(e.NotebookCellKind=st={}));var lt;(function(Me){function Fe(ne){const Te={metadata:ne.metadata??Object.create(null),cells:[]};for(const qe of ne.cells)s.$XL.validate(qe),Te.cells.push(wt.from(qe));return Te}Me.from=Fe;function Ce(ne){const Te=new s.$YL(ne.cells.map(wt.to));return(0,$.$Pf)(ne.metadata)||(Te.metadata=ne.metadata),Te}Me.to=Ce})(lt||(e.NotebookData=lt={}));var wt;(function(Me){function Fe(ne){return{cellKind:st.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Ge.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Kt.from):[]}}Me.from=Fe;function Ce(ne){return new s.$XL(st.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Kt.to):void 0,ne.metadata,ne.internalMetadata?Ge.to(ne.internalMetadata):void 0)}Me.to=Ce})(wt||(e.NotebookCellData=wt={}));var Ue;(function(Me){function Fe(ne){return{mime:ne.mime,valueBytes:T.$fe.wrap(ne.data)}}Me.from=Fe;function Ce(ne){return new s.$ZL(ne.valueBytes.buffer,ne.mime)}Me.to=Ce})(Ue||(e.NotebookCellOutputItem=Ue={}));var Kt;(function(Me){function Fe(ne){return{outputId:ne.id,items:ne.items.map(Ue.from),metadata:ne.metadata}}Me.from=Fe;function Ce(ne){const Te=ne.items.map(Ue.to);return new s.$1L(Te,ne.outputId,ne.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Fe(Te){return ne(Te)?{include:ue.from(Te.include)??void 0,exclude:ue.from(Te.exclude)??void 0}:ue.from(Te)??void 0}Me.from=Fe;function Ce(Te){return ne(Te)?{include:ue.to(Te.include),exclude:ue.to(Te.exclude)}:ue.to(Te)}Me.to=Ce;function ne(Te){const qe=Te;return qe?!(0,$.$Lf)(qe.include)&&!(0,$.$Lf)(qe.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var Et;(function(Me){function Fe(Ce,ne,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(qe,Te),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Fe})(Et||(e.NotebookStatusBarItem=Et={}));var Ut;(function(Me){function Fe(Ce,ne,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:ne.toInternal(qe,Te),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Fe})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Nt;(function(Me){function Fe(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Me){function Fe(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=Fe;function Ce(ne){return new s.$3L(v.URI.revive(ne.uri),ne.provides)}Me.to=Ce})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Me){function Fe(ne){return{message:F.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:c.from(ne.location.range),uri:ne.location.uri}}}Me.from=Fe;function Ce(ne){const Te=new s.$9L(typeof ne.message=="string"?ne.message:F.to(ne.message));return Te.actualOutput=ne.actual,Te.expectedOutput=ne.expected,Te.contextValue=ne.contextValue,Te.location=ne.location?be.to(ne.location):void 0,Te}Me.to=Ce})(Bt||(e.TestMessage=Bt={}));var Dt;(function(Me){Me.namespace=a.$uJ,Me.denamespace=a.$vJ})(Dt||(e.TestTag=Dt={}));var Mt;(function(Me){function Fe(ne){const Te=(0,o.$vM)(ne).controllerId;return{extId:r.$qJ.fromExtHostTestItem(ne,Te).toString(),label:ne.label,uri:v.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(qe=>Dt.namespace(Te,qe.id)),range:S.$zs.lift(c.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&F.fromStrict(ne.error)||null}}Me.from=Fe;function Ce(ne){return{parent:void 0,error:void 0,id:r.$qJ.fromString(ne.extId).localId,label:ne.label,uri:v.URI.revive(ne.uri),tags:(ne.tags||[]).map(Te=>{const{tagId:qe}=Dt.denamespace(Te);return new s.$0L(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=Ce})(Mt||(e.TestItem=Mt={})),function(Me){function Fe(ne){return{id:ne.id}}Me.from=Fe;function Ce(ne){return new s.$0L(ne.id)}Me.to=Ce}(Dt||(e.TestTag=Dt={}));var Wt;(function(Me){const Fe=(ne,Te)=>{const qe=[];for(const[Qe,ot]of Te)r.$qJ.compare(ot.item.extId,Qe)===2&&(Te.delete(Qe),qe.push(ot));const xe={...Mt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ot=>ot.type===0).map(Bt.to)})),children:qe.map(Qe=>Fe(Qe,Te))};for(const Qe of xe.children)Qe.parent=xe;return xe};function Ce(ne){const Te=[],qe=new Map;for(const xe of ne.items){qe.set(xe.item.extId,xe);const Qe=r.$qJ.root(xe.item.extId);ne.request.targets.some(ot=>ot.controllerId===Qe&&ot.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:ne.completedAt,results:Te.map(xe=>Fe(xe,qe))}}Me.to=Ce})(Wt||(e.TestResults=Wt={}));var tt;(function(Me){function Fe(qe){return{covered:qe.covered,total:qe.covered}}function Ce(qe){return"line"in qe?E.from(qe):c.from(qe)}function ne(qe){return"branches"in qe?{count:qe.executionCount,location:Ce(qe.location),type:1,branches:qe.branches.length?qe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,count:qe.executionCount,location:Ce(qe.location)}}Me.fromDetailed=ne;function Te(qe){return{uri:qe.uri,statement:Fe(qe.statementCoverage),branch:qe.branchCoverage&&Fe(qe.branchCoverage),function:qe.functionCoverage&&Fe(qe.functionCoverage),details:qe.detailedCoverage?.map(ne)}}Me.fromFile=Te})(tt||(e.TestCoverage=tt={}));var Vt;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Fe})(Vt||(e.CodeActionTriggerKind=Vt={}));var qt;(function(Me){function Fe(ne){const Te=new s.$dM(le.to(ne.kind),ne.name,ne.detail||"",v.URI.revive(ne.uri),c.to(ne.range),c.to(ne.selectionRange));return Te._sessionId=ne._sessionId,Te._itemId=ne._itemId,Te}Me.to=Fe;function Ce(ne,Te,qe){if(Te=Te??ne._sessionId,qe=qe??ne._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,kind:le.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:c.from(ne.range),selectionRange:c.from(ne.selectionRange),tags:ne.tags?.map(Q.from)}}Me.from=Ce})(qt||(e.TypeHierarchyItem=qt={}));var ut;(function(Me){function Fe(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Fe})(ut||(e.ViewBadge=ut={}));var mt;(function(Me){function Fe(qe,xe,Qe){const ot=xe.fileData;return ot?new s.$oL(new s.$pL(ot.name,v.URI.revive(ot.uri),ot.id,(0,R.$cb)(()=>Qe(ot.id)))):qe===A.$Vr.uriList&&xe.uriListData?new s.$nL(Te(xe.uriListData)):new s.$nL(xe.asString)}Me.to=Fe;async function Ce(qe,xe){const Qe=await xe.asString();if(qe===A.$Vr.uriList)return{asString:Qe,fileData:void 0,uriListData:ne(Qe)};const ot=xe.asFile();return{asString:Qe,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Me.from=Ce;function ne(qe){return g.$9s.split(qe).map(xe=>{if(xe.startsWith("#"))return xe;try{return v.URI.parse(xe)}catch{}return xe})}function Te(qe){return g.$9s.create(qe.map(xe=>typeof xe=="string"?xe:v.URI.revive(xe)))}})(mt||(e.DataTransferItem=mt={}));var Ot;(function(Me){function Fe(ne,Te){const qe=ne.items.map(([xe,Qe])=>[xe,mt.to(xe,Qe,Te)]);return new s.$qL(qe)}Me.toDataTransfer=Fe;async function Ce(ne){const Te={items:[]},qe=[];for(const[xe,Qe]of ne)qe.push((async()=>{Te.items.push([xe,await mt.from(xe,Qe)])})());return await Promise.all(qe),Te}Me.from=Ce})(Ot||(e.DataTransfer=Ot={}));var Pt;(function(Me){function Fe(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Me.from=Fe})(Pt||(e.ChatReplyFollowup=Pt={}));var At;(function(Me){function Fe(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:Pt.from(Ce)}Me.from=Fe})(At||(e.ChatFollowup=At={}));var gt;(function(Me){function Fe(ne){const Te=new s.$oM(St.to(ne.role),ne.content);return Te.name=ne.name,Te}Me.to=Fe;function Ce(ne){return{role:St.from(ne.role),content:ne.content,name:ne.name}}Me.from=Ce})(gt||(e.ChatMessage=gt={}));var St;(function(Me){function Fe(ne){switch(ne){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Me.to=Fe;function Ce(ne){switch(ne){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Me.from=Ce})(St||(e.ChatMessageRole=St={}));var Rt;(function(Me){function Fe(Te){const qe={};for(const xe of Object.keys(Te))qe[xe]=Te[xe].map(Me.to);return qe}Me.objectTo=Fe;function Ce(Te){return{level:It.to(Te.level),value:Te.value,description:Te.description}}Me.to=Ce;function ne(Te){return{level:It.from(Te.level),value:Te.value,description:Te.description}}Me.from=ne})(Rt||(e.ChatVariable=Rt={}));var It;(function(Me){function Fe(ne){switch(ne){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Fe;function Ce(ne){switch(ne){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(It||(e.ChatVariableLevel=It={}));var Je;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Fe})(Je||(e.InteractiveEditorResponseFeedbackKind=Je={}));var jt;(function(Me){function Fe(Ce,ne){if("placeholder"in ne&&"resolvedContent"in ne)return{content:ne.placeholder,kind:"asyncContent"};if("markdownContent"in ne)return(0,d.$MF)(Ce,"chatAgents2Additions"),{content:F.from(ne.markdownContent),kind:"markdownContent"};if("content"in ne)return typeof ne.content=="string"?{content:ne.content,kind:"content"}:((0,d.$MF)(Ce,"chatAgents2Additions"),{content:F.from(ne.content),kind:"markdownContent"});if("documents"in ne)return{documents:ne.documents.map(Te=>({uri:Te.uri,version:Te.version,ranges:Te.ranges.map(qe=>c.from(qe))})),kind:"usedContext"};if("reference"in ne)return{reference:"uri"in ne.reference?{uri:ne.reference.uri,range:c.from(ne.reference.range)}:ne.reference,kind:"reference"};if("inlineReference"in ne)return{inlineReference:"uri"in ne.inlineReference?{uri:ne.inlineReference.uri,range:c.from(ne.inlineReference.range)}:ne.inlineReference,name:ne.title,kind:"inlineReference"};if("agentName"in ne)return(0,d.$MF)(Ce,"chatAgents2Additions"),{agentName:ne.agentName,command:ne.command,kind:"agentDetection"};if("treeData"in ne)return{treeData:ne.treeData,kind:"treeData"};if("message"in ne)return{content:ne.message,kind:"progressMessage"};throw new Error("Invalid progress type: "+JSON.stringify(ne))}Me.from=Fe})(jt||(e.ChatResponseProgress=jt={}));var Jt;(function(Me){function Fe(Ce,ne,Te){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:ne.toInternal(Ce,Te)}Me.from=Fe})(Jt||(e.TerminalQuickFix=Jt={}))}),define(ke[294],Se([1,0,2,8,7,15,75]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class b{constructor(m,A,C,$={timeout:1500,errors:3}){this.c=m,this.d=A,this.f=C,this.g=$,this.a=new L.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(m){return(A,C,$)=>{const S={dispose:this.a.push([A,C,m])};return Array.isArray($)&&$.push(S),S}}async $participateInSave(m,A){const C=D.URI.revive(m);let $=!1;const v=setTimeout(()=>$=!0,this.g.timeout),S=[];try{for(const w of[...this.a]){if($)break;const u=this.d.getDocument(C),o=await this.h(w,{document:u,reason:R.TextDocumentSaveReason.to(A)});S.push(o)}}finally{clearTimeout(v)}return S}h([m,A,C],$){const v=this.b.get(m);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(C,m,A,$).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const w=this.b.get(m);this.b.set(m,w?w+1:1),typeof w=="number"&&w>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(m,A,C,$){const v=[],S=Date.now(),{document:w,reason:u}=$,{version:o}=w,i=Object.freeze({document:w,reason:u,waitUntil(n){if(Object.isFrozen(v))throw(0,T.$7)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{A.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,r)=>{const a=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),r(t)})}).then(n=>{const r={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof g.$GK))for(const{newText:t,newEol:s,range:d}of a)r.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:d&&R.Range.from(d),text:t,eol:s&&R.EndOfLine.from(s)}});if(r.edits.length!==0)return o===w.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$gfc=b}),define(ke[295],Se([1,0,17,2,15,7,111]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=void 0;class b{constructor(C,$,v,S){this.start=C,this.deletedCount=$,this.deletedItems=v,this.items=S}asApiEvent(){return{range:new R.$WL(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(C,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,$,v){this.notebook=C,this.h=$,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(g.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(v)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,$,v){const S=v.map(g.NotebookCellOutputItem.to),w=this.a.find(u=>u.id===C);if(w&&($||(w.items.length=0),w.items.push(...S),w.items.length>1&&w.items.every(u=>L.$CI(u.mime)))){const u=new Map,o=[];w.items.forEach(i=>{let n;u.has(i.mime)?n=u.get(i.mime):(n=[],u.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),w.items.length=0,o.forEach(i=>{const n=L.$DI(u.get(i));w.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$lfc=y;class m{static{this.a=0}constructor(C,$,v,S,w){this.k=C,this.l=$,this.m=v,this.uri=S,this.handle=m.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=w.viewType,this.f=Object.freeze(w.metadata??Object.create(null)),this.r([[0,0,w.cells]],!0,void 0),this.g=w.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,$={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(v){return v=C.n(v),C.b[v].apiCell},getCells(v){return(v?C.p(v):C.b).map(w=>w.apiCell)},save(){return C.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,$,v){this.g=C.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:v});const S={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},w=[];for(const o of C.rawEvents)o.kind===L.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===L.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===L.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),w.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),w.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),w.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===L.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),w.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),w.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const u=new Map;for(let o=0;o<w.length;o++){const i=w[o],n=u.get(i.cell);if(n===void 0){const r=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});u.set(i.cell,r-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let $=C.start|0,v=C.end|0;return $<0&&($=0),v>this.b.length&&(v=this.b.length),C.with({start:$,end:v})}p(C){C=this.o(C);const $=[];for(let v=C.start;v<C.end;v++)$.push(this.b[v]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,$,v){if(this.j)return;const S=[],w=[],u=[];if(C.reverse().forEach(o=>{const n=o[2].map(t=>{const s=new y(this,this.l,t);return $||w.push(y.asModelAddData(this.apiNotebook,t)),s}),r=new b(o[0],o[1],[],n),a=this.b.splice(o[0],o[1],...n);for(const t of a)u.push(t.uri),r.deletedItems.push(t.apiCell);S.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:u}),v)for(const o of S)v.push(o.asApiEvent())}s(C,$,v,S){const w=this.b.splice(C,$);this.b.splice(v,0,...w);const u=[new b(C,$,w.map(o=>o.apiCell),[]),new b(v,0,[],w)];for(const o of u)S.push(o.asApiEvent())}t(C,$){this.b[C].setOutputs($)}u(C,$,v,S){this.b[C].setOutputItems($,v,S)}v(C,$){const v=this.b[C];v.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(v.uri,$)}w(C,$){const v=this.b[C];v.apiCell.mime=$}x(C,$){this.b[C].setMetadata($)}y(C,$){this.b[C].setInternalMetadata($)}getCellFromApiCell(C){return this.b.find($=>$.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find($=>$.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$mfc=m}),define(ke[296],Se([1,0,4,2,15,7]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class L{constructor(y,m,A,C={timeout:1500,errors:3}){this.b=y,this.c=m,this.d=A,this.f=C,this.a=new D.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(m,A,C)=>{const $=function(S){m.call(A,S)};return $.extension=y,this.a.event($,void 0,C)}}async $participateInSave(y,m,A){const C=T.URI.revive(y),$=this.c.getNotebookDocument(C);if(!$)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:g.TextDocumentSaveReason.to(m)},A,async(w,u)=>{const o=Date.now(),i=await await Promise.resolve(w);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof R.$JK?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const S={edits:[]};for(const w of v){const{edits:u}=g.WorkspaceEdit.from(w);S.edits=S.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Cfc=L}),define(ke[148],Se([1,0,8,15,7]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,y,m,A,C,$){this.id=b,this.f=y,this.notebookData=m,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=$}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(y){this.selections=[y]},get selections(){return b.a},set selections(y){if(!Array.isArray(y)||!y.every(g.$WL.isNotebookRange))throw(0,D.$6)("selections");b.a=y,b.g(y)},get visibleRanges(){return b.b},revealRange(y,m){b.f.$tryRevealRange(b.id,T.NotebookRange.from(y),m??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(T.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$nfc=R}),define(ke[297],Se([1,0,8,4,14,15]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;let L=class{constructor(y,m){this.c=y,this.d=m,this.a=new T.$Rd({onListenerError:D.$1}),this.b=new T.$Rd({onListenerError:D.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(y,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,m);const A=this.d.getEditorById(y);m.visibleRanges&&A._acceptVisibleRanges(m.visibleRanges.ranges.map(R.NotebookRange.to)),m.selections&&A._acceptSelections(m.selections.selections.map(R.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const m in y)this.d.getEditorById(m)._acceptViewColumn(R.ViewColumn.to(y[m]))}};e.$Efc=L,e.$Efc=L=He([Be(0,g.$dj)],L)}),define(ke[298],Se([1,0,15,85,216,21,59,8]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class y{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,v,S){const w=this.b++,{title:u,location:o,cancellable:i}=v,n={label:(0,g.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(w,{location:D.ProgressLocation.from(o),title:u,source:n,cancellable:i},$.isUnderDevelopment?void 0:$.identifier.value).catch(b.$1),this.d(w,S,!!i)}d($,v,S){let w;S&&(w=new R.$2d,this.c.set($,w));const u=i=>{this.a.$progressEnd(i),this.c.delete(i),w?.dispose()};let o;try{o=v(new A(this.a,$),S&&w?w.token:R.CancellationToken.None)}catch(i){throw u($),i}return o.then(i=>u($),i=>u($)),o}$acceptProgressCanceled($){const v=this.c.get($);v&&(v.cancel(),this.c.delete($))}}e.$Lfc=y;function m(C,$){return C.message=$.message,typeof $.increment=="number"&&(typeof C.increment=="number"?C.increment+=$.increment:C.increment=$.increment),C}class A extends T.$$u{constructor($,v){super(S=>this.throttledReport(S)),this.c=$,this.d=v}throttledReport($){this.c.$progressReport(this.d,$)}}He([(0,L.$ph)(100,(C,$)=>m(C,$),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(ke[149],Se([1,0,29,144,67,112,89,15,2]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=e.$LM=void 0;const m=(n,r,a,t)=>{let s=r;return{enumerable:!0,configurable:!1,get(){return s},set(d){if(!a(s,d)){const l=s;s=d,n.listener?.(t(d,l))}}}},A=(n,r)=>n===r,C={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.find(t=>a.id===t.id)))},$=n=>r=>({op:4,update:n(r)}),v=(n,r)=>({range:(()=>{let a;const t=$(s=>({range:D.$zs.lift(b.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return a},set(s){n.listener?.({op:6}),C.range(a,s)||(a=s,n.listener?.(t(s)))}}})(),label:m(n,r,C.label,$(a=>({label:a}))),description:m(n,void 0,C.description,$(a=>({description:a}))),sortText:m(n,void 0,C.sortText,$(a=>({sortText:a}))),canResolveChildren:m(n,!1,C.canResolveChildren,a=>({op:2,state:a})),busy:m(n,!1,C.busy,$(a=>({busy:a}))),error:m(n,void 0,C.error,$(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:m(n,[],C.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=n=>{const r=g.$qJ.fromString(n.extId),a=new u(r.controllerId,r.localId,n.label,y.URI.revive(n.uri)||void 0);return a.range=b.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>b.TestTag.to({id:(0,L.$vJ)(t).tagId})),a},w=n=>{let r;for(const a of n.tests){const t=S(a.item);(0,T.$vM)(t).parent=r,r=t}return r};e.$LM=w;class u{constructor(r,a,t,s){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,T.$uM)(this,r);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,R.$tM)(d,T.$vM,u),enumerable:!0,writable:!1},...v(d,t)})}}e.$MM=u;class o extends u{constructor(r,a){super(r,r,a,void 0),this._isRoot=!0}}e.$NM=o;class i extends R.$pM{constructor(r,a,t){super({controllerId:r,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:T.$vM,getChildren:s=>s.children,root:new o(r,a),toITestItem:b.TestItem.from})}}e.$OM=i}),define(ke[150],Se([1,0,60,8,122,15,7]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=e.$GM=void 0;class b{static{this.c=new g.$EM("TextEditorDecorationType")}constructor($,v,S){const w=b.c.nextId();$.$registerTextEditorDecorationType(v.identifier,w,R.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:w,dispose(){$.$removeTextEditorDecorationType(w)}})}}e.$GM=b;class y{constructor($,v){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,v){this.k();let S=null;if($ instanceof L.$AK)S=new L.$BK($,$);else if($ instanceof L.$BK)S=$;else throw new Error("Unrecognized location");this.l(S,v,!1)}insert($,v){this.k(),this.l(new L.$BK($,$),v,!0)}delete($){this.k();let v=null;if($ instanceof L.$BK)v=$;else throw new Error("Unrecognized location");this.l(v,null,!0)}l($,v,S){const w=this.c.validateRange($);this.g.push({range:w,text:v,forceMoveMarkers:S})}setEndOfLine($){if(this.k(),$!==L.EndOfLine.LF&&$!==L.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=$}}class m{constructor($,v,S,w){this.c=$,this.d=v,this._accept(S),this.e=w;const u=this;this.value={get tabSize(){return u.f},set tabSize(o){u.m(o)},get indentSize(){return u.g},set indentSize(o){u.o(o)},get insertSpaces(){return u.h},set insertSpaces(o){u.q(o)},get cursorStyle(){return u.j},set cursorStyle(o){u.s(o)},get lineNumbers(){return u.k},set lineNumbers(o){u.t(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const v=Math.floor($);return v>0?v:null}if(typeof $=="string"){const v=parseInt($,10);return isNaN(v)?null:v>0?v:null}return null}m($){const v=this.l($);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const v=Math.floor($);return v>0?v:null}if(typeof $=="string"){const v=parseInt($,10);return isNaN(v)?null:v>0?v:null}return null}o($){const v=this.n($);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const v=this.p($);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const v={};let S=!1;if(typeof $.tabSize<"u"){const w=this.l($.tabSize);w==="auto"?(S=!0,v.tabSize=w):typeof w=="number"&&this.f!==w&&(this.f=w,S=!0,v.tabSize=w)}if(typeof $.indentSize<"u"){const w=this.n($.indentSize);w==="tabSize"?(S=!0,v.indentSize=w):typeof w=="number"&&this.g!==w&&(this.g=w,S=!0,v.indentSize=w)}if(typeof $.insertSpaces<"u"){const w=this.p($.insertSpaces);w==="auto"?(S=!0,v.insertSpaces=w):this.h!==w&&(this.h=w,S=!0,v.insertSpaces=w)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,S=!0,v.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,S=!0,v.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u($,v){v.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(S)})}}e.$HM=m;class A{constructor($,v,S,w,u,o,i,n){this.id=$,this.j=v,this.k=S,this.g=!1,this.h=new Set,this.c=u,this.d=new m(this.j,this.id,o,S),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return w.value},set document(a){throw new T.$8("document")},get selection(){return r.c&&r.c[0]},set selection(a){if(!(a instanceof L.$CK))throw(0,T.$6)("selection");r.c=[a],r.l()},get selections(){return r.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof L.$CK)))throw(0,T.$6)("selections");r.c=a,r.l()},get visibleRanges(){return r.e},set visibleRanges(a){throw new T.$8("visibleRanges")},get options(){return r.d.value},set options(a){r.g||r.d.assign(a)},get viewColumn(){return r.f},set viewColumn(a){throw new T.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(w.value,t);return a(s),r.m(s)},insertSnippet(a,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>R.Range.from(l));else if(t instanceof L.$AK){const{lineNumber:l,column:c}=R.Position.from(t);d=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof L.$BK)d=[R.Range.from(t)];else{d=[];for(const l of t)if(l instanceof L.$BK)d.push(R.Range.from(l));else{const{lineNumber:c,column:h}=R.Position.from(l);d.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return v.$tryInsertSnippet($,w.value.version,a.value,d,s)},setDecorations(a,t){const s=t.length===0;s&&!r.h.has(a.key)||(s?r.h.delete(a.key):r.h.add(a.key),r.n(()=>{if(R.$wM(t))return v.$trySetDecorations($,a.key,R.$xM(t));{const d=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return v.$trySetDecorationsFast($,a.key,d)}}))},revealRange(a,t){r.n(()=>v.$tryRevealRange($,R.Range.from(a),t||L.TextEditorRevealType.Default))},show(a){v.$tryShowEditor($,R.ViewColumn.from(a))},hide(){v.$tryHideEditor($)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions($){(0,D.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,D.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,D.ok)(!this.g),this.f=$}_acceptSelections($){(0,D.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const v=$.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const S=v.edits.map(u=>u.range);S.sort((u,o)=>u.end.line===o.end.line?u.end.character===o.end.character?u.start.line===o.start.line?u.start.character-o.start.character:u.start.line-o.start.line:u.end.character-o.end.character:u.end.line-o.end.line);for(let u=0,o=S.length-1;u<o;u++){const i=S[u].end;if(S[u+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=v.edits.map(u=>({range:R.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,w,{setEndOfLine:typeof v.setEndOfLine=="number"?R.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$IM=A}),define(ke[299],Se([1,0,220,23,2,4,3,279,12,7,18,19,15,80,21,177,25]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;function o(r,a){if((0,A.$Cf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends L.$Rc{constructor(a,t,s){super(),this.f=a,this.g=t,this.h=s,this.a=new Map,this.b=new w.$Q7;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(c=>d(c)?this.r(c):c):l})}registerTreeDataProvider(a,t,s){const d=this.createTreeView(a,{treeDataProvider:t},s);return{dispose:()=>d.dispose()}}createTreeView(a,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,E=this.m(a,t,s),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(a,I),p={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,u.$MF)(s,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,u.$MF)(s,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(k){(0,v.$$j)(k)&&(0,u.$MF)(s,"treeViewMarkdownMessage"),E.message=k},get title(){return E.title},set title(k){E.title=k},get description(){return E.description},set description(k){E.description=k},get badge(){return E.badge},set badge(k){k!==void 0&&m.ViewBadge.isViewBadge(k)?E.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(E.badge=void 0)},reveal:(k,P)=>E.reveal(k,P),dispose:async()=>{await f,this.a.delete(a),E.dispose()}};return this.B(p),p}$getChildren(a,t){const s=this.a.get(a);return s?s.getChildren(t):Promise.reject(new b.$KE(a))}async $handleDrop(a,t,s,d,l,c,h,E){const I=this.a.get(a);if(!I)return Promise.reject(new b.$KE(a));const f=$.DataTransfer.toDataTransfer(s,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return h===a&&E&&await this.j(f,I,E,l,c),I.onDrop(f,d,l)}async j(a,t,s,d,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((h,E)=>{h&&a.set(E,h)});else if(l&&t.handleDrag){const h=t.handleDrag(s,a,d);this.b.addDragOperationTransfer(l,h),await h}return a}async $handleDrag(a,t,s,d){const l=this.a.get(a);if(!l)return Promise.reject(new b.$KE(a));const c=await this.j(new m.$qL,l,t,d,s);if(!(!c||d.isCancellationRequested))return $.DataTransfer.from(c)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$KE(a);return t.hasResolve}$resolve(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);return d.resolveTreeItem(t,s)}$setExpanded(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);d.setExpanded(t,s)}$setSelectionAndFocus(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);d.setSelectionAndFocus(t,s)}$setVisible(a,t){const s=this.a.get(a);if(!s){if(!t)return;throw new b.$KE(a)}s.setVisible(t)}$changeCheckboxState(a,t){const s=this.a.get(a);if(!s)throw new b.$KE(a);s.setCheckboxState(t)}m(a,t,s){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,s));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$5fc=i;class n extends L.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$Lf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,s,d,l,c){if(super(),this.I=a,this.J=s,this.L=d,this.M=l,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$2d,c.contributes&&c.contributes.views)for(const f in c.contributes.views)for(const p of c.contributes.views[f])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let h,E;const I=R.Event.debounce(this.F.event,(f,p)=>(f||(f={message:!1,elements:[]}),p.element!==!1&&(h||(h=new Promise(k=>E=k),this.G=this.G.then(()=>h)),Array.isArray(p.element)?f.elements.push(...p.element):f.elements.push(p.element)),p.message&&(f.message=!0),f),200,!0);this.B(I(({message:f,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const k=E;return h=null,this.$(p).then(()=>k())})),f&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let s=this.X(a);return s||(s=await this.Y(t)),s?s.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const s=(0,A.$Lf)(t.select)?!0:t.select,d=(0,A.$Lf)(t.focus)?!1:t.focus,l=(0,A.$Lf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(c=>this.W(a,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(E=>E.item)},{select:s,focus:d,expand:l})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:s,focus:d,expand:l})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=$.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const s=this.getExtensionElement(a);s&&(t?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(a,t){const s=!(0,C.$tb)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async s=>{const d=this.getExtensionElement(s.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:s.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(a,t,s){const d=[];for(const l of a){const c=this.getExtensionElement(l);c&&d.push(c)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,s){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,y.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const s=this.j.get(a);if(s){const d=this.m.get(s);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,s,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(s=>this.W(t,s[s.length-1]).then(d=>(s.push(d),s))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,y.$Qg)(()=>this.f.getParent(a))}W(a,t){const s=this.m.get(a);return s?Promise.resolve(s):(0,y.$Qg)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const c=this.m.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const s=this.getExtensionElement(a);t=s?this.m.get(s):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$2d(this.Z.token);try{const s=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,C.$Gb)(d||[]).map(async c=>{const h=await this.f.getTreeItem(c);return h&&!t.token.isCancellationRequested?this.db(c,h,s):null}));return t.token.isCancellationRequested?void 0:(0,C.$Gb)(l)}finally{t.dispose()}}$(a){if(a.some(s=>!s))return this.Z.dispose(!0),this.Z=new S.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(a);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(a){const t=new Set,s=a.map(l=>this.m.get(l));for(const l of s)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&s.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const c=this.j.get(l);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(a){const t={};return Promise.all(a.map(s=>this.cb(s).then(d=>{d&&(t[s]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const s=this.m.get(t);if(s)return this.rb(t),(0,y.$Qg)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,s.parent);return this.pb(t,l,s,s.parent),s.dispose(),l}return null})}return Promise.resolve(null)}db(a,t,s){const d=this.ib(a,t,s);if(t.id&&this.j.has(d.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,s),d}eb(a){return m.$ZK.isMarkdownString(a)?$.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,s,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,s=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===m.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:d}}hb(a){if(!m.$lL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,s){this.hb(t);const d=this.B(new L.$Qc),l=this.kb(a,t,s),c=this.lb(t);return{item:{handle:l,parentHandle:s?s.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$Lf)(t.collapsibleState)?m.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof m.$tL?a.iconPath:void 0}kb(a,{id:t,label:s,resourceUri:d},l,c){if(t)return`${n.b}/${t}`;const h=o(s,this.N),E=l?l.item.handle:n.a;let I=h?h.label:d?(0,T.$wg)(d):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const f=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(l)||[];let k,P=0;do{if(k=`${E}/${P}:${I}`,c||!this.j.has(k)||f===k)break;P++}while(P<=p.length);return k}lb(a){if(a.iconPath&&!(a.iconPath instanceof m.$tL))return typeof a.iconPath=="string"||g.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof m.$tL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return g.URI.isUri(a)?a:g.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,s,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(a,t);const l=this.X(d)||[],c=l.filter(h=>h.item.handle===s.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[300],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[301],Se([1,0,234,8,39,135,108,37,26,300,138,139]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const $=b.$mn.as(L.$nn.JSONContribution);class v{constructor(a,t,s){this.a=a,this.b=t,this.c=s}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(g.default.Error,a)}warn(a){this.d(g.default.Warning,a)}info(a){this.d(g.default.Info,a)}}e.$SF=v;class S{static a(a){const t=new y.$am;for(let s=0,d=a.length;s<d;s++)t.add(a[s].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const s=this.a(a),d=this.a(t),l=t.filter(h=>!s.has(h.description.identifier)),c=a.filter(h=>!d.has(h.description.identifier));return new S(l,c)}constructor(a,t){this.added=a,this.removed=t}}e.$TF=S;class w{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,T.$Z)(a)}}}e.$UF=w;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$VF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.$$l},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4n}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4n}},extensionKind:{description:D.localize(52,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new w(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&C.$xF.register(a.extensionPoint,a.activationEventsGenerator),e.$VF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,$.registerSchema(o,e.$VF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$WF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$mn.add(n.ExtensionsRegistry,new i),e.$XF=b.$mn.as(n.ExtensionsRegistry),$.registerSchema(o,e.$VF),$.registerSchema(A.$wj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(ke[302],Se([1,0,230,18,24,301,45,4]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var m;(function($){function v(S,w,u){if(!S)return;const o=T.$Cf(S.type)?S.type:void 0;if(!o||o.length===0){u.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)T.$Cf(n)&&i.push(n);return{extensionId:w.value,taskType:o,required:i,properties:S.properties?g.$an(S.properties):{},when:S.when?L.$Ti.deserialize(S.when):void 0}}$.from=v})(m||(m={}));const A=R.$XF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,v)=>{for(const S of $)S.type&&v.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:y}});class C{constructor(){this.d=new b.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,S)=>{A.setHandler((w,u)=>{this.c=void 0;try{for(const o of u.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of u.added){const i=o.value;for(const n of i){const r=m.from(n,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const S of this.all()){const w={type:"object",additionalProperties:!1};S.required.length>0&&(w.required=S.required.slice(0)),S.properties!==void 0?w.properties=g.$an(S.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[S.taskType]},v.push(w)}this.c={oneOf:v}}return this.c}}e.$7F=new C}),define(ke[303],Se([1,0,231,18,23,24,45,302]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$eG=e.JsonSchemaVersion=e.ExecutionEngine=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$$F=e.ShellQuoting=e.$0F=e.$9F=e.$8F=void 0,e.$8F="settings",e.$9F=new L.$aj("taskRunning",!1,D.localize(0,null)),e.$0F={value:D.localize(1,null),original:"Tasks"};var y;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.$$F="$customized",function(N){function O(W){if(!W)return N.Strong;switch(W.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=O}(y||(e.ShellQuoting=y={}));var m;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function O(W){switch(W.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=O}(A||(e.RevealKind=A={}));var C;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(N){function O(W){switch(W.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=O}(C||(e.RevealProblemKind=C={}));var $;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})($||(e.PanelKind=$={})),function(N){function O(W){switch(W.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=O}($||(e.PanelKind=$={}));var v;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(N){function O(x){switch(x.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=O;function W(x){switch(x){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=W}(S||(e.RuntimeType=S={}));var w;(function(N){function O(W){return T.$Cf(W)?W:W.value}N.value=O})(w||(e.CommandString=w={}));var u;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function O(x){return x===N.Clean._id||x===N.Build._id||x===N.Rebuild._id||x===N.Test._id}N.is=O;function W(x){if(x!==void 0)return T.$Cf(x)?O(x)?{_id:x,isDefault:!1}:void 0:x}N.from=W})(u||(e.TaskGroup=u={}));var o;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function O(W){switch(W){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var a;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(O,W,x,ce,Y,G){this._label="",this._id=O,W&&(this._label=W),x&&(this.type=x),this.runOptions=ce,this.configurationProperties=Y,this._source=G}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,W=!1){if(O===void 0)return!1;if(T.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||W&&O===this._id;const x=this.getDefinition(!0);return x!==void 0&&x._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$_F=t;class s extends t{constructor(O,W,x,ce,Y,G,J,le){super(O,x,void 0,J,le,W),this.command={},this._source=W,this.hasDefinedMatchers=G,Y&&(this.command=Y)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case S.Shell:W="shell";break;case S.Process:W="process";break;case S.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$$F,folder:O,id:W};return JSON.stringify(x)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$aG=s;class d extends t{constructor(O,W,x,ce,Y,G,J){super(O,x,ce,G,J,W),this._source=W,this.configures=Y}static is(O){return O instanceof d}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$$F,folder:O,id:W};return JSON.stringify(x)}}e.$bG=d;class l extends t{constructor(O,W,x,ce,Y,G,J,le,Q){super(O,x,ce,le,Q,W),this.defines=Y,this.hasDefinedMatchers=J,this.command=G,this.icon=Q.icon,this.hide=Q.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof l}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new l(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$cG=l;class c extends t{constructor(O,W,x,ce,Y,G){super(O,x,ce,Y,G,W),this._source=W}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new c(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$dG=c;var h;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(N){N._default=N.Terminal}(h||(e.ExecutionEngine=h={}));var E;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class I{constructor(O){this.c=new Map;for(let W=0;W<O.length;W++)this.c.set(O[W].uri.toString(),W)}compare(O,W){const x=O.getWorkspaceFolder(),ce=W.getWorkspaceFolder();if(x&&ce){let Y=this.c.get(x.uri.toString());Y=Y===void 0?0:Y+1;let G=this.c.get(ce.uri.toString());return G=G===void 0?0:G+1,Y===G?O._label.localeCompare(W._label):Y-G}else return!x&&ce?-1:x&&!ce?1:0}}e.$eG=I;var f;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(f||(e.TaskEventKind=f={}));var p;(function(N){N.SingleRun="singleRun",N.Background="background"})(p||(e.TaskRunType=p={}));var k;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(N){function O(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function W(le,Q,Ee){return{...O(le),kind:"start",terminalId:Q,resolvedVariables:Ee}}N.start=W;function x(le,Q,Ee){return{...O(le),kind:"processStarted",terminalId:Q,processId:Ee}}N.processStarted=x;function ce(le,Q,Ee){return{...O(le),kind:"processEnded",terminalId:Q,exitCode:Ee}}N.processEnded=ce;function Y(le,Q,Ee){return{...O(le),kind:"terminated",exitReason:Ee,terminalId:Q}}N.terminated=Y;function G(le,Q,Ee){return{...O(Q),kind:le,terminalId:Ee}}N.general=G;function J(){return{kind:"changed"}}N.changed=J})(P||(e.TaskEvent=P={}));var j;(function(N){function O(x){const ce=Object.keys(x).sort();let Y="";for(const G of ce){let J=x[G];J instanceof Object?J=O(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),Y+=G+","+J+","}return Y}function W(x){const Y={_key:O(x),type:x.taskType};return Object.assign(Y,x),Y}N.create=W})(j||(e.KeyedTaskIdentifier=j={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var M;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var F;(function(N){function O(W,x){const ce=b.$7F.get(W.type);if(ce===void 0){const le=R.$an(W);return delete le._key,j.create(le)}const Y=Object.create(null);Y.type=ce.taskType;const G=new Set;ce.required.forEach(le=>G.add(le));const J=ce.properties;for(const le of Object.keys(J)){const Q=W[le];if(Q!=null)Y[le]=Q;else if(G.has(le)){const Ee=J[le];if(Ee.default!==void 0)Y[le]=R.$an(Ee.default);else switch(Ee.type){case"boolean":Y[le]=!1;break;case"number":case"integer":Y[le]=0;break;case"string":Y[le]="";break;default:x.error(D.localize(2,null,JSON.stringify(W,void 0,0),le));return}}}return j.create(Y)}N.createTaskIdentifier=O})(F||(e.TaskDefinition=F={}))}),define(ke[304],Se([1,0,8]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=e.$j6b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,b)=>{this.b=L,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,D.$Z)(L))}then(L,b){return this.j().then(L,b)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$j6b=T;class g extends T{constructor(){super(),this.h=!0,this.i=new D.$4}}e.$k6b=g}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class D{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++D.count}}e.$tv=D;const T=[];function g(b){const y=new D(b);return T[y.nid]=y,y}e.$uv=g;function R(b){return T[b].sid}e.$vv=R;class L{constructor(y){this.value=y}}e.$wv=L}),define(ke[6],Se([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yK=e.$xK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$wK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var g;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput",w[w.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var R;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var b;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var y;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var m;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var A;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class C{static{this.a=0}static mixin(u){return u._id=C.a++,u}}e.$wK=C;var $;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var v;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var S;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$xK={MainThreadAuthentication:(0,D.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$uv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$uv)("MainThreadClipboard"),MainThreadCommands:(0,D.$uv)("MainThreadCommands"),MainThreadComments:(0,D.$uv)("MainThreadComments"),MainThreadConfiguration:(0,D.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$uv)("MainThreadConsole"),MainThreadDebugService:(0,D.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$uv)("MainThreadLanguages"),MainThreadLogger:(0,D.$uv)("MainThreadLogger"),MainThreadMessageService:(0,D.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$uv)("MainThreadOutputService"),MainThreadProgress:(0,D.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$uv)("MainThreadSecretState"),MainThreadStorage:(0,D.$uv)("MainThreadStorage"),MainThreadSpeech:(0,D.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$uv)("MainThreadSCM"),MainThreadSearch:(0,D.$uv)("MainThreadSearch"),MainThreadShare:(0,D.$uv)("MainThreadShare"),MainThreadTask:(0,D.$uv)("MainThreadTask"),MainThreadWindow:(0,D.$uv)("MainThreadWindow"),MainThreadLabelService:(0,D.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$uv)("MainThreadInteractive"),MainThreadChat:(0,D.$uv)("MainThreadChat"),MainThreadInlineChat:(0,D.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$uv)("MainThreadTimeline"),MainThreadTesting:(0,D.$uv)("MainThreadTesting"),MainThreadLocalization:(0,D.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$uv)("MainThreadIssueReporter")},e.$yK={ExtHostCommands:(0,D.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$uv)("ExtHostStatusBar"),ExtHostShare:(0,D.$uv)("ExtHostShare"),ExtHostExtensionService:(0,D.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$uv)("ExtHostSCM"),ExtHostSearch:(0,D.$uv)("ExtHostSearch"),ExtHostTask:(0,D.$uv)("ExtHostTask"),ExtHostWorkspace:(0,D.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$uv)("ExtHostWindow"),ExtHostWebviews:(0,D.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$uv)("ExtHostProgress"),ExtHostComments:(0,D.$uv)("ExtHostComments"),ExtHostSecretState:(0,D.$uv)("ExtHostSecretState"),ExtHostStorage:(0,D.$uv)("ExtHostStorage"),ExtHostUrls:(0,D.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$uv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$uv)("ExtHostTimeline"),ExtHostTesting:(0,D.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$uv)("ExtHostIssueReporter")}}),define(ke[305],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$xK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,b,y){if(this.a.size===0)throw new Error("No related information providers registered");const m=this.a.get(L);if(!m)throw new Error("related information provider not found");return await m.provideRelatedInformation(b,y)??[]}getRelatedInformation(L,b,y){return this.c.$getAiRelatedInformation(b,y)}registerRelatedInformationProvider(L,b,y){const m=this.b;return this.b++,this.a.set(m,y),this.c.$registerAiRelatedInformationProvider(m,b),new T.$zK(()=>{this.c.$unregisterAiRelatedInformationProvider(m),this.a.delete(m)})}}e.$5dc=g}),define(ke[91],Se([1,0,5,14,6,20]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=e.$$dc=void 0,e.$$dc=(0,D.$Vh)("IExtHostApiDeprecationService");let L=class{constructor(y,m){this.c=m,this.a=new Set,this.b=y.getProxy(g.$xK.MainThreadTelemetry)}report(y,m,A){const C=this.d(y,m);this.a.has(C)||(this.a.add(C),m.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:y}))}d(y,m){return`${y}-${m.identifier.value}`}};e.$_dc=L,e.$_dc=L=He([Be(0,R.$zM),Be(1,T.$dj)],L),e.$aec=Object.freeze(new class{report(b,y,m){}})}),define(ke[306],Se([1,0,4,6,7,26]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class L{constructor(m){this.b=new Map,this.c=[],this.d=new D.$Rd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=m.getProxy(T.$xK.MainThreadAuthentication)}$setProviders(m){return this.c=m,Promise.resolve()}async getSession(m,A,C,$={}){const v=R.$_l.toKey(m.identifier),S=[...C].sort().join(" ");return await this.f.getOrCreate(`${v} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const w=m.displayName||m.name;return this.a.$getSession(A,C,v,w,$)})}async getSessions(m,A,C){const $=R.$_l.toKey(m.identifier),v=[...C].sort().join(" ");return await this.g.getOrCreate(`${$} ${v}`,async()=>{await this.a.$ensureProvider(A);const S=m.displayName||m.name;return this.a.$getSessions(A,C,$,S)})}async removeSession(m,A){const C=this.b.get(m);return C?C.provider.removeSession(A):this.a.$removeSession(m,A)}registerAuthenticationProvider(m,A,C,$){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:A,provider:C,options:$??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===m)||this.c.push({id:m,label:A});const v=C.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(m,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(m,A,$?.supportsMultipleAccounts??!1),new g.$zK(()=>{v.dispose(),this.b.delete(m);const S=this.c.findIndex(w=>w.id===m);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,A,C){const $=this.b.get(m);if($)return Promise.resolve($.provider.createSession(A,C));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,A){const C=this.b.get(m);if(C)return Promise.resolve(C.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,A){const C=this.b.get(m);if(C)return Promise.resolve(C.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,A){return this.d.fire({provider:{id:m,label:A}}),Promise.resolve()}}e.$dec=L;class b{constructor(){this.a=new Map}getOrCreate(m,A){const C=this.a.get(m);if(C)return C;const $=A().finally(()=>this.a.delete(m));return this.a.set(m,$),$}}}),define(ke[307],Se([1,0,6,20,15]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;let R=class{constructor(b,y){this.a=b.getProxy(D.$xK.MainThreadBulkEdits),this.b={getTextDocumentVersion:m=>y.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,y,m){const A=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,m?.isRefactoring??!1)}};e.$eec=R,e.$eec=R=He([Be(0,T.$zM)],R)}),define(ke[308],Se([1,0,4,51,3,6,15]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;class b{static{this.a=0}constructor(A,C){this.extension=A,this.provider=C,this.handle=b.a++}}class y{static{this.a=0}constructor(A){this.b=new Map,this.c=new Map,this.d=new D.$Rd,this.onDidPerformUserAction=this.d.event,this.e=A.getProxy(R.$xK.MainThreadChat)}registerChatProvider(A,C,$){const v=new b(A,$);return this.b.set(v.handle,v),this.e.$registerChatProvider(v.handle,C),(0,g.$Pc)(()=>{this.e.$unregisterChatProvider(v.handle),this.b.delete(v.handle)})}transferChatSession(A,C){const $=T.Iterable.find(this.c.keys(),v=>this.c.get(v)===A)??0;typeof $=="number"&&this.e.$transferChatSession($,C)}sendInteractiveRequestToProvider(A,C){this.e.$sendRequestToProvider(A,C)}async $prepareChat(A,C){const $=this.b.get(A);if(!$)return;const v=await $.provider.prepareSession(C);if(!v)return;const S=y.a++;return this.c.set(S,v),{id:S,requesterUsername:v.requester?.name,requesterAvatarIconUri:v.requester?.icon,responderUsername:v.responder?.name,responderAvatarIconUri:v.responder?.icon,inputPlaceholder:v.inputPlaceholder}}async $provideWelcomeMessage(A,C){const $=this.b.get(A);if(!$||!$.provider.provideWelcomeMessage)return;const v=await $.provider.provideWelcomeMessage(C);if(v)return v.map(S=>typeof S=="string"?S:Array.isArray(S)?S.map(w=>L.ChatReplyFollowup.from(w)):L.MarkdownString.from(S))}async $provideSampleQuestions(A,C){const $=this.b.get(A);if(!$||!$.provider.provideSampleQuestions)return;const v=await $.provider.provideSampleQuestions(C);if(v)return v?.map(S=>L.ChatReplyFollowup.from(S))}$releaseSession(A){this.c.delete(A)}async $onDidPerformUserAction(A){this.d.fire(A)}}e.$fec=y}),define(ke[309],Se([1,0,12,21,43,4,38,18,2,210,85,6,15,7,280,25]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class u{static{this.a=0}constructor(n,r,a){this.i=r,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(C.$xK.MainThreadChatAgents2)}createChatAgent(n,r,a){const t=u.a++,s=new o(n,r,this.d,t,a);return this.b.set(t,s),this.d.$registerAgent(t,r,{}),s.apiAgent}async $invokeAgent(n,r,a,t,s,d){this.g.delete(r);const l=this.b.get(n);if(!l)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let c=!1;function h(){if(c)throw new Error("Only valid while executing the command")}const E=new D.$ih;d.onCancellationRequested(()=>E.complete()),setTimeout(()=>E.complete(),10*1e3),this.i.allowListExtensionWhile(l.extension.identifier,E.p);const I=t.command?await l.validateSlashCommand(t.command):void 0,f=L.$Nd.create(!1);let p;try{const k=l.invoke({prompt:t.message,variables:$.ChatVariable.objectTo(t.variables),slashCommand:I},{history:s.history.map($.ChatMessage.to)},new A.$$u(P=>{h(),typeof p>"u"&&"content"in P&&(p=f.elapsed());const j=$.ChatResponseProgress.from(l.extension,P);if("placeholder"in P&&"resolvedContent"in P){const z=Promise.all([this.d.$handleProgressChunk(a,j),P.resolvedContent]);(0,D.$Mg)(z,d).then(M=>{if(!M)return;const[F,N]=M,O=$.ChatResponseProgress.from(l.extension,N);this.d.$handleProgressChunk(a,O,F??void 0)})}else this.d.$handleProgressChunk(a,j)}),d);return await(0,D.$Mg)(Promise.resolve(k).then(P=>{if(P){this.g.set(r,P);let j=this.h.get(r);j||(j=new Map,this.h.set(r,j)),j.set(a,P);const z={firstProgress:p,totalElapsed:f.elapsed()};return{errorDetails:P.errorDetails,timings:z}}else this.g.delete(r)}),d)}catch(k){return this.j.error(k,l.extension),{errorDetails:{message:(0,m.localize)(0,null,(0,g.$Gi)(k)),responseIsIncomplete:!0}}}finally{c=!0,E.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,r){const a=this.b.get(n);return a?a.provideSlashCommand(r):[]}$provideFollowups(n,r,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const s=this.g.get(r);return s?t.provideFollowups(s,a):Promise.resolve([])}$acceptFeedback(n,r,a,t,s){const d=this.b.get(n);if(!d)return;const l=this.h.get(r)?.get(a);if(!l)return;let c;switch(t){case S.InteractiveSessionVoteDirection.Down:c=v.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:c=v.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(s?{result:l,kind:c,reportIssue:s}:{result:l,kind:c}))}$acceptAction(n,r,a,t){const s=this.b.get(n);if(!s)return;const d=this.h.get(r)?.get(a);d&&t.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:t.action,result:d}))}}e.$hec=u;class o{constructor(n,r,a,t,s){this.extension=n,this.s=r,this.t=a,this.u=t,this.w=s,this.o=new R.$Rd,this.q=new R.$Rd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,b.$Mf)(this.b));const r=this.b.find(a=>a.name===n);if(!r)throw new Error(`Unknown slashCommand: ${n}`);return r}async provideSlashCommand(n){if(!this.a)return[];const r=await this.a.provideSlashCommands(n);return r?(this.b=r,r.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,r){if(!this.d)return[];const a=await this.d.provideFollowups(n,r);return a?a.map(t=>$.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,r=!1;const a=()=>{n||r||(r=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof y.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$tL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:$.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:$.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),r=!1}))},t=this;return{get name(){return t.s},get description(){return t.g??""},set description(s){t.g=s,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(s){t.h=s,a()},get iconPath(){return t.i},set iconPath(s){t.i=s,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(s){t.a=s,a()},get followupProvider(){return t.d},set followupProvider(s){t.d=s,a()},get isDefault(){return(0,w.$MF)(t.extension,"defaultChatAgent"),t.j},set isDefault(s){(0,w.$MF)(t.extension,"defaultChatAgent"),t.j=s,a()},get helpTextPrefix(){return(0,w.$MF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(s){if((0,w.$MF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=s,a()},get helpTextPostfix(){return(0,w.$MF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(s){if((0,w.$MF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=s,a()},get isSecondary(){return(0,w.$MF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(s){(0,w.$MF)(t.extension,"defaultChatAgent"),t.n=s,a()},get sampleRequest(){return t.m},set sampleRequest(s){t.m=s,a()},get supportIssueReporting(){return(0,w.$MF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(s){(0,w.$MF)(t.extension,"chatAgents2Additions"),t.r=s,a()},get onDidReceiveFeedback(){return t.o.event},onDidPerformAction:(0,w.$LF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.t.$unregisterAgent(t.u)}}}invoke(n,r,a,t){return this.w(n,r,a,t)}}}),define(ke[310],Se([1,0,21,3,6,15,85,26,12,4]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class A{constructor(S,w){this.stream=new y.$mh,this.stream=w??new y.$mh;const u=this;this.apiObj={option:S,response:u.stream.asyncIterable}}}class C{constructor(S,w){this.a=new m.$Rd,this.b=new Map,this.c=new y.$mh,this.d=!1;const u=this;this.apiObject={result:S,response:u.c.asyncIterable,onDidStartResponseStream:u.a.event,cancel(){w.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let w=this.b.get(S.index);w||(this.b.size===0?w=new A(S.index,this.c):w=new A(S.index),this.b.set(S.index,w),this.a.fire(w.apiObj)),w.stream.emitOne(S.part)}}class ${static{this.a=1}constructor(S,w){this.d=w,this.c=new Map,this.e=new Map,this.f=new b.$bm,this.b=S.getProxy(g.$xK.MainThreadChatProvider)}registerProvider(S,w,u,o){const i=$.a++;return this.c.set(i,{extension:S,provider:u}),this.b.$registerProvider(i,w,{extension:S,displayName:o.name??S.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,w,u,o,i){const n=this.c.get(S);if(!n)return;const r=new L.$$u(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(w,{index:a.index,part:a.part})});return n.provider.provideChatResponse(u.map(R.ChatMessage.to),o,r,i)}allowListExtensionWhile(S,w){this.f.set(S,w),w.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,w){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const u=this;return{get isRevoked(){return!u.f.has(S)},makeRequest(o,i,n){if(!u.f.has(S))throw new Error("Access to chat has been revoked");const r=new D.$2d(n),a=Math.random()*1e6|0,t=u.b.$fetchResponse(S,w,a,o.map(R.ChatMessage.from),i??{},r.token),s=new C(t,r);return u.e.set(a,{res:s}),t.finally(()=>{u.e.delete(a)}),s.apiObject}}}async $handleResponseFragment(S,w){const u=this.e.get(S);u&&u.res.handleFragment(w)}}e.$gec=$}),define(ke[311],Se([1,0,3,6,8,15]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class L{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(T.$xK.MainThreadChatVariables)}async $resolveVariable(y,m,A){const C=this.b.get(y);if(C)try{const $=await C.resolver.resolve(C.data.name,{message:m},A);if($)return $.map(R.ChatVariable.from)}catch($){(0,g.$1)($)}}registerVariableResolver(y,m,A,C){const $=L.a++;return this.b.set($,{extension:y.identifier,data:{name:m,description:A},resolver:C}),this.c.$registerVariable($,{name:m,description:A}),(0,D.$Pc)(()=>{this.b.delete($),this.c.$unregisterVariable($)})}}e.$iec=L}),define(ke[312],Se([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class T{constructor(R){const L=R.getProxy(D.$xK.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(b){return L.$writeText(b)}})}}e.$jec=T}),define(ke[35],Se([1,0,18,7,15,24,6,19,14,54,29,53,2,3,5,20,149,22,68,43,38,87,90,30]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=void 0;let d=class{#e;#t;#i;constructor(f,p,k){this.b=new Map,this.c=new Map,this.#e=f.getProxy(L.$xK.MainThreadCommands),this.d=p,this.#i=k,this.#t=f.getProxy(L.$xK.MainThreadTelemetry),this.converter=new l(this,P=>{const j=this.c.get(P);return j?.result===h.Void?j:void 0},p),this.f=[{processArgument(P){return(0,m.$sh)(P)}},{processArgument(P){return(0,R.$cn)(P,function(j){if(A.$zs.isIRange(j))return g.Range.to(j);if(C.$ys.isIPosition(j))return g.Position.to(j);if(A.$zs.isIRange(j.range)&&$.URI.isUri(j.uri))return g.location.to(j);if(j instanceof o.$fe)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const p=this.registerCommand(!1,f.id,async(...k)=>{const P=f.args.map((z,M)=>{if(!z.validate(k[M]))throw new Error(`Invalid argument '${z.name}' when running '${f.id}', received: ${typeof k[M]=="object"?JSON.stringify(k[M],null,"	"):k[M]} `);return z.convert(k[M])}),j=await this.executeCommand(f.internalId,...P);return f.result.convert(j,k,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new T.$zK(()=>{p.dispose(),this.c.delete(f.id)})}registerCommand(f,p,k,P,j,z){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:k,thisArg:P,metadata:j,extension:z}),f&&this.#e.$registerCommand(p),new T.$zK(()=>{this.b.delete(p)&&f&&this.#e.$unregisterCommand(p)})}executeCommand(f,...p){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,p,!0)}async g(f,p,k){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,p,!1);{let P=!1;const j=(0,R.$cn)(p,function(z){if(z instanceof T.$AK)return g.Position.from(z);if(z instanceof T.$BK)return g.Range.from(z);if(z instanceof T.$LK)return g.location.from(z);if(T.$WL.isNotebookRange(z))return g.NotebookRange.from(z);if(z instanceof ArrayBuffer)return P=!0,o.$fe.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return P=!0,o.$fe.wrap(z);if(z instanceof o.$fe)return P=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(f,P?new i.$wv(j):j,k);return(0,m.$sh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(f,p,!1);throw z}}}async h(f,p,k){const P=this.b.get(f);if(!P)throw new Error("Unknown command");const{callback:j,thisArg:z,metadata:M}=P;if(M?.args)for(let N=0;N<M.args.length;N++)try{(0,D.$Tf)(p[N],M.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${M.args[N].name}' - ${M.args[N].description}`)}const F=r.$Nd.create();try{return await j.apply(z,p)}catch(N){if(f===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...p);O&&(f=O.command)}if(this.d.error(N,f,P.extension?.identifier),!k)throw N;if(P.extension?.identifier){const O=this.#i.onExtensionError(P.extension.identifier,N);this.d.trace("forwarded error to extension?",O,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Gi)(N)),this.id=f,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,f,F.elapsed())}}j(f,p,k){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new a.$po(p),duration:k})}$executeContributedCommand(f,...p){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const k=this.b.get(f);return k?(p=p.map(P=>this.f.reduce((j,z)=>z.processArgument(j,k.extension?.identifier),P)),this.h(f,p,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(p=>(f&&(p=p.filter(k=>k[0]!=="_")),p))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[p,k]of this.b){const{metadata:P}=k;P&&(f[p]=P)}return Promise.resolve(f)}};e.$UM=d,e.$UM=d=He([Be(0,w.$zM),Be(1,y.$dj),Be(2,t.$TM)],d),e.$VM=(0,S.$Vh)("IExtHostCommands");class l{constructor(f,p,k){this.d=f,this.f=p,this.g=k,this.delegatingCommandId=`__vsc${(0,s.$ig)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,p){if(!f)return;const k={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return k;const P=this.f(f.command);if(P)k.id=P.internalId,k.arguments=P.args.map((j,z)=>j.convert(f.arguments&&f.arguments[z]));else if((0,b.$Kb)(f.arguments)){const j=`${f.command} /${++this.c}`;this.b.set(j,f),p.add((0,v.$Pc)(()=>{this.b.delete(j),this.g.trace("CommandsConverter#DISPOSE",j)})),k.$ident=j,k.id=this.delegatingCommandId,k.arguments=[j],this.g.trace("CommandsConverter#CREATE",f.command,j)}return k}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const p=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$WM=l;class c{static{this.Uri=new c("uri","Uri of a text document",f=>$.URI.isUri(f),f=>f)}static{this.Position=new c("position","A position in a text document",f=>T.$AK.isPosition(f),g.Position.from)}static{this.Range=new c("range","A range in a text document",f=>T.$BK.isRange(f),g.Range.from)}static{this.Selection=new c("selection","A selection in a text document",f=>T.$CK.isSelection(f),g.Selection.from)}static{this.Number=new c("number","",f=>typeof f=="number",f=>f)}static{this.String=new c("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=c.Arr(c.String)}static Arr(f){return new c(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,p=>Array.isArray(p)&&p.every(k=>f.validate(k)),p=>p.map(k=>f.convert(k)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",f=>f instanceof T.$VK,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",f=>f instanceof T.$dM,g.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",f=>f instanceof u.$MM,g.TestItem.from)}constructor(f,p,k,P){this.name=f,this.description=p,this.validate=k,this.convert=P}optional(){return new c(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,p){return new c(f??this.name,p??this.description,this.validate,this.convert)}}e.$XM=c;class h{static{this.Void=new h("no result",f=>f)}constructor(f,p){this.description=f,this.convert=p}}e.$YM=h;class E{constructor(f,p,k,P,j){this.id=f,this.internalId=p,this.description=k,this.args=P,this.result=j}}e.$ZM=E}),define(ke[313],Se([1,0,19,17,2,83,132,45,137,35,15,7]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;const $=[new m.$ZM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of DocumentHighlight-instances.",S(A.DocumentHighlight.to))),new m.$ZM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$XM.Uri],new m.$YM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,o)=>{if((0,D.$Jb)(u))return;class i extends C.$QK{static to(r){const a=new i(r.name,A.SymbolKind.to(r.kind),r.containerName||"",new C.$LK(o[0],A.Range.to(r.range)));return a.detail=r.detail,a.range=a.location.range,a.selectionRange=A.Range.to(r.selectionRange),a.children=r.children?r.children.map(i.to):[],a}}return u.map(i.to)})),new m.$ZM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$XM.Uri,new m.$XM("options","Formatting options",u=>!0,u=>u)],new m.$YM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new m.$ZM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$XM.Uri,m.$XM.Range,new m.$XM("options","Formatting options",u=>!0,u=>u)],new m.$YM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new m.$ZM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$XM.Uri,m.$XM.Position,new m.$XM("ch","Trigger character",u=>typeof u=="string",u=>u),new m.$XM("options","Formatting options",u=>!0,u=>u)],new m.$YM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new m.$ZM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$ZM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$ZM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$ZM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$ZM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of Location-instances.",S(A.location.to))),new m.$ZM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of Hover-instances.",S(A.Hover.to))),new m.$ZM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$XM.Uri,new m.$XM("position","A position in a text document",u=>Array.isArray(u)&&u.every(o=>C.$AK.isPosition(o)),u=>u.map(A.Position.from))],new m.$YM("A promise that resolves to an array of ranges.",u=>u.map(o=>{let i;for(const n of o.reverse())i=new C.$UK(A.Range.to(n),i);return i}))),new m.$ZM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$XM.String.with("query","Search string")],new m.$YM("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(A.WorkspaceSymbol.to))),new m.$ZM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(A.CallHierarchyItem.to))),new m.$ZM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$XM.CallHierarchyItem],new m.$YM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(A.CallHierarchyIncomingCall.to))),new m.$ZM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$XM.CallHierarchyItem],new m.$YM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(A.CallHierarchyOutgoingCall.to))),new m.$ZM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:A.Range.to(u.range),placeholder:u.text}})),new m.$ZM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$XM.Uri,m.$XM.Position,m.$XM.String.with("newName","The new symbol name")],new m.$YM("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return A.WorkspaceEdit.to(u)}})),new m.$ZM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$XM.Uri,m.$XM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$YM("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(A.DocumentLink.to))),new m.$ZM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$XM.Uri],new m.$YM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new C.$OL(u.tokenTypes,u.tokenModifiers)})),new m.$ZM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$XM.Uri],new m.$YM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const o=(0,L.$10)(u);if(o.type==="full")return new C.$QL(o.data,void 0)})),new m.$ZM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$XM.Uri,m.$XM.Range.optional()],new m.$YM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new C.$OL(u.tokenTypes,u.tokenModifiers)})),new m.$ZM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$XM.Uri,m.$XM.Range],new m.$YM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const o=(0,L.$10)(u);if(o.type==="full")return new C.$QL(o.data,void 0)})),new m.$ZM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$XM.Uri,m.$XM.Position,m.$XM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$XM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$YM("A promise that resolves to a CompletionList-instance.",(u,o,i)=>{if(!u)return new C.$7K([]);const n=u.suggestions.map(r=>A.CompletionItem.to(r,i));return new C.$7K(n,u.incomplete)})),new m.$ZM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$XM.Uri,m.$XM.Position,m.$XM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$YM("A promise that resolves to SignatureHelp.",u=>{if(u)return A.SignatureHelp.to(u)})),new m.$ZM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$XM.Uri,m.$XM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$YM("A promise that resolves to an array of CodeLens-instances.",(u,o,i)=>S(n=>new C.$YK(A.Range.to(n.range),n.command&&i.fromInternal(n.command)))(u))),new m.$ZM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$XM.Uri,new m.$XM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>C.$BK.isRange(u),u=>C.$CK.isSelection(u)?A.Selection.from(u):A.Range.from(u)),m.$XM.String.with("kind","Code action kind to return code actions for").optional(),m.$XM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$YM("A promise that resolves to an array of Command-instances.",(u,o,i)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(n.command)}else{const r=new C.$SK(n.title,n.kind?new C.$TK(n.kind):void 0);return n.edit&&(r.edit=A.WorkspaceEdit.to(n.edit)),n.command&&(r.command=i.fromInternal(n.command)),r.isPreferred=n.isPreferred,r}})(u))),new m.$ZM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$XM.Uri],new m.$YM("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(o=>new C.$aL(A.Range.to(o.range),A.Color.to(o.color))):[])),new m.$ZM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$XM("color","The color to show and insert",u=>u instanceof C.$_K,A.Color.from),new m.$XM("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:A.Range.from(u.range)}))],new m.$YM("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(A.ColorPresentation.to):[])),new m.$ZM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$XM.Uri,m.$XM.Range],new m.$YM("A promise that resolves to an array of Inlay objects",(u,o,i)=>u.map(A.InlayHint.to.bind(void 0,i)))),new m.$ZM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$XM.Uri],new m.$YM("A promise that resolves to an array of FoldingRange objects",(u,o)=>{if(u)return u.map(A.FoldingRange.to)})),new m.$ZM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$YM("A promise that resolves to an array of NotebookContentProvider static info objects.",S(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(o=>A.NotebookExclusiveDocumentPattern.to(o))})))),new m.$ZM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$XM.Uri,m.$XM.Range,new m.$XM("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof C.$BK,u=>A.InlineValueContext.from(u))],new m.$YM("A promise that resolves to an array of InlineValue objects",u=>u.map(A.InlineValue.to))),new m.$ZM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$XM("uriOrString","Uri-instance or string (only http/https)",u=>g.URI.isUri(u)||typeof u=="string"&&(0,y.$RU)(u,T.Schemas.http,T.Schemas.https),u=>u),new m.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional(),m.$XM.String.with("label","").optional()],m.$YM.Void),new m.$ZM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$XM.Uri.with("resource","Resource to open"),m.$XM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional()],m.$YM.Void),new m.$ZM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$XM.Uri.with("left","Left-hand side resource of the diff editor"),m.$XM.Uri.with("right","Right-hand side resource of the diff editor"),m.$XM.String.with("title","Human readable title for the diff editor").optional(),new m.$XM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)]).optional()],m.$YM.Void),new m.$ZM("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$XM.String.with("title","Human readable title for the changes editor"),new m.$XM("resourceList","List of resources to compare",u=>{for(const o of u){if(o.length!==3)return!1;const[i,n,r]=o;if(!g.URI.isUri(i)||!g.URI.isUri(n)&&n!==void 0&&n!==null||!g.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},u=>u)],m.$YM.Void),new m.$ZM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$XM.Uri,m.$XM.Position],new m.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new m.$ZM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$XM.TypeHierarchyItem],new m.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new m.$ZM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$XM.TypeHierarchyItem],new m.$YM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new m.$ZM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$XM.TestItem],m.$YM.Void),new m.$ZM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$XM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$YM.Void),new m.$ZM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$XM.String.with("name","The context key name"),new m.$XM("value","The context key value",()=>!0,u=>u)],m.$YM.Void),new m.$ZM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$XM.Uri,m.$XM.StringArray,new m.$XM("MappedEditsContext","Mapped Edits Context",u=>A.MappedEditsContext.is(u),u=>A.MappedEditsContext.from(u))],new m.$YM("A promise that resolves to a workspace edit or null",u=>u?A.WorkspaceEdit.to(u):null))];class v{static register(o){$.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",b.$Ui)}}e.$cec=v;function S(u){return o=>{if(Array.isArray(o))return o.map(u)}}function w(u){if(!Array.isArray(u))return;const o=[];for(const i of u)R.$kt(i)?o.push(A.DefinitionLink.to(i)):o.push(A.location.to(i));return o}}),define(ke[314],Se([1,0,12,59,4,3,2,83,26,15,7,6,25]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;function v(S,w,u){const o=S.getProxy(C.$xK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new y.$bm,w.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const E=this.b.get(h.handle);return E?E.value:h}else if(h&&h.$mid===7){const E=this.b.get(h.commentControlHandle);if(!E)return h;const I=E.getCommentThread(h.commentThreadHandle);return I?I.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const I=E.getCommentThread(h.thread.commentThreadHandle);return I?h.$mid===8?I.value:{thread:I.value,text:h.text}:h}else if(h&&h.$mid===10){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const I=E.getCommentThread(h.thread.commentThreadHandle);if(!I)return h;const f=h.commentUniqueId,p=I.getCommentByUniqueId(f);return p||h}else if(h&&h.$mid===11){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const I=E.getCommentThread(h.thread.commentThreadHandle);if(!I)return h;const f=h.text,p=h.commentUniqueId,k=I.getCommentByUniqueId(p);return k?(typeof k.body=="string"?k.body=f:k.body=new A.$ZK(f),k):h}return h}})}createCommentController(h,E,I){const f=i.a++,p=new r(h,f,E,I);this.b.set(p.handle,p);const k=this.c.get(h.identifier)||[];return k.push(p),this.c.set(h.identifier,k),p.value}async $createCommentThreadTemplate(h,E,I){const f=this.b.get(h);f&&f.$createCommentThreadTemplate(E,I)}async $updateCommentThreadTemplate(h,E,I){const f=this.b.get(h);f&&f.$updateCommentThreadTemplate(E,I)}$deleteCommentThread(h,E){this.b.get(h)?.$deleteCommentThread(E)}$provideCommentingRanges(h,E,I){const f=this.b.get(h);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const p=u.getDocument(L.URI.revive(E));return(0,D.$Qg)(async()=>{const k=await f.commentingRangeProvider.provideCommentingRanges(p,I);let P;return Array.isArray(k)?P={ranges:k,fileComments:!1}:k?P={ranges:k.ranges||[],fileComments:k.fileComments||!1}:P=k??void 0,P}).then(k=>{let P;return k&&(P={ranges:k.ranges.map(j=>m.Range.from(j)),fileComments:k.fileComments}),P})}$toggleReaction(h,E,I,f,p){const k=this.b.get(h);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,D.$Qg)(()=>{const P=k.getCommentThread(E);if(P){const j=P.getCommentByUniqueId(f.uniqueIdInThread);if(k!==void 0&&j&&k.reactionHandler)return k.reactionHandler(j,s(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,E,I,f,p,k,P,j){this.m=E,this.n=I,this.o=f,this.p=p,this.q=k,this.extensionDescription=P,this.r=j,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Sc,this.l.value=new R.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),o.$createCommentThread(E,this.handle,this.n,this.o,m.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{o.$deleteCommentThread(E,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Qc);const h=I=>Object.prototype.hasOwnProperty.call(this.b,I),E={};h("range")&&(E.range=m.Range.from(this.p)),h("label")&&(E.label=this.label),h("contextValue")&&(E.contextValue=this.contextValue??null),h("comments")&&(E.comments=this.q.map(I=>a(this,I,this.k,this.extensionDescription))),h("collapsibleState")&&(E.collapseState=d(this.g)),h("canReply")&&(E.canReply=this.canReply),h("state")&&(E.state=l(this.h)),h("isTemplate")&&(E.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(h){for(const E of this.k){const I=E[0],f=E[1];if(h===f)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,T.$oh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,E,I,f){this.f=h,this.g=E,this.h=I,this.i=f,this.a=new Map,o.$registerCommentController(this.handle,I,f,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(k){p.options=k},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(k){p.commentingRangeProvider=k},get reactionHandler(){return p.reactionHandler},set reactionHandler(k){p.reactionHandler=k},createCommentThread(k,P,j){return p.createCommentThread(k,P,j).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(h,E,I){E===void 0&&(0,$.$MF)(this.f,"fileComments");const f=new n(this.id,this.handle,void 0,h,E,I,this.f,!1);return this.a.set(f.handle,f),f}$createCommentThreadTemplate(h,E){const I=new n(this.id,this.handle,void 0,L.URI.revive(h),m.Range.to(E),[],this.f,!0);return I.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(h,E){const I=this.a.get(h);I&&(I.range=m.Range.to(E))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(c,h,E,I){let f=E.get(h);return f||(f=++c.commentHandle,E.set(h,f)),h.state!==void 0&&(0,$.$MF)(I,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:f,body:typeof h.body=="string"?h.body:m.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(p=>t(p)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?m.$yM(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function s(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?L.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function d(c){if(c!==void 0)switch(c){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(c){if(c!==void 0)switch(c){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$mec=v}),define(ke[315],Se([1,0,24,6,27,20]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;let L=class{constructor(A,C){this.a=A.getProxy(T.$xK.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,C){const $=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,C,v,arguments)}})}e(A,C,$,v){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:y(v,this.b)}),this.c&&this.f(A,$,v)}};e.$agc=L,e.$agc=L=He([Be(0,R.$zM),Be(1,g.$PM)],L);const b=1e5;function y(m,A){const C=[];if(m.length)for(let $=0;$<m.length;$++){let v=m[$];if(typeof v>"u")v="undefined";else if(v instanceof Error){const S=v;S.stack?v=S.stack:v=S.toString()}C.push(v)}if(A){const $=new Error().stack;$&&C.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,D.$fn)(C);return $.length>b?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[151],Se([1,0,2,6,7,5,20,14,19,13,16,25]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=void 0;let v=class{static{$=this}static{this.c=0}static{this.d=250}constructor(w,u){this.h=u,this.f=new Map,this.g=w.getProxy(T.$xK.MainThreadDecorations)}registerFileDecorationProvider(w,u){const o=$.c++;this.f.set(o,{provider:w,extensionDescription:u}),this.g.$registerDecorationProvider(o,u.identifier.value);const i=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const r=(0,y.$2b)(n);if(r.length<=$.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,r.length);const a=r.map(d=>({uri:d,rank:(0,m.$Ke)(d.path,"/")})),t=(0,y.$yb)(a,(d,l)=>d.rank-l.rank||(0,m.$Ye)(d.uri.path,l.uri.path)),s=[];e:for(const d of t){let l;for(const c of d){const h=(0,A.$lc)(c.uri.path);if(l!==h&&(l=h,s.push(c.uri)>=$.d))break e}}this.g.$onDidChange(o,s)});return new g.$zK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(w,u,o){if(!this.f.has(w))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(w);return await Promise.all(u.map(async a=>{try{const{uri:t,id:s}=a,d=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),o));if(!d)return;try{g.$UL.validate(d),d.badge&&typeof d.badge!="string"&&(0,C.$MF)(r,"codiconDecoration"),i[s]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),i}};e.$cfc=v,e.$cfc=v=$=He([Be(0,L.$zM),Be(1,b.$dj)],v),e.$dfc=(0,R.$Vh)("IExtHostDecorations")}),define(ke[316],Se([1,0,211,136,2,6,7,15,4,14,28,57]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0;class v{#e;#t;#i;constructor(u,o,i,n,r,a,t,s){this.d=u,this.e=o,this.f=i,this.g=n,this.h=r,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$zc(d=>a.getComparisonKey(d)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,o){if(!u){this.clear();return}this.j();let i=[];if(g.URI.isUri(u)){if(!o){this.delete(u);return}this.#i.set(u,o.slice()),i=[u]}else if(Array.isArray(u)){i=[];let a;u=[...u].sort(v.k);for(const t of u){const[s,d]=t;if((!a||s.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=s,i.push(s),this.#i.set(s,[])),d)this.#i.get(s)?.push(...d);else{const l=this.#i.get(s);l&&(l.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const a of i){let t=[];const s=this.#i.get(a);if(s)if(s.length>this.g){t=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const c of s)if(c.severity===d[l]&&t.push({...b.Diagnostic.from(c),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,n)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,o){this.j();for(const[i,n]of this)u.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const o=this.#i.get(u);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,o){return u[0].toString()<o[0].toString()?-1:u[0].toString()>o[0].toString()?1:0}}e.$9dc=v;let S=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(u){const o=new A.$zc;for(const i of u)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(u,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new y.$Vd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.h.event,$._mapper),this.f=u.getProxy(R.$xK.MainThreadDiagnostics)}createDiagnosticCollection(u,o){const{g:i,f:n,h:r,j:a,k:t,l:s}=this,d=new class{$changeMany(h,E){n.$changeMany(h,E),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,h,E.length===0?"CLEARING":E)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,h)}dispose(){n.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,l=o;else if(!i.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+$.c++;while(i.has(l))}return new class extends v{constructor(){super(o,l,$.e,$.d,h=>s.getDocument(h)?.version,t.extUri,d,r),i.set(l,this)}dispose(){super.dispose(),i.delete(l)}}}getDiagnostics(u){if(u)return this.m(u);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((r,a)=>{let t=o.get(r.toString());typeof t>"u"&&(t=i.length,o.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(u){let o=[];for(const i of this.g.values())i.has(u)&&(o=o.concat(i.get(u)));return o}$acceptMarkersChange(u){if(!this.n){const o="_generated_mirror",i=new v(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of u)this.n.set(g.URI.revive(o),i.map(b.Diagnostic.to))}};e.$0dc=S,e.$0dc=S=$=He([Be(1,m.$dj),Be(2,C.$8dc)],S)}),define(ke[317],Se([1,0,2,6,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class R{constructor(b){this.a=b.getProxy(T.$xK.MainThreadDialogs)}showOpenDialog(b,y){return y?.allowUIResources&&(0,g.$MF)(b,"showLocal"),this.a.$showOpenDialog(y).then(m=>m?m.map(A=>D.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(y=>y?D.URI.revive(y):void 0)}}e.$efc=R}),define(ke[318],Se([1,0,8,2,7,6,17,21,13]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;class m{static{this.a=0}constructor(C,$,v){this.d=$,this.e=v,this.b=new Map,this.c=C.getProxy(R.$xK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,$){if(Object.keys(L.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const v=m.a++;this.b.set(v,$),this.c.$registerTextContentProvider(v,C);let S;return typeof $.onDidChange=="function"&&(S=$.onDidChange(w=>{if(w.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this.d.getDocument(w)&&this.$provideTextDocumentContent(v,w).then(u=>{if(!u&&typeof u!="string")return;const o=this.d.getDocument(w);if(!o)return;const i=(0,y.$Te)(u);if(!o.equalLines(i))return this.c.$onVirtualDocumentChange(w,u)},D.$Z)})),new g.$zK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,$){const v=this.b.get(C);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive($),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$ffc=m}),define(ke[319],Se([1,0,4,3,2,6,143,15,18,24,7,8]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;class ${constructor(S,w){this.a=new D.$Rd({onListenerError:C.$1}),this.b=new D.$Rd({onListenerError:C.$1}),this.c=new D.$Rd({onListenerError:C.$1}),this.d=new D.$Rd({onListenerError:C.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=S.getProxy(R.$xK.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(u=>{for(const o of u)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const o of u)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const w=this.g.getDocument(S);if(w)return w}getDocument(S){const w=this.getDocumentData(S);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return w.document}ensureDocumentData(S){const w=this.g.getDocument(S);if(w)return Promise.resolve(w);let u=this.h.get(S.toString());return u||(u=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const i=g.URI.revive(o);return(0,y.$Nf)(this.g.getDocument(i))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),u)),u}createDocumentData(S){return this.f.$tryCreateDocument(S).then(w=>g.URI.revive(w))}$acceptModelLanguageChanged(S,w){const u=g.URI.revive(S),o=this.g.getDocument(u);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(w),this.a.fire(o.document)}$acceptModelSaved(S){const w=g.URI.revive(S),u=this.g.getDocument(w);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(S,w){const u=g.URI.revive(S),o=this.g.getDocument(u);if(!o)throw new Error("unknown document");o._acceptIsDirty(w),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,w,u){const o=g.URI.revive(S),i=this.g.getDocument(o);if(!i)throw new Error("unknown document");i._acceptIsDirty(u),i.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,m.$bn)({document:i.document,contentChanges:w.changes.map(r=>({range:b.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:n}))}setWordDefinitionFor(S,w){(0,L.$BM)(S,w)}}e.$6dc=$}),define(ke[69],Se([1,0,60,4,3,2,5,6,143,20,150,15,14,28,17,51,48]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,a){this.h=r,this.i=a,this.a=null,this.b=new Map,this.c=new v.$zc,this.d=new T.$Rd,this.e=new T.$Rd,this.f=new T.$Rd,this.g=new T.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const a=[],t=[],s=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=R.URI.revive(d),c=this.c.get(l);c?.unref()&&(this.c.delete(l),a.push(c.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=R.URI.revive(d.uri);let c=this.c.get(l);if(c&&l.scheme!==S.Schemas.vscodeNotebookCell&&l.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new o(new y.$CM(this.h.getProxy(b.$xK.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(l,c),t.push(c.value)),c.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&s.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=R.URI.revive(d.documentUri);D.ok(this.c.has(l),`document '${l}' does not exist`),D.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const c=this.c.get(l).value,h=new A.$IM(d.id,this.h.getProxy(b.$xK.MainThreadTextEditors),this.i,new u.$U(()=>c.document),d.selections.map(C.Selection.to),d.options,d.visibleRanges.map(E=>C.Range.to(E)),typeof d.editorPosition=="number"?C.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(D.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,g.$Mc)(a),(0,g.$Mc)(s),r.removedDocuments&&this.e.fire(a),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return w.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const a=this.b.get(this.a);return r?a:a?.value}allEditors(){return[...this.b.values()]}};e.$JM=i,e.$JM=i=He([Be(0,m.$zM),Be(1,$.$dj)],i),e.$KM=(0,L.$Vh)("IExtHostDocumentsAndEditors")}),define(ke[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=e.$Fec=void 0,e.$Fec=(0,L.$Vh)("IExtHostEditorTabs");class C{constructor(u,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,o={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$eM(R.URI.revive(this.b.input.uri));case 2:return new A.$fM(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$gM(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$hM(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$iM(this.b.input.viewType);case 4:return new A.$jM(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$kM(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$lM;case 9:return new A.$mM(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$nM(this.b.input.providerId);default:return}}}class ${constructor(u,o){this.c=[],this.d="",this.b=u,this.e=o;for(const i of u.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,o={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return m.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(i=>i.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const i=new C(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,i),u.tabDto.isActive&&(this.d=i.tabId),i}else if(u.kind===1){const i=this.c.splice(u.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(u.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,i),i}const o=this.c.find(i=>i.tabId===u.tabDto.id);if(!o)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(u.tabDto),o}activeTabId(){return this.d}}let v=class{constructor(u){this.b=new T.$Rd,this.c=new T.$Rd,this.e=[],this.a=u.getProxy(b.$xK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,o={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(i=>i.apiObject))},get activeTabGroup(){const i=u.d;return(0,g.$Nf)(u.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?S(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(u){const o=new Set(this.e.map(d=>d.groupId)),i=new Set(u.map(d=>d.groupId)),n=(0,D.$K)(o,i),r=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=u.map(d=>{const l=new $(d,()=>this.d);return n.added.includes(l.groupId)?a.push(l.apiObject):t.push(l.apiObject),l});const s=(0,g.$Nf)(u.find(d=>d.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:a,closed:r,changed:t}))}$acceptTabGroupUpdate(u){const o=this.e.find(i=>i.groupId===u.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const o=this.e.find(n=>n.groupId===u.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(u){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===u)return i}h(u){return this.e.find(o=>o.apiObject===u)}async i(u,o){const i=[];for(const n of u){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,o)}async j(u,o){const i=[];for(const n of u){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,o)}};e.$Gec=v,e.$Gec=v=He([Be(0,y.$zM)],v);function S(w){return w.tabs!==void 0}}),define(ke[320],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$xK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,b,y){if(this.a.size===0)throw new Error("No embedding vector providers registered");const m=this.a.get(L);if(!m)throw new Error("Embedding vector provider not found");const A=await m.provideEmbeddingVector(b,y);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,b,y){const m=this.b;return this.b++,this.a.set(m,y),this.c.$registerAiEmbeddingVectorProvider(b,m),new T.$zK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(m),this.a.delete(m)})}}e.$hfc=g}),define(ke[321],Se([1,0,2,6,3,7,15,173,13,22,25,80]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class ${constructor(){this.a=[]}add(w){this.b=void 0,this.a.push(w)}delete(w){const u=this.a.indexOf(w);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const w=this.a.sort(),u=[];let o,i,n=14,r=14;for(const a of w){let t=o?(0,y.$8e)(o,a):0;for(t===0?i=1:i=r;t<a.length;t++)t+1===a.length?(n=r,r=9):r+=1,u.push([i,a.toUpperCase().charCodeAt(t),r]),u.push([i,a.toLowerCase().charCodeAt(t),r]),i=r;o=a,r=n}u.push([9,58,10]),u.push([10,47,12]),this.b=new b.$3Y(u)}}provideDocumentLinks(w){this.c();const u=[],o=b.$4Y.computeLinks({getLineContent(i){return w.lineAt(i-1).text},getLineCount(){return w.lineCount}},this.b);for(const i of o){const n=L.DocumentLink.to(i);n.target&&u.push(n)}return u}}class v{constructor(w,u){this.i=u,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=w.getProxy(T.$xK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(w,u,o,i={}){if(v.j(o),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(w,"*",this.b));const n=this.h++;this.b.add(u),this.d.add(u),this.c.set(n,o);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$MF)(w,"fsChunks"),r+=4);let a;i.isReadonly&&(0,C.$$j)(i.isReadonly)&&((0,A.$MF)(w,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,u,r,a).catch(s=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${u}`),console.error(s)});const t=o.onDidChangeFile(s=>{const d=[];for(const l of s){const{uri:c,type:h}=l;if(c.scheme!==u)continue;let E;switch(h){case R.FileChangeType.Changed:E=0;break;case R.FileChangeType.Created:E=1;break;case R.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:c,type:E})}this.a.$onFileSystemChange(n,d)});return(0,g.$Pc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static k(w){const{type:u,ctime:o,mtime:i,size:n,permissions:r}=w;return{type:u,ctime:o,mtime:i,size:n,permissions:r}}$stat(w,u){return Promise.resolve(this.l(w).stat(D.URI.revive(u))).then(o=>v.k(o))}$readdir(w,u){return Promise.resolve(this.l(w).readDirectory(D.URI.revive(u)))}$readFile(w,u){return Promise.resolve(this.l(w).readFile(D.URI.revive(u))).then(o=>m.$fe.wrap(o))}$writeFile(w,u,o,i){return Promise.resolve(this.l(w).writeFile(D.URI.revive(u),o.buffer,i))}$delete(w,u,o){return Promise.resolve(this.l(w).delete(D.URI.revive(u),o))}$rename(w,u,o,i){return Promise.resolve(this.l(w).rename(D.URI.revive(u),D.URI.revive(o),i))}$copy(w,u,o,i){const n=this.l(w);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(u),D.URI.revive(o),i))}$mkdir(w,u){return Promise.resolve(this.l(w).createDirectory(D.URI.revive(u)))}$watch(w,u,o,i){const n=this.l(w).watch(D.URI.revive(o),i);this.f.set(u,n)}$unwatch(w,u){const o=this.f.get(u);o&&(o.dispose(),this.f.delete(u))}$open(w,u,o){const i=this.l(w);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(u),o))}$close(w,u){const o=this.l(w);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(u))}$read(w,u,o,i){const n=this.l(w);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=m.$fe.alloc(i);return Promise.resolve(n.read(u,o,r.buffer,0,i)).then(a=>r.slice(0,a))}$write(w,u,o,i){const n=this.l(w);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(u,o,i.buffer,0,i.byteLength))}l(w){const u=this.c.get(w);if(!u){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return u}}e.$ifc=v}),define(ke[71],Se([1,0,6,32,7,22,5,20,57,3,12,23,17]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=e.$uec=void 0;let S=v=class{constructor(u,o){this.b=new Map,this.c=new A.$7g,this.a=u.getProxy(D.$xK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),r=await a.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===T.FilePermission.Readonly?1:void 0}}catch(r){v.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return v.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return v.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return v.e(r)}},async writeFile(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,R.$fe.wrap(r))}catch(a){return v.e(a)}},async delete(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(a){return v.e(a)}},async rename(n,r,a){try{return await i.a.$rename(n,r,{overwrite:!1,...a})}catch(t){return v.e(t)}},async copy(n,r,a){try{return await i.a.$copy(n,r,{overwrite:!1,...a})}catch(t){return v.e(t)}},isWritableFileSystem(n){const r=o.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(u,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await u.stat(i)).type&T.FileType.Directory))throw g.$ML.FileExists(`Unable to create folder '${i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(T.$uk(r)!==T.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(o.basename(i)),i=o.dirname(i)}for(let r=n.length-1;r>=0;r--){i=o.joinPath(i,n[r]);try{await u.createDirectory(i)}catch(a){if(T.$uk(a)!==T.FileSystemProviderErrorCode.FileExists)throw a}}}static e(u){if(u instanceof g.$ML)throw u;if(u instanceof T.$qk)switch(u.code){case T.FileSystemProviderErrorCode.FileExists:throw g.$ML.FileExists(u.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$ML.FileNotFound(u.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$ML.FileNotADirectory(u.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$ML.FileIsADirectory(u.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$ML.NoPermissions(u.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$ML.Unavailable(u.message);default:throw new g.$ML(u.message,u.name)}if(!(u instanceof Error))throw new g.$ML(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw g.$ML.Unavailable(u.message);switch(u.name){case T.FileSystemProviderErrorCode.FileExists:throw g.$ML.FileExists(u.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$ML.FileNotFound(u.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$ML.FileNotADirectory(u.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$ML.FileIsADirectory(u.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$ML.NoPermissions(u.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$ML.Unavailable(u.message);default:throw new g.$ML(u.message,u.name)}}addFileSystemProvider(u,o,i){return this.b.set(u,{impl:o,extUri:i?.isCaseSensitive?C.$pg:C.$rg,isReadonly:!!i?.isReadonly}),(0,m.$Pc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??C.$pg}};e.$uec=S,e.$uec=S=v=He([Be(0,b.$zM),Be(1,y.$8dc)],S),e.$vec=(0,L.$Vh)("IExtHostConsumerFileSystem")}),define(ke[322],Se([1,0,4,34,2,6,15,7,48]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class m{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,S,w,u,o,i){this.a=Math.random(),this.b=new D.$Rd,this.c=new D.$Rd,this.d=new D.$Rd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,T.$Cj)(o),r=typeof o=="string",a=i?.correlate,t=u(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(a&&typeof s.session>"u")){if(!i?.ignoreCreateEvents)for(const d of s.created){const l=g.URI.revive(d);n(l.fsPath)&&(!r||S.getWorkspaceFolder(l))&&this.b.fire(l)}if(!i?.ignoreChangeEvents)for(const d of s.changed){const l=g.URI.revive(d);n(l.fsPath)&&(!r||S.getWorkspaceFolder(l))&&this.c.fire(l)}if(!i?.ignoreDeleteEvents)for(const d of s.deleted){const l=g.URI.revive(d);n(l.fsPath)&&(!r||S.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$zK.from(this.i(v,w,o,i,i?.correlate),this.b,this.c,this.d,t)}i(v,S,w,u,o){const i=b.$zK.from();if(typeof w=="string")return i;const n=v.getProxy(R.$xK.MainThreadFileSystemEventService);let r=!1;return(w.pattern.includes(T.$yj)||w.pattern.includes(T.$zj))&&(r=!0),n.$watch(S.identifier.value,this.a,w.baseUri,{recursive:r,excludes:u?.excludes??[]},!!o),b.$zK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new y.$U(()=>this.a.created.map(g.URI.revive)),this.c=new y.$U(()=>this.a.changed.map(g.URI.revive)),this.d=new y.$U(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(v,S,w){this.j=v,this.k=S,this.l=w,this.a=new D.$Rd,this.b=new D.$Rd,this.c=new D.$Rd,this.d=new D.$Rd,this.g=new D.$Td,this.h=new D.$Td,this.i=new D.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,S,w,u){return new m(this.j,v,S,this.a.event,L.GlobPattern.from(w),u)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,S){switch(v){case 2:this.b.fire(Object.freeze({files:S.map(w=>({oldUri:g.URI.revive(w.source),newUri:g.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(w=>g.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(w=>g.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,S){return(w,u,o)=>{const i=function(r){w.call(u,r)};return i.extension=v,S.event(i,void 0,o)}}async $onWillRunFileOperation(v,S,w,u){switch(v){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:g.URI.revive(o.source),newUri:g.URI.revive(o.target)}))},w,u);case 1:return await this.n(this.i,{files:S.map(o=>g.URI.revive(o.target))},w,u);case 0:case 3:return await this.n(this.h,{files:S.map(o=>g.URI.revive(o.target))},w,u)}}async n(v,S,w,u){const o=new Set,i=[];if(await v.fireAsync(S,u,async(r,a)=>{const t=Date.now(),s=await Promise.resolve(r);s instanceof b.$JK&&(i.push([a.extension,s]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>w&&this.k.warn("SLOW file-participant",a.extension.identifier)}),u.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:a}=L.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(o)}}}e.$jfc=C}),define(ke[323],Se([1,0,3,2,6,15,7,35,12]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class m{static{this.a=0}constructor(v,S){this.extension=v,this.provider=S,this.handle=m.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class C{static{this.a=0}constructor(v,S,w,u){this.f=w,this.g=u,this.b=new Map,this.d=new Map,this.e=v.getProxy(g.$xK.MainThreadInlineChat),S.registerApiCommand(new b.$ZM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$XM("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?R.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?R.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?R.Position.from(o.position):void 0}})],b.$YM.Void))}registerProvider(v,S,w){const u=new m(v,S);return this.b.set(u.handle,u),this.e.$registerInteractiveEditorProvider(u.handle,w?.label??v.displayName??v.name,v.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",w?.supportReportIssue??!1),(0,D.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(u.handle),this.b.delete(u.handle)})}async $prepareSession(v,S,w,u){const o=this.b.get(v);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(S)),n=R.Selection.to(w),r=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},u);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=C.a++;return this.d.set(a,new A(r)),{id:a,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(r.wholeRange),message:r.message}}async $provideResponse(v,S,w,u){const o=this.b.get(v);if(!o)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:w.prompt,selection:R.Selection.to(w.selection),wholeRange:R.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let r=!1;const a={report:async c=>{if(!w.live&&c.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||u.isCancellationRequested||await this.e.$handleProgressChunk(w.requestId,{message:c.message,edits:c.edits?.map(R.TextEdit.from),editsShouldBeInstant:c.editsShouldBeInstant,slashCommand:c.slashCommand?.command,markdownFragment:L.$ZK.isMarkdownString(c.content)?c.content.value:c.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,a,u));let s;try{s=await(0,y.$Mg)(t,u)}finally{r=!0}if(!s)return;const d=i.responses.push(s)-1,l={wholeRange:R.Range.from(s.wholeRange),placeholder:s.placeholder};if(C.h(s)){const{edits:c,contents:h}=s,E=h!==void 0?R.MarkdownString.from(h):void 0;return c instanceof L.$JK?{...l,id:d,type:"bulkEdit",edits:R.WorkspaceEdit.from(c),message:E}:{...l,id:d,type:"editorEdit",edits:c.map(R.TextEdit.from),message:E}}return{...l,id:d,type:"message",message:R.MarkdownString.from(s.contents)}}async $provideFollowups(v,S,w,u){const o=this.b.get(v),i=this.d.get(S),n=i?.responses[w];if(o&&n&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(i.session,n,u));return(await(0,y.$Mg)(r,u))?.map(R.ChatReplyFollowup.from)}}$handleFeedback(v,S,w,u){const o=this.b.get(v),i=this.d.get(S),n=i?.responses[w];if(o&&n){const r=R.InteractiveEditorResponseFeedbackKind.to(u);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(v,S){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$kfc=C}),define(ke[324],Se([1,0,2,35]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class g{constructor(L,b,y,m,A){this.a=b,this.b=y,this.c=m;const C=new T.$ZM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$XM("showOptions","Show Options",$=>!0,$=>$),new T.$XM("resource","Interactive resource Uri",$=>!0,$=>$),new T.$XM("controllerId","Notebook controller Id",$=>!0,$=>$),new T.$XM("title","Interactive editor title",$=>!0,$=>$)],new T.$YM("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const v=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:D.URI.revive($.notebookUri),inputUri:D.URI.revive($.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:D.URI.revive($.notebookUri),inputUri:D.URI.revive($.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(L,b,y,m){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:y,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$xfc=g}),define(ke[325],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;class g{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(D.$xK.MainThreadIssueReporter)}async $getIssueReporterUri(L,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const y=this.a.get(L);if(!y)throw new Error("Issue request handler not found");const m=await y.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}async $getIssueReporterData(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const y=this.b.get(L);if(!y)throw new Error("Issue data provider not found");const m=await y.provideIssueData(b);if(!m)throw new Error("Issue data provider returned no result");return m}async $getIssueReporterTemplate(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const y=this.b.get(L);if(!y)throw new Error("Issue data provider not found");const m=await y.provideIssueTemplate(b);if(!m)throw new Error("Issue template provider returned no result");return m}registerIssueUriRequestHandler(L,b){const y=L.identifier.value;return this.a.set(y,b),this.c.$registerIssueUriRequestHandler(y),new T.$zK(()=>{this.c.$unregisterIssueUriRequestHandler(y),this.a.delete(y)})}registerIssueDataProvider(L,b){const y=L.identifier.value;return this.b.set(y,b),this.c.$registerIssueDataProvider(y),new T.$zK(()=>{this.c.$unregisterIssueDataProvider(y),this.b.delete(y)})}}e.$yfc=g}),define(ke[326],Se([1,0,3,6]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;class g{constructor(L){this.b=0,this.a=L.getProxy(T.$xK.MainThreadLabelService)}$registerResourceLabelFormatter(L){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,L),(0,D.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$zfc=g}),define(ke[327],Se([1,0,2,24,15,7,83,6,13,29,19,18,169,21,26,3,132,122,110,38,8,12,25,213]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class d{constructor(B,X){this.d=B,this.e=X}async provideDocumentSymbols(B,X){const se=this.d.getDocument(B),oe=await this.e.provideDocumentSymbols(se,X);if(!(0,A.$Jb)(oe))return oe[0]instanceof R.$RK?oe.map(g.DocumentSymbol.from):d.f(oe)}static f(B){B=B.slice(0).sort((oe,ee)=>{let ge=oe.location.range.start.compareTo(ee.location.range.start);return ge===0&&(ge=ee.location.range.end.compareTo(oe.location.range.end)),ge});const X=[],se=[];for(const oe of B){const ee={name:oe.name||"!!MISSING: name!!",kind:g.SymbolKind.from(oe.kind),tags:oe.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:g.Range.from(oe.location.range),selectionRange:g.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(ee),X.push(ee);break}const ge=se[se.length-1];if(m.$zs.containsRange(ge.range,ee.range)&&!m.$zs.equalsRange(ge.range,ee.range)){ge.children?.push(ee),se.push(ee);break}se.pop()}}return X}}class l{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,X,se){this.g=B,this.h=X,this.j=se,this.e=new i.$4dc("CodeLens"),this.f=new Map}async provideCodeLenses(B,X){const se=this.g.getDocument(B),oe=await this.j.provideCodeLenses(se,X);if(!oe||X.isCancellationRequested)return;const ee=this.e.add(oe),ge=new w.$Qc;this.f.set(ee,ge);const ye={cacheId:ee,lenses:[]};for(let je=0;je<oe.length;je++)ye.lenses.push({cacheId:[ee,je],range:g.Range.from(oe[je].range),command:this.h.toInternal(oe[je].command,ge)});return ye}async resolveCodeLens(B,X){const se=B.cacheId&&this.e.get(...B.cacheId);if(!se)return;let oe;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this.j.resolveCodeLens(se,X),oe||(oe=se),X.isCancellationRequested)return;const ee=B.cacheId&&this.f.get(B.cacheId[0]);if(ee)return B.command=this.h.toInternal(oe.command??l.d,ee),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function c(Pe){return Array.isArray(Pe)?Pe.map(g.DefinitionLink.from):Pe?[g.DefinitionLink.from(Pe)]:[]}class h{constructor(B,X){this.d=B,this.e=X}async provideDefinition(B,X,se){const oe=this.d.getDocument(B),ee=g.Position.to(X),ge=await this.e.provideDefinition(oe,ee,se);return c(ge)}}class E{constructor(B,X){this.d=B,this.e=X}async provideDeclaration(B,X,se){const oe=this.d.getDocument(B),ee=g.Position.to(X),ge=await this.e.provideDeclaration(oe,ee,se);return c(ge)}}class I{constructor(B,X){this.d=B,this.e=X}async provideImplementation(B,X,se){const oe=this.d.getDocument(B),ee=g.Position.to(X),ge=await this.e.provideImplementation(oe,ee,se);return c(ge)}}class f{constructor(B,X){this.d=B,this.e=X}async provideTypeDefinition(B,X,se){const oe=this.d.getDocument(B),ee=g.Position.to(X),ge=await this.e.provideTypeDefinition(oe,ee,se);return c(ge)}}class p{constructor(B,X){this.d=B,this.e=X}async provideHover(B,X,se){const oe=this.d.getDocument(B),ee=g.Position.to(X),ge=await this.e.provideHover(oe,ee,se);if(!(!ge||(0,A.$Jb)(ge.contents)))return ge.range||(ge.range=oe.getWordRangeAtPosition(ee)),ge.range||(ge.range=new R.$BK(ee,ee)),g.Hover.from(ge)}}class k{constructor(B,X){this.d=B,this.e=X}async provideEvaluatableExpression(B,X,se){const oe=this.d.getDocument(B),ee=g.Position.to(X),ge=await this.e.provideEvaluatableExpression(oe,ee,se);if(ge)return g.EvaluatableExpression.from(ge)}}class P{constructor(B,X){this.d=B,this.e=X}async provideInlineValues(B,X,se,oe){const ee=this.d.getDocument(B),ge=await this.e.provideInlineValues(ee,g.Range.to(X),g.InlineValueContext.to(se),oe);if(Array.isArray(ge))return ge.map(ye=>g.InlineValue.from(ye))}}class j{constructor(B,X){this.d=B,this.e=X}async provideDocumentHighlights(B,X,se){const oe=this.d.getDocument(B),ee=g.Position.to(X),ge=await this.e.provideDocumentHighlights(oe,ee,se);if(Array.isArray(ge))return ge.map(g.DocumentHighlight.from)}}class z{constructor(B,X){this.d=B,this.e=X}async provideLinkedEditingRanges(B,X,se){const oe=this.d.getDocument(B),ee=g.Position.to(X),ge=await this.e.provideLinkedEditingRanges(oe,ee,se);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,A.$Gb)(ge.ranges.map(g.Range.from)),wordPattern:ge.wordPattern}}}class M{constructor(B,X){this.d=B,this.e=X}async provideReferences(B,X,se,oe){const ee=this.d.getDocument(B),ge=g.Position.to(X),ye=await this.e.provideReferences(ee,ge,se,oe);if(Array.isArray(ye))return ye.map(g.location.from)}}class F{static{this.d=1e3}constructor(B,X,se,oe,ee,ge,ye){this.g=B,this.h=X,this.j=se,this.k=oe,this.l=ee,this.m=ge,this.n=ye,this.e=new i.$4dc("CodeAction"),this.f=new Map}async provideCodeActions(B,X,se,oe){const ee=this.g.getDocument(B),ge=$.$Bs.isISelection(X)?g.Selection.to(X):g.Range.to(X),ye=[];for(const nt of this.j.getDiagnostics(B))if(ge.intersection(nt.range)&&ye.push(nt)>F.d)break;const je={diagnostics:ye,only:se.only?new R.$TK(se.only):void 0,triggerKind:g.CodeActionTriggerKind.to(se.trigger)},We=await this.k.provideCodeActions(ee,ge,je,oe);if(!(0,A.$Kb)(We)||oe.isCancellationRequested)return;const et=this.e.add(We),Ye=new w.$Qc;this.f.set(et,Ye);const rt=[];for(let nt=0;nt<We.length;nt++){const Ae=We[nt];Ae&&(F.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[et,nt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(g.Diagnostic.from),edit:Ae.edit&&g.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$LF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:et,actions:rt}}async resolveCodeAction(B,X){const[se,oe]=B,ee=this.e.get(se,oe);if(!ee||F.o(ee))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(ee,X)??ee;let ye;ge.edit&&(ye=g.WorkspaceEdit.from(ge.edit,void 0));let je;if(ge.command){const We=this.f.get(se);We&&(je=this.h.toInternal(ge.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class N{static toInternalProviderId(B,X){return B+"."+X}constructor(B,X,se,oe,ee){this.d=B,this.e=X,this.f=se,this.g=oe,this.h=ee}async prepareDocumentPaste(B,X,se,oe){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(B),ge=X.map(We=>g.Range.to(We)),ye=g.DataTransfer.toDataTransfer(se,()=>{throw new r.$0});if(await this.f.prepareDocumentPaste(ee,ge,ye,oe),oe.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof R.$nL));return g.DataTransfer.from(je)}async providePasteEdits(B,X,se,oe,ee){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(X),ye=se.map(et=>g.Range.to(et)),je=g.DataTransfer.toDataTransfer(oe,async et=>(await this.d.$resolvePasteFileData(this.g,B,et)).buffer),We=await this.f.provideDocumentPasteEdits(ge,ye,je,ee);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(et=>"mimeType"in et?et:{providerId:N.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?g.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(B,X){this.d=B,this.e=X}async provideDocumentFormattingEdits(B,X,se){const oe=this.d.getDocument(B),ee=await this.e.provideDocumentFormattingEdits(oe,X,se);if(Array.isArray(ee))return ee.map(g.TextEdit.from)}}class W{constructor(B,X){this.d=B,this.e=X}async provideDocumentRangeFormattingEdits(B,X,se,oe){const ee=this.d.getDocument(B),ge=g.Range.to(X),ye=await this.e.provideDocumentRangeFormattingEdits(ee,ge,se,oe);if(Array.isArray(ye))return ye.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,X,se,oe){(0,C.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(B),ge=X.map(g.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(ee,ge,se,oe);if(Array.isArray(ye))return ye.map(g.TextEdit.from)}}class x{constructor(B,X){this.d=B,this.e=X,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,X,se,oe,ee){const ge=this.d.getDocument(B),ye=g.Position.to(X),je=await this.e.provideOnTypeFormattingEdits(ge,ye,se,oe,ee);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class ce{constructor(B,X){this.e=B,this.f=X,this.d=new i.$4dc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,X){const se=await this.e.provideWorkspaceSymbols(B,X);if(!(0,A.$Kb)(se))return{symbols:[]};const oe=this.d.add(se),ee={cacheId:oe,symbols:[]};for(let ge=0;ge<se.length;ge++){const ye=se[ge];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ee.symbols.push({...g.WorkspaceSymbol.from(ye),cacheId:[oe,ge]})}return ee}async resolveWorkspaceSymbol(B,X){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const se=this.d.get(...B.cacheId);if(se){const oe=await this.e.resolveWorkspaceSymbol(se,X);return oe&&(0,T.$dn)(B,g.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Y{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,X,se){this.d=B,this.e=X,this.f=se}async provideRenameEdits(B,X,se,oe){const ee=this.d.getDocument(B),ge=g.Position.to(X);try{const ye=await this.e.provideRenameEdits(ee,ge,se,oe);return ye?g.WorkspaceEdit.from(ye):void 0}catch(ye){const je=Y.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,X,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(B),ee=g.Position.to(X);try{const ge=await this.e.prepareRename(oe,ee,se);let ye,je;if(R.$BK.isRange(ge)?(ye=ge,je=oe.getText(ge)):(0,C.$Ef)(ge)&&(ye=ge.range,je=ge.placeholder),!ye||!je)return;if(ye.start.line>ee.line||ye.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(ye),text:je}}catch(ge){const ye=Y.g(ge);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class G{constructor(B,X){this.resultId=B,this.tokens=X}}class J{constructor(B,X){this.f=B,this.g=X,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,X,se){const oe=this.f.getDocument(B),ee=X!==0?this.d.get(X):null;let ge=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,ee.resultId,se):await this.g.provideDocumentSemanticTokens(oe,se);return ee&&this.d.delete(X),ge?(ge=J.h(ge),this.o(J.n(ee,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return J.j(B)?J.k(B)?B:new R.$QL(new Uint32Array(B.data),B.resultId):J.l(B)?J.m(B)?B:new R.$SL(B.edits.map(X=>new R.$RL(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const X of B.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static n(B,X){if(!J.j(X)||!B||!B.tokens)return X;const se=B.tokens,oe=se.length,ee=X.data,ge=ee.length;let ye=0;const je=Math.min(oe,ge);for(;ye<je&&se[ye]===ee[ye];)ye++;if(ye===oe&&ye===ge)return new R.$SL([],X.resultId);let We=0;const et=je-ye;for(;We<et&&se[oe-We-1]===ee[ge-We-1];)We++;return new R.$SL([{start:ye,deleteCount:oe-ye-We,data:ee.subarray(ye,ge-We)}],X.resultId)}o(B,X){if(J.j(B)){const se=this.e++;return this.d.set(se,new G(B.resultId,B.data)),(0,u.$Z0)({id:se,type:"full",data:B.data})}if(J.l(B)){const se=this.e++;return J.j(X)?this.d.set(se,new G(X.resultId,X.data)):this.d.set(se,new G(B.resultId)),(0,u.$Z0)({id:se,type:"delta",deltas:(B.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class le{constructor(B,X){this.d=B,this.e=X}async provideDocumentRangeSemanticTokens(B,X,se){const oe=this.d.getDocument(B),ee=await this.e.provideDocumentRangeSemanticTokens(oe,g.Range.to(X),se);return ee?this.f(ee):null}f(B){return(0,u.$Z0)({id:0,type:"full",data:B.data})}}class Q{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,X,se,oe,ee){this.f=B,this.g=X,this.h=se,this.j=oe,this.k=ee,this.d=new i.$4dc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,X,se,oe){const ee=this.f.getDocument(B),ge=g.Position.to(X),ye=ee.getWordRangeAtPosition(ge)||new R.$BK(ge,ge),je=ye.with({end:ge}),We=new n.$Nd,et=await this.h.provideCompletionItems(ee,ge,oe,g.CompletionContext.to(se));if(!et||oe.isCancellationRequested)return;const Ye=Array.isArray(et)?new R.$7K(et):et,rt=Q.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),nt=new w.$Qc;this.e.set(rt,nt);const Ae=[],Oe={x:rt,b:Ae,a:{replace:g.Range.from(ye),insert:g.Range.from(je)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Ye.items.length;Ve++){const Le=Ye.items[Ve],Ze=this.l(Le,[rt,Ve],je,ye);Ae.push(Ze)}return Oe}async resolveCompletionItem(B,X){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...B);if(!se)return;const oe=this.l(se,B),ee=await this.h.resolveCompletionItem(se,X);if(!ee)return;const ge=this.l(ee,B);return(oe.h!==ge.h||oe.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==ge.n||oe.o!==ge.o||!(0,T.$en)(oe.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,X,se,oe){const ee=this.e.get(X[0]);if(!ee)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,ee),ye={x:X,a:B.label,b:B.kind!==void 0?g.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(g.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:g.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(g.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof R.$KK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),R.$BK.isRange(je)?ye.j=g.Range.from(je):je&&(!se?.isEqual(je.inserting)||!oe?.isEqual(je.replacing))&&(ye.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),ye}}class Ee{async provideInlineCompletions(B,X,se,oe){}disposeCompletions(B){}handleDidShowCompletionItem(B,X,se){}handlePartialAccept(B,X,se){}}class he extends Ee{constructor(B,X,se,oe){super(),this.f=B,this.g=X,this.h=se,this.j=oe,this.d=new K,this.e=(0,t.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,X,se,oe){const ee=this.g.getDocument(B),ge=g.Position.to(X),ye=await this.h.provideInlineCompletionItems(ee,ge,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:g.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},oe);if(!ye||oe.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],et=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:je}),items:je.map((nt,Ae)=>{let Oe;nt.command&&(Ye||(Ye=new w.$Qc),Oe=this.j.toInternal(nt.command,Ye));const Ve=nt.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:nt.filterText,range:nt.range?g.Range.from(nt.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:We.map(nt=>(Ye||(Ye=new w.$Qc),this.j.toInternal(nt,Ye))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,X,se){const oe=this.d.get(B)?.items[X];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,se)}handlePartialAccept(B,X,se){const oe=this.d.get(B)?.items[X];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,se)}}class K{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const X=this.e++;return this.d.set(X,B),X}disposeReferenceId(B){const X=this.d.get(B);return this.d.delete(B),X}get(B){return this.d.get(B)}}class U{constructor(B,X){this.e=B,this.f=X,this.d=new i.$4dc("SignatureHelp")}async provideSignatureHelp(B,X,se,oe){const ee=this.e.getDocument(B),ge=g.Position.to(X),ye=this.g(se),je=await this.f.provideSignatureHelp(ee,ge,oe,ye);if(je){const We=this.d.add([je]);return{...g.SignatureHelp.from(je),id:We}}}g(B){let X;if(B.activeSignatureHelp){const se=g.SignatureHelp.to(B.activeSignatureHelp),oe=this.d.get(B.activeSignatureHelp.id,0);oe?(X=oe,X.activeSignature=se.activeSignature,X.activeParameter=se.activeParameter):X=se}return{...B,activeSignatureHelp:X}}releaseSignatureHelp(B){this.d.delete(B)}}class ie{constructor(B,X,se,oe,ee){this.f=B,this.g=X,this.h=se,this.j=oe,this.k=ee,this.d=new i.$4dc("InlayHints"),this.e=new Map}async provideInlayHints(B,X,se){const oe=this.f.getDocument(B),ee=g.Range.to(X),ge=await this.h.provideInlayHints(oe,ee,se);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(X)}`);return}if(se.isCancellationRequested)return;const ye=this.d.add(ge);this.e.set(ye,new w.$Qc);const je={hints:[],cacheId:ye};for(let We=0;We<ge.length;We++)this.l(ge[We],ee)&&je.hints.push(this.m(ge[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(X)}`),je}async resolveInlayHint(B,X){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...B);if(!se)return;const oe=await this.h.resolveInlayHint(se,X);if(oe&&this.l(oe))return this.m(oe,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,X){return B.label.length===0||Array.isArray(B.label)&&B.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(X&&!X.contains(B.position))}m(B,X){const se=this.e.get(X[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:X,tooltip:g.MarkdownString.fromStrict(B.tooltip),position:g.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(g.TextEdit.from),kind:B.kind&&g.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?oe.label=B.label:oe.label=B.label.map(ee=>{const ge={label:ee.value};return ge.tooltip=g.MarkdownString.fromStrict(ee.tooltip),R.$LK.isLocation(ee.location)&&(ge.location=g.location.from(ee.location)),ee.command&&(ge.command=this.g.toInternal(ee.command,se)),ge}),oe}}class be{constructor(B,X){this.e=B,this.f=X,this.d=new i.$4dc("DocumentLink")}async provideLinks(B,X){const se=this.e.getDocument(B),oe=await this.f.provideDocumentLinks(se,X);if(!(!Array.isArray(oe)||oe.length===0)&&!X.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(be.g).map(g.DocumentLink.from)};{const ee=this.d.add(oe),ge={links:[],cacheId:ee};for(let ye=0;ye<oe.length;ye++){if(!be.g(oe[ye]))continue;const je=g.DocumentLink.from(oe[ye]);je.cacheId=[ee,ye],ge.links.push(je)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,X){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...B);if(!se)return;const oe=await this.f.resolveDocumentLink(se,X);if(!(!oe||!be.g(oe)))return g.DocumentLink.from(oe)}releaseLinks(B){this.d.delete(B)}}class H{constructor(B,X){this.d=B,this.e=X}async provideColors(B,X){const se=this.d.getDocument(B),oe=await this.e.provideDocumentColors(se,X);return Array.isArray(oe)?oe.map(ge=>({color:g.Color.from(ge.color),range:g.Range.from(ge.range)})):[]}async provideColorPresentations(B,X,se){const oe=this.d.getDocument(B),ee=g.Range.to(X.range),ge=g.Color.to(X.color),ye=await this.e.provideColorPresentations(ge,{document:oe,range:ee},se);if(Array.isArray(ye))return ye.map(g.ColorPresentation.from)}}class _{constructor(B,X){this.d=B,this.e=X}async provideFoldingRanges(B,X,se){const oe=this.d.getDocument(B),ee=await this.e.provideFoldingRanges(oe,X,se);if(Array.isArray(ee))return ee.map(g.FoldingRange.from)}}class Z{constructor(B,X,se){this.d=B,this.e=X,this.f=se}async provideSelectionRanges(B,X,se){const oe=this.d.getDocument(B),ee=X.map(g.Position.to),ge=await this.e.provideSelectionRanges(oe,ee,se);if(!(0,A.$Kb)(ge))return[];if(ge.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<ee.length;je++){const We=[];ye.push(We);let et=ee[je],Ye=ge[je];for(;;){if(!Ye.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(We.push(g.SelectionRange.from(Ye)),!Ye.parent)break;et=Ye.range,Ye=Ye.parent}}return ye}}class $e{constructor(B,X){this.f=B,this.g=X,this.d=new o.$EM(""),this.e=new Map}async prepareSession(B,X,se){const oe=this.f.getDocument(B),ee=g.Position.to(X),ge=await this.g.prepareCallHierarchy(oe,ee,se);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideCallsTo(B,X,se){const oe=this.j(B,X);if(!oe)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(oe,se);if(ee)return ee.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ye=>g.Range.from(ye))}))}async provideCallsFrom(B,X,se){const oe=this.j(B,X);if(!oe)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(oe,se);if(ee)return ee.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ye=>g.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,X){const se=this.e.get(B),oe=g.CallHierarchyItem.from(X,B,se.size.toString(36));return se.set(oe._itemId,X),oe}j(B,X){return this.e.get(B)?.get(X)}}class re{constructor(B,X){this.f=B,this.g=X,this.d=new o.$EM(""),this.e=new Map}async prepareSession(B,X,se){const oe=this.f.getDocument(B),ee=g.Position.to(X),ge=await this.g.prepareTypeHierarchy(oe,ee,se);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideSupertypes(B,X,se){const oe=this.j(B,X);if(!oe)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(oe,se);if(ee)return ee.map(ge=>this.h(B,ge))}async provideSubtypes(B,X,se){const oe=this.j(B,X);if(!oe)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(oe,se);if(ee)return ee.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,X){const se=this.e.get(B),oe=g.TypeHierarchyItem.from(X,B,se.size.toString(36));return se.set(oe._itemId,X),oe}j(B,X){return this.e.get(B)?.get(X)}}class fe{static toInternalProviderId(B,X){return B+"."+X}constructor(B,X,se,oe,ee){this.d=B,this.e=X,this.f=se,this.g=oe,this.h=ee}async provideDocumentOnDropEdits(B,X,se,oe,ee){const ge=this.e.getDocument(X),ye=g.Position.to(se),je=g.DataTransfer.toDataTransfer(oe,async et=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,et)).buffer),We=await this.f.provideDocumentDropEdits(ge,ye,je,ee);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(et=>"mimeType"in et?et:{providerId:fe.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?g.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,X){this.d=B,this.e=X}async provideMappedEdits(B,X,se,oe){const ee=D.URI.revive(B),ge=this.d.getDocument(ee),ye=se.documents.map(et=>et.map(Ye=>({uri:D.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(rt=>g.Range.to(rt))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,X,je,oe);return We?g.WorkspaceEdit.from(We):null}}class de{constructor(B,X){this.adapter=B,this.extension=X}}class pe{static{this.d=0}constructor(B,X,se,oe,ee,ge,ye,je){this.g=X,this.h=se,this.j=oe,this.k=ee,this.l=ge,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(b.$xK.MainThreadLanguageFeatures)}o(B,X){return g.DocumentSelector.from(B,this.g,X)}p(B){return new R.$zK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return pe.d++}async s(B,X,se,oe,ee,ge=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof X))return oe;const je=Date.now();ge||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(ye.adapter,ye.extension);return Promise.resolve(We).catch(et=>{(0,r.$3)(et)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(ye.extension.identifier,et))}).finally(()=>{ge||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),v.CancellationToken.isCancellationToken(ee)?(0,a.$Ng)(We,ee):We}t(B,X){const se=this.q();return this.f.set(se,new de(B,X)),se}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,X,se,oe){const ee=this.t(new d(this.h,se),B),ge=oe&&oe.label||pe.u(B);return this.e.$registerDocumentSymbolProvider(ee,this.o(X,B),ge),this.p(ee)}$provideDocumentSymbols(B,X,se){return this.s(B,d,oe=>oe.provideDocumentSymbols(D.URI.revive(X),se),void 0,se)}registerCodeLensProvider(B,X,se){const oe=this.q(),ee=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new de(new l(this.h,this.j.converter,se),B)),this.e.$registerCodeLensSupport(oe,this.o(X,B),ee);let ge=this.p(oe);if(ee!==void 0){const ye=se.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ee));ge=R.$zK.from(ge,ye)}return ge}$provideCodeLenses(B,X,se){return this.s(B,l,oe=>oe.provideCodeLenses(D.URI.revive(X),se),void 0,se)}$resolveCodeLens(B,X,se){return this.s(B,l,oe=>oe.resolveCodeLens(X,se),void 0,void 0)}$releaseCodeLenses(B,X){this.s(B,l,se=>Promise.resolve(se.releaseCodeLenses(X)),void 0,void 0)}registerDefinitionProvider(B,X,se){const oe=this.t(new h(this.h,se),B);return this.e.$registerDefinitionSupport(oe,this.o(X,B)),this.p(oe)}$provideDefinition(B,X,se,oe){return this.s(B,h,ee=>ee.provideDefinition(D.URI.revive(X),se,oe),[],oe)}registerDeclarationProvider(B,X,se){const oe=this.t(new E(this.h,se),B);return this.e.$registerDeclarationSupport(oe,this.o(X,B)),this.p(oe)}$provideDeclaration(B,X,se,oe){return this.s(B,E,ee=>ee.provideDeclaration(D.URI.revive(X),se,oe),[],oe)}registerImplementationProvider(B,X,se){const oe=this.t(new I(this.h,se),B);return this.e.$registerImplementationSupport(oe,this.o(X,B)),this.p(oe)}$provideImplementation(B,X,se,oe){return this.s(B,I,ee=>ee.provideImplementation(D.URI.revive(X),se,oe),[],oe)}registerTypeDefinitionProvider(B,X,se){const oe=this.t(new f(this.h,se),B);return this.e.$registerTypeDefinitionSupport(oe,this.o(X,B)),this.p(oe)}$provideTypeDefinition(B,X,se,oe){return this.s(B,f,ee=>ee.provideTypeDefinition(D.URI.revive(X),se,oe),[],oe)}registerHoverProvider(B,X,se,oe){const ee=this.t(new p(this.h,se),B);return this.e.$registerHoverProvider(ee,this.o(X,B)),this.p(ee)}$provideHover(B,X,se,oe){return this.s(B,p,ee=>ee.provideHover(D.URI.revive(X),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(B,X,se,oe){const ee=this.t(new k(this.h,se),B);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(X,B)),this.p(ee)}$provideEvaluatableExpression(B,X,se,oe){return this.s(B,k,ee=>ee.provideEvaluatableExpression(D.URI.revive(X),se,oe),void 0,oe)}registerInlineValuesProvider(B,X,se,oe){const ee=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new P(this.h,se),B);this.e.$registerInlineValuesProvider(ge,this.o(X,B),ee);let ye=this.p(ge);if(ee!==void 0){const je=se.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(ee));ye=R.$zK.from(ye,je)}return ye}$provideInlineValues(B,X,se,oe,ee){return this.s(B,P,ge=>ge.provideInlineValues(D.URI.revive(X),se,oe,ee),void 0,ee)}registerDocumentHighlightProvider(B,X,se){const oe=this.t(new j(this.h,se),B);return this.e.$registerDocumentHighlightProvider(oe,this.o(X,B)),this.p(oe)}$provideDocumentHighlights(B,X,se,oe){return this.s(B,j,ee=>ee.provideDocumentHighlights(D.URI.revive(X),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(B,X,se){const oe=this.t(new z(this.h,se),B);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(X,B)),this.p(oe)}$provideLinkedEditingRanges(B,X,se,oe){return this.s(B,z,async ee=>{const ge=await ee.provideLinkedEditingRanges(D.URI.revive(X),se,oe);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?pe.w(ge.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(B,X,se){const oe=this.t(new M(this.h,se),B);return this.e.$registerReferenceSupport(oe,this.o(X,B)),this.p(oe)}$provideReferences(B,X,se,oe,ee){return this.s(B,M,ge=>ge.provideReferences(D.URI.revive(X),se,oe,ee),void 0,ee)}registerCodeActionProvider(B,X,se,oe){const ee=new w.$Qc,ge=this.t(new F(this.h,this.j.converter,this.k,se,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(X,B),{providedKinds:oe?.providedCodeActionKinds?.map(ye=>ye.value),documentation:oe?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ee)}))},pe.u(B),!!se.resolveCodeAction),ee.add(this.p(ge)),ee}$provideCodeActions(B,X,se,oe,ee){return this.s(B,F,ge=>ge.provideCodeActions(D.URI.revive(X),se,oe,ee),void 0,ee)}$resolveCodeAction(B,X,se){return this.s(B,F,oe=>oe.resolveCodeAction(X,se),{},void 0)}$releaseCodeActions(B,X){this.s(B,F,se=>Promise.resolve(se.releaseCodeActions(X)),void 0,void 0)}registerDocumentFormattingEditProvider(B,X,se){const oe=this.t(new O(this.h,se),B);return this.e.$registerDocumentFormattingSupport(oe,this.o(X,B),B.identifier,B.displayName||B.name),this.p(oe)}$provideDocumentFormattingEdits(B,X,se,oe){return this.s(B,O,ee=>ee.provideDocumentFormattingEdits(D.URI.revive(X),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(B,X,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",ee=this.t(new W(this.h,se),B);return this.e.$registerRangeFormattingSupport(ee,this.o(X,B),B.identifier,B.displayName||B.name,oe),this.p(ee)}$provideDocumentRangeFormattingEdits(B,X,se,oe,ee){return this.s(B,W,ge=>ge.provideDocumentRangeFormattingEdits(D.URI.revive(X),se,oe,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(B,X,se,oe,ee){return this.s(B,W,ge=>ge.provideDocumentRangesFormattingEdits(D.URI.revive(X),se,oe,ee),void 0,ee)}registerOnTypeFormattingEditProvider(B,X,se,oe){const ee=this.t(new x(this.h,se),B);return this.e.$registerOnTypeFormattingSupport(ee,this.o(X,B),oe,B.identifier),this.p(ee)}$provideOnTypeFormattingEdits(B,X,se,oe,ee,ge){return this.s(B,x,ye=>ye.provideOnTypeFormattingEdits(D.URI.revive(X),se,oe,ee,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,X){const se=this.t(new ce(X,this.l),B);return this.e.$registerNavigateTypeSupport(se,typeof X.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(B,X,se){return this.s(B,ce,oe=>oe.provideWorkspaceSymbols(X,se),{symbols:[]},se)}$resolveWorkspaceSymbol(B,X,se){return this.s(B,ce,oe=>oe.resolveWorkspaceSymbol(X,se),void 0,void 0)}$releaseWorkspaceSymbols(B,X){this.s(B,ce,se=>se.releaseWorkspaceSymbols(X),void 0,void 0)}registerRenameProvider(B,X,se){const oe=this.t(new Y(this.h,se,this.l),B);return this.e.$registerRenameSupport(oe,this.o(X,B),Y.supportsResolving(se)),this.p(oe)}$provideRenameEdits(B,X,se,oe,ee){return this.s(B,Y,ge=>ge.provideRenameEdits(D.URI.revive(X),se,oe,ee),void 0,ee)}$resolveRenameLocation(B,X,se,oe){return this.s(B,Y,ee=>ee.resolveRenameLocation(D.URI.revive(X),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(B,X,se,oe){const ee=this.t(new J(this.h,se),B),ge=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(X,B),oe,ge);let ye=this.p(ee);if(ge){const je=se.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));ye=R.$zK.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,X,se,oe){return this.s(B,J,ee=>ee.provideDocumentSemanticTokens(D.URI.revive(X),se,oe),null,oe)}$releaseDocumentSemanticTokens(B,X){this.s(B,J,se=>se.releaseDocumentSemanticColoring(X),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,X,se,oe){const ee=this.t(new le(this.h,se),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(X,B),oe),this.p(ee)}$provideDocumentRangeSemanticTokens(B,X,se,oe){return this.s(B,le,ee=>ee.provideDocumentRangeSemanticTokens(D.URI.revive(X),se,oe),null,oe)}registerCompletionItemProvider(B,X,se,oe){const ee=this.t(new Q(this.h,this.j.converter,se,this.m,B),B);return this.e.$registerCompletionsProvider(ee,this.o(X,B),oe,Q.supportsResolving(se),B.identifier),this.p(ee)}$provideCompletionItems(B,X,se,oe,ee){return this.s(B,Q,ge=>ge.provideCompletionItems(D.URI.revive(X),se,oe,ee),void 0,ee)}$resolveCompletionItem(B,X,se){return this.s(B,Q,oe=>oe.resolveCompletionItem(X,se),void 0,se)}$releaseCompletionItems(B,X){this.s(B,Q,se=>se.releaseCompletionItems(X),void 0,void 0)}registerInlineCompletionsProvider(B,X,se,oe){const ee=new he(B,this.h,se,this.j.converter),ge=this.t(ee,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(X,B),ee.supportsHandleEvents,S.$_l.toKey(B.identifier.value),oe?.yieldTo?.map(ye=>S.$_l.toKey(ye))||[]),this.p(ge)}$provideInlineCompletions(B,X,se,oe,ee){return this.s(B,Ee,ge=>ge.provideInlineCompletions(D.URI.revive(X),se,oe,ee),void 0,ee)}$handleInlineCompletionDidShow(B,X,se,oe){this.s(B,Ee,async ee=>{ee.handleDidShowCompletionItem(X,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,X,se,oe){this.s(B,Ee,async ee=>{ee.handlePartialAccept(X,se,oe)},void 0,void 0)}$freeInlineCompletionsList(B,X){this.s(B,Ee,async se=>{se.disposeCompletions(X)},void 0,void 0)}registerSignatureHelpProvider(B,X,se,oe){const ee=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ge=this.t(new U(this.h,se),B);return this.e.$registerSignatureHelpProvider(ge,this.o(X,B),ee),this.p(ge)}$provideSignatureHelp(B,X,se,oe,ee){return this.s(B,U,ge=>ge.provideSignatureHelp(D.URI.revive(X),se,oe,ee),void 0,ee)}$releaseSignatureHelp(B,X){this.s(B,U,se=>se.releaseSignatureHelp(X),void 0,void 0)}registerInlayHintsProvider(B,X,se){const oe=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ie(this.h,this.j.converter,se,this.l,B),B);this.e.$registerInlayHintsProvider(ee,this.o(X,B),typeof se.resolveInlayHint=="function",oe,pe.u(B));let ge=this.p(ee);if(oe!==void 0){const ye=se.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(oe));ge=R.$zK.from(ge,ye)}return ge}$provideInlayHints(B,X,se,oe){return this.s(B,ie,ee=>ee.provideInlayHints(D.URI.revive(X),se,oe),void 0,oe)}$resolveInlayHint(B,X,se){return this.s(B,ie,oe=>oe.resolveInlayHint(X,se),void 0,se)}$releaseInlayHints(B,X){this.s(B,ie,se=>se.releaseHints(X),void 0,void 0)}registerDocumentLinkProvider(B,X,se){const oe=this.t(new be(this.h,se),B);return this.e.$registerDocumentLinkProvider(oe,this.o(X,B),typeof se.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(B,X,se){return this.s(B,be,oe=>oe.provideLinks(D.URI.revive(X),se),void 0,se,X.scheme==="output")}$resolveDocumentLink(B,X,se){return this.s(B,be,oe=>oe.resolveLink(X,se),void 0,void 0,!0)}$releaseDocumentLinks(B,X){this.s(B,be,se=>se.releaseLinks(X),void 0,void 0,!0)}registerColorProvider(B,X,se){const oe=this.t(new H(this.h,se),B);return this.e.$registerDocumentColorProvider(oe,this.o(X,B)),this.p(oe)}$provideDocumentColors(B,X,se){return this.s(B,H,oe=>oe.provideColors(D.URI.revive(X),se),[],se)}$provideColorPresentations(B,X,se,oe){return this.s(B,H,ee=>ee.provideColorPresentations(D.URI.revive(X),se,oe),void 0,oe)}registerFoldingRangeProvider(B,X,se){const oe=this.q(),ee=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new de(new _(this.h,se),B)),this.e.$registerFoldingRangeProvider(oe,this.o(X,B),B.identifier,ee);let ge=this.p(oe);if(ee!==void 0){const ye=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));ge=R.$zK.from(ge,ye)}return ge}$provideFoldingRanges(B,X,se,oe){return this.s(B,_,ee=>ee.provideFoldingRanges(D.URI.revive(X),se,oe),void 0,oe)}registerSelectionRangeProvider(B,X,se){const oe=this.t(new Z(this.h,se,this.l),B);return this.e.$registerSelectionRangeProvider(oe,this.o(X,B)),this.p(oe)}$provideSelectionRanges(B,X,se,oe){return this.s(B,Z,ee=>ee.provideSelectionRanges(D.URI.revive(X),se,oe),[],oe)}registerCallHierarchyProvider(B,X,se){const oe=this.t(new $e(this.h,se),B);return this.e.$registerCallHierarchyProvider(oe,this.o(X,B)),this.p(oe)}$prepareCallHierarchy(B,X,se,oe){return this.s(B,$e,ee=>Promise.resolve(ee.prepareSession(D.URI.revive(X),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(B,X,se,oe){return this.s(B,$e,ee=>ee.provideCallsTo(X,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(B,X,se,oe){return this.s(B,$e,ee=>ee.provideCallsFrom(X,se,oe),void 0,oe)}$releaseCallHierarchy(B,X){this.s(B,$e,se=>Promise.resolve(se.releaseSession(X)),void 0,void 0)}registerTypeHierarchyProvider(B,X,se){const oe=this.t(new re(this.h,se),B);return this.e.$registerTypeHierarchyProvider(oe,this.o(X,B)),this.p(oe)}$prepareTypeHierarchy(B,X,se,oe){return this.s(B,re,ee=>Promise.resolve(ee.prepareSession(D.URI.revive(X),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(B,X,se,oe){return this.s(B,re,ee=>ee.provideSupertypes(X,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(B,X,se,oe){return this.s(B,re,ee=>ee.provideSubtypes(X,se,oe),void 0,oe)}$releaseTypeHierarchy(B,X){this.s(B,re,se=>Promise.resolve(se.releaseSession(X)),void 0,void 0)}registerDocumentOnDropEditProvider(B,X,se,oe){const ee=this.q();this.f.set(ee,new de(new fe(this.e,this.h,se,ee,B),B));const ge=(0,t.$LF)(B,"dropMetadata")&&oe?fe.toInternalProviderId(B.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ee,this.o(X,B),ge,(0,t.$LF)(B,"dropMetadata")?oe:void 0),this.p(ee)}$provideDocumentOnDropEdits(B,X,se,oe,ee,ge){return this.s(B,fe,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(X,D.URI.revive(se),oe,ee,ge)),void 0,void 0)}registerMappedEditsProvider(B,X,se){const oe=this.t(new te(this.h,se),B);return this.e.$registerMappedEditsProvider(oe,this.o(X,B)),this.p(oe)}$provideMappedEdits(B,X,se,oe,ee){return this.s(B,te,ge=>Promise.resolve(ge.provideMappedEdits(X,se,oe,ee)),null,ee)}registerDocumentPasteEditProvider(B,X,se,oe){const ee=this.q();this.f.set(ee,new de(new N(this.e,this.h,se,ee,B),B));const ge=N.toInternalProviderId(B.identifier.value,oe.id);return this.e.$registerPasteEditProvider(ee,this.o(X,B),ge,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(B,X,se,oe,ee){return this.s(B,N,ge=>ge.prepareDocumentPaste(D.URI.revive(X),se,oe,ee),void 0,ee)}$providePasteEdits(B,X,se,oe,ee,ge){return this.s(B,N,ye=>ye.providePasteEdits(X,D.URI.revive(se),oe,ee,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:pe.w(B.decreaseIndentPattern),increaseIndentPattern:pe.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?pe.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?pe.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:pe.w(B.beforeText),afterText:B.afterText?pe.w(B.afterText):void 0,previousLineText:B.previousLineText?pe.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(pe.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(X=>R.SyntaxTokenType.toString(X)):void 0}}static D(B){return B.map(pe.C)}setLanguageConfiguration(B,X,se){const{wordPattern:oe}=se;if(oe&&(0,y.$Se)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(X,oe):this.h.setWordDefinitionFor(X,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ee=this.q(),ge={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?pe.w(se.wordPattern):void 0,indentationRules:se.indentationRules?pe.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?pe.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?pe.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,X,ge),this.p(ee)}$setWordDefinitions(B){for(const X of B)this.h.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.$bec=pe}),define(ke[328],Se([1,0,6,15,7,39,12,3,25]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;class m{constructor(C,$,v,S){this.c=$,this.d=v,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$xK.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,$){await this.a.$changeLanguage(C,$);const v=this.c.getDocumentData(C);if(!v)throw new Error(`document '${C.toString()}' NOT found`);return v.document}async tokenAtPosition(C,$){const v=C.version,S=T.Position.from($),w=await this.a.$tokensAtPosition(C.uri,S),u={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition($)??new g.$BK($.line,$.character,$.line,$.character)};if(!w)return u;const o={range:T.Range.to(w.range),type:T.TokenType.to(w.type)};return!o.range.contains($)||v!==C.version?u:o}createLanguageStatusItem(C,$,v){const S=this.f++,w=this.a,u=this.g,o=`${C.identifier.value}/${$}`;if(u.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);u.add(o);const i={selector:v,id:$,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new b.$Qc,a=()=>{if(n?.dispose(),!u.has(o)){console.warn(`LanguageStatusItem (${$}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$Zg)(()=>{r.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?R.default.Error:i.severity===g.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),w.$removeLanguageStatus(S),u.delete(o)},get id(){return i.id},get name(){return i.name},set name(s){i.name=s,a()},get selector(){return i.selector},set selector(s){i.selector=s,a()},get text(){return i.text},set text(s){i.text=s,a()},set text2(s){(0,y.$MF)(C,"languageStatusText"),i.text=s,a()},get text2(){return(0,y.$MF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(s){i.detail=s,a()},get severity(){return i.severity},set severity(s){i.severity=s,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(s){i.accessibilityInformation=s,a()},get command(){return i.command},set command(s){i.command=s,a()},get busy(){return i.busy},set busy(s){i.busy=s,a()}};return a(),t}}e.$Afc=m}),define(ke[115],Se([1,0,11,13,2,5,14,6,27,20]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=e.$Yec=void 0;let A=class{constructor($,v,S){this.f=S,this.d=new Map,this.a=v.getProxy(b.$xK.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===D.$g}getMessage($,v){const{message:S,args:w,comment:u}=v;if(this.c)return(0,T.$He)(S,w??{});let o=S;u&&u.length>0&&(o+=`/${Array.isArray(u)?u.join(""):u}`);const i=this.d.get($)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,T.$He)(i??S,w??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let v;const S=await this.g($);if(!S){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const w=await this.a.$fetchBundleContents(S),u=JSON.parse(w);v=$.isBuiltin?u.contents?.bundle:u}catch(w){this.f.error(`Failed to load translations for ${$.identifier.value} from ${S}: ${w.message}`);return}v&&this.d.set($.identifier.value,{contents:v,uri:S})}async g($){if($.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return g.URI.revive(v)}return $.l10n?g.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Yec=A,e.$Yec=A=He([Be(0,y.$PM),Be(1,m.$zM),Be(2,L.$dj)],A),e.$Zec=(0,R.$Vh)("IExtHostLocalizationService")}),define(ke[152],Se([1,0,14,6,27,20,2,54]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;let y=class extends D.$oj{constructor(C,$){super($.logLevel,$.logsLocation,$.loggers.map(v=>(0,b.$sh)(v))),this.r=C.getProxy(T.$xK.MainThreadLogger)}$setLogLevel(C,$){$?this.setLogLevel(L.URI.revive($),C):this.setLogLevel(C)}setVisibility(C,$){super.setVisibility(C,$),this.r.$setVisibility(C,$)}s(C,$,v){return new m(this.r,C,$,v)}};e.$_fc=y,e.$_fc=y=He([Be(0,R.$zM),Be(1,g.$PM)],y);class m extends D.$jj{constructor(C,$,v,S){super(S?.logLevel==="always"),this.r=C,this.s=$,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger($,S).then(()=>{this.u(this.n),this.m=!0})}g(C,$){const v=[[C,$]];this.m?this.u(v):this.n.push(...v)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=void 0,e.$1ec=(0,T.$Vh)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$xK.MainThreadManagedSockets)}setFactory(C,$){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new y(C,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const $=++this.b,v=await this.c.makeConnection(),S=new g.$Qc;return this.d.set($,new m($,v,S)),S.add((0,g.$Pc)(()=>this.d.delete($))),S.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),S.dispose()})),S.add(v.onDidClose(w=>{this.a.$onDidManagedSocketClose($,w?.stack??w?.message),S.dispose()})),S.add(v.onDidReceiveMessage(w=>this.a.$onDidManagedSocketHaveData($,L.$fe.wrap(w)))),$}$remoteSocketWrite(C,$){this.d.get(C)?.actual.send($.buffer)}$remoteSocketEnd(C){const $=this.d.get(C);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$2ec=b,e.$2ec=b=He([Be(0,R.$zM)],b);class y{constructor(C,$){this.socketFactoryId=C,this.makeConnection=$}}class m extends g.$Rc{constructor(C,$,v){super(),this.socketId=C,this.actual=$,this.B(v)}}}),define(ke[329],Se([1,0,6,14,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;function R(b){return b&&b.title}let L=class{constructor(y,m){this.b=m,this.a=y.getProxy(D.$xK.MainThreadMessageService)}showMessage(y,m,A,C,$){const v={source:{identifier:y.identifier,label:y.displayName||y.name}};let S;typeof C=="string"||R(C)?S=[C,...$]:(v.modal=C?.modal,v.useCustom=C?.useCustom,v.detail=C?.detail,S=$),v.useCustom&&(0,g.$MF)(y,"resolvers");const w=[];for(let u=0;u<S.length;u++){const o=S[u];if(typeof o=="string")w.push({title:o,handle:u,isCloseAffordance:!1});else if(typeof o=="object"){const{title:i,isCloseAffordance:n}=o;w.push({title:i,isCloseAffordance:!!n,handle:u})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(m,A,v,w).then(u=>{if(typeof u=="number")return S[u]})}};e.$Bfc=L,e.$Bfc=L=He([Be(1,T.$dj)],L)}),define(ke[330],Se([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,286,25,68]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0;let n=class{constructor(h,E,I,f,p){this.m=E,this.n=I,this.o=f,this.q=p,this.b=new b.$zc,this.c=new b.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$Rd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=h.getProxy(C.$xK.MainThreadNotebookKernels);const k=new $.$ZM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$XM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const j=this.n.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:j}}else if(P&&"notebookEditor"in P){const j=this.n.getIdByEditor(P.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return P})],$.$YM.Void);this.o.registerApiCommand(k)}createNotebookController(h,E,I,f,p,k){for(const Q of this.j.values())if(Q.controller.id===E&&m.$_l.equals(h.identifier,Q.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const P=this.k++,j=this;this.q.trace(`NotebookController[${P}], CREATED by ${h.identifier.value}, ${E}`);const z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${h.identifier}'`);let M=!1;const F=new R.$Rd,N=new R.$Rd,O={id:l(h.identifier,E),notebookType:I,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:f||h.identifier.value,preloads:k?k.map(v.NotebookRendererScript.from):[]};let W=p??z,x,ce;this.a.$addKernel(P,O).catch(Q=>{console.log(Q),M=!0});let Y=0;const G=()=>{if(M)return;const Q=++Y;Promise.resolve().then(()=>{Q===Y&&this.a.$updateKernel(P,O)})},J=new b.$zc,le={get id(){return E},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return O.label},set label(Q){O.label=Q??h.displayName??h.name,G()},get detail(){return O.detail??""},set detail(Q){O.detail=Q,G()},get description(){return O.description??""},set description(Q){O.description=Q,G()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(Q){O.supportedLanguages=Q,G()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){O.supportsExecutionOrder=Q,G()},get rendererScripts(){return O.preloads?O.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(Q){W=Q??z},get interruptHandler(){return x},set interruptHandler(Q){x=Q,O.supportsInterrupt=!!Q,G()},set variableProvider(Q){(0,o.$MF)(h,"notebookVariableProvider"),ce=Q,O.hasVariableProvider=!!Q,Q?.onDidChangeVariables(Ee=>j.a.$variablesUpdated(Ee.uri)),G()},get variableProvider(){return ce},createNotebookCellExecution(Q){if(M)throw new Error("notebook controller is DISPOSED");if(!J.has(Q.notebook.uri))throw j.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(Ee=>Ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return j._createNotebookCellExecution(Q,l(h.identifier,this.id))},createNotebookExecution(Q){if((0,o.$MF)(h,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!J.has(Q.uri))throw j.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(Ee=>Ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.uri.toString()}`);return j._createNotebookExecution(Q,l(h.identifier,this.id))},dispose:()=>{M||(this.q.trace(`NotebookController[${P}], DISPOSED`),M=!0,this.j.delete(P),F.dispose(),N.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(Q,Ee){Ee===S.NotebookControllerAffinity2.Hidden&&(0,o.$MF)(h,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(P,Q.uri,Ee)},onDidReceiveMessage:N.event,postMessage(Q,Ee){return(0,o.$MF)(h,"notebookMessaging"),j.a.$postMessage(P,Ee&&j.n.getIdByEditor(Ee),Q)},asWebviewUri(Q){return(0,o.$MF)(h,"notebookMessaging"),(0,w.$iub)(Q,j.m.remote)}};return this.j.set(P,{extensionId:h.identifier,controller:le,onDidReceiveMessage:N,onDidChangeSelection:F,associatedNotebooks:J}),le}getIdByController(h){for(const[E,I]of this.j)if(I.controller===h)return l(I.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,E){const I=this.g++,f=this;this.q.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(I,E);const p={dispose:()=>{this.f.delete(I),f.a.$removeKernelDetectionTask(I)}};return this.f.set(I,p),p}registerKernelSourceActionProvider(h,E,I){const f=this.i++,p=typeof I.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,k=this;this.h.set(f,I),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,E);let P;return p!==void 0&&(P=I.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(f),k.a.$removeKernelSourceActionProvider(f,f),P?.dispose()}}}async $provideKernelSourceActions(h,E){const I=this.h.get(h);if(I){const f=new L.$Qc;return(await I.provideNotebookKernelSourceActions(E)??[]).map(k=>v.NotebookKernelSourceAction.from(k,this.o.converter,f))}return[]}$acceptNotebookAssociation(h,E,I){const f=this.j.get(h);if(f){const p=this.n.getNotebookDocument(y.URI.revive(E));I?f.associatedNotebooks.set(p.uri,!0):f.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${h}] ASSOCIATE notebook`,p.uri.toString(),I),f.onDidChangeSelection.fire({selected:I,notebook:p.apiNotebook})}}async $executeCells(h,E,I){const f=this.j.get(h);if(!f)return;const p=this.n.getNotebookDocument(y.URI.revive(E)),k=[];for(const P of I){const j=p.getCell(P);j&&k.push(j.apiCell)}try{this.q.trace(`NotebookController[${h}] EXECUTE cells`,p.uri.toString(),k.length),await f.controller.executeHandler.call(f.controller,k,p.apiNotebook,f.controller)}catch(P){this.q.error(`NotebookController[${h}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(h,E,I){const f=this.j.get(h);if(!f)return;const p=this.n.getNotebookDocument(y.URI.revive(E));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,p.apiNotebook);else for(const k of I){const P=p.getCell(k);P&&this.b.get(P.uri)?.cancel()}if(f.controller.interruptHandler){const k=this.c.get(p.uri);I.length&&Array.isArray(k)&&k.length&&k.forEach(P=>P.dispose())}}async $provideVariables(h,E,I,f,p,k,P){const j=this.j.get(h);if(!j)return;const z=this.n.getNotebookDocument(y.URI.revive(I)),M=j.controller.variableProvider;if(!M)return;const F=f?{name:f,value:""}:void 0,N=p==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,O=M.provideVariables(z.apiNotebook,F,N,k,P);for await(const W of O){if(P.isCancellationRequested)return;this.a.$receiveVariable(E,W)}}$acceptKernelMessageFromRenderer(h,E,I){const f=this.j.get(h);if(!f)return;const p=this.n.getEditorById(E);f.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:I}))}$cellExecutionChanged(h,E,I){const p=this.n.getNotebookDocument(y.URI.revive(h)).getCell(E);if(p){const k=I?v.NotebookCellExecutionState.to(I):S.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:p.apiCell,state:k})}}_createNotebookCellExecution(h,E){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const p=new a(E,f,this.a);this.b.set(f.uri,p);const k=p.onDidChangeState(()=>{p.state===r.Resolved&&(p.dispose(),k.dispose(),this.b.delete(f.uri))});return p.asApiObject()}_createNotebookExecution(h,E){const I=this.n.getNotebookDocument(h.uri),f=h.getCells().find(P=>{const j=I.getCellFromApiCell(P);return j&&this.b.has(j.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const p=new s(E,I,this.a),k=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),k.dispose(),this.c.delete(I.uri))});return this.c.set(I.uri,[p,k]),p.asApiObject()}};e.$Ffc=n,e.$Ffc=n=He([Be(4,A.$dj)],n);var r;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(r||(r={}));class a extends L.$Rc{static{this.a=0}get state(){return this.f}constructor(h,E,I){super(),this.m=E,this.n=I,this.b=a.a++,this.c=new R.$Rd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new g.$2d),this.h=new d(10,f=>this.s(f)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const E=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$wv(E))}t(){if(this.f===r.Init)throw new Error("Must call start before modifying cell output");if(this.f===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let E=this.m;if(h&&(E=this.m.notebook.getCellFromApiCell(h)),!E)throw new Error("INVALID cell");return E.handle}y(h){return h.map(E=>{const I=S.$1L.ensureUniqueMimeTypes(E.items,!0);return I===E.items?v.NotebookCellOutput.from(E):v.NotebookCellOutput.from({items:I,id:E.id,metadata:E.metadata})})}async z(h,E,I){const f=this.w(E),p=this.y((0,D.$2b)(h));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:f,append:I,outputs:p})}async C(h,E,I){return h=S.$1L.ensureUniqueMimeTypes((0,D.$2b)(h),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:h.map(v.NotebookCellOutputItem.from),outputId:E.id,append:I})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(I){h.j=I,h.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(I){if(h.f===r.Resolved||h.f===r.Started)throw new Error("Cannot call start again");h.f=r.Started,h.c.fire(),h.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,f){if(h.f===r.Resolved)throw new Error("Cannot call resolve twice");h.f=r.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$wv({runEndTime:f,lastRunSuccess:I}))},clearOutput(I){return h.t(),h.z([],I,!1)},appendOutput(I,f){return h.t(),h.z(I,f,!0)},replaceOutput(I,f){return h.t(),h.z(I,f,!1)},appendOutputItems(I,f){return h.t(),h.C(I,f,!0)},replaceOutputItems(I,f){return h.t(),h.C(I,f,!1)}})}}var t;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(t||(t={}));class s extends L.$Rc{static{this.a=0}get state(){return this.f}constructor(h,E,I){super(),this.h=E,this.j=I,this.b=s.a++,this.c=new R.$Rd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$2d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,E){this.f=h,this.g=E,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new T.$ih,this.b=Date.now(),(0,T.$Yg)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>h.complete())}}function l(c,h){return`${c.value}/${h}`}e.$Gfc=l}),define(ke[331],Se([1,0,4,6,148]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;class R{constructor(b,y){this.c=y,this.a=new Map,this.b=b.getProxy(T.$xK.MainThreadNotebookRenderers)}$postRendererMessage(b,y,m){const A=this.c.getEditorById(b);this.a.get(y)?.fire({editor:A.apiEditor,message:m})}createRendererMessaging(b,y){if(!b.contributes?.notebookRenderer?.some(A=>A.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(A,C,$)=>this.d(y).event(A,C,$),postMessage:(A,C)=>{g.$nfc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const $=C&&g.$nfc.apiEditorsToExtHost.get(C);return this.b.$postMessage($?.id,y,A)}}}d(b){let y=this.a.get(b);return y||(y=new D.$Rd({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(b)}}),this.a.set(b,y),y)}}e.$Hfc=R}),define(ke[332],Se([1,0,3,18,2,25,6]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class b{constructor(m){this.b=new Map,this.a=m.getProxy(L.$xK.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,A,C){if((0,R.$MF)(m,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,m.identifier.value),(0,D.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(m,A,C,$){const v=this.b.get(m);if(!v)throw new Error(`Unknown handler with id: ${m}`);return v.saveProfile(A,C,$)}async $readProfile(m,A,C){const $=this.b.get(m);if(!$)throw new Error(`Unknown handler with id: ${m}`);return $.readProfile((0,T.$Cf)(A)?A:g.URI.revive(A),C)}}e.$Kfc=b}),define(ke[333],Se([1,0,2,6,12,15]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class L{static{this.a=0}constructor(y,m){this.d=m,this.c=new Map,this.b=y.getProxy(T.$xK.MainThreadQuickDiff)}$provideOriginalResource(y,m,A){const C=D.URI.revive(m),$=this.c.get(y);return $?(0,g.$Qg)(()=>$.provideOriginalResource(C,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(y,m,A,C){const $=L.a++;return this.c.set($,m),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(y,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Mfc=L}),define(ke[334],Se([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;function S(w,u,o){const i=w.getProxy(R.$xK.MainThreadQuickOpen);class n{constructor(E,I){this.e=new Map,this.f=0,this.a=E,this.b=I}showQuickPick(E,I,f,p=D.CancellationToken.None){this.c=void 0;const k=Promise.resolve(I),P=++this.f,j=i.$show(P,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},p),z={},M=j.then(()=>z);return Promise.race([M,k]).then(F=>{if(F===z)return;const N=(0,$.$LF)(E,"quickPickItemTooltip");return k.then(O=>{const W=[];for(let x=0;x<O.length;x++){const ce=O[x];if(typeof ce=="string")W.push({label:ce,handle:x});else if(ce.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:ce.label});else{ce.tooltip&&!N&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const Y=ce.iconPath?d(ce.iconPath):void 0;W.push({label:ce.label,iconPath:Y?.iconPath,iconClass:Y?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:N?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:x})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=x=>{f.onDidSelectItem(O[x])}),i.$setItems(P,W),j.then(x=>{if(typeof x=="number")return O[x];if(Array.isArray(x))return x.map(ce=>O[ce])})})}).then(void 0,F=>{if(!(0,y.$3)(F))return i.$setError(P,F),Promise.reject(F)})}$onItemSelected(E){this.c?.(E)}showInput(E,I=D.CancellationToken.None){return this.d=E?.validateInput,i.$input(E,typeof this.d=="function",I).then(void 0,f=>{if(!(0,y.$3)(f))return Promise.reject(f)})}async $validateInput(E){if(!this.d)return;const I=await this.d(E);if(!I||typeof I=="string")return I;let f;switch(I.severity){case b.InputBoxValidationSeverity.Info:f=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:f=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:f=A.default.Error;break;default:f=I.message?A.default.Error:A.default.Ignore;break}return{content:I.message,severity:f}}async showWorkspaceFolderPick(E,I=D.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!f)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(k=>k.uri.toString()===f.uri.toString())}createQuickPick(E){const I=new l(E,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(E){const I=new c(E,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(E,I){this.e.get(E)?._fireDidChangeValue(I)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,I){const f=this.e.get(E);f instanceof l&&f._fireDidChangeActive(I)}$onDidChangeSelection(E,I){const f=this.e.get(E);f instanceof l&&f._fireDidChangeSelection(I)}$onDidTriggerButton(E,I){this.e.get(E)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(E,I,f){const p=this.e.get(E);p instanceof l&&p._fireDidTriggerItemButton(I,f)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class r{static{this.a=1}constructor(E,I){this.x=E,this.y=I,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Rd,this.q=new T.$Rd,this.r=new T.$Rd,this.s=new T.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){this.n=E.slice(),this.o.clear(),E.forEach((I,f)=>{const p=I===b.$TL.Back?-1:f;this.o.set(p,I)}),this.z({buttons:E.map((I,f)=>({...d(I.iconPath),tooltip:I.tooltip,handle:I===b.$TL.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const I=this.o.get(E);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(E){if(!this.v){for(const I of Object.keys(E)){const f=E[I];this.u[I]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof b.$tL)return{id:h.id};const E=s(h),I=t(h);return{dark:typeof E=="string"?L.URI.file(E):E,light:typeof I=="string"?L.URI.file(I):I}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function s(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const E=a(h);let I,f;return"id"in E?f=C.ThemeIcon.asClassName(E):I=E,{iconPath:I,iconClass:f}}class l extends r{constructor(E,I){super(E.identifier,I),this.O=E,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Rd,this.L=[],this.M=new T.$Rd,this.N=new T.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((p,k)=>{this.C.set(k,p),this.D.set(p,k)});const I=(0,$.$LF)(this.O,"quickPickItemTooltip"),f=[];for(let p=0;p<E.length;p++){const k=E[p];if(k.kind===b.QuickPickItemKind.Separator)f.push({type:"separator",label:k.label});else{k.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?d(k.iconPath):void 0;f.push({handle:p,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:I?v.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((j,z)=>({...d(j.iconPath),tooltip:j.tooltip,handle:z}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(E){const I=(0,m.$Gb)(E.map(f=>this.C.get(f)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(E){const I=(0,m.$Gb)(E.map(f=>this.C.get(f)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(E,I){const f=this.C.get(E);if(!f||!f.buttons||!f.buttons.length)return;const p=f.buttons[I];p&&this.N.fire({button:p,item:f})}}class c extends r{constructor(E,I){super(E.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:A.default.Error}):this.z({validationMessage:E.message,severity:E.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(u,o)}e.$Nfc=S}),define(ke[335],Se([1,0,2,4,59,3,12,6,19,129,14,21,26,61,15,25,17,11]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=void 0;function n(M){return M instanceof D.URI}function r(M,F){return M.scheme===u.Schemas.file&&F.scheme===u.Schemas.file&&o.$k?M.toString()===F.toString():M.toString().toLowerCase()===F.toString().toLowerCase()}function a(M){if(M)return typeof M.iconPath=="string"?D.URI.file(M.iconPath):D.URI.isUri(M.iconPath)||v.ThemeIcon.isThemeIcon(M.iconPath)?M.iconPath:void 0}function t(M){if(M?.icon){if(D.URI.isUri(M.icon))return M.icon;if(v.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const F=M.icon;return{light:F.light,dark:F.dark}}}else return}function s(M){if(M.icon){if(D.URI.isUri(M.icon))return M.icon;if(v.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const F=M.icon;return{light:F.light,dark:F.dark}}}else return}function d(M){if(M.icon){if(D.URI.isUri(M.icon))return M.icon;if(v.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const F=M.icon;return{light:F.light,dark:F.dark}}}else return}function l(M,F){if(!M.iconPath&&!F.iconPath)return 0;if(M.iconPath){if(!F.iconPath)return 1}else return-1;const N=typeof M.iconPath=="string"?M.iconPath:D.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id,O=typeof F.iconPath=="string"?F.iconPath:D.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,m.$xq)(N,O)}function c(M,F){let N=0;if(M.strikeThrough!==F.strikeThrough)return M.strikeThrough?1:-1;if(M.faded!==F.faded)return M.faded?1:-1;if(M.tooltip!==F.tooltip)return(M.tooltip||"").localeCompare(F.tooltip||"");if(N=l(M,F),N!==0)return N;if(M.light&&F.light)N=l(M.light,F.light);else{if(M.light)return 1;if(F.light)return-1}if(N!==0)return N;if(M.dark&&F.dark)N=l(M.dark,F.dark);else{if(M.dark)return 1;if(F.dark)return-1}return N}function h(M,F){if(M.command!==F.command)return M.command<F.command?-1:1;if(M.title!==F.title)return M.title<F.title?-1:1;if(M.tooltip!==F.tooltip){if(M.tooltip!==void 0&&F.tooltip!==void 0)return M.tooltip<F.tooltip?-1:1;if(M.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(M.arguments===F.arguments)return 0;if(M.arguments)if(F.arguments){if(M.arguments.length!==F.arguments.length)return M.arguments.length-F.arguments.length}else return 1;else return-1;for(let N=0;N<M.arguments.length;N++){const O=M.arguments[N],W=F.arguments[N];if(O!==W&&!(n(O)&&n(W)&&r(O,W)))return O<W?-1:1}return 0}function E(M,F){let N=(0,m.$xq)(M.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(N!==0)return N;if(M.command&&F.command)N=h(M.command,F.command);else{if(M.command)return 1;if(F.command)return-1}if(N!==0)return N;if(M.decorations&&F.decorations)N=c(M.decorations,F.decorations);else{if(M.decorations)return 1;if(F.decorations)return-1}return N}function I(M,F){for(let N=0;N<M.length;N++)if(M[N]!==F[N])return!1;return!0}function f(M,F){return M.command===F.command&&M.title===F.title&&M.tooltip===F.tooltip&&(M.arguments&&F.arguments?I(M.arguments,F.arguments):M.arguments===F.arguments)}function p(M,F){return(0,y.$tb)(M,F,f)}class k{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.o,F),this.q(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.o,F),this.f=F}get validateInput(){return(0,w.$MF)(this.m,"scmValidation"),this.g}set validateInput(F){if((0,w.$MF)(this.m,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.o,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.o,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.o,F))}get actionButton(){return(0,w.$MF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(F){(0,w.$MF)(this.m,"scmInputBoxActionButton"),this.l.value=new R.$Qc,this.k=F;const N=F!==void 0?{command:this.n.converter.toInternal(F.command,this.l.value),icon:t(F),enabled:F.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,w.$MF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(F,N,O,W,x,ce){this.m=F,this.n=N,this.o=x,this.p=ce,this.d="",this.e=new T.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new R.$Sc,this.#t=O,this.#e=W}showValidationMessage(F,N){(0,w.$MF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,F,N)}$onInputBoxValueChange(F){this.q(F)}q(F){this.d=F,this.e.fire(F)}}e.$Ofc=k;class P{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,N,O,W,x){this.q=F,this.s=N,this.t=O,this.u=W,this.v=x,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=P.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,N){const O=this.h.get(F);return O?(0,L.$Qg)(()=>this.s.executeCommand(O.command,...O.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(E),O=(0,y.$Cb)(this.o,F,E).map(ce=>{const Y=ce.toInsert.map(G=>{const J=this.e++;this.g.set(J,G);const le=G.resourceUri;let Q;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"||G.command.command==="vscode.changes"){const $e=new R.$Qc;Q=this.s.converter.toInternal(G.command,$e),this.j.set(J,$e)}else this.h.set(J,G.command);const Ee=a(G.decorations),he=G.decorations&&a(G.decorations.light)||Ee,K=G.decorations&&a(G.decorations.dark)||Ee,U=[he,K],ie=G.decorations&&G.decorations.tooltip||"",be=G.decorations&&!!G.decorations.strikeThrough,H=G.decorations&&!!G.decorations.faded,_=G.contextValue||"";return{rawResource:[J,le,U,ie,be,H,_,Q],handle:J}});return{start:ce.start,deleteCount:ce.deleteCount,toInsert:Y}}),W=O.map(({start:ce,deleteCount:Y,toInsert:G})=>[ce,Y,G.map(J=>J.rawResource)]),x=O.reverse();for(const{start:ce,deleteCount:Y,toInsert:G}of x){const J=G.map(Q=>Q.handle),le=this.n.splice(ce,Y,...J);for(const Q of le)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=F,W}dispose(){this.l=!0,this.m.fire()}}class j{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let N;(0,w.$LF)(this.y,"quickDiffProvider")&&(N=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:N})}get historyProvider(){return(0,w.$MF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,w.$MF)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new R.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&(this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.l=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(F.onDidChangeActionButton(()=>{(0,w.$MF)(this.y,"scmActionButton"),this.m.value=new R.$Qc;const N=F.actionButton!==void 0?{command:this.z.converter.toInternal(F.actionButton.command,this.m.value),description:F.actionButton.description,enabled:F.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new R.$Qc,this.p=F;const N=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,w.$MF)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,w.$MF)(this.y,"scmActionButton"),this.q.value=new R.$Qc,this.s=F;const N=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(O=>O.map(W=>this.z.converter.toInternal(W,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&p(this.u,F))return;this.t.value=new R.$Qc,this.u=F;const N=(F||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(F,N,O,W,x,ce,Y){this.y=F,this.z=W,this.A=x,this.B=ce,this.C=Y,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Sc,this.m=new R.$Sc,this.n=void 0,this.o=new R.$Sc,this.p=void 0,this.q=new R.$Sc,this.t=new R.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Rd,this.onDidChangeSelection=this.w.event,this.x=j.d++,this.D=new Map,this.E=new Set,this.#e=O;const G=D.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${x}/scm${this.x}/input`,query:Y?`rootUri=${encodeURIComponent(Y.toString())}`:void 0});this.f=new k(F,W,N,this.#e,this.x,G),this.#e.$registerSourceControl(this.x,x,ce,Y,G)}createResourceGroup(F,N){const O=new P(this.#e,this.z,this.x,F,N),W=T.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,W),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const F=[],N=[];for(const[O,W]of this.D){W.dispose();const x=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});T.Event.once(O.onDidDispose)(()=>{this.E.delete(O),x.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),F.push([O.handle,O.id,O.label,O.features]);const ce=O._takeResourceStateSnapshot();ce.length>0&&N.push([O.handle,ce]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,F,N),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(N=>{const O=N._takeResourceStateSnapshot();O.length!==0&&F.push([N.handle,O])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,g.$oh)(100)],j.prototype,"eventuallyAddResourceGroups",null),He([(0,g.$oh)(100)],j.prototype,"eventuallyUpdateResourceStates",null);let z=class{static{i=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(F,N,O,W){this.n=N,this.o=O,this.p=W,this.h=new Map,this.j=new $.$bm,this.k=new T.$Rd,this.l=new Map,this.f=F.getProxy(b.$xK.MainThreadSCM),this.g=F.getProxy(b.$xK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:x=>{if(x&&x.$mid===3){const ce=this.h.get(x.sourceControlHandle);if(!ce)return x;const Y=ce.getResourceGroup(x.groupHandle);return Y?Y.getResourceState(x.handle):x}else if(x&&x.$mid===4){const ce=this.h.get(x.sourceControlHandle);return ce?ce.getResourceGroup(x.groupHandle):x}else if(x&&x.$mid===5){const ce=this.h.get(x.handle);return ce||x}return x}})}createSourceControl(F,N,O,W){this.p.trace("ExtHostSCM#createSourceControl",F.identifier.value,N,O,W),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const x=i.d++,ce=new j(F,this.o,this.f,this.n,N,O,W);this.h.set(x,ce);const Y=this.j.get(F.identifier)||[];return Y.push(ce),this.j.set(F.identifier,Y),ce}registerSourceControlInputBoxValueProvider(F,N){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",F.identifier.value,N.label);const O=i.e++;return this.l.set(O,N),this.f.$registerSourceControlInputBoxValueProvider(O,N.label,d(N)),(0,R.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(O),this.l.delete(O)})}async $provideInputBoxValue(F,N,O){const W=this.l.get(F);if(W)return await W.provideValue(N,O,C.CancellationToken.None)??void 0}getLastInputBox(F){this.p.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const N=this.j.get(F.identifier),O=N&&N[N.length-1];return O&&O.inputBox}$provideOriginalResource(F,N,O){const W=D.URI.revive(N);this.p.trace("ExtHostSCM#$provideOriginalResource",F,W.toString());const x=this.h.get(F);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Qg)(()=>x.quickDiffProvider.provideOriginalResource(W,O)).then(ce=>ce||null)}$onInputBoxValueChange(F,N){this.p.trace("ExtHostSCM#$onInputBoxValueChange",F);const O=this.h.get(F);return O&&O.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(F,N,O,W){this.p.trace("ExtHostSCM#$executeResourceCommand",F,N,O);const x=this.h.get(F);if(!x)return Promise.resolve(void 0);const ce=x.getResourceGroup(N);return ce?ce.$executeResourceCommand(O,W):Promise.resolve(void 0)}$validateInput(F,N,O){this.p.trace("ExtHostSCM#$validateInput",F);const W=this.h.get(F);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Qg)(()=>W.inputBox.validateInput(N,O)).then(x=>{if(!x)return Promise.resolve(void 0);const ce=S.MarkdownString.fromStrict(x.message);return ce?Promise.resolve([ce,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.h.get(F)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(F,N,O){return await this.h.get(F)?.historyProvider?.resolveHistoryItemGroupBase(N,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(F,N,O,W){return await this.h.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,O,W)??void 0}async $provideHistoryItems(F,N,O,W){return(await this.h.get(F)?.historyProvider?.provideHistoryItems(N,O,W))?.map(Y=>({...Y,icon:s(Y)}))??void 0}async $provideHistoryItemChanges(F,N,O){return await this.h.get(F)?.historyProvider?.provideHistoryItemChanges(N,O)??void 0}};e.$Pfc=z,e.$Pfc=z=i=He([Be(3,A.$dj)],z)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.$Vec=void 0;class R{constructor(b){this.b=new T.$Rd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$xK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,y){return this.a.$getPassword(b,y)}store(b,y,m){return this.a.$setPassword(b,y,m)}delete(b,y){return this.a.$deletePassword(b,y)}}e.$Vec=R,e.$Wec=(0,g.$Vh)("IExtHostSecretState")}),define(ke[336],Se([1,0,6,15,2]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class R{static{this.a=0}constructor(b,y){this.d=y,this.c=new Map,this.b=b.getProxy(D.$xK.MainThreadShare)}async $provideShare(b,y,m){return await this.c.get(b)?.provideShare({selection:T.Range.to(y.selection),resourceUri:g.URI.revive(y.resourceUri)},m)??void 0}registerShareProvider(b,y){const m=R.a++;return this.c.set(m,y),this.b.$registerShareProvider(m,T.DocumentSelector.from(b,this.d),y.id,y.label,y.priority),{dispose:()=>{this.b.$unregisterShareProvider(m),this.c.delete(m)}}}}e.$Qfc=R}),define(ke[337],Se([1,0,21,3,6]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$xK.MainThreadSpeech)}async $createSpeechToTextSession(b,y){const m=this.c.get(b);if(!m)return;const A=new T.$Qc,C=new D.$2d;this.d.set(y,C);const $=A.add(m.provideSpeechToTextSession(C.token));A.add($.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(y,v)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,y,m){const A=R.a++;return this.c.set(A,m),this.b.$registerProvider(A,y,{extension:b,displayName:b.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Rfc=R}),define(ke[338],Se([1,0,7,6,217,3,15,18]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=e.$Sfc=void 0;class y{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$uL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$uL("statusBarItem.warningForeground")]])}#e;#t;constructor($,v,S,w,u,o=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new R.$Qc,this.#e=$,this.#t=v,u&&w){this.c=(0,D.$0K)(w.identifier,u);const n=S.get(this.c);n&&(o=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(y.a++);this.e=w,this.f=u,this.g=o,this.h=this.u(i)}u($){if((0,b.$Gf)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!y.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Qc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let v;this.m?v=this.m:v=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=y.b.get(this.o.id));const w=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,v,this.k,w,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Sfc=y;class m{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const v={message:$};return this.b.unshift(v),this.c(),new D.$zK(()=>{const S=this.b.indexOf(v);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,v){this.e=new Map,this.a=$.getProxy(T.$xK.MainThreadStatusBar),this.b=v,this.c=new m(this)}$acceptStaticEntries($){for(const v of $)this.e.set(v.entryId,v)}createStatusBarEntry($,v,S,w){return new y(this.a,this.b,this.e,$,v,S,w)}setStatusBarMessage($,v){const S=this.c.setMessage($);let w;return typeof v=="number"?w=setTimeout(()=>S.dispose(),v):typeof v<"u"&&v.then(()=>S.dispose(),()=>S.dispose()),new D.$zK(()=>{S.dispose(),clearTimeout(w)})}}e.$Tfc=A}),define(ke[118],Se([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=e.$Nec=void 0;class R{constructor(b,y){this.c=y,this.b=new T.$Rd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$xK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,y){this.a.$registerExtensionStorageKeysToSync(b,y)}async initializeExtensionStorage(b,y,m){const A=await this.a.$initializeExtensionStorage(b,y);let C;return A&&(C=this.d(b,y,A)),C||m}setValue(b,y,m){return this.a.$setValue(b,y,m)}$acceptValue(b,y,m){const A=this.d(b,y,m);A&&this.b.fire({shared:b,key:y,value:A})}d(b,y,m){try{return JSON.parse(m)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${b}): ${A}`)}}}e.$Nec=R,e.$Oec=(0,g.$Vh)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,14,71,2]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=e.$wec=void 0,e.$wec=(0,D.$Vh)("IExtensionStoragePaths");let b=class{constructor(m,A,C){this.d=A,this.f=C,this.a=m.workspace??void 0,this.b=m.environment,this.whenReady=this.h().then($=>this.c=$)}async g(m){return L.URI.joinPath(this.b.workspaceStorageHome,m)}async h(){if(!this.a)return Promise.resolve(void 0);const m=this.a.id,A=await this.g(m);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(m){if(this.c)return L.URI.joinPath(this.c,m.identifier.value)}globalValue(m){return L.URI.joinPath(this.b.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xec=b,e.$xec=b=He([Be(0,T.$PM),Be(1,g.$dj),Be(2,R.$vec)],b)}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,219,8,263,21,30,264,61,12,15,35]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=e.$Sec=e.$Rec=void 0,e.$Rec=(0,g.$Vh)("IExtHostTerminalService");class n{constructor(f,p,k,P){this.l=f,this._id=p,this.m=k,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const j=this;this.value={get name(){return j.n||""},get processId(){return j.b},get creationOptions(){return j.m},get exitStatus(){return j.h},get state(){return j.j},get selection(){return j.k},sendText(z,M=!0){j.q(),j.l.$sendText(j._id,z,M)},show(z){j.q(),j.l.$show(j._id,z)},hide(){j.q(),j.l.$hide(j._id)},dispose(){j.a||(j.a=!0,j.l.$dispose(j._id))},get dimensions(){if(!(j.d===void 0||j.g===void 0))return{columns:j.d,rows:j.g}}}}async create(f,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??p?.cwd??void 0,env:f.env??void 0,icon:c(f.iconPath)??void 0,color:w.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(f.location,p?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,p,k,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:k,color:w.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(f,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(f,p){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in f?{viewColumn:o.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.n=f}setExitStatus(f,p){this.h=Object.freeze({code:f,reason:p})}setDimensions(f,p){return f===this.d&&p===this.g||f===0||p===0?!1:(this.d=f,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(f){this.k=f}_setProcessId(f){this.f?(this.f(f),this.f=void 0):this.b.then(p=>{p!==f&&(this.b=Promise.resolve(f))})}}e.$Sec=n;class r{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new D.$Rd,this.onProcessData=this.a.event,this.b=new D.$Rd,this.d=new D.$Rd,this.onDidChangeProperty=this.d.event,this.f=new D.$Rd,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,p){this.g.setDimensions?.({columns:f,rows:p})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,p,k){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Rd,this.onDidChangeShell=this.N.event,this.O=new D.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$xK.MainThreadTerminalService),this.y=new S.$xqb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:P=>{const j=z=>{const M=z;return this.W(M.instanceId)?.value};switch(P?.$mid){case 15:return j(P);default:{if(Array.isArray(P))for(let z=0;z<P.length&&P[z].$mid===15;z++)P[z]=j(P[z]);return P}}}}),this.B({dispose:()=>{for(const[P,j]of this.g)j.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,p){const k=new n(this.a,(0,v.$ig)(),f,f.name),P=new r(f.pty);return k.createExtensionTerminal(f.location,this.R(f,p).resolvedExtHostIdentifier,c(f.iconPath),h(f.color)).then(j=>{const z=this.S(j,P);this.h[j]=z}),this.f.push(k),k.value}R(f,p){if(p=p||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const k=f.location.parentTerminal;if(k){const P=this.f.find(j=>j.value===k);P&&(p.resolvedExtHostIdentifier=P._id)}}else f.location&&typeof f.location!="object"?p.location=f.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(f,p){if(!this.W(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const P=new r(p),j=this.S(f,P);this.h[f]=j}async $acceptActiveTerminalChanged(f){const p=this.b;if(f===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const k=this.W(f);k&&(this.b=k,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,p){const k=this.W(f);k&&this.O.fire({terminal:k.value,data:p})}async $acceptTerminalDimensions(f,p,k){const P=this.W(f);P&&P.setDimensions(p,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(f,p){const k=this.W(f);k&&this.P.fire({terminal:k.value,...p})}async $acceptTerminalMaximumDimensions(f,p,k){this.g.get(f)?.resize(p,k)}async $acceptTerminalTitleChange(f,p){const k=this.W(f);k&&(k.name=p)}async $acceptTerminalClosed(f,p,k){const P=this.Y(this.f,f);if(P!==null){const j=this.f.splice(P,1)[0];j.setExitStatus(p,k),this.H.fire(j.value)}}$acceptTerminalOpened(f,p,k,P){if(p){const M=this.Y(this.f,p);if(M!==null){this.f[M]._id=f,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const j={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},z=new n(this.a,f,j,k);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(f,p){this.W(f)?._setProcessId(p)}async $startExtensionTerminal(f,p){const k=this.W(f);if(!k)return{message:(0,m.localize)(0,null,f)};k.isOpen||await new Promise(j=>{const z=this.onDidOpenTerminal(async M=>{M===k.value&&(z.dispose(),j())})});const P=this.g.get(f);P?P.startSendingEvents(p):this.j[f]={initialDimensions:p}}S(f,p){const k=new b.$Qc;k.add(p.onProcessReady(j=>this.a.$sendProcessReady(f,j.pid,j.cwd,j.windowsPty))),k.add(p.onDidChangeProperty(j=>this.a.$sendProcessProperty(f,j))),this.y.startBuffering(f,p.onProcessData),k.add(p.onProcessExit(j=>this.U(f,j))),this.g.set(f,p);const P=this.j[f];return P&&p instanceof r&&(p.startSendingEvents(P.initialDimensions),delete this.j[f]),k}$acceptProcessAckDataEvent(f,p){this.g.get(f)?.acknowledgeDataEvent(p)}$acceptProcessInput(f,p){this.g.get(f)?.input(p)}$acceptTerminalInteraction(f){const p=this.W(f);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(f,p){this.W(f)?.setSelection(p)}$acceptProcessResize(f,p,k){try{this.g.get(f)?.resize(p,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(f,p){this.g.get(f)?.shutdown(p)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(p=>this.a.$sendProcessProperty(f,{type:"cwd",value:p}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new y.$zK(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,p,k){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,k),this.a.$registerProfileProvider(p,f.identifier.value),new y.$zK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(f,p,k){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,k),this.a.$registerQuickFixProvider(f,p),new y.$zK(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,p){const k=new $.$2d().token;if(k.isCancellationRequested)return;const P=this.D.get(f);if(!P)return;const j=await P.provideTerminalQuickFixes(p,k);if(j===null||Array.isArray(j)&&j.length===0)return;const z=new b.$Qc;if(this.w.value=z,!Array.isArray(j))return j?o.TerminalQuickFix.from(j,this.Q.converter,z):void 0;const M=[];for(const F of j){const N=o.TerminalQuickFix.from(F,this.Q.converter,z);N&&M.push(N)}return M}async $createContributedProfileTerminal(f,p){const k=new $.$2d().token;let P=await this.C.get(f)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,p);return}this.createTerminalFromOptions(P.options,p)}}async $provideLinks(f,p){const k=this.W(f);if(!k)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const j=new $.$2d;this.G.set(f,j);const z=[],M={terminal:k.value,line:p},F=[];for(const W of this.z)F.push(u.Promises.withAsyncBody(async x=>{j.token.onCancellationRequested(()=>x({provider:W,links:[]}));const ce=await W.provideTerminalLinks(M,j.token)||[];j.token.isCancellationRequested||x({provider:W,links:ce})}));const N=await Promise.all(F);if(j.token.isCancellationRequested)return[];const O=new Map;for(const W of N)W&&W.links.length>0&&z.push(...W.links.map(x=>{const ce={id:a++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return O.set(ce.id,{provider:W.provider,link:x}),ce}));return this.F.set(f,O),z}$activateLink(f,p){const k=this.F.get(f)?.get(p);k&&k.provider.handleTerminalLink(k.link)}U(f,p){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const k=this.h[f];k&&(k.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,p)}W(f){return this.X(this.f,f)}X(f,p){const k=this.Y(f,p);return k!==null?f[k]:null}Y(f,p){const k=f.findIndex(P=>P._id===p);return k===-1?null:k}getEnvironmentVariableCollection(f){let p=this.n.get(f.identifier.value);return p||(p=new s,this.$(f.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(f,p){const k=(0,C.$qr)(p.map),P=(0,C.$rr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(f,p.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(f){f.forEach(p=>{const k=p[0],P=new s(p[1]);this.$(k,P)})}$acceptDefaultProfile(f,p){const k=this.s;this.s=f,this.u=p,k?.path!==f.path&&this.N.fire(f.path)}$(f,p){this.n.set(f,p),p.onDidChangeCollection(()=>{this.Z(f,p)})}};e.$Tec=t,e.$Tec=t=He([Be(1,i.$VM),Be(2,L.$zM)],t);class s{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Rd,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const p=this.h(f);let k=this.a.get(p);return k||(k=new d(this,f),this.a.set(p,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(f,p,k,P){this.f(f,{value:p,type:y.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(f,p,k,P){this.f(f,{value:p,type:y.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(f,p,k,P){this.f(f,{value:p,type:y.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(f,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(f,p.scope),P=this.map.get(k),j=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==p.value||P.type!==p.type||P.options?.applyAtProcessCreation!==j.applyAtProcessCreation||P.options?.applyAtShellIntegration!==j.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const z=this.g(f,p.scope),M={variable:f,...p,options:j};this.map.set(z,M),this.d.fire()}}get(f,p){const k=this.g(f,p),P=this.map.get(k);return P?E(P):void 0}g(f,p){const k=this.h(p);return k.length?`${f}:::${k}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const p=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(f)&&p.set(P.variable,E(P));return p}delete(f,p){const k=this.g(f,p);this.map.delete(k),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[p,k]of this.map)k.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(p);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,p){const k=this.h(p),P=this.descriptionMap.get(k);if(!P||P.description!==f){let j;typeof f=="string"?j=f:j=f?.value.split(`

`)[0];const z={description:j,scope:p};this.descriptionMap.set(k,z),this.d.fire()}}getDescription(f){const p=this.h(f);return this.descriptionMap.get(p)?.description}k(f){const p=this.h(f);this.descriptionMap.delete(p)}}class d{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,p){this.b=f,this.d=p,this.a=new D.$Rd}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,p,k){this.b.replace(f,p,k,this.d)}append(f,p,k){this.b.append(f,p,k,this.d)}prepend(f,p,k){this.b.prepend(f,p,k,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,p){this.b.getVariableMap(this.d).forEach((k,P)=>f.call(p,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(f,p){super(!1,f,p)}createTerminal(f,p,k){throw new A.$$}createTerminalFromOptions(f,p){throw new A.$$}};e.$Uec=l,e.$Uec=l=He([Be(0,i.$VM),Be(1,L.$zM)],l);function c(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function h(I){return w.ThemeColor.isThemeColor(I)?I:void 0}function E(I){const f={...I};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(ke[339],Se([1,0,121,12,22,21,4,74,52,3,24,18,30,6,20,149,15,7,67,112,89,25]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=e.$Yfc=e.$Xfc=void 0;let t=class extends m.$Rc{constructor(M,F,N){super(),this.u=N,this.f=this.B(new L.$Rd),this.g=new Map,this.s=this.B(new L.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=M.getProxy(v.$xK.MainThreadTesting),this.m=new k(this.h),this.j=new c(this.h),F.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const W=O,x=W.tests[W.tests.length-1].item.extId;return this.g.get(i.$qJ.root(x))?.collection.tree.get(x)?.actual??(0,w.$LM)(O)}case 18:{const{extId:W,message:x}=O;return{test:this.g.get(i.$qJ.root(W))?.collection.tree.get(W)?.actual,message:u.TestMessage.to(x)}}default:return O}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await F.executeCommand("_testing.getExplorerSelection"),W=x=>{const ce=this.g.get(i.$qJ.root(x));if(ce)return i.$qJ.isRoot(x)?ce.controller:ce.collection.tree.get(x)?.actual};return{include:O?.include.map(W).filter(C.$Kf)||[],exclude:O?.exclude.map(W).filter(C.$Kf)||[]}})}createTestController(M,F,N,O){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const W=new m.$Qc,x=W.add(new w.$OM(F,N,this.u));x.root.label=N;const ce=new Map,Y=new Set,G=this.h,J={items:x.root.children,get label(){return N},set label(Q){N=Q,x.root.label=Q,G.$updateController(F,{label:N})},get refreshHandler(){return O},set refreshHandler(Q){O=Q,G.$updateController(F,{canRefresh:!!Q})},get id(){return F},createRunProfile:(Q,Ee,he,K,U,ie)=>{let be=(0,y.$Ji)(Q);for(;ce.has(be);)be++;return new P(this.h,ce,M,Y,this.s.event,F,be,Q,Ee,he,K,U,ie)},createTestItem(Q,Ee,he){return new w.$MM(F,Q,Ee,he)},createTestRun:(Q,Ee,he=!0)=>this.j.createTestRun(M,F,x,Q,Ee,he),invalidateTestResults:Q=>{if(Q===void 0)this.h.$markTestRetired(void 0);else{const Ee=Q instanceof Array?Q:[Q];this.h.$markTestRetired(Ee.map(he=>i.$qJ.fromExtHostTestItem(he,F).toString()))}},set resolveHandler(Q){x.resolveHandler=Q},get resolveHandler(){return x.resolveHandler},dispose:()=>{W.dispose()}};G.$registerTestController(F,N,!!O),W.add((0,m.$Pc)(()=>G.$unregisterTestController(F)));const le={controller:J,collection:x,profiles:ce,extension:M,activeProfiles:Y};return this.g.set(F,le),W.add((0,m.$Pc)(()=>this.g.delete(F))),W.add(x.onDidGenerateDiff(Q=>G.$publishDiff(F,Q.map(r.TestsDiffOp.serialize)))),J}createTestObserver(){return this.m.checkout()}async runTests(M,F=R.CancellationToken.None){const N=h(M);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(N.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(W=>i.$qJ.fromExtHostTestItem(W,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:j[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:M.exclude?.map(W=>W.id)},F)}$syncTests(){for(const{collection:M}of this.g.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,F,N){return(0,D.$qb)(this.j.trackers,W=>W.id===M?W.getCoverage(F):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(M,F,N,O){return(0,D.$qb)(this.j.trackers,x=>x.id===M?x.getCoverage(F):void 0)?.resolveFileCoverage(N,O)??Promise.resolve([])}$configureRunProfile(M,F){this.g.get(M)?.profiles.get(F)?.configureHandler?.()}$setActiveRunProfiles(M){const F=new Map;for(const[N,O]of Object.entries(M)){const W=this.g.get(N);if(!W)continue;const x=new Map,ce=O.filter(G=>!W.activeProfiles.has(G)),Y=[...W.activeProfiles].filter(G=>!O.includes(G));for(const G of ce)x.set(G,!0),W.activeProfiles.add(G);for(const G of Y)x.set(G,!1),W.activeProfiles.delete(G);x.size&&F.set(N,x)}this.s.fire(F)}async $refreshTests(M,F){await this.g.get(M)?.controller.refreshHandler?.(F)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,A.$bn)(u.TestResults.to(F))).concat(this.results).sort((F,N)=>N.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(M,F){const N=this.g.get(i.$qJ.fromString(M).controllerId)?.collection;N&&(await N.expand(M,F<0?1/0:F),N.flushDiff())}$acceptDiff(M){this.m.applyDiff(M.map(r.TestsDiffOp.deserialize))}async $runControllerTests(M,F){return Promise.all(M.map(N=>this.w(N,!1,F)))}async $startContinuousRun(M,F){const N=new R.$2d(F),O=await Promise.all(M.map(W=>this.w(W,!0,N.token)));return!F.isCancellationRequested&&!O.some(W=>W.error)&&await new Promise(W=>F.onCancellationRequested(W)),N.dispose(!0),O}async w(M,F,N){const O=this.g.get(M.controllerId);if(!O)return{};const{collection:W,profiles:x,extension:ce}=O,Y=x.get(M.profileId);if(!Y)return{};const G=M.testIds.map(Ee=>W.tree.get(Ee)).filter(C.$Kf),J=M.excludeExtIds.map(Ee=>O.collection.tree.get(Ee)).filter(C.$Kf).filter(Ee=>G.some(he=>he.fullId.compare(Ee.fullId)===2));if(!G.length)return{};const le=new o.$8L(G.some(Ee=>Ee.actual instanceof w.$NM)?void 0:G.map(Ee=>Ee.actual),J.map(Ee=>Ee.actual),Y,F),Q=(0,r.$sJ)(M)&&this.j.prepareForMainThreadTestRun(le,E.fromInternal(M,O.collection),ce,N);try{return await Y.runHandler(le,N),{}}catch(Ee){return{error:String(Ee)}}finally{Q&&(Q.hasRunningTasks&&!N.isCancellationRequested&&await L.Event.toPromise(Q.onEnd),Q.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.j.cancelAllRuns():this.j.cancelRunById(M)}};e.$Xfc=t,e.$Xfc=t=He([Be(0,S.$zM)],t);const s=1e4;var d;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(d||(d={}));class l extends m.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,F,N){super(),this.m=M,this.s=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Rd),this.onEnd=this.j.event,this.h=this.B(new R.$2d(N));const O=this.B(new T.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const F=this.m.id,N=this.m.controllerId,O=(0,$.$ig)(),W=new I(this.s,F,O),x=J=>(le,...Q)=>{if(Y){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.m.isIncluded(le)&&(this.y(le),J(le,...Q))},ce=(J,le)=>{const Q=le instanceof Array?le.map(u.TestMessage.from):[u.TestMessage.from(le)];if(J.uri&&J.range){const Ee={range:u.Range.from(J.range),uri:J.uri};for(const he of Q)he.location=he.location||Ee}this.s.$appendTestMessagesInRun(F,O,i.$qJ.fromExtHostTestItem(J,N).toString(),Q)};let Y=!1;const G={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return W.coverageProvider},set coverageProvider(J){W.coverageProvider=J},enqueued:x(J=>{this.s.$updateTestStateInRun(F,O,i.$qJ.fromExtHostTestItem(J,N).toString(),1)}),skipped:x(J=>{this.s.$updateTestStateInRun(F,O,i.$qJ.fromExtHostTestItem(J,N).toString(),5)}),started:x(J=>{this.s.$updateTestStateInRun(F,O,i.$qJ.fromExtHostTestItem(J,N).toString(),2)}),errored:x((J,le,Q)=>{ce(J,le),this.s.$updateTestStateInRun(F,O,i.$qJ.fromExtHostTestItem(J,N).toString(),6,Q)}),failed:x((J,le,Q)=>{ce(J,le),this.s.$updateTestStateInRun(F,O,i.$qJ.fromExtHostTestItem(J,N).toString(),4,Q)}),passed:x((J,le)=>{this.s.$updateTestStateInRun(F,O,i.$qJ.fromExtHostTestItem(J,this.m.controllerId).toString(),3,le)}),appendOutput:(J,le,Q)=>{Y||(Q&&(this.m.isIncluded(Q)?this.y(Q):Q=void 0),this.s.$appendOutputToRun(F,O,g.$fe.fromString(J),le&&u.location.from(le),Q&&i.$qJ.fromExtHostTestItem(Q,N).toString()))},end:()=>{Y||(Y=!0,this.s.$finishedTestRunTask(F,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:G,coverage:W}),this.s.$startedTestRunTask(F,{id:O,name:M,running:!0}),G}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof w.$MM))throw new n.$rM(M.id);if(this.g.has(i.$qJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const F=[],N=this.m.colllection.root;for(;;){const O=u.TestItem.from(M);if(F.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),M===N))break;M=M.parent||N}this.s.$addTestsToRun(this.m.controllerId,this.m.id,F)}dispose(){this.w(),super.dispose()}}class c{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,F,N,O){return this.f(M,F,N,O)}cancelRunById(M){for(const F of this.c.values())if(F.id===M){F.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,F,N,O,W,x){const ce=this.c.get(O);if(ce)return ce.createRun(W);const Y=E.fromPublic(F,N,O,x),G=h(O);this.d.$startedExtensionTestRun({controllerId:F,continuous:!!O.continuous,profile:G&&{group:j[G.kind],id:G.profileId},exclude:O.exclude?.map(le=>i.$qJ.fromExtHostTestItem(le,N.root.id).toString())??[],id:Y.id,include:O.include?.map(le=>i.$qJ.fromExtHostTestItem(le,N.root.id).toString())??[N.root.id],persist:x});const J=this.f(O,Y,M);return L.Event.once(J.onEnd)(()=>{this.d.$finishedExtensionTestRun(Y.id),J.dispose()}),J.createRun(W)}f(M,F,N,O){const W=new l(F,this.d,O);return this.c.set(M,W),L.Event.once(W.onEnd)(()=>this.c.delete(M)),W}}e.$Yfc=c;const h=z=>{if(z.profile){if(!(z.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class E{static fromPublic(M,F,N,O){return new E(M,(0,$.$ig)(),N.include?.map(W=>i.$qJ.fromExtHostTestItem(W,M).toString())??[M],N.exclude?.map(W=>i.$qJ.fromExtHostTestItem(W,M).toString())??[],O,F)}static fromInternal(M,F){return new E(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,F)}constructor(M,F,N,O,W,x){this.controllerId=M,this.id=F,this.isPersisted=W,this.colllection=x,this.c=N.map(ce=>ce+"\0"),this.d=O.map(ce=>ce+"\0")}isIncluded(M){const F=i.$qJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const N of this.d)if(F===N||F.startsWith(N))return!1;for(const N of this.c)if(F===N||F.startsWith(N))return!0;return!1}}e.$Zfc=E;class I{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,F,N){this.f=M,this.g=F,this.h=N}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(u.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(M,F){const N=await this.d;let O=N?.[M];return!this.c||!N||!O?[]:(O.detailedCoverage||(O=N[M]=await this.c.resolveFileCoverage?.(O,F)??O),O.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class f{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,u.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const F=i.$qJ.parentId(M.item.extId);if(F&&this.g.has(F.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:F,f:N}=this;return{get added(){return[...M].map(O=>O.revived)},get updated(){return[...F].map(O=>O.revived)},get removed(){return[...N].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends r.$xJ{constructor(){super(...arguments),this.q=new L.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,F){return{...M,revived:u.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set}}o(){return new f(this.q)}}class k{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(F=>F.revived)},dispose:(0,b.$cb)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class P{#e;#t;#i;#o;#r;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?u.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}get isSelected(){return(0,a.$MF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,a.$MF)(this.#t,"testingActiveProfile"),L.Event.chain(this.#o,M=>M.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(C.$Kf))}constructor(M,F,N,O,W,x,ce,Y,G,J,le=!1,Q=void 0,Ee=!1){this.controllerId=x,this.profileId=ce,this.d=Y,this.kind=G,this.runHandler=J,this.f=le,this._tag=Q,this.g=Ee,this.#e=M,this.#r=F,this.#t=N,this.#i=O,this.#o=W,F.set(ce,this);const he=j[G];if(typeof he!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);this.#e.$publishTestRunProfile({profileId:ce,controllerId:x,tag:Q?u.TestTag.namespace(this.controllerId,Q.id):null,label:Y,group:he,isDefault:le,hasConfigurationHandler:!1,supportsContinuousRun:Ee})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$1fc=P;const j={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[340],Se([1,0,19,8,4,6,150,15,7]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class m{constructor(C,$){this.i=$,this.a=new g.$Rd({onListenerError:T.$1}),this.b=new g.$Rd({onListenerError:T.$1}),this.c=new g.$Rd({onListenerError:T.$1}),this.d=new g.$Rd({onListenerError:T.$1}),this.f=new g.$Rd({onListenerError:T.$1}),this.g=new g.$Rd({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(R.$xK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const $=this.i.allEditors();return C?$:$.map(v=>v.value)}async showTextDocument(C,$,v){let S;typeof $=="number"?S={position:b.ViewColumn.from($),preserveFocus:v}:typeof $=="object"?S={position:b.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?b.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:S={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(C.uri,S),u=w&&this.i.getEditor(w);if(u)return u.value;throw w?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,$){return new L.$GM(this.h,C,$).value}$acceptEditorPropertiesChanged(C,$){const v=this.i.getEditor(C);if(!v)throw new Error("unknown text editor");if($.options&&v._acceptOptions($.options),$.selections){const S=$.selections.selections.map(b.Selection.to);v._acceptSelections(S)}if($.visibleRanges){const S=D.$Gb($.visibleRanges.map(b.Range.to));v._acceptVisibleRanges(S)}if($.options&&this.b.fire({textEditor:v.value,options:{...$.options,lineNumbers:b.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const S=y.TextEditorSelectionChangeKind.fromValue($.selections.source),w=$.selections.selections.map(b.Selection.to);this.a.fire({textEditor:v.value,selections:w,kind:S})}if($.visibleRanges){const S=D.$Gb($.visibleRanges.map(b.Range.to));this.c.fire({textEditor:v.value,visibleRanges:S})}}$acceptEditorPositionData(C){for(const $ in C){const v=this.i.getEditor($);if(!v)throw new Error("Unknown text editor");const S=b.ViewColumn.to(C[$]);v.value.viewColumn!==S&&(v._acceptViewColumn(S),this.d.fire({textEditor:v.value,viewColumn:S}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$kec=m}),define(ke[341],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=void 0,e.$3fc=(0,T.$Vh)("IExtHostTimeline");class A{constructor(v,S){this.b=new Map,this.c=new Map,this.a=v.getProxy(g.$xK.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(w,u)=>{if(w&&w.$mid===12)if(this.b.get(w.source)&&y.$_l.equals(u,this.b.get(w.source)?.extension)){const o=w.uri===void 0?void 0:D.URI.revive(w.uri);return this.c.get(w.source)?.get(C(o))?.get(w.handle)}else return;return w}})}async $getTimeline(v,S,w,u){return this.b.get(v)?.provider.provideTimeline(D.URI.revive(S),w,u)}registerTimelineProvider(v,S,w,u){const o=new R.$Qc,i=this.d(S.id,u,o).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const r=this.c;return this.f({...S,scheme:v,onDidChange:void 0,async provideTimeline(a,t,s){t?.resetCache&&(o.clear(),r.get(S.id)?.clear());const d=await S.provideTimeline(a,t,s);if(d==null)return;const l=i(a,t);return{...d,source:S.id,items:d.items.map(l)}},dispose(){for(const a of r.values())a.get(S.id)?.clear();n?.dispose(),o.dispose()}},w)}d(v,S,w){return(u,o)=>{let i;if(o?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const r=C(u);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...a}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let s,d,l;n.iconPath&&(r instanceof L.$tL?l={id:r.id,color:r.color}:D.URI.isUri(r)?(s=r,d=r):{light:s,dark:d}=r);let c;return L.$ZK.isMarkdownString(a.tooltip)?c=b.MarkdownString.from(a.tooltip):(0,m.$Cf)(a.tooltip)?c=a.tooltip:L.$ZK.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.MarkdownString.from(a.detail)):(0,m.$Cf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:v,command:n.command?S.toInternal(n.command,w):void 0,icon:s,iconDark:d,themeIcon:l,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}f(v,S){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:S}),(0,R.$Pc)(()=>{for(const u of this.c.values())u.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$4fc=A;function C($){return $?.toString()}}),define(ke[72],Se([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bxb=e.$axb=e.TunnelDtoConverter=void 0;class v extends y.$mv{}var S;(function(u){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:n.protocol}}u.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==y.TunnelPrivacyId.ConstantPrivate&&n.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}u.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$axb=(0,L.$Vh)("IExtHostTunnelService");let w=class extends g.$Rc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(m.$xK.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const r=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new $.$zK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,r,a){const t=[];for(const d of o){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(i.map(async c=>{let h;try{h=await l.provider.providePortAttributes({port:c,pid:n,commandLine:r},a)}catch{h=await l.provider.providePortAttributes(c,n,r,a)}return{providedAttributes:h,port:c}})))}const s=t.filter(d=>!!d.providedAttributes);return s.length>0?s.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,a)=>await o.provideTunnel(r,a,new D.$2d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,g.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,g.$Pc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:a}),S.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),n=o.filter((r,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$bxb=w,e.$bxb=w=He([Be(0,C.$zM),Be(1,A.$PM),Be(2,b.$dj)],w)}),define(ke[342],Se([1,0,3,17,2,6]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;class L{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(y){this.c=new Map,this.b=y.getProxy(R.$xK.MainThreadUriOpeners)}registerExternalUriOpener(y,m,A,C){if(this.c.has(m))throw new Error(`Opener with id '${m}' already registered`);const $=C.schemes.find(v=>!L.a.has(v));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(m,A),this.b.$registerUriOpener(m,C.schemes,y,C.label),(0,D.$Pc)(()=>{this.c.delete(m),this.b.$unregisterUriOpener(m)})}async $canOpenUri(y,m,A){const C=this.c.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const $=g.URI.revive(m);return C.canOpenExternalUri($,A)}async $openUri(y,m,A){const C=this.c.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(g.URI.revive(m.resolvedUri),{sourceUri:g.URI.revive(m.sourceUri)},A)}}e.$6fc=L}),define(ke[343],Se([1,0,6,2,3,8,26]),function(me,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class b{static{this.a=0}constructor(m){this.c=new L.$am,this.d=new Map,this.b=m.getProxy(D.$xK.MainThreadUrls)}registerUriHandler(m,A){const C=m.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const $=b.a++;return this.c.add(C),this.d.set($,A),this.b.$registerUriHandler($,C,m.displayName||m.name),(0,g.$Pc)(()=>{this.c.delete(C),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(m,A){const C=this.d.get(m);if(!C)return Promise.resolve(void 0);try{C.handleUri(T.URI.revive(A))}catch($){(0,R.$Z)($)}return Promise.resolve(void 0)}async createAppUri(m){return T.URI.revive(await this.b.$createAppUri(m))}}e.$7fc=b}),define(ke[93],Se([1,0,4,3,17,24,2,238,275,113,6]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=e.$Bec=e.$Aec=e.$zec=e.$yec=void 0;class C{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(r,a,t,s,d,l,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Rd,this._onDidDispose=this.#h.event,this.#e=r,this.#t=a,this.#s=t,this.#o=s,this.#r=d,this.#n=l,this.#l=$(l),this.#d=v(l),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,m.$iub)(r,this.#o)}get cspSource(){const r=this.#n.extensionLocation;if(r.scheme===g.Schemas.https||r.scheme===g.Schemas.http){let a=r.toString();return a.endsWith("/")||(a+="/"),a+" "+m.$hub}return m.$hub}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#s}set options(r){this.a(),R.$en(this.#s,r)||this.#t.$setOptions(this.#e,u(this.#n,this.#r,r)),this.#s=r}async postMessage(r){if(this.#c)return!1;const a=(0,y.$Dcb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const a=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,l,c,h,E)=>{const I=L.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),f=(0,m.$iub)(I,{isRemote:a,authority:t}).toString();return`${d}${f}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,l,c,h,E)=>{const I=L.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),f=(0,m.$iub)(I,{isRemote:a,authority:t}).toString();return`${d}${f}${E}`})}}e.$yec=C;function $(n){try{const r=(0,b.$To)((0,b.$So)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$zec=$;function v(n){try{const r=(0,b.$To)((0,b.$So)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class S extends T.$Rc{constructor(r,a,t,s,d){super(),this.c=a,this.f=t,this.g=s,this.h=d,this.b=new Map,this.a=r.getProxy(A.$xK.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,a,t){const s=this.j(r);if(s){const{message:d}=(0,y.$Ecb)(a,t.value);s._onMessageEmitter.fire(d)}}$onMissingCsp(r,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,a,t){const s=new C(r,this.a,o(a),this.c,this.f,t,this.h);this.b.set(r,s);const d=s._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return s}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Aec=S;function w(n){return{id:n.identifier,location:n.extensionLocation}}e.$Bec=w;function u(n,r,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,r)}}e.$Cec=u;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>L.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[344],Se([1,0,21,52,3,17,23,2,15,93,110,6,7]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class v{constructor(s,d){this.document=s,this.b=d,this.a=1,this.c=new A.$4dc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,d){await this.f(s).undo(),d||this.disposeBackup()}async redo(s,d){await this.f(s).redo(),d||this.disposeBackup()}disposeEdits(s){for(const d of s)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=a(this.document.uri)+this.a++;return(0,L.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const d=this.c.get(s,0);if(!d)throw new Error("No edit found");return d}}class S{constructor(){this.a=new Map}get(s,d){return this.a.get(this.b(s,d))}add(s,d,l){const c=this.b(s,d.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${s} resource:${d.uri}`);const h=new v(d,l);return this.a.set(c,h),h}delete(s,d){const l=this.b(s,d.uri);this.a.delete(l)}b(s,d){return`${s}@@@${d}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class u{constructor(){this.a=new Map}addTextProvider(s,d,l){return this.b(0,s,d,l)}addCustomProvider(s,d,l){return this.b(1,s,d,l)}get(s){return this.a.get(s)}b(s,d,l,c){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:s,extension:l,provider:c}),new $.$zK(()=>this.a.delete(d))}}class o{constructor(s,d,l,c,h){this.d=d,this.f=l,this.g=c,this.h=h,this.b=new u,this.c=new S,this.a=s.getProxy(C.$xK.MainThreadCustomEditors)}registerCustomEditorProvider(s,d,l,c){const h=new g.$Qc;return n(l)?(h.add(this.b.addTextProvider(d,s,l)),this.a.$registerTextEditorProvider((0,m.$Bec)(s),d,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,m.$zec)(s))):(h.add(this.b.addCustomProvider(d,s,l)),i(l)&&h.add(l.onDidChangeCustomDocument(E=>{const I=this.i(d,E.document.uri);if(r(E)){const f=I.addEdit(E);this.a.$onDidEdit(E.document.uri,d,f,E.label)}else this.a.$onContentChange(E.document.uri,d)})),this.a.$registerCustomEditorProvider((0,m.$Bec)(s),d,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,m.$zec)(s))),$.$zK.from(h,new $.$zK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(s,d,l,c,h){const E=this.b.get(d);if(!E)throw new Error(`No provider found for '${d}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${d}'`);const I=b.URI.revive(s),f=await E.provider.openCustomDocument(I,{backupId:l,untitledDocumentData:c?.buffer},h);let p;return i(E.provider)&&this.f&&(p=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(d,f,p),{editable:i(E.provider)}}async $disposeCustomDocument(s,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const c=b.URI.revive(s),{document:h}=this.i(d,c);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(s,d,l,c,h,E){const I=this.b.get(l);if(!I)throw new Error(`No provider found for '${l}'`);const f=y.ViewColumn.to(h),p=this.g.createNewWebview(d,c.contentOptions,I.extension),k=this.h.createNewWebviewPanel(d,l,c.title,f,c.options,p,c.active),P=b.URI.revive(s);switch(I.type){case 1:{const{document:j}=this.i(l,P);return I.provider.resolveCustomEditor(j,k,E)}case 0:{const j=this.d.getDocument(P);return I.provider.resolveCustomTextEditor(j,k,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,d,l){this.i(d,s).disposeEdits(l)}async $onMoveCustomEditor(s,d,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(s);if(!h)throw new Error("No webview found");const E=b.URI.revive(d),I=this.d.getDocument(E);await c.provider.moveCustomTextEditor(I,h,D.CancellationToken.None)}async $undo(s,d,l,c){return this.i(d,s).undo(l,c)}async $redo(s,d,l,c){return this.i(d,s).redo(l,c)}async $revert(s,d,l){const c=this.i(d,s);await this.j(d).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(s,d,l){const c=this.i(d,s);await this.j(d).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(s,d,l,c){const h=this.i(d,s);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(l),c)}async $backup(s,d,l){const c=this.i(d,s),E=await this.j(d).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(E),E.id}i(s,d){const l=this.c.get(s,b.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(s){const l=this.b.get(s)?.provider;if(!l||!i(l))throw new Error("Custom document is not editable");return l}}e.$Eec=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Ji)(s)+""}}),define(ke[345],Se([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class A extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(S,w,u,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=w,this.#o=u,this.#i=o.viewType,this.#r=o.panelOptions,this.#s=o.viewColumn,this.#n=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,w){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:L.ViewColumn.from(S),preserveFocus:!!w})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends T.$Rc{static c(){return(0,R.$ig)()}constructor(S,w,u){super(),this.j=w,this.m=u,this.g=new Map,this.h=new Map,this.f=S.getProxy(y.$xK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,w,u,o,i={}){const n=typeof o=="object"?o.viewColumn:o,r={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,b.$zec)(S),t=C.c();this.f.$createWebviewPanel((0,b.$Bec)(S),t,w,{title:u,panelOptions:$(i),webviewOptions:(0,b.$Cec)(S,this.m,i),serializeBuffersForPostMessage:a},r);const s=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,w,u,n,i,s,!0)}$onDidChangeWebviewPanelViewStates(S){const w=Object.keys(S);w.sort((u,o)=>{const i=S[u],n=S[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const u of w){const o=this.getWebviewPanel(u);if(!o)continue;const i=S[u];o._updateViewState({active:i.active,visible:i.visible,viewColumn:L.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,w,u){if(this.h.has(w))throw new Error(`Serializer for '${w}' already registered`);return this.h.set(w,{serializer:u,extension:S}),this.f.$registerSerializer(w,{serializeBuffersForPostMessage:(0,b.$zec)(S)}),new m.$zK(()=>{this.h.delete(w),this.f.$unregisterSerializer(w)})}async $deserializeWebviewPanel(S,w,u,o){const i=this.h.get(w);if(!i)throw new Error(`No serializer found for '${w}'`);const{serializer:n,extension:r}=i,a=this.j.createNewWebview(S,u.webviewOptions,r),t=this.createNewWebviewPanel(S,w,u.title,o,u.panelOptions,a,u.active);await n.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(S,w,u,o,i,n,r){const a=new A(S,this.f,n,{viewType:w,title:u,viewColumn:o,panelOptions:i,active:r});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$Dec=C;function $(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(ke[346],Se([1,0,4,3,93,15,6,7]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;class y extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(C,$,v,S,w,u){super(),this.#r=!1,this.#u=this.B(new D.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Rd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=S,this.#e=C,this.#t=$,this.#o=w,this.#n=u}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#n||this.#r||(this.#n=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#r)throw new Error("Webview is disposed")}}class m{constructor(C,$){this.d=$,this.b=new Map,this.c=new Map,this.a=C.getProxy(L.$xK.MainThreadWebviewViews)}registerWebviewViewProvider(C,$,v,S){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:v,extension:C}),this.a.$registerWebviewViewProvider((0,g.$Bec)(C),$,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$zec)(C)}),new b.$zK(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(C,$,v,S,w){const u=this.b.get($);if(!u)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:i}=u,n=this.d.createNewWebview(C,{},i),r=new y(C,this.a,$,v,n,!0);this.c.set(C,r),await o.resolveWebviewView(r,{state:S},w)}async $onDidChangeWebviewViewVisibility(C,$){this.e(C)._setVisible($)}async $disposeWebviewView(C){const $=this.e(C);this.c.delete(C),$.dispose(),this.d.deleteWebview(C)}e(C){const $=this.c.get(C);if(!$)throw new Error("No webview found");return $}}e.$8fc=m}),define(ke[153],Se([1,0,4,6,2,17,13,5,20,25]),function(me,e,D,T,g,R,L,b,y,m){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0;let C=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const S=this.d;return{get focused(){return S.focused},get active(){return(0,m.$MF)(v,"windowActivity"),S.active}}}constructor(v){this.c=new D.$Rd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(T.$xK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:w})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,S){S!==this.d[v]&&(this.d={...this.d,[v]:S},this.c.fire(this.d))}openUri(v,S){let w;if(typeof v=="string"){w=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,L.$Fe)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,w,S)}async asExternalUri(v,S){if((0,L.$Fe)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(v,S);return g.URI.from(w)}};e.$9fc=C,e.$9fc=C=A=He([Be(0,y.$zM)],C),e.$0fc=(0,b.$Vh)("IExtHostWindow")}),define(ke[347],Se([1,0,315,27,20]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;const R=1024*1024;let L=class extends D.$agc{constructor(y,m){super(y,m),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,m,A){const C=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),m.apply(console,A),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,m){const A=process[y],C=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(v,S,w)=>{if(!this.g){$+=v.toString(S);const u=$.length>R?$.length:$.lastIndexOf(`
`);u!==-1&&(console[m]($.slice(0,u)),$=$.slice(u+1))}C.call(A,v,S,w)}})}};e.$Lgc=L,e.$Lgc=L=He([Be(0,g.$zM),Be(1,T.$PM)],L)}),define(ke[348],Se([1,0,71,17,14,250,32,11]),function(me,e,D,T,g,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;let y=class{constructor(C,$){C.addFileSystemProvider(T.Schemas.file,new m($),{isCaseSensitive:b.$k})}};e.$Mgc=y,e.$Mgc=y=He([Be(0,D.$vec),Be(1,g.$dj)],y);class m{constructor(C){this.b=C,this.a=new R.$gq(this.b)}async stat(C){const $=await this.a.stat(C);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,$,v){return this.a.writeFile(C,$,{...v,unlock:!1,atomic:!1})}delete(C,$){return this.a.delete(C,{...$,useTrash:!1,atomic:!1})}rename(C,$,v){return this.a.rename(C,$,v)}copy(C,$,v){return this.a.copy(C,$,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,$){throw new Error("Method not implemented.")}}}),define(ke[349],Se([1,0,16,63,30,35,3,6,2,20]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;let A=class extends L.$Rc{constructor($,v){super();const S=$.getProxy(b.$xK.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async w=>{const u=y.URI.file((0,D.$ic)((0,T.tmpdir)(),(0,g.$ig)()));return await S.$download(w,u),u})}};e.$Kgc=A,e.$Kgc=A=He([Be(0,m.$zM),Be(1,R.$VM)],A)}),define(ke[350],Se([1,0,152,17,252,30]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class L extends D.$_fc{s(y,m,A){return y.scheme===T.Schemas.file?new g.$LN(A?.name||(0,R.$ig)(),y.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,m):super.s(y,m,A)}registerLogger(y){super.registerLogger(y),this.r.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.r.$deregisterLogger(y)}}e.$Xgc=L}),define(ke[351],Se([1,0,55,16,2,92,3,17,12,31]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class A extends R.$xec{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==b.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const d=s.fsPath;let l=0;do{let c;l===0?c=d:c=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await C(c);const h=T.$ic(c,"vscode.lock"),E=await w(this.d,h,!1);if(E)return this.i=E,process.on("exit",()=>{E.dispose()}),g.URI.file(c);l++}while(l<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Wgc=A;async function C(a){try{await m.Promises.stat(a);return}catch{}try{await m.Promises.mkdir(a,{recursive:!0})}catch{}}const $=1e3,v=10*60*1e3;class S extends L.$Rc{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new y.$9g),this.a.cancelAndSet(async()=>{const d=await u(t,s);(!d||d.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await m.Promises.utimes(s,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${s}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await m.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function w(a,t,s){try{const l={pid:process.pid,willReleaseAt:0};await m.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){a.error(l)}const d=await u(a,t);return!d||d.pid!==process.pid?s?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function u(a,t){let s;try{s=await m.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(s))}catch(d){return a.error(d),null}}async function o(a,t){let s;try{s=await m.Promises.stat(t)}catch(d){return a.error(d),0}return s.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const s=await u(a,t);if(!s)return a.info(`Lock '${t}': Could not read pid of lock holder.`),r(a,t);if(s.willReleaseAt){let E=s.willReleaseAt-Date.now();if(E<5e3){for(E>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${E} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);E>0;){if(await(0,y.$Yg)(Math.min(100,E)),await o(a,t)===0)return r(a,t);E=s.willReleaseAt-Date.now()}return r(a,t)}}if(!i(s.pid))return a.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),r(a,t);const d=await o(a,t),l=Date.now()-d;if(l<=v)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.$Yg)(2e3);const c=await o(a,t),h=Date.now()-c;return h<=v?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(a,t))}async function r(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await m.Promises.unlink(t)}catch{}return w(a,t,!0)}}),define(ke[352],Se([1,0,30,20,46,35]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;let L=class extends g.$Tec{constructor(y,m){super(!0,y,m)}createTerminal(y,m,A){return this.createTerminalFromOptions({name:y,shellPath:m,shellArgs:A})}createTerminalFromOptions(y,m){const A=new g.$Sec(this.a,(0,D.$ig)(),y,y.name);return this.f.push(A),A.create(y,this.R(y,m)),A.value}};e.$fgc=L,e.$fgc=L=He([Be(0,R.$VM),Be(1,T.$zM)],L)}),define(ke[353],Se([1,0,12,22,21,8,4,3,131,304,68]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=e.ResponsiveState=e.RequestInitiator=e.$m6b=e.$l6b=void 0;function $(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const v="$$ref$$",S={[v]:-1};class w{constructor(P,j){this.jsonString=P,this.referencedBuffers=j}}function u(k,P=null,j=!1){const z=[];return{jsonString:(j?$:JSON.stringify)(k,(F,N)=>{if(typeof N>"u")return S;if(typeof N=="object"){if(N instanceof T.$fe){const O=z.push(N)-1;return{[v]:O}}if(P)return P(F,N)}return N}),referencedBuffers:z}}e.$l6b=u;function o(k,P,j){return JSON.parse(k,(z,M)=>{if(M){const F=M[v];if(typeof F=="number")return P[F];if(j&&M.$mid===1)return j.transformIncoming(M)}return M})}e.$m6b=o;function i(k,P){return JSON.stringify(k,P)}function n(k){return k?(P,j)=>j&&j.$mid===1?k.transformOutgoing(j):j:null}var r;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var a;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},s=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends b.$Rc{static{C=s}static{this.a=3*1e3}constructor(P,j=null,z=null){super(),this[C]=!0,this.b=this.B(new L.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=j,this.g=z,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,F=A.$tv.count;M<F;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$0g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const j=this.w[P];delete this.w[P],j.resolveErr(R.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,y.$Um)(P,this.g):P}getProxy(P){const{nid:j,sid:z}=P;return this.s[j]||(this.s[j]=this.J(j,z)),this.s[j]}J(P,j){const z={get:(M,F)=>(typeof F=="string"&&!M[F]&&F.charCodeAt(0)===36&&(M[F]=(...N)=>this.U(P,F,N)),F===d?j:M[F])};return new Proxy(Object.create(null),z)}set(P,j){return this.m[P.nid]=j,j}assertRegistered(P){for(let j=0,z=P.length;j<z;j++){const M=P[j];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(P){if(this.j)return;const j=P.byteLength,z=h.read(P,0),M=z.readUInt8(),F=z.readUInt32();switch(M){case 1:case 2:{let{rpcId:N,method:O,args:W}=I.deserializeRequestJSONArgs(z);this.g&&(W=(0,y.$Um)(W,this.g)),this.M(j,F,N,O,W,M===2);break}case 3:case 4:{let{rpcId:N,method:O,args:W}=I.deserializeRequestMixedArgs(z);this.g&&(W=(0,y.$Um)(W,this.g)),this.M(j,F,N,O,W,M===4);break}case 5:{this.f?.logIncoming(j,F,0,"ack"),this.G(F);break}case 6:{this.N(j,F);break}case 7:{this.O(j,F,void 0);break}case 9:{let N=I.deserializeReplyOKJSON(z);this.g&&(N=(0,y.$Um)(N,this.g)),this.O(j,F,N);break}case 10:{const N=I.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(j,F,N);break}case 8:{const N=I.deserializeReplyOKVSBuffer(z);this.O(j,F,N);break}case 11:{let N=I.deserializeReplyErrError(z);this.g&&(N=(0,y.$Um)(N,this.g)),this.P(j,F,N);break}case 12:{this.P(j,F,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,j,z,M,F,N){this.f?.logIncoming(P,j,1,`receiveRequest ${(0,A.$vv)(z)}.${M}(`,F);const O=String(j);let W,x;if(N){const Y=new g.$2d;F.push(Y.token),W=this.Q(z,M,F),x=()=>Y.cancel()}else W=this.Q(z,M,F),x=t;this.u[O]=x;const ce=I.serializeAcknowledged(j);this.f?.logOutgoing(ce.byteLength,j,1,"ack"),this.c.send(ce),W.then(Y=>{delete this.u[O];const G=I.serializeReplyOK(j,Y,this.h);this.f?.logOutgoing(G.byteLength,j,1,"reply:",Y),this.c.send(G)},Y=>{delete this.u[O];const G=I.serializeReplyErr(j,Y);this.f?.logOutgoing(G.byteLength,j,1,"replyErr:",Y),this.c.send(G)})}N(P,j){this.f?.logIncoming(P,j,1,"receiveCancel");const z=String(j);this.u[z]?.()}O(P,j,z){this.f?.logIncoming(P,j,0,"receiveReply:",z);const M=String(j);if(!this.w.hasOwnProperty(M))return;const F=this.w[M];delete this.w[M],F.resolveOk(z)}P(P,j,z){this.f?.logIncoming(P,j,0,"receiveReplyErr:",z);const M=String(j);if(!this.w.hasOwnProperty(M))return;const F=this.w[M];delete this.w[M];let N;z&&(z.$isError?(N=new Error,N.name=z.name,N.message=z.message,N.stack=z.stack):N=z),F.resolveErr(N)}Q(P,j,z){try{return Promise.resolve(this.S(P,j,z))}catch(M){return Promise.reject(M)}}S(P,j,z){const M=this.m[P];if(!M)throw new Error("Unknown actor "+(0,A.$vv)(P));const F=M[j];if(typeof F!="function")throw new Error("Unknown method "+j+" on actor "+(0,A.$vv)(P));return F.apply(M,z)}U(P,j,z){if(this.j)return new m.$k6b;let M=null;if(z.length>0&&g.CancellationToken.isCancellationToken(z[z.length-1])&&(M=z.pop()),M&&M.isCancellationRequested)return Promise.reject(R.$5());const F=I.serializeRequestArguments(z,this.h),N=++this.t,O=String(N),W=new m.$j6b,x=new b.$Qc;M&&x.add(M.onCancellationRequested(()=>{const Y=I.serializeCancel(N);this.f?.logOutgoing(Y.byteLength,N,0,"cancel"),this.c.send(I.serializeCancel(N))})),this.w[O]=new c(W,x),this.F(N);const ce=I.serializeRequest(N,P,j,F,!!M);return this.f?.logOutgoing(ce.byteLength,N,0,`request: ${(0,A.$vv)(P)}.${j}(`,z),this.c.send(ce),W}}e.$n6b=l;class c{constructor(P,j){this.a=P,this.b=j}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class h{static alloc(P,j,z){const M=new h(T.$fe.alloc(z+1+4),0);return M.writeUInt8(P),M.writeUInt32(j),M}static read(P,j){return new h(P,j)}get buffer(){return this.a}constructor(P,j){this.a=P,this.b=j}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+P);return this.b+=P,j}static sizeMixedArray(P){let j=0;j+=1;for(let z=0,M=P.length;z<M;z++){const F=P[z];switch(j+=1,F.type){case 1:j+=this.sizeLongString(F.value);break;case 2:j+=this.sizeVSBuffer(F.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(F.value);for(let N=0;N<F.buffers.length;++N)j+=this.sizeVSBuffer(F.buffers[N]);break;case 4:break}}return j}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let j=0,z=P.length;j<z;j++){const M=P[j];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let F=0;F<M.buffers.length;++F)this.writeBuffer(M.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const j=new Array(P);for(let z=0;z<P;z++)switch(this.readUInt8()){case 1:j[z]=this.readLongString();break;case 2:j[z]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),N=this.readLongString(),O=[];for(let W=0;W<F;++W)O.push(this.readVSBuffer());j[z]=new A.$wv(o(N,O,null));break}case 4:j[z]=void 0;break}return j}}var E;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(E||(E={}));class I{static a(P){for(let j=0,z=P.length;j<z;j++)if(P[j]instanceof T.$fe||P[j]instanceof A.$wv||typeof P[j]>"u")return!0;return!1}static serializeRequestArguments(P,j){if(this.a(P)){const z=[];for(let M=0,F=P.length;M<F;M++){const N=P[M];if(N instanceof T.$fe)z[M]={type:2,value:N};else if(typeof N>"u")z[M]={type:4};else if(N instanceof A.$wv){const{jsonString:O,referencedBuffers:W}=u(N.value,j);z[M]={type:3,value:T.$fe.fromString(O),buffers:W}}else z[M]={type:1,value:T.$fe.fromString(i(N,j))}}return{type:1,args:z}}return{type:0,args:i(P,j)}}static serializeRequest(P,j,z,M,F){switch(M.type){case 0:return this.b(P,j,z,M.args,F);case 1:return this.c(P,j,z,M.args,F)}}static b(P,j,z,M,F){const N=T.$fe.fromString(z),O=T.$fe.fromString(M);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(N),W+=h.sizeLongString(O);const x=h.alloc(F?2:1,P,W);return x.writeUInt8(j),x.writeShortString(N),x.writeLongString(O),x.buffer}static deserializeRequestJSONArgs(P){const j=P.readUInt8(),z=P.readShortString(),M=P.readLongString();return{rpcId:j,method:z,args:JSON.parse(M)}}static c(P,j,z,M,F){const N=T.$fe.fromString(z);let O=0;O+=h.sizeUInt8(),O+=h.sizeShortString(N),O+=h.sizeMixedArray(M);const W=h.alloc(F?4:3,P,O);return W.writeUInt8(j),W.writeShortString(N),W.writeMixedArray(M),W.buffer}static deserializeRequestMixedArgs(P){const j=P.readUInt8(),z=P.readShortString(),M=P.readMixedArray(),F=new Array(M.length);for(let N=0,O=M.length;N<O;N++){const W=M[N];typeof W=="string"?F[N]=JSON.parse(W):F[N]=W}return{rpcId:j,method:z,args:F}}static serializeAcknowledged(P){return h.alloc(5,P,0).buffer}static serializeCancel(P){return h.alloc(6,P,0).buffer}static serializeReplyOK(P,j,z){if(typeof j>"u")return this.d(P);if(j instanceof T.$fe)return this.e(P,j);if(j instanceof A.$wv){const{jsonString:M,referencedBuffers:F}=u(j.value,z,!0);return this.g(P,M,F)}else return this.f(P,$(j,z))}static d(P){return h.alloc(7,P,0).buffer}static e(P,j){let z=0;z+=h.sizeVSBuffer(j);const M=h.alloc(8,P,z);return M.writeVSBuffer(j),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,j){const z=T.$fe.fromString(j);let M=0;M+=h.sizeLongString(z);const F=h.alloc(9,P,M);return F.writeLongString(z),F.buffer}static g(P,j,z){const M=T.$fe.fromString(j);let F=0;F+=h.sizeUInt32,F+=h.sizeLongString(M);for(const O of z)F+=h.sizeVSBuffer(O);const N=h.alloc(10,P,F);N.writeUInt32(z.length),N.writeLongString(M);for(const O of z)N.writeBuffer(O);return N.buffer}static deserializeReplyOKJSON(P){const j=P.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(P,j){const z=P.readUInt32(),M=P.readLongString(),F=[];for(let N=0;N<z;++N)F.push(P.readVSBuffer());return new A.$wv(o(M,F,j))}static serializeReplyErr(P,j){const z=j?$(R.$2(j),null):void 0;if(typeof z!="string")return this.h(P);const M=T.$fe.fromString(z);let F=0;F+=h.sizeLongString(M);const N=h.alloc(11,P,F);return N.writeLongString(M),N.buffer}static deserializeReplyErrError(P){const j=P.readLongString();return JSON.parse(j)}static h(P){return h.alloc(12,P,0).buffer}}var f;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var p;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(p||(p={}))}),define(ke[354],Se([1,0,4,37,45,5]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.OutputChannelUpdateMode=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=void 0,e.$IJ="text/x-code-output",e.$JJ="output",e.$KJ="Log",e.$LJ="text/x-code-log-output",e.$MJ="log",e.$NJ="workbench.panel.output",e.$OJ=new g.$aj("inOutput",!1),e.$PJ=new g.$aj("activeLogOutput",!1),e.$QJ=new g.$aj("outputView.scrollLock",!1),e.$RJ=(0,R.$Vh)("outputService");var L;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$SJ={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(A=>m.push(A)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}T.$mn.add(e.$SJ.OutputChannels,new b),e.$TJ=new g.$aj("activeOutputChannel","")}),define(ke[154],Se([1,0,6,5,20,26,14,354,71,27,57,182,22,18,32,4,3]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0;class o extends L.$jj{get disposed(){return this.n}constructor(a,t,s,d,l){super(),this.id=a,this.name=t,this.r=s,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=$.$fe.fromString(t).byteLength,(0,L.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let n=class{constructor(a,t,s,d,l,c){this.i=t,this.j=s,this.k=d,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(D.$xK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(a,t,s){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,v.$Cf)(t)?t:void 0;if((0,v.$Cf)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([I])=>R.$_l.equals(s.identifier,I))?.[1];h&&(c=(0,L.$tj)(h));const E=d?this.o(a,c,s):this.n(a,l,s);return E.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),d?this.r(a,c??this.m.getLevel(),E):this.q(a,E)}async n(a,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,l,t,s.identifier.value);return new o(h,a,c,this.a,s)}async o(a,t,s){const d=await this.p(s),l=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(d,`${l}.log`),h=`${s.identifier.value}.${l}`,E=this.l.createLogger(c,{id:h,name:a,logLevel:t,extensionId:s.identifier.value});return new i(h,a,E,this.a,s)}p(a){let t=this.d.get(a.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(d){if((0,S.$uk)(d)!==S.FileSystemProviderErrorCode.FileExists)throw d}return s})())}return t}q(a,t){let s=!1;const d=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return a},append(l){d(),t.then(c=>c.append(l))},appendLine(l){d(),t.then(c=>c.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(c=>c.replace(l))},show(l,c){d(),t.then(h=>h.show(l,c))},hide(){d(),t.then(l=>l.hide())},dispose(){s=!0,t.then(l=>l.dispose())}}}r(a,t,s){const d=new u.$Qc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},c=d.add(new w.$Rd);function h(E){t=E,c.fire(E)}return s.then(E=>{d.add(E),E.logLevel!==t&&h(E.logLevel),d.add(E.onDidChangeLogLevel(I=>h(I)))}),{...this.q(a,s),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(E,...I){l(),s.then(f=>f.trace(E,...I))},debug(E,...I){l(),s.then(f=>f.debug(E,...I))},info(E,...I){l(),s.then(f=>f.info(E,...I))},warn(E,...I){l(),s.then(f=>f.warn(E,...I))},error(E,...I){l(),s.then(f=>f.error(E,...I))},dispose(){d.dispose()}}}};e.$Ifc=n,e.$Ifc=n=He([Be(0,g.$zM),Be(1,m.$PM),Be(2,y.$vec),Be(3,A.$8dc),Be(4,L.$ej),Be(5,L.$dj)],n),e.$Jfc=(0,T.$Vh)("IExtHostOutputService")}),define(ke[155],Se([1,0,5,12]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,D.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const y=await g.getRoundTripTime();if(y===void 0)return;R=Math.min(R,y/2),await(0,T.$Yg)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((b,y)=>b+y,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((b,y)=>b+y,0)/this.average.length,high:(()=>typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[355],Se([1,0,224,86,37,40,44,3,4,155,11,24]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=void 0,e.$oH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$pH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$qH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$rH={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new y.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const v=new $;g.$mn.add(e.$rH.ConfigurationMigration,v);let S=class extends b.$Rc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const r of n.added)await this.f(r,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(n=>this.g(n,o?.uri))])}async g(o,i){const n=this.a.inspect(o.key,{resource:i}),r=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[a,t]of r){const s=[];for(const l of n.overrideIdentifiers??[]){const c=await this.h(o,{resource:i,overrideIdentifier:l},a);for(const h of c??[]){let E=s.find(([[I,f]])=>I===h[0]&&(0,C.$en)(f.value,h[1].value));E||s.push(E=[h,[]]),E[1].push(l)}}const d=await this.h(o,{resource:i},a,n);for(const l of d??[])s.push([l,[]]);s.length&&await Promise.allSettled(s.map(async([[l,c],h])=>this.a.updateValue(l,c.value,{resource:i,overrideIdentifiers:h},t)))}}async h(o,i,n,r){const a=(r??this.a.inspect(o.key,i))[n];if(a===void 0)return;const t=d=>this.a.inspect(d,i)[n],s=await o.migrateFn(a,t);return Array.isArray(s)?s:[[o.key,s]]}};e.$sH=S,e.$sH=S=He([Be(0,L.$pi),Be(1,R.$5h)],S);let w=class extends b.$Rc{constructor(o){super(),(async()=>{if(!A.$i&&(await o.getEnvironment())?.os!==1)return;g.$mn.as(T.$rn.Configuration).registerConfiguration({...e.$qH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.$tH=w,e.$tH=w=He([Be(0,m.$zm)],w)}),define(ke[356],Se([1,0,34,17,16,23,233,355,86,5,37]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbb=e.$Wbb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Vbb=e.$Ubb=void 0,e.$Ubb=(0,m.$Vh)("editorResolverService"),e.$Vbb="workbench.editorAssociations";const C=A.$mn.as(y.$rn.Configuration),$={...b.$pH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration($);var v;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(v||(e.RegisteredEditorPriority=v={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function w(o){switch(o){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Wbb=w;function u(o,i){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(g.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,R.$wg)(i);return D.$Bj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$Xbb=u}),define(ke[357],Se([1,0,33,17,16,11,23,2,5,268,40,146,155]),function(me,e,D,T,g,R,L,b,y,m,A,C,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=void 0,e.$_J=(0,y.$Vh)("pathService");let S=v=class{constructor(u,o,i,n){this.d=u,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??u})()}hasValidBasename(u,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(u,n,o)):this.h(u,o,i)}h(u,o,i){return u.scheme===T.Schemas.file||u.scheme===T.Schemas.vscodeRemote?(0,D.$Zf)(i??(0,L.$wg)(u),o===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,o){if(u.remoteAuthority)return T.Schemas.vscodeRemote;const i=(0,m.$9J)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:T.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?g.$ec:g.$fc)}async fileURI(u){let o="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const n=u.indexOf("/",2);n===-1?(o=u.substring(2),u="/"):(o=u.substring(2,n),u=u.substring(n)||"/")}return b.URI.from({scheme:T.Schemas.file,authority:o,path:u,query:"",fragment:""})}};e.$aK=S,e.$aK=S=v=He([Be(1,$.$zm),Be(2,C.$UJ),Be(3,A.$5h)],S)}),define(ke[358],Se([1,0,235,19,59,4,52,3,2,44,240,14,64,270,88,40,146,25,21,18,24,45]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=e.OnPortForward=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.TunnelSource=e.TunnelCloseReason=e.$XJ=e.$WJ=e.$VJ=void 0;const t=10*1e3,s="remote.tunnels.toRestore";e.$VJ="onTunnel",e.$WJ=new a.$aj("forwardedPortsViewEnabled",!1,D.localize(0,null));function d(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$XJ=d;var l;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(l||(e.TunnelCloseReason=l={}));var c;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$YJ={source:c.User,description:D.localize(1,null)},e.$ZJ={source:c.Auto,description:D.localize(2,null)};function h(j,z,M){const F=j.get(I(z,M));if(F)return F;if((0,S.$iv)(z))for(const N of S.$hv){const O=I(N,M);if(j.has(O))return j.get(O)}else if((0,S.$kv)(z))for(const N of S.$jv){const O=I(N,M);if(j.has(O))return j.get(O)}}e.$1J=h;function E(j,z,M){const F=h(j,z,M);if(F)return F;const N=(0,S.$kv)(z)?"localhost":(0,S.$iv)(z)?"0.0.0.0":void 0;if(N)return h(j,N,M)}e.$2J=E;function I(j,z){return j+":"+z}e.$3J=I;var f;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(f||(e.OnPortForward=f={}));function p(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}e.$4J=p;class k extends b.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new R.$Rd,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(M=>{(M.affectsConfiguration(k.c)||M.affectsConfiguration(k.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,M,F){let N=this.w(z,M,F,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const W=this.j[N];W.key===z?(O.onAutoForward=W.onAutoForward??O.onAutoForward,O.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:O.elevateIfNeeded,O.label=W.label??O.label,O.requireLocalPort=W.requireLocalPort,O.protocol=W.protocol):(O.onAutoForward=O.onAutoForward??W.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:W.elevateIfNeeded,O.label=O.label??W.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??W.protocol),N=this.w(z,M,F,this.j,N+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,n.$Cf)(z.host)&&(0,n.$Gf)(z.port)}w(z,M,F,N,O){if(O>=N.length)return-1;const W=!(0,S.$iv)(M)&&!(0,S.$kv)(M),ce=N.slice(O).findIndex(Y=>(0,n.$Gf)(Y.key)?W?!1:Y.key===z:this.t(Y.key)?W?!1:z>=Y.key.start&&z<=Y.key.end:this.u(Y.key)?z===Y.key.port&&M===Y.key.host:F?Y.key.test(F):!1);return ce>=0?ce+O:-1}y(){const z=this.r.getValue(k.c);if(!z||!(0,n.$Ef)(z))return[];const M=[];for(const N in z){if(N===void 0)continue;const O=z[N];let W;if(Number(N))W=Number(N);else if((0,n.$Cf)(N))if(k.g.test(N)){const x=N.match(k.g);W={start:Number(x[1]),end:Number(x[2])}}else if(k.h.test(N)){const x=N.match(k.h);W={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(N)}catch{}x&&(W=x)}W&&M.push({key:W,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const F=this.r.getValue(k.f);return F&&(this.m={elevateIfNeeded:F.elevateIfNeeded,label:F.label,onAutoForward:F.onAutoForward,requireLocalPort:F.requireLocalPort,protocol:F.protocol}),this.z(M)}z(z){function M(F,N){return(0,n.$Gf)(F.key)?F.key:N.t(F.key)?F.key.start:N.u(F.key)?F.key.port:Number.MAX_VALUE}return z.sort((F,N)=>M(F,this)-M(N,this))}C(){return this.m}static providedActionToAction(z){switch(z){case S.ProvidedOnAutoForward.Notify:return f.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return f.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return f.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return f.OpenPreview;case S.ProvidedOnAutoForward.Silent:return f.Silent;case S.ProvidedOnAutoForward.Ignore:return f.Ignore;default:return}}async addAttributes(z,M,F){const O=this.r.inspect(k.c).userRemoteValue;let W;!O||!(0,n.$Ef)(O)?W={}:W=(0,r.$an)(O),W[`${z}`]||(W[`${z}`]={});for(const x in M)W[`${z}`][x]=M[x];return this.r.updateValue(k.c,W,F)}}e.$5J=k;let P=class extends b.$Rc{constructor(z,M,F,N,O,W,x,ce,Y,G){super(),this.H=z,this.I=M,this.J=F,this.L=N,this.M=O,this.N=W,this.O=x,this.P=ce,this.Q=Y,this.R=G,this.c=new Map,this.g=new R.$Rd,this.onForwardPort=this.g.event,this.h=new R.$Rd,this.onClosePort=this.h.event,this.j=new R.$Rd,this.onPortName=this.j.event,this.n=new R.$Rd,this.onCandidatesChanged=this.n.event,this.t=new R.$Rd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$Rd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new k(F),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async J=>{const le=await this.getAttributes(J.map(Q=>({port:Q.tunnelRemotePort,host:Q.tunnelRemoteHost})));for(const Q of J)if(Q.localAddress){const Ee=I(Q.tunnelRemoteHost,Q.tunnelRemotePort),he=E(this.m??new Map,Q.tunnelRemoteHost,Q.tunnelRemotePort);this.forwarded.set(Ee,{remotePort:Q.tunnelRemotePort,remoteHost:Q.tunnelRemoteHost,localAddress:Q.localAddress,protocol:le?.get(Q.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Q.localAddress,le?.get(Q.tunnelRemotePort)),localPort:Q.tunnelLocalPort,runningProcess:he?.detail,hasRunningProcess:!!he,pid:he?.pid,privacy:Q.privacy,source:e.$YJ}),this.f.set(Ee,Q)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async J=>{const le=I(J.tunnelRemoteHost,J.tunnelRemotePort);if(!E(this.forwarded,J.tunnelRemoteHost,J.tunnelRemotePort)&&!E(this.detected,J.tunnelRemoteHost,J.tunnelRemotePort)&&!E(this.c,J.tunnelRemoteHost,J.tunnelRemotePort)&&J.localAddress){const Q=E(this.m??new Map,J.tunnelRemoteHost,J.tunnelRemotePort),Ee=(await this.getAttributes([{port:J.tunnelRemotePort,host:J.tunnelRemoteHost}]))?.get(J.tunnelRemotePort);this.forwarded.set(le,{remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localAddress:J.localAddress,protocol:Ee?.protocol??S.TunnelProtocol.Http,localUri:await this.X(J.localAddress,Ee),localPort:J.tunnelLocalPort,closeable:!0,runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,privacy:J.privacy,source:e.$YJ})}await this.$(),this.f.set(le,J),this.g.fire(this.forwarded.get(le))})),this.B(this.H.onTunnelClosed(J=>this.W(J,l.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$VJ))?(this.R.createKey(e.$WJ.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,M){const F=I(z.host,z.port);this.forwarded.has(F)&&(this.forwarded.delete(F),await this.$(),this.h.fire(z))}X(z,M){if(z.startsWith("http"))return y.URI.parse(z);const F=M?.protocol??"http";return y.URI.parse(`${F}://${z}`)}async Y(){const z=this.N.getWorkspace(),M=z.configuration?(0,L.$Ji)(z.configuration.path):z.folders.length>0?(0,L.$Ji)(z.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${s}.${this.L.remoteAuthority}.${M}`}async Z(){const z=this.I.get(s,1);if(z)return this.I.remove(s,1),await this.$(),z;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const M=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(F=>F.remotePort).join(", ")}`);for(const F of M){const N=E(this.detected,F.remoteHost,F.remotePort);F.source.source!==c.Extension&&!N||F.source.source===c.Extension&&N?await this.cb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,privacy:F.privacy,elevateIfNeeded:!0,source:F.source}):F.source.source===c.Extension&&!N&&this.D.set(I(F.remoteHost,F.remotePort),F)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new b.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(z,M,F){if(!z.tunnelLocalPort||!F?.requireLocalPort||z.tunnelLocalPort===M)return;const N=new Date;if(this.ab.getTime()+t>N.getTime())return;this.ab=N;const O=D.localize(3,null,M,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(O)}async forward(z,M){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.cb(z,M)}async cb(z,M){await this.Q.activateByEvent(e.$VJ);const F=E(this.forwarded,z.remote.host,z.remote.port);M=M??(M!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const N=z.local!==void 0?z.local:z.remote.port;let O;if(F)return this.eb(F,z,M);{const W=this.L.remoteAuthority,x=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,ce=I(z.remote.host,z.remote.port);this.c.set(ce,!0),z=this.db(ce,z);const Y=await this.H.openTunnel(x,z.remote.host,z.remote.port,void 0,N,z.elevateIfNeeded?z.elevateIfNeeded:M?.elevateIfNeeded,z.privacy,M?.protocol);if(typeof Y=="string")O=Y;else if(Y&&Y.localAddress){const G=E(this.m??new Map,z.remote.host,z.remote.port),J=Y.protocol?Y.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,le={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:M?.label??z.name,closeable:!0,localAddress:Y.localAddress,protocol:J,localUri:await this.X(Y.localAddress,M),runningProcess:G?.detail,hasRunningProcess:!!G,pid:G?.pid,source:z.source??e.$YJ,privacy:Y.privacy};return this.forwarded.set(ce,le),this.f.set(ce,Y),this.c.delete(ce),await this.$(),await this.bb(Y,N,M),this.g.fire(le),Y}this.c.delete(ce)}return O}db(z,M){const F=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(F){const N=F.get(z);F.delete(z),N&&(M.name=N.name??M.name,M.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??M.local,M.privacy=N.privacy??M.privacy)}return M}async eb(z,M,F){const N=F?.label??M.name;let O;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(O||(O={}));let W=O.None;switch(N!==z.name&&(z.name=N,W=O.Fire),(F?.protocol||z.protocol!==S.TunnelProtocol.Http)&&F?.protocol!==z.protocol&&(M.source=z.source,W=O.Reopen),M.privacy&&z.privacy!==M.privacy&&(W=O.Reopen),W){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(z.remoteHost,z.remotePort,l.User),await this.cb(M,F)}return E(this.f,M.remote.host,M.remote.port)}async name(z,M,F){const N=E(this.forwarded,z,M),O=I(z,M);if(N){N.name=F,await this.$(),this.j.fire({host:z,port:M});return}else this.detected.has(O)&&(this.detected.get(O).name=F,this.j.fire({host:z,port:M}))}async close(z,M,F){const N=I(z,M),O=this.forwarded.get(N);return F===l.AutoForwardEnd&&O&&O.source.source===c.Auto&&this.F.set(N,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(z,M),this.W({host:z,port:M},F)}address(z,M){const F=I(z,M);return(this.forwarded.get(F)||this.detected.get(F))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const M of z){const F=E(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),N=typeof M.localAddress=="string"?M.localAddress:I(M.localAddress.host,M.localAddress.port);this.detected.set(I(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:N,protocol:S.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:F?.detail,hasRunningProcess:!!F,pid:F?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,N,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let M=z;this.r&&(M=await this.r(z));const F=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(F.values()).map(N=>N.port).join(", ")}`),this.n.fire(F)}fb(z){const M=this.m??new Map,F=new Map;return this.m=F,z.forEach(N=>{const O=I(N.host,N.port);F.set(O,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),M.has(O)&&M.delete(O);const W=E(this.forwarded,N.host,N.port);W&&(W.runningProcess=N.detail,W.hasRunningProcess=!0,W.pid=N.pid)}),M.forEach((N,O)=>{const W=d(O);if(!W)return;const x=E(this.forwarded,W.host,W.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const ce=E(this.detected,W.host,W.port);ce&&(ce.runningProcess=void 0,ce.hasRunningProcess=!1,ce.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),M=await this.getAttributes(z.map(F=>({port:F.remotePort,host:F.remoteHost})),!1);if(M)for(const F of z){const N=M.get(F.remotePort);(N?.protocol||F.protocol!==S.TunnelProtocol.Http)&&N?.protocol!==F.protocol&&await this.cb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,source:F.source},N),N&&N.label&&N.label!==F.name&&await this.name(F.remoteHost,F.remotePort,N.label)}}async getAttributes(z,M=!0){const F=new Map,N=new Map;z.forEach(Y=>{const G=E(this.m??new Map,S.$hv[0],Y.port)??Y;if(G){F.set(Y.port,G);const J=p(G)?G.pid:void 0;N.has(J)||N.set(J,[]),N.get(J)?.push(Y.port)}});const O=new Map;if(z.forEach(Y=>{const G=this.configPortsAttributes.getAttributes(Y.port,Y.host,F.get(Y.port)?.detail);G&&O.set(Y.port,G)}),this.G.length===0||!M)return O.size>0?O:void 0;const W=await Promise.all((0,T.$Qb)(this.G.map(Y=>Array.from(N.entries()).map(G=>{const J=G[1],le=F.get(J[0]);return Y.providePortAttributes(J,le?.pid,le?.detail,new i.$2d().token)})))),x=new Map;if(W.forEach(Y=>Y.forEach(G=>{G&&x.set(G.port,G)})),!O&&!x)return;const ce=new Map;return z.forEach(Y=>{const G=O.get(Y.port),J=x.get(Y.port);ce.set(Y.port,{elevateIfNeeded:G?.elevateIfNeeded,label:G?.label,onAutoForward:G?.onAutoForward??k.providedActionToAction(J?.autoForwardAction),requireLocalPort:G?.requireLocalPort,protocol:G?.protocol})}),ce}addAttributesProvider(z){this.G.push(z)}};e.$6J=P,He([(0,g.$oh)(1e3)],P.prototype,"$",null),e.$6J=P=He([Be(0,S.$dv),Be(1,v.$_o),Be(2,m.$pi),Be(3,u.$UJ),Be(4,$.$Vk),Be(5,w.$5h),Be(6,C.$dj),Be(7,A.$Iv),Be(8,o.$IF),Be(9,a.$bj)],P)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$PI=e.$OI=void 0;class D{constructor(L,b){this.line=L,this.character=b}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,b){return new D(0,0)}with(L){return new D(0,0)}}e.$OI=D;class T{constructor(L,b,y,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(L,b),this.end=new D(y,m)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new T(0,0,0,0)}with(L){return new T(0,0,0,0)}}e.$PI=T;var g;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,8,94,12]),function(me,e,D,T,g,R,L,b,y,m,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.SearchErrorCode=e.$5I=e.$4I=e.SearchSortOrder=e.ViewMode=e.$3I=e.$2I=e.$1I=e.$ZI=e.SearchCompletionExitCode=e.$YI=e.$XI=e.$WI=e.QueryType=e.SearchProviderType=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$QI="workbench.view.search",e.$RI="workbench.panel.search",e.$SI="workbench.view.search",e.$TI="search-result",e.$UI="search.exclude";const $="\u27EA ",v=" characters skipped \u27EB",S=($.length+v.length+5)*2;e.$VI=(0,b.$Vh)("searchService");var w;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(w||(e.SearchProviderType=w={}));var u;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(u||(e.QueryType=u={}));function o(J){return!!J.preview}e.$WI=o;function i(J){return!!J.resource}e.$XI=i;function n(J){return!!J.message}e.$YI=n;var r;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class a{constructor(le){this.resource=le,this.results=[]}}e.$ZI=a;class t{constructor(le,Q,Ee,he){this.ranges=Q,this.webviewIndex=he;const K=Array.isArray(Q)?Q:[Q];if(Ee&&Ee.matchLines===1&&s(K)){le=(0,L.$vf)(le,Ee.matchLines);let U="",ie=0,be=0;const H=Math.floor(Ee.charsPerLine/5),_=[];for(const Z of K){const $e=Math.max(Z.startColumn-H,0),re=Z.startColumn+Ee.charsPerLine;if($e>be+H+S){const fe=$+($e-be)+v;U+=fe+le.slice($e,re),ie+=$e-(be+fe.length)}else U+=le.slice(be,re);_.push(new l(0,Z.startColumn-ie,Z.endColumn-ie)),be=re}this.preview={text:U,matches:Array.isArray(this.ranges)?_:_[0]}}else{const U=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:le,matches:(0,D.$1b)(Q,ie=>new d(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$1I=t;function s(J){const le=J[0].startLineNumber;for(const Q of J)if(Q.startLineNumber!==le||Q.endLineNumber!==le)return!1;return!0}class d{constructor(le,Q,Ee,he){this.startLineNumber=le,this.startColumn=Q,this.endLineNumber=Ee,this.endColumn=he}}e.$2I=d;class l extends d{constructor(le,Q,Ee){super(le,Q,le,Ee)}}e.$3I=l;var c;(function(J){J.List="list",J.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function E(J,le=!0){const Q=J&&J.files&&J.files.exclude,Ee=le&&J&&J.search&&J.search.exclude;if(!Q&&!Ee)return;if(!Q||!Ee)return Q||Ee;let he=Object.create(null);return he=g.$dn(he,g.$an(Q)),he=g.$dn(he,g.$an(Ee),!0),he}e.$4I=E;function I(J,le){return J.excludePattern&&T.$Bj(J.excludePattern,le)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&T.$Bj(J.includePattern,le)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(Q=>{const Ee=Q.folder.fsPath;if(R.$2f(le,Ee)){const he=y.$kc(Ee,le);return!Q.includePattern||!!T.$Bj(Q.includePattern,he)}else return!1}):!1:!0}e.$5I=I;var f;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class p extends Error{constructor(le,Q){super(le),this.code=Q}}e.$6I=p;function k(J){const le=J.message;if((0,m.$3)(J))return new p(le,f.canceled);try{const Q=JSON.parse(le);return new p(Q.message,Q.code)}catch{return new p(le,f.other)}}e.$7I=k;function P(J){const le={message:J.message,code:J.code};return new Error(JSON.stringify(le))}e.$8I=P;function j(J){return J.type==="error"?!0:J.type==="success"}e.$9I=j;function z(J){return J.type==="success"}e.$0I=z;function M(J){return!!J.path}e.$$I=M;function F(J,le){const Q=J.searchPath?J.searchPath:J.relativePath;return(0,L.$sf)(Q,le)}e.$_I=F;class N{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$aJ=N;function O(J,le){const Q={...J||{},...le||{}};return Object.keys(Q).filter(Ee=>{const he=Q[Ee];return typeof he=="boolean"&&he})}e.$bJ=O;class W{constructor(le,Q){this.c=null,this.a={...le.excludePattern||{},...Q.excludePattern||{}},this.b=T.$Cj(this.a);let Ee=le.includePattern;Q.includePattern&&(Ee?Ee={...Ee,...Q.includePattern}:Ee=Q.includePattern),Ee&&(this.c=T.$Cj(Ee))}matchesExcludesSync(le,Q,Ee){return!!(this.b&&this.b(le,Q,Ee))}includedInQuerySync(le,Q,Ee){return!(this.b&&this.b(le,Q,Ee)||this.c&&!this.c(le,Q,Ee))}includedInQuery(le,Q,Ee){const he=this.b(le,Q,Ee),K=()=>this.c?!!this.c(le,Q,Ee):!0;return(0,C.$Kg)(he)?he.then(U=>U?!1:K()):K()}hasSiblingExcludeClauses(){return x(this.a)}}e.$cJ=W;function x(J){for(const le in J)if(typeof J[le]!="boolean")return!0;return!1}function ce(J){if(!J)return;let le;return Q=>(le||(le=(J()||Promise.resolve([])).then(Ee=>Ee?G(Ee):{})),le.then(Ee=>!!Ee[Q]))}e.$dJ=ce;function Y(J){if(!J)return;let le;return Q=>{if(!le){const Ee=J();le=Ee?G(Ee):{}}return!!le[Q]}}e.$eJ=Y;function G(J){const le={};for(const Q of J)le[Q]=!0;return le}}),define(ke[41],Se([1,0,19,12,21,4,3,77,17,123,23,13,2,222,5,14,253,40,57,27,20,15,7,66,36,6,54]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0;function h(z,M,F){return new A.$og(N=>p(N,F)).isEqual(z,M)}function E(z,M,F){return h(z.uri,M.uri,F)?0:(0,C.$Ye)(z.uri.toString(),M.uri.toString())}function I(z,M,F){return z.index!==M.index?z.index<M.index?-1:1:h(z.uri,M.uri,F)?(0,C.$Ye)(z.name,M.name):(0,C.$Ye)(z.uri.toString(),M.uri.toString())}function f(z,M,F,N){const O=z.slice(0).sort((x,ce)=>F(x,ce,N)),W=M.slice(0).sort((x,ce)=>F(x,ce,N));return(0,D.$Db)(O,W,(x,ce)=>F(x,ce,N))}function p(z,M){const F=M.getCapabilities(z.scheme);return!(F&&F&1024)}class k extends o.$ci{static toExtHostWorkspace(M,F,N,O){if(!M)return{workspace:null,added:[],removed:[]};const{id:W,name:x,folders:ce,configuration:Y,transient:G,isUntitled:J}=M,le=[],Q=F;F?ce.forEach((U,ie)=>{const be=$.URI.revive(U.uri),H=k.o(N||F,be,O);H?(H.name=U.name,H.index=U.index,le.push(H)):le.push({uri:be,name:U.name,index:ie})}):le.push(...ce.map(({uri:U,name:ie,index:be})=>({uri:$.URI.revive(U),name:ie,index:be}))),le.sort((U,ie)=>U.index<ie.index?-1:1);const Ee=new k(W,x,le,!!G,Y?$.URI.revive(Y):null,!!J,U=>p(U,O)),{added:he,removed:K}=f(Q?Q.workspaceFolders:[],Ee.workspaceFolders,E,O);return{workspace:Ee,added:he,removed:K}}static o(M,F,N){for(let O=0;O<M.folders.length;O++){const W=M.workspaceFolders[O];if(h(W.uri,F,N))return W}}constructor(M,F,N,O,W,x,ce){super(M,N.map(Y=>new o.$di(Y)),O,W,ce),this.t=F,this.u=x,this.q=[],this.s=b.$2h.forUris(ce),N.forEach(Y=>{this.q.push(Y),this.s.set(Y.uri,Y)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,F){return F&&this.s.get(M)&&(M=(0,A.$yg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let P=class{constructor(M,F,N,O,W){this.c=new R.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Td,this.B=new Map,this.h=O,this.s=N,this.t=W,this.j=new m.$Wl,this.k=new T.$Wg,this.o=M.getProxy(l.$xK.MainThreadWorkspace),this.q=M.getProxy(l.$xK.MainThreadMessageService);const x=F.workspace;this.l=x?new k(x.id,x.name,[],!!x.transient,x.configuration?$.URI.revive(x.configuration):null,!!x.isUntitled,ce=>p(ce,N)):void 0}$initializeWorkspace(M,F){this.v=F,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:y.Schemas.untitled,path:(0,A.$wg)((0,A.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,F,N,...O){const W=[];if(Array.isArray(O)&&O.forEach(J=>{$.URI.isUri(J.uri)&&!W.some(le=>h(le.uri,J.uri,this.s))&&W.push({uri:J.uri,name:J.name||(0,A.$vg)(J.uri)})}),this.n||[F,N].some(J=>typeof J!="number"||J<0)||N===0&&W.length===0)return!1;const x=this.x?this.x.workspaceFolders:[];if(F+N>x.length)return!1;const ce=x.slice(0);ce.splice(F,N,...W.map(J=>({uri:J.uri,name:J.name||(0,A.$vg)(J.uri),index:void 0})));for(let J=0;J<ce.length;J++){const le=ce[J];if(ce.some((Q,Ee)=>Ee!==J&&h(le.uri,Q.uri,this.s)))return!1}ce.forEach((J,le)=>J.index=le);const{added:Y,removed:G}=f(x,ce,I,this.s);if(Y.length===0&&G.length===0)return!1;if(this.o){const J=M.displayName||M.name;this.o.$updateWorkspaceFolders(J,F,N,W).then(void 0,le=>{this.n=void 0;const Q={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(u.Severity.Error,(0,v.localize)(0,null,J,le.toString()),Q,[])})}return this.y(ce),!0}getWorkspaceFolder(M,F){if(this.x)return this.x.getWorkspaceFolder(M,F)}async getWorkspaceFolder2(M,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,F)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,F){let N,O="";if(typeof M=="string"?(N=$.URI.file(M),O=M):typeof M<"u"&&(N=M,O=M.fsPath),!N)return O;const W=this.getWorkspaceFolder(N,!0);if(!W)return O;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let x=(0,A.$Bg)(W.uri,N);return F&&W.name&&(x=`${W.name}/${x}`),x}y(M){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:F,added:N,removed:O}=k.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:O}))}findFiles(M,F,N,O,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let x;if(F===null?x=!1:F&&(typeof F=="string"?x=F:x=F.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ce,folder:Y}=j(a.GlobPattern.from(M));return this.o.$startFileSearch(ce??null,Y??null,x??null,N??null,W).then(G=>Array.isArray(G)?G.map(J=>$.URI.revive(J)):[])}async findTextInFiles(M,F,N,O,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const x=this.j.getNext(),ce=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:Y,folder:G}=j(a.GlobPattern.from(F.include)),J=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,le={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:ce,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:Y,excludePattern:J},Q=!1;if(this.u[x]=Ee=>{if(Q)return;const he=$.URI.revive(Ee.resource);Ee.results.forEach(K=>{const U=(0,c.$sh)(K);(0,d.$WI)(U)?N({uri:he,preview:{text:U.preview.text,matches:(0,D.$1b)(U.preview.matches,ie=>new t.$BK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,D.$1b)(U.ranges,ie=>new t.$BK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):N({uri:he,text:U.text,lineNumber:U.lineNumber})})},W.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(M,G??null,le,x,W);return delete this.u[x],Ee||{}}catch(Ee){throw delete this.u[x],Ee}}$handleTextSearchResult(M,F){this.u[F]?.(M)}async save(M){const F=await this.o.$save(M,{saveAs:!1});return $.URI.revive(F)}async saveAs(M){const F=await this.o.$save(M,{saveAs:!0});return $.URI.revive(F)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,F){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,F);const N=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,N),(0,L.$Pc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(M,F){this.h.info("Getting edit session identifier for workspaceFolder",M);const N=await this.resolveWorkspaceFolder($.URI.revive(M));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const O=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!O),!O)return;const W=await O.provideEditSessionIdentity(N,F);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(M,F,N,O){this.h.info("Getting edit session identifier for workspaceFolder",M);const W=await this.resolveWorkspaceFolder($.URI.revive(M));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const x=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!x),!x)return;const ce=await x.provideEditSessionIdentityMatch?.(F,N,O);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(M){return(F,N,O)=>{const W=function(ce){F.call(N,ce)};return W.extension=M,this.A.event(W,void 0,O)}}async $onWillCreateEditSessionIdentity(M,F,N){const O=await this.resolveWorkspaceFolder($.URI.revive(M));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},F,async(W,x)=>{const ce=Date.now();await Promise.resolve(W),Date.now()-ce>N&&this.h.warn("SLOW edit session create-participant",x.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(M,F){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,F);const N=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerCanonicalUriProvider(O,N),(0,L.$Pc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(M,F,N){const O=this.B.get(M.scheme);if(!O)return;const W=await O.provideCanonicalUri?.($.URI.revive(M),F,N);if(W)return W}async $provideCanonicalUri(M,F,N){return this.provideCanonicalUri($.URI.revive(M),{targetScheme:F},N)}};e.$pec=P,e.$pec=P=He([Be(0,r.$zM),Be(1,n.$PM),Be(2,i.$8dc),Be(3,w.$dj),Be(4,s.$nec)],P),e.$qec=(0,S.$Vh)("IExtHostWorkspace");function j(z){let M,F;return z&&(typeof z=="string"?M=z:(M=z.pattern,F=$.URI.revive(z.baseUri))),{includePattern:M,folder:F}}}),define(ke[42],Se([1,0,24,4,41,6,7,255,86,18,12,5,20,14,2]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=e.$rec=void 0;function w(s,d){if(d){const l=d.split(".");let c=s;for(let h=0;c&&h<l.length;h++)c=c[l[h]];return c}}function u(s){return s instanceof S.URI}function o(s){return s&&s.uri instanceof S.URI&&s.languageId&&typeof s.languageId=="string"}function i(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&s.uri instanceof S.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function r(s){if(u(s))return{resource:s};if(o(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(i(s))return{overrideIdentifier:s.languageId};if(n(s))return{resource:s.uri};if(s===null)return{resource:null}}let a=class{constructor(d,l,c){this.a=d.getProxy(R.$xK.MainThreadConfiguration),this.c=l,this.b=c,this.d=new A.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(d,l))}};e.$rec=a,e.$rec=a=He([Be(0,$.$zM),Be(1,g.$qec),Be(2,v.$dj)],a);class t{constructor(d,l,c,h){this.a=new T.$Rd,this.b=d,this.f=h,this.c=l,this.e=b.$Kn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Kn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(d,l,c){const h=r(l)||{},E=this.g(d?w(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,c?.identifier);function I(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(p){return typeof w(E,p)<"u"},get:(p,k)=>{this.h(d?`${d}.${p}`:p,h,c?.identifier);let P=w(E,p);if(typeof P>"u")P=k;else{let j;const z=(M,F)=>{if((0,m.$Ef)(M)){let N;const O=()=>{j=j||(0,D.$an)(E),N=N||w(j,F)};return new Proxy(M,{get:(W,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return O(),()=>N;if(j)return N=N||w(j,F),N[x];const ce=W[x];return typeof x=="string"?z(ce,`${F}.${x}`):ce},set:(W,x,ce)=>(O(),N&&(N[x]=ce),!0),deleteProperty:(W,x)=>(O(),N&&delete N[x],!0),defineProperty:(W,x,ce)=>(O(),N&&Object.defineProperty(N,x,ce),!0)})}return Array.isArray(M)?(0,D.$an)(M):M};P=z(P,p)}return P},update:(p,k,P,j)=>{p=d?`${d}.${p}`:p;const z=I(P);return k!==void 0?this.b.$updateConfigurationOption(z,p,k,h,j):this.b.$removeConfigurationOption(z,p,h,j)},inspect:p=>{p=d?`${d}.${p}`:p;const k=this.e.inspect(p,h,this.c.workspace);if(k)return{key:p,defaultValue:(0,D.$an)(k.policy?.value??k.default?.value),globalValue:(0,D.$an)(k.user?.value??k.application?.value),workspaceValue:(0,D.$an)(k.workspace?.value),workspaceFolderValue:(0,D.$an)(k.workspaceFolder?.value),defaultLanguageValue:(0,D.$an)(k.default?.override),globalLanguageValue:(0,D.$an)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,D.$an)(k.workspace?.override),workspaceFolderLanguageValue:(0,D.$an)(k.workspaceFolder?.override),languageIds:(0,D.$an)(k.overrideIdentifiers)}}};return typeof E=="object"&&(0,D.$dn)(f,E,!1),Object.freeze(f)}g(d){const l=c=>(0,m.$Ef)(c)?new Proxy(c,{get:(h,E)=>l(h[E]),set:(h,E,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(h,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(h,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(d)}h(d,l,c){const h=y.$Bn.test(d)?4:this.d.get(d),E=c?`[${c.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const c=new b.$Mn(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,E)=>c.affectsConfiguration(h,r(E))})}k(d){return d.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.$sec=t,e.$tec=(0,C.$Vh)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,12,4,6,7,41,69,42,21,46,20,27,5,17,11,14,91,303,8]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=e.$Vfc=e.$Ufc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(z){function M(N){if(N!=null)return N}z.from=M;function F(N){if(N!=null)return N}z.to=F})(a||(a={}));var t;(function(z){function M(N){if(N!=null)return N}z.from=M;function F(N){if(N!=null)return N}z.to=F})(t||(t={}));var s;(function(z){function M(N){if(N!=null)return N}z.from=M;function F(N){if(N!=null)return N}z.to=F})(s||(s={}));var d;(function(z){function M(O){if(O){const W=O;return W&&!!W.process}else return!1}z.is=M;function F(O){if(O==null)return;const W={process:O.process,args:O.args};return O.options&&(W.options=s.from(O.options)),W}z.from=F;function N(O){if(O!=null)return new L.$hL(O.process,O.args,O.options)}z.to=N})(d||(d={}));var l;(function(z){function M(N){if(N!=null)return N}z.from=M;function F(N){if(N!=null)return N}z.to=F})(l||(l={}));var c;(function(z){function M(O){if(O){const W=O;return W&&(!!W.commandLine||!!W.command)}else return!1}z.is=M;function F(O){if(O==null)return;const W={};return O.commandLine!==void 0?W.commandLine=O.commandLine:(W.command=O.command,W.args=O.args),O.options&&(W.options=l.from(O.options)),W}z.from=F;function N(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new L.$iL(O.commandLine,O.options):new L.$iL(O.command,O.args?O.args:[],O.options)}z.to=N})(c||(c={}));var h;(function(z){function M(O){if(O){const W=O;return W&&W.customExecution==="customExecution"}else return!1}z.is=M;function F(O){return{customExecution:"customExecution"}}z.from=F;function N(O,W){return W.get(O)}z.to=N})(h||(e.CustomExecutionDTO=h={}));var E;(function(z){function M(F,N){let O;return F.scope!==void 0&&typeof F.scope!="number"?O=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===L.TaskScope.Workspace&&N&&N.workspaceFile?O=N.workspaceFile:O=n.$8F),{id:F._id,workspaceFolder:O}}z.from=M})(E||(e.TaskHandleDTO=E={}));var I;(function(z){function M(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}z.from=M})(I||(I={}));var f;(function(z){function M(O,W){if(O==null)return[];const x=[];for(const ce of O){const Y=F(ce,W);Y&&x.push(Y)}return x}z.fromMany=M;function F(O,W){if(O==null)return;let x;O.execution instanceof L.$hL?x=d.from(O.execution):O.execution instanceof L.$iL?x=c.from(O.execution):O.execution&&O.execution instanceof L.$jL&&(x=h.from(O.execution));const ce=a.from(O.definition);let Y;return O.scope?typeof O.scope=="number"?Y=O.scope:Y=O.scope.uri:Y=L.TaskScope.Workspace,!ce||!Y?void 0:{_id:O._id,definition:ce,name:O.name,source:{extensionId:W.identifier.value,label:O.source,scope:Y},execution:x,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=F;async function N(O,W,x){if(O==null)return;let ce;d.is(O.execution)?ce=d.to(O.execution):c.is(O.execution)?ce=c.to(O.execution):h.is(O.execution)&&(ce=h.to(O._id,x));const Y=a.to(O.definition);let G;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?G=O.source.scope:G=await W.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):G=L.TaskScope.Workspace),!Y||!G)return;const J=new L.$kL(Y,G,O.name,O.source.label,ce,O.problemMatchers);return O.isBackground!==void 0&&(J.isBackground=O.isBackground),O.group!==void 0&&(J.group=L.$gL.from(O.group._id),J.group&&O.group.isDefault&&(J.group=new L.$gL(J.group.id,J.group.label),O.group.isDefault===!0&&(J.group.isDefault=O.group.isDefault))),O.presentationOptions&&(J.presentationOptions=t.to(O.presentationOptions)),O._id&&(J._id=O._id),O.detail&&(J.detail=O.detail),J}z.to=N})(f||(e.TaskDTO=f={}));var p;(function(z){function M(N){return N}z.from=M;function F(N){if(N)return Object.assign(Object.create(null),N)}z.to=F})(p||(p={}));class k{#e;constructor(M,F,N){this._id=F,this.a=N,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let P=class{constructor(M,F,N,O,W,x,ce,Y){this.q=new g.$Rd,this.r=new g.$Rd,this.s=new g.$Rd,this.t=new g.$Rd,this.a=M.getProxy(R.$xK.MainThreadTask),this.b=N,this.c=O,this.d=W,this.e=x,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=Y,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,F,N){if(!N)return new L.$zK(()=>{});const O=this.w();return this.j.set(O,{type:F,provider:N,extension:M}),this.a.$registerTaskProvider(O,F),new L.$zK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(M,F){this.a.$registerTaskSystem(M,F)}fetchTasks(M){return this.a.$fetchTasks(p.from(M)).then(async F=>{const N=[];for(const O of F){const W=await f.to(O,this.b,this.m);W&&N.push(W)}return N})}get taskExecutions(){const M=[];return this.k.forEach(F=>M.push(F)),M}terminateTask(M){if(!(M instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,F,N){const O=this.m.get(M.id);O&&(this.o.set(M.id,O),this.e.attachPtyToTerminal(F,await O.callback(N))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const F=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const F=await this.y(M.id);this.s.fire({execution:F,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const F=await this.y(M.id);this.t.fire({execution:F,exitCode:M.exitCode})}$provideTasks(M,F){const N=this.j.get(M);if(!N)return Promise.reject(new Error("no handler found"));const O=[],W=(0,T.$Qg)(()=>N.provider.provideTasks(A.CancellationToken.None)).then(x=>this.u(F,O,N,x));return new Promise(x=>{W.then(ce=>{Promise.all(O).then(()=>{x(ce)})})})}async $resolveTask(M,F){const N=this.j.get(M);if(!N)return Promise.reject(new Error("no handler found"));if(F.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${N.type}].`);const O=await f.to(F,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const W=await N.provider.resolveTask(O,A.CancellationToken.None);if(!W)return;this.z(W,N);const x=f.from(W,N.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(x.execution)&&await this.x(x,W,!0),await this.v(x)}w(){return this.h++}async x(M,F,N){const O=await this.a.$createTaskId(M);!N&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,F.execution)),this.m.set(O,F.execution)}async y(M,F){if(typeof M=="string"){const W=this.l.get(M);if(!W)throw new r.$ab("Unexpected: The specified task is missing an execution");return W}const N=this.l.get(M.id);if(N)return N;const O=new Promise((W,x)=>{function ce(Y,G,J){J?W(new k(Y,G.id,J)):x("Unexpected: Task does not exist.")}F?ce(this,M,F):f.to(M.task,this.b,this.m).then(Y=>ce(this,M,Y))});return this.l.set(M.id,O),O.then(W=>(this.k.set(M.id,W),W),W=>Promise.reject(W))}z(M,F){M._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const N=this.n.values();let O=N.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=N.next()}};e.$Ufc=P,e.$Ufc=P=He([Be(0,$.$zM),Be(1,v.$PM),Be(2,b.$qec),Be(3,y.$KM),Be(4,m.$tec),Be(5,C.$Rec),Be(6,o.$dj),Be(7,i.$$dc)],P);let j=class extends P{constructor(M,F,N,O,W,x,ce,Y){super(M,F,N,O,W,x,ce,Y),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:u.$h(0)})}async executeTask(M,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const N=f.from(F,M);if(N===void 0)throw new Error("Task is not valid");if(h.is(N.execution))await this.x(N,F,!1);else throw new r.$$;const O=await this.y(await this.a.$getTaskExecution(N),F);return this.a.$executeTask(N).catch(W=>{throw new Error(W)}),O}u(M,F,N,O){const W=[];if(O)for(const x of O){if(this.z(x,N),!x.definition||!M[x.definition.type]){const Y=x.source?x.source:"No task source";this.f.warn(`The task [${Y}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=f.from(x,N.extension);ce&&h.is(ce.execution)?(W.push(ce),F.push(this.x(ce,x,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:N.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,F,N){}};e.$Vfc=j,e.$Vfc=j=He([Be(0,$.$zM),Be(1,v.$PM),Be(2,b.$qec),Be(3,y.$KM),Be(4,m.$tec),Be(5,C.$Rec),Be(6,o.$dj),Be(7,i.$$dc)],j),e.$Wfc=(0,S.$Vh)("IExtHostTask")}),define(ke[359],Se([1,0,36,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mJ=e.$lJ=e.$kJ=void 0;function g(L){return"cellResults"in L}e.$kJ=g,e.$lJ="rawCell#";function R(L,b){let y=-1;const m=[];let A=[];return L.forEach($=>{$.range.startLineNumber!==y&&A.length>0&&(m.push([...A]),A=[]),A.push($),y=$.range.endLineNumber}),A.length>0&&m.push([...A]),m.map($=>{const v=[],S=$[0].range.startLineNumber,w=$[$.length-1].range.endLineNumber;for(let u=S;u<=w;u++)v.push(b.getLineContent(u));return new D.$1I(v.join(`
`)+`
`,$.map(u=>new T.$zs(u.range.startLineNumber-1,u.range.startColumn-1,u.range.endLineNumber-1,u.range.endColumn-1)))})}e.$mJ=R}),define(ke[360],Se([1,0,215,22,4,3,28,13,18,2,32,110,6,35,15,7,68,295,148,8,24,17,287,359,356]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class l{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,E,I,f,p,k){this.q=I,this.r=f,this.s=p,this.t=k,this.f=new Map,this.g=new L.$zc,this.h=new Map,this.j=new g.$Rd({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Rd({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Rd({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Rd({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$4dc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy($.$xK.MainThreadNotebook),this.c=h.getProxy($.$xK.MainThreadNotebookDocuments),this.d=h.getProxy($.$xK.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===13){const j=P.notebookEditor?.notebookUri,z=P.cell.handle,F=this.g.get(j)?.getCell(z);if(F)return F.apiCell}if(P&&P.$mid===14){const j=P.uri,z=this.g.get(j);if(z)return z.apiNotebook}return P}}),l.B(E)}getEditorById(h){const E=this.h.get(h);if(!E)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(h){for(const[E,I]of this.h)if(I.apiEditor===h)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,E){const I=this.g.get(h);if(!I&&!E)throw new Error(`NO notebook document for '${h}'`);return I}static u(h,E){if(!E)return;const I=E.filenamePattern.map(f=>S.NotebookExclusiveDocumentPattern.from(f)).filter(f=>f!==void 0);if(E.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:E.displayName,filenamePattern:I,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,E,I){const f=l.a++,p=typeof I.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(f,I),this.b.$registerNotebookCellStatusBarItemProvider(f,p,E);let k;return p!==void 0&&(k=I.onDidChangeCellStatusBarItems(P=>this.b.$emitCellStatusBarEvent(p))),new w.$zK(()=>{this.f.delete(f),this.b.$unregisterNotebookCellStatusBarItemProvider(f,p),k?.dispose()})}async createNotebookDocument(h){const E=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&S.NotebookData.from(h.content)});return m.URI.revive(E)}async openNotebookDocument(h){const E=this.g.get(h);if(E)return E.apiNotebook;const I=await this.c.$tryOpenNotebook(h),f=this.g.get(m.URI.revive(I));return(0,y.$Nf)(f?.apiNotebook)}async showNotebookDocument(h,E){m.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let I;typeof E=="object"?I={position:S.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(S.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:I={preserveFocus:!1};const f=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,I),p=f&&this.h.get(f)?.apiEditor;if(p)return p;throw f?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,E,I,f){const p=this.f.get(h),k=m.URI.revive(E),P=this.g.get(k);if(!P||!p)return;const j=P.getCellFromIndex(I);if(!j)return;const z=await p.provideCellStatusBarItems(j.apiCell,f);if(!z)return;const M=new R.$Qc,F=this.p.add([M]),O=(Array.isArray(z)?z:[z]).map(W=>S.NotebookStatusBarItem.from(W,this.i,M));return{cacheId:F,items:O}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,E,I,f,p){if((0,b.$Fe)(E))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:E,serializer:I,options:f}),this.b.$registerNotebookSerializer(k,{id:h.identifier,location:h.extensionLocation},E,S.NotebookDocumentContentOptions.from(f),l.u(h,p)),(0,R.$Pc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(h,E,I){const f=this.x.get(h);if(!f)throw new Error("NO serializer found");const p=await f.serializer.deserializeNotebook(E.buffer,I);return new u.$wv(S.NotebookData.from(p))}async $notebookToData(h,E,I){const f=this.x.get(h);if(!f)throw new Error("NO serializer found");const p=await f.serializer.serializeNotebook(S.NotebookData.to(E.value),I);return T.$fe.wrap(p)}async $saveNotebook(h,E,I,f,p){const k=m.URI.revive(E),P=this.x.get(h);if(!P)throw new Error("NO serializer found");const j=this.g.get(k);if(!j)throw new Error("Document NOT found");if(j.versionId!==I)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$zk((0,D.localize)(0,null,this.z(k)),6);await this.y(k,f);const z={metadata:(0,r.$in)(j.apiNotebook.metadata,W=>!(P.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of j.apiNotebook.getCells()){const x=new w.$XL(W.kind,W.document.getText(),W.document.languageId,W.mime,P.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);x.metadata=(0,r.$in)(W.metadata,ce=>!(P.options?.transientCellMetadata??{})[ce]),z.cells.push(x)}const M=await P.serializer.serializeNotebook(z,p);await this.s.value.writeFile(k,M);const F=this.s.getFileSystemProviderExtUri(k.scheme),N=await this.s.value.stat(k);return{name:F.basename(k),isFile:(N.type&A.FileType.File)!==0,isDirectory:(N.type&A.FileType.Directory)!==0,isSymbolicLink:(N.type&A.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((N.permissions??0)&A.FilePermission.Locked),etag:A.$Kk({mtime:N.mtime,size:N.size}),children:void 0}}async $searchInNotebooks(h,E,I,f,p){const k=this.x.get(h)?.serializer;if(!k)return{limitHit:!1,results:[]};const P=new L.$Ac;await(async(N,O,W)=>{await Promise.all(N.map(async x=>await Promise.all(x.filenamePatterns.map(ce=>{const Y={...W,type:1,filePattern:ce};return this.t.doInternalFileSearchWithCustomCallback(Y,O,G=>{G.forEach(J=>{P.has(J)||f.some(Q=>x.isFromSettings&&!Q.isFromSettings?!1:Q.filenamePatterns.some(Ee=>(0,d.$Xbb)(Ee,J)))||P.add(J)})})}))))})(I,p,E);const z=new L.$zc;let M=!1;const F=Array.from(P).map(async N=>{const O=[];try{if(p.isCancellationRequested)return;if(E.maxResults&&[...z.values()].reduce((Y,G)=>Y+G.cellResults.length,0)>E.maxResults){M=!0;return}const W=[],x=this.g.get(N);if(x)x.apiNotebook.getCells().forEach(G=>W.push({input:G.document.getText(),outputs:G.outputs.flatMap(J=>J.items.map(le=>le.data.toString()))}));else{const Y=await this.s.value.readFile(N),G=T.$fe.fromString(Y.toString()),J=await k.deserializeNotebook(G.buffer,p);if(p.isCancellationRequested)return;S.NotebookData.from(J).cells.forEach(Q=>W.push({input:Q.source,outputs:Q.outputs.flatMap(Ee=>Ee.items.map(he=>he.valueBytes.toString()))}))}if(p.isCancellationRequested)return;W.forEach((Y,G)=>{const J=E.contentPattern.pattern,le=new t.$$Ob(Y.input,void 0,Y.outputs),Q=le.findInInputs(J),Ee=le.findInOutputs(J),he=Ee.flatMap(K=>(0,s.$mJ)(K.matches,K.textBuffer)).map((K,U)=>(K.webviewIndex=U,K));if(Q.length>0||Ee.length>0){const K={index:G,contentResults:(0,s.$mJ)(Q,le.inputTextBuffer),webviewResults:he};O.push(K)}});const ce={resource:N,cellResults:O};z.set(N,ce);return}catch{return}});return await Promise.all(F),{limitHit:M,results:[...z.values()]}}async y(h,E){const I=await this.s.value.stat(h);if(typeof E?.mtime=="number"&&typeof E.etag=="string"&&E.etag!==A.$Jk&&typeof I.mtime=="number"&&typeof I.size=="number"&&E.mtime<I.mtime&&E.etag!==A.$Kk({mtime:E.mtime,size:I.size}))throw new A.$zk((0,D.localize)(1,null),3,E)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,E,I){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const f=new i.$nfc(E,this.d,h,I.visibleRanges.map(S.NotebookRange.to),I.selections.map(S.NotebookRange.to),typeof I.viewColumn=="number"?S.ViewColumn.to(I.viewColumn):void 0);this.h.set(E,f)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const I of h.value.removedDocuments){const f=m.URI.revive(I),p=this.g.get(f);p&&(p.dispose(),this.g.delete(f),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(p.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===f.toString()&&this.h.delete(k.id)}if(h.value.addedDocuments){const I=[];for(const f of h.value.addedDocuments){const p=m.URI.revive(f.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const k=new o.$mfc(this.c,this.q,this.r,p,f);I.push(...f.cells.map(P=>o.$lfc.asModelAddData(k.apiNotebook,P))),this.g.get(p)?.dispose(),this.g.set(p,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this.m.fire(k.apiNotebook)}}if(h.value.addedEditors)for(const I of h.value.addedEditors){if(this.h.has(I.id))return;const f=m.URI.revive(I.documentUri),p=this.g.get(f);p&&this.A(p,I.id,I)}const E=[];if(h.value.removedEditors)for(const I of h.value.removedEditors){const f=this.h.get(I);f&&(this.h.delete(I),this.k?.id===f.id&&(this.k=void 0),E.push(f))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(f=>this.h.get(f)).filter(f=>!!f);const I=new Set;this.l.forEach(f=>I.add(f.id));for(const f of this.h.values()){const p=I.has(f.id);f._acceptVisibility(p)}this.l=[...this.h.values()].map(f=>f).filter(f=>f.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const E=v.$XM.String.with("notebookType","A notebook type"),I=new v.$ZM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new v.$XM("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>T.$fe.wrap(p))],new v.$YM("Notebook Data",p=>S.NotebookData.to(p.value))),f=new v.$ZM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new v.$XM("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new u.$wv(S.NotebookData.from(p)))],new v.$YM("Bytes",p=>p.buffer));h.registerApiCommand(I),h.registerApiCommand(f)}}e.$wfc=l}),define(ke[361],Se([1,0,16,21,43,34,23,38,36]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class m{constructor($,v,S){this.k=$,this.l=v,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$Cj($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$Cj($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const v=this.k.folderQueries||[];return new Promise((S,w)=>{const u=o=>{this.f++,$(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=D.$mc(i);this.j&&this.j(i,n)||this.v(u,{base:o,basename:n})}),Promise.all(v.map(o=>this.p(o,u))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{w(new Error((0,g.$Gi)(o)))})})}async p($,v){const S=new T.$2d,w=this.q($),u=this.r(),o=new y.$cJ(this.k,$),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=b.$Nd.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},w,S.token),a=n.elapsed(),t=b.$Nd.create();return this.g&&!this.e||(r&&r.forEach(s=>{const d=D.$fc.relative($.folder.path,s.path);if(i){const l=D.$mc(s.path);this.v(v,{base:$.folder,relativePath:d,basename:l});return}this.s(u,$.folder,d,v)}),this.g&&!this.e)?null:(this.u(u,o,v),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q($){const v=(0,y.$bJ)(this.k.includePattern,$.includePattern),S=(0,y.$bJ)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:S,includes:v,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},v,S,w){if(S===this.a){const o=D.$mc(this.a);this.v(w,{base:v,relativePath:this.a,basename:o})}function u(o){const i=D.$mc(o),n=D.$lc(o);let r=$[n];r||(r=$[n]=[],u(n)),r.push({base:v,relativePath:o,basename:i})}u(S)}u({rootEntries:$,pathToEntries:v},S,w){const u=this,o=this.a;function i(n){const r=(0,y.$eJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const s=n[a],{relativePath:d,basename:l}=s;if(S.matchesExcludesSync(d,l,o!==l?r:void 0))continue;const c=v[d];if(c)i(c);else{if(d===o)continue;u.v(w,s)}if(u.e)break}}i($)}v($,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,v,S,w){const u=this.c($.cacheKey),o=new m($,v,u&&u.token);let i=0;const n=r=>{i+=r.length,S(r.map(a=>this.d(a)))};return this.e(o,A.a,n,w).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new T.$2d),this.b.get($)}d($){return $.relativePath?{resource:L.$zg($.base,$.relativePath)}:{resource:$.base}}e($,v,S,w){const u=w.onCancellationRequested(()=>{$.cancel()}),o=n=>{n&&(i.push(n),v>0&&i.length>=v&&(S(i),i=[]))};let i=[];return $.search(o).then(n=>(i.length&&S(i),u.dispose(),n),n=>(i.length&&S(i),u.dispose(),Promise.reject(n)))}}e.$ofc=A}),define(ke[362],Se([1,0,19,73,34,102,28,17,16,23,13,18,2,99,236,44,14,40,145,357,36]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.$bK=void 0;let a=class{constructor(p,k,P,j,z){this.a=p,this.b=k,this.c=P,this.d=j,this.e=z}text(p,k,P={}){p=this.f(p,P);const j=this.a.getValue(),z=k&&k.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(k?.map(o.$ei),P),type:2,contentPattern:p,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:j.search.usePCRE2||z||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(p,k){const P=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const j={...p,wordSeparators:P.editor.wordSeparators};return this.j(p,k)&&(j.isCaseSensitive=!0),this.k(p)&&(j.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),j}file(p,k={}){return{...this.h(p,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(p,k){return p?(p=Array.isArray(p)?p.map(c):c(p),k?this.parseSearchPaths(p):{pattern:s(...Array.isArray(p)?p:[p])}):{}}h(p=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),j=this.g(k.excludePattern,k.expandPatterns),z=p.length>1,M=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,k,j)):p.map(O=>this.r(O,k,j,z))).filter(O=>!!O),F={_reason:k._reason,folderQueries:M,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:j.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const O=D.$Gb(D.$Qb(this.c.groups.map(ce=>ce.editors.map(Y=>Y.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const W=O.filter(ce=>(0,r.$5I)(F,ce.fsPath)),x=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...F,...x}}const N=k.extraFileResources&&k.extraFileResources.filter(O=>(0,r.$5I)(F,O.fsPath));return F.extraFileResources=N&&N.length?N:void 0,F}i(p){const k=[],P=new L.$zc,j={};let z=!1;return p.forEach(M=>{if(M.scheme===b.Schemas.walkThrough)return;if((0,m.$Dg)(M)){const N=this.b.getWorkspaceFolder(M)?.uri??M.with({path:y.$lc(M.fsPath)});let O=P.get(N);O||(z=!0,O={folder:N,includePattern:{}},k.push(O),P.set(N,O));const W=y.$kc(N.fsPath,M.fsPath);(0,C.$Nf)(O.includePattern)[W.replace(/\\/g,"/")]=!0}else M.fsPath&&(z=!0,j[M.fsPath]=!0)}),{folderQueries:k,includePattern:j,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(p,k){if(k.isSmartCase){if(p.isRegExp){if(A.$tf(p.pattern,!0))return!0}else if(A.$tf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.$CB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const k=x=>y.$hc(x)||/^\.\.?([\/\\]|$)/.test(x),j=(Array.isArray(p)?p:d(p)).map(x=>{const ce=this.e.resolvedUserHome;return ce?(0,R.$Bv)(x,ce.scheme===b.Schemas.file?ce.fsPath:ce.path):x}),z=T.$J(j,x=>k(x)?"searchPaths":"exprSegments"),M=(z.exprSegments||[]).map(x=>A.$Oe(x,"/")).map(x=>A.$Oe(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),l(x))),F={},N=this.m(z.searchPaths||[]);N&&N.length&&(F.searchPaths=N);const O=D.$Qb(M),W=s(...O);return W&&(F.pattern=W),F}l(p,k){return k.disregardExcludeSettings?void 0:(0,r.$4I)(p,!k.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const k=p.flatMap(j=>{let{pathPortion:z,globPortion:M}=t(j);return M&&(M=h(M)),this.n(z).flatMap(N=>this.o(N,M))}),P=new Map;return k.forEach(j=>{const z=j.searchPath.toString(),M=P.get(z);M?j.pattern&&(M.pattern=M.pattern||{},M.pattern[j.pattern]=!0):P.set(z,{searchPath:j.searchPath,pattern:j.pattern?s(j.pattern):void 0})}),Array.from(P.values())}n(p){if(y.$hc(p)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==b.Schemas.file?[{searchPath:k[0].uri.with({path:p})}]:[{searchPath:$.URI.file(y.$gc(p))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(p=c(p),p.startsWith("../")||p===".."){const j=y.$fc.resolve(k.path,p);return[{searchPath:k.with({path:j})}]}const P=h(p);return[{searchPath:k,pattern:P}]}else{if(p==="./"||p===".\\")return[];{const k=p.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(z=>{const M=k.match(new RegExp(`^${A.$Je(z.name)}(?:/(.*)|$)`));return M?{match:M,folder:z}:null}).filter(C.$Kf);if(j.length)return j.map(z=>{const M=z.match[1];return{searchPath:z.folder.uri,pattern:M&&h(M)}});{const z=p.match(/\.[\/\\](.+)[\/\\]?/),M=z?z[1]:p,F=S.localize(0,null,M);throw new Error(F)}}}}o(p,k){const P=p.pattern&&k?`${p.pattern}/${k}`:p.pattern||k,j=[{searchPath:p.searchPath,pattern:P}];return P&&!P.endsWith("**")&&j.push({searchPath:p.searchPath,pattern:P+"/**"}),j}q(p,k,P){const j=this.r((0,o.$ei)(p.searchPath),k,P,!1);return j?{...j,includePattern:p.pattern}:null}r(p,k,P,j){let z;const M=$.URI.isUri(p)?p:p.uri;if(P.searchPaths){const x=P.searchPaths.filter(ce=>(0,m.$sg)(ce.searchPath,M))[0];if(x&&!x.pattern)return null;x&&(z=x.pattern)}const F=this.a.getValue({resource:M}),O={...this.l(F,k)||{},...z||{}},W=$.URI.isUri(p)?(0,m.$wg)(p):p.name;return{folder:M,folderName:j?W:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!F.search.followSymlinks}}};e.$bK=a,e.$bK=a=He([Be(0,w.$pi),Be(1,o.$5h),Be(2,i.$GC),Be(3,u.$dj),Be(4,n.$_J)],a);function t(f){const p=f.match(/[\*\{\}\(\)\[\]\?]/);if(p){const k=p.index,P=f.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let j=f.substr(0,P.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:f.substr((P.index||0)+1)}}}return{pathPortion:f}}function s(...f){return f.length?f.reduce((p,k)=>(p[k]=!0,p),Object.create(null)):void 0}function d(f){return g.$Aj(f,",").map(p=>p.trim()).filter(p=>!!p.length)}function l(f){return[`**/${f}/**`,`**/${f}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function c(f){return f.replace(/\\/g,"/")}function h(f){return c(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(f){return f.replace(/([?*[\]])/g,"[$1]")}function I(f,p){f=D.$Lb(f,j=>j.toString());const k=[],P=p.getWorkspace();return f&&f.forEach(j=>{let z;if(p.getWorkbenchState()===2)z=(0,m.$Bg)(P.folders[0].uri,j),z&&z!=="."&&(z="./"+z);else{const M=p.getWorkspaceFolder(j);if(M){const F=M.name;if(P.folders.filter(O=>O.name===F).length===1){const O=(0,m.$Bg)(M.uri,j);O===""?z=`./${M.name}`:z=`./${M.name}/${O}`}else z=j.fsPath}}z&&k.push(E(z))}),k}e.$cK=I}),define(ke[363],Se([1,0,23,2,21,8,5,362,36,40]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erb=e.$drb=void 0;const A=7e3;function C(w,u){const o=u.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],n=[];for(const l of o)if(/^workspaceContains:/.test(l)){const c=l.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||w.forceUsingSearch?n.push(c):i.push(c)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let r;const a=new Promise((l,c)=>{r=l}),t=l=>r({activationEvent:l}),s=Promise.all(i.map(l=>$(w,l,t))).then(()=>{}),d=v(w,u.identifier,n,t);return Promise.all([s,d]).then(()=>{r(void 0)}),a}e.$drb=C;async function $(w,u,o){for(const i of w.folders)if(await w.exists(D.$zg(T.URI.revive(i),u))){o(`workspaceContains:${u}`);return}}async function v(w,u,o,i){if(o.length===0)return Promise.resolve(void 0);const n=new g.$2d,r=w.checkExists(w.folders,o,n.token),a=setTimeout(async()=>{n.cancel(),w.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},A);let t=!1;try{t=await r}catch(s){R.$3(s)||R.$Z(s)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${o.join(",")}`)}function S(w,u,o,i){const n=w.get(L.$Uh),r=w.get(y.$VI),t=n.createInstance(b.$bK).file(u.map(s=>(0,m.$ei)(T.URI.revive(s))),{_reason:"checkExists",includePattern:o,exists:!0});return r.fileSearch(t,i).then(s=>!!s.limitHit,s=>R.$3(s)?!1:Promise.reject(s))}e.$erb=S}),define(ke[47],Se([1,0,212,16,56,23,12,3,77,2,14,6,42,293,118,41,25,147,8,26,22,272,7,64,5,27,92,20,107,72,46,4,363,117,274,17,115,38,11,116]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s,d,l,c,h,E,I,f,p,k,P,j,z,M,F,N,O){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=e.$5ec=e.$4ec=e.$3ec=void 0,e.$3ec=(0,d.$Vh)("IHostUtils");let x=W=class extends b.$Rc{constructor(K,U,ie,be,H,_,Z,$e,re,fe,te,de){super(),this.X=de,this.a=this.B(new p.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ie,this.f=Z,this.j=be,this.m=H,this.s=_,this.t=re,this.u=fe,this.w=te,this.y=this.g.getProxy(C.$xK.MainThreadWorkspace),this.z=this.g.getProxy(C.$xK.MainThreadTelemetry),this.C=this.g.getProxy(C.$xK.MainThreadExtensionService),this.D=new L.$Wg,this.F=new L.$Wg,this.G=new L.$Wg,this.H=new L.$Wg,this.I=new Ee(this.f.extensions.activationEvents),this.L=new o.$f6b(this.I,this.f.extensions.allExtensions);const pe=new n.$am(this.f.extensions.myExtensions);this.J=new o.$f6b(this.I,le(this.L,pe)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${G(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${G(this.J)}`)),this.M=new S.$Nec(this.g,this.s),this.N=new P.$Vec(this.g),this.O=$e,this.h=K.createChild(new E.$Th([S.$Oec,this.M],[P.$Wec,this.N])),this.P=this.B(new v.$Mec(this.J,this.L,{onExtensionActivationError:(Pe,B,X)=>{this.C.$onExtensionActivationError(Pe,i.$2(B),X)},actualActivateExtension:async(Pe,B)=>{if(o.$f6b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new v.$Lec;const X=this.J.getExtensionDescription(Pe);return this.db(X,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$Z(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(H=>H.identifier).filter(H=>this.isActivated(H)).map(H=>this.cb(H))}catch{}await Promise.all(K)}terminate(K,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ie=this.Y();Promise.race([(0,L.$Yg)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const U=await this.C.$getExtension(K);return U&&{...U,identifier:new n.$_l(U.identifier.value),extensionLocation:m.URI.revive(U.extensionLocation)}}Z(K,U){return this.P.activateByEvent(K,U)}$(K,U){return this.P.activateById(K,U)}activateByIdWithErrors(K,U){return this.$(K,U).then(()=>{const ie=this.P.getActivatedExtension(K);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===z.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(K.fsPath);return m.URI.file(U)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new Q(K))),this.Q}async bb(K){const U=y.$2h.forUris(ie=>R.$qg.ignorePathCasing(ie));return await Promise.all(K.map(async ie=>{if(this.ub(ie)){const be=await this.ab(ie.extensionLocation);U.set(be,ie)}})),U}cb(K){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return U;const ie=this.P.getActivatedExtension(K);if(!ie)return U;try{typeof ie.module.deactivate=="function"&&(U=Promise.resolve(ie.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(be)}try{(0,b.$Mc)(ie.subscriptions)}catch(be){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(be)}return U}async db(K,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,U).then(ie=>{const be=ie.activationTimes;return this.C.$onDidActivateExtension(K.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,U),this.eb(K,U,"success",be),ie},ie=>{throw this.eb(K,U,"failure"),ie})}eb(K,U,ie,be){const H=Y(K,U);this.z.$publicLog2("extensionActivationTimes",{...H,...be||{},outcome:ie})}fb(K,U){const ie=Y(K,U);this.z.$publicLog2("activatePlugin",ie);const be=this.ub(K);if(!be)return Promise.resolve(new v.$Kec(v.$Hec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${K.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const H=new v.$Iec(U.startup);return Promise.all([this.vb(K,(0,R.$zg)(K.extensionLocation,be),H),this.gb(K)]).then(_=>(g.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),W.hb(this.s,K.identifier,_[0],_[1],H))).then(_=>(g.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),_))}gb(K){const U=new a.$Qec(K,this.M),ie=new a.$Pec(K.identifier.value,!1,this.M),be=new j.$Xec(K,this.N),H=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,_=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([U.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const Z=this;let $e,re;const fe=(0,u.$LF)(K,"ipc")?this.f.messagePorts?.get(n.$_l.toKey(K.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ie,secrets:be,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(te){return T.$ic(K.extensionLocation.fsPath,te)},get storagePath(){return Z.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return Z.O.globalValue(K).fsPath},get logPath(){return T.$ic(Z.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return m.URI.joinPath(Z.f.logsLocation,K.identifier.value)},get storageUri(){return Z.O.workspaceValue(K)},get globalStorageUri(){return Z.O.globalValue(K)},get extensionMode(){return H},get extension(){return $e===void 0&&($e=new J(Z,K.identifier,K,_,!1)),$e},get extensionRuntime(){return(0,u.$MF)(K,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!re){if(!fe)return;const te=p.Event.buffer(p.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),re={onDidReceiveMessage:te,postMessage:fe.postMessage.bind(fe)}}return re}})})}static hb(K,U,ie,be,H){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(K,U,ie,be,H).then(_=>new v.$Jec(!1,null,H.build(),ie,_,be.subscriptions))}static ib(K,U,ie,be,H){if(typeof ie.activate=="function")try{H.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${U.value}`);const _=typeof global=="object"?global:self,Z=ie.activate.apply(_,[be]);return H.activateCallStop(),H.activateResolveStart(),Promise.resolve(Z).then($e=>(H.activateResolveStop(),$e))}catch(_){return Promise.reject(_)}else return Promise.resolve(ie)}jb(K,U){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:U}).then(void 0,ie=>{this.s.error(ie)})}kb(K,U=0){const be=Date.now();(0,N.$B)(()=>{for(let H=U;H<K.length;H+=1){const _=K[H];for(const Z of _.activationEvents??[])if(Z==="onStartupFinished")if(Date.now()-be>50){this.kb(K,H);break}else this.jb(_,Z)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(K=>{const U=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(U)this.kb(ie);else for(const be of ie)if(be.activationEvents)for(const H of be.activationEvents)H==="onStartupFinished"&&this.jb(be,H)})}mb(){const K=this.Z("*",!0).then(void 0,_=>{this.s.error(_)});this.B(this.j.onDidChangeWorkspace(_=>this.nb(_.added)));const U=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(U),be=this.pb(),H=Promise.all([be,K,ie]).then(()=>{});return Promise.race([H,(0,L.$Yg)(1e4)]).then(()=>{this.lb()}),H}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(K,U))).then(()=>{})}async ob(K,U){if(this.isActivated(U.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:K.map(_=>_.uri),forceUsingSearch:ie||!this.c.fsExists,exists:_=>this.c.fsExists(_.fsPath),checkExists:(_,Z,$e)=>this.y.$checkExists(_,Z,$e)},H=await(0,k.$drb)(be,U);if(H)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:H.activationEvent}).then(void 0,_=>this.s.error(_))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:U}=this.f.environment;if(!K||!U)throw new Error(D.localize(0,null));const ie=await this.vb(null,U,new v.$Iec(!1));if(!ie||typeof ie.run!="function")throw new Error(D.localize(1,null,U.toString()));return new Promise((be,H)=>{const _=(re,fe)=>{re?(N.$t&&this.s.error("Test runner called back with error",re),H(re)):(N.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof fe=="number"&&fe>0?1:0))},Z=(0,R.$ng)(U),$e=ie.run(Z,_);$e&&$e.then&&$e.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),be(0)}).catch(re=>{N.$t&&this.s.error("Test runner finished with error",re),H(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,U){return this.R[K]=U,(0,b.$Pc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:U}=await this.sb(K);return U?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const U=K.indexOf("+");if(U===-1)throw new t.$FK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=K.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(K,U){const ie=F.$Nd.create(!1),be=()=>`[resolveAuthority(${(0,s.$Zk)(K)},${U})][${ie.elapsed()}ms] `,H=oe=>this.s.info(`${be()}${oe}`),_=oe=>this.s.warn(`${be()}${oe}`),Z=(oe,ee=void 0)=>this.s.error(`${be()}${oe}`,ee),$e=oe=>{if(oe instanceof t.$FK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},re=async oe=>{H(`activating resolver for ${oe}...`);const{resolver:ee,authorityPrefix:ge}=await this.sb(oe);if(!ee)throw Z(`no resolver for ${ge}`),new t.$FK(`No remote extension installed to resolve ${ge}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ee,authorityPrefix:ge,remoteAuthority:oe}},fe=K.split(/@|%40/g).reverse();H(`activating remote resolvers ${fe.join(" -> ")}`);let te;try{te=await Promise.all(fe.map(re)).catch(async oe=>{if(!(oe instanceof t.$FK)||oe._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return _(`resolving nested authorities failed: ${oe.message}`),[await re(K)]})}catch(oe){return $e(oe)}const de=new L.$9g;de.cancelAndSet(()=>H("waiting..."),1e3);let pe,Pe;for(const[oe,{authorityPrefix:ee,resolver:ge,remoteAuthority:ye}]of te.entries())try{if(oe===te.length-1)H("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${ee}`),pe=await ge.resolve(ye,{resolveAttempt:U,execServer:Pe}),g.mark(`code/extHost/didResolveAuthorityOK/${ee}`),H("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$EK.isManagedResolvedAuthority(pe)?pe:void 0));else{if(H(`invoking resolveExecServer() for ${ye}`),g.mark(`code/extHost/willResolveExecServer/${ee}`),Pe=await ge.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$FK(`Exec server was not available for ${ye}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${ee}`)}}catch(je){return g.mark(`code/extHost/didResolveAuthorityError/${ee}`),Z("returned an error",je),de.dispose(),$e(je)}de.dispose();const B={environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures},X={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};H(`returned ${t.$EK.isManagedResolvedAuthority(pe)?"managed authority":`${pe.host}:${pe.port}`}`);let se;if(t.$EK.isManagedResolvedAuthority(pe)){const oe=U;this.X.setFactory(oe,pe.makeConnection),se={authority:K,connectTo:new s.$Wk(oe),connectionToken:pe.connectionToken}}else se={authority:K,connectTo:new s.$Xk(pe.host,pe.port),connectionToken:pe.connectionToken};return{type:"ok",value:{authority:se,options:X,tunnelInformation:B}}}async $getCanonicalURI(K,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(K)})`);const{resolver:ie}=await this.sb(K);if(!ie)return null;const be=m.URI.revive(U);if(typeof ie.getCanonicalURI>"u")return be;const H=await(0,L.$Qg)(()=>ie.getCanonicalURI(be));return H||be}$startExtensionHost(K){K.toAdd.forEach(be=>be.extensionLocation=m.URI.revive(be.extensionLocation));const{globalRegistry:U,myExtensions:ie}=ce(this.I,this.L,this.J,K);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ie),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${G(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${G(this.J)}`)),this.rb()}$activateByEvent(K,U){return U===1?this.D.wait().then(ie=>this.Z(K,!1)):this.G.wait().then(ie=>this.Z(K,!1))}async $activate(K,U){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,U),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(_=>_.extensionLocation=m.URI.revive(_.extensionLocation));const{globalRegistry:U,myExtensions:ie}=ce(this.I,this.L,this.J,K),be=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ie),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${G(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${G(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const U=r.$fe.alloc(K),ie=Math.random()%256;for(let be=0;be<K;be++)U.writeUInt8(ie,be);return U}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$4ec=x,e.$4ec=x=W=He([Be(0,d.$Uh),Be(1,e.$3ec),Be(2,h.$zM),Be(3,w.$qec),Be(4,$.$tec),Be(5,A.$dj),Be(6,l.$PM),Be(7,c.$wec),Be(8,I.$axb),Be(9,f.$Rec),Be(10,M.$Zec),Be(11,O.$1ec)],x);function ce(he,K,U,ie){he.addActivationEvents(ie.addActivationEvents);const be=new o.$f6b(he,K.getAllExtensionDescriptions());be.deltaExtensions(ie.toAdd,ie.toRemove);const H=new n.$am(U.getAllExtensionDescriptions().map(Z=>Z.identifier));for(const Z of ie.myToRemove)H.delete(Z);for(const Z of ie.myToAdd)H.add(Z);const _=le(be,H);return{globalRegistry:be,myExtensions:_}}function Y(he,K){return{id:he.identifier.value,name:he.name,extensionVersion:he.version,publisherDisplayName:he.publisher,activationEvents:he.activationEvents?he.activationEvents.join(","):null,isBuiltin:he.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function G(he){return he.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$5ec=(0,d.$Vh)("IExtHostExtensionService");class J{#e;#t;#i;constructor(K,U,ie,be,H){this.#e=K,this.#t=U,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=T.$gc((0,R.$ng)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=be,this.isFromDifferentExtensionHost=H}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$6ec=J;function le(he,K){return he.getAllExtensionDescriptions().filter(U=>K.has(U.identifier))}class Q{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$7ec=Q;class Ee{constructor(K){this.a=new n.$bm,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const U of Object.keys(K))this.a.set(U,K[U])}}}),define(ke[364],Se([1,0,56,2,6,42,25,26,20,27,5,47,14,13]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;let w=class{constructor(r,a,t,s,d,l,c){this.c=r,this.d=a,this.e=t,this.f=s,this.g=d,this.h=l,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,r,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const a of r.nodeModuleName)this.a.set(a,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(a=>r.alternativeModuleName(a))}};e.$cgc=w,e.$cgc=w=He([Be(2,A.$Uh),Be(3,R.$tec),Be(4,C.$5ec),Be(5,m.$PM),Be(6,$.$dj)],w);let u=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&S.a.size){const a=(0,v.$Je)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const a=this.b.exec(this.c(r));if(!a)return;const[,t,s,d]=a,l=S.a.get(s);if(l!==void 0)return console.warn(`${s} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};u=S=He([Be(0,m.$PM)],u);class o{constructor(r,a,t,s,d){this.c=r,this.d=a,this.e=t,this.f=s,this.g=d,this.nodeModuleName="vscode",this.a=new b.$bm}load(r,a){const t=this.d.findSubstr(a);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((d,l)=>s+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${s}`),this.b=this.c(L.$GF,this.e,this.f)}return this.b}}let i=class{constructor(r,a,t){this.e=r,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$xK.MainThreadTelemetry);const s=t.getProxy(g.$xK.MainThreadWindow);this.c=(d,l)=>{const c=T.URI.parse(d);return l?this.g(d,l):c.scheme==="http"||c.scheme==="https"?s.$openUri(c,d,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?s.$openUri(c,d,{}):this.g(d,l)}}load(r,a,t){const s=this.e.findSubstr(a);return s&&(this.a=s.identifier.value,this.h()),this.b=t(r),this.c}g(r,a){return this.i(),this.b(r,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=He([Be(2,y.$zM)],i)}),define(ke[58],Se([1,0,48,3,16,49,5,69,70,47,7,41,290,42]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=void 0,e.$8ec=(0,L.$Vh)("IExtHostVariableResolverProvider");class S extends $.$AN{constructor(o,i,n,r,a,t,s){function d(){if(n){const l=n.activeEditor();if(l)return l.document.uri;const c=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$fM||c.input instanceof A.$kM)return c.input.modified;if(c.input instanceof A.$eM||c.input instanceof A.$jM||c.input instanceof A.$hM)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(h=>h.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>a.getConfiguration(void 0,l).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return g.$gc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const l=d();if(l){const c=i.getWorkspaceFolder(l);if(c)return g.$gc(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const l=n.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(n){const l=n.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let w=class extends T.$Rc{constructor(o,i,n,r,a){super(),this.b=o,this.c=i,this.g=n,this.h=r,this.j=a,this.a=new D.$U(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$9ec=w,e.$9ec=w=He([Be(0,m.$5ec),Be(1,C.$qec),Be(2,b.$KM),Be(3,v.$tec),Be(4,y.$Fec)],w)}),define(ke[96],Se([1,0,12,4,2,5,6,70,47,20,7,41,142,282,42,58]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=e.$_ec=e.$$ec=e.$0ec=void 0,e.$0ec=(0,R.$Vh)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,d,l,c,h,E){this.E=d,this.F=l,this.G=c,this.H=h,this.I=E,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Rd,this.n=new T.$Rd,this.o=new T.$Rd,this.u=new T.$Rd,this.k=s.getProxy(L.$xK.MainThreadDebugService),this.y=new T.$Rd,this.A=new T.$Rd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(f=>{this.J(I)}),this.J(I)})}asDebugSourceUri(s,d){const l=s;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let c=`debug:${encodeURIComponent(l.path||"")}`,h="?";return d&&(c+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),c+=`${h}ref=${l.sourceReference}`,g.URI.parse(c)}else{if(l.path)return g.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const d=[];for(const l of s.getAllExtensionDescriptions())if(l.contributes){const c=l.contributes.debuggers;if(c&&c.length>0)for(const h of c)(0,v.$iF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(d=>s.push(d)),s}addBreakpoints(s){const d=s.filter(h=>{const E=h.id;return this.w.has(E)?!1:(this.w.set(E,h),!0)});this.U(d,[],[]);const l=[],c=new Map;for(const h of d)if(h instanceof A.$yL){let E=c.get(h.location.uri.toString());E||(E={type:"sourceMulti",uri:h.location.uri,lines:[]},c.set(h.location.uri.toString(),E),l.push(E)),E.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$zL&&l.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(s){const d=s.filter(E=>this.w.delete(E.id));this.U([],d,[]);const l=d.filter(E=>E instanceof A.$yL).map(E=>E.id),c=d.filter(E=>E instanceof A.$zL).map(E=>E.id),h=d.filter(E=>E instanceof A.$AL).map(E=>E.id);return this.k.$unregisterBreakpoints(l,c,h)}startDebugging(s,d,l){return this.k.$startDebugging(s?s.uri:void 0,d,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,d,l){if(!d)return new A.$zK(()=>{});const c=this.d++;return this.f.push({type:s,handle:c,provider:d}),this.k.$registerDebugConfigurationProvider(s,l,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,c),new A.$zK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(s,d,l){if(!l)return new A.$zK(()=>{});if(!this.Q(s,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:d,handle:c,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(d,c),new A.$zK(()=>{this.h=this.h.filter(h=>h.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(s,d){if(!d)return new A.$zK(()=>{});const l=this.i++;return this.j.push({type:s,handle:l,factory:d}),new A.$zK(()=>{this.j=this.j.filter(c=>c.factory!==d)})}async $runInTerminal(s,d){return Promise.resolve(void 0)}async $substituteVariables(s,d){let l;const c=await this.W(s);return c&&(l={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(l,d)}K(s,d){if(s.type==="implementation")return new r(s.implementation)}L(){}async $startDASession(s,d){const l=this,c=await this.V(d);return this.S(this.N(c.type),c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const E=this.M(h),I=this.K(E,c);if(!I)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const f=I;return this.B.set(s,f),this.R(c).then(p=>(p&&this.C.set(s,p),f.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const P=k,j={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(P.arguments.value);j.body={signature:z},f.sendResponse(j)}else throw new Error("no signer")}catch(z){j.success=!1,j.message=z.message,f.sendResponse(j)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(k),k=(0,v.$nF)(k,!0),l.k.$acceptDAMessage(s,k)}),f.onError(k=>{p&&p.onError&&p.onError(k),this.k.$acceptDAError(s,k.name,k.message,k.stack)}),f.onExit(k=>{p&&p.onExit&&p.onExit(k??void 0,void 0),this.k.$acceptDAExit(s,k??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),f.startSession()))})}$sendDAMessage(s,d){d=(0,v.$mF)(d,!1);const l=this.C.get(s);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(d),this.B.get(s)?.sendMessage(d)}$stopDASession(s){const d=this.C.get(s);this.C.delete(s),d&&d.onWillStopSession&&d.onWillStopSession();const l=this.B.get(s);return this.B.delete(s),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const d=[],l=[],c=[];if(s.added)for(const h of s.added){const E=h.id;if(E&&!this.w.has(E)){let I;if(h.type==="function")I=new A.$zL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")I=new A.$AL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const f=g.URI.revive(h.uri);I=new A.$yL(new A.$LK(f,new A.$AK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$wL)(I,E),this.w.set(E,I),d.push(I)}}if(s.removed)for(const h of s.removed){const E=this.w.get(h);E&&(this.w.delete(h),l.push(E))}if(s.changed){for(const h of s.changed)if(h.id){const E=this.w.get(h.id);if(E){if(E instanceof A.$zL&&h.type==="function"){const I=E;I.enabled=h.enabled,I.condition=h.condition,I.hitCondition=h.hitCondition,I.logMessage=h.logMessage,I.functionName=h.functionName}else if(E instanceof A.$yL&&h.type==="source"){const I=E;I.enabled=h.enabled,I.condition=h.condition,I.hitCondition=h.hitCondition,I.logMessage=h.logMessage,I.location=new A.$LK(g.URI.revive(h.uri),new A.$AK(h.line,h.character))}c.push(E)}}}this.U(d,l,c)}async $acceptStackFrameFocus(s){let d;const l=s.sessionId?await this.V(s.sessionId):void 0;if(!l)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?d=new A.$GL(l,s.threadId):d=new A.$FL(l,s.threadId,s.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(s,d,l){return(0,D.$Qg)(async()=>{const c=this.P(s);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return c.provideDebugConfigurations(h,l)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(s,d,l,c){return(0,D.$Qg)(async()=>{const h=this.P(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.W(d);return h.resolveDebugConfiguration(E,l,c)})}$resolveDebugConfigurationWithSubstitutedVariables(s,d,l,c){return(0,D.$Qg)(async()=>{const h=this.P(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(E,l,c)})}async $provideDebugAdapter(s,d){const l=this.O(s);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(d);return this.S(l,c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(s){const d=await this.V(s);this.m.fire(d)}async $acceptDebugSessionTerminated(s){const d=await this.V(s);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,d){(await this.V(s))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(s,d){const c={session:await this.V(s),event:d.event,body:d.body};this.u.fire(c)}M(s){if(s instanceof A.$BL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$CL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$DL)return{type:"pipeServer",path:s.path};if(s instanceof A.$EL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const d=this.h.filter(l=>l.type===s);if(d.length>0)return d[0].factory}O(s){const d=this.h.filter(l=>l.handle===s);if(d.length>0)return d[0].factory}P(s){const d=this.f.filter(l=>l.handle===s);if(d.length>0)return d[0].provider}Q(s,d){if(s.contributes){const l=s.contributes.debuggers;if(l&&l.length>0){for(const c of l)if(c.label&&c.type&&c.type===d)return!0}}return!1}R(s){const l=s.configuration.type,c=this.j.filter(h=>h.type===l||h.type==="*").map(h=>(0,D.$Qg)(()=>h.factory.createDebugAdapterTracker(s)).then(E=>E,E=>null));return Promise.race([Promise.all(c).then(h=>{const E=h.filter(I=>!!I);if(E.length>0)return new n(E)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(s,d){const l=d.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new A.$CL(l));if(s){const h=await this.F.getExtensionRegistry();return(0,D.$Qg)(()=>s.createDebugAdapterDescriptor(d,this.T(d,h))).then(E=>{if(E)return E})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,c))}T(s,d){}U(s,d,l){(s.length>0||d.length>0||l.length>0)&&this.y.fire(Object.freeze({added:s,removed:d,changed:l}))}async V(s){if(s)if(typeof s=="string"){const d=this.l.get(s);if(d)return d}else{let d=this.l.get(s.id);if(!d){const l=await this.W(s.folderUri),c=s.parent?this.l.get(s.parent):void 0;d=new o(this.k,s.id,s.type,s.name,l,s.configuration,c),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(s){if(s){const d=g.URI.revive(s);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$$ec=u,e.$$ec=u=He([Be(0,m.$zM),Be(1,C.$qec),Be(2,y.$5ec),Be(3,S.$tec),Be(4,b.$Fec),Be(5,w.$8ec)],u);class o{constructor(s,d,l,c,h,E,I){this.d=s,this.f=d,this.g=l,this.h=c,this.i=h,this.j=E,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,d){return this.d.$customDebugAdapterRequest(this.f,s,d)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$_ec=o;class i{constructor(s){this.value=Object.freeze({append(d){s.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$afc=i;class n{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(d=>d.onError?d.onError(s):void 0)}onExit(s,d){this.d.forEach(l=>l.onExit?l.onExit(s,d):void 0)}}class r extends $.$0cb{constructor(s){super(),this.h=s,s.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends u{constructor(s,d,l,c,h,E){super(s,d,l,c,h,E)}};e.$bfc=a,e.$bfc=a=He([Be(0,m.$zM),Be(1,C.$qec),Be(2,y.$5ec),Be(3,S.$tec),Be(4,b.$Fec),Be(5,w.$8ec)],a)}),define(ke[365],Se([1,0,8,56,2,6,353,14,106,107,27,248,20,66,47,90]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=void 0;class u{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(b.$dj),t=n.get($.$zM).getProxy(R.$xK.MainThreadErrors);D.setUnexpectedErrorHandler(s=>{r.error(s);const d=D.$2(s);t.$onUnexpectedError(d)})}static async installFullHandler(n){const r=n.get(b.$dj),a=n.get($.$zM),t=n.get(S.$5ec),s=n.get(w.$TM),d=a.getProxy(R.$xK.MainThreadExtensionService),l=a.getProxy(R.$xK.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function E(p,k){if(h.has(p))return h.get(p).stack;let P="",j,z;for(const F of k)P+=`
	at ${F.toString()}`,z=F.getFileName(),!j&&z&&(j=c.findSubstr(g.URI.file(z)));const M=`${p.name||"Error"}: ${p.message||""}${P}`;return h.set(p,{extensionIdentifier:j?.identifier,stack:M}),M}const I=Symbol("prepareStackTrace wrapped");let f=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(p){if(p===E||!p||p[I]){f=p||E;return}f=function(k,P){return E(k,P),p.call(Error,k,P)},Object.assign(f,{[I]:!0})}}),D.setUnexpectedErrorHandler(p=>{r.error(p);const k=D.$2(p),P=h.get(p);if(!P?.extensionIdentifier){l.$onUnexpectedError(k);return}d.$onExtensionRuntimeError(P.extensionIdentifier,k);const j=s.onExtensionError(P.extensionIdentifier,p);r.trace("forwarded error to extension?",j,P)})}}e.$dgc=u;class o{constructor(n,r,a,t,s){this.a=a,this.b=new L.$n6b(n,null,t),r=o.e(r,this.b);const d=new m.$Th(...(0,y.$Dr)());d.set(A.$PM,{_serviceBrand:void 0,...r,messagePorts:s}),d.set($.$zM,new $.$AM(this.b)),d.set(v.$nec,new v.$oec(t)),d.set(S.$3ec,a);const l=new C.$jq(d,!0);l.invokeFunction(u.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(b.$dj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(c=>c.get(S.$5ec)),this.c.initialize(),l.invokeFunction(u.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(R.$xK.MainThreadExtensionService);return g.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=g.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>g.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=g.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=g.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=g.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=g.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=g.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=g.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$egc=o}),define(ke[366],Se([1,0,12,11,223,242,140,96,70,47,20,46,7,58,41,283,284,42]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;let i=class extends b.$$ec{constructor(s,d,l,c,h,E,I){super(s,d,l,c,E,I),this.Z=h,this.X=new a}K(s,d){switch(s.type){case"server":return new w.$jgc(s);case"pipeServer":return new w.$kgc(s);case"executable":return new w.$lgc(s,d.type)}return super.K(s,d)}T(s,d){const l=w.$lgc.platformAdapterExecutable(d.getAllExtensionDescriptions(),s.type);if(l)return new $.$BL(l.command,l.args,l.options)}L(){return new L.$c0b}async $runInTerminal(s,d){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const l=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),E=s.title||g.localize(0,null),I=JSON.stringify({shell:c,shellArgs:h});let f=await this.X.checkout(I,E),p,k=!1;if(f)p=s.cwd;else{const M={shellPath:c,shellArgs:h,cwd:s.cwd,name:E,iconPath:new $.$tL("debug")};k=!0,f=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(f,I)}f.show(!0);const P=await f.processId;k?await new Promise(M=>setTimeout(M,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?f.sendText("cls"):c.indexOf("bash")>=0?f.sendText("clear"):T.$i?f.sendText("cls"):f.sendText("clear"));const j=(0,u.$ngc)(c,s.args,!!s.argsCanBeInterpretedByShell,p,s.env);f.sendText(j);const z=this.onDidTerminateDebugSession(M=>{M.id===d&&(this.X.free(f),z.dispose())});return P}else if(s.kind==="external")return r(s,await this.G.getConfigProvider());return super.$runInTerminal(s,d)}};e.$ogc=i,e.$ogc=i=He([Be(0,A.$zM),Be(1,S.$qec),Be(2,m.$5ec),Be(3,o.$tec),Be(4,C.$Rec),Be(5,y.$Fec),Be(6,v.$8ec)],i);let n;function r(t,s){if(!n)if(T.$i)n=new R.$18b;else if(T.$j)n=new R.$28b;else if(T.$k)n=new R.$38b;else throw new Error("external terminals not supported on this platform");const d=s.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,d){const c=[...this.b.entries()].map(([h,E])=>(0,D.$Lg)(async I=>{if(h.name!==d||E.lastUsedAt!==-1&&await(0,u.$mgc)(await h.processId))return null;const f=Date.now();return E.lastUsedAt+a.a>f||I.isCancellationRequested||E.config!==s?null:(E.lastUsedAt=f,h)}));return await(0,D.$3g)(c,h=>!!h)}insert(s,d){this.b.set(s,{lastUsedAt:Date.now(),config:d})}free(s){const d=this.b.get(s);d&&(d.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(ke[367],Se([1,0,16,2,104,41,69,42,40,46,20,27,95,17,14,91,23,63,58]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;let n=class extends $.$Ufc{constructor(a,t,s,d,l,c,h,E,I){super(a,t,s,d,l,c,h,E),this.B=s,this.C=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const d=$.TaskHandleDTO.from(s,this.B),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(l,t);return this.a.$executeTask(d).catch(()=>{}),c}else{const d=$.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const l=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}u(a,t,s,d){const l=[];if(d)for(const c of d){this.z(c,s),(!c.definition||!a[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=$.TaskDTO.from(c,s.extension);h&&(l.push(h),$.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,c,!0)))}return{tasks:l,extension:s.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const s=T.URI.file((0,o.homedir)());t=new y.$di({uri:s,name:u.$wg(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const s=T.URI.revive(a),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(s),c=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),E=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const I of t.variables)d.variables[I]=await h.resolveAsync(E,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(D.$sc);for(let f=0;f<I.length;f++)I[f]=await h.resolveAsync(E,I[f])}d.process=await g.win32.findExecutable(await h.resolveAsync(E,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(E,t.process.cwd):void 0,I)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,s){return g.win32.findExecutable(a,t,s)}};e.$ggc=n,e.$ggc=n=He([Be(0,A.$zM),Be(1,C.$PM),Be(2,R.$qec),Be(3,L.$KM),Be(4,b.$tec),Be(5,m.$Rec),Be(6,S.$dj),Be(7,w.$$dc),Be(8,i.$8ec)],n)}),define(ke[368],Se([1,0,63,58]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class g extends T.$9ec{m(){return(0,D.homedir)()}}e.$Ygc=g}),define(ke[156],Se([1,0,19,12,21,43,17,16,23,2,36]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=e.$rfc=e.$qfc=e.$pfc=void 0;class C{constructor(i,n,r,a){this.d=i,this.e=n,this.f=r,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const r=this.d.folderQueries||[],a=new g.$2d(n);return new Promise((t,s)=>{this.a=new v(i);let d=!1;const l=(c,h)=>{if(!d&&!this.b){const E=this.h(c);w(c)&&typeof this.d.maxResults=="number"&&this.c+E>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),c=this.j(c,this.d.maxResults-this.c));const I=this.h(c);this.c+=I,(I>0||!w(c))&&this.a.add(c,h)}};Promise.all(r.map((c,h)=>this.k(c,E=>l(E,h),a.token))).then(c=>{a.dispose(),this.a.flush();const h=c.some(E=>!!E&&!!E.limitHit);t({limitHit:this.b||h,messages:(0,D.$Qb)(c.map(E=>E?.message?Array.isArray(E.message)?E.message:[E.message]:[])),stats:{type:this.g}})},c=>{a.dispose();const h=(0,R.$Gi)(c);s(new Error(h))})})}h(i){return w(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const a=new A.$cJ(this.d,i),t=[],s={report:c=>{if(!this.l(c))return;const h=i.folder.scheme===L.Schemas.file?(0,A.$dJ)(()=>this.f.readdir(y.$yg(c.uri))):void 0,E=y.$Bg(i.folder,c.uri);if(E){const I=a.includedInQuery(E,b.$mc(E),h);(0,T.$Kg)(I)?t.push(I.then(f=>{f&&n(c)})):I&&n(c)}}},d=this.n(i),l=await this.e.provideTextSearchResults($(this.d.contentPattern),d,s,r);return t.length&&await Promise.all(t),l}l(i){if(w(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$bJ)(this.d.includePattern,i.includePattern),r=(0,A.$bJ)(this.d.excludePattern,i.excludePattern),a={folder:m.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$pfc=C;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new u(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!y.$sg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$qfc=v;function S(o){return w(o)?{preview:{matches:(0,D.$1b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,D.$1b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function w(o){return!!o.preview}e.$rfc=w;class u{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$sfc=u}),define(ke[97],Se([1,0,3,6,5,361,20,66,14,2,156]),function(me,e,D,T,g,R,L,b,y,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=e.$tfc=void 0,e.$tfc=(0,g.$Vh)("IExtHostSearch");let C=class{constructor(w,u,o){this.k=w,this.l=u,this.n=o,this.c=this.k.getProxy(T.$xK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$ofc}o(w){return this.l.transformOutgoingScheme(w)}registerTextSearchProvider(w,u){if(this.g.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this.g.add(w);const o=this.d++;return this.e.set(o,u),this.c.$registerTextSearchProvider(o,this.o(w)),(0,D.$Pc)(()=>{this.g.delete(w),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(w,u){if(this.i.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this.i.add(w);const o=this.d++;return this.h.set(o,u),this.c.$registerFileSearchProvider(o,this.o(w)),(0,D.$Pc)(()=>{this.i.delete(w),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(w,u,o,i){const n=$(o),r=this.h.get(w);if(r)return this.j.fileSearch(n,r,a=>{this.c.$handleFileMatch(w,u,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+w)}async doInternalFileSearchWithCustomCallback(w,u,o){return{messages:[]}}$clearCache(w){return this.j.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,u,o,i){const n=this.e.get(w);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const r=$(o);return this.q(r,n).search(t=>this.c.$handleTextMatch(w,u,t),i)}$enableExtensionHostSearch(){}q(w,u){return new A.$pfc(w,u,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$ufc=C,e.$ufc=C=He([Be(0,L.$zM),Be(1,b.$nec),Be(2,y.$dj)],C);function $(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(v),extraFileResources:S.extraFileResources&&S.extraFileResources.map(w=>m.URI.revive(w))}}e.$vfc=$;function v(S){return{...S,folder:m.URI.revive(S.folder)}}}),define(ke[369],Se([1,0,21,8,4,3,17,39,2,133,191,172,79,26,32,14,137,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,151,316,317,318,294,319,69,70,320,47,321,71,322,57,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,154,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,46,339,340,285,341,299,72,15,7,342,66,343,93,345,346,153,41,281,114,25,94]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s,d,l,c,h,E,I,f,p,k,P,j,z,M,F,N,O,W,x,ce,Y,G,J,le,Q,Ee,he,K,U,ie,be,H,_,Z,$e,re,fe,te,de,pe,Pe,B,X,se,oe,ee,ge,ye,je,We,et,Ye,rt,nt,Ae,Oe,Ve,Le,Ze,ue,ae,Ie,Ke,Ge,_e,st,lt,wt,Ue,Kt,Ht,Et,Ut,Nt,Gt,Bt,Dt,Mt,Wt,tt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;function qt(ut){const mt=ut.get(U.$PM),Ot=ut.get(K.$8dc),Pt=ut.get(Ee.$vec),At=ut.get(le.$5ec),gt=ut.get(Dt.$qec),St=ut.get(ue.$TM),Rt=ut.get(j.$tec),It=ut.get(Ht.$nec),Je=ut.get(We.$zM),jt=ut.get(Ve.$Oec),Jt=ut.get(Le.$wec),Me=ut.get(w.$ej),Fe=ut.get(w.$dj),Ce=ut.get(lt.$axb),ne=ut.get(s.$$dc),Te=ut.get(Bt.$0fc),qe=ut.get(rt.$Wec),xe=ut.get(G.$Fec),Qe=ut.get(fe.$1ec);Je.set(r.$yK.ExtHostFileSystemInfo,Ot),Je.set(r.$yK.ExtHostLogLevelServiceShape,Me),Je.set(r.$yK.ExtHostWorkspace,gt),Je.set(r.$yK.ExtHostConfiguration,Rt),Je.set(r.$yK.ExtHostExtensionService,At),Je.set(r.$yK.ExtHostStorage,jt),Je.set(r.$yK.ExtHostTunnelService,Ce),Je.set(r.$yK.ExtHostWindow,Te),Je.set(r.$yK.ExtHostSecretState,qe),Je.set(r.$yK.ExtHostTelemetry,St),Je.set(r.$yK.ExtHostEditorTabs,xe),Je.set(r.$yK.ExtHostManagedSockets,Qe);const ot=Je.set(r.$yK.ExtHostDecorations,ut.get(F.$dfc)),pt=Je.set(r.$yK.ExtHostDocumentsAndEditors,ut.get(Y.$KM)),bt=Je.set(r.$yK.ExtHostCommands,ut.get(k.$VM)),vt=Je.set(r.$yK.ExtHostTerminalService,ut.get(ae.$Rec)),ht=Je.set(r.$yK.ExtHostDebugService,ut.get(M.$0ec)),Lt=Je.set(r.$yK.ExtHostSearch,ut.get(Ye.$tfc)),Qt=Je.set(r.$yK.ExtHostTask,ut.get(Ze.$Wfc)),Zt=Je.set(r.$yK.ExtHostOutputService,ut.get(oe.$Jfc)),si=Je.set(r.$yK.ExtHostLocalization,ut.get(re.$Zec)),ki=Je.set(r.$yK.ExtHostUrls,new Et.$7fc(Je)),Ct=Je.set(r.$yK.ExtHostDocuments,new ce.$6dc(Je,pt)),Yi=Je.set(r.$yK.ExtHostDocumentContentProviders,new W.$ffc(Je,pt,Fe)),hn=Je.set(r.$yK.ExtHostDocumentSaveParticipant,new x.$gfc(Fe,Ct,Je.getProxy(r.$xK.MainThreadBulkEdits))),kt=Je.set(r.$yK.ExtHostNotebook,new de.$wfc(Je,bt,pt,Ct,Pt,Lt)),mi=Je.set(r.$yK.ExtHostNotebookDocuments,new Pe.$Dfc(kt)),$i=Je.set(r.$yK.ExtHostNotebookEditors,new B.$Efc(Fe,kt)),oi=Je.set(r.$yK.ExtHostNotebookKernels,new X.$Ffc(Je,mt,kt,bt,Fe)),Si=Je.set(r.$yK.ExtHostNotebookRenderers,new se.$Hfc(Je,kt)),Di=Je.set(r.$yK.ExtHostNotebookDocumentSaveParticipant,new pe.$Cfc(Fe,kt,Je.getProxy(r.$xK.MainThreadBulkEdits))),Ft=Je.set(r.$yK.ExtHostEditors,new Ke.$kec(Je,pt)),bi=Je.set(r.$yK.ExtHostTreeViews,new st.$5fc(Je.getProxy(r.$xK.MainThreadTreeViews),bt,Fe)),Ci=Je.set(r.$yK.ExtHostEditorInsets,new p.$lec(Je.getProxy(r.$xK.MainThreadEditorInsets),Ft,mt.remote)),ai=Je.set(r.$yK.ExtHostDiagnostics,new N.$0dc(Je,Fe,Ot,pt)),ci=Je.set(r.$yK.ExtHostLanguages,new $e.$Afc(Je,Ct,bt.converter,It)),dt=Je.set(r.$yK.ExtHostLanguageFeatures,new Z.$bec(Je,It,Ct,bt,ai,Fe,ne,St)),Ii=Je.set(r.$yK.ExtHostFileSystem,new Q.$ifc(Je,dt)),xt=Je.set(r.$yK.ExtHostFileSystemEventService,new he.$jfc(Je,Fe,pt)),ni=Je.set(r.$yK.ExtHostQuickOpen,(0,je.$Nfc)(Je,gt,bt)),hi=Je.set(r.$yK.ExtHostSCM,new et.$Pfc(Je,bt,Ct,Fe)),Zi=Je.set(r.$yK.ExtHostQuickDiff,new ye.$Mfc(Je,It)),Pi=Je.set(r.$yK.ExtHostShare,new nt.$Qfc(Je,It)),Ai=Je.set(r.$yK.ExtHostComments,(0,P.$mec)(Je,bt,Ct)),Ri=Je.set(r.$yK.ExtHostProgress,new ge.$Lfc(Je.getProxy(r.$xK.MainThreadProgress))),xi=Je.set(r.$yK.ExtHosLabelService,new _.$zfc(Je)),Li=Je.set(r.$yK.ExtHostTheming,new Ge.$2fc(Je)),ui=Je.set(r.$yK.ExtHostAuthentication,new d.$dec(Je)),_i=Je.set(r.$yK.ExtHostTimeline,new _e.$4fc(Je,bt)),Mi=Je.set(r.$yK.ExtHostWebviews,new Ut.$Aec(Je,mt.remote,gt,Fe,ne)),Fi=Je.set(r.$yK.ExtHostWebviewPanels,new Nt.$Dec(Je,Mi,gt)),Ti=Je.set(r.$yK.ExtHostCustomEditors,new z.$Eec(Je,Ct,Jt,Mi,Fi)),Oi=Je.set(r.$yK.ExtHostWebviewViews,new Gt.$8fc(Je,Mi)),di=Je.set(r.$yK.ExtHostTesting,new Ie.$Xfc(Je,bt,pt)),dn=Je.set(r.$yK.ExtHostUriOpeners,new Kt.$6fc(Je)),en=Je.set(r.$yK.ExtHostProfileContentHandlers,new ee.$Kfc(Je));Je.set(r.$yK.ExtHostInteractive,new be.$xfc(Je,kt,pt,bt,Fe));const Ni=Je.set(r.$yK.ExtHostInlineChat,new ie.$kfc(Je,bt,Ct,Fe)),pi=Je.set(r.$yK.ExtHostChatProvider,new E.$gec(Je,Fe)),tn=Je.set(r.$yK.ExtHostChatAgents2,new h.$hec(Je,pi,Fe)),nn=Je.set(r.$yK.ExtHostChatVariables,new I.$iec(Je)),wi=Je.set(r.$yK.ExtHostChat,new c.$fec(Je)),vi=Je.set(r.$yK.ExtHostAiRelatedInformation,new a.$5dc(Je)),rn=Je.set(r.$yK.ExtHostAiEmbeddingVector,new J.$hfc(Je)),_t=Je.set(r.$yK.ExtHostIssueReporter,new H.$yfc(Je)),fi=Je.set(r.$yK.ExtHostStatusBar,new Oe.$Tfc(Je,bt.converter)),fn=Je.set(r.$yK.ExtHostSpeech,new Ae.$Rfc(Je)),Xt=Object.values(r.$yK);Je.assertRegistered(Xt);const yi=new l.$eec(Je,pt),sn=new f.$jec(Je),Ei=new te.$Bfc(Je,Fe),ji=new O.$efc(Je);return t.$cec.register(bt),function(ze,ti,zi){const $t=function(){let we=!ze.isUnderDevelopment;function De(){we||(Fe.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Ne(at){if(Array.isArray(at))at.forEach(Ne);else if(typeof at=="string")De();else{const yt=at;typeof yt.scheme>"u"&&De(),typeof yt.exclusive=="boolean"&&(0,tt.$MF)(ze,"documentFiltersExclusive")}return at}}(),gn={getSession(we,De,Ne){return ui.getSession(ze,we,De,Ne)},getSessions(we,De){return(0,tt.$MF)(ze,"authGetSessions"),ui.getSessions(ze,we,De)},async hasSession(we,De){return(0,tt.$MF)(ze,"authSession"),!!await ui.getSession(ze,we,De,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(we,De,Ne,at){return ui.registerAuthenticationProvider(we,De,Ne,at)}},mn={registerCommand(we,De,Ne){return bt.registerCommand(!0,we,De,Ne,void 0,ze)},registerTextEditorCommand(we,De,Ne){return bt.registerCommand(!0,we,(...at)=>{const yt=Ft.getActiveTextEditor();if(!yt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}return yt.edit(Tt=>{De.apply(Ne,[yt,Tt,...at])}).then(Tt=>{Tt||Fe.warn("Edits from command "+we+" were not applied.")},Tt=>{Fe.warn("An error occurred while running command "+we,Tt)})},void 0,void 0,ze)},registerDiffInformationCommand:(we,De,Ne)=>((0,tt.$MF)(ze,"diffCommand"),bt.registerCommand(!0,we,async(...at)=>{const yt=pt.activeEditor(!0);if(!yt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(yt.id);De.apply(Ne,[Tt,...at])},void 0,void 0,ze)),executeCommand(we,...De){return bt.executeCommand(we,...De)},getCommands(we=!1){return bt.getCommands(we)}},Ui={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return vt.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$MF)(ze,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$MF)(ze,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ue.$SM)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,De){return ue.$RM.validateSender(we),St.instantiateLogger(ze,we,De)},openExternal(we,De){return Te.openUri(we,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===mt.environment.appUriScheme)return ki.createAppUri(we);try{return await Te.asExternalUri(we,{allowTunneling:!!mt.remote.authority})}catch(De){if((0,u.$QU)(we,L.Schemas.http)||(0,u.$QU)(we,L.Schemas.https))return we;throw De}},get remoteName(){return(0,o.$2k)(mt.remote.authority)},get remoteAuthority(){return(0,tt.$MF)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return Fe.getLevel()},get onDidChangeLogLevel(){return Fe.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,tt.$MF)(ze,"handleIssueUri"),_t.registerIssueUriRequestHandler(ze,we)},registerIssueDataProvider(we){return(0,tt.$MF)(ze,"handleIssueUri"),_t.registerIssueDataProvider(ze,we)},get appQuality(){return(0,tt.$MF)(ze,"resolvers"),mt.quality},get appCommit(){return(0,tt.$MF)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(Ui);const Bi={createTestController(we,De,Ne){return di.createTestController(ze,we,De,Ne)},createTestObserver(){return(0,tt.$MF)(ze,"testObserver"),di.createTestObserver()},runTests(we){return(0,tt.$MF)(ze,"testObserver"),di.runTests(we)},get onDidChangeTestResults(){return(0,tt.$MF)(ze,"testObserver"),di.onResultsChanged},get testResults(){return(0,tt.$MF)(ze,"testObserver"),di.results}},gi=mt.remote.isRemote?Ue.ExtensionKind.Workspace:Ue.ExtensionKind.UI,on={getExtension(we,De){(0,tt.$LF)(ze,"extensionsAny")||(De=!1);const Ne=ti.mine.getExtensionDescription(we);if(Ne)return new le.$6ec(At,ze.identifier,Ne,gi,!1);if(De){const at=ti.all.getExtensionDescription(we);if(at)return new le.$6ec(At,ze.identifier,at,gi,!0)}},get all(){const we=[];for(const De of ti.mine.getAllExtensionDescriptions())we.push(new le.$6ec(At,ze.identifier,De,gi,!1));return we},get allAcrossExtensionHosts(){(0,tt.$MF)(ze,"extensionsAny");const we=new v.$am(ti.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),De=[];for(const Ne of ti.all.getAllExtensionDescriptions()){const at=!we.has(Ne.identifier);De.push(new le.$6ec(At,ze.identifier,Ne,gi,at))}return De},get onDidChange(){return(0,tt.$LF)(ze,"extensionsAny")?g.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},an={createDiagnosticCollection(we){return ai.createDiagnosticCollection(ze.identifier,we)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:we=>ai.getDiagnostics(we),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(we,De){return ci.changeLanguage(we.uri,De)},match(we,De){const Ne=Ct.getDocumentData(De.uri)?.notebook;return(0,A.$LE)(wt.LanguageSelector.from(we),De.uri,De.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(we,De,Ne){return dt.registerCodeActionProvider(ze,$t(we),De,Ne)},registerDocumentPasteEditProvider(we,De,Ne){return(0,tt.$MF)(ze,"documentPaste"),dt.registerDocumentPasteEditProvider(ze,$t(we),De,Ne)},registerCodeLensProvider(we,De){return dt.registerCodeLensProvider(ze,$t(we),De)},registerDefinitionProvider(we,De){return dt.registerDefinitionProvider(ze,$t(we),De)},registerDeclarationProvider(we,De){return dt.registerDeclarationProvider(ze,$t(we),De)},registerImplementationProvider(we,De){return dt.registerImplementationProvider(ze,$t(we),De)},registerTypeDefinitionProvider(we,De){return dt.registerTypeDefinitionProvider(ze,$t(we),De)},registerHoverProvider(we,De){return dt.registerHoverProvider(ze,$t(we),De,ze.identifier)},registerEvaluatableExpressionProvider(we,De){return dt.registerEvaluatableExpressionProvider(ze,$t(we),De,ze.identifier)},registerInlineValuesProvider(we,De){return dt.registerInlineValuesProvider(ze,$t(we),De,ze.identifier)},registerDocumentHighlightProvider(we,De){return dt.registerDocumentHighlightProvider(ze,$t(we),De)},registerLinkedEditingRangeProvider(we,De){return dt.registerLinkedEditingRangeProvider(ze,$t(we),De)},registerReferenceProvider(we,De){return dt.registerReferenceProvider(ze,$t(we),De)},registerRenameProvider(we,De){return dt.registerRenameProvider(ze,$t(we),De)},registerDocumentSymbolProvider(we,De,Ne){return dt.registerDocumentSymbolProvider(ze,$t(we),De,Ne)},registerWorkspaceSymbolProvider(we){return dt.registerWorkspaceSymbolProvider(ze,we)},registerDocumentFormattingEditProvider(we,De){return dt.registerDocumentFormattingEditProvider(ze,$t(we),De)},registerDocumentRangeFormattingEditProvider(we,De){return dt.registerDocumentRangeFormattingEditProvider(ze,$t(we),De)},registerOnTypeFormattingEditProvider(we,De,Ne,...at){return dt.registerOnTypeFormattingEditProvider(ze,$t(we),De,[Ne].concat(at))},registerDocumentSemanticTokensProvider(we,De,Ne){return dt.registerDocumentSemanticTokensProvider(ze,$t(we),De,Ne)},registerDocumentRangeSemanticTokensProvider(we,De,Ne){return dt.registerDocumentRangeSemanticTokensProvider(ze,$t(we),De,Ne)},registerSignatureHelpProvider(we,De,Ne,...at){return typeof Ne=="object"?dt.registerSignatureHelpProvider(ze,$t(we),De,Ne):dt.registerSignatureHelpProvider(ze,$t(we),De,typeof Ne>"u"?[]:[Ne,...at])},registerCompletionItemProvider(we,De,...Ne){return dt.registerCompletionItemProvider(ze,$t(we),De,Ne)},registerInlineCompletionItemProvider(we,De,Ne){return De.handleDidShowCompletionItem&&(0,tt.$MF)(ze,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,tt.$MF)(ze,"inlineCompletionsAdditions"),Ne&&(0,tt.$MF)(ze,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(ze,$t(we),De,Ne)},registerDocumentLinkProvider(we,De){return dt.registerDocumentLinkProvider(ze,$t(we),De)},registerColorProvider(we,De){return dt.registerColorProvider(ze,$t(we),De)},registerFoldingRangeProvider(we,De){return dt.registerFoldingRangeProvider(ze,$t(we),De)},registerSelectionRangeProvider(we,De){return dt.registerSelectionRangeProvider(ze,we,De)},registerCallHierarchyProvider(we,De){return dt.registerCallHierarchyProvider(ze,we,De)},registerTypeHierarchyProvider(we,De){return dt.registerTypeHierarchyProvider(ze,we,De)},setLanguageConfiguration:(we,De)=>dt.setLanguageConfiguration(ze,we,De),getTokenInformationAtPosition(we,De){return(0,tt.$MF)(ze,"tokenInformation"),ci.tokenAtPosition(we,De)},registerInlayHintsProvider(we,De){return dt.registerInlayHintsProvider(ze,we,De)},createLanguageStatusItem(we,De){return ci.createLanguageStatusItem(ze,we,De)},registerDocumentDropEditProvider(we,De,Ne){return dt.registerDocumentOnDropEditProvider(ze,we,De,(0,tt.$LF)(ze,"dropMetadata")?Ne:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(we,De,Ne){const at=await(y.URI.isUri(we)?Promise.resolve(cn.openTextDocument(we)):Promise.resolve(we));return Ft.showTextDocument(at,De,Ne)},createTextEditorDecorationType(we){return Ft.createTextEditorDecorationType(ze,we)},onDidChangeActiveTextEditor(we,De,Ne){return Ft.onDidChangeActiveTextEditor(we,De,Ne)},onDidChangeVisibleTextEditors(we,De,Ne){return Ft.onDidChangeVisibleTextEditors(we,De,Ne)},onDidChangeTextEditorSelection(we,De,Ne){return Ft.onDidChangeTextEditorSelection(we,De,Ne)},onDidChangeTextEditorOptions(we,De,Ne){return Ft.onDidChangeTextEditorOptions(we,De,Ne)},onDidChangeTextEditorVisibleRanges(we,De,Ne){return Ft.onDidChangeTextEditorVisibleRanges(we,De,Ne)},onDidChangeTextEditorViewColumn(we,De,Ne){return Ft.onDidChangeTextEditorViewColumn(we,De,Ne)},onDidCloseTerminal(we,De,Ne){return vt.onDidCloseTerminal(we,De,Ne)},onDidOpenTerminal(we,De,Ne){return vt.onDidOpenTerminal(we,De,Ne)},onDidChangeActiveTerminal(we,De,Ne){return vt.onDidChangeActiveTerminal(we,De,Ne)},onDidChangeTerminalDimensions(we,De,Ne){return(0,tt.$MF)(ze,"terminalDimensions"),vt.onDidChangeTerminalDimensions(we,De,Ne)},onDidChangeTerminalState(we,De,Ne){return vt.onDidChangeTerminalState(we,De,Ne)},onDidWriteTerminalData(we,De,Ne){return(0,tt.$MF)(ze,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(we,De,Ne)},onDidExecuteTerminalCommand(we,De,Ne){return(0,tt.$MF)(ze,"terminalExecuteCommandEvent"),vt.onDidExecuteTerminalCommand(we,De,Ne)},get state(){return Te.getState(ze)},onDidChangeWindowState(we,De,Ne){return Te.onDidChangeWindowState(we,De,Ne)},showInformationMessage(we,...De){return Ei.showMessage(ze,b.default.Info,we,De[0],De.slice(1))},showWarningMessage(we,...De){return Ei.showMessage(ze,b.default.Warning,we,De[0],De.slice(1))},showErrorMessage(we,...De){return Ei.showMessage(ze,b.default.Error,we,De[0],De.slice(1))},showQuickPick(we,De,Ne){return ni.showQuickPick(ze,we,De,Ne)},showWorkspaceFolderPick(we){return ni.showWorkspaceFolderPick(we)},showInputBox(we,De){return ni.showInput(we,De)},showOpenDialog(we){return ji.showOpenDialog(ze,we)},showSaveDialog(we){return ji.showSaveDialog(we)},createStatusBarItem(we,De,Ne){let at,yt,Tt;return typeof we=="string"?(at=we,yt=De,Tt=Ne):(yt=we,Tt=De),fi.createStatusBarEntry(ze,at,yt,Tt)},setStatusBarMessage(we,De){return fi.setStatusBarMessage(we,De)},withScmProgress(we){return ne.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ri.withProgress(ze,{location:Ue.ProgressLocation.SourceControl},(De,Ne)=>we({report(at){}}))},withProgress(we,De){return Ri.withProgress(ze,we,De)},createOutputChannel(we,De){return Zt.createOutputChannel(we,De,ze)},createWebviewPanel(we,De,Ne,at){return Fi.createWebviewPanel(ze,we,De,Ne,at)},createWebviewTextEditorInset(we,De,Ne,at){return(0,tt.$MF)(ze,"editorInsets"),Ci.createWebviewEditorInset(we,De,Ne,at,ze)},createTerminal(we,De,Ne){return typeof we=="object"?"pty"in we?vt.createExtensionTerminal(we):vt.createTerminalFromOptions(we):vt.createTerminal(we,De,Ne)},registerTerminalLinkProvider(we){return vt.registerLinkProvider(we)},registerTerminalProfileProvider(we,De){return vt.registerProfileProvider(ze,we,De)},registerTerminalQuickFixProvider(we,De){return(0,tt.$MF)(ze,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(we,ze.identifier.value,De)},registerTreeDataProvider(we,De){return bi.registerTreeDataProvider(we,De,ze)},createTreeView(we,De){return bi.createTreeView(we,De,ze)},registerWebviewPanelSerializer:(we,De)=>Fi.registerWebviewPanelSerializer(ze,we,De),registerCustomEditorProvider:(we,De,Ne={})=>Ti.registerCustomEditorProvider(ze,we,De,Ne),registerFileDecorationProvider(we){return ot.registerFileDecorationProvider(we,ze)},registerUriHandler(we){return ki.registerUriHandler(ze,we)},createQuickPick(){return ni.createQuickPick(ze)},createInputBox(){return ni.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(we,De,Ne){return Li.onDidChangeActiveColorTheme(we,De,Ne)},registerWebviewViewProvider(we,De,Ne){return Oi.registerWebviewViewProvider(ze,we,De,Ne?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,De,Ne){return kt.onDidChangeActiveNotebookEditor(we,De,Ne)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,De,Ne){return $i.onDidChangeNotebookEditorSelection(we,De,Ne)},onDidChangeNotebookEditorVisibleRanges(we,De,Ne){return $i.onDidChangeNotebookEditorVisibleRanges(we,De,Ne)},showNotebookDocument(we,De){return kt.showNotebookDocument(we,De)},registerExternalUriOpener(we,De,Ne){return(0,tt.$MF)(ze,"externalUriOpener"),dn.registerExternalUriOpener(ze.identifier,we,De,Ne)},registerProfileContentHandler(we,De){return(0,tt.$MF)(ze,"profileContentHandlers"),en.registrProfileContentHandler(ze,we,De)},registerQuickDiffProvider(we,De,Ne,at){return(0,tt.$MF)(ze,"quickDiffProvider"),Zi.registerQuickDiffProvider($t(we),De,Ne,at)},get tabGroups(){return xe.tabGroups},registerShareProvider(we,De){return(0,tt.$MF)(ze,"shareProvider"),Pi.registerShareProvider($t(we),De)}},cn={get rootPath(){return ne.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(we){throw new T.$8("rootPath")},getWorkspaceFolder(we){return gt.getWorkspaceFolder(we)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(we){throw new T.$8("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(we){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(we,De,...Ne)=>gt.updateWorkspaceFolders(ze,we,De||0,...Ne),onDidChangeWorkspaceFolders:function(we,De,Ne){return gt.onDidChangeWorkspace(we,De,Ne)},asRelativePath:(we,De)=>gt.getRelativePath(we,De),findFiles:(we,De,Ne,at)=>gt.findFiles(we,De,Ne,ze.identifier,at),findTextInFiles:(we,De,Ne,at)=>{(0,tt.$MF)(ze,"findTextInFiles");let yt,Tt;return typeof De=="object"?(yt=De,Tt=Ne):(yt={},Tt=De,at=Ne),gt.findTextInFiles(we,yt||{},Tt,ze.identifier,at)},save:we=>((0,tt.$MF)(ze,"saveEditor"),gt.save(we)),saveAs:we=>((0,tt.$MF)(ze,"saveEditor"),gt.saveAs(we)),saveAll:we=>gt.saveAll(we),applyEdit(we,De){return yi.applyWorkspaceEdit(we,ze,De)},createFileSystemWatcher:(we,De,Ne,at)=>{let yt;return typeof De=="boolean"?yt={ignoreCreateEvents:!!De,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!at,correlate:!1}:De&&((0,tt.$MF)(ze,"createFileSystemWatcher"),yt={...De,correlate:!0}),xt.createFileSystemWatcher(gt,ze,we,yt)},get textDocuments(){return Ct.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new T.$8("textDocuments")},openTextDocument(we){let De;const Ne=we;if(typeof we=="string")De=Promise.resolve(y.URI.file(we));else if(y.URI.isUri(we))De=Promise.resolve(we);else if(!Ne||typeof Ne=="object")De=Ct.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(at=>Ct.ensureDocumentData(at).then(yt=>yt.document))},onDidOpenTextDocument:(we,De,Ne)=>Ct.onDidAddDocument(we,De,Ne),onDidCloseTextDocument:(we,De,Ne)=>Ct.onDidRemoveDocument(we,De,Ne),onDidChangeTextDocument:(we,De,Ne)=>Ct.onDidChangeDocument(we,De,Ne),onDidSaveTextDocument:(we,De,Ne)=>Ct.onDidSaveDocument(we,De,Ne),onWillSaveTextDocument:(we,De,Ne)=>hn.getOnWillSaveTextDocumentEvent(ze)(we,De,Ne),get notebookDocuments(){return kt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,De){let Ne;if(y.URI.isUri(we))Ne=we,await kt.openNotebookDocument(we);else if(typeof we=="string")Ne=y.URI.revive(await kt.createNotebookDocument({viewType:we,content:De}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(we,De,Ne){return mi.onDidSaveNotebookDocument(we,De,Ne)},onDidChangeNotebookDocument(we,De,Ne){return mi.onDidChangeNotebookDocument(we,De,Ne)},onWillSaveNotebookDocument(we,De,Ne){return Di.getOnWillSaveNotebookDocumentEvent(ze)(we,De,Ne)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(we,De,Ne,at){return kt.registerNotebookSerializer(ze,we,De,Ne,(0,tt.$LF)(ze,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(we,De,Ne)=>zi.onDidChangeConfiguration(we,De,Ne),getConfiguration(we,De){return De=arguments.length===1?void 0:De,zi.getConfiguration(we,De,ze)},registerTextDocumentContentProvider(we,De){return Yi.registerTextDocumentContentProvider(we,De)},registerTaskProvider:(we,De)=>(ne.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(ze,we,De)),registerFileSystemProvider(we,De,Ne){return(0,R.$Oc)(Ii.registerFileSystemProvider(ze,we,De,Ne),Pt.addFileSystemProvider(we,De,Ne))},get fs(){return Pt.value},registerFileSearchProvider:(we,De)=>((0,tt.$MF)(ze,"fileSearchProvider"),Lt.registerFileSearchProvider(we,De)),registerTextSearchProvider:(we,De)=>((0,tt.$MF)(ze,"textSearchProvider"),Lt.registerTextSearchProvider(we,De)),registerRemoteAuthorityResolver:(we,De)=>((0,tt.$MF)(ze,"resolvers"),At.registerRemoteAuthorityResolver(we,De)),registerResourceLabelFormatter:we=>((0,tt.$MF)(ze,"resolvers"),xi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,tt.$MF)(ze,"resolvers"),At.getRemoteExecServer(we)),onDidCreateFiles:(we,De,Ne)=>xt.onDidCreateFile(we,De,Ne),onDidDeleteFiles:(we,De,Ne)=>xt.onDidDeleteFile(we,De,Ne),onDidRenameFiles:(we,De,Ne)=>xt.onDidRenameFile(we,De,Ne),onWillCreateFiles:(we,De,Ne)=>xt.getOnWillCreateFileEvent(ze)(we,De,Ne),onWillDeleteFiles:(we,De,Ne)=>xt.getOnWillDeleteFileEvent(ze)(we,De,Ne),onWillRenameFiles:(we,De,Ne)=>xt.getOnWillRenameFileEvent(ze)(we,De,Ne),openTunnel:we=>((0,tt.$MF)(ze,"tunnels"),Ce.openTunnel(ze,we).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,tt.$MF)(ze,"tunnels"),Ce.getTunnels()},onDidChangeTunnels:(we,De,Ne)=>((0,tt.$MF)(ze,"tunnels"),Ce.onDidChangeTunnels(we,De,Ne)),registerPortAttributesProvider:(we,De)=>((0,tt.$MF)(ze,"portsAttributes"),Ce.registerPortsAttributesProvider(we,De)),registerTunnelProvider:(we,De)=>((0,tt.$MF)(ze,"tunnelFactory"),Ce.registerTunnelProvider(we,De)),registerTimelineProvider:(we,De)=>((0,tt.$MF)(ze,"timeline"),_i.registerTimelineProvider(we,De,ze.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:we=>((0,tt.$MF)(ze,"workspaceTrust"),gt.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,De,Ne)=>gt.onDidGrantWorkspaceTrust(we,De,Ne),registerEditSessionIdentityProvider:(we,De)=>((0,tt.$MF)(ze,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(we,De)),onWillCreateEditSessionIdentity:(we,De,Ne)=>((0,tt.$MF)(ze,"editSessionIdentityProvider"),gt.getOnWillCreateEditSessionIdentityEvent(ze)(we,De,Ne)),registerCanonicalUriProvider:(we,De)=>((0,tt.$MF)(ze,"canonicalUriProvider"),gt.registerCanonicalUriProvider(we,De)),getCanonicalUri:(we,De,Ne)=>((0,tt.$MF)(ze,"canonicalUriProvider"),gt.provideCanonicalUri(we,De,Ne))},un={get inputBox(){return ne.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(ze)},createSourceControl(we,De,Ne){return hi.createSourceControl(ze,we,De,Ne)},registerSourceControlInputBoxValueProvider(we){return(0,tt.$MF)(ze,"scmInputBoxValueProvider"),hi.registerSourceControlInputBoxValueProvider(ze,we)}},ln={createCommentController(we,De){return Ai.createCommentController(ze,we,De)}},Wi={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},get stackFrameFocus(){return ht.stackFrameFocus},onDidStartDebugSession(we,De,Ne){return ht.onDidStartDebugSession(we,De,Ne)},onDidTerminateDebugSession(we,De,Ne){return ht.onDidTerminateDebugSession(we,De,Ne)},onDidChangeActiveDebugSession(we,De,Ne){return ht.onDidChangeActiveDebugSession(we,De,Ne)},onDidReceiveDebugSessionCustomEvent(we,De,Ne){return ht.onDidReceiveDebugSessionCustomEvent(we,De,Ne)},onDidChangeBreakpoints(we,De,Ne){return ht.onDidChangeBreakpoints(we,De,Ne)},onDidChangeStackFrameFocus(we,De,Ne){return(0,tt.$MF)(ze,"debugFocus"),ht.onDidChangeStackFrameFocus(we,De,Ne)},registerDebugConfigurationProvider(we,De,Ne){return ht.registerDebugConfigurationProvider(we,De,Ne||Mt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,De){return ht.registerDebugAdapterDescriptorFactory(ze,we,De)},registerDebugAdapterTrackerFactory(we,De){return ht.registerDebugAdapterTrackerFactory(we,De)},startDebugging(we,De,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?ht.startDebugging(we,De,{parentSession:Ne}):ht.startDebugging(we,De,Ne||{})},stopDebugging(we){return ht.stopDebugging(we)},addBreakpoints(we){return ht.addBreakpoints(we)},removeBreakpoints(we){return ht.removeBreakpoints(we)},asDebugSourceUri(we,De){return ht.asDebugSourceUri(we,De)}},Vi={registerTaskProvider:(we,De)=>Qt.registerTaskProvider(ze,we,De),fetchTasks:we=>Qt.fetchTasks(we),executeTask:we=>Qt.executeTask(ze,we),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(we,De,Ne)=>Qt.onDidStartTask(we,De,Ne),onDidEndTask:(we,De,Ne)=>Qt.onDidEndTask(we,De,Ne),onDidStartTaskProcess:(we,De,Ne)=>Qt.onDidStartTaskProcess(we,De,Ne),onDidEndTaskProcess:(we,De,Ne)=>Qt.onDidEndTaskProcess(we,De,Ne)},qi={createNotebookController(we,De,Ne,at,yt){return oi.createNotebookController(ze,we,De,Ne,at,(0,tt.$LF)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(we,De)=>kt.registerNotebookCellStatusBarItemProvider(ze,we,De),createRendererMessaging(we){return Si.createRendererMessaging(ze,we)},createNotebookControllerDetectionTask(we){return(0,tt.$MF)(ze,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(ze,we)},registerKernelSourceActionProvider(we,De){return(0,tt.$MF)(ze,"notebookKernelSource"),oi.registerKernelSourceActionProvider(ze,we,De)},onDidChangeNotebookCellExecutionState(we,De,Ne){return(0,tt.$MF)(ze,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,De,Ne)}},li={t(...we){if(typeof we[0]=="string"){const De=we.shift(),Ne=!we||typeof we[0]!="object"?we:we[0];return si.getMessage(ze.identifier.value,{message:De,args:Ne})}return si.getMessage(ze.identifier.value,we[0])},get bundle(){return si.getBundle(ze.identifier.value)},get uri(){return si.getBundleUri(ze.identifier.value)}},Ki={_version:1,registerInteractiveEditorSessionProvider(we,De){return(0,tt.$MF)(ze,"interactive"),Ni.registerProvider(ze,we,De)},registerInteractiveSessionProvider(we,De){return(0,tt.$MF)(ze,"interactive"),wi.registerChatProvider(ze,we,De)},sendInteractiveRequestToProvider(we,De){return(0,tt.$MF)(ze,"interactive"),wi.sendInteractiveRequestToProvider(we,De)},get onDidPerformUserAction(){return(0,tt.$MF)(ze,"interactiveUserActions"),wi.onDidPerformUserAction},transferChatSession(we,De){return(0,tt.$MF)(ze,"interactive"),wi.transferChatSession(we,De)}},Hi={getRelatedInformation(we,De){return(0,tt.$MF)(ze,"aiRelatedInformation"),vi.getRelatedInformation(ze,we,De)},registerRelatedInformationProvider(we,De){return(0,tt.$MF)(ze,"aiRelatedInformation"),vi.registerRelatedInformationProvider(ze,we,De)},registerEmbeddingVectorProvider(we,De){return(0,tt.$MF)(ze,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(ze,we,De)}},Gi={registerChatResponseProvider(we,De,Ne){return(0,tt.$MF)(ze,"chatProvider"),pi.registerProvider(ze.identifier,we,De,Ne)},requestChatAccess(we){return(0,tt.$MF)(ze,"chatRequestAccess"),pi.requestChatResponseProvider(ze.identifier,we)},registerVariable(we,De,Ne){return(0,tt.$MF)(ze,"chatVariables"),nn.registerVariableResolver(ze,we,De,Ne)},registerMappedEditsProvider(we,De){return(0,tt.$MF)(ze,"mappedEditsProvider"),dt.registerMappedEditsProvider(ze,we,De)},createChatAgent(we,De){return(0,tt.$MF)(ze,"chatAgents2"),tn.createChatAgent(ze,we,De)}},Ji={registerSpeechProvider(we,De){return(0,tt.$MF)(ze,"speech"),fn.registerProvider(ze.identifier,we,De)}};return{version:mt.version,ai:Hi,authentication:gn,commands:mn,comments:ln,chat:Gi,debug:Wi,env:Ui,extensions:on,interactive:Ki,l10n:li,languages:an,notebooks:qi,scm:un,speech:Ji,tasks:Vi,tests:Bi,window:$n,workspace:cn,Breakpoint:Ue.$xL,TerminalOutputAnchor:Ue.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ue.ChatAgentResultFeedbackKind,ChatMessage:Ue.$oM,ChatMessageRole:Ue.ChatMessageRole,ChatVariableLevel:Ue.ChatVariableLevel,CallHierarchyIncomingCall:Ue.$WK,CallHierarchyItem:Ue.$VK,CallHierarchyOutgoingCall:Ue.$XK,CancellationError:T.$4,CancellationTokenSource:D.$2d,CandidatePortSource:r.CandidatePortSource,CodeAction:Ue.$SK,CodeActionKind:Ue.$TK,CodeActionTriggerKind:Ue.CodeActionTriggerKind,CodeLens:Ue.$YK,Color:Ue.$_K,ColorInformation:Ue.$aL,ColorPresentation:Ue.$bL,ColorThemeKind:Ue.ColorThemeKind,CommentMode:Ue.CommentMode,CommentState:Ue.CommentState,CommentThreadCollapsibleState:Ue.CommentThreadCollapsibleState,CommentThreadState:Ue.CommentThreadState,CompletionItem:Ue.$6K,CompletionItemKind:Ue.CompletionItemKind,CompletionItemTag:Ue.CompletionItemTag,CompletionList:Ue.$7K,CompletionTriggerKind:Ue.CompletionTriggerKind,ConfigurationTarget:Ue.ConfigurationTarget,CustomExecution:Ue.$jL,DebugAdapterExecutable:Ue.$BL,DebugAdapterInlineImplementation:Ue.$EL,DebugAdapterNamedPipeServer:Ue.$DL,DebugAdapterServer:Ue.$CL,DebugConfigurationProviderTriggerKind:Mt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ue.DebugConsoleMode,DecorationRangeBehavior:Ue.DecorationRangeBehavior,Diagnostic:Ue.$NK,DiagnosticRelatedInformation:Ue.$MK,DiagnosticSeverity:Ue.DiagnosticSeverity,DiagnosticTag:Ue.DiagnosticTag,Disposable:Ue.$zK,DocumentHighlight:Ue.$PK,DocumentHighlightKind:Ue.DocumentHighlightKind,DocumentLink:Ue.$$K,DocumentSymbol:Ue.$RK,EndOfLine:Ue.EndOfLine,EnvironmentVariableMutatorType:Ue.EnvironmentVariableMutatorType,EvaluatableExpression:Ue.$HL,InlineValueText:Ue.$IL,InlineValueVariableLookup:Ue.$JL,InlineValueEvaluatableExpression:Ue.$KL,InlineCompletionTriggerKind:Ue.InlineCompletionTriggerKind,EventEmitter:g.$Rd,ExtensionKind:Ue.ExtensionKind,ExtensionMode:Ue.ExtensionMode,ExternalUriOpenerPriority:Ue.ExternalUriOpenerPriority,FileChangeType:Ue.FileChangeType,FileDecoration:Ue.$UL,FileDecoration2:Ue.$UL,FileSystemError:Ue.$ML,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Ue.$NL,FoldingRangeKind:Ue.FoldingRangeKind,FunctionBreakpoint:Ue.$zL,InlineCompletionItem:Ue.$8K,InlineCompletionList:Ue.$9K,Hover:Ue.$OK,IndentAction:C.IndentAction,Location:Ue.$LK,MarkdownString:Ue.$ZK,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Ue.$1K,PortAutoForwardAction:Ue.PortAutoForwardAction,Position:Ue.$AK,ProcessExecution:Ue.$hL,ProgressLocation:Ue.ProgressLocation,QuickInputButtons:Ue.$TL,Range:Ue.$BK,RelativePattern:Ue.$vL,Selection:Ue.$CK,SelectionRange:Ue.$UK,SemanticTokens:Ue.$QL,SemanticTokensBuilder:Ue.$PL,SemanticTokensEdit:Ue.$RL,SemanticTokensEdits:Ue.$SL,SemanticTokensLegend:Ue.$OL,ShellExecution:Ue.$iL,ShellQuoting:Ue.ShellQuoting,SignatureHelp:Ue.$3K,SignatureHelpTriggerKind:Ue.SignatureHelpTriggerKind,SignatureInformation:Ue.$2K,SnippetString:Ue.$KK,SourceBreakpoint:Ue.$yL,StandardTokenType:Ue.StandardTokenType,StatusBarAlignment:Ue.StatusBarAlignment,SymbolInformation:Ue.$QK,SymbolKind:Ue.SymbolKind,SymbolTag:Ue.SymbolTag,Task:Ue.$kL,TaskGroup:Ue.$gL,TaskPanelKind:Ue.TaskPanelKind,TaskRevealKind:Ue.TaskRevealKind,TaskScope:Ue.TaskScope,TerminalLink:Ue.$cL,TerminalQuickFixExecuteTerminalCommand:Ue.$eL,TerminalQuickFixOpener:Ue.$dL,TerminalLocation:Ue.TerminalLocation,TerminalProfile:Ue.$fL,TerminalExitReason:Ue.TerminalExitReason,TextDocumentSaveReason:Ue.TextDocumentSaveReason,TextEdit:Ue.$GK,SnippetTextEdit:Ue.$IK,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ue.TextEditorLineNumbersStyle,TextEditorRevealType:Ue.TextEditorRevealType,TextEditorSelectionChangeKind:Ue.TextEditorSelectionChangeKind,SyntaxTokenType:Ue.SyntaxTokenType,TextDocumentChangeReason:Ue.TextDocumentChangeReason,ThemeColor:Ue.$uL,ThemeIcon:Ue.$tL,TreeItem:Ue.$lL,TreeItemCheckboxState:Ue.TreeItemCheckboxState,TreeItemCollapsibleState:Ue.TreeItemCollapsibleState,TypeHierarchyItem:Ue.$dM,UIKind:Wt.UIKind,Uri:y.URI,ViewColumn:Ue.ViewColumn,WorkspaceEdit:Ue.$JK,DocumentDropEdit:Ue.$rL,DocumentPasteEdit:Ue.$sL,InlayHint:Ue.$5K,InlayHintLabelPart:Ue.$4K,InlayHintKind:Ue.InlayHintKind,RemoteAuthorityResolverError:Ue.$FK,ResolvedAuthority:Ue.$DK,ManagedResolvedAuthority:Ue.$EK,SourceControlInputBoxValidationType:Ue.SourceControlInputBoxValidationType,ExtensionRuntime:Ue.ExtensionRuntime,TimelineItem:Ue.$5L,NotebookRange:Ue.$WL,NotebookCellKind:Ue.NotebookCellKind,NotebookCellExecutionState:Ue.NotebookCellExecutionState,NotebookCellData:Ue.$XL,NotebookData:Ue.$YL,NotebookRendererScript:Ue.$3L,NotebookCellStatusBarAlignment:Ue.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ue.NotebookEditorRevealType,NotebookCellOutput:Ue.$1L,NotebookCellOutputItem:Ue.$ZL,NotebookCellStatusBarItem:Ue.$2L,NotebookControllerAffinity:Ue.NotebookControllerAffinity,NotebookControllerAffinity2:Ue.NotebookControllerAffinity2,NotebookEdit:Ue.$HK,NotebookKernelSourceAction:Ue.$4L,NotebookVariablesRequestKind:Ue.NotebookVariablesRequestKind,PortAttributes:Ue.$7L,LinkedEditingRanges:Ue.$6L,TestResultState:Ue.TestResultState,TestRunRequest:Ue.$8L,TestMessage:Ue.$9L,TestMessage2:Ue.$9L,TestTag:Ue.$0L,TestRunProfileKind:Ue.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Ue.$qL,DataTransferItem:Ue.$mL,CoveredCount:Ue.$$L,FileCoverage:Ue.$_L,StatementCoverage:Ue.$aM,BranchCoverage:Ue.$bM,FunctionCoverage:Ue.$cM,WorkspaceTrustState:Ue.WorkspaceTrustState,LanguageStatusSeverity:Ue.LanguageStatusSeverity,QuickPickItemKind:Ue.QuickPickItemKind,InputBoxValidationSeverity:Ue.InputBoxValidationSeverity,TabInputText:Ue.$eM,TabInputTextDiff:Ue.$fM,TabInputTextMerge:Ue.$gM,TabInputCustom:Ue.$hM,TabInputNotebook:Ue.$jM,TabInputNotebookDiff:Ue.$kM,TabInputWebview:Ue.$iM,TabInputTerminal:Ue.$lM,TabInputInteractiveWindow:Ue.$mM,TabInputChat:Ue.$nM,TelemetryTrustedValue:i.$po,LogLevel:w.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ue.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ue.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ue.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ue.$FL,ThreadFocus:Ue.$GL,RelatedInformationType:Ue.RelatedInformationType,SpeechToTextStatus:Ue.SpeechToTextStatus}}}e.$$fc=qt}),define(ke[370],Se([1,0,106,154,41,151,42,35,69,46,95,96,97,118,72,91,153,71,57,117,90,70,152,14,58,115,116]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Cr)(l.$Zec,l.$Yec,1),(0,D.$Cr)(s.$ej,t.$_fc,1),(0,D.$Cr)(w.$$dc,w.$_dc,1),(0,D.$Cr)(b.$VM,b.$UM,0),(0,D.$Cr)(L.$tec,L.$rec,0),(0,D.$Cr)(o.$vec,o.$uec,0),(0,D.$Cr)(C.$0ec,C.$bfc,0),(0,D.$Cr)(R.$dfc,R.$cfc,0),(0,D.$Cr)(y.$KM,y.$JM,0),(0,D.$Cr)(c.$1ec,c.$2ec,0),(0,D.$Cr)(i.$8dc,i.$7dc,0),(0,D.$Cr)(T.$Jfc,T.$Ifc,1),(0,D.$Cr)($.$tfc,$.$ufc,0),(0,D.$Cr)(v.$Oec,v.$Nec,0),(0,D.$Cr)(A.$Wfc,A.$Vfc,0),(0,D.$Cr)(m.$Rec,m.$Uec,0),(0,D.$Cr)(S.$axb,S.$bxb,0),(0,D.$Cr)(u.$0fc,u.$9fc,0),(0,D.$Cr)(g.$qec,g.$pec,0),(0,D.$Cr)(n.$Wec,n.$Vec,0),(0,D.$Cr)(r.$TM,r.$QM,0),(0,D.$Cr)(a.$Fec,a.$Gec,0),(0,D.$Cr)(d.$8ec,d.$9ec,0)}),define(ke[119],Se([1,0,19,14,36,94]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=e.$qgc=e.$pgc=void 0;function L(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$pgc=L;function b(C,$,v,S){const w=(0,D.$1b)(v,y),u=new g.$1I($,w,S),o=u.preview.matches;return{ranges:(0,D.$1b)(w,m),uri:C,preview:{text:u.preview.text,matches:(0,D.$1b)(o,m)}}}e.$qgc=b;function y(C){return new g.$2I(C.start.line,C.start.character,C.end.line,C.end.character)}function m(C){return new R.$PI(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let A=class{constructor($,v){this.a=$,this.b=v}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$rgc=A,e.$rgc=A=He([Be(1,T.$dj)],A)}),define(ke[371],Se([1,0,50,16,76,33,11,13,119,372]),function(me,e,D,T,g,R,L,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=e.$tgc=e.$sgc=void 0;const A=m.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,r,a,t){const s=$(n,r,a,t),d=r.folder.fsPath;return{cmd:D.spawn(A,s.args,{cwd:d}),rgDiskPath:A,siblingClauses:s.siblingClauses,rgArgs:s,cwd:d}}e.$sgc=C;function $(n,r,a,t){const s=["--files","--hidden","--case-sensitive","--no-require-git"];S([r],a,!1).forEach(l=>{const c=(0,y.$pgc)(l);if(s.push("-g",c),L.$j){const h=(0,g.$vl)(c);h!==c&&s.push("-g",h)}});const d=v([r],t,void 0,!1);return d.globArgs.forEach(l=>{const c=`!${(0,y.$pgc)(l)}`;if(s.push("-g",c),L.$j){const h=(0,g.$vl)(c);h!==c&&s.push("-g",h)}}),r.disregardIgnoreFiles!==!1?s.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),r.ignoreSymlinks||s.push("--follow"),n.exists&&s.push("--quiet"),s.push("--no-config"),r.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:d.siblingClauses}}function v(n,r,a,t=!0){const s=[];let d={};return n.forEach(l=>{const c=Object.assign({},l.excludePattern||{},r||{}),h=w(c,t?l.folder.fsPath:void 0,a);s.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:s,siblingClauses:d}}function S(n,r,a=!0){const t=[];return n.forEach(s=>{const d=Object.assign({},r||{},s.includePattern||{}),l=w(d,a?s.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function w(n,r,a){const t=[],s={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const l=n[d];d=o(r?u(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):l&&l.when&&(s[d]=l)}),{globArgs:t,siblingClauses:s}}function u(n,r){return T.$hc(r)?r:T.$ic(n,r)}e.$tgc=u;function o(n){return n=b.$Oe(n,"\\"),b.$Oe(n,"/")}function i(n){return R.$Xf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$ugc=i}),define(ke[373],Se([1,0,50,55,16,374,19,43,34,76,33,11,38,13,18,31,36,371,130]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&y.$Cj(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Eq)(this.b).normalizedLowercase),this.u=l.excludePattern&&y.$Cj(l.excludePattern),this.t=new Map,l.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),E=c.folder.fsPath;l.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==E).forEach(I=>{(0,A.$2f)(I,E)&&(h[g.$kc(E,I)]=!0)}),this.t.set(E,new t(h,E))})}cancel(){this.l=!0,n.forEach(l=>l())}walk(l,c,h,E,I){if(this.m=$.$Nd.create(!1),this.l)return I(null,this.j);c.forEach(f=>{const p=g.$mc(f.fsPath);this.u&&this.u(f.fsPath,p)||this.J(h,{relativePath:f.fsPath,searchPath:void 0})}),this.r=$.$Nd.create(!1),this.w(l,(f,p)=>{this.x(this.y,this,f,h,E,k=>{if(k){const P=(0,b.$Gi)(k);console.error(P),this.q.push(P),p(k,void 0)}else p(null,void 0)})},(f,p)=>{this.m.stop();const k=f?L.$Gb(f)[0]:null;I(k,this.j)})}w(l,c,h){const E=new Array(l.length),I=new Array(l.length);let f=!1,p=0;if(l.length===0)return h(null,[]);l.forEach((k,P)=>{c(k,(j,z)=>{if(j?(f=!0,E[P]=null,I[P]=j):(E[P]=z,I[P]=null),++p===l.length)return h(f?I:null,E)})})}x(l,c,...h){try{l.apply(c,h)}catch(E){h[h.length-1](E)}}y(l,c,h,E){const I=l.folder.fsPath,f=C.$j,p=()=>M&&M.kill();n.add(p);let k=W=>{n.delete(p),k=()=>{},E(W)},P="";const j=this.D(),z=(0,o.$sgc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),M=z.cmd,F=!Object.keys(z.siblingClauses).length,N=z.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let O=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:O}),this.s=0,this.z(M,"utf8",h,(W,x,ce)=>{if(W){k(W);return}if(this.j){k();return}const G=(P+(f?m.$ul(x||""):x)).split(`
`);if(ce){const J=G.length;G[J-1]=G[J-1].trim(),G[J-1]||G.pop()}else P=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=G.length,F){for(const J of G)if(this.J(c,{base:I,relativePath:J,searchPath:this.N(l,J)}),this.j){p();break}(ce||this.j)&&k();return}this.G(l,j,I,G,c),ce&&(this.H(j,I,c),k())})}spawnFindCmd(l){const c=this.t.get(l.folder.fsPath),h=c.getBasenameTerms(),E=c.getPathTerms(),I=["-L","."];if(h.length||E.length){I.push("-not","(","(");for(const f of h)I.push("-name",f),I.push("-o");for(const f of E)I.push("-path",f),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),D.spawn("find",I,{cwd:l.folder.fsPath})}readStdout(l,c,h){let E="";this.z(l,c,()=>{},(I,f,p)=>{if(I){h(I);return}E+=f,p&&h(null,E)})}z(l,c,h,E){let I=(k,P,j)=>{(k||j)&&(I=()=>{},this.r?.stop()),E(k,P,j)},f=!1;l.stdout?(this.A(l.stdout,c,I),l.stdout.once("data",()=>f=!0)):h({message:"stdout is null"});let p;l.stderr?p=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",k=>{I(k)}),l.on("close",k=>{let P;!f&&(P=this.C(p,c))&&s(P)?I(new Error(`command failed with error code ${k}: ${this.C(p,c)}`)):(this.g&&k===0&&(this.j=!0),I(null,"",!0))})}A(l,c,h){const E=new R.StringDecoder(c);return l.on("data",I=>{h(null,E.write(I))}),E}B(l){const c=[];return l.on("data",h=>{c.push(h)}),c}C(l,c){const h=new R.StringDecoder(c);return l.map(E=>h.write(E)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:c},h,E,I){E.indexOf(this.b)!==-1&&this.J(I,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const f=p=>{const k=g.$mc(p),P=g.$lc(p);let j=c[P];j||(j=c[P]=[],f(P)),j.push({base:h,relativePath:p,basename:k,searchPath:this.N(l,p)})};E.forEach(f)}H({rootEntries:l,pathToEntries:c},h,E){const I=this,f=this.t.get(h),p=this.b;function k(P){I.o++;const j=(0,u.$eJ)(()=>P.map(z=>z.basename));for(let z=0,M=P.length;z<M;z++){const F=P[z],{relativePath:N,basename:O}=F;if(f.test(N,O,p!==O?j:void 0))continue;const W=c[N];if(W)k(W);else{if(I.p++,N===p)continue;I.J(E,F)}if(I.j)break}}k(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,c,h,E,I){const f=l.folder,p=(0,u.$eJ)(()=>h);this.w(h,(k,P)=>{if(this.l||this.j)return P(null);const j=c?[c,k].join(g.sep):k;if(this.t.get(l.folder.fsPath).test(j,k,this.a.filePattern!==k?p:void 0))return P(null);const z=[f.fsPath,j].join(g.sep);T.lstat(z,(M,F)=>{if(M||this.l||this.j)return P(null);this.L(z,F,(N,O)=>N||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(z,F,(W,x)=>W||this.l||this.j||(x=x||"",this.v[x])?P(null):(this.v[x]=!0,w.Promises.readdir(z).then(ce=>{if(this.l||this.j)return P(null);this.I(l,j,ce,E,Y=>P(Y||null))},ce=>{P(null)})))):(this.p++,j===this.b||this.h&&S.$Gf(O.size)&&O.size>this.h||this.J(E,{base:f.fsPath,relativePath:j,searchPath:this.N(l,j)}),P(null,void 0)))})},k=>{const P=k&&L.$Gb(k);return I(P&&P.length>0?P[0]:void 0)})}J(l,c){this.K(c)&&(!this.d||this.d(c.relativePath,g.$mc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(c))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.$_I)(l,this.c)}return!0}L(l,c,h){return c.isSymbolicLink()?T.stat(l,h):h(null,c)}M(l,c,h){return c.isSymbolicLink()?T.realpath(l,(E,I)=>E?h(E):h(null,I)):h(null,l)}N(l,c){return l.folderName?g.$ic(l.folderName,c):c}}e.$vgc=r;class a{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,c,h){this.c.walk(this.a,this.b,l,c,(E,I)=>{h(E,{limitHit:I,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$wgc=a;class t{constructor(l,c){this.expression=l,this.c=c,this.d(l)}d(l){let c,h;Object.keys(l).filter(E=>l[E]).forEach(E=>{g.$hc(E)?(c=c||y.$xj(),c[E]=l[E]):(h=h||y.$xj(),h[E]=l[E])}),this.a=c&&y.$Cj(c,{trimForExclusions:!0}),this.b=h&&y.$Cj(h,{trimForExclusions:!0})}test(l,c,h){return this.b&&this.b(l,c,h)||this.a&&this.a(g.$ic(this.c,l),c,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...y.$Ej(this.a)),this.b&&l.push(...y.$Ej(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...y.$Fj(this.a)),this.b&&l.push(...y.$Fj(this.b)),l}}function s(d){const l=d.trim().split(`
`),c=l[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return v.$uf(l[l.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ke[375],Se([1,0,98,22,186,21]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.DecodeStreamErrorKind=e.$WC=e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=void 0,e.$PC="utf8",e.$QC="utf8bom",e.$RC="utf16be",e.$SC="utf16le";function L(c){return[e.$PC,e.$QC,e.$RC,e.$SC].some(h=>h===c)}e.$TC=L,e.$UC=[254,255],e.$VC=[255,254],e.$WC=[239,187,191];const b=512,y=512,m=512*8,A=512*128;var C;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class $ extends Error{constructor(h,E){super(h),this.decodeStreamErrorKind=E}}e.$XC=$;class v{static async create(h){let E;if(h!==e.$PC)E=(await(0,g.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const I=new TextDecoder;E={write(f){return I.decode(f,{stream:!0})},end(){return I.decode()}}}return new v(E)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function S(c,h){const E=h.minBytesRequiredForDetection??h.guessEncoding?m:y;return new Promise((I,f)=>{const p=(0,D.$6d)(F=>F.join("")),k=[];let P=0,j;const z=new R.$2d,M=async()=>{try{const F=await l({buffer:T.$fe.concat(k),bytesRead:P},h.guessEncoding);if(F.seemsBinary&&h.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);F.encoding=await h.overwriteEncoding(F.encoding),j=await v.create(F.encoding);const N=j.write(T.$fe.concat(k).buffer);p.write(N),k.length=0,P=0,I({stream:p,detected:F})}catch(F){z.cancel(),p.destroy(),f(F)}};(0,D.$0d)(c,{onData:async F=>{j?p.write(j.write(F.buffer)):(k.push(F),P+=F.byteLength,P>=E&&(c.pause(),await M(),setTimeout(()=>c.resume())))},onError:F=>p.error(F),onEnd:async()=>{j||await M(),p.end(j?.end())}},z.token)})}e.$YC=S;async function w(c,h,E){const f=(await(0,g.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),E);let p=!1,k=!1;return{read(){if(k)return null;const P=c.read();if(typeof P!="string"){if(k=!0,!p&&E?.addBOM)switch(h){case e.$PC:case e.$QC:return T.$fe.wrap(Uint8Array.from(e.$WC));case e.$RC:return T.$fe.wrap(Uint8Array.from(e.$UC));case e.$SC:return T.$fe.wrap(Uint8Array.from(e.$VC))}const j=f.end();return j&&j.length>0?(p=!0,T.$fe.wrap(j)):null}return p=!0,T.$fe.wrap(f.write(P))}}}e.$ZC=w;async function u(c){return(await(0,g.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}e.$1C=u;function o(c){return c===e.$QC||c===null?e.$PC:c}e.$2C=o;function i(c,h){if(!c||h<e.$UC.length)return null;const E=c.readUInt8(0),I=c.readUInt8(1);if(E===e.$UC[0]&&I===e.$UC[1])return e.$RC;if(E===e.$VC[0]&&I===e.$VC[1])return e.$SC;if(h<e.$WC.length)return null;const f=c.readUInt8(2);return E===e.$WC[0]&&I===e.$WC[1]&&f===e.$WC[2]?e.$QC:null}e.$3C=i;const n=["ascii","utf-16","utf-32"];async function r(c){const h=await(0,g.$OC)("jschardet","dist/jschardet.min.js"),E=c.slice(0,A),I=s(E.buffer),f=h.detect(I);if(!f||!f.encoding)return null;const p=f.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(f.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function s(c){let h="";for(let E=0;E<c.length;E++)h+=String.fromCharCode(c[E]);return h}function d(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}e.$4C=d;function l({buffer:c,bytesRead:h},E){let I=i(c,h),f=!1;if(I!==e.$RC&&I!==e.$SC&&c){let p=!0,k=!0,P=!1;for(let j=0;j<h&&j<b;j++){const z=j%2===1,M=c.readUInt8(j)===0;if(M&&(P=!0),p&&(z&&!M||!z&&M)&&(p=!1),k&&(z&&M||!z&&!M)&&(k=!1),M&&!p&&!k)break}P&&(p?I=e.$SC:k?I=e.$RC:f=!0)}return E&&!f&&!I&&c?r(c.slice(0,h)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:f,encoding:I}}e.$5C=l,e.$6C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[157],Se([1,0,375,31,156]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class R extends g.$pfc{constructor(b,y,m=T,A="searchProcess"){super(b,y,{readdir:C=>m.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$4C)(C)},A)}}e.$Egc=R}),define(ke[158],Se([1,0,50,391,374,19,73,34,16,13,2,36,94,392,372,119]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=e.$Bgc=e.$Agc=e.$zgc=e.$ygc=e.$xgc=void 0;const u=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(k){this.a=k}provideTextSearchResults(k,P,j,z){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((M,F)=>{z.onCancellationRequested(()=>J());const N=s(k,P),O=P.folder.fsPath,W=N.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.a.appendLine(`${u} ${W}
 - cwd: ${O}`);let x=D.spawn(u,N,{cwd:O});x.on("error",K=>{console.error(K),this.a.appendLine("Error: "+(K&&K.message)),F((0,C.$8I)(new C.$6I(K&&K.message,C.SearchErrorCode.rgProcessError)))});let ce=!1;const Y=new r(P.maxResults,O,P.previewOptions);Y.on("result",K=>{ce=!0,Q="",j.report(K)});let G=!1;const J=()=>{G=!0,x?.kill(),Y?.cancel()};let le=!1;Y.on("hitLimit",()=>{le=!0,J()});let Q="";x.stdout.on("data",K=>{Y.handleData(K),ce||(Q+=K)});let Ee=!1;x.stdout.once("data",()=>Ee=!0);let he="";x.stderr.on("data",K=>{const U=K.toString();this.a.appendLine(U),he.length+U.length<1e6&&(he+=U)}),x.on("close",()=>{if(this.a.appendLine(Ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(ce?"Got result from parser":"No result from parser"),Q&&this.a.appendLine(`Got data without result: ${Q}`),this.a.appendLine(""),G)M({limitHit:le});else{Y.flush(),x=null;let K;he&&!Ee&&(K=i(he))?F((0,C.$8I)(new C.$6I(K.message,K.code))):M({limitHit:le})}})})}}e.$xgc=o;function i(p){const k=p.split(`
`),P=k[0].trim();if(k.some(z=>z.startsWith("regex parse error")))return new C.$6I(n(k),C.SearchErrorCode.regexParseError);const j=P.match(/grep config error: unknown encoding: (.*)/);if(j)return new C.$6I(`Unknown encoding: ${j[1]}`,C.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new C.$6I(P.charAt(0).toUpperCase()+P.substr(1),C.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new C.$6I(P.charAt(0).toUpperCase()+P.substr(1),C.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new C.$6I(P,C.SearchErrorCode.regexParseError)}function n(p){const k=["Regex parse error"],P=p.filter(j=>j.startsWith("PCRE2:"));if(P.length>=1){const j=P[0].replace("PCRE2:","");if(j.indexOf(":")!==-1&&j.split(":").length>=2){const z=j.split(":")[1];k.push(":"+z)}}return k.join("")}class r extends T.EventEmitter{constructor(k,P,j){super(),this.g=k,this.h=P,this.j=j,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,P){return super.on(k,P),this}handleData(k){if(this.b)return;const P=typeof k=="string"?k:this.d.write(k);this.k(P)}k(k){let P=k.indexOf(`
`);const j=this.a+k;if(P>=0)P+=this.a.length;else{this.a=j;return}let z=0;for(;P>=0;)this.m(j.substring(z,P).trim()),z=P+1,P=j.indexOf(`
`,z);this.a=j.substring(z)}m(k){if(this.b||!k)return;let P;try{P=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(P.type==="match"){const j=a(P.data.path),z=A.URI.file(y.$ic(this.h,j)),M=this.n(P.data,z);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const j=a(P.data.path),z=A.URI.file(y.$ic(this.h,j));this.o(P.data,z).forEach(F=>this.p(F))}}n(k,P){const j=k.line_number-1,z=a(k.lines),M=Buffer.from(z);let F=0,N=0,O=j;k.submatches.length===0&&k.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const W=(0,R.$Gb)(k.submatches.map((x,ce)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Y=a(x.match),G=M.slice(F,x.start).toString(),J=t(G),le=J.numLines>0?J.lastLineLength:J.lastLineLength+N,Q=t(Y),Ee=J.numLines+O,he=Q.numLines+Ee,K=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+le;return F=x.end,N=K,O=he,new $.$PI(Ee,le,he,K)}));return(0,w.$qgc)(P,z,W,this.j)}o(k,P){const j=a(k.lines),z=k.line_number;return j.replace(/\r?\n$/,"").split(`
`).map((M,F)=>({text:M,uri:P,lineNumber:z+F}))}p(k){this.emit("result",k)}}e.$ygc=r;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const k=/\n/g;let P=0,j=-1,z;for(;z=k.exec(p);)P++,j=z.index;const M=j>=0?p.length-j-1:p.length;return{numLines:P,lastLineLength:M}}function s(p,k){const P=["--hidden","--no-require-git"];P.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:j,otherIncludes:z}=(0,L.$J)(k.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(z&&z.length){const F=new Set;z.forEach(N=>{F.add(N)}),P.push("-g","!*"),F.forEach(N=>{d(N).map(w.$pgc).forEach(O=>{P.push("-g",O)})})}j&&j.length&&j.forEach(F=>{P.push("-g",F)}),k.excludes.map(w.$pgc).forEach(F=>P.push("-g",`!${F}`)),k.maxFileSize&&P.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),k.followSymlinks&&P.push("--follow"),k.encoding&&k.encoding!=="utf8"&&P.push("--encoding",k.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,m.$Je)(p.pattern),p.isRegExp=!0),k.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),p.isRegExp&&(p.pattern=l(p.pattern),P.push("--engine","auto"));let M;if(p.isWordMatch){const N=(0,m.$Re)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",N)}else if(p.isRegExp){let F=h(p.pattern);F=E(F),P.push("--regexp",F)}else M=p.pattern,P.push("--fixed-strings");return P.push("--no-config"),k.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),p.isMultiline&&P.push("--multiline"),k.beforeContext&&P.push("--before-context",k.beforeContext+""),k.afterContext&&P.push("--after-context",k.afterContext+""),P.push("--"),M&&P.push(M),P.push("."),P}e.$zgc=s;function d(p){return f(p).flatMap(P=>{const j=(0,b.$Aj)(P,"/");return j.map((z,M)=>j.slice(0,M+1).join("/"))})}function l(p){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(k);)p=p.replace(k,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(P);)p=p.replace(P,"$1\\x{$2}");return p}e.$Agc=l;const c=p=>p.type==="Assertion"&&p.kind==="lookbehind";function h(p){let k;try{k=new v.RegExpParser().parsePattern(p)}catch{return p}let P="",j=0;const z=(N,O,W)=>{P+=p.slice(j,N)+W,j=O},M=[];return new v.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const O=M[0];if(!O)z(N.start,N.end,"\\r?\\n");else if(!M.some(c))if(O.type==="CharacterClass")if(O.negate){const W=p.slice(O.start+2,N.start)+p.slice(N.end,O.end-1);O.parent?.type==="Quantifier"?z(O.start,O.end,W?`[^${W}]`:"."):z(O.start,O.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=p.slice(O.start+1,N.start)+p.slice(N.end,O.end-1);z(O.start,O.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else O.type==="Quantifier"&&z(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){M.unshift(N)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(N){M.unshift(N)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(N){M.unshift(N)},onCharacterClassLeave(){M.shift()},onAssertionEnter(N){c(N)&&M.push(N)},onAssertionLeave(N){M[0]===N&&M.shift()}}).visit(k),P+=p.slice(j),P}e.$Bgc=h;function E(p){return p.replace(/\n/g,"\\r?\\n")}e.$Cgc=E;function I(p){let k=!1,P=!1,j="",z="";for(let M=0;M<p.length;M++){const F=p[M];switch(F){case"\\":P?(k?z+="\\"+F:j+="\\"+F,P=!1):P=!0;break;case"{":if(P)k?z+=F:j+=F,P=!1;else{if(k)return{strInBraces:j+"{"+z+"{"+p.substring(M+1)};k=!0}break;case"}":if(P)k?z+=F:j+=F,P=!1;else{if(k)return{fixedStart:j,strInBraces:z,fixedEnd:p.substring(M+1)};j+=F}break;default:k?z+=(P?"\\":"")+F:j+=(P?"\\":"")+F,P=!1;break}}return{strInBraces:j+(k?"{"+z:"")}}function f(p){const{fixedStart:k,strInBraces:P,fixedEnd:j}=I(p);if(k===void 0||j===void 0)return[P];let z=(0,b.$Aj)(P,",");z.length||(z=[""]);const M=f(j);return z.flatMap(F=>{const N=k+F;return M.map(O=>N+O)})}e.$Dgc=f}),define(ke[376],Se([1,0,21,158,85,17]),function(me,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class L{constructor(m){this.b=m,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(m,A,C,$){const v=new T.$xgc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:R.Schemas.file})},w=new g.$$u(u=>C.report({...u,uri:u.uri.with({scheme:A.folder.scheme})}));return this.c($,u=>v.provideTextSearchResults(m,S,w,u))}else return this.c($,S=>v.provideTextSearchResults(m,A,C,S))}async c(m,A){const C=b(m);this.a.add(C);const $=await A(C.token);return this.a.delete(C),$}d(){this.a.forEach(m=>m.cancel())}}e.$Hgc=L;function b(y){const m=new D.$2d;return y.onCancellationRequested(()=>m.cancel()),m}}),define(ke[377],Se([1,0,31,158,157]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class R{constructor(y){this.a=y}search(y,m,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(v){A({message:v})}},$=new g.$Egc(this.a,new T.$xgc(C),D);return new Promise((v,S)=>$.search(w=>{m(w.map(L))},y).then(w=>v({limitHit:w.limitHit,type:"success",stats:w.stats}),S))}}e.$Fgc=R;function L(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((y,m)=>{if(m.ranges){const A=m;return y+(Array.isArray(A.ranges)?A.ranges.length:1)}else return y+1},0)}}}),define(ke[378],Se([1,0,19,12,8,4,130,16,38,2,32,36,373,377]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class S{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let a;const t=o(r),s=new R.$Rd({onDidAddFirstListener:()=>{a=(0,T.$Lg)(d=>this.doFileSearchWithEngine($.$wgc,t,l=>s.fire(l),d)),a.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return s.event}textSearch(r){let a;const t=o(r),s=new R.$Rd({onDidAddFirstListener:()=>{a=(0,T.$Lg)(d=>this.f(t,l=>s.fire(l),d)),a.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return s.event}f(r,a,t){return r.maxFileSize=this.g().maxFileSize,new v.$Fgc(r).search(t,a,a)}g(){return{maxFileSize:16*A.$Mk.GB}}doFileSearch(r,a,t){return this.doFileSearchWithEngine($.$wgc,r,a,t)}doFileSearchWithEngine(r,a,t,s,d=S.a){let l=0;const c=E=>{Array.isArray(E)?(l+=E.length,t(E.map(I=>this.h(I)))):E.relativePath?(l++,t(this.h(E))):t(E)};if(a.sortByScore){let E=this.l(a,c,s);if(!E){const I=a.maxResults?Object.assign({},a,{maxResults:null}):a,f=new r(I);E=this.j(f,a,t,c,s)}return new Promise((I,f)=>{E.then(([p,k])=>{const P=k.map(j=>this.h(j));this.o(P,t,d),I(p)},f)})}const h=new r(a);return this.r(h,c,d,s).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$ic)(r.base,r.relativePath):r.relativePath}}j(r,a,t,s,d){const l=new R.$Rd;let c=(0,T.$Lg)(E=>{let I=[];const f=p=>{Array.isArray(p)?I=p:(s(p),l.fire(p))};return this.r(r,f,-1,E).then(p=>[p,I])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const E={promise:c,event:l.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=E,c.then(()=>{E.resolved=!0},I=>{delete h.resultsToSearchCache[a.filePattern||""]}),c=this.s(c)}return c.then(([E,I])=>{const f=h?h.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&y.$Nd.create(!1);return this.n(a,I,f,d).then(k=>{const P=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:k.length},messages:E.messages,limitHit:E.limitHit||typeof a.maxResults=="number"&&I.length>a.maxResults},k]})})}k(r){const a=this.b[r];return a||(this.b[r]=new w)}l(r,a,t){const s=r.cacheKey&&this.b[r.cacheKey];if(!s)return;const d=this.q(s,r.filePattern||"",a,t);if(d)return d.then(([l,c,h])=>{const E=y.$Nd.create(!1);return this.n(r,c,s.scorerCache,t).then(I=>{const f=E.elapsed(),p={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:f};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:p},I]})})}n(r,a,t,s){const d=(0,L.$Eq)(r.filePattern||""),l=(h,E)=>(0,L.$Dq)(h,E,d,!0,u,t),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return D.$Fb(a,l,c,1e4,s)}o(r,a,t){if(t&&t>0)for(let s=0;s<r.length;s+=t)a(r.slice(s,s+t));else a(r)}q(r,a,t,s){const d=y.$Nd.create(!1),l=a.indexOf(b.sep)>=0;let c;for(const f in r.resultsToSearchCache)if(a.startsWith(f)){if(l&&f.indexOf(b.sep)<0&&f!=="")continue;const p=r.resultsToSearchCache[f];c={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!c)return null;const h=d.elapsed(),E=y.$Nd.create(!1),I=c.event(t);return s&&s.onCancellationRequested(()=>{I.dispose()}),c.promise.then(([f,p])=>{if(s&&s.isCancellationRequested)throw(0,g.$5)();const k=[],P=(0,L.$Eq)(a).normalizedLowercase;for(const j of p)(0,C.$_I)(j,P)&&k.push(j);return[f,k,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:E.elapsed(),cacheEntryCount:p.length}]})}r(r,a,t,s){return new Promise((d,l)=>{let c=[];s?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(a(c),c=[])):a(h))},h=>{a(h)},(h,E)=>{c.length&&a(c),h?l(h):d(E)})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return r.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return r.finally(a)}}}}e.$Ggc=S;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(n){return(0,b.$mc)(n.relativePath)}getItemDescription(n){return(0,b.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>m.URI.revive(r))}}function i(n){return{...n,folder:m.URI.revive(n.folder)}}}),define(ke[379],Se([1,0,3,17,2,31,14,27,20,97,66,36,378,376,119,157]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;let u=class extends m.$ufc{constructor(i,n,r,a){super(i,r,a),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Qc;const t=new S.$rgc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new v.$Hgc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$rgc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new v.$Hgc(i))),this.x.add(this.z(T.Schemas.file,new $.$Ggc("fileSearchProvider")))}z(i,n){const r=this.d++;return this.v=n,this.t=r,this.c.$registerFileSearchProvider(r,this.o(i)),(0,D.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,a){const t=(0,m.$vfc)(r);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,r,a)}doInternalFileSearchWithCustomCallback(i,n,r){const a=t=>{if((0,C.$$I)(t)&&(t=[t]),Array.isArray(t)){r(t.map(s=>g.URI.file(s.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,r,a){return this.doInternalFileSearchWithCustomCallback(r,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new w.$Egc(i,n,void 0,"textSearchProvider")}};e.$Igc=u,e.$Igc=u=He([Be(0,y.$zM),Be(1,b.$PM),Be(2,A.$nec),Be(3,L.$dj)],u)}),define(ke[120],Se([1,0,393,62,63,394,22,8,4,3,16,11,30,81,82]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0;class w{traceSocketEvent(p,k){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,k)}constructor(p,k=""){this.f=!0,this.debugLabel=k,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$Z)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const k=P=>{this.traceSocketEvent("read",P),p(L.$fe.wrap(P))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(p){const k=P=>{p({type:0,hadError:P,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(p){const k=()=>{p()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,b.$Z)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,b.$Z)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Kh=w;var u;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize",f[f.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var o;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(o||(o={}));class i extends m.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,k){this.socket.traceSocketEvent(p,k)}constructor(p,k,P,j){super(),this.f=this.B(new y.$Rd),this.g=this.B(new y.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:P?.byteLength||0,recordInflateBytes:j}),this.a=this.B(new n(this,k,P,j,this.f,(z,M)=>this.m(z,M))),this.B(this.a.onError(z=>{console.error(z),(0,b.$Z)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Fh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let k=0;for(;k<p.byteLength;)this.a.writeMessage(p.slice(k,Math.min(k+262144,p.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(p,{compressed:k,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let j=2;p.byteLength<126?j+=0:p.byteLength<2**16?j+=2:j+=8;const z=L.$fe.alloc(j),M=k?64:0,F=P&15;if(z.writeUInt8(128|M|F,0),p.byteLength<126)z.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){z.writeUInt8(126,1);let N=1;z.writeUInt8(p.byteLength>>>8&255,++N),z.writeUInt8(p.byteLength>>>0&255,++N)}else{z.writeUInt8(127,1);let N=1;z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(p.byteLength>>>24&255,++N),z.writeUInt8(p.byteLength>>>16&255,++N),z.writeUInt8(p.byteLength>>>8&255,++N),z.writeUInt8(p.byteLength>>>0&255,++N)}this.socket.write(L.$fe.concat([z,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),P=k.readUInt8(0),j=(P&128)>>>7,z=(P&64)>>>6,M=P&15,F=k.readUInt8(1),N=(F&128)>>>7,O=F&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=j,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!j,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),P=k.readUInt8(1),j=(P&128)>>>7;let z=P&127,M=1;z===126?z=k.readUInt8(++M)*2**8+k.readUInt8(++M):z===127&&(z=k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*2**24+k.readUInt8(++M)*2**16+k.readUInt8(++M)*2**8+k.readUInt8(++M));let F=0;j&&(F=k.readUInt8(++M)*2**24+k.readUInt8(++M)*2**16+k.readUInt8(++M)*2**8+k.readUInt8(++M)),this.j.state=3,this.j.readLen=z,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Lh=i;class n extends m.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$fe.alloc(0)}constructor(p,k,P,j,z,M){super(),this.n=p,this.r=z,this.s=M,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new y.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new r(this.n,j,P,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(p,k){this.g.push({data:p,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:k}=this.g.shift();if(this.f&&k.compressed){const P=await this.w(this.f,p);this.s(P,k)}else this.s(p,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,k){return new Promise((P,j)=>{p.write(k),p.flush(z=>P(z))})}acceptFrame(p,k,P){this.h.push({data:p,isCompressed:k,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const k=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,k,P){return new Promise((j,z)=>{p.write(k),P&&p.write(L.$fe.fromByteArray([0,0,255,255])),p.flush(M=>j(M))})}}class r extends m.$Rc{get recordedInflateBytes(){return this.j?L.$fe.concat(this.f):L.$fe.alloc(0)}constructor(p,k,P,j){super(),this.h=p,this.j=k,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(j),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(L.$fe.wrap(z))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=L.$fe.concat(this.g);this.g.length=0,p(k)})}}class a extends m.$Rc{constructor(p,k){super(),this.g=p,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(L.$fe.wrap(P))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=L.$fe.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),p(k)})}}function t(f,p){if(p===0)return;const k=f.byteLength>>>2;for(let N=0;N<k;N++){const O=f.readUInt32BE(N*4);f.writeUInt32BE(O^p,N*4)}const P=k*4,j=f.byteLength-P,z=p>>>24&255,M=p>>>16&255,F=p>>>8&255;j>=1&&f.writeUInt8(f.readUInt8(P)^z,P),j>=2&&f.writeUInt8(f.readUInt8(P+1)^M,P+1),j>=3&&f.writeUInt8(f.readUInt8(P+2)^F,P+2)}e.$Mh=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function d(){const f=(0,$.$ig)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;const p=process.platform!=="darwin"&&e.$Mh?e.$Mh:(0,g.tmpdir)(),k=(0,A.$ic)(p,`vscode-ipc-${f}.sock`);return c(k),k}e.$Nh=d;function l(f,p,k){const P=(0,D.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${k}-${p}-sock`;const j=k.substr(0,4),z=p.substr(0,6),M=P.substr(0,8);let F;return process.platform!=="darwin"&&e.$Mh&&!process.env.VSCODE_PORTABLE?F=(0,A.$ic)(e.$Mh,`vscode-${M}-${j}-${z}.sock`):F=(0,A.$ic)(f,`${j}-${z}.sock`),c(F),F}e.$Oh=l;function c(f){const p=s[C.$u];typeof p=="number"&&f.length>=p&&console.warn(`WARNING: IPC handle "${f}" is longer than ${p} chars, try a shorter --user-data-dir`)}class h extends v.$zh{static b(p){const k=y.Event.fromNodeEventEmitter(p,"connection");return y.Event.map(k,P=>({protocol:new S.$Gh(new w(P,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(P,"close"))}))}constructor(p){super(h.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ph=h;function E(f){return new Promise((p,k)=>{const P=(0,T.createServer)();P.on("error",k),P.listen(f,()=>{P.removeListener("error",k),p(new h(P))})})}e.$Qh=E;function I(f,p){return new Promise((k,P)=>{const j=(0,T.createConnection)(f,()=>{j.removeListener("error",P),k(S.$Hh.fromSocket(new w(j,`ipc-client${p}`),p))});j.once("error",P)})}e.$Rh=I}),define(ke[380],Se([1,0,62,63,166,120,12,3,11,44,14,138,257,258,109,88,22]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a0b=e.$_9b=e.$$9b=e.$09b=void 0;async function o(t,s,d,l,c){let h;for(let E=3;E&&(h?.dispose(),h=await new i(t,s,d,l,c).waitForReady(),!(c&&g.$lg[c]||!g.$lg[h.tunnelLocalPort]));E--);return h}class i extends b.$Rc{constructor(s,d,l,c,h){super(),this.m=d,this.n=h,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=D.createServer(),this.c=new L.$Wg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=E=>this.r(E),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,d=(0,w.$kv)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,g.$mg)(s,2,1e3,d),c=null;return this.b.listen(l,this.m),await this.c.wait(),c=this.b.address(),c||(l=0,this.b.listen(l,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(s){s.pause();const d=(0,w.$iv)(this.tunnelRemoteHost)||(0,w.$kv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,$.$_k)(this.a,d,this.tunnelRemotePort),c=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&s.write(h.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),c.end()}),s.on("close",()=>c.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),c instanceof R.$Kh?c.socket.destroy():c.end()}),c instanceof R.$Kh?this.t(s,c):this.s(s,c),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),c.end()})}s(s,d){d.onClose(()=>s.destroy()),d.onEnd(()=>s.end()),d.onData(l=>s.write(l.buffer)),s.on("data",l=>d.write(u.$fe.wrap(l))),s.resume()}t(s,d){const l=d.socket;l.on("end",()=>s.end()),l.on("close",()=>s.end()),l.on("error",()=>{s.destroy()}),l.pipe(s),s.pipe(l)}}e.$09b=i;let n=class extends w.$nv{constructor(s,d,l,c,h){super(d,h),this.u=s,this.v=l,this.w=c}isPortPrivileged(s){return(0,w.$lv)(s,this.l,y.OS,T.release())}s(s,d,l,c,h,E,I,f){const p=this.r(d,l);if(p)return++p.refcount,p.value;if((0,w.$fv)(s))return this.t(s,d,l,h,E,I,f);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const k={commit:this.w.commit,quality:this.w.quality,addressProvider:s,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=o(k,c,d,l,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,l,P),P}}};e.$$9b=n,e.$$9b=n=He([Be(0,v.$6k),Be(1,A.$dj),Be(2,S.$9k),Be(3,C.$vj),Be(4,m.$pi)],n);let r=class extends n{constructor(s,d,l,c,h){super(s,d,l,c,h)}};e.$_9b=r,e.$_9b=r=He([Be(0,v.$6k),Be(1,A.$dj),Be(2,S.$9k),Be(3,C.$vj),Be(4,m.$pi)],r);let a=class extends b.$Rc{constructor(s,d,l,c,h){super(),this.b=s,this.c=d,this.f=l,this.g=c,this.h=h,this.a=new Map}async openTunnel(s,d,l,c,h,E,I,f,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${c} on local port ${E}.`),!this.a.has(s)){const k=new r(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(s,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(d,l,c,h,E,I,f,p)}};e.$a0b=a,e.$a0b=a=He([Be(0,v.$6k),Be(1,A.$dj),Be(2,C.$vj),Be(3,S.$9k),Be(4,m.$pi)],a)}),define(ke[381],Se([1,0,120,277,55,35,2,14,40]),function(me,e,D,T,g,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=void 0;class m{constructor($,v,S){this.b=$,this.c=v,this.f=S,this.a=T.createServer((w,u)=>this.h(w,u)),this.g().catch(w=>(v.error(w),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,v){const S=(u,o)=>{v.writeHead(u,{"content-type":"application/json"}),v.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},w=[];$.setEncoding("utf8"),$.on("data",u=>w.push(u)),$.on("end",async()=>{try{const u=JSON.parse(w.join(""));let o;switch(u.type){case"open":o=await this.i(u);break;case"openExternal":o=await this.j(u);break;case"status":o=await this.l(u);break;case"extensionManagement":o=await this.k(u);break;default:S(404,`Unknown message type: ${u.type}`);break}S(200,o)}catch(u){const o=u instanceof Error?u.message:JSON.stringify(u);S(500,o),this.c.error("Error while processing pipe request",u)}})}async i($){const{fileURIs:v,folderURIs:S,forceNewWindow:w,diffMode:u,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:a,remoteAuthority:t}=$,s=[];if(Array.isArray(S))for(const h of S)try{s.push({folderUri:L.URI.parse(h)})}catch{}if(Array.isArray(v))for(const h of v)try{(0,y.$oi)(h)?s.push({workspaceUri:L.URI.parse(h)}):s.push({fileUri:L.URI.parse(h)})}catch{}const d=a?L.URI.file(a):void 0,c={forceNewWindow:w,diffMode:u,mergeMode:o,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,c)}async j($){for(const v of $.uris){const S=L.URI.parse(v),w=S.scheme==="file"?S:v;await this.b.executeCommand("_remoteCLI.openExternal",w)}}async k($){const v=w=>w?.map(u=>/\.vsix$/i.test(u)?L.URI.parse(u):u),S={list:$.list,install:v($.install),uninstall:v($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$1M=m;let A=class extends m{constructor($,v){super($,v,(0,D.$Nh)())}};e.$2M=A,e.$2M=A=He([Be(0,R.$VM),Be(1,b.$dj)],A)}),define(ke[382],Se([1,0,56,369,364,276,47,349,2,17,7,381,103,347,348]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class w extends g.$cgc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(d,l,c){return d=t(d),i.a.has(d)?i.a.get(d).load(d,y.URI.file((0,$.$bq)(l.filename)),h=>r.apply(this,[h,l,c])):r.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(s,d)=>a.call(this,t(s),d);const t=s=>{for(const d of i.b){const l=d(s);if(l){s=l;break}}return s}}}class u extends L.$4ec{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$Lgc);const i=this.h.invokeFunction(T.$$fc);if(this.h.createInstance(b.$Kgc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(C.$2M);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$Mgc),await this.h.createInstance(w,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,R.$Jgc)(this.j,r,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,r){if(n.scheme!==m.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.$Ngc=u}),define(ke[383],Se([1,0,50,22,4,3,123,11,23,2,31,14,256,64,109,88,380,27,20,72,358]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=e.$Pgc=e.$Ogc=void 0;function a(p){const k=p.trim().split(`
`),P=[];return k.forEach(z=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);M&&M.length>=3&&P.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),P.reduce((z,M)=>(z[M.socket]=M,z),{})}e.$Ogc=a;function t(...p){const k=[].concat(...p.map(d));return[...new Map(k.filter(P=>P.st==="0A").map(P=>{const j=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:s(j[0]),port:parseInt(j[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Pgc=t;function s(p){let k="";if(p.length===8)for(let P=p.length-2;P>=0;P-=2)k+=parseInt(p.substr(P,2),16),P!==0&&(k+=".");else for(let P=0;P<p.length;P+=8){const j=p.substring(P,P+8);let z="";for(let M=8;M>=2;M-=2)z+=j.substring(M-2,M),(M===6||M===2)&&(z=parseInt(z,16).toString(16),k+=`${z}`,z="",P+M!==p.length-6&&(k+=":"))}return k}e.$Qgc=s;function d(p){const k=p.trim().split(`
`),P=k.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return k.map(z=>z.trim().split(/\s+/).reduce((M,F,N)=>(M[P[N]||N]=F,M),{}))}e.$Rgc=d;function l(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function c(p){const k=p.trim().split(`
`),P=[];return k.forEach(j=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(j);z&&z.length>=4&&P.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),P}e.$Sgc=c;async function h(p,k,P){const j=P.reduce((M,F)=>(M[F.pid]=F,M),{}),z=[];return p.forEach(({socket:M,ip:F,port:N})=>{const O=k[M]?k[M].pid:void 0,W=O?j[O]?.cmd:void 0;O&&W&&!l(W)&&z.push({host:F,port:N,detail:W,pid:O})}),z}e.$Tgc=h;function E(p,k,P){const j=new Map,z=c(k);for(const M of p){const F=P.get(M.port);if(F){j.set(M.port,F);continue}const N=z.find(O=>O.cmd.includes(`${M.port}`));if(N){let O=N,W;do W=z.find(x=>x.ppid===O.pid),W&&(O=W);while(W);j.set(M.port,{host:M.ip,port:M.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else j.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return j}e.$Ugc=E;let I=class extends n.$bxb{constructor(k,P,j,z){super(k,P,j),this.D=P,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const j=new L.$Xl;let z=0;for(;this.C;){const M=new Date().getTime(),F=(await this.I()).filter(W=>(0,w.$iv)(W.host)||(0,w.$kv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(W=>W.port).join(", ")}`);const N=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),z++>3&&j.update(N),(!P||JSON.stringify(P)!==JSON.stringify(F))&&(P=F,await this.a.$onFoundNewCandidates(P));const O=this.G(j.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(W=>setTimeout(()=>W(),O))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",P="";try{k=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const j=t(k,P),z=await new Promise(Y=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,J,le)=>{Y(J)})}),M=a(z),F=await A.Promises.readdir("/proc"),N=[];for(const Y of F)try{const G=Number(Y),J=y.$zg(m.URI.file("/proc"),Y);if((await A.Promises.stat(J.fsPath)).isDirectory()&&!isNaN(G)){const Q=await A.Promises.readlink(y.$zg(J,"cwd").fsPath),Ee=await A.Promises.readFile(y.$zg(J,"cmdline").fsPath,"utf8");N.push({pid:G,cwd:Q,cmd:Ee})}}catch{}const O=[],W=j.filter(Y=>{const G=M[Y.socket];return G||O.push(Y),G}),x=h(W,M,N);let ce;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const Y=await new Promise(G=>{(0,D.exec)("ps -F -A -l | grep root",(J,le,Q)=>{G(le)})});this.z=E(O,Y,this.z),ce=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ce.map(G=>G.port).join(", ")}`)}return x.then(Y=>ce?Y.concat(ce):Y)}w(k){return async P=>{const j=new u.$09b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,F,N,O){const W=await k.makeConnection();return f.connect(W,F,N,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$Wk(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await j.waitForReady();const z=new g.$Rd;return{localAddress:(0,r.$XJ)(j.localAddress)??j.localAddress,remoteAddress:{port:j.tunnelRemotePort,host:j.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{j.dispose(),z.fire(),z.dispose()}}}}};e.$Vgc=I,e.$Vgc=I=He([Be(0,i.$zM),Be(1,o.$PM),Be(2,C.$dj),Be(3,S.$9k)],I);class f extends $.$gqb{static connect(k,P,j,z){const M=new R.$Qc,F={onClose:M.add(new g.$Rd),onData:M.add(new g.$Rd),onEnd:M.add(new g.$Rd)};M.add(k.onDidReceiveMessage(O=>F.onData.fire(T.$fe.wrap(O)))),M.add(k.onDidEnd(()=>F.onEnd.fire())),M.add(k.onDidClose(O=>F.onClose.fire({type:0,error:O,hadError:!!O})));const N=new f(k,z,F);return N.B(M),(0,$.$fqb)(N,P,j,z,F)}constructor(k,P,j){super(P,j),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[384],Se([1,0,106,352,367,366,379,382,383,96,47,97,95,46,72,92,351,350,14,368,58,271,105,109,140]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Cr)(A.$5ec,b.$Ngc,0),(0,D.$Cr)(i.$ej,o.$Xgc,1),(0,D.$Cr)(i.$dj,new t.$Sh(a.$bgc,[!1],!0)),(0,D.$Cr)(s.$9k,d.$c0b,1),(0,D.$Cr)(w.$wec,u.$Wgc,0),(0,D.$Cr)(m.$0ec,R.$ogc,0),(0,D.$Cr)(C.$tfc,L.$Igc,0),(0,D.$Cr)($.$Wfc,g.$ggc,0),(0,D.$Cr)(v.$Rec,T.$fgc,0),(0,D.$Cr)(S.$axb,y.$Vgc,0),(0,D.$Cr)(r.$8ec,n.$Ygc,0)}),define(ke[395],Se([1,0,62,396,56,8,82,120,254,114,365,22,31,103,12,133,278,292,370,384]),function(me,e,D,T,g,R,L,b,y,m,A,C,$,v,S,w,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,h=c._load;c._load=function(E){if(E==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function r(c){process.exit=function(h){if(c)n(h);else{const E=new Error("An extension called process.exit() and this was prevented.");console.warn(E.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(c){n()};function t(){const c=(0,o.$Hm)(process.env);if(c.type===3)return new Promise((h,E)=>{const I=f=>{const p=f[0],k=new L.$Ih;p.on("message",P=>k.fire(C.$fe.wrap(P.data))),p.on("close",()=>{a("renderer closed the MessagePort")}),p.start(),h({onMessage:k.event,send:P=>p.postMessage(P.buffer)})};process.parentPort.on("message",f=>I(f.ports))});if(c.type===2)return new Promise((h,E)=>{let I=null;const f=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=108e5,k=3e5,P=new S.$$g(()=>a("renderer disconnected for too long (1)"),p),j=new S.$$g(()=>a("renderer disconnected for too long (2)"),k);process.on("message",(M,F)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){F.setNoDelay(!0);const N=C.$fe.wrap(Buffer.from(M.initialDataChunk,"base64"));let O;if(M.skipWebSocketFrames)O=new b.$Kh(F,"extHost-socket");else{const W=C.$fe.wrap(Buffer.from(M.inflateBytes,"base64"));O=new b.$Lh(new b.$Kh(F,"extHost-socket"),M.permessageDeflate,W,!1)}I?(P.cancel(),j.cancel(),I.beginAcceptReconnection(O,N),I.endAcceptReconnection(),I.sendResume()):(clearTimeout(f),I=new L.$Jh({socket:O,initialChunk:N}),I.sendResume(),I.onDidDispose(()=>a("renderer disconnected")),h(I),I.onSocketClose(()=>{P.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;P.isScheduled()&&j.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const h=c.pipeName;return new Promise((E,I)=>{const f=D.createConnection(h,()=>{f.removeListener("error",I);const p=new L.$Jh({socket:new b.$Kh(f,"extHost-renderer")});p.sendResume(),E(p)});f.once("error",I),f.on("close",()=>{a("renderer closed the socket")})})}}async function s(){const c=await t();return new class{constructor(){this.a=new L.$Ih,this.onMessage=this.a.event,this.b=!1,c.onMessage(h=>{(0,m.$im)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||c.send(h)}async drain(){if(c.drain)return c.drain()}}}function d(c){return new Promise(h=>{const E=c.onMessage(I=>{E.dispose();const f=JSON.parse(I.toString()),p=f.commit,k=y.default.commit;if(p&&k&&p!==k&&n(55),f.parentPid){let P=0;setInterval(function(){try{process.kill(f.parentPid,0),P=0}catch(z){z&&z.code==="EPERM"?(P++,P>=3&&a(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):a(`parent process ${f.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(f.parentPid)}catch(z){(0,R.$Z)(z)}}c.send((0,m.$hm)(0)),h({protocol:c,initData:f})});c.send((0,m.$hm)(1))})}async function l(){const c=[];process.on("unhandledRejection",(P,j)=>{c.push(j),setTimeout(()=>{const z=c.indexOf(j);z>=0&&j.catch(M=>{c.splice(z,1),(0,R.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),P&&(0,R.$Z)(P))})},1e3)}),process.on("rejectionHandled",P=>{const j=c.indexOf(P);j>=0&&c.splice(j,1)}),process.on("uncaughtException",function(P){(0,R.$Y)(P)||(0,R.$Z)(P)}),g.mark("code/extHost/willConnectToRenderer");const h=await s();g.mark("code/extHost/didConnectToRenderer");const E=await d(h);g.mark("code/extHost/didWaitForInitData");const{initData:I}=E;r(!!I.environment.extensionTestsLocationURI),I.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,I.environment.skipWorkspaceStorageLock=(0,w.boolean)(i.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(j){n(j)}fsExists(j){return $.Promises.exists(j)}fsRealpath(j){return(0,v.$aq)(j)}};let p=null;I.remote.authority&&i.transformURIs&&(p=(0,u.$Gr)(I.remote.authority));const k=new A.$egc(E.protocol,I,f,p);a=P=>k.terminate(P)}l().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a7a67c4d7460b0f0e26ad96ea9c35197d3d085f1/core/vs/workbench/api/node/extensionHostProcess.js.map
